#ifndef HAIKUEXT_H
#define HAIKUEXT_H

//////////
//mono-utils-mono-mmap.c
#define MADV_DONTNEED POSIX_MADV_DONTNEED//hailu
#define madvise posix_madvise//haiku
#define MADV_FREE 5//mman.h

//sysmacros.h
#define makedev(major,minor) (((major) << 8) | ((minor) & 0xff))

///////////

////
//metadata-console-unix.c
//signal.h
typedef void (*_sig_func_ptr)();

union sigval {
	int sival_int;
	void* sival_ptr;	
};

typedef struct {
	int si_signo;
	int si_code;
	union sigval si_value;	
} siginfo_t;

#include <signal.h>//sigset_t
struct sigaction1 {
	int sa_flags;
	sigset_t sa_mask;
	
	union {
		_sig_func_ptr _handler;
		void (*_sigaction)(int, siginfo_t*,void*);
	}_signal_handlers;
};
//#define sa_handler _signal_handlers._handler
#define sa_sigaction _signal_handlers._sigaction

////]

/////////
//metadata-socket-io.c
//socket.c
#define AF_SNA 11
#define AF_DECnet 12
#define SOCK_RDM 4
#define SOCK_SEQPACKET 5

//in,h
#define IPV6_UNICAST_HOPS 16
#define IPV6_JOIN_GROUP 20
#define IPV6_LEAVE_GROUP 21

#define IN6_IS_ADDR_LOOPBACK(a) \
	(((__const uint32_t *) (a))[0] == 0 \
	&& (( __const uint32_t * ) (a))[1] == 0 \
	&& (( __const uint32_t * ) (a))[2] == 0 \
	&& (( __const uint32_t * ) (a))[3] == htonl (1) )
	
#include <netinet6/in6.h>//in6_add
struct ipv6_mreq {
	struct in6_addr ipv6mr_multiaddr;
	unsigned int ipv6mr_interface;	
};
///////////

/////////
//mini-exception-x86.c
//sigcontext.h
struct sigcontext {
	unsigned short gs,__gsh;
	unsigned short fs,__fsh;
	unsigned short es,__esh;
	unsigned short ds,__dsh;
	unsigned long edi;
	unsigned long esi;
	unsigned long ebp;
	unsigned long esp;
	unsigned long ebx;
	unsigned long edx;
	unsigned long ecx;
	unsigned long eax;
	unsigned long trapno;
	unsigned long err;
	unsigned long eip;
	unsigned short cs,__csh;
	unsigned long eflags;
	unsigned long esp_at_signal;
	unsigned short ss,__ssh;
	struct _fpstate * fpstate;
	unsigned long oldmask;
	unsigned long cr2;
};
/////////

/////////
//mini-mini-posix.c
//sys=signal.h
#define SA_SIGINFO 2
/////////

////////
//support-old-map.c
//signal.h
#define SIGIO 29
/////

/////////////////
//support-serial.c
//sys-termios.h
#define TIOCMSET 0x5418
#define TIOCMGET 0x5415
#define TIOCM_RTS 0x004
#define TIOCM_DTR 0x002
#define TIOCM_DSR 0x100
#define TIOCM_CTS 0x020
#define TIOCM_CAR 0x040

//ioctls.h
#define TIOCOUTQ 0x5411
///////////

////////////////
//libgc-pthread-support.c
//signal.h
#define SIGPWR 30
/////////
#endif//HAIKUEXT_H
