#ifndef __AVCVIDEOSERVICES_AVCVIDEOSERVICES__
#define __AVCVIDEOSERVICES_AVCVIDEOSERVICES__

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>
#include <string.h>
#include <mach/mach.h>
#include <mach/vm_map.h>
#include <mach/mach_time.h>

#include <deque>


#include <IOKit/IOKitLib.h>
#include <IOKit/IOMessage.h>
#include <CoreFoundation/CoreFoundation.h>
#include <CoreServices/CoreServices.h>
#include <IOKit/firewire/IOFireWireLib.h>
#include <IOKit/firewire/IOFireWireLibIsoch.h>
#include <IOKit/firewire/IOFireWireFamilyCommon.h>
#include <IOKit/avc/IOFireWireAVCLib.h>
#include <IOKit/avc/IOFireWireAVCConsts.h>

namespace AVS
{
//#include <APPLE/AVCVideoServices/AVCVideoServices_AVC1.h>
} 

#include "AVSCommon.h"
#include "StringLogger.h"
#include "TSPacket.h"
#include "PSITables.h"
#include "MPEG2XmitCycle.h"
#include "MPEG2Transmitter.h"
#include "MPEG2Receiver.h"
#include "TSDemuxer.h"
#include "DVXmitCycle.h"
#include "DVTransmitter.h"
#include "DVReceiver.h"
#include "FireWireDV.h"
#include "FireWireMPEG.h"
#include "AVCDevice.h"
#include "AVCDeviceController.h"
#include "AVCDeviceCommandInterface.h"
#include "TapeSubunitController.h"
#include "PanelSubunitController.h"
#include "MPEGTrickModes.h"
#include "VirtualTapeSubunit.h"
#include "VirtualMPEGTapePlayerRecorder.h"
#include "VirtualMusicSubunit.h"

namespace AVS
{
//	#include <APPLE/AVCVideoServices/AVCVideoServices_AVC2.h>
}
#endif 
