#ifndef APPKIT_NSOPENGL_H
#define APPKIT_NSOPENGL_H

#import "/usr/GNUstep/System/Library/Headers/AppKit/NSOpenGL.h"


@interface NSOpenGLPixelFormat (OC)

/*CGLPixelFormatObj

Returns the low-level, platform-specific Core OpenGL (CGL) pixel format object represented by the receiver.

- (void *)CGLPixelFormatObj
Return Value

A pointer to the underlying CGLPixelFormatObj object. 
Availability
Available in Mac OS X v10.3 and later.
Declared In
NSOpenGL.h*/
- (void *)CGLPixelFormatObj;

@end

@interface NSOpenGLContext (OC)

/*CGLContextObj

Returns the low-level, platform-specific Core OpenGL (CGL) context object represented by the receiver.

- (void *)CGLContextObj
Return Value

A pointer to the CGLContextObj data type represented by the receiver. 
Availability
Available in Mac OS X v10.3 and later.
Declared In
NSOpenGL.h*/

- (void *)CGLContextObj;

@end

#endif
