
#ifndef _CDSAuthParams_
#define _CDSAuthParams_	1

#include <openssl/evp.h>
#include <PasswordServer/AuthFile.h>
#include <DirectoryService/DirServices.h>
#include <DirectoryService/DirServicesUtils.h>
#include <DirectoryService/DirServicesConst.h>
#include <DirectoryServiceCore/CDSAuthDefs.h>
#include <DirectoryServiceCore/chap.h>
#include <DirectoryServiceCore/digestmd5.h>
#include <DirectoryServiceCore/pps.h>

#include <HYS/DirectoryServiceCore/CDSAuthParams.h>
class CDSAuthParams:public CDSAuthParams_HYS {
public:
CDSAuthParams_INIT
CDSAuthParams_FINAL

CDSAuthParams_ZeroHashes
CDSAuthParams_LoadParamsForAuthMethod
CDSAuthParams_PostEvent 
CDSAuthParams_DictionaryFromAuthItems
CDSAuthParams_SetParamsFromDictionary
CDSAuthParams_ExtractServiceInfo

protected:
private:
};

#endif //_CDSAuthParams_

