#ifndef OC__DISKS__
#define OC__DISKS__

#include <MacTypes.h>
#include <OSUtils.h>
#include <Files.h>

#ifdef __cplusplus
extern "C" {
#endif

/*GetDrvQHdr
    You can use the GetDrvQHdr function to get a pointer to the header of the drive queue.

    FUNCTION GetDrvQHdr: QHdrPtr;

    DESCRIPTION
    The GetDrvQHdr function returns a pointer to the header of the drive queue.

    ASSEMBLY-LANGUAGE INFORMATION
    The global variable DrvQHdr contains the header of the drive queue.

*/
QHdrPtr GetDrvQHdr(void);

#ifdef __cplusplus
}
#endif

#endif //OC__DISKS__


