#ifndef OC_FOUNDATION_BUNDLE_H
#define OC_FOUNDATION_BUNDLE_H

#import "/usr/GNUstep/System/Library/Headers/Foundation/NSBundle.h"

@interface NSBundle (OC)

/*privateFrameworksPath

Returns the full pathname of the receiver's subdirectory containing private frameworks.

- (NSString *)privateFrameworksPath
Return Value

The full pathname of the receiver's subdirectory containing private frameworks.
Discussion

This method returns the appropriate path for modern application and framework bundles. This method may not return a path for non-standard bundle formats or for some older bundle formats.
Availability

    * Available in Mac OS X v10.0 and later.

Declared In
NSBundle.h*/
- (NSString *)privateFrameworksPath;

@end

#endif//OC
