#ifndef OC_FOUNDATION_NSRUNLOOP_H
#define OC_FOUNDATION_NSRUNLOOP_H

#import <Foundation/NSObject.h>
#import <Foundation/NSDate.h>
#import <CoreFoundation/CFRunLoop.h>

#include "/usr/GNUstep/System/Library/Headers/Foundation/NSRunLoop.h"

@interface NSRunLoop (OC)

/*getCFRunLoop

Returns the receiver's underlying CFRunLoop Reference object.

- (CFRunLoopRef)getCFRunLoop
Return Value

The receiver's underlying CFRunLoop Reference object.
Discussion

You can use the returned run loop to configure the current run loop using Core Foundation function calls. For example, you might use this function to set up a run loop observer. 
Availability
Available in Mac OS X v10.0 and later.
Declared In
NSRunLoop.h*/
- (CFRunLoopRef)getCFRunLoop;

@end

#endif//OC_FOUNDATION_NSRUNLOOP_H

