#ifndef HYS_MACTYPES_H
#define HYS_MACTYPES_H

#ifndef nil
  #define nil NULL//c
#endif
//////////////////////////////////
enum {
	#ifndef OC_kVariableLengthArray
		#define OC_kVariableLengthArray
		kVariableLengthArray,//?
	#endif
	
	kUnknownType,//?
	bold,//?
	normal,//?
};
///////////////////////////////
#ifndef OC_UINT8
	#define OC_UINT8
	typedef unsigned char  UInt8;//c
#endif


#ifndef OC_BOOLEAN
	#define OC_BOOLEAN
	typedef unsigned char  Boolean;//c
#endif

#ifndef OC_UINT16
	#define OC_UINT16
	typedef unsigned short UInt16;//c
#endif

#ifndef OC_SINT8
	#define OC_SINT8
	typedef char  SInt8;//c
#endif

#ifndef OC_SINT16
	#define OC_SINT16
	typedef signed short   SInt16;//c
#endif


#ifndef OC_SINT64
	#define OC_SINT64	
	typedef signed long long  SInt64;//c
#endif

struct Float80 {
    SInt16  exp;
    UInt16  man[4];
};
typedef struct Float80 Float80;//c

#ifndef OC_Float64
#define OC_Float64
typedef double Float64;//c
#endif	

#ifndef OC_LangCode
#define OC_LangCode
typedef SInt16  LangCode;//C
#endif

#ifndef OC_ConstStringPtr	
#define OC_ConstStringPtr
typedef const unsigned char * ConstStringPtr;//C
#endif

#ifndef OC_AbsoluteTime
#define OC_AbsoluteTime
typedef struct UnsignedWide  AbsoluteTime;//c
#endif

typedef unsigned char                   Str27[28];//c
typedef const unsigned char *           ConstStr63Param;//c
typedef const unsigned char *           ConstStr31Param;//c
typedef const unsigned char *           ConstStr32Param;//c
typedef unsigned char                   Str63[64];//c
typedef Float80                         extended80;//c
typedef const void *                    ConstLogicalAddress;//c
typedef short                           CharParameter;//c
typedef short                           StyleParameter;//c
typedef unsigned char                   Str32[33];//c

#ifndef OC_UniChar
#define OC_UniChar
typedef UInt16	UniChar;
#endif

#ifndef OC_UTF16Char
#define OC_UTF16Char
typedef UInt16	UTF16Char;
#endif
typedef UniChar * UniCharPtr;//c

#endif//HYS_MACTYPES_H
//////////////////////////
#ifdef HYS_MACTYPES_H_END
#undef HYS_MACTYPES_H_END

#ifndef OC_OSType
#define OC_OSType
typedef FourCharCode                    OSType;//c
#endif

typedef UInt32                          UnsignedFixed;//c
typedef UnsignedFixed *                 UnsignedFixedPtr;//c
typedef OSType *   OSTypePtr;//c
typedef SInt32                          Duration;//c
typedef Style                           StyleField;//c

struct Float32Point {
    Float32             x;
    Float32             y;
};
typedef struct Float32Point Float32Point;//c

//func

extern void DebugStr(ConstStr255Param debuggerMsg);

#endif//HYS_MACTYPES_H_END

