#ifndef HYS_COREFOUNDATION_CFPRIV_H
#define HYS_COREFOUNDATION_CFPRIV_H

enum {
	CFSystemVersionLeopard,//?
	CFSystemVersionPanther,//?
	CFSystemVersionTiger,//?
	kCFLibraryDirectory,//?
	kCFSystemDomainMask,//?
};
/////////////////////////

enum {
	kCFCharacterSetNoBitmapAvailable = (1 << 1),//c
   	kCFCharacterSetIsInverted = (1 << 2),//c
    	kCFCharacterSetIsCompactBitmap = (1 << 0),//c
};

//////////////////////////////
typedef struct {
    CFCharacterSetRef cset;
    uint32_t flags;
    uint32_t rangeStart;
    uint32_t rangeLimit;
    const uint8_t *bitmap;
} CFCharacterSetInlineBuffer;//c

typedef CFIndex CFSearchPathDirectory;//c
typedef CFOptionFlags CFSearchPathDomainMask;//c
typedef CFIndex CFSystemVersion;//c

///////////////////
CF_EXPORT Boolean _CFExecutableLinkedOnOrAfter(CFSystemVersion version);//c
CF_EXPORT CFURLRef CFCopyHomeDirectoryURLForUser(CFStringRef uName);//c
CF_EXPORT const char *_CFProcessPath(void);//c

CF_EXPORT void CFQSortArray(void *list, CFIndex count, CFIndex elementSize, CFComparatorFunction comparator, void *context);//c

CF_EXPORT
CFStringRef CFGetUserName(void);//c

CF_EXPORT const char **_CFGetProgname(void);//c

CF_EXPORT CFArrayRef CFCopySearchPathForDirectoriesInDomains(CFSearchPathDirectory directory, CFSearchPathDomainMask domainMask, Boolean expandTilde);//c

#endif//HYS_COREFOUNDATION_CFPRIV_H
