#ifndef HYS_DIRECTORYSERVICECORE_PPS_H
#define HYS_DIRECTORYSERVICECORE_PPS_H

struct CommonAuthDataBlock {
	int saltLen;//?
	int salt;//?
	int serverChallenge;//?
	int encryptedChallengeLen;//?
	int hashType;//?
	int peerChallenge;//?
	int response;//?
	int nonce;//?
	int encryptedNonceLen;//?
	int sessionKey;//?
	int outPtr;//?
	int step;//?
	int sessionEncryptKey;//?
};
typedef struct CommonAuthDataBlock CommonAuthDataBlock;
typedef CommonAuthDataBlock* CommonAuthDataBlockPtr;

struct ServerAuthDataBlock {
	CommonAuthDataBlock c;//c
	int saltedHashLen;//?
	int saltedHash;//?
	int userName;//?
	int saltedHashHash;//?
	int encryptedChallenge;//?
	int dsRef;//?
	int typeBuff;//?
	int nodeRef;//?
	int encryptedNonce;//?
	int authBuff;//?
	int authStepBuff;//?
};
typedef struct ServerAuthDataBlock ServerAuthDataBlock;//c
typedef ServerAuthDataBlock*  ServerAuthDataBlockPtr;//c


void server_step_0_set_hash(const unsigned char* a,ServerAuthDataBlockPtr  b);//c

int pps_server_mech_step(ServerAuthDataBlockPtr a,const char *b,unsigned c,const char **d,unsigned *e);//c

void pps_server_mech_dispose(ServerAuthDataBlockPtr a);//c

#endif//HYS_DIRECTORYSERVICECORE_PPS_H
