#ifndef HYS_EAP8021X_EAP_H
#define HYS_EAP8021X_EAP_H

enum {
	kEAPCodeResponse,//?
	kEAPTypeTTLS,//?
	kEAPTypeIdentity,//?
	kEAPCodeRequest,//?
	kEAPCodeSuccess,//?
	kEAPCodeFailure,//?
	kEAPTypeMSCHAPv2,//?
	kEAPTypeMD5Challenge,//?
	kEAPTypeGenericTokenCard,//?
	kEAPTypeInvalid,//?
	kEAPTypePEAP,//?
	kEAPTypeExtensions,//?
	kEAPTypeNak,//?
	kEAPTypeNotification,//?
	kEAPTypeOneTimePassword,//?
	kEAPTypeTLS,//?
	kEAPTypeCiscoLEAP,//?
	kEAPTypeSRPSHA1,//?
	kEAPTypeEAPFAST,//?
};
///////////////////////////////
typedef uint32_t EAPType;//c
typedef uint32_t EAPCode;//c

//////////////
struct EAPPacket_s {
	uint8_t		identifier;//c
    	uint8_t		code;//c
    	uint8_t		data[0];//c
 };
typedef struct EAPPacket_s EAPPacket;
typedef EAPPacket *EAPPacketRef;

struct EAPRequestResponsePacket_s { 
   	uint8_t		code;//c
  	uint8_t		identifier;//c
    	uint8_t		type;//c
    	uint8_t		type_data[0];//c
};
typedef struct EAPRequestResponsePacket_s EAPRequestPacket;
typedef struct EAPRequestResponsePacket_s *EAPRequestPacketRef;
typedef struct EAPRequestResponsePacket_s EAPResponsePacket;
typedef struct EAPRequestResponsePacket_s *EAPResponsePacketRef;

struct EAPNakPacket_s { 
   	uint8_t	       	desired_type;//c
};
typedef struct EAPNakPacket_s  EAPNakPacket;
typedef struct EAPNakPacket_s  *EAPNakPacketRef;

struct EAPMD5ChallengePacket_s {
    	uint8_t		value_size;//c
   	uint8_t		identifier;//c
   	uint8_t		value[0];//c
};
typedef struct EAPMD5ChallengePacket_s EAPMD5ChallengePacket;
typedef struct EAPMD5ChallengePacket_s *EAPMD5ChallengePacketRef;

struct EAPMD5ResponsePacket_s {
    	uint8_t		code;//c
  	uint8_t		identifier;//c
   	uint8_t		type;//c
    	uint8_t		value_size;//c
  	uint8_t		value[16];//c
    	uint8_t		name[0];//c
};
typedef struct  EAPMD5ResponsePacket_s EAPMD5ResponsePacket; 
typedef struct  EAPMD5ResponsePacket_s *EAPMD5ResponsePacketRef;

struct EAPNotificationPacket_s {};
typedef struct EAPNotificationPacket_s EAPNotificationPacket;

#endif//HYS_EAP8021X_EAP_H
