#ifndef HYS_EAP8021X_EAPTLSUTIL_H
#define HYS_EAP8021X_EAPTLSUTIL_H

struct memoryBuffer_s {
   	size_t			offset;//c
    	void *			data;//c
    	size_t			length;//c
 };
typedef struct memoryBuffer_s memoryBuffer;
typedef struct memoryBuffer_s *memoryBufferRef;

struct memoryIO {
    	memoryBufferRef		read;//c
    	bool			debug;//c
  	memoryBufferRef		write;//c
};
typedef struct memoryIO memoryIO;
typedef struct memoryIO* memoryIORef;
////////////////

OSStatus  EAPSSLMemoryIORead(SSLConnectionRef connection, void * data_buf, 		  size_t * data_length);//c

OSStatus
EAPSSLMemoryIOWrite(SSLConnectionRef connection, const void * data_buf, 
		   size_t * data_length);//c

#endif//HYS_EAP8021X_EAPTLSUTIL_H
