#ifndef HYS_FOUNSATION_NSGEOMETRY_H
#define HYS_FOUNSATION_NSGEOMETRY_H

#if __LP64__ || NS_BUILD_32_LIKE_64

typedef CGPoint NSPoint;
typedef CGRect NSRect;
typedef CGSize NSSize;

#else

#ifndef OC_NSPoint
#define OC_NSPoint
typedef struct _NSPoint {
    CGFloat x;
    CGFloat y;
} NSPoint;
#endif

#ifndef OC_NSSize
#define OC_NSSize
typedef struct _NSSize {
    CGFloat width;	
    CGFloat height;		
} NSSize;
#endif

#ifndef OC_NSRect
#define OC_NSRect
typedef struct _NSRect {
    NSPoint origin;
    NSSize size;
} NSRect;
#endif


#endif

#endif//HYS_FOUNSATION_NSGEOMETRY_H
