#ifndef HYS_IOKIT_IODMACOMMAND_H
#define HYS_IOKIT_IODMACOMMAND_H


class IODMACommand_HYS
{
    OSDeclareDefaultStructors(IODMACommand_HYS);

public://data


	
enum SynchronizeOptions {
	kForceDoubleBuffer,//?
    };

public://func-define

#define IODMACommand_gen32IOVMSegments \
 inline IOReturn gen32IOVMSegments(UInt64   *offset, Segment32 *segments,    UInt32     *numSegments)   {  };//?c

#define IODMACommand_gen64IOVMSegments \
 inline IOReturn gen64IOVMSegments(UInt64    *offset,  Segment64 *segments,      UInt32    *numSegments) {};//c?

#define IODMACommand_initWithSpecification \
    virtual bool initWithSpecification( SegmentFunction  outSegFunc,UInt8     numAddressBits,UInt64    maxSegmentSize,MappingOptions mappingOptions = kMapped,UInt64    maxTransferSize = 0,UInt32    alignment = 1,IOMapper *mapper = 0,void     *refCon = 0);//c
	

	#define IODMACommand_getMemoryDescriptor \
	virtual const IOMemoryDescriptor *getMemoryDescriptor() const;//c
	
	#define IODMACommand_synchronize \
	  virtual IOReturn synchronize(IOOptionBits options);//c
	  
	 #define IODMACommand_writeBytes \
	      UInt64 writeBytes(UInt64 offset, const void *bytes, UInt64 length);//c
		  
		 #define IODMACommand_clearMemoryDescriptor \
    virtual IOReturn clearMemoryDescriptor(bool autoComplete = true);//c
	
	#define IODMACommand_complete \
	    virtual IOReturn complete(bool invalidateCache = true, bool synchronize = true);//c
		
		#define IODMACommand_setMemoryDescriptor \
		  virtual IOReturn setMemoryDescriptor(const IOMemoryDescriptor *mem, bool autoPrepare = true);//c
			
			#define IODMACommand_prepare \
    virtual IOReturn prepare(UInt64 offset = 0, UInt64 length = 0, bool flushCache = true, bool synchronize = true);//c
				
public://func




};

#endif//HYS_IOKIT_IODMACOMMAND_H

