#ifndef  HYS_IOKIT_IOKITLIB_H
#define   HYS_IOKIT_IOKITLIB_H

#ifdef __cplusplus
class OSObject;//add
#endif //__cplusplus

//hys add
#define IODictionary OSDictionary
#define IOOffset OSNumber

#ifdef __cplusplus
#define IOObject OSObject
#endif //__cplusplus

#define IOString OSString

#ifdef __cplusplus
inline int IORegistryEntryGetProperties(int a,OSObject** b) {return 0;};
#endif //__cplusplus

typedef struct IOObject IOObject;//c

////////hys add end


////////////

enum {
#ifndef IOKIT_kIORegistryIterateRecursively
	#define IOKIT_kIORegistryIterateRecursively
	kIORegistryIterateRecursively=0x00000001,//c
#endif

#ifndef IOKIT_kIORegistryIterateParents
	#define IOKIT_kIORegistryIterateParents
	kIORegistryIterateParents=0x00000002,//c
#endif
	HYS_IOKIT_IOKITLIB_H_ENUM_DUMMY,//dummy
};
typedef struct IONotificationPort * IONotificationPortRef;//c
///////////////////////////

kern_return_t IORegistryDisposeEnumerator(	io_enumerator_t	enumerator ) DEPRECATED_ATTRIBUTE;//c

kern_return_t
OSGetNotificationFromMessage(
	mach_msg_header_t     * msg,
	uint32_t	  	index,
        uint32_t    	      * type,
        uintptr_t	      * reference,
	void		     ** content,
        vm_size_t	      * size );//c

kern_return_t
IOConnectCallAsyncMethod(
	mach_port_t	 connection,	
	uint32_t	 selector,		
	mach_port_t	 wake_port,		
	uint64_t	*reference,	
	uint32_t	 referenceCnt,	
	const uint64_t	*input,	
	uint32_t	 inputCnt,		
	const void	*inputStruct,		
	size_t		 inputStructCnt,	
	uint64_t	*output,		
	uint32_t	*outputCnt,	
	void		*outputStruct,		
	size_t		*outputStructCnt)	
AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c

kern_return_t
IOConnectCallStructMethod(
	mach_port_t	 connection,	
	uint32_t	 selector,		
	const void	*inputStruct,	
	size_t		 inputStructCnt,	
	void		*outputStruct,		
	size_t		*outputStructCnt)	
AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;

kern_return_t
IOConnectCallAsyncStructMethod(
	mach_port_t	 connection,		
	uint32_t	 selector,		
	mach_port_t	 wake_port,		
	uint64_t	*reference,		
	uint32_t	 referenceCnt,		
	const void	*inputStruct,		
	size_t		 inputStructCnt,	
	void		*outputStruct,		
	size_t		*outputStructCnt)	
AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c

kern_return_t
io_connect_method_scalarI_scalarO(
	mach_port_t connection,
	int selector,
	io_scalar_inband_t input,
	mach_msg_type_number_t inputCnt,
	io_scalar_inband_t output,
	mach_msg_type_number_t *outputCnt) DEPRECATED_ATTRIBUTE;//c

extern const mach_port_t kIOMasterPortDefault;//c



kern_return_t
IOConnectCallMethod(
	mach_port_t	 connection,	
	uint32_t	 selector,		
	const uint64_t	*input,			
	uint32_t	 inputCnt,	
	const void      *inputStruct,		
	size_t		 inputStructCnt,	
	uint64_t	*output,		
	uint32_t	*outputCnt,	
	void		*outputStruct,	
	size_t		*outputStructCnt)	
AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c


kern_return_t
IOConnectCallAsyncScalarMethod(
	mach_port_t	 connection,		
	uint32_t	 selector,		
	mach_port_t	 wake_port,		
	uint64_t	*reference,		
	uint32_t	 referenceCnt,		
	const uint64_t	*input,		
	uint32_t	 inputCnt,		
	uint64_t	*output,		
	uint32_t	*outputCnt)		
AVAILABLE_MAC_OS_X_VERSION_10_5_AND_LATER;//c

kern_return_t
IOMapMemory(
	io_connect_t	connect,
	uint32_t	memoryType,
	task_port_t	intoTask,
	vm_address_t *	atAddress,
	vm_size_t    *	ofSize,
	uint32_t	flags ) DEPRECATED_ATTRIBUTE;//c

kern_return_t
io_connect_method_scalarI_structureO(
	mach_port_t connection,
	int selector,
	io_scalar_inband_t input,
	mach_msg_type_number_t inputCnt,
	io_struct_inband_t output,
	mach_msg_type_number_t *outputCnt) DEPRECATED_ATTRIBUTE;//c

kern_return_t
io_connect_method_scalarI_structureI(
	mach_port_t connection,
	int selector,
	io_scalar_inband_t input,
	mach_msg_type_number_t inputCnt,
	io_struct_inband_t inputStruct,
	mach_msg_type_number_t inputStructCnt) DEPRECATED_ATTRIBUTE;//c

kern_return_t
IOServiceAddNotification(
	mach_port_t	masterPort,
	const io_name_t	notificationType,
	CFDictionaryRef	matching,
	mach_port_t	wakePort,
	uintptr_t	reference,
	io_iterator_t *	notification )  DEPRECATED_ATTRIBUTE;//c

/////////////////////////

#endif//HYS_IOKIT_IOKITLIB_H
