#ifndef HYS_IOKIT_IOPLATFORMEXPERT_H
#define HYS_IOKIT_IOPLATFORMEXPERT_H

#define kIOPlatformMapperPresentKey "kIOPlatformMapperPresentKey"//?

enum {
	kPERestartCPU,//?
};

#ifdef __cplusplus
extern "C" {
#endif

int PEHaltRestart(int a);//?

#ifdef __cplusplus
} 
#endif

class IOPlatformExpert_HYS
{
    OSDeclareDefaultStructors(IOPlatformExpert_HYS)

public://data
int _pePMFeatures;//c
int _pePrivPMFeatures;//c
int _peNumBatteriesSupported;//c
OSArray* thePowerTree;//c
IOPMrootDomain * root;//c
int multipleParentKeyValue;//?
int numInstancesRegistered;//c

public://func
int registerInterruptController(OSSymbol* a,IOInterruptController* b);
int writeNVRAMProperty(IORegistryEntry* a, const OSSymbol* b, OSData* c);
int setCPUInterruptProperties(IOService * a);//?
int hasPrivPMFeature(int a);//?
int hasPMFeature(int a);//?
int setChipSetType(int a);//?
int setMachineType(long int a);//?
IOService* createNub(OSDictionary* a);//?
int getMachineType();//?
int CheckSubTree(OSArray* a , IOService* b, IOService* c, int d);//?
IORangeAllocator* getPhysicalRangeAllocator();//?
int setConsoleInfo(PE_Video * a,int b);//?
int getConsoleInfo(PE_Video *  a);//?
int getChipSetType();//?

};


class IODTPlatformExpert_HYS
{
    OSDeclareAbstractStructors(IODTPlatformExpert_HYS);

public:

int createNubs(IOService *a,OSIterator* b);//?
int readXPRAM(IOByteCount a, UInt8* b, IOByteCount c);//?
int writeXPRAM(IOByteCount a, UInt8* b, IOByteCount c);//?
int compareNubName(const IOService *a,OSString * b,OSString ** c=0);//?
int getNubResources(IOService * a);//?
int readNVRAMProperty(IORegistryEntry *a, const OSSymbol **b, OSData ** c);//?

};


#endif//HYS_IOKIT_IOPLATFORMEXPERT_H
