#ifndef HYS_IOKIT_OSMESSAGENOTIFICTION_H
#define HYS_IOKIT_OSMESSAGENOTIFICTION_H

enum {
	kOSNotificationMessageID,//?
	kIOAsyncCalloutCount,//?
   	kIOAsyncReservedCount,//?
	kMaxAsyncArgs,//?
	kOSAsyncCompleteMessageID,//?
	kIOAsyncCalloutFuncIndex,//?
	kIOAsyncCalloutRefconIndex,//?
	kOSAsyncRef64Count,//?
	kOSAsyncRef64Size,//?
	kOSAsyncRefCount,//?
	kIOMatchingCalloutCount,//?
	kIOMatchingCalloutFuncIndex,//?
	kIOMatchingCalloutRefconIndex,//?
	kIOInterestCalloutCount,//?
	kIOInterestCalloutFuncIndex,//?
	kIOInterestCalloutRefconIndex,//?
	kIOInterestCalloutServiceIndex,//?
	kIOAsyncCompletionNotificationType,//?
	kIOServiceMessageNotificationType,//?
	kIOServicePublishNotificationType,//?
	kIOServiceMatchedNotificationType,//?
	kIOServiceTerminatedNotificationType,//?
};

typedef natural_t OSAsyncReference[1];//?

struct OSNotificationHeader {
	int type;//?
	OSAsyncReference reference;//c
	int size;//?
	int content[1];//?
};
typedef struct OSNotificationHeader OSNotificationHeader;

struct IOAsyncCompletionContent {
	int result;//?
	int *args[1];//?
};
typedef struct IOAsyncCompletionContent IOAsyncCompletionContent;

struct IOServiceInterestContent {
	int messageArgument[1];//?
	int messageType;//?
};
typedef struct IOServiceInterestContent IOServiceInterestContent;

typedef io_user_reference_t  OSAsyncReference64[1];//?


#endif//HYS_IOKIT_OSMESSAGENOTIFICTION_H
