#ifndef HYS_IOKIT_ACPI_IOACPIPLATFORMDEVICE_H
#define HYS_IOKIT_ACPI_IOACPIPLATFORMDEVICE_H

//hys add
#define IOACPIPlatformDevice_init bool init( IOService * a,void * b,OSDictionary *c);//?

#define IOACPIPlatformDevice_free void free();//?

#define IOACPIPlatformDevice_attachToParent bool attachToParent(IORegistryEntry* a, const IORegistryPlane* b);//?

#define IOACPIPlatformDevice_detachFromParent  void  detachFromParent( IORegistryEntry * a, const IORegistryPlane * b );//?

#define IOACPIPlatformDevice_initACPIPowerManagement \
bool     initACPIPowerManagement( IOService *a);//?

#define IOACPIPlatformDevice_stopACPIPowerManagement \
void stopACPIPowerManagement(IOService *  a);//?

#define IOACPIPlatformDevice_getDeviceHandle \
void *   getDeviceHandle( ) const;//c

#define IOACPIPlatformDevice_getDeviceType \
UInt32   getDeviceType() const;//c

#define IOACPIPlatformDevice_setDeviceType \
void     setDeviceType( UInt32 a);//?

#define IOACPIPlatformDevice_validateObject_const_OSSymbol \
IOReturn validateObject(  const OSSymbol * a );//c

#define IOACPIPlatformDevice_validateObject_const_char \
IOReturn  validateObject(const char * a);//?

#define IOACPIPlatformDevice_evaluateObject_const_char \
IOReturn evaluateObject(const char *     a,OSObject ** b=0,OSObject * c[]=0,\
IOItemCount d = 0,IOOptionBits  e= 0 );//?

#define IOACPIPlatformDevice_evaluateObject_const_OSSymbol \
IOReturn evaluateObject( const OSSymbol * a,\
                                      OSObject **     b  = 0,\
                                      OSObject *       c[]=0,\
                                      IOItemCount      d = 0,\
                                      IOOptionBits     e= 0 );\

#define IOACPIPlatformDevice_evaluateInteger_const_char \
IOReturn evaluateInteger( const char *    a,\
                                      UInt64 *    b,\
                                      OSObject *     c[]= 0,\
                                      IOItemCount      d= 0,\
                                      IOOptionBits     e = 0 );//?

#define IOACPIPlatformDevice_evaluateInteger_const_OSSymbol \
IOReturn evaluateInteger( const OSSymbol * a,\
                                      UInt64 *         b,\
                                      OSObject *       c[]   = 0,\
                                      IOItemCount      d = 0,\
                                      IOOptionBits     e    = 0 );//c

#define IOACPIPlatformDevice_evaluateInteger_const_OSSymbol_UInt32 \
 IOReturn evaluateInteger( const OSSymbol * a,\
                                      UInt32 *         b,\
                                      OSObject *       c[]   = 0,\
                                      IOItemCount      d = 0,\
                                      IOOptionBits     e    = 0 );//c

#define IOACPIPlatformDevice_evaluateInteger_const_char_UInt32 \
    virtual IOReturn evaluateInteger( const char *    a,\
                                      UInt32 *         b,\
                                      OSObject *       c[]   = 0,\
                                      IOItemCount    d = 0,\
                                      IOOptionBits     e    = 0 );//c

#define IOACPIPlatformDevice_getACPITableData \
const OSData * getACPITableData( const char * a,UInt32   b = 0 ) const;//c

#define IOACPIPlatformDevice_getDeviceStatus \
UInt32   getDeviceStatus() const;//c

#define IOACPIPlatformDevice_installInterruptForFixedEvent \
SInt32   installInterruptForFixedEvent( UInt32 a );

#define IOACPIPlatformDevice_installInterruptForGPE \
SInt32   installInterruptForGPE( UInt32      a, \
                                             void *       b = 0, \
                                             IOOptionBits c = 0 );//?

#define IOACPIPlatformDevice_acquireGlobalLock \
IOReturn acquireGlobalLock( UInt32 * a,const mach_timespec_t * b = 0 );//?

#define IOACPIPlatformDevice_releaseGlobalLock \
void     releaseGlobalLock( UInt32 a );//?

#define IOACPIPlatformDevice_registerAddressSpaceHandler \
IOReturn registerAddressSpaceHandler( \
                                   IOACPIAddressSpaceID      a, \
                                   IOACPIAddressSpaceHandler b, \
                                   void *                    c, \
                                   IOOptionBits              d = 0 );//?
#define IOACPIPlatformDevice_unregisterAddressSpaceHandler \
void     unregisterAddressSpaceHandler(\
                                   IOACPIAddressSpaceID      a,\
                                   IOACPIAddressSpaceHandler b,\
                                   IOOptionBits              c = 0 );//?

#define IOACPIPlatformDevice_readAddressSpace\
 IOReturn readAddressSpace(  UInt64 *            a,\
                                        IOACPIAddressSpaceID b,\
                                        IOACPIAddress        c,\
                                        UInt32               d,\
                                        UInt32               e = 0,\
                                        IOOptionBits       f   = 0 );//?

#define IOACPIPlatformDevice_writeAddressSpace \
IOReturn writeAddressSpace( UInt64               a,\
                                        IOACPIAddressSpaceID b,\
                                        IOACPIAddress        c,\
                                        UInt32               d,\
                                        UInt32               e = 0,         \
                                        IOOptionBits       f  = 0 );//?

#define IOACPIPlatformDevice_getPathComponent \
bool     getPathComponent( char * a, int * b, const IORegistryPlane * c ) const;//?

#define IOACPIPlatformDevice_compareName \
 bool     compareName( OSString *  a,OSString ** b) const;//?

#define IOACPIPlatformDevice_getResources \
IOReturn getResources();//?

#define IOACPIPlatformDevice_hasSystemWakeCapability \
 bool     hasSystemWakeCapability() const;//?

#define IOACPIPlatformDevice_setSystemWakeCapabilityEnable \
IOReturn setSystemWakeCapabilityEnable( bool a );//?

#define IOACPIPlatformDevice_hasACPIPowerStateSupport \
bool     hasACPIPowerStateSupport( UInt32 a ) const;//?

#define IOACPIPlatformDevice_setACPIPowerManagementEnable \
IOReturn setACPIPowerManagementEnable( \
                            bool         a, \
                            UInt32       b = 0, \
                            IOOptionBits c    = 0 );//?

#define IOACPIPlatformDevice_ioWrite8 \
void     ioWrite8(  UInt16 a, UInt8 b, IOMemoryMap * c= 0 );//?

#define IOACPIPlatformDevice_ioRead8 \
UInt8    ioRead8(  UInt16 a, IOMemoryMap * b = 0 );//?

#define IOACPIPlatformDevice_setPowerState \
IOReturn setPowerState( unsigned long a,IOService * b );//?

#define IOACPIPlatformDevice_ioRead32 \
UInt32   ioRead32( UInt16 a, IOMemoryMap *b = 0 );//?

#define IOACPIPlatformDevice_ioWrite16 \
void     ioWrite16( UInt16 a, UInt16 b, IOMemoryMap * c = 0 );//?

#define IOACPIPlatformDevice_ioRead16 \
UInt16   ioRead16( UInt16 a, IOMemoryMap *b = 0 );//?

#define IOACPIPlatformDevice_ioWrite32 \
void     ioWrite32( UInt16 a, UInt32 b,IOMemoryMap *c= 0 );//?

////////////

class IOACPIPlatformDevice_HYS
{
OSDeclareDefaultStructors( IOACPIPlatformDevice_HYS)

public://data

enum {
	kTypeDevice,//?
};

void * _deviceHandle;//c
int _deviceType;//?
IOACPIPlatformExpert * _platform;//c
int  _sleepPowerState;//?
UInt32 *  _powerStateFlags;//c
IOService *  _acpiParent;//c
int _powerFlags;//?

public://func

};

#endif//HYS_IOKIT_ACPI_IOACPIPLATFORMDEVICE_H

