#ifndef HYS_IOKIT_ACPI_IOACPIPLATFORMEXPORT_H
#define HYS_IOKIT_ACPI_IOACPIPLATFORMEXPORT_H

//hys add

#define IOACPIPlatformExpert_start \
bool     start( IOService * a);//?

#define IOACPIPlatformExpert_validateObject \
IOReturn validateObject( IOACPIPlatformDevice * a, const char * b);//?

#define IOACPIPlatformExpert_evaluateObject \
IOReturn evaluateObject( IOACPIPlatformDevice * a, \
                                     const char *           b, \
                                     OSObject **            c, \
                                     OSObject *             d[], \
                                     IOItemCount           e, \
                                     IOOptionBits           f );//?

///////////////////////////////////////
class IOACPIPlatformExpert_HYS
{
//OSDeclareAbstractStructors( IOACPIPlatformExpert_HYS)

public:

int validateObject(IOACPIPlatformDevice* a, const OSSymbol* b);//?
int evaluateObject( IOACPIPlatformDevice * a,const OSSymbol *b,OSObject **   c,OSObject *d[],IOItemCount  e,IOOptionBits  f ) ;//c
const OSData *getACPITableData( const char *a, UInt32       b );//c

int installDeviceInterruptForFixedEvent(IOService *a,int b);//?
int installDeviceInterruptForGPE(IOService * a,int b,void *  c,int d);//?
int acquireGlobalLock(IOService *  a,UInt32 *      b, const mach_timespec_t *c);//?
int releaseGlobalLock(IOService *a,int b);//?
int registerAddressSpaceHandler( IOACPIPlatformDevice *  a,int b,int c,void *   d,int e);//?
int unregisterAddressSpaceHandler(IOACPIPlatformDevice *   a,int b,int c,int d);//?
int readAddressSpace(UInt64* a,int b,int c,int d,int e,int f);//?
int writeAddressSpace(int a,int b,int c,int d,int e,int f);//?
int setDeviceWakeEnable(IOACPIPlatformDevice *a,int b);//?
int setDevicePowerState(IOACPIPlatformDevice * a,int b);//?

private:

};


#endif//HYS_IOKIT_ACPI_IOACPIPLATFORMEXPORT_H
