#ifndef HYS_IOKIT_ADB_IOADBBUS_H
#define HYS_IOKIT_ADB_IOADBBUS_H

//hys add
#define IOADBBus_init \
 bool init ( OSDictionary *a= 0 );//?

#define IOADBBus_setHandlerID \
IOReturn setHandlerID ( ADBDeviceControl * a, UInt8 b );//?

///////////////////

#define ADBaddressProperty "ADBaddressProperty"//?
#define ADBhandlerIDProperty "ADBhandlerIDProperty"//?
#define ADBdefAddressProperty "ADBdefAddressProperty"//?
#define ADBdefHandlerProperty "ADBdefHandlerProperty"//?

struct ADBDeviceControl {
	IOADBDevice * nub;//c
	int defaultAddress;//?
	int handlerID;//?
	int defaultHandlerID;//?
	int address;//?
	IOService * owner;//c
	ADB_callback_func handler;//c
};
typedef struct ADBDeviceControl ADBDeviceControl;

class  IOADBBus_HYS
{
OSDeclareAbstractStructors(IOADBBus_HYS)

public://data
ADBDeviceControl *adbDevices[1];//?

public://func

int matchNubWithPropertyTable(IOService *  a,OSDictionary *  b);//?
int setOwner( void *  a, IOService *b,ADB_callback_func c);//?
int clearOwner (void * a);//?
int flush (ADBDeviceControl *  a);//?
int readRegister(ADBDeviceControl * a,int b,UInt8 * c,IOByteCount *d);//?
int writeRegister(ADBDeviceControl * a,int b,UInt8 * c,IOByteCount *d);//?
int address (ADBDeviceControl *a);//?
int defaultAddress(ADBDeviceControl* a);//?
int handlerID(ADBDeviceControl* a);//?
int defaultHandlerID(ADBDeviceControl*a);//?

};

#endif//HYS_IOKIT_ADB_IOADBBUS_H
