#ifndef HYS_IOKIT_ATA_IOATATYPES_H
#define HYS_IOKIT_ATA_IOATATYPES_H

#define kATANotifyOnChangeKey "kATANotifyOnChangeKey"//?
#define kIOACPIMessageDeviceNotification  1//?
#define kATAMediaBaySocketString "kATAMediaBaySocketString"//?
#define kATAPCCardSocketString "kATAPCCardSocketString"//?
#define kATAVendorPropertyKey "kATAVendorPropertyKey"//?
#define kATAUnitNumberKey "kATAUnitNumberKey"//?
#define kATARevisionPropertyKey "kATARevisionPropertyKey"//?

#ifdef __ppc__
#define IOATARegPtr8  volatile UInt8 *//c
#define IOATARegPtr16 volatile UInt16*//c
#define IOATARegPtr32 volatile UInt32 *//c
#else
#include <IOKit/ata/IOATARegI386.h>
#endif

enum {
	kInternalSATA,//?
	mATADCRReset,//?
	mATABusy,//?
	kUnknownATADeviceType,//?
	kATAPIDeviceType,//?
	kATADeviceType,//?
	kInternalATASocket,//?
	kATAModeNotSupported,//?
	kATADeviceError,//?
	kATAResetEvent,//?
	mATAFlagQuiesce,//?
	kSATABay,//?
	kATAPIFnExecIO,//?
	kATAErrUnknownType,//?
	mATAFlagProtocolATAPI,//?
	mATAFlagUseDMA,//?
	mATAFlagIORead,//?
	mATAFlagIOWrite,//?
	mATAFlag48BitLBA,//?
	kATAInvalidDevID,//?
	mATADataRequest,//?
	kATAFnExecIO,//?
	mATADriveReady,//?
	kATAErrDevBusy,//?
	mATAErrFeaturesValid,//?
	mATASectorCntValid,//?
	mATASectorNumValid,//?
	mATACylinderLoValid,//?
	mATACylinderHiValid,//?
	mATASDHValid,//?
	mATAAltSDevCValid,//?
	mATADataValid,//?
	mATAStatusCmdValid,//?
	kATATimeoutErr,//?
	mATAError,//?
	mATASectorSize,//?
	kATAPIResetEvent,//?
	kMediaBaySocket,//?
	kATARemovedEvent,//?
	kPCCardSocket,//?
	kATAPIUnknown,//?
	kATAPIDRQFast,//?
	kPACKET,//?
	mATAFlagUseConfigSpeed,//?
	mATAPIuseDMA,//?
	kATADefaultSectorSize,//?
	kATADevIntNoCmd,//?
	kATADMAErr,//?
	kATANullEvent,//?
	kATAcmdSleep,//?
	kATAFnRegAccess,//?
	kATAcmdSetFeatures,//?
	kATASetTransferMode,//?
	kID_DRIVE,//?
	mATAFlagImmediate,//?
	kATAFnBusReset,//?
	kSOFTRESET,//?
};

struct ataTaskFile{
	int ataTFSDH;//?
	int ataTFFeatures;//?
	int ataTFCount;//?
	int ataTFSector;//?
	int ataTFCylLo;//?
	int ataTFCylHigh;//?
	int ataTFCommand;//?
};

typedef int ataEventCode;//?
typedef int ataSocketType;//?
typedef int ataDeviceType;//?
typedef int atapiConfig;//?
typedef int ataFlags;//?
typedef int ataOpcode;//?
typedef int ataRegMask;//?

#endif//HYS_IOKIT_ATA_IOATATYPES_H

