#ifndef HYS_IOKIT_ATA_MACIOATA_H
#define HYS_IOKIT_ATA_MACIOATA_H

class  MacIOATA_HYS
{
    OSDeclareDefaultStructors(MacIOATA_HYS)

public://data

enum ATADMAState 	{
		kATADMAInactive,
		kATADMAStarting,
		kATADMAActive,
		kATADMAStatus,
		kATADMAComplete,
		kATADMAError
	};//c

IOMemoryMap* _baseAddressMap;//c
volatile IODBDMAChannelRegisters* _dmaControlReg;//c
volatile UInt32*_timingConfigReg;//c
IOInterruptEventSource *_devIntSrc;//c
IODBDMADescriptor* _descriptors;//c
IODBDMAMemoryCursor* _DMACursor;//c
bool  _resyncInterrupts;//c
IOPhysicalAddress _descriptorsPhysical;//c
bool isMediaBay;//c
UInt32 _dmaIntExpected;//c
UInt32 _dmaState;//c
bool isBusOnline;//c

public://define

#define MacIOATA_configureTFPointers \
virtual bool configureTFPointers(void);//c

#define MacIOATA_handleDeviceInterrupt \
virtual IOReturn handleDeviceInterrupt(void);//c

#define MacIOATA_processDMAInterrupt \
virtual void processDMAInterrupt (void);//c

#define MacIOATA_initATADMAChains \
virtual void initATADMAChains (IODBDMADescriptor* descPtr);//c

#define MacIOATA_shutDownATADMA \
virtual void shutDownATADMA (void);//c

public://func


};

#endif//HYS_IOKIT_ATA_MACIOATA_H

