#ifndef HYS_IOKIT_AUDIO_IOAUDIOCONTROL_H
#define HYS_IOKIT_AUDIO_IOAUDIOCONTROL_H

//hys add 

#define IOAudioControl_sendQueuedNotifications \
void sendQueuedNotifications();//?

#define IOAudioControl_sendChangeNotification \
void sendChangeNotification(UInt32 a);//?

#define IOAudioControl_setCoreAudioPropertyID \
void setCoreAudioPropertyID(UInt32 a);//?

#define IOAudioControl_getType \
 UInt32 getType();//?

#define IOAudioContro_getSubType \
UInt32 getSubType();//?

#define IOAudioControl_getUsage \
UInt32 getUsage();//?

#define IOAudioControl_attachAndStart \
bool attachAndStart(IOService *a);//?

#define IOAudioControl_getDataBytes \
const void *getDataBytes();//?

#define IOAudioControl_getDataLength \
 UInt32 getDataLength();//?

#define IOAudioControl_setChannelNumber \
void setChannelNumber(SInt32 a);//?

#define IOAudioControl_setValue \
IOReturn setValue(SInt32 a);//?

#define IOAudioControl_setValueChangeHandler \
void setValueChangeHandler(DataValueChangeHandler a, OSObject *b);//?

#define IOAudioControl_setWorkLoop \
void setWorkLoop(IOWorkLoop *a);//?

#define IOAudioControl__setValue \
IOReturn _setValue(OSObject *a);//?

#define IOAudioControls_setValueChangeHandler_ObjectValueChangeHandler \
void setValueChangeHandler(ObjectValueChangeHandler a, OSObject *b);//?

#define IOAudioControl_setValueChangeHandler_IntValueChangeHandler \
void setValueChangeHandler(IntValueChangeHandler a, OSObject *b);//?

#define IOAudioControl_setValueChangeTarget \
void setValueChangeTarget(OSObject *a);//?

#define IOAudioControl_detachUserClients \
IOReturn detachUserClients();//?

#define IOAudioControl_getIntValue \
SInt32 getIntValue();//?

#define IOAudioControl_newUserClient_OSDictionary \
IOReturn newUserClient(task_t a, void *b, UInt32 c, OSDictionary *d, IOUserClient **e);//?


///////////////////
class  IOAudioControl_HYS
{
        OSDeclareDefaultStructors(IOAudioControl_HYS)

public://datatype
struct ExpansionData {
	IOAudioEngine * providerEngine;//c
	OSArray *	  notificationQueue;//c
};

typedef  IOReturn (*DataValueChangeHandler)(OSObject *a, IOAudioControl *b, const void *c, UInt32 d, const void *e, UInt32 f);//c


typedef IOReturn (*ObjectValueChangeHandler)(OSObject *a, IOAudioControl *b, OSObject *c, OSObject *d);//c

/*IntValueChangeHandler


Handler function used to make a notification when a value is to be changed. 

public

typedef IOReturn ( *IntValueChangeHandler)(
    OSObject *target,
    IOAudioControl *audioControl,
    SInt32 oldValue,
    SInt32 newValue); 
Fields
target
Reference supplied when the handler was registered.
audioControl
The IOAudioControl that is changing.
oldValue
The old value of the control.
newValue
The new value the control is being changed to.
Return Value

Must return kIOReturnSuccess when the hardware is successfully updated.*/

typedef IOReturn ( *IntValueChangeHandler)(
    OSObject *target,
    IOAudioControl *audioControl,
    SInt32 oldValue,
    SInt32 newValue);

union  {
	IntValueChangeHandler intHandler;//c
	DataValueChangeHandler dataHandler;//c
	ObjectValueChangeHandler objectHandler;//c
}valueChangeHandler;


typedef enum{
	kIntValueChangeHandler,//?
	kDataValueChangeHandler,//?
	kObjectValueChangeHandler,//?
    } ValueChangeHandlerType;
ValueChangeHandlerType valueChangeHandlerType;

public://data

ExpansionData * reserved;//?
int type;//?
int subType;//?
int usage;//?
OSObject	*valueChangeTarget;//c
OSObject	*value;//c

public: //func

int getIntValue();//?

};

#endif //HYS_IOKIT_AUDIO_IOAUDIOCONTROL_H
