#ifndef HYS_IOKIT_AVC_IOFIREWIREAVCUSERCLIENTCOMMON_H
#define HYS_IOKIT_AVC_IOFIREWIREAVCUSERCLIENTCOMMON_H

#define kAsyncCmdSharedBufInterimRespOffset 0//?
#define kAsyncCmdSharedBufFinalRespOffset 1//?

enum {
	kIOFWAVCProtocolUserClientSendAVCResponse,//?
	kIOFWAVCProtocolUserClientFreeInputPlug,//?
	kIOFWAVCProtocolUserClientReadInputPlug,//?
	kIOFWAVCProtocolUserClientUpdateInputPlug,//?
	kIOFWAVCProtocolUserClientFreeOutputPlug,//?
	kIOFWAVCProtocolUserClientReadOutputPlug,//?
	kIOFWAVCProtocolUserClientUpdateOutputPlug,//?
	kIOFWAVCProtocolUserClientReadOutputMasterPlug,//?
	kIOFWAVCProtocolUserClientUpdateOutputMasterPlug,//?
	kIOFWAVCProtocolUserClientReadInputMasterPlug,//?
	kIOFWAVCProtocolUserClientUpdateInputMasterPlug,//?
	kIOFWAVCProtocolUserClientPublishAVCUnitDirectory,//?
	kIOFWAVCProtocolUserClientSetSubunitPlugSignalFormat,//?
	kIOFWAVCProtocolUserClientGetSubunitPlugSignalFormat,//?
	kIOFWAVCProtocolUserClientDisconnectTargetPlugs,//?
	kIOFWAVCProtocolUserClientGetTargetPlugConnection,//?
	kIOFWAVCProtocolUserClientConnectTargetPlugs,//?
	kIOFWAVCProtocolUserClientAVCRequestNotHandled,//?
	kIOFWAVCProtocolUserClientAllocateInputPlug,//?
	kIOFWAVCProtocolUserClientAllocateOutputPlug,//?
	kIOFWAVCProtocolUserClientInstallAVCCommandHandler,//?
	kIOFWAVCProtocolUserClientAddSubunit,//?
	kIOFWAVCProtocolUserClientSetAVCRequestCallback,//?
	kIOFWAVCUserClientOpen,//?
	kIOFWAVCUserClientClose,//?
	kIOFWAVCUserClientGetSessionRef,//?
	kIOFWAVCUserClientAVCCommand,//?
	kIOFWAVCUserClientUpdateAVCCommandTimeout,//?
	kIOFWAVCUserClientCancelAsyncAVCCommand,//?
	kIOFWAVCUserClientReleaseAsyncAVCCommand,//?
	kIOFWAVCUserClientReinitAsyncAVCCommand,//?
	kIOFWAVCUserClientInstallAsyncAVCCommandCallback,//?
	kIOFWAVCUserClientMakeP2PInputConnection,//?
	kIOFWAVCUserClientSubmitAsyncAVCCommand,//?
	kIOFWAVCUserClientBreakP2PInputConnection,//?
	kIOFWAVCUserClientCreateAsyncAVCCommand,//?
	kIOFWAVCUserClientOpenWithSessionRef,//?
	kIOFWAVCUserClientBreakP2POutputConnection,//?
	kIOFWAVCUserClientMakeP2POutputConnection,//?
	kIOFWAVCUserClientAVCCommandInGen,//?
};

struct _AVCConnectTargetPlugsInParams {
	int sourceSubunitTypeAndID;//?
	int sourcePlugType;//?
	int sourcePlugNum;//?
	int destSubunitTypeAndID;//?
	int destPlugType;//?
	UInt32 destPlugNum;//c
	int lockConnection;//?
	int permConnection;//?
};
typedef struct _AVCConnectTargetPlugsInParams AVCConnectTargetPlugsInParams;

struct _AVCConnectTargetPlugsOutParams {
	int sourcePlugNum;//?
	int destPlugNum;//?
};
typedef struct _AVCConnectTargetPlugsOutParams AVCConnectTargetPlugsOutParams;

struct _AVCGetTargetPlugConnectionInParams {
	int plugType;//?
	int subunitTypeAndID;//?
	int plugNum;//?
};
typedef struct _AVCGetTargetPlugConnectionInParams AVCGetTargetPlugConnectionInParams;

struct _AVCGetTargetPlugConnectionOutParams {
	int connectedSubunitTypeAndID;//?
	int connectedPlugType;//?
	int connectedPlugNum;//?
	int lockConnection;//?
	int permConnection;//?
};
typedef struct  _AVCGetTargetPlugConnectionOutParams AVCGetTargetPlugConnectionOutParams;



#endif//HYS_IOKIT_AVC_IOFIREWIREAVCUSERCLIENTCOMMON_H
