#ifndef HYS_IOKIT_FIREWIRE_IOFWADDRESSSPACE_H
#define HYS_IOKIT_FIREWIRE_IOFWADDRESSSPACE_H

class IOFWAddressSpace;//add

typedef void* IOFWRequestRefCon;//?

class  IOFWAddressSpace_HYS
{
//    OSDeclareAbstractStructors(IOFWAddressSpace_HYS)

public:
IOFireWireController * fControl;//c

public://func

#define IOFWAddressSpace_init \
 bool init(IOFireWireBus *a);//?

#define IOFWAddressSpace_createAuxiliary \
IOFWAddressSpaceAux * createAuxiliary( );//?

#define IOFWAddressSpace_free \
void free();//?

public://func
int doRead(UInt16 a,int b,FWAddress c,int d,IOMemoryDescriptor** e,IOByteCount* f,IOFWRequestRefCon g);//?

int doWrite(UInt16 a,int b,FWAddress c,int d,const void* e,IOFWRequestRefCon f);//?
int setExclusive(int a);//?

};

class IOFWAddressSpaceAux_HYS
{
    OSDeclareDefaultStructors(IOFWAddressSpaceAux_HYS)

public://dara
IOFWAddressSpace *fPrimary;//c
IOFireWireController *	fControl;//c
OSSet *fTrustedNodeSet;//c
OSIterator *fTrustedNodeSetIterator;//c

int fExclusive;//?

public://func

#define IOFWAddressSpaceAux_init \
bool init( IOFWAddressSpace * a);//?

#define IOFWAddressSpaceAux_free \
void free();//?

#define IOFWAddressSpaceAux_isTrustedNode \
bool isTrustedNode( UInt16 a);//?

#define IOFWAddressSpaceAux_removeAllTrustedNodes \
void removeAllTrustedNodes();//?

#define IOFWAddressSpaceAux_setExclusive \
void setExclusive( bool a );//c

#define IOFWAddressSpaceAux_removeTrustedNode \
void removeTrustedNode( IOFireWireDevice * a );//?

#define IOFWAddressSpaceAux_addTrustedNode \
void addTrustedNode( IOFireWireDevice * a);//?

#define IOFWAddressSpaceAux_isExclusive \
bool isExclusive( );//c

#define IOFWAddressSpaceAux_intersects \
bool intersects( IOFWAddressSpace *a);//?

};


#endif//HYS_IOKIT_FIREWIRE_IOFWADDRESSSPACE_H
