#ifndef HYS_IOKIT_FIREWIRE_IOFWPHYSICALADDRESSSPACE_H
#define HYS_IOKIT_FIREWIRE_IOFWPHYSICALADDRESSSPACE_H

struct FWSegment  {
	int length;//?
	FWAddress address;//c
};

class  IOFWPhysicalAddressSpace_HYS
{
    OSDeclareDefaultStructors(IOFWPhysicalAddressSpace_HYS)

public://func

int getPhysicalSegment(int a,UInt64 *b);//?
int getSegments(UInt64 * a,FWSegment * b,UInt32 *c);//?

public://func=define

#define IOFWPhysicalAddressSpace_createAuxiliary \
IOFWAddressSpaceAux * createAuxiliary();//?

#define IOFWPhysicalAddressSpace_free \
void free();//?

};

class  IOFWPhysicalAddressSpaceAux_HYS
{
    OSDeclareDefaultStructors(IOFWPhysicalAddressSpaceAux_HYS)

public://dara
IODMACommand *fDMACommand;//c

int fDMACommandPrepared;//?

public://func

#define IOFWPhysicalAddressSpaceAux_complete \
IOReturn complete();//?

#define IOFWPhysicalAddressSpaceAux_getPhysicalSegment \
UInt64 getPhysicalSegment( UInt64 a, UInt64 * b);//?

#define IOFWPhysicalAddressSpaceAux_setDMACommand \
void setDMACommand( IODMACommand * a);//?

#define IOFWPhysicalAddressSpaceAux_init \
bool init( IOFWAddressSpace * a);//?

#define  IOFWPhysicalAddressSpaceAux_free \
void free();//?

#define IOFWPhysicalAddressSpaceAux_isPrepared \
bool isPrepared();//?

#define IOFWPhysicalAddressSpaceAux_synchronize \
IOReturn synchronize( IOOptionBits a );//?

#define IOFWPhysicalAddressSpaceAux_getSegments \
IOReturn getSegments( UInt64 * a, FWSegment * b, UInt32 * c );//?

#define IOFWPhysicalAddressSpaceAux_prepare \
IOReturn prepare( );//?

#define IOFWPhysicalAddressSpaceAux_getDMACommand \
IODMACommand * getDMACommand(); //?

};


#endif//HYS_IOKIT_FIREWIRE_IOFWPHYSICALADDRESSSPACE_H
