#ifndef HYS_IOKIT_FIREWIRE_IOFWPSEUDEADDRESSSPACE_H
#define HYS_IOKIT_FIREWIRE_IOFWPSEUDEADDRESSSPACE_H

typedef void (*IOFWARxReqIntCompleteHandler)( void *a );//c

class IOFWPseudoAddressSpace_HYS
{
    OSDeclareDefaultStructors(IOFWPseudoAddressSpace_HYS)

public://data-define

#define  IOFWPseudoAddressSpace_allocatedAddresses \
static	OSData *allocatedAddresses; //c

public://data

IOMemoryDescriptor* fDesc;//c
FWAddress  fBase;//c
void* fRefCon;//c
FWReadCallback fReader;//c
FWWriteCallback fWriter;//c

int fLen;//?

public://func

#define IOFWPseudoAddressSpace_allocateAddress \
IOReturn	allocateAddress(FWAddress* a,UInt32 b);//?

#define IOFWPseudoAddressSpace_freeAddress \
void freeAddress(FWAddress a,UInt32 b);//?

#define IOFWPseudoAddressSpace_free \
void free();//?

#define IOFWPseudoAddressSpace_createAuxiliary  \
IOFWAddressSpaceAux * createAuxiliary();//?

public://func

int handleARxReqIntComplete();//?

};

class  IOFWPseudoAddressSpaceAux_HYS
{
    OSDeclareDefaultStructors(IOFWPseudoAddressSpaceAux_HYS)

public://data

struct MemberVariables {
	IOFWARxReqIntCompleteHandler  fARxReqIntCompleteHandler;//c
	void* fARxReqIntCompleteHandlerRefcon;//c
};

MemberVariables* fMembers;//c

public://func

#define IOFWPseudoAddressSpaceAux_init \
bool init( IOFWAddressSpace * a);//?

#define IOFWPseudoAddressSpaceAux_free \
void free();//?

#define IOFWPseudoAddressSpaceAux_createMemberVariables \
bool createMemberVariables( );//?

#define IOFWPseudoAddressSpaceAux_destroyMemberVariables \
void destroyMemberVariables();//?

#define IOFWPseudoAddressSpaceAux_setARxReqIntCompleteHandler \
void setARxReqIntCompleteHandler( void * a, IOFWARxReqIntCompleteHandler b );//?

#define IOFWPseudoAddressSpaceAux_handleARxReqIntComplete \
void handleARxReqIntComplete();//?

#define IOFWPseudoAddressSpaceAux_intersects \
bool intersects( IOFWAddressSpace *a);//?

};


#endif//HYS_IOKIT_FIREWIRE_IOFWPSEUDEADDRESSSPACE_H
