#ifndef HYS_IOKIT_FIREWIRE_IOFIREWIRELIBISOCH_H
#define HYS_IOKIT_FIREWIRE_IOFIREWIRELIBISOCH_H

#define IOFIREWIRELIBISOCHPORT_C_GUTS	\
	IOReturn	(*GetSupported)	( IOFireWireLibIsochPortRef self, IOFWSpeed* maxSpeed, UInt64* chanSupported ) ;	\
	IOReturn	(*AllocatePort)	( IOFireWireLibIsochPortRef self, IOFWSpeed speed, UInt32 chan ) ;	\
	IOReturn 	(*ReleasePort)	( IOFireWireLibIsochPortRef self ) ;	\
	IOReturn	(*Start)		( IOFireWireLibIsochPortRef self ) ;	\
	IOReturn	(*Stop)			( IOFireWireLibIsochPortRef self ) ;	\
	void 		(*SetRefCon)	( IOFireWireLibIsochPortRef self, void* inRefCon) ;	\
	void*		(*GetRefCon)	( IOFireWireLibIsochPortRef self)

////////////////////

#define kIOFireWireRemoteIsochPortInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//?

#define kIOFireWireLocalIsochPortInterfaceID  CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//? 

#define kIOFireWireLocalIsochPortInterfaceID_v2 CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//? 

#define kIOFireWireLocalIsochPortInterfaceID_v5 CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//? 

#define kIOFireWireLocalIsochPortInterfaceID_v4 CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//? 

#define kIOFireWireNuDCLPoolInterfaceID CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16)//? 

#define kIOFireWireIsochChannelInterfaceID 1//?


//////////////
typedef IOReturn	(*IOFireWireLibIsochPortGetSupportedCallback)(IOFireWireLibIsochPortRef a, IOFWSpeed
*b, UInt64* c) ;//c

typedef IOReturn (*IOFireWireLibIsochPortAllocateCallback)(IOFireWireLibIsochPortRef	 a, IOFWSpeed b, UInt32 c) ;//c

typedef IOReturn	(*IOFireWireLibIsochPortCallback)(IOFireWireLibIsochPortRef	a) ;//c
typedef IOReturn	(*IOFireWireLibIsochPortFinalizeCallback)( void* a) ;//c
/////////////////

struct IOFireWireNuDCLPoolInterface_t {
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy
	DCLCommand*	 (*GetProgram)( IOFireWireLibNuDCLPoolRef a) ;//c	
	CFArrayRef				(*GetDCLs)( IOFireWireLibNuDCLPoolRef a) ;//c
	void					(*PrintProgram)( IOFireWireLibNuDCLPoolRef a ) ;//c
	void					(*PrintDCL)( NuDCLRef a) ;//c
	void	(*SetCurrentTagAndSync)( IOFireWireLibNuDCLPoolRef a, UInt8 b, UInt8 c) ;//c

	NuDCLSendPacketRef		(*AllocateSendPacket)( IOFireWireLibNuDCLPoolRef a, CFMutableSetRef b, UInt32 c, IOVirtualRange* d) ;	//c

	NuDCLSendPacketRef		(*AllocateSendPacket_v)( IOFireWireLibNuDCLPoolRef a, CFMutableSetRef b, IOVirtualRange* c, ... ) ;	//c

	NuDCLSkipCycleRef		(*AllocateSkipCycle)( IOFireWireLibNuDCLPoolRef a) ;//c

	NuDCLReceivePacketRef	(*AllocateReceivePacket)( IOFireWireLibNuDCLPoolRef a, CFMutableSetRef b, UInt8 c, UInt32 d, IOVirtualRange* e ) ;//c

	NuDCLReceivePacketRef	(*AllocateReceivePacket_v)( IOFireWireLibNuDCLPoolRef a, CFMutableSetRef b, UInt8 c, IOVirtualRange* d, ... ) ;//c
	
	NuDCLRef (*FindDCLNextDCL)( IOFireWireLibNuDCLPoolRef a, NuDCLRef b) ;//c
	IOReturn			(*SetDCLBranch)( NuDCLRef a, NuDCLRef b) ;//c
	NuDCLRef			(*GetDCLBranch)( NuDCLRef a) ;//c

	IOReturn			(*SetDCLTimeStampPtr)( NuDCLRef a, UInt32* b ) ;//c
	UInt32*				(*GetDCLTimeStampPtr)( NuDCLRef a) ;//c
	IOReturn			(*SetDCLStatusPtr)( NuDCLRef dcl, UInt32* statusPtr ) ;
	UInt32*				(*GetDCLStatusPtr)( NuDCLRef a ) ;//c
	IOReturn (*AppendDCLRanges) ( NuDCLRef a, UInt32 b, IOVirtualRange* c ) ;//c
	IOReturn (*SetDCLRanges) ( NuDCLRef a, UInt32 b, IOVirtualRange* c ) ;//c
	IOReturn (*SetDCLRanges_v) ( NuDCLRef a, IOVirtualRange* b, ... ) ;//c
	UInt32 (*GetDCLRanges) ( NuDCLRef a, UInt32 b, IOVirtualRange* c ) ;//c
	UInt32				(*CountDCLRanges)			( NuDCLRef a) ;//c
	IOReturn			(*GetDCLSpan) ( NuDCLRef a, IOVirtualRange* b ) ;//c
	IOByteCount			(*GetDCLSize)				( NuDCLRef a) ;//c
	IOReturn			(*SetDCLCallback)	( NuDCLRef a, NuDCLCallback b) ;//c
	NuDCLCallback		(*GetDCLCallback)( NuDCLRef a ) ;//c
	IOReturn	(*SetDCLUserHeaderPtr)( NuDCLRef a, UInt32 *b, UInt32 *c ) ;//c
	UInt32 *			(*GetDCLUserHeaderPtr)( NuDCLRef a) ;//c
	UInt32 *			(*GetUserHeaderMaskPtr)( NuDCLRef a ) ;//c
	void				(*SetDCLRefcon)( NuDCLRef a, void* b ) ;//c
	void*				(*GetDCLRefcon)( NuDCLRef a) ;//c
	IOReturn			(*AppendDCLUpdateList)( NuDCLRef a, NuDCLRef b) ;//c
	IOReturn			(*SetDCLUpdateList)( NuDCLRef a, CFSetRef b ) ;//c
	CFSetRef			(*CopyDCLUpdateList)( NuDCLRef a ) ;//c
	IOReturn			(*RemoveDCLUpdateList)( NuDCLRef a ) ;//c
	IOReturn			(*SetDCLWaitControl)( NuDCLRef a, Boolean b) ;//c
	void				(*SetDCLFlags)( NuDCLRef a, UInt32 b ) ;//c
	UInt32				(*GetDCLFlags)( NuDCLRef a) ;//c
	IOReturn			(*SetDCLSkipBranch)( NuDCLRef a, NuDCLRef b) ;//c
	NuDCLRef			(*GetDCLSkipBranch)( NuDCLRef a ) ;//c
	IOReturn			(*SetDCLSkipCallback)( NuDCLRef a, NuDCLCallback b ) ;//c
	NuDCLCallback		(*GetDCLSkipCallback)( NuDCLRef a ) ;//c
	IOReturn			(*SetDCLSkipRefcon)( NuDCLRef a, void * b ) ;//c
	void *				(*GetDCLSkipRefcon)( NuDCLRef a ) ;//c
	IOReturn			(*SetDCLSyncBits)( NuDCLRef a, UInt8 b ) ;//c
	UInt8				(*GetDCLSyncBits)( NuDCLRef a ) ;//c
	IOReturn			(*SetDCLTagBits)( NuDCLRef a, UInt8 b ) ;//c
	UInt8				(*GetDCLTagBits)( NuDCLRef a) ;//c
};
typedef  struct IOFireWireNuDCLPoolInterface_t  IOFireWireNuDCLPoolInterface;

struct IOFireWireIsochPortInterface_t {
	IUNKNOWN_C_GUTS ;
	IOFIREWIRELIBISOCHPORT_C_GUTS ;
};
typedef struct IOFireWireIsochPortInterface_t IOFireWireIsochPortInterface;

struct IOFireWireRemoteIsochPortInterface_t {
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy
	IOFIREWIRELIBISOCHPORT_C_GUTS ;

	IOFireWireLibIsochPortGetSupportedCallback (*SetGetSupportedHandler) ( IOFireWireLibRemoteIsochPortRef a, IOFireWireLibIsochPortGetSupportedCallback b) ;//c

	IOFireWireLibIsochPortAllocateCallback	   (*SetAllocatePortHandler) ( IOFireWireLibRemoteIsochPortRef a, IOFireWireLibIsochPortAllocateCallback b) ;//c

	IOFireWireLibIsochPortCallback	(*e)( IOFireWireLibRemoteIsochPortRef a, IOFireWireLibIsochPortCallback b) ;//dummy

	IOFireWireLibIsochPortCallback	(*f)( IOFireWireLibRemoteIsochPortRef a, IOFireWireLibIsochPortCallback b) ;//dummy

	IOFireWireLibIsochPortCallback	(*g)( IOFireWireLibRemoteIsochPortRef a, IOFireWireLibIsochPortCallback b) ;//dummy

};
typedef struct IOFireWireRemoteIsochPortInterface_t IOFireWireRemoteIsochPortInterface;

struct IOFireWireIsochChannelInterface_t {
	IUNKNOWN_C_GUTS ;
	int (*SetTalker)(int a,int b);//?
	int (*AddListener)(int a,int b);//?
	int (*TurnOnNotification)(int a);//?
	int (*AllocateChannel)(int a);//?
	int (*Start)(int a);//?
	int (*TurnOffNotification)(int a);//?
	int (*Stop)(int a);//?
	int (*ReleaseChannel)(int a);//?
};
typedef struct IOFireWireIsochChannelInterface_t IOFireWireIsochChannelInterface;

struct IOFireWireLocalIsochPortInterface_t {
	IUNKNOWN_C_GUTS ;
	int a;//dummy
	int b;//dummy
	IOFIREWIRELIBISOCHPORT_C_GUTS ;
	IOReturn 	(*ModifyJumpDCL)( IOFireWireLibLocalIsochPortRef a, DCLJump* b, DCLLabel* c) ;//c
	void 		(*PrintDCLProgram)( IOFireWireLibLocalIsochPortRef a, const DCLCommand* b, UInt32 c) ;//c
	IOReturn	(*ModifyTransferPacketDCLSize)( IOFireWireLibLocalIsochPortRef a, DCLTransferPacket* b, IOByteCount c) ;//c
	IOReturn	(*ModifyTransferPacketDCLBuffer)( IOFireWireLibLocalIsochPortRef a, DCLTransferPacket* b, void* c) ;//c
	IOReturn	(*ModifyTransferPacketDCL)( IOFireWireLibLocalIsochPortRef a, DCLTransferPacket* b, void* c, IOByteCount d) ;//c
	IOReturn		(*SetFinalizeCallback)( IOFireWireLibLocalIsochPortRef a, IOFireWireLibIsochPortFinalizeCallback b) ;//c
	IOReturn		(*SetResourceUsageFlags)( IOFireWireLibLocalIsochPortRef a, IOFWIsochResourceFlags b) ;//c
	IOReturn		(*Notify)( IOFireWireLibLocalIsochPortRef a, IOFWDCLNotificationType b, void ** c, UInt32 d) ;//c
};
typedef struct IOFireWireLocalIsochPortInterface_t IOFireWireLocalIsochPortInterface;

///////////////////



#endif//HYS_IOKIT_FIREWIRE_IOFIREWIRELIBISOCH_H
