#ifndef HYS_IOKIT_FIREWIRE_IOFIREWIRELINK_H
#define HYS_IOKIT_FIREWIRE_IOFIREWIRELINK_H

enum {
	kIOFWSetDSLimit,//?
	kIOFWAllPhysicalFilters,//?
	kIOFWNodeFlagRetryOnAckD,//?
};

class IOFireWireLink_HYS
{
   // OSDeclareAbstractStructors(IOFireWireLink_HYS)

public://data

IOFireWireController *fControl;//c
IOFWWorkLoop *fWorkLoop;//c

public://define

#define IOFireWireLink_handleSystemShutDown \
void handleSystemShutDown( UInt32 a);//?

#define IOFireWireLink_disablePHYPortOnSleep \
void disablePHYPortOnSleep( UInt32 a);//?

#define IOFireWireLink_enterLoggingMode \
bool enterLoggingMode();//?

#define IOFireWireLink_isPhysicalAccessEnabledForNodeID \
bool isPhysicalAccessEnabledForNodeID( UInt16 a );//?

#define IOFireWireLink_getCycleTimeAndUpTime \
IOReturn getCycleTimeAndUpTime( UInt32 &a, UInt64 &b);//?

#define IOFireWireLink_setLinkMode \
UInt32 setLinkMode( UInt32 a, UInt32 b);//?

#define IOFireWireLink_notifyInvalidSelfIDs \
void notifyInvalidSelfIDs ();//?

#define IOFireWireLink_handleAsyncCompletion \
IOReturn handleAsyncCompletion( IOFWCommand *a, IOReturn b);//?

#define IOFireWireLink_getWorkLoop \
IOWorkLoop *getWorkLoop () const;//?

#define IOFireWireLink_getPingTransmits \
bool getPingTransmits ();//?

#define IOFireWireLink_getPingTimes \
UInt32 *getPingTimes ();//?

#define IOFireWireLink_setPingTransmits \
void setPingTransmits ( bool a);//?

#define IOFireWireLink_getFireWireWorkLoop \
IOFWWorkLoop *getFireWireWorkLoop () const;//?

#define IOFireWireLink_createBufferFillIsochPort \
IOFWBufferFillIsochPort *   createBufferFillIsochPort () ;//?

#define IOFireWireLink_createDCLPool  \
IOFWDCLPool* createDCLPool ( UInt32 a );//?

#define IOFireWireLink_configureAsyncRobustness \
void configureAsyncRobustness( bool a );//?

#define IOFireWireLink_asyncPHYPacket \
IOReturn asyncPHYPacket( UInt32 a, UInt32 b, IOFWAsyncPHYCommand * c);//?

#define IOFireWireLink_getController \
IOFireWireController *getController() const;//?

#define IOFireWireLink_createDeviceNub \
IOFireWireDevice *createDeviceNub(CSRNodeUniqueID a, const IOFWNodeScan *b);//?

#define IOFireWireLink_createWorkLoop \
IOFWWorkLoop* createWorkLoop();//?

#define IOFireWireLink_createController \
IOFireWireController * createController();//?

public://func

int setNodeFlags(int a,int b);//?
int clipMaxRec2K(int a);//?
int getBusCycleTime(int a,int b);//?
int getCycleTime(int a);//?
int asyncLockResponse(int a,int b,int c,int d,int e,void* f,int g);//?
int asyncWriteResponse(int a,int b,int c,int d,int e);//?

IODCLProgram* createDCLProgram(bool a, DCLCommand *b, IOFireWireController::DCLTaskInfo *c, UInt32 d, UInt32 e, UInt32 f);

int flushWaitingPackets();//?
int getPhySpeed();//?
int handleInterrupts(int* a,int b);//?
IOFWDCLPool* createDCLPool(int a);//?
int getGUID();//?
int getBusCharacteristics();//?
int getMaxSendLog();//?
int setContender(int a);//?
int setRootHoldOff(int a);//?
int resetBus(int a=0);//?
int setLinkPowerState(int a);//?
int sendPHYPacket(int a);//?
int setCycleMaster(int a);//?
int setNodeIDPhysicalFilter(int a,int b);//?
int setSecurityMode(int a);//?
int updateROM(const OSData *a);//?
int asyncRead(int a,int b,int c,int d,int e,int f,IOFWAsyncCommand* g,int h);//?

int asyncWrite(int a,int b,int c,int d,int e,IOMemoryDescriptor * f,int g,int h, IOFWAsyncCommand *i,int j);

int asyncLock(UInt16 a, UInt16 b, UInt32 c, int d, int e, int f, IOMemoryDescriptor *g, IOByteCount h, int i, IOFWAsyncCommand *j);//?

int handleAsyncTimeout(IOFWAsyncCommand* a);//?

int asyncStreamTransmit (UInt32 a, int b, UInt32 c, UInt32 d, IOMemoryDescriptor* e, IOByteCount f, int g,IOFWAsyncStreamCommand *h );//?

int asyncReadQuadResponse(int a,int b,int c,int d,int e);//?

int asyncReadResponse(int a,int b,int c,int d,IOMemoryDescriptor* e,int f,int g, IODMACommand *h);//?

};

#endif//HYS_IOKIT_FIREWIRE_IOFIREWIRELINK_H
