#ifndef HYS_IOKIT_FIREWIRE_IOFIREWIREUNIT_H
#define HYS_IOKIT_FIREWIRE_IOFIREWIREUNIT_H


class  IOFireWireUnit_HYS
{
    OSDeclareDefaultStructors(IOFireWireUnit_HYS)

public://data

IOFireWireDevice *fDevice;//c

public://define

#define IOFireWireUnit_setMaxSpeed \
void setMaxSpeed( IOFWSpeed a);//?

#define IOFireWireUnit_getNodeFlags \
UInt32 getNodeFlags();//?

#define IOFireWireUnit_setConfigDirectory \
IOReturn setConfigDirectory( IOConfigDirectory *a);//?

#define IOFireWireUnit_free \
void free();//?

#define IOFireWireUnit_terminateUnitThreadFunc \
static void terminateUnitThreadFunc( void * a);//?

#define IOFireWireUnit_clearNodeFlags \
void clearNodeFlags( UInt32 a);//?

#define IOFireWireUnit_message \
IOReturn message( UInt32 a, IOService * b, void * c);//?

#define IOFireWireUnit_matchPropertyTable \
bool matchPropertyTable(OSDictionary * a);//?;

#define IOFireWireUnit_setNodeFlags \
void setNodeFlags( UInt32 a);//?

#define IOFireWireUnit_handleOpen \
bool handleOpen( 	IOService *a,  IOOptionBits b, void *c);//?

#define IOFireWireUnit_handleClose \
void handleClose(  IOService *a, IOOptionBits b);//?

#define IOFireWireUnit_terminateUnit \
void terminateUnit();//?

#define IOFireWireUnit_createPhysicalAddressSpace \
IOFWPhysicalAddressSpace *createPhysicalAddressSpace(IOMemoryDescriptor *a);//?

#define IOFireWireUnit_createAuxiliary \
IOFireWireNubAux * createAuxiliary();//?

#define IOFireWireUnit_attach \
bool attach(IOService * a );//?

#define IOFireWireUnit_createPseudoAddressSpace \
IOFWPseudoAddressSpace *createPseudoAddressSpace(FWAddress *a, UInt32 b, FWReadCallback c, FWWriteCallback d, void *e);//?

#define IOFireWireUnit_init \
bool  init(OSDictionary *a, IOConfigDirectory * b);//?

public://func

IOFWSimpleContiguousPhysicalAddressSpace * createSimpleContiguousPhysicalAddressSpace(int a,int b);//?

int isPhysicalAccessEnabled();//?

};


class IOFireWireUnitAux_HYS
{
    OSDeclareDefaultStructors(IOFireWireUnitAux_HYS)
public:

#define IOFireWireUnitAux_free \
void free();//?

#define IOFireWireUnitAux_isPhysicalAccessEnabled \
bool isPhysicalAccessEnabled( );//?

#define IOFireWireUnitAux_createSimpleContiguousPhysicalAddressSpace \
IOFWSimpleContiguousPhysicalAddressSpace * createSimpleContiguousPhysicalAddressSpace( vm_size_t a, IODirection b);//?
		
#define IOFireWireUnitAux_createSimplePhysicalAddressSpace \
IOFWSimplePhysicalAddressSpace * createSimplePhysicalAddressSpace( vm_size_t a, IODirection b);//?

#define IOFireWireUnitAux_init \
bool init( IOFireWireUnit * a);//?

};

#endif//HYS_IOKIT_FIREWIRE_IOFIREWIREUNIT_H
