#ifndef HYS_IOKIT_GRAPHICS_IOGRAPHICSINTERFACE_H
#define HYS_IOKIT_GRAPHICS_IOGRAPHICSINTERFACE_H

#define kIOGraphicsAcceleratorTypeID (CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16))//?

#define kIOGraphicsAcceleratorInterfaceID	(CFUUIDGetConstantUUIDWithBytes(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16))//?

typedef IOReturn (*IOBlitterPtr)(void *a, IOOptionBits b, IOBlitType c, IOBlitSourceType d, IOBlitOperation *e, void * f);//c

struct IOGraphicsAcceleratorInterfaceStruct {

IOReturn (*SetDestination) (void *a, IOOptionBits b, IOBlitSurface * c);//c
IOReturn (*GetBlitter) (void *a, IOOptionBits b,IOBlitType c, IOBlitSourceType d, IOBlitterPtr *e);//c
IOReturn (*Reset) (void *a, IOOptionBits b);//c
IOReturn (*WaitComplete) (void *a, IOOptionBits b);//c
IOReturn (*Synchronize) (void *a, UInt32 b, UInt32 c, UInt32 d, UInt32 e, UInt32 f );//c
IOReturn (*GetBeamPosition) (void *a, IOOptionBits b, SInt32 *c);//c
IOReturn (*Flush) (void *a, IOOptionBits b);//c
IOReturn (*FreeSurface) (void *a, IOOptionBits b, IOBlitSurface * c);//c
IOReturn (*AllocateSurface) (void *a, IOOptionBits b,IOBlitSurface *c, void *d);//c

};
typedef  struct IOGraphicsAcceleratorInterfaceStruct IOGraphicsAcceleratorInterface;

#endif//HYS_IOKIT_GRAPHICS_IOGRAPHICSINTERFACE_H
