#ifndef HYS_IOKIT_GRAPHICS_IOGRAPHISCINTERFACETYPES_H
#define HYS_IOKIT_GRAPHICS_IOGRAPHISCINTERFACETYPES_H

#define kIOAccelTypesKey "kIOAccelTypesKey"//?
#define kIOAccelIndexKey "kIOAccelIndexKey"//?

enum {
	kIOBlitFramebufferDestination,//?
	kIOBlitAllOptions,//?
	kIOBlitTypeCopyRects,//?
	kIOBlitCopyOperation,//?
	kIOBlitSourceDefault,//?
	kIOBlitTypeRects,//?
	kIOBlitTypeOperationType0,//?
	kIOBlitSourceMemory,//?
	kIOBlitSourceSolid,//?
	kIOBlitTypeCopyRegion,//?
	kIOBlitSourceFramebuffer,//?
	kIOBlitWaitAll2D,//?
	kIOBlitDestFramebuffer,//?
	kIOBlitSurfaceDestination,//?
	kIOBlitHasCGSSurface,//?
	kIOBlitSourceCGSSurface,//?
};

struct IOBlitSurfaceStruct {
	int interfaceRef;//?
 	int byteOffset;//?
	int rowBytes;//?
	union {
		int ref;//?
	} memory;
};
typedef struct IOBlitSurfaceStruct  IOBlitSurface;

struct IOBlitOperationStruct {};
typedef struct IOBlitOperationStruct  IOBlitOperation;

struct IOBlitRectangleStruct  {
	int x;//?
	int y;//?
	int width;//?
	int height;//?
};
typedef struct IOBlitRectangleStruct  IOBlitRectangle;

struct IOBlitRectanglesStruct {
	int count;//?
	IOBlitRectangle rects[1];//
	int operation;//?
};
typedef struct IOBlitRectanglesStruct  IOBlitRectangles;

struct IOBlitCopyRectangleStruct {
	int x;//?
	int y;//?
	int width;//?
	int height;//?
	int sourceX;//?
	int sourceY;//?
};
typedef struct IOBlitCopyRectangleStruct  IOBlitCopyRectangle;

struct IOBlitCopyRectanglesStruct {
	int count;//?
	 IOBlitCopyRectangle rects[1];//?
	int operation;//?
};
typedef struct IOBlitCopyRectanglesStruct  IOBlitCopyRectangles;

struct IOBlitCopyRegionStruct {
	int region;//?
	int deltaX;//?
	int deltaY;//?
	int operation;//?
};
typedef struct IOBlitCopyRegionStruct  IOBlitCopyRegion;

typedef IOBlitSurface IOBlitMemory;//c
typedef int IOBlitType;//?
typedef int IOBlitSourceType;//?

#endif//HYS_IOKIT_GRAPHICS_IOGRAPHISCINTERFACETYPES_H
