#ifndef HYS_IOKIT_HID_IOHIDEVENTTYPES_H
#define HYS_IOKIT_HID_IOHIDEVENTTYPES_H

#define IOHIDEventTypeMask(a) a//?

enum {
	kIOHIDEventFieldTranslationX,//?
	kIOHIDEventFieldTranslationY,//?
	kIOHIDEventFieldMouseClickCount,//?
	kIOHIDEventFieldDigitizerZ,//?
	kIOHIDEventFieldTemperatureLevel,//?
	kIOHIDEventFieldSwipeMask,//?
	kIOHIDEventFieldMouseNumber,//?
	kIOHIDEventFieldDigitizerIndex,//?
	kIOHIDEventFieldDigitizerMinorRadius,//?
	kIOHIDEventFieldDigitizerAzimuth,//?
	kIOHIDEventFieldDigitizerDensity,//?
	kIOHIDEventFieldDigitizerIrregularity,//?
	kIOHIDEventFieldDigitizerAltitude,//?
	kIOHIDEventFieldDigitizerMajorRadius,//?
	kIOHIDEventFieldDigitizerQuality,//?
	kIOHIDEventFieldDigitizerTiltX,//?
	kIOHIDEventFieldDigitizerTiltY,//?
	kIOHIDEventFieldDigitizerCollection,//?
	kIOHIDEventFieldDigitizerTwist,//?
	kIOHIDEventFieldDigitizerPressure,//?
	kIOHIDEventFieldDigitizerBarrelPressure,//?
	kIOHIDEventFieldDigitizerButtonMask,//?
	kIOHIDEventFieldDigitizerTouch,//?
	kIOHIDEventFieldDigitizerRange,//?
	kIOHIDEventFieldDigitizerChildEventMask,//?
	kIOHIDEventFieldDigitizerEventMask,//?
	kIOHIDEventFieldDigitizerIdentity,//?
	kIOHIDEventFieldDigitizerY,//?
	kIOHIDEventFieldTranslationZ,//?
	kIOHIDEventFieldScrollIsPixels,//?
	kIOHIDEventFieldKeyboardRepeat,//?
	kIOHIDEventFieldKeyboardUsagePage,//?
	kIOHIDEventFieldDigitizerX,//?
	kIOHIDEventOptionPixelUnits,//?
	kIOHIDEventFieldProximityDetectionMask,//?
	kIOHIDEventFieldAmbientLightSensorLevel,//?
	kIOHIDEventFieldMousePressure,//?
	kIOHIDEventFieldKeyboardDown,//?
	kIOHIDEventFieldKeyboardUsage,//?
	kIOHIDEventFieldAmbientLightSensorRawChannel1,//?
	kIOHIDEventFieldAmbientLightDisplayBrightnessChanged,//?
	kIOHIDEventFieldAmbientLightSensorRawChannel0,//?
	kIOHIDEventFieldMouseButtonMask,//?
	kIOHIDEventFieldMouseZ,//?
	kIOHIDEventFieldMouseY,//?
	kIOHIDEventFieldMouseX,//?
	kIOHIDEventFieldButtonPressure,//?
	kIOHIDEventFieldButtonClickCount,//?
	kIOHIDEventFieldButtonNumber,//?
	kIOHIDEventFieldButtonMask,//?
	kIOHIDEventFieldProgressLevel,//?
	kIOHIDEventFieldProgressEventType,//?
	kIOHIDEventFieldVendorDefinedData,//?
	kIOHIDEventFieldVendorDefinedDataLength,//?
	kIOHIDEventFieldVendorDefinedVersion,//?
	kIOHIDEventFieldVendorDefinedUsage,//?
	kIOHIDEventFieldVendorDefinedUsagePage,//?
	kIOHIDEventOptionIsCollection,//?
	kIOHIDEventFieldIsCollection,//?
	kIOHIDEventOptionIsAbsolute,//?
	kIOHIDEventFieldIsRelative,//?
	kIOHIDEventTypeZoom,//?
	kIOHIDEventTypeProgress,//?
	kIOHIDEventTypeMouse,//?
	kIOHIDEventTypeSwipe,//?
	kIOHIDEventTypeTemperature,//?
	kIOHIDEventTypeDigitizer,//?
	kIOHIDEventTypeButton,//?
	kIOHIDEventTypeProximity,//?
	kIOHIDEventTypeAmbientLightSensor,//?
	kIOHIDEventTypeAccelerometer,//?
	kIOHIDEventTypeOrientation,//?
	kIOHIDEventTypeVelocity,//?
	kIOHIDEventTypeScale,//?
	kIOHIDEventTypeScroll,//?
	kIOHIDEventTypeTranslation,//?
	kIOHIDEventTypeRotation,//?
	kIOHIDEventTypeKeyboard,//?
	kIOHIDEventTypeVendorDefined,//?
	kIOHIDEventTypeNULL,//?
};

typedef int IOHIDEventType;//?
typedef int IOHIDEventField;//?
typedef int IOHIDSwipeMask;//?

#endif//HYS_IOKIT_HID_IOHIDEVENTTYPES_H
