#ifndef HYS_IOKIT_HIDSYSTEM_IOHIDPARAMETER_H
#define HYS_IOKIT_HIDSYSTEM_IOHIDPARAMETER_H

#define EVSIORKBD 	kIOHIDResetKeyboardKey//c
#define EVSIOSKR  	kIOHIDKeyRepeatKey//c
#define EVSIOCKR_SIZE	EVS_PACKED_TIME_SIZE//c
#define EVSIOSIKR 	kIOHIDInitialKeyRepeatKey//c
#define EVSIOSKM  	kIOHIDKeyMappingKey//c
#define	EVSIOCKML 	kIOHIDKeyMappingKey//c
#define	EVSIOCKM  	kIOHIDKeyMappingKey//c
#define EVSIORMS  	kIOHIDResetPointerKey//c
#define	EVSIOSCT  	kIOHIDClickTimeKey//c
#define EVSIOCCT_SIZE	EVS_PACKED_TIME_SIZE//c
#define	EVSIOCCT  	kIOHIDClickTimeKey//c
#define EVSIOSCS_SIZE	(EVSIOSCS_Y + 1)//c
#define	EVSIOSCS  	kIOHIDClickSpaceKey//c
#define EVSIOCCS_SIZE	(EVSIOCCS_Y + 1)//c
#define	EVSIOCCS  	kIOHIDClickSpaceKey//c
#define EVSIOIDLE 	kIOHIDIdleTimeKey//c
///////////////////////////
#define kIOHIDKeyMappingKey "kIOHIDKeyMappingKey"//?
#define kIOHIDStickyKeysOnKey "kIOHIDStickyKeysOnKey"//?
#define kIOHIDPointerAccelerationTypeKey "kIOHIDPointerAccelerationTypeKey"//?
#define kIOHIDTrackpadAccelerationType "kIOHIDTrackpadAccelerationType"//?
#define kIOHIDVirtualHIDevice "kIOHIDVirtualHIDevice"//?
#define kIOHIDMouseKeysOnKey "kIOHIDMouseKeysOnKey"//?
#define kIOHIDKindKey "kIOHIDKindKey"//?
#define kIOHIDInterfaceIDKey "kIOHIDInterfaceIDKey"//?
#define kIOHIDSubinterfaceIDKey "kIOHIDSubinterfaceIDKey"//?
#define kIOHIDClickSpaceKey "kIOHIDClickSpaceKey"//?
#define kIOHIDClickTimeKey "kIOHIDClickTimeKey"//?
#define kIOHIDResetPointerKey "kIOHIDResetPointerKey"//?
#define kIOHIDInitialKeyRepeatKey "kIOHIDInitialKeyRepeatKey"//?
#define kIOHIDPointerAccelerationKey "kIOHIDPointerAccelerationKey"//?
#define kIOHIDTrackpadScrollAccelerationKey "kIOHIDTrackpadScrollAccelerationKey"//?
#define kIOHIDParametersKey "kIOHIDParametersKey"//?
#define kIOHIDScrollAccelerationKey "kIOHIDScrollAccelerationKey"//?
#define kIOHIDUseKeyswitchKey "kIOHIDUseKeyswitchKey"//?
#define kIOHIDIdleTimeKey "kIOHIDIdleTimeKey"//?
#define kIOHIDPointerButtonMode "IOHIDPointerButtonMode"//?
#define kIOHIDF12EjectDelayKey "kIOHIDF12EjectDelayKey"//?
#define kIOHIDResetKeyboardKey "kIOHIDResetKeyboardKey"//?
#define kIOHIDMouseKeysOptionTogglesKey "kIOHIDMouseKeysOptionTogglesKey"//?
#define kIOHIDKeyRepeatKey "kIOHIDKeyRepeatKey"//?
#define kIOHIDSlowKeysDelayKey "kIOHIDSlowKeysDelayKey"//?
#define kIOHIDStickyKeysDisabledKey "kIOHIDStickyKeysDisabledKey"//?
#define kIOHIDStickyKeysShiftTogglesKey "kIOHIDStickyKeysShiftTogglesKey"//?
#define kIOHIDFKeyModeKey "kIOHIDFKeyModeKey"//?
#define kIOHIDWaitCursorFrameIntervalKey "kIOHIDWaitCursorFrameIntervalKey"//?
#define kIOHIDScrollResetKey "kIOHIDScrollResetKey"//?
#define kIOHIDMouseAccelerationType "kIOHIDMouseAccelerationType"//?
#define kIOHIDMouseScrollAccelerationKey "kIOHIDMouseScrollAccelerationKey"//?
#define kIOHIDKeyboardSupportedModifiersKey "kIOHIDKeyboardSupportedModifiersKey"//?
#define kIOHIDPointerResolutionKey "kIOHIDPointerResolutionKey"//?

#define kIOHIDKeyboardModifierMappingPairsKey "kIOHIDKeyboardModifierMappingPairsKey"//?

#define kIOHIDKeyboardModifierMappingSrcKey "kIOHIDKeyboardModifierMappingSrcKey"//?
#define kIOHIDKeyboardModifierMappingDstKey "kIOHIDKeyboardModifierMappingDstKey"//?
#define kIOHIDKeyboardCapsLockDoesLockKey "kIOHIDKeyboardCapsLockDoesLockKey"//?
#define kIOHIDKeyboardSupportsF12EjectKey "kIOHIDKeyboardSupportsF12EjectKey"//?
#define kIOHIDPointerAccelerationSettingsKey "kIOHIDPointerAccelerationSettingsKey"//?
#define kIOHIDScrollAccelerationTypeKey "kIOHIDScrollAccelerationTypeKey"//?
#define kIOHIDPointerButtonCountKey "kIOHIDPointerButtonCountKey"//?
#define kIOHIDScrollMouseButtonKey "kIOHIDScrollMouseButtonKey"//?
#define kIOHIDPointerConvertAbsoluteKey "kIOHIDPointerConvertAbsoluteKey"//?
#define kIOHIDPointerContactToMoveKey "kIOHIDPointerContactToMoveKey"//?
#define kIOHIDScrollReportRateKey "kIOHIDScrollReportRateKey"//?
#define kIOHIDPointerAccelerationTableKey "kIOHIDPointerAccelerationTableKey"//?
#define kIOHIDScrollZoomModifierMaskKey "kIOHIDScrollZoomModifierMaskKey"//?
#define kIOHIDScrollResolutionYKey "kIOHIDScrollResolutionYKey"//?
#define kIOHIDScrollResolutionXKey "kIOHIDScrollResolutionXKey"//?
#define kIOHIDScrollResolutionZKey "kIOHIDScrollResolutionZKey"//?
#define kIOHIDScrollResolutionKey "kIOHIDScrollResolutionKey"//?
#define kIOHIDScrollAccelerationTableYKey "kIOHIDScrollAccelerationTableYKey"//?
#define kIOHIDScrollAccelerationTableXKey "kIOHIDScrollAccelerationTableXKey"//?
#define kIOHIDScrollAccelerationTableZKey "kIOHIDScrollAccelerationTableZKey"//?
#define kIOHIDScrollAccelerationTableKey "kIOHIDScrollAccelerationTableKey"//?
////////////////////////////////
#define EVSIORKBD_SIZE 1//?
#define EVS_PACKED_TIME_SIZE 2//?
#define EVSIOSKM_SIZE 3//?
#define EVSIORMS_SIZE 4//?
///////////////////////////////////

enum {
	EVSIOCCS_X,//?
	EVSIOCCS_Y,//?
	EVSIOSCS_X,//?
	EVSIOSCS_Y,//?
	kIOHIDButtonMode_EnableRightClick,//?
	kIOHIDButtonMode_BothLeftClicks,//?
	kIOHIDButtonMode_ReverseLeftRightClicks,//?
};

#endif//HYS_IOKIT_HIDSYSTEM_IOHIDPARAMETER_H
