#ifndef HYS_IOKIT_I2C_IOI2CINTERFACE_H
#define HYS_IOKIT_I2C_IOI2CINTERFACE_H

#define kIOI2CInterfaceIDKey "kIOI2CInterfaceIDKey"//?
#define kIOI2CBusTypeKey "kIOI2CBusTypeKey"//?
#define kIOI2CTransactionTypesKey "kIOI2CTransactionTypesKey"//?
#define kIOI2CSupportedCommFlagsKey "kIOI2CSupportedCommFlagsKey"//?
#define kIOFBI2CInterfaceInfoKey "kIOFBI2CInterfaceInfoKey"//?
#define kIOFBI2CInterfaceIDsKey "kIOFBI2CInterfaceIDsKey"//?
#define kIOI2CInterfaceClassName "kIOI2CInterfaceClassName"//?

enum {
	kIOI2CBusTypeI2C,//?
	kIOI2CSimpleTransactionType,//?
	kIOI2CUseSubAddressCommFlag,//?
	kIOI2CNoTransactionType,//?
	kIOI2CCombinedTransactionType,//?
	kIOI2CDDCciReplyTransactionType,//?
	kIOI2CBusNumberMask,//?
};

typedef struct IOI2CRequest IOI2CRequest;//c
typedef void (*IOI2CRequestCompletion) (IOI2CRequest *a);//c
typedef struct IOI2CConnect *IOI2CConnectRef;//c
typedef struct IOI2CBuffer IOI2CBuffer;//c

#ifdef __cplusplus
class  IOI2CInterface_HYS
{
    OSDeclareDefaultStructors(IOI2CInterface_HYS)

public://data

int fID;//?

public://func-define

#define IOI2CInterface_newUserClient \
IOReturn newUserClient( task_t a, void *b, UInt32 c, IOUserClient **d);//?

#define IOI2CInterface_registerI2C \
bool registerI2C( UInt64 a);//c

public://func

int startIO( IOI2CRequest *a);//?

};
#endif //__cplusplus

#endif//HYS_IOKIT_I2C_IOI2CINTERFACE_H

