#ifndef HYS_IOKIT_NDRVSUPPORT_IOMACOSVIDEO_H
#define HYS_IOKIT_NDRVSUPPORT_IOMACOSVIDEO_H


/////////////

enum {
	kDisplayModeIDCurrent,//?
	kAVPowerSuspend,//?
	kHardwareSleep,//?
	kHardwareWake,//?
	kHardwareWakeToDoze,//?
	kAVPowerOn,//?
	kAVPowerOff,//?
	cscSetPowerState,//?
	kPowerStateSleepWakeNeedsProbeMask,//?
	kPowerStateSupportsReducedPower3BitMask,//?
	kDPMSSyncMask,//?
	kDPMSSyncOff,//?
	kPowerStateSleepCanPowerOffMask,//?
	cscGetPowerState,//?
	kDDCBlockSize,//?
	cscGetDDCBlock,//?
	kDDCForceReadMask,//?
	kHasDDCConnection,//?
	kReportsDDCConnection,//?
	kDetailedTimingFormat,//?
	kTaggingInfoNonStandard,//?
	kESCFourNTSC,//?
	kRSCFour,//?
	kESCSixStandard,//?
	kRSCSix,//?
	kReportsTagging,//?
	timingApplePAL_FFconv,//?
	timingApplePAL_STconv,//?
	timingApplePAL_FF,//?
	timingApplePAL_ST,//?
	timingAppleNTSC_FFconv,//?
	timingAppleNTSC_STconv,//?
	timingAppleNTSC_FF,//?
	timingAppleNTSC_ST,//?
	cscGetConnection,//?
	cscSetSync,//?
	cscSetFeatureConfiguration,//?
	kVideoBufferSizeErr,//?
	kVideoI2CTransactionTypeErr,//?
	kVideoI2CBusyErr,//?
	kVideoI2CTransactionErr,//?
	kVideoI2CReplyPendingErr,//?
	kPowerStateSleepWaketoDozeMask,//?
	kDisplayModeIDNoMoreResolutions,//?
	kPowerStateSupportsReducedPower2BitMask,//?
	kPowerStateSupportsReducedPower1BitMask,//?
	kDPMSSyncOn,//?
	cscGetSync,//?
	cscGetFeatureConfiguration,//?
	kVideoReplyMicroSecDelayMask,//?
	cscDoCommunication,//?
	cscGetCommunicationInfo,//?
	kVideoDefaultBus,//?
	cscGetMultiConnect,//?
	kGetConnectionCount,//?
	cscSupportsHardwareCursor,//?
	cscSetMirror,//?
	kMirrorVAlignCenterMirrorMask,//?
	kMirrorHAlignCenterMirrorMask,//?
	kMirrorClippedMirrorMask,//?
	kMirrorUnclippedMirrorMask,//?
	kMirrorAreMirroredMask,//?
	cscGetMirror,//?
	kMirrorCanMirrorMask,//?
	cscSetEntries,//?
	kSetClutAtVBL,//?
	cscGetPreferredConfiguration,//?
	cscSavePreferredConfiguration,//?
	cscSetMode,//?
	cscSwitchMode,//?
	timingApple_0x0_0hz_Offline,//?
	timingInvalid,//?
	cscGetModeTiming,//?
	cscSetGray,//?
	kPanelTFTConnect,//?
	kGenericLCD,//?
	kPanelFSTNConnect,//?
	kDisplayModeIDReservedBase,//?
	kDepthMode6,//?
	kDepthMode1,//?
	kDisplayModeIDInvalid,//?
	kDeclROMtables,//?
	kDisplayModeIDBootProgrammable,//?
	cscGetScaler,//?
	cscProbeConnection,//?
	cscSetHardwareCursor,//?
	cscDrawHardwareCursor,//?
	cscGetCurMode,//?
	cscGrayPage,//?
	kSetClutAtSetEntries,//?
	cscSetClutBehavior,//?
	cscGetGamma,//?
	kGammaTableIDFindFirst,//?
	cscGetGammaInfoList,//?
	kGammaTableIDNoMoreTables,//?
	cscRetrieveGammaTable,//?
	cscSetGamma,//?
	cscGetTimingRanges,//?
	cscGetScalerInfo,//?
	kScaleCanRotateMask,//?
	kDisplayModeIDFindFirstResolution,//?
	cscGetNextResolution,//?
	cscGetVideoParameters,//?
	cscGetDetailedTiming,//?
	kDisplayModeIDFindFirstProgrammable,//?
	kDMSModeReady,//?
	kDMSModeFree,//?
	cscSetDetailedTiming,//?
	kDMSModeNotReady,//?
	cscSetScaler,//?
};

enum {
	kVideoNoTransactionType =0,//c
	kVideoSimpleI2CType=1,//c
	kVideoDDCciReplyType=2,//c
	kBuiltInConnection=11,//c
	kConnectionInactive=9,//c
};
/////////////////////////


typedef UInt32 VDClutBehavior;//c
typedef UInt32                          DisplayModeID;//c

////////////////////////
struct VDScalerRec {
    UInt32                          csScalerSize;		
    UInt32                          csScalerVersion;	
    UInt32                          csReserved1;		
    UInt32                          csReserved2;		
    DisplayModeID                   csDisplayModeID;
    UInt32                          csDisplayModeSeed;
    UInt32                          csDisplayModeState;
    UInt32                          csReserved3;		
    UInt32                          csScalerFlags;		
    UInt32                          csHorizontalPixels;	
    UInt32                          csVerticalPixels;	
    UInt32                          csHorizontalInset;     
    UInt32                          csVerticalInset;         
    UInt32                          csReserved6;		
    UInt32                          csReserved7;		
    UInt32                          csReserved8;		
};//c
typedef struct VDScalerRec   VDScalerRec;
typedef VDScalerRec  *VDScalerPtr;

struct VDDrawHardwareCursorRec {
    SInt32                          csCursorX;                 
    SInt32                          csCursorY;                 
    UInt32                          csCursorVisible;         
    UInt32                          csReserved1;             
    UInt32                          csReserved2;             
};//c
typedef struct VDDrawHardwareCursorRec  VDDrawHardwareCursorRec;
typedef VDDrawHardwareCursorRec *       VDDrawHardwareCursorPtr;

struct VDDisplayTimingRangeRec {
	UInt32 csRangeSize;//c
};
typedef struct VDDisplayTimingRangeRec  VDDisplayTimingRangeRec;
typedef VDDisplayTimingRangeRec *       VDDisplayTimingRangePtr;

struct VDScalerInfoRec {
	UInt32 csScalerInfoSize;//c
	UInt32 csScalerFeatures;//c
};
typedef struct VDScalerInfoRec   VDScalerInfoRec;
typedef VDScalerInfoRec *VDScalerInfoPtr;

struct VPBlock {
    long                            vpBaseOffset;             
    short                           vpRowBytes;              
    Rect                            vpBounds;                 
    short                           vpVersion;                 
    short                           vpPackType;
    long                            vpPackSize;
    long                            vpHRes;                     
    long                            vpVRes;                     
    short                           vpPixelType;              
    short                           vpPixelSize;               
    short                           vpCmpCount;             
    short                           vpCmpSize;               
    long                            vpPlaneBytes;              
};//c
typedef struct VPBlock                  VPBlock;
typedef VPBlock *                       VPBlockPtr;

struct VDDetailedTimingRec {
    UInt32                          csTimingSize;              
    UInt32                          csTimingType;             
    UInt32                          csTimingVersion;         
    UInt32                          csTimingReserved;      
    DisplayModeID                   csDisplayModeID; 
    UInt32                          csDisplayModeSeed;   
    UInt32                          csDisplayModeState;    
    UInt32                          csDisplayModeAlias;    
    UInt32                          csSignalConfig;
    UInt32                          csSignalLevels;
    UInt64                          csPixelClock;    
    UInt64                          csMinPixelClock;
    UInt64                          csMaxPixelClock;
    UInt32                          csHorizontalActive;
    UInt32                          csHorizontalBlanking;       
    UInt32                          csHorizontalSyncOffset;    
    UInt32                          csHorizontalSyncPulseWidth; 
    UInt32                          csVerticalActive;           
    UInt32                          csVerticalBlanking;       
    UInt32                          csVerticalSyncOffset;      
    UInt32                          csVerticalSyncPulseWidth;
    UInt32                          csHorizontalBorderLeft;    
    UInt32                          csHorizontalBorderRight;  
    UInt32                          csVerticalBorderTop;        
    UInt32                          csVerticalBorderBottom;    
    UInt32                          csHorizontalSyncConfig;
    UInt32                          csHorizontalSyncLevel;     
    UInt32                          csVerticalSyncConfig;
    UInt32                          csVerticalSyncLevel;        
    UInt32                          csReserved1;                
    UInt32                          csReserved2;                
    UInt32                          csReserved3;                
    UInt32                          csReserved4;                
    UInt32                          csReserved5;                
    UInt32                          csReserved6;                
    UInt32                          csReserved7;                
    UInt32                          csReserved8;                
};//c
typedef struct VDDetailedTimingRec      VDDetailedTimingRec;
typedef VDDetailedTimingRec *           VDDetailedTimingPtr;

struct VDMirrorRec {
    UInt32              csMirrorSize; 
    UInt32              csMirrorVersion; 
    void *		csMirrorRequestID[4]; 
    void *		csMirrorResultID[4];    
    UInt32              csMirrorFeatures;     
    UInt32              csMirrorSupportedFlags;
    UInt32              csMirrorFlags;         
    UInt32              csReserved1;        
    UInt32              csReserved2;        
    UInt32              csReserved3;        
    UInt32              csReserved4;        
    UInt32              csReserved5;       
};//c
typedef struct VDMirrorRec VDMirrorRec;
typedef VDMirrorRec * VDMirrorPtr;

struct VDCommunicationInfoRec {
    SInt32                          csBusID;   
    UInt32                          csBusType;
    SInt32                          csMinBus;
    SInt32                          csMaxBus;
    UInt32                          csSupportedTypes;  
    UInt32			    csSupportedCommFlags;	
    UInt32                          csReserved2;                
    UInt32                          csReserved3;                
    UInt32                          csReserved4;               
    UInt32                          csReserved5;               
    UInt32                          csReserved6;               
    UInt32                          csReserved7;               
};//c
typedef struct VDCommunicationInfoRec   VDCommunicationInfoRec;
typedef VDCommunicationInfoRec *        VDCommunicationInfoPtr;

struct VDCommunicationRec {
    SInt32                          csBusID;                   
    UInt32			    csCommFlags;		
    UInt32			    csMinReplyDelay;	
    UInt32                          csReserved2;           
    UInt32                          csSendAddress;      
    UInt32                          csSendType;            
    LogicalAddress                  csSendBuffer;    
    ByteCount                       csSendSize;          
    UInt32                          csReplyAddress;       
    UInt32                          csReplyType;             
    LogicalAddress                  csReplyBuffer;     
    ByteCount                       csReplySize;           
    UInt32                          csReserved3;
    UInt32                          csReserved4;
    UInt32                          csReserved5;             
    UInt32                          csReserved6;             
};//c
typedef struct VDCommunicationRec       VDCommunicationRec;
typedef VDCommunicationRec *            VDCommunicationPtr;

struct VDConfigurationRec {
    UInt32              csConfigFeature; 
    UInt32              csConfigSupport; 
    UInt32              csConfigValue;     
    UInt32              csReserved1;
    UInt32              csReserved2;
};//c
typedef struct VDConfigurationRec       VDConfigurationRec;
typedef VDConfigurationRec *            VDConfigurationPtr;

struct VDDDCBlockRec {
    UInt32                          ddcBlockNumber;    
    ResType                         ddcBlockType;     
    UInt32                          ddcFlags;                 
    UInt32                          ddcReserved;           
    Byte                            ddcBlockData[128];  
};//c
typedef struct VDDDCBlockRec            VDDDCBlockRec;
typedef VDDDCBlockRec *                 VDDDCBlockPtr;

#endif//HYS_IOKIT_NDRVSUPPORT_IOMACOSVIDEO_H


#ifdef HYS_IOKIT_NDRVSUPPORT_IOMACOSVIDEO_H_END
#undef HYS_IOKIT_NDRVSUPPORT_IOMACOSVIDEO_H_END
struct VDMultiConnectInfoRec { 
    unsigned long                   csDisplayCountOrNumber;    
    VDDisplayConnectInfoRec         csConnectInfo;         
}; //c
typedef struct VDMultiConnectInfoRec    VDMultiConnectInfoRec; 
typedef VDMultiConnectInfoRec *         VDMultiConnectInfoPtr;
#endif//HYS_IOKIT_NDRVSUPPORT_IOMACOSVIDEO_H_END
