#ifndef HYS_IOKIT_NDRVSUPPORT_IONDRVFRAMEBUFFER_H
#define  HYS_IOKIT_NDRVSUPPORT_IONDRVFRAMEBUFFER_H

class IONDRVFramebuffer_HYS
{
    OSDeclareDefaultStructors(IONDRVFramebuffer_HYS)

private:

#define IONDRVFramebuffer___private \
struct IONDRVFramebufferPrivate *__private;//c

public://data

class IONDRV * ndrv;//c
IOService * nub;//c
VDResolutionInfoRec  cachedVDResolution;//c
IOService * device;//c
struct _VSLService *vslServices;//c
IODeviceMemory * vramMemory;//c
SInt32 ndrvEnter;//c
UInt32* detailedTimingsCurrent;//c
OSArray *	 detailedTimings;//c

int physicalFramebuffer;//?
int currentPage;//?
int grayMode;//?
int detailedTimingsSeed;//?
int ndrvState;//?
int online;//?
int consoleDevice;//?
int powerState;//?
int platformSleep;//?
int accessFlags;//?
int currentDisplayMode;//?
int currentDepth;//?
int avJackState;//?
int supportsProbe;//?
int forceReadEDID;//?
int lastClutSetting;//?
int lastGrayMode;//?
int shouldDoI2CPower;//?

public: //func

#define IONDRVFramebuffer_ndrvSetDisplayPowerState \
IOReturn ndrvSetDisplayPowerState( UInt32 a );//c

#define IONDRVFramebuffer_powerStateForDomainState \
unsigned long powerStateForDomainState( IOPMPowerFlags a);//?

#define IONDRVFramebuffer_initialPowerStateForDomainState \
unsigned long initialPowerStateForDomainState( IOPMPowerFlags a);//?

#define IONDRVFramebuffer_maxCapabilityForDomainState \
unsigned long maxCapabilityForDomainState( IOPMPowerFlags a );//?

#define IONDRVFramebuffer_hasDDCConnect \
bool hasDDCConnect( IOIndex a);//?

#define IONDRVFramebuffer_connectFlags \
IOReturn connectFlags( IOIndex a, IODisplayModeID b, IOOptionBits *c);//?

#define IONDRVFramebuffer_getAppleSense \
IOReturn getAppleSense( IOIndex a, UInt32 *b, UInt32 *c, UInt32 *d,UInt32 *e);//?

#define IONDRVFramebuffer_getAttributeForConnection \
IOReturn getAttributeForConnection( IOIndex a, IOSelect b, UInt32  *c);//?

#define IONDRVFramebuffer_processConnectChange \
IOReturn processConnectChange( UInt32 *a);//c

#define IONDRVFramebuffer_searchOfflineMode \
bool searchOfflineMode( IODisplayModeID *a);//c

#define IONDRVFramebuffer_setAttributeForConnection \
IOReturn setAttributeForConnection( IOIndex a, IOSelect b, UInt32 c);//?

#define IONDRVFramebuffer_setConnectionFlags \
IOReturn setConnectionFlags( void );//c

#define IONDRVFramebuffer_displayI2CPower \
void displayI2CPower( bool a );//?

#define IONDRVFramebuffer_doI2CRequest \
IOReturn doI2CRequest( UInt32 a, IOI2CBusTiming *b, IOI2CRequest *c);//?

#define IONDRVFramebuffer_getConnectionCount \
IOItemCount getConnectionCount( void );//?

#define IONDRVFramebuffer_getOnlineState \
bool getOnlineState( void );//c

#define IONDRVFramebuffer_getAttribute \
IOReturn getAttribute( IOSelect a, UInt32 *b);//?

#define IONDRVFramebuffer_ndrvUpdatePowerState \
IOReturn ndrvUpdatePowerState( void );//c

#define IONDRVFramebuffer_ndrvGetSetFeature \
IOReturn ndrvGetSetFeature( UInt32 a, UInt32 b, UInt32 * c);//?

#define IONDRVFramebuffer_ndrvSetPowerState \
IOReturn ndrvSetPowerState( UInt32 a);//c

#define IONDRVFramebuffer_setAttribute \
IOReturn setAttribute( IOSelect a, UInt32 b);//?

#define IONDRVFramebuffer_setMirror \
IOReturn setMirror( IONDRVFramebuffer *a);//?

#define IONDRVFramebuffer_mirrorInfo \
IOReturn mirrorInfo( UInt32 a);//c

#define IONDRVFramebuffer_setGammaTable \
IOReturn setGammaTable( UInt32 a, UInt32 b, UInt32 c, void *d);//?

#define IONDRVFramebuffer_setCLUTWithEntries \
IOReturn setCLUTWithEntries( IOColorEntry *a, UInt32 b, UInt32 c, IOOptionBits d);//?

#define IONDRVFramebuffer_setApertureEnable \
IOReturn setApertureEnable( IOPixelAperture a, IOOptionBits b);//?

#define IONDRVFramebuffer_getStartupDisplayMode \
IOReturn getStartupDisplayMode( IODisplayModeID *a, IOIndex *b);//?

#define IONDRVFramebuffer_setStartupDisplayMode \
IOReturn setStartupDisplayMode( IODisplayModeID a, IOIndex b);//?

#define IONDRVFramebuffer_getTimingInfoForDisplayMode \
IOReturn getTimingInfoForDisplayMode( IODisplayModeID a, IOTimingInformation *b);//?

#define IONDRVFramebuffer_getPixelFormatsForDisplayMode \
UInt64  getPixelFormatsForDisplayMode( IODisplayModeID a, IOIndex b);//?

#define IONDRVFramebuffer_setDetailedTimings \
IOReturn setDetailedTimings( OSArray * a);//?

#define IONDRVFramebuffer_validateDetailedTiming \
IOReturn validateDetailedTiming(void *a, IOByteCount b);//?

#define IONDRVFramebuffer_getPixelFormats \
const char * getPixelFormats( void );//?

#define IONDRVFramebuffer_makeSubRange \
IODeviceMemory * makeSubRange( IOPhysicalAddress a, IOPhysicalLength b);//?

#define IONDRVFramebuffer_setDetailedTiming \
IOReturn setDetailedTiming(IODisplayModeID a, IOOptionBits b, void *c, IOByteCount d);//?

#define IONDRVFramebuffer_getResInfoForMode \
IOReturn getResInfoForMode(IODisplayModeID a, IODisplayModeInformation *b);//?

#define IONDRVFramebuffer_validateDisplayMode \
IOReturn validateDisplayMode(IODisplayModeID a, IOOptionBits b, VDDetailedTimingRec ** c);//?

#define IONDRVFramebuffer_getResInfoForArbMode \
IOReturn getResInfoForArbMode( IODisplayModeID a, IODisplayModeInformation *b);//?

#define IONDRVFramebuffer_getResInfoForDetailed \
IOReturn getResInfoForDetailed( IODisplayModeID a, VDDetailedTimingRec *b, IODisplayModeInformation *c);//c

#define IONDRVFramebuffer_mapDepthIndex \
IOIndex mapDepthIndex( IODisplayModeID a, IOIndex b, bool c);//c

#define IONDRVFramebuffer_iterateAllModes \
UInt32 iterateAllModes( IODisplayModeID *a);//?

#define IONDRVFramebuffer_setInfoProperties \
void setInfoProperties( void );//c

#define IONDRVFramebuffer_createI2C \
IOReturn createI2C( void );//c

#define IONDRVFramebuffer_extStatus \
static IOReturn extStatus( OSObject *a, void *b, void *c);//c

#define IONDRVFramebuffer_doDriverIO \
IOReturn doDriverIO( UInt32 a, void *b, UInt32 c, UInt32 d);//?

#define IONDRVFramebuffer_setCursorState \
IOReturn setCursorState( SInt32 a, SInt32 b, bool c);//?

#define IONDRVFramebuffer_VSLPrepareCursorForHardwareCursor \
static Boolean  VSLPrepareCursorForHardwareCursor(void *a, IOHardwareCursorDescriptor *b, IOHardwareCursorInfo *c);//c

#define IONDRVFramebuffer_VSLDoInterruptService \
static OSStatus VSLDoInterruptService( _VSLService * a);//c

#define IONDRVFramebuffer_VSLDisposeInterruptService \
static OSStatus VSLDisposeInterruptService( _VSLService * a);//c

#define IONDRVFramebuffer_setInterruptState \
IOReturn setInterruptState( void * a, UInt32 b);//?

#define IONDRVFramebuffer_VSLNewInterruptService \
static OSStatus VSLNewInterruptService(void *a, UInt32 b, _VSLService ** c);//c

#define IONDRVFramebuffer_setCursorImage \
IOReturn setCursorImage( void *a);//?

#define IONDRVFramebuffer_unregisterInterrupt \
IOReturn unregisterInterrupt( void * a);//?

#define IONDRVFramebuffer_registerForInterruptType \
IOReturn registerForInterruptType( IOSelect a, IOFBInterruptProc b, OSObject *c, void *d, void ** e);//?

#define IONDRVFramebuffer_free \
void free( void );//?

#define IONDRVFramebuffer_undefinedSymbolHandler \
const IOTVector * undefinedSymbolHandler( const char *a, const char *b);//?

#define IONDRVFramebuffer_findVRAM \
IODeviceMemory * findVRAM( void );//?

#define IONDRVFramebuffer_getVRAMRange \
IODeviceMemory * getVRAMRange( void );//?

#define IONDRVFramebuffer_requestProbe \
IOReturn requestProbe( IOOptionBits a);//?

#define IONDRVFramebuffer__doControl \
static IOReturn _doControl( IONDRVFramebuffer *a, UInt32 b, void *c);//c

#define IONDRVFramebuffer__probeAction \
static IOReturn _probeAction( IONDRVFramebuffer *a, IOOptionBits b);//c

#define IONDRVFramebuffer__avProbeAction \
static void _avProbeAction( OSObject *a, IOTimerEventSource *b);//c

#define IONDRVFramebuffer_initForPM \
void initForPM ( void );//c

#define IONDRVFramebuffer__doStatus \
static IOReturn _doStatus( IONDRVFramebuffer *a, UInt32 b, void *c);//c

#define IONDRVFramebuffer_getCurrentConfiguration \
void getCurrentConfiguration( void );//?

#define IONDRVFramebuffer_extControl \
static IOReturn extControl( OSObject *a, void *b, void *c);//c

#define IONDRVFramebuffer_checkDriver \
IOReturn checkDriver( void );//?

#define IONDRVFramebuffer_isConsoleDevice \
bool isConsoleDevice( void );//?

#define IONDRVFramebuffer_enableController \
IOReturn enableController( void );//?

#define IONDRVFramebuffer__videoJackStateChangeHandler \
static bool _videoJackStateChangeHandler( void *a, void *b, IOService *c);//?

#define IONDRVFramebuffer_start \
bool start( IOService *a);//?

#define IONDRVFramebuffer_stop \
void stop( IOService * a);//?

#define IONDRVFramebuffer__undefinedSymbolHandler \
static const IOTVector * _undefinedSymbolHandler( void *a, const char *b, const char *c);//?

#define IONDRVFramebuffer_setProperties \
IOReturn setProperties( OSObject *a);//?

#define IONDRVFramebuffer_probe \
IOService * probe(IOService *a, SInt32 *b);//?

#define IONDRVFramebuffer_getDDCBlock \
IOReturn getDDCBlock( IOIndex a, UInt32 b, IOSelect c, IOOptionBits d, UInt8 *e, IOByteCount * f);//?

#define IONDRVFramebuffer_setDisplayMode \
IOReturn setDisplayMode( IODisplayModeID a, IOIndex b);//?

#define IONDRVFramebuffer_getCurrentDisplayMode \
IOReturn getCurrentDisplayMode( IODisplayModeID *a, IOIndex *b);//?

#define IONDRVFramebuffer_getDisplayModeCount \
IOItemCount getDisplayModeCount( void );//?

#define IONDRVFramebuffer_getDisplayModes \
IOReturn getDisplayModes( IODisplayModeID * a);//?

#define IONDRVFramebuffer_getApertureRange \
IODeviceMemory * getApertureRange( IOPixelAperture a);//?

#define IONDRVFramebuffer_getPixelInformation \
IOReturn getPixelInformation(IODisplayModeID a, IOIndex b, IOPixelAperture c, IOPixelInformation *d);//?

#define IONDRVFramebuffer_getInformationForDisplayMode \
IOReturn getInformationForDisplayMode(IODisplayModeID a, IODisplayModeInformation *b);//?

#define IONDRVFramebuffer_doStatus \
IOReturn doStatus( UInt32 a, void *b);//?

#define IONDRVFramebuffer_doControl \
IOReturn doControl( UInt32 a, void *b);//?

};

#endif//HYS_IOKIT_NDRVSUPPORT_IONDRVFRAMEBUFFER_H
