#ifndef HYS_IOKJIT_NETWORK_IOKERNELDEBUGGER_H
#define HYS_IOKJIT_NETWORK_IOKERNELDEBUGGER_H

#define IODebuggerLock    IOKernelDebugger::lock//c
#define IODebuggerUnlock  IOKernelDebugger::unlock//c

#ifdef __cplusplus
class IOKernelDebugger_HYS
{
    OSDeclareDefaultStructors( IOKernelDebugger_HYS )

public://data

struct ExpansionData {
	thread_call_t enableDebuggerThreadCall;//c
	thread_call_t disableDebuggerThreadCall;//c
	thread_call_t activationChangeThreadCall;//c
	IONotifier  * interfaceNotifier;//c
	UInt32 stateVars[1];//?
};

IOService* _target;//c
IODebuggerTxHandler  _txHandler;//c
IODebuggerRxHandler _rxHandler;//c
IOService* _client;//c

public://define

#define IOKernelDebugger_message \
IOReturn message( UInt32 a, IOService * b, void *c );//?

#define IOKernelDebugger_pmDisableDebugger \
static void pmDisableDebugger( IOKernelDebugger *a );//c

#define IOKernelDebugger_pmEnableDebugger \
static void pmEnableDebugger(  IOKernelDebugger *a);//c

#define IOKernelDebugger_interfacePublished \
static bool interfacePublished( void *a, void *b, IOService *c );//c

};
#endif//__cplusplus

#endif//HYS_IOKJIT_NETWORK_IOKERNELDEBUGGER_H
