#ifndef HYS_IOKIT_NETWORK_IONETWORKCONTROLLERE_H
#define HYS_IOKIT_NETWORK_IONETWORKCONTROLLERE_H

enum {
	kIOPacketBufferAlign2,//?
	kIOPacketBufferAlign1,//?
	kIOPacketBufferAlign16,//?
	kIOPacketBufferAlign32,//?
};

#ifdef __cplusplus
class  IONetworkController_HYS
{
    //OSDeclareAbstractStructors( IONetworkController_HYS )

public://data

enum {
	kDelayFree,//?
};

const OSData* _lastLinkData;//c
const OSSymbol* _lastActiveMediumName;//c
const OSSymbol* _lastCurrentMediumName;//c
OSSet* _clientSet;//c
OSCollectionIterator * _clientSetIter;//c
OSNumber* _linkStatus;//c
OSNumber* _linkSpeed;//c
IOLock *_mediumLock;//c
IOWorkLoop * _workLoop;//c
IOCommandGate *  _cmdGate;//c
IOOutputQueue *_outputQueue;//c
OSObject* _cmdClient;//c
mbuf_t _freeList;//?
IODebuggerLockState  _debugLockState;//c

int _alignPadding;//?
int _alignLength;//?
int _propertiesPublished;//?
int _alignStart;//?
int _debugLockCount;//?

public://func-define

#define IONetworkController_executeCommandAction \
static IOReturn executeCommandAction(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IONetworkController_debugRxHandler \
static void debugRxHandler(IOService *a, void *b, UInt32 *c, UInt32 d);//c

#define IONetworkController_debugTxHandler \
static void debugTxHandler(IOService *a, void *b, UInt32 c);//c

#define IONetworkController__broadcastEvent \
bool _broadcastEvent(UInt32 a, void * b = 0);//c

#define IONetworkController_handleCommand \
static IOReturn handleCommand(void *a, void *b, void *c, void *d, void *e);//c

#define IONetworkController_setCurrentMedium \
bool setCurrentMedium(const IONetworkMedium *a);//c

#define IONetworkController_getCurrentMedium \
const IONetworkMedium * getCurrentMedium() const;//c

};
#endif //__cplusplus

#endif//HYS_IOKIT_NETWORK_IONETWORKCONTROLLERE_H

