#ifndef HYS_IOKIT_NETWORK_IONETWORKMEDIUM_H
#define HYS_IOKIT_NETWORK_IONETWORKMEDIUM_H

#define kIOMediumCommonOptionsMask  IFM_GMASK//c
#define kIOMediumSubTypeMask        IFM_TMASK//c
#define kIOMediumNetworkTypeMask    IFM_NMASK//c

///////////
enum {
 	kIOMediumOptionFullDuplex     = IFM_FDX,//c
    	kIONetworkLinkValid        = IFM_AVALID,//c
    	kIONetworkLinkActive       = IFM_ACTIVE, //c
    	kIOMediumEthernet10BaseT      =  ( IFM_10_T    | IFM_ETHER ),//c
    	kIOMediumEthernet10Base5      =  ( IFM_10_5    | IFM_ETHER ),//c
    	kIOMediumEthernetNone         =  ( IFM_NONE    | IFM_ETHER ),//c
    	kIOMediumEthernet100BaseT4    =  ( IFM_100_T4  | IFM_ETHER ),//c
    	kIOMediumEthernet1000BaseSX   =  ( IFM_1000_SX | IFM_ETHER ),//c
    	kIOMediumEthernetAuto         =  ( IFM_AUTO    | IFM_ETHER ),//c
    	kIOMediumEthernet10Base2      =  ( IFM_10_2    | IFM_ETHER ),//c
 	kIOMediumEthernet1000BaseT    =  ( IFM_1000_T  | IFM_ETHER ),//c
    	kIOMediumOptionFlowControl    = IFM_FLOW,//c
    	kIOMediumEthernet100BaseFX    =  ( IFM_100_FX  | IFM_ETHER ),//c
    	kIOMediumOptionLoopback       = IFM_LOOP,//c
  	kIOMediumEthernet100BaseTX    =  ( IFM_100_TX  | IFM_ETHER ),//c
    	kIOMediumOptionHalfDuplex     = IFM_HDX,//c
    	kIOMediumEthernet             =  IFM_ETHER,//c
};

/////////////


#ifdef __cplusplus
class IONetworkMedium_HYS
{
    OSDeclareDefaultStructors( IONetworkMedium_HYS )
public:

const OSSymbol *  _name;//c
IOMediumType      _type;//c
UInt32            _flags;//c
UInt64            _speed;//c
UInt32            _index;//c

};
#endif //__cplusplus

#endif //HYS_IOKIT_NETWORK_IONETWORKMEDIUM_H


