#ifndef HYS_IOKIT_PCCARD_CS_H
#define HYS_IOKIT_PCCARD_CS_H

//#include <IOKit/pccard/cs_types.h>

#define CS_ADJUST_FAKE_HANDLE ((void *)1)//?

#define CS_GENERAL_FAILURE 1//?
#define CS_SUCCESS 2//?
#define IO_DATA_PATH_WIDTH 3//?
#define IO_DATA_PATH_WIDTH_8 4//?
#define CS_EVENT_EJECTION_REQUEST 5//?
#define CS_EVENT_CARD_REMOVAL 6//?
#define CS_EVENT_MTD_REQUEST 7//?
#define CS_EVENT_PRI_LOW 8//?
#define CS_BUSY 9//?
#define CS_BAD_SIZE 10//?
#define CS_WRITE_PROTECTED 11//?
#define CS_BAD_OFFSET 12//?
#define CS_EVENT_ERASE_COMPLETE 13//?
#define CS_NO_CARD 14//?
#define CS_BAD_HANDLE 15//?
#define CS_EVENT_READY_CHANGE 16//?
#define CS_UNSUPPORTED_FUNCTION 17//?
#define WIN_USE_WAIT 18//?
#define WIN_MEMORY_TYPE 19//?
#define CS_BAD_VPP 20//?
#define INFO_MTD_CLIENT 21//?
#define CS_NO_MORE_ITEMS 22//?
#define INFO_MASTER_CLIENT 23//?
#define CS_OUT_OF_RESOURCE 24//?
#define CS_READ_FAILURE 25//?
#define BIND_FN_ALL 26//?
#define CS_BAD_TUPLE 27//?
#define IRQ_INFO2_VALID 28//?
#define CS_BAD_ADAPTER 29//?
#define CS_BAD_ATTRIBUTE 30//?
#define CS_BAD_BASE 31//?
#define CS_BAD_EDC 32//?
#define CS_BAD_IRQ 33//?
#define CS_BAD_PAGE 34//?
#define CS_BAD_SOCKET 35//?
#define CS_BAD_TYPE 36//?
#define CS_BAD_VCC 37//?
#define CS_BAD_WINDOW 38//?
#define CS_WRITE_FAILURE 39//?
#define CS_UNSUPPORTED_MODE 40//?
#define CS_BAD_SPEED 41//?
#define CS_IN_USE 42//?
#define CS_CONFIGURATION_LOCKED 43//?
#define CS_BAD_ARGS 44//?
#define CS_BAD_ARG_LENGTH 45//?
#define CS_EVENT_PM_RESUME 46//?
#define CS_EVENT_CARD_INSERTION 47//?
#define CS_EVENT_CARD_RESET 48//?
#define CS_EVENT_RESET_COMPLETE 49//?
#define CS_EVENT_PRI_HIGH 50//?
#define CS_EVENT_BATTERY_DEAD 51//?
#define CS_EVENT_BATTERY_LOW 52//?
#define CS_READ 53//?
#define CS_WRITE 54//?
#define INT_CARDBUS 55//?
#define CONF_VALID_CLIENT 56//?
#define CONF_ENABLE_IRQ 57//?
#define CLIENT_THIS_SOCKET 58//?
#define WIN_MEMORY_TYPE_AM 59//?
#define WIN_ENABLE 60//?
#define WIN_DATA_WIDTH_16 61//?
#define CS_EVENT_CARD_DETECT 62//?
#define CS_EVENT_CB_DETECT 63//?
#define CS_EVENT_3VCARD 64//?
#define CS_EVENT_XVCARD 65//?
#define CS_EVENT_PM_SUSPEND 66//?
#define INT_MEMORY_AND_IO 67//?
#define PRESENT_PIN_REPLACE 68//?
#define CS_EVENT_WRITE_PROTECT 69//?
#define PRESENT_EXT_STATUS 70//?
#define CS_EVENT_REQUEST_ATTENTION 71//?
#define CONF_IRQ_CHANGE_VALID 72//?
#define CONF_VCC_CHANGE_VALID 73//?
#define CONF_VPP1_CHANGE_VALID 74//?
#define CONF_VPP2_CHANGE_VALID 75//?
#define CS_EVENT_REGISTRATION_COMPLETE 76//?
#define IRQ_HANDLE_PRESENT 77//?
#define CONF_ENABLE_DMA 78//?
#define CONF_ENABLE_SPKR 79//?
#define PRESENT_COPY 80//?
#define IO_DATA_PATH_WIDTH_16 81//?
#define PRESENT_OPTION 82//?
#define PRESENT_IOBASE_0 83//?
#define IRQ_FORCED_PULSE 84//?
#define PRESENT_STATUS 85//?
#define PRESENT_IOSIZE 86//?
#define IO_DATA_PATH_WIDTH_AUTO 87//?
#define IO_SHARED 88//?
#define IO_FORCE_ALIAS_ACCESS 89//?
#define WIN_PAGED 90//?
#define WIN_SHARED 91//?
#define WIN_STRICT_ALIGN 92//?
#define WIN_MAP_BELOW_1MB 93//?
#define CS_EVENT_RESET_REQUEST 94//?
#define CS_EVENT_RESET_PHYSICAL 95//?
#define CS_EVENT_EJECTION_COMPLETE 96//?
#define CONF_EVENT_MASK_VALID 97//?
#define ADD_MANAGED_RESOURCE 98//?
#define REMOVE_MANAGED_RESOURCE  99//?
#define RES_MEMORY_RANGE 100//?
#define RES_IO_RANGE 101//?
#define RES_IRQ 102//?
#define CS_EVENT_INSERTION_REQUEST 103//?
#define INT_MEMORY 104//?
#define WIN_MEMORY_TYPE_CM 105//?
#define INFO_IO_CLIENT 106//?
#define INFO_CARD_SHARE 107//?

enum {
	CopyMemory,//?
	BindDevice,//?
	RequestIO,//?
	RegisterEraseQueue,//?
	RequestConfiguration,//?
	RegisterMTD,//?
	RegisterClient,//?
	OpenMemory,//?
	BindMTD,//?
	GetNextWindow,//?
	GetFirstWindow,//?
	ReplaceCIS,//?
	InsertCard,//?
	GetMemPage,//?
	ValidateCIS,//?
	WriteMemory,//?
	ReportError,//?
	SuspendCard,//?
	ResumeCard,//?
	EjectCard,//?
	ReleaseConfiguration,//?
	ModifyWindow,//?
	ModifyConfiguration,//?
	MapMemPage,//?
	GetFirstRegion,//?
	GetEventMask,//?
	ReleaseIRQ,//?
	ReleaseIO,//?
	RequestSocketMask,//?
	RequestIRQ,//?
	SetEventMask,//?
	ResetCard,//?
	GetConfigurationInfo,//?
	GetClientInfo,//?
	ReadMemory,//?
	GetNextClient,//?
	GetFirstClient,//?
	GetNextRegion,//?
	GetStatus,//?
	GetCardServicesInfo,//?
	DeregisterEraseQueue,//?
	DeregisterClient,//?
	CloseMemory,//?
	CheckEraseQueue,//?
	AdjustResourceInfo,//?
	AddSocketServices,//?
	AccessConfigurationRegister,//?
	GetFirstTuple,//?
	GetTupleData,//?
	ParseTuple,//?
	GetNextTuple,//?
	RequestWindow,//?
	ReleaseWindow,//?
};

typedef int (*ss_entry_t)(u_int a, u_int b, void *c);//c

struct event_callback_args_t {
	void* mtdrequest;//c
	void* buffer;//c
	void* info;//c
	client_handle_t client_handle;//c
	void* client_data;//c
};
typedef struct event_callback_args_t event_callback_args_t;

struct io_req_t {
	int BasePort1;//?
	int NumPorts1;//?
	int Attributes1;//?
	int BasePort2;//?
	int NumPorts2;//?
	int Attributes2;//?
	int IOAddrLines;//?
};
typedef struct io_req_t io_req_t;

struct adjust_t {
	int Action;//?
	int Resource;//?
	int Attributes;//?

	union {
		struct memory {
			int Base;//?
			int Size;//?
		} memory;

		struct io {
 			int BasePort;//?
 			int NumPorts;//?
			int IOAddrLines;//?
		} io;
	} resource;
};
typedef struct adjust_t adjust_t;

struct conf_reg_t {
	int Function;//?
	int Offset;//?
	int Action;//?
	int Value;//?
};
typedef struct conf_reg_t conf_reg_t;

struct bind_req_t {
	int Socket;//?
	dev_info_t* dev_info;//c
	int Function;//?
};
typedef struct bind_req_t bind_req_t;

struct mtd_bind_t {
	int Socket;//?
	int Attributes;//?
	int CardOffset;//?
	int dev_info;//?
};
typedef struct mtd_bind_t mtd_bind_t;

struct config_info_t{
	int Function;//?
	int Vcc;//?
	int Vpp1;//?
	int Vpp2;//?
	int Option;//?
	int IntType;//?
	int ConfigBase;//?
	int Attributes;//?
	int AssignedIRQ;//?
	int BasePort1;//?
	int NumPorts1;//?
	void* PCCardNub;//c
	void* CardBusNub;//c
	int CardValues;//?
	int IRQAttributes;//?
	int Attributes1;//?
	int BasePort2;//?
	int NumPorts2;//?
	int Attributes2;//?
	int IOAddrLines;//?
};
typedef struct config_info_t config_info_t;

struct client_req_t {
	int Attributes;//?
	int Socket;//?
};
typedef struct client_req_t client_req_t;

struct servinfo_t {
	char Signature[1];//?
	int Count;//?
	int Revision;//?
 	int CSLevel;//?
	char* VendorString;//c
};
typedef struct servinfo_t servinfo_t;

struct win_req_t {
	int Base;//?
	int Size;//?
	int AccessSpeed;//?
	int Attributes;//?
};
typedef struct win_req_t win_req_t;

struct cs_status_t {
	int CardState;//?
 	int SocketState;//?
	int Function;//?
};
typedef struct cs_status_t cs_status_t;

struct memreq_t {
	int Page;//?
	int CardOffset;//?
};
typedef struct memreq_t memreq_t;

struct modconf_t {
	int Attributes;//?
	int Vcc;//?
	int Vpp1;//?
	int Vpp2;//?
};
typedef struct modconf_t modconf_t;

struct modwin_t {
	int Attributes;//?
	int AccessSpeed;//?
};
typedef struct modwin_t modwin_t;

struct client_reg_t {
	dev_info_t	* dev_info;//c
	int Attributes;//?
	int EventMask;//?
	event_callback_args_t  event_callback_args;//c
	int Version;//?

#ifdef __MACOSX__
    int		(*event_handler)(cs_event_t a, int b, event_callback_args_t *c);//c
#else
    int		(*event_handler)(event_t a , int b, event_callback_args_t *c);//c
#endif

};
typedef struct client_reg_t client_reg_t;

struct config_req_t {
	int IntType;//?
	int Vcc;//?
	int Vpp1;//?
	int Vpp2;//?
	int Attributes;//?
	int ConfigBase;//?
	int Present;//?
	int Copy;//?
	int ConfigIndex;//?
 	int Status;//?
 	int Pin;//?
 	int ExtStatus;//?
};
typedef struct config_req_t config_req_t;

struct irq_req_t {
	int Attributes;//?
	int AssignedIRQ;//?
};
typedef struct irq_req_t irq_req_t;

struct eventmask_t {
	int EventMask;//?
};
typedef struct eventmask_t eventmask_t;

struct error_info_t {
	int func;//?
	int retcode;//?
};
typedef struct error_info_t error_info_t;

//func

int CardServices(int a, void *b, void *c, void *d);//c
#ifdef __cplusplus
inline int CardServices(int func, ...){
int CardServices(int a, void *b, void *c, void *d);
};
#endif

#endif//HYS_IOKIT_PCCARD_CS_H

