#ifndef HYS_IOKIT_PCI_IOPCIPRIVATE_H
#define HYS_IOKIT_PCI_IOPCIPRIVATE_H

#define configShadow(a)	((IOPCIConfigShadow *) &a->savedConfig[0])//c

#define kIOPCIHotPlugKey "kIOPCIHotPlugKey"//?
#define kIOPCIOnlineKey "kIOPCIOnlineKey"//?
#define kIOPCIConfiguredKey "kIOPCIConfiguredKey"//?
#define kIOPCIEjectableKey "kIOPCIEjectableKey"//?
#define kIOPCIResourcedKey "kIOPCIResourcedKey"//?
#define kIOPCIResetKey "kIOPCIResetKey"//?
#define kIOPCILinkChangeKey "kIOPCILinkChangeKey"//?
#define kACPIPCILinkChangeKey "kACPIPCILinkChangeKey"//?
#define kACPIDevicePathKey "kACPIDevicePathKey"//?
#define kACPIDevicePropertiesKey "kACPIDevicePropertiesKey"//?

enum {
	kIOPCIProbeOptionEject,//?
	kIOPCIConfigShadowBridge,//?
	kIOPCIConfigShadowValid,//?
	kSaveDeviceState,//?
	kRestoreDeviceState,//?
	kRestoreBridgeState,//?
	kIOPCIConfigShadowRegs,//?
	kIOPCIVolatileRegsMask,//?
	kIOPCIConfigShadowXPress,//?
	kIOPCIConfigShadowMSI,//?
	kSaveBridgeState,//?
};

struct IOPCIDeviceExpansionData {
	int msiConfig;//?
	int msiMode;//?
	int msiBlockSize;//?
	int msiEnable;//?
	int expressConfig;//?
	int expressCapabilities;//?
	int pmSleepEnabled;//?
	int pmControlStatus;//?
	int sleepControlBits;//?
};

struct IOPCIConfigShadow {
	IOPCI2PCIBridge * bridge;//c
	int flags;//?
	queue_chain_t link;//c
	IOPCIDevice *  device;//c
	UInt32 savedConfig[1];//?
};

extern const IORegistryPlane * gIOPCIACPIPlane;//c

#endif//HYS_IOKIT_PCI_IOPCIPRIVATE_H
