#ifndef HYS_IOKIT_PWR_MFT_ROOTDOMAIN_C_H
#define HYS_IOKIT_PWR_MFT_ROOTDOMAIN_C_H

enum {
	kPCICantSleep,//?
	kRootDomainSleepSupported,//?
	kFrameBufferDeepSleepSupported,//?
	kIOPMSupportedOnAC,//?
	kIOPMSupportedOnUPS,//?
};

typedef int IOPMSettingControllerCallback;//?

#ifdef __cplusplus
extern "C" {
#endif

IONotifier* registerPrioritySleepWakeInterest(IOServiceInterestHandler a,void * b, void *c=0);
int acknowledgeSleepWakeNotification(void *a);//?

#ifdef __cplusplus
}
#endif


class IOPMrootDomain_HYS
{
OSDeclareDefaultStructors(IOPMrootDomain_HYS)

public:

int setSleepSupported(int a);//?
static IOPMrootDomain* construct(void );//c
int publishFeature(const char* a);//?
int receivePowerNotification(int a);//?
int registerPMSettingController(const OSSymbol*  a[], IOPMSettingControllerCallback b, OSObject* c, uintptr_t d, OSObject** e);//?
OSObject* copyPMSetting(OSSymbol* a);//?
int wakeFromDoze();//?
int getSleepSupported();//?
int publishFeature(const char * a,int b,uint32_t * c);//?
int removePublishedFeature(int a);//?

};

#endif//HYS_IOKIT_PWR_MFT_ROOTDOMAIN_C_H
