#ifndef HYS_IOKIT_SCSI_IOSCSIPROTOCPLSERVICES_H
#define HYS_IOKIT_SCSI_IOSCSIPROTOCPLSERVICES_H

class IOSCSIProtocolServices_HYS
{
	OSDeclareAbstractStructors ( IOSCSIProtocolServices_HYS )

public://define

#define IOSCSIProtocolServices_GetLogicalUnitNumber \
UInt8			GetLogicalUnitNumber ( SCSITaskIdentifier a);//c

#define IOSCSIProtocolServices_GetCommandDescriptorBlock \
bool	GetCommandDescriptorBlock ( SCSITaskIdentifier a, SCSICommandDescriptorBlock *b);//c
	
public:

int SetAutoSenseData(SCSITaskIdentifier a,SCSI_Sense_Data * b,int c);//?
int InitializePowerManagement( IOService * a);//?
int GetTaskExecutionMode(SCSITaskIdentifier a);//?
int GetCommandDescriptorBlockSize(SCSITaskIdentifier a);//
IOMemoryDescriptor * GetDataBuffer(SCSITaskIdentifier a);//c
int GetDataBufferOffset(SCSITaskIdentifier a);//?
int GetRequestedDataTransferCount(SCSITaskIdentifier a);//?
int GetTimeoutDuration(SCSITaskIdentifier a);//?
int GetDataTransferDirection(SCSITaskIdentifier a);//?
int SetRealizedDataTransferCount(SCSITaskIdentifier a,int b);//?
int SendNotification_VerifyDeviceState();//?
int CommandCompleted(SCSITaskIdentifier a,int b,int c);//?
int SendNotification_DeviceRemoved();//?
int GetAutosenseRequestedDataTransferCount(SCSITaskIdentifier a);//?
int CreateSCSITargetDevice();//?

};

#endif//HYS_IOKIT_SCSI_IOSCSIPROTOCPLSERVICES_H
