#ifndef HYS_IOKIT_SCSI_IOSCSICMDS_INQUIRY_DEFINITIONS_H
#define HYS_IOKIT_SCSI_IOSCSICMDS_INQUIRY_DEFINITIONS_H

#define kIOPropertySCSIPeripheralDeviceType "kIOPropertySCSIPeripheralDeviceType"//?
#define kIOPropertySCSIVendorIdentification "kIOPropertySCSIVendorIdentification"//?
#define kIOPropertySCSIProductIdentification "kIOPropertySCSIProductIdentification"//?
#define kIOPropertySCSIProductRevisionLevel "kIOPropertySCSIProductRevisionLevel"//?

////////////////////////////////////
enum {
	kINQUIRY_ANSI_VERSION_Mask,//?
	kINQUIRY_ANSI_VERSION_SCSI_2_Compliant,//?
	kINQUIRY_Byte7_Offset,//?
	kINQUIRY_Byte7_SYNC_Mask,//?
	kINQUIRY_Byte7_WBUS16_Mask,//?
	kINQUIRY_ANSI_VERSION_SCSI_SPC_Compliant,//?
	kINQUIRY_Byte56_Offset,//?
	kINQUIRY_Byte56_IUS_Mask,//?
	kINQUIRY_Byte56_QAS_Mask,//?
	kINQUIRY_Byte56_CLOCKING_Mask,//?
	kINQUIRY_Byte56_CLOCKING_ONLY_DT,//?
	kINQUIRY_Byte56_CLOCKING_ST_AND_DT,//?
	kINQUIRY_VENDOR_IDENTIFICATION_Length,//?
	kINQUIRY_PRODUCT_IDENTIFICATION_Length,//?
	kINQUIRY_PRODUCT_REVISION_LEVEL_Length,//?
};
//////////////////////
struct SCSICmd_INQUIRY_StandardData {
	int VERSION;//?
	int ADDITIONAL_LENGTH;//?
	int VENDOR_IDENTIFICATION[kINQUIRY_VENDOR_IDENTIFICATION_Length];//?c
	int PRODUCT_IDENTIFICATION[kINQUIRY_PRODUCT_IDENTIFICATION_Length];//?c
	int PRODUCT_REVISION_LEVEL[kINQUIRY_PRODUCT_REVISION_LEVEL_Length];//?c
};
typedef struct SCSICmd_INQUIRY_StandardData SCSICmd_INQUIRY_StandardData;
typedef SCSICmd_INQUIRY_StandardData * SCSICmd_INQUIRY_StandardDataPtr;

#endif//HYS_IOKIT_SCSI_IOSCSICMDS_INQUIRY_DEFINITIONS_H
