#ifndef HYS_IOKIT_SCSI_SCSICOMMAND_H
#define HYS_IOKIT_SCSI_SCSICOMMAND_H

#include <libkern/OSTypes.h>//UInt8

enum {
	kCDBFlagsNegotiatePPR,//?
	kCDBFNoDisconnect,//?
	kSCSIDisableTimeoutmS,//?
	kSCSIAdapterStatusOverrun,//?
	kSCSIStatusGood,//?
	kCDBFlagsNoDisconnect,//?
	kCDBFlagsNegotiateWDTR,//?
	kCDBFlagsNegotiateSDTR,//?
	kSCSIAdapterStatusParityError,//?
	kSCSIAdapterStatusProtocolError,//?
	kSCSIAdapterStatusSuccess,//?
	kSCSIAdapterStatusSelectionTimeout,//?
	kSCSIAdapterStatusMsgReject,//?
};

struct SCSICDBInfo{
	int cdbFlags;//?
	int cdbLength;//?
	UInt8 cdb[16];//c
	int cdbTagMsg;//?
	UInt32 cdbTag;//c
	int cdbAbortMsg;//?
};
typedef struct SCSICDBInfo SCSICDBInfo;

struct SCSIResults{
	int adapterStatus;//?
	int returnCode;//?
	int bytesTransferred;//?
	int scsiStatus;//?
	int requestSenseDone;//?
	int requestSenseLength;//?
};
typedef struct SCSIResults SCSIResults;//?

typedef int SCSIAdapterStatus;//?


#endif //HYS_IOKIT_SCSI_SCSICOMMAND_H
