#ifndef HYS_IOKIT_SCSI_SCSIPARALLELCONTROLLER_H
#define  HYS_IOKIT_SCSI_SCSIPARALLELCONTROLLER_H

enum {
	kTagAllocationNone,//?
	kDispatchNextCommand,//?
	kTagAllocationPerLun,//?
	kDispatchStop,//?
	kDispatchNextTarget,//?
	kDispatchNextLun,//?
	kTagAllocationPerTarget,//?
	kTagAllocationPerController,//?
};

struct SCSIControllerInfo{
	int initiatorId;//?
	int maxTargetsSupported;//?
	int maxLunsSupported;//?
	int minTransferPeriodpS;//?
	int disableCancelCommands;//?
	int maxCommandsPerTarget;//?
	int targetPrivateDataSize;//?
	int maxTransferOffset;//?
	int maxCommandsPerController;//?
	int commandPrivateDataSize;//?
	int lunPrivateDataSize;//?
	int maxTransferWidth;//?
	int tagAllocationMethod;//?
	int maxCommandsPerLun;//?
	int maxTags;//?
};
typedef struct SCSIControllerInfo  SCSIControllerInfo;

#endif //HYS_IOKIT_SCSI_SCSIPARALLELCONTROLLER_H
