#ifndef HYS_IOKIT_SCSI_SCSITASK_H
#define HYS_IOKIT_SCSI_SCSITASK_H

enum {
	kSCSICDBSize_Maximum=16,//c
};

enum {
	kSCSITaskStatus_TASK_SET_FULL,//?
	kSCSITaskStatus_RESERVATION_CONFLICT,//?
	kSCSITaskStatus_INTERMEDIATE,//?
	kSCSITaskStatus_CONDITION_MET,//?
	kSCSITaskStatus_INTERMEDIATE_CONDITION_MET,//?
	kSCSITaskStatus_BUSY,//?
	kSCSITaskStatus_GOOD,//?
	kSCSITaskMode_Autosense,//?
	kSCSIServiceResponse_Request_In_Process,//?
	kSCSITaskStatus_No_Status,//?
	kSCSIServiceResponse_SERVICE_DELIVERY_OR_TARGET_FAILURE,//?
	kSCSICDBSize_6Byte,//?
	kSCSICDBSize_10Byte,//?
	kSCSICDBSize_12Byte,//?
	kSCSICDBSize_16Byte,//?
	kSCSIDataTransfer_FromTargetToInitiator,//?
	kSCSIDataTransfer_FromInitiatorToTarget,//?
	kSCSIDataTransfer_NoDataTransfer,//?
	kSCSIServiceResponse_TASK_COMPLETE,//?
	kSCSITaskStatus_TaskTimeoutOccurred,//?
	kSCSITaskStatus_DeviceNotResponding,//?
	kSCSITaskStatus_CHECK_CONDITION,//?
	kSCSITaskStatus_DeliveryFailure,//?
	kSCSITaskStatus_DeviceNotPresent,//?
	kSCSIServiceResponse_FUNCTION_REJECTED,//?
	kSCSITaskStatus_ProtocolTimeoutOccurred,//?
	kSCSIUntaggedTaskIdentifier,//?
	kSCSITask_SIMPLE,//?
};

#ifdef	__cplusplus
typedef OSObject * SCSITaskIdentifier;//c
#endif //__cplusplus

typedef void ( *SCSITaskCompletion )( SCSITaskIdentifier a );//c
typedef UInt8 SCSICommandDescriptorBlock[kSCSICDBSize_Maximum];//c

typedef int SCSIServiceResponse;//?
typedef int SCSITaskStatus;//?
typedef int SCSITargetIdentifier;//?
typedef int SCSILogicalUnitNumber;//?
typedef int SCSITaskAttribute;//?
typedef int SCSITaggedTaskIdentifier;//?
typedef int SCSIDeviceIdentifier;//?
typedef int SCSIInitiatorIdentifier;//?


#endif //HYS_IOKIT_SCSI_SCSITASK_H
