#ifndef HYS_IOKIT_SERIAL_IOSR232SERIALSTREAMSYNC_H
#define HYS_IOKIT_SERIAL_IOSR232SERIALSTREAMSYNC_H

#define PD_RS232_PARITY_NONE 10//?
#define PD_RS232_N_SHIFT 13//?
#define PD_RS232_PARITY_DEFAULT 16//?
#define PD_RS232_PARITY_SPACE 19//?
#define PD_RS232_PARITY_MARK 21//?
#define PD_RS232_PARITY_EVEN 22//?
#define PD_RS232_D_SHIFT 26//?
#define PD_RS232_A_XANY 28//?
#define PD_RS232_PARITY_ANY 29//?
#define PD_RS232_PARITY_ODD 35//?

/////////////////
#define PD_RS232_S_MASK   0x0000ffffUL//c
#define PD_RS232_A_MASK   0x0000ffffUL//c
#define	PD_RS232_S_BRK	0x00000800UL//c
#define PD_RS232_N_MASK   0xffff0000UL//c
#define	PD_RS232_S_LOOP 0x00001000UL//c
////////////////////
#define PD_RS232_S_RXO	TIOCM_SR//c
#define PD_RS232_E_XOFF_BYTE          (PD_DATA_BYTE|PD_OP(58))//c
#define PD_RS232_E_RX_STOP_BITS       (PD_DATA_LONG|PD_OP(61)) //c
#define PD_RS232_E_STOP_BITS          (PD_DATA_LONG|PD_OP(60))//c
#define	PD_RS232_N_TXO	(PD_RS232_S_TXO << PD_RS232_N_SHIFT)//c
#define PD_RS232_E_RX_LINE_BREAK      (PD_DATA_VOID|PD_OP(63))//c
#define PD_RS232_E_MIN_LATENCY        (PD_DATA_BYTE|PD_OP(57))//c
#define PD_RS232_E_LINE_BREAK         (PD_DATA_BYTE|PD_OP(62))//c
#define	PD_RS232_D_RFR	(PD_RS232_S_RFR << PD_RS232_D_SHIFT)//c
#define	PD_RS232_D_DTR	(PD_RS232_S_DTR << PD_RS232_D_SHIFT)//c
#define	PD_RS232_D_RXO	(PD_RS232_S_RXO << PD_RS232_D_SHIFT)//c
#define PD_RS232_E_XON_BYTE           (PD_DATA_BYTE|PD_OP(59))//c
#define PD_RS232_S_RTS	TIOCM_RTS//c
#define PD_RS232_S_RFR        PD_RS232_S_RTS//c
#define PD_RS232_A_TXO	PD_RS232_S_TXO//c
#define PD_RS232_S_CAR	TIOCM_CAR//c
#define PD_RS232_S_CTS	TIOCM_CTS//c
#define PD_RS232_S_DSR	TIOCM_DSR//c
#define PD_RS232_S_RI     	PD_RS232_S_RNG//c
#define PD_RS232_S_DTR	TIOCM_DTR//c
#define PD_RS232_A_RXO	PD_RS232_S_RXO//c
#define PD_RS232_A_RFR	PD_RS232_S_RFR//c
#define PD_RS232_S_TXO	TIOCM_ST //c
#define PD_RS232_A_CTS	PD_RS232_S_CTS//c
#define PD_RS232_A_DTR	PD_RS232_S_DTR//c
#define PD_RS232_A_DCD	PD_RS232_S_DCD//c
#define PD_RS232_A_DSR	PD_RS232_S_DSR//c
#define PD_RS232_A_RTS	PD_RS232_S_RTS//c
#define PD_RS232_S_DCD	PD_RS232_S_CAR//c
#define PD_RS232_S_RNG	TIOCM_RNG//c
////////////////////////////////////////////////////////////////////
class  IORS232SerialStreamSync_HYS
{
    OSDeclareDefaultStructors(IORS232SerialStreamSync_HYS)

public:

};

#endif

