#ifndef HYS_IOKIT_STORAGE_IOAPPLELABELSCHEME_H
#define HYS_IOKIT_STORAGE_IOAPPLELABELSCHEME_H

#define AL_MAGIC 1//?
#define AL_TYPE_DEFAULT 2//?

////////////////
struct applelabel {
	int al_magic;//?
	int al_type;//?
 	int al_offset;//?
	int al_checksum;//?
	int al_size;//?
};
////////////////
class IOAppleLabelScheme_HYS
{
    OSDeclareDefaultStructors(IOAppleLabelScheme_HYS);

public://data

IOMedia * _content;//c

public://define

#define IOAppleLabelScheme_instantiateDesiredMediaObject  \
IOMedia * instantiateDesiredMediaObject(OSDictionary * a);//?

#define IOAppleLabelScheme_instantiateMediaObject \
IOMedia * instantiateMediaObject(OSDictionary * a);//?

#define IOAppleLabelScheme_isContentInvalid \
bool isContentInvalid(OSDictionary * a);//?

#define IOAppleLabelScheme_isContentCorrupt \
bool isContentCorrupt(OSDictionary * a);//?

#define IOAppleLabelScheme_detachMediaObjectFromDeviceTree \
   void detachMediaObjectFromDeviceTree(IOMedia * a);//?

#define IOAppleLabelScheme_stop \
void stop(IOService * a);//?

#define IOAppleLabelScheme_attachMediaObjectToDeviceTree \
bool attachMediaObjectToDeviceTree(IOMedia * a);//?

#define IOAppleLabelScheme_start \
 bool start(IOService * a);//?

#define IOAppleLabelScheme_scan \
IOMedia * scan(SInt32 * a);//?

#define IOAppleLabelScheme_probe \
 IOService * probe(IOService * a, SInt32 * b);//?

#define IOAppleLabelScheme_free \
    void free();//?

#define IOAppleLabelScheme_init \
  bool init(OSDictionary * a = 0);//?

};

#endif//HYS_IOKIT_STORAGE_IOAPPLELABELSCHEME_H
