#ifndef HYS_IOKIT_STORAGE_IOAPPLEPARTITIONSCHEME_H
#define HYS_IOKIT_STORAGE_IOAPPLEPARTITIONSCHEME_H

#define kIOApplePartitionSchemeClass "kIOApplePartitionSchemeClass"//?

////////////////
#define BLOCK0_SIGNATURE 1//?
#define DPME_SIGNATURE 2//?
#define DPISTRLEN 3//?
#define DPME_FLAGS_WRITABLE 4//?
#define DPME_FLAGS_VALID 5//? 
///////////////////
struct dpme {
	UInt16  dpme_signature;//c
  	char    dpme_type[DPISTRLEN];//c
    	UInt32  dpme_map_entries;//c
    	UInt32  dpme_pblocks; //c
    	UInt32  dpme_pblock_start;//c
 	char    dpme_name[DPISTRLEN];//c
    	UInt32  dpme_flags; //c
};
typedef struct dpme  DPME;

struct DDMap {};
typedef struct DDMap DDMap;

struct Block0 {
    	UInt16  sbSig;//c
    	UInt16  sbBlkSize;//c
};
typedef struct Block0 Block0;

///////////////////////
#ifdef __cplusplus
class IOApplePartitionScheme_HYS
{
    OSDeclareDefaultStructors(IOApplePartitionScheme_HYS);

public://data

OSSet* _partitions;//c

public://define

#define IOApplePartitionScheme_detachMediaObjectFromDeviceTree \
virtual void detachMediaObjectFromDeviceTree(IOMedia * media) __attribute__ ((deprecated));//c

#define IOApplePartitionScheme_attachMediaObjectToDeviceTree \
virtual bool attachMediaObjectToDeviceTree(IOMedia * media) __attribute__ ((deprecated));//c

#define IOApplePartitionScheme_instantiateDesiredMediaObject \
virtual IOMedia * instantiateDesiredMediaObject(dpme * partition,UInt32 partitionID,UInt32 partitionBlockSize );//c

#define IOApplePartitionScheme_instantiateMediaObject \
IOMedia * instantiateMediaObject( dpme *a, UInt32 b, UInt32 c);//?

#define IOApplePartitionScheme_isPartitionInvalid \
bool isPartitionInvalid( dpme *a, UInt32 b, UInt32 c);//?

#define IOApplePartitionScheme_isPartitionCorrupt \
bool isPartitionCorrupt( dpme *a, UInt32 b, UInt32 c);//?

#define IOApplePartitionScheme_requestProbe \
IOReturn requestProbe(IOOptionBits a);//?

#define IOApplePartitionScheme_stop \
void stop(IOService * a);//?

#define IOApplePartitionScheme_start \
 bool start(IOService *a);//?

#define  IOApplePartitionScheme_scan \
OSSet * scan(SInt32 * a);//?

#define IOApplePartitionScheme_probe \
IOService * probe(IOService * a, SInt32 * b);//?

#define IOApplePartitionScheme_free \
void free();//?

#define IOApplePartitionScheme_init \
bool init(OSDictionary * a = 0);//?

};
#endif //__cplusplus

#endif//HYS_IOKIT_STORAGE_IOAPPLEPARTITIONSCHEME_H
