#ifndef HYS_IOKIT_STORAGE_IOCDMEDIABSDCLIENT_H
#define HYS_IOKIT_STORAGE_IOCDMEDIABSDCLIENT_H

//hys add

#define IOCDMediaBSDClient_ioctl \
int ioctl(dev_t a, u_long b, caddr_t c, int d, proc_t e);//?

#define IOCDMediaBSDClient_getProvider \
IOCDMedia * getProvider() const;//?

////////

#define DKIOCCDREADTRACKINFO 1//? 
#define DKIOCCDREAD 2//?
#define DKIOCCDREADISRC 3//?
#define DKIOCCDREADMCN 4//?
#define DKIOCCDGETSPEED 5//?
#define DKIOCCDSETSPEED 6//?
#define DKIOCCDREADTOC 7//?
#define DKIOCCDREADDISCINFO 8//?


struct dk_cd_read_t {
	int buffer;//?
	int bufferLength;//?
	int offset;//?
	int sectorArea;//?
	int sectorType;//?
};
typedef struct dk_cd_read_t dk_cd_read_t;

struct dk_cd_read_isrc_t {
	int track;//?
	int isrc;//?
};
typedef struct dk_cd_read_isrc_t dk_cd_read_isrc_t;

struct dk_cd_read_mcn_t {
	int mcn;//?
};
typedef struct dk_cd_read_mcn_t dk_cd_read_mcn_t;

struct dk_cd_read_toc_t {
	int buffer;//?
	u_int16_t bufferLength;//c
	u_int8_t  format;//c
	u_int8_t formatAsTime;//c
  	  union {
		u_int8_t session;//c
    	} address;
};
typedef struct dk_cd_read_toc_t dk_cd_read_toc_t;

struct dk_cd_read_disc_info_t {
	int buffer;//?
	u_int16_t bufferLength;//c
};
typedef struct dk_cd_read_disc_info_t dk_cd_read_disc_info_t;

struct dk_cd_read_track_info_t {
	int buffer;//?
	u_int16_t  bufferLength;//c
	u_int32_t address;//c
	u_int8_t addressType;//c
};
typedef struct dk_cd_read_track_info_t dk_cd_read_track_info_t;

#endif//HYS_IOKIT_STORAGE_IOCDMEDIABSDCLIENT_H
