#ifndef HYS_IOKIT_STORAGE_IOFDISKPARTIOTIONSCHEME_H
#define HYS_IOKIT_STORAGE_IOFDISKPARTIOTIONSCHEME_H
/////////////////////////////////
#define DISK_SIGNATURE 1//?
#define DISK_NPART 2//?

/////////////////////

struct fdisk_part {
	int systid;//?
 	int relsect;//?
	int numsect;//?
	int bootid;//?
};

struct disk_blk0 {
	int signature;//?
	struct fdisk_part parts[1];//?
};
////////////////////
class  IOFDiskPartitionScheme_HYS
{
    OSDeclareDefaultStructors(IOFDiskPartitionScheme_HYS);

public://data

OSSet* _partitions;//c

public://define

#define IOFDiskPartitionScheme_attachMediaObjectToDeviceTree \
bool attachMediaObjectToDeviceTree(IOMedia *a);//?

#define IOFDiskPartitionScheme_detachMediaObjectFromDeviceTree \
void detachMediaObjectFromDeviceTree(IOMedia * a);//?

#define IOFDiskPartitionScheme_instantiateDesiredMediaObject \
IOMedia * instantiateDesiredMediaObject( fdisk_part * a, UInt32 b, UInt32 c);//?

#define IOFDiskPartitionScheme_instantiateMediaObject \
IOMedia * instantiateMediaObject( fdisk_part *a, UInt32 b, UInt32  c);//?

#define IOFDiskPartitionScheme_isPartitionInvalid \
bool isPartitionInvalid( fdisk_part * a, UInt32 b, UInt32 c);//?

#define IOFDiskPartitionScheme_isPartitionCorrupt \
bool isPartitionCorrupt( fdisk_part *a, UInt32 b, UInt32 c);//?

#define IOFDiskPartitionScheme_isPartitionUsed \
bool isPartitionUsed(fdisk_part * a);//?

#define IOFDiskPartitionScheme_requestProbe \
IOReturn requestProbe(IOOptionBits a);//?

#define IOFDiskPartitionScheme_isPartitionExtended \
 bool isPartitionExtended(fdisk_part * a);//?

#define IOFDiskPartitionScheme_stop \
void stop(IOService *a);//?

#define IOFDiskPartitionScheme_start \
bool start(IOService * a);//?

#define IOFDiskPartitionScheme_scan \
OSSet * scan(SInt32 *a);//?

#define IOFDiskPartitionScheme_probe \
IOService * probe(IOService * a, SInt32 * b);//?

#define IOFDiskPartitionScheme_free \
void free();//?

#define IOFDiskPartitionScheme_init \
bool init(OSDictionary * a= 0);//?

};

#endif//HYS_IOKIT_STORAGE_IOFDISKPARTIOTIONSCHEME_H
