#ifndef HYS_IOKIT_STORAGE_IOMEDIA_H
#define HYS_IOKIT_STORAGE_IOMEDIA_H

typedef UInt32 IOMediaAttributeMask;//c
////////////////////////////////

#ifdef __cplusplus
class  IOMedia_HYS
{
 OSDeclareDefaultStructors(IOMedia_HYS)

public://data

OSDictionary * _openClients;//c
IOStorageAccess _openLevel;//c
UInt64          _mediaSize;//c
UInt64          _preferredBlockSize;//c
UInt64          _mediaBase;//c
bool            _isWritable;//c
UInt32          _attributes;//c
bool            _isWhole;//c

public://define

#define IOMedia_detachFromChild \
virtual void detachFromChild(IORegistryEntry *       client, const IORegistryPlane * plane);//c

#define IOMedia_attachToChild \
virtual bool attachToChild(IORegistryEntry *       client,const IORegistryPlane * plane);//c

#define IOMedia_getProvider \
virtual IOStorage * getProvider() const;//c

#define IOMedia_matchPropertyTable \
    virtual bool matchPropertyTable(OSDictionary * table, SInt32 * score);//c

#define IOMedia_free \
virtual void free();//c

#define IOMedia_init \
 virtual bool init(UInt64         base, UInt64         size, UInt64         preferredBlockSize, bool           isEjectable,bool           isWhole,bool           isWritable, const char *   contentHint = 0,OSDictionary * properties  = 0) __attribute__ ((deprecated));//c


public://func


};
#endif //__cplusplus

#endif//HYS_IOKIT_STORAGE_IOMEDIA_H
