#ifndef HYS_IOKIT_USB_IOUFISTORAGESERVCE_H
#define HYS_IOKIT_USB_IOUFISTORAGESERVCE_H

class IOUFIStorageServices_HYS
{
	OSDeclareDefaultStructors ( IOUFIStorageServices_HYS) 
public://data

IOUSBMassStorageUFIDevice *fProvider;//c

int fMaxWriteBlocks;//?
int fMaxReadBlocks;//?
int fMediaPresent;//?
int fMediaChanged;//?

public://define

#define  IOUFIStorageServices_getRevisionString \
char *		getRevisionString ( void );//?c

#define IOUFIStorageServices_doSyncReadWrite \
IOReturn	doSyncReadWrite ( 	IOMemoryDescriptor *a, UInt32 b, UInt32 c);//?c

#define IOUFIStorageServices_AsyncReadWriteComplete \
static void  AsyncReadWriteComplete ( void *a, IOReturn b, UInt64 c);//c

#define IOUFIStorageServices_message \
IOReturn 	message ( UInt32 a, IOService * b, void * c);//?c

#define IOUFIStorageServices_detach \
void	detach ( IOService * a );//?c

#define IOUFIStorageServices_getAdditionalDeviceInfoString \
char *		getAdditionalDeviceInfoString ( void );//?c

#define IOUFIStorageServices_attach \
 bool 	attach ( IOService * a);//?c

#define IOUFIStorageServices_doFormatMedia \
IOReturn	 doFormatMedia ( UInt64 a);//?c

#define IOUFIStorageServices_reportRemovability \
IOReturn	reportRemovability ( bool * a);//?c

#define IOUFIStorageServices_doGetFormatCapacities \
UInt32		doGetFormatCapacities (UInt64 *a, UInt32	 b ) const;//?c

#define IOUFIStorageServices_reportPollRequirements  \
IOReturn	reportPollRequirements (bool *a, bool *b);//?c

#define  IOUFIStorageServices_getProductString \
 char *		getProductString ( void );//?c

#define IOUFIStorageServices_reportMediaState \
IOReturn	reportMediaState ( bool * a, bool * b);//?c

#define IOUFIStorageServices_getVendorString \
char *		getVendorString ( void );//?c

#define IOUFIStorageServices_doAsyncReadWrite \
IOReturn	doAsyncReadWrite(IOMemoryDescriptor *a, UInt32 b, UInt32 c, IOStorageCompletion d);//?c

#define IOUFIStorageServices_reportMaxWriteTransfer  \
IOReturn	reportMaxWriteTransfer ( UInt64 a, UInt64 * b);//?c

#define IOUFIStorageServices_reportMaxReadTransfer \
IOReturn	reportMaxReadTransfer ( UInt64 a, UInt64 * b);//?c

#define IOUFIStorageServices_doEjectMedia \
 IOReturn	doEjectMedia ( void );//?c

#define IOUFIStorageServices_reportEjectability \
 IOReturn	reportEjectability ( bool * a);//?c

#define IOUFIStorageServices_reportBlockSize  \
IOReturn	reportBlockSize ( UInt64 * a);//?c

#define IOUFIStorageServices_reportLockability \
IOReturn	reportLockability ( bool * a);//?c

#define IOUFIStorageServices_doLockUnlockMedia \
 IOReturn	doLockUnlockMedia ( bool a);//?c

#define IOUFIStorageServices_reportMaxValidBlock  \
IOReturn	reportMaxValidBlock ( UInt64 * a);//?c

#define IOUFIStorageServices_reportWriteProtection \
IOReturn	reportWriteProtection ( bool * a);//?c

#define IOUFIStorageServices_doSynchronizeCache \
IOReturn	doSynchronizeCache ( void );//?c

};


#endif//HYS_IOKIT_USB_IOUFISTORAGESERVCE_H
