#ifndef HYS_IOKIT_USB_IOUSBCONTROLLERLISTELEMENT_H
#define HYS_IOKIT_USB_IOUSBCONTROLLERLISTELEMENT_H
/////////

class IOUSBControllerListElement;//add
class IOUSBControllerIsochListElement;//add

class  IOUSBControllerListElement_HYS
{
    OSDeclareDefaultStructors(IOUSBControllerListElement_HYS)
public://data

void* _sharedLogical;//c
IOUSBIsocFrame * _pFrames;//c
IOUSBControllerListElement* _logicalNext;//c

int _sharedPhysical;//?

public://define

#define IOUSBControllerListElement_print \
void					print(int a);//?c

public://func
int SetPhysicalLink(int a);//?
int GetPhysicalLink();//?
int GetPhysicalAddrWithType();//?

};
//////////////////////////

class IOUSBControllerIsochListElement_HYS
{
  OSDeclareDefaultStructors(IOUSBControllerIsochListElement_HYS)
public:

IOUSBControllerIsochEndpoint	* _pEndpoint;//c
IOUSBControllerIsochListElement* _doneQueueLink;//c
IOUSBIsocCompletion _completion;//c

int _frameNumber;//?
int _requestFromRosettaClient;//?
int _framesInTD;//?
int _lowLatency;//?
int _frameIndex;//?

public://define

#define IOUSBControllerIsochListElement_Deallocate \
 IOReturn				Deallocate(IOUSBControllerV2 *a);//?c?

#define IOUSBControllerIsochListElement_print \
 void					print(int a);//?c

public://func

int UpdateFrameList(AbsoluteTime a);//?

};
////////////////////////
class  IOUSBControllerIsochEndpoint_HYS
{
    OSDeclareDefaultStructors(IOUSBControllerIsochEndpoint_HYS)
	
public:
/////////////
#ifdef IOUSBFamily
volatile SInt32 scheduledTDs;//c//IOUSVFamily define
#else
UInt32 scheduledTDs;//c
#endif
/////////////////////////
IOUSBControllerIsochEndpoint	* nextEP;//c
IOUSBControllerIsochListElement  *toDoList;//c
IOUSBControllerIsochListElement  *toDoEnd;//c
IOUSBControllerIsochListElement  *doneEnd;//c
IOUSBControllerIsochListElement  *doneQueue;//c
IOUSBControllerIsochListElement *deferredQueue;//c
IOUSBControllerIsochListElement* deferredEnd;//c

int onDoneQueue;//?
int deferredTDs;//?
int onToDoList;//?
int aborting;//?
int functionAddress;//?
int endpointNumber;//?
int firstAvailableFrame;//?
int activeTDs;//?
int inSlot;//?
int onReversedList;//?
int onProducerQ;//?
int accumulatedStatus;//?
int interval;//?
int maxPacketSize;//?
int direction;//?

public://define

#define IOUSBControllerIsochEndpoint_init \
bool init();//?

};

#endif//HYS_IOKIT_USB_IOUSBCONTROLLERLISTELEMENT_H
