#ifndef HYS_IOKIT_USB_IOUSBLIB_H
#define HYS_IOKIT_USB_IOUSBLIB_H

#include <mach/mach_port.h>//‘mach_port_allocate

//hys add start
//usb.subproj/USBTest.cpp-IOKituser


struct IOUSBEndpoint {
	int number;
	int direction;
	int transferType;
	int maxPacketSize;
};
typedef struct IOUSBEndpoint IOUSBEndpoint;

struct IOUSBInterface_descriptor {
	int numEndpoints;
};

struct IOUSBInterface {
	struct IOUSBInterface_descriptor* descriptor;
	IOUSBEndpoint *endpoints[1];
};
typedef struct IOUSBInterface IOUSBInterface;

typedef int IOUSBIteratorRef;
//typedef struct 	IOUSBDeviceStruct197**	 			IOUSBDeviceRef ;
typedef int IOUSBPipeRef;

static inline int IOUSBGetDeviceDescriptor(int a, IOUSBDeviceDescriptor* b, int c){return 0;};
static inline int IOUSBGetInterfaceDescriptor(int a, IOUSBInterfaceDescriptor* b, int c){return 0;};
//inline int IOUSBNewDeviceRef(int a, IOUSBDeviceRef* b) {return 0;};
static inline int IOUSBGetConfiguration(int a, UInt8* b) {return 0;};
static inline int IOUSBSetConfiguration(int a, int b) {return 0;};
static inline int IOUSBGetConfigDescriptor(int a,int b,IOUSBConfigurationDescriptor** c) {return 0;};
static inline int IOUSBDeviceRequest(int a,int b, int c,int d,int e,char*  f,UInt16* g){return 0;};

static inline IOUSBInterface* IOUSBFindNextInterface(int a, IOUSBFindInterfaceRequest* b) {return 0;};

static inline int IOUSBDisposeInterface(IOUSBInterface* a) {return 0;};
static inline int IOUSBDisposeRef(int a) {return 0;};
static inline int IOUSBOpenPipe(int a,IOUSBEndpoint* b,IOUSBPipeRef* c) {return 0;};
static inline int IOUSBReadPipe(int a, char* b, UInt32* c){return 0;};
static inline int IOUSBClosePipe(int a){return 0;};
static inline int IOUSBCreateIterator(int a,int b,IOUSBMatch* c,IOUSBIteratorRef* d){return 0;};
static inline int IOUSBIteratorNext(int a){};
static inline int IOUSBDisposeIterator(int a){};

//////////hys add end
#define kIOUSBInterfaceClassName "kIOUSBInterfaceClassName"//?
#define kIOUSBDeviceClassName "kIOUSBDeviceClassName"//?
/////////////////////////////
#define kIOUSBDeviceInterfaceID245 CFUUIDGetConstantUUIDWithBytes(0, 1,2,3,4,5,6,7,8,9,10, 11, 12,13,14,15,16)//?
///////////

#define IOUSBDeviceStruct300_FUNC \
    IOReturn (*CreateDeviceAsyncEventSource)(void *a, CFRunLoopSourceRef *b); \
    CFRunLoopSourceRef (*GetDeviceAsyncEventSource)(void *a); \
    IOReturn (*CreateDeviceAsyncPort)(void *a, mach_port_t *b); \
    mach_port_t (*GetDeviceAsyncPort)(void *a); \
    IOReturn (*USBDeviceOpen)(void *a); \
    IOReturn (*USBDeviceClose)(void *a); \
    IOReturn (*GetDeviceClass)(void *a, UInt8 *b); \
    IOReturn (*GetDeviceSubClass)(void *a, UInt8 *b); \
    IOReturn (*GetDeviceProtocol)(void *a, UInt8 *b); \
    IOReturn (*GetDeviceVendor)(void *a, UInt16 *b); \
    IOReturn (*GetDeviceProduct)(void *a, UInt16 *b); \
    IOReturn (*GetDeviceReleaseNumber)(void *a, UInt16 *b); \
    IOReturn (*GetDeviceAddress)(void *a, USBDeviceAddress *b); \
    IOReturn (*GetDeviceBusPowerAvailable)(void *a, UInt32 *b); \
    IOReturn (*GetDeviceSpeed)(void *a, UInt8 *b); \
    IOReturn (*GetNumberOfConfigurations)(void *a, UInt8 *b); \
    IOReturn (*GetLocationID)(void *a, UInt32 *b); \
IOReturn (*GetConfigurationDescriptorPtr)(void *a, UInt8 b, IOUSBConfigurationDescriptorPtr *c); \
    IOReturn (*GetConfiguration)(void *a, UInt8 *b); \
    IOReturn (*SetConfiguration)(void *a, UInt8 b); \
    IOReturn (*GetBusFrameNumber)(void *a, UInt64 *b, AbsoluteTime *c); \
    IOReturn (*ResetDevice)(void *a); \
    IOReturn (*DeviceRequest)(void *a, IOUSBDevRequest *b); \
    IOReturn (*DeviceRequestAsync)(void *a, IOUSBDevRequest *b, IOAsyncCallback1 c, void *d); \
    IOReturn (*CreateInterfaceIterator)(void *a, IOUSBFindInterfaceRequest *b, io_iterator_t *c); \
    IOReturn (*USBDeviceOpenSeize)(void *a); \
    IOReturn (*DeviceRequestTO)(void *a, IOUSBDevRequestTO *b); \
    IOReturn (*DeviceRequestAsyncTO)(void *a, IOUSBDevRequestTO *b, IOAsyncCallback1 c, void *d); \
    IOReturn (*USBDeviceSuspend)(void *a, Boolean b); \
    IOReturn (*USBDeviceAbortPipeZero)(void *a); \
    IOReturn (*USBGetManufacturerStringIndex)(void *a, UInt8 *b); \
    IOReturn (*USBGetProductStringIndex)(void *a, UInt8 *b); \
    IOReturn (*USBGetSerialNumberStringIndex)(void *a, UInt8 *b); \
    IOReturn (*USBDeviceReEnumerate)(void *a, UInt32 b); \
    IOReturn (*GetBusMicroFrameNumber)(void *a, UInt64 *b, AbsoluteTime *v); \
    IOReturn (*GetIOUSBLibVersion)(void *a, NumVersion *b, NumVersion *v);
////////////////////////

typedef struct IOUSBInterfaceStruct300{
	IUNKNOWN_C_GUTS;
	IOReturn (*CreateInterfaceAsyncEventSource)(void *a, CFRunLoopSourceRef *b);//c
    	CFRunLoopSourceRef (*GetInterfaceAsyncEventSource)(void *a);//c
    	IOReturn (*CreateInterfaceAsyncPort)(void *a, mach_port_t *b);//c
    	mach_port_t (*GetInterfaceAsyncPort)(void *a);//c
    	IOReturn (*USBInterfaceOpen)(void *a);//c
    	IOReturn (*USBInterfaceClose)(void *a);//c
    	IOReturn (*GetInterfaceClass)(void *a, UInt8 *b);//c
    	IOReturn (*GetInterfaceSubClass)(void *a, UInt8 *b);//c
    	IOReturn (*GetInterfaceProtocol)(void *a, UInt8 *b);//c
    	IOReturn (*GetDeviceVendor)(void *a, UInt16 *b);//c
    	IOReturn (*GetDeviceProduct)(void *a, UInt16 *b);//c
    	IOReturn (*GetDeviceReleaseNumber)(void *a, UInt16 *b);//c
    	IOReturn (*GetConfigurationValue)(void *a, UInt8 *b);//c
    	IOReturn (*GetInterfaceNumber)(void *a, UInt8 *b);//c
    	IOReturn (*GetAlternateSetting)(void *a, UInt8 *b);//c
	IOReturn (*GetNumEndpoints)(void *a, UInt8 *b);//c
    	IOReturn (*GetLocationID)(void *a, UInt32 *b);//c
    	IOReturn (*GetDevice)(void *a, io_service_t *b);//c
    	IOReturn (*SetAlternateInterface)(void *a, UInt8 b);//c
    	IOReturn (*GetBusFrameNumber)(void *a, UInt64 *b, AbsoluteTime *c);//c
    	IOReturn (*ControlRequest)(void *a, UInt8 b, IOUSBDevRequest *c);//c
    	IOReturn (*ControlRequestAsync)(void *a, UInt8 b, IOUSBDevRequest *c, IOAsyncCallback1 d, void *e);//c
    	IOReturn (*GetPipeProperties)(void *a, UInt8 b, UInt8 *c, UInt8 *d, UInt8 *e, UInt16 *f, UInt8 *g);//c
    	IOReturn (*GetPipeStatus)(void *a, UInt8 b);//c
    	IOReturn (*AbortPipe)(void *a, UInt8 b);//c
    	IOReturn (*ResetPipe)(void *a, UInt8 b);//c
    	IOReturn (*ClearPipeStall)(void *a, UInt8 b);//c
    	IOReturn (*ReadPipe)(void *a, UInt8 b, void *c, UInt32 *d);//c
    	IOReturn (*WritePipe)(void *a, UInt8 b, void *c, UInt32 d);//c
    	IOReturn (*ReadPipeAsync)(void *a, UInt8 b, void *c, UInt32 d, IOAsyncCallback1 e, void *f);//c
    	IOReturn (*WritePipeAsync)(void *a, UInt8 b, void *c, UInt32 d, IOAsyncCallback1 e, void *f);//c
    	IOReturn (*ReadIsochPipeAsync)(void *a, UInt8 b, void *c, UInt64 d, UInt32 e, IOUSBIsocFrame *f,IOAsyncCallback1 g, void *h);//c
    	IOReturn (*WriteIsochPipeAsync)(void *a, UInt8 b, void *c, UInt64 d, UInt32 e, IOUSBIsocFrame *f, IOAsyncCallback1 g, void *h);//c
    	IOReturn (*ControlRequestTO)(void *a, UInt8 b, IOUSBDevRequestTO *c);//c
	IOReturn (*ControlRequestAsyncTO)(void *a, UInt8 b, IOUSBDevRequestTO *c, IOAsyncCallback1 d, void *e);//c
    	IOReturn (*ReadPipeTO)(void *a, UInt8 b, void *c, UInt32 *d, UInt32 e, UInt32 f);//c
    	IOReturn (*WritePipeTO)(void *a, UInt8 b, void *c, UInt32 d, UInt32 e, UInt32 f);//c
    	IOReturn (*ReadPipeAsyncTO)(void *a, UInt8 b, void *c, UInt32 d, UInt32 e, UInt32 f, IOAsyncCallback1 g, void *h);//c
    	IOReturn (*WritePipeAsyncTO)(void *a, UInt8 b, void *c, UInt32 d, UInt32 e, UInt32 f, IOAsyncCallback1 g, void *h);//c
    	IOReturn (*USBInterfaceGetStringIndex)(void *a, UInt8 *b);//c
    	IOReturn (*USBInterfaceOpenSeize)(void *a);//c
    	IOReturn (*ClearPipeStallBothEnds)(void *a, UInt8 b);//c
    	IOReturn (*SetPipePolicy)(void *a, UInt8 b, UInt16 c, UInt8 d);//c
    	IOReturn (*GetBandwidthAvailable)(void *a, UInt32 *b);//c
    	IOReturn (*GetEndpointProperties)(void *a, UInt8 b, UInt8 c, UInt8 d, UInt8 *e, UInt16 *f, UInt8 *g);//c
    	IOReturn (*LowLatencyReadIsochPipeAsync)(void *a, UInt8 b, void *c, UInt64 d, UInt32 e, UInt32 f, IOUSBLowLatencyIsocFrame *g,IOAsyncCallback1 h, void *i);//c
    	IOReturn (*LowLatencyWriteIsochPipeAsync)(void *a, UInt8 b, void *c, UInt64 d, UInt32 e, UInt32 f, IOUSBLowLatencyIsocFrame *g,IOAsyncCallback1 h, void *i);//c
    	IOReturn (*LowLatencyCreateBuffer)(void *a, void **b, IOByteCount c, UInt32 d);//c
	IOReturn (*LowLatencyDestroyBuffer) (void * a, void * b);//c
    	IOReturn (*GetBusMicroFrameNumber)(void *a, UInt64 *b, AbsoluteTime *c);//c
	IOReturn (*GetFrameListTime)(void *a, UInt32 *b);//c
    	IOReturn (*GetIOUSBLibVersion)(void *a, NumVersion *b, NumVersion *c);//c
    	IOUSBDescriptorHeader * (*FindNextAssociatedDescriptor)(void *a, const void *b, UInt8 c);//c
    	IOUSBDescriptorHeader * (*FindNextAltInterface)(void *a, const void *b, IOUSBFindInterfaceRequest *c);//c
    	IOReturn (*GetBusFrameNumberWithTime)(void *a, UInt64 *b, AbsoluteTime *c);//c
} IOUSBInterfaceInterface300;
////////////////////////
typedef struct IOUSBDeviceStruct245 {
    IUNKNOWN_C_GUTS;
    IOReturn (*CreateDeviceAsyncEventSource)(void *a, CFRunLoopSourceRef *b);//c
    CFRunLoopSourceRef (*GetDeviceAsyncEventSource)(void *a);//c
    IOReturn (*CreateDeviceAsyncPort)(void *a, mach_port_t *b);//c
    mach_port_t (*GetDeviceAsyncPort)(void *a);//c
    IOReturn (*USBDeviceOpen)(void *a);//c
    IOReturn (*USBDeviceClose)(void *a);//c
    IOReturn (*GetDeviceClass)(void *a, UInt8 *b);//c
    IOReturn (*GetDeviceSubClass)(void *a, UInt8 *b);//c
    IOReturn (*GetDeviceProtocol)(void *a, UInt8 *b);//c
    IOReturn (*GetDeviceVendor)(void *a, UInt16 *b);//c
    IOReturn (*GetDeviceProduct)(void *a, UInt16 *b);//c
    IOReturn (*GetDeviceReleaseNumber)(void *a, UInt16 *b);//c
    IOReturn (*GetDeviceAddress)(void *a, USBDeviceAddress *b);//c
    IOReturn (*GetDeviceBusPowerAvailable)(void *a, UInt32 *b);//c
    IOReturn (*GetDeviceSpeed)(void *a, UInt8 *b);//c
    IOReturn (*GetNumberOfConfigurations)(void *a, UInt8 *b);//c
    IOReturn (*GetLocationID)(void *a, UInt32 *b);//c
    IOReturn (*GetConfigurationDescriptorPtr)(void *a, UInt8 b, IOUSBConfigurationDescriptorPtr *c);//x
    IOReturn (*GetConfiguration)(void *a, UInt8 *b);//c
    IOReturn (*SetConfiguration)(void *a, UInt8 b);//c
    IOReturn (*GetBusFrameNumber)(void *a, UInt64 *b, AbsoluteTime *c);//c;
    IOReturn (*ResetDevice)(void *a);//c
    IOReturn (*DeviceRequest)(void *a, IOUSBDevRequest *b);//c
    IOReturn (*DeviceRequestAsync)(void *a, IOUSBDevRequest *b, IOAsyncCallback1 c, void *d);//c
    IOReturn (*CreateInterfaceIterator)(void *a, IOUSBFindInterfaceRequest *b, io_iterator_t *c);//x
    IOReturn (*USBDeviceOpenSeize)(void *a);//c
    IOReturn (*DeviceRequestTO)(void *a, IOUSBDevRequestTO *b);//c
    IOReturn (*DeviceRequestAsyncTO)(void *a, IOUSBDevRequestTO *b, IOAsyncCallback1 c, void *d);//c
    IOReturn (*USBDeviceSuspend)(void *a, Boolean b);//c
    IOReturn (*USBDeviceAbortPipeZero)(void *a);//c
    IOReturn (*USBGetManufacturerStringIndex)(void *a, UInt8 *b);//c
;    IOReturn (*USBGetProductStringIndex)(void *a, UInt8 *b);//c
    IOReturn (*USBGetSerialNumberStringIndex)(void *a, UInt8 *b);//c
    IOReturn (*USBDeviceReEnumerate)(void *a, UInt32 b);//c
    IOReturn (*GetBusMicroFrameNumber)(void *a, UInt64 *b, AbsoluteTime *c);//c
    IOReturn (*GetIOUSBLibVersion)(void *a, NumVersion *b, NumVersion *c);//c
} IOUSBDeviceInterface245;


typedef struct IOUSBInterfaceStruct245{
    IUNKNOWN_C_GUTS;
    	IOReturn (*ControlRequest)(void *a, UInt8 b, IOUSBDevRequest *c);//c
    	IOReturn (*USBInterfaceOpen)(void *a);//c
    	IOReturn (*GetNumEndpoints)(void *a, UInt8 *b);//c
   	 IOReturn (*GetPipeProperties)(void *a, UInt8 b, UInt8 *c, UInt8 *d, UInt8 *e, UInt16 *f, UInt8 *g);//c
    	IOReturn (*USBInterfaceClose)(void *a);//c
    	IOReturn (*GetInterfaceClass)(void *a, UInt8 *b);//c
    	IOReturn (*ReadPipeAsync)(void *a, UInt8 b, void *c, UInt32 d, IOAsyncCallback1 e, void *f);//c
    	IOReturn (*ReadPipe)(void *a, UInt8 b, void *c, UInt32 *d);//c
    	IOReturn (*WritePipe)(void *a, UInt8 b, void *c, UInt32 d);//c
    	IOReturn (*GetInterfaceSubClass)(void *a, UInt8 *b);//c
    	IOReturn (*CreateInterfaceAsyncEventSource)(void *a, CFRunLoopSourceRef *b);//c
	IOReturn (*WritePipeAsync)(void *a, UInt8 b, void *c, UInt32 d, IOAsyncCallback1 e, void *f);//c
   	IOReturn (*SetAlternateInterface)(void *a, UInt8 b);//c
   	IOReturn (*GetLocationID)(void *self, UInt32 *locationID);//c
    	IOReturn (*GetDevice)(void *self, io_service_t *device);//c
    	IOReturn (*GetDeviceVendor)(void *self, UInt16 *devVendor);//c
    	IOReturn (*GetDeviceProduct)(void *self, UInt16 *devProduct);//c
    	IOReturn (*GetPipeStatus)(void *self, UInt8 pipeRef);//c
    	IOReturn (*ReadPipeTO)(void *self, UInt8 pipeRef, void *buf, UInt32 *size, UInt32 noDataTimeout, UInt32 completionTimeout);//c
} IOUSBInterfaceInterface245;

typedef struct IOUSBDeviceStruct197 {
    IUNKNOWN_C_GUTS;

    	IOReturn (*GetLocationID)(void *a, UInt32 *b);//c
 	IOReturn (*GetDeviceSpeed)(void *a, UInt8 *b);//v
    	IOReturn (*GetDeviceAddress)(void *a, USBDeviceAddress *b);//c
    	IOReturn (*USBDeviceOpen)(void *a);//c
    	IOReturn (*USBDeviceSuspend)(void *a, Boolean b);//c
    	IOReturn (*DeviceRequest)(void *a, IOUSBDevRequest *b);//c
    	IOReturn (*USBDeviceClose)(void *a);//c

} IOUSBDeviceInterface197;



#endif //HYS_IOKIT_USB_IOUSBLIB_H
