#ifndef HYS_IOKIT_USB_IOUSBLOG_H
#define HYS_IOKIT_USB_IOUSBLOG_H

////////////////
#define USBError( a, b...)	//?
#define USBLog( a, b...)	//?
//////////////////////

#define kLogKextName "kLogKextName"//?

//////////////////

enum
{
    kUSBControllerUserClientOpen = 0,
    kUSBControllerUserClientClose,
    kUSBControllerUserClientEnableLogger,
    kUSBControllerUserClientSetDebuggingLevel,
    kUSBControllerUserClientSetDebuggingType,
    kUSBControllerUserClientGetDebuggingLevel,
    kUSBControllerUserClientGetDebuggingType,
    kUSBControllerUserClientSetTestMode,
    kUSBControllerUserClientReadRegister,
    kUSBControllerUserClientWriteRegister,
    kNumUSBControllerMethods
};//c

enum {
	kKernelDebugOutputIOLogType,//?
	kKernelDebugOutputKextLoggerType,//?
};


///////////////
typedef int KernelDebugLevel;//?
typedef int KernelDebuggingOutputType;//?
///////////////////////



#ifdef	__cplusplus
	extern "C" {
#endif

int KernelDebugFindKernelLogger();//?
void			KernelDebugEnable( bool a);//
void			KernelDebugSetLevel( KernelDebugLevel a);//c
void			KernelDebugSetOutputType( KernelDebuggingOutputType a );//c
KernelDebugLevel	KernelDebugGetLevel();//c
KernelDebuggingOutputType	KernelDebugGetOutputType();//c

#ifdef	__cplusplus
	}
#endif


/////////////////

class com_apple_iokit_KLog_HYS
{

    OSDeclareDefaultStructors(com_apple_iokit_KLog_HYS)
public:
int vLog(int a,int b,const char * c, va_list d);//?

};
/////////////////
class  IOUSBLog_HYS
{
   // OSDeclareAbstractStructors(IOUSBLog_HYS)

public:

#define IOUSBLog_AddStatusLevel \
void 	AddStatusLevel (UInt32 a, UInt32 b, char *c, UInt32 d);//?

#define IOUSBLog_AddStatus_char \
void	AddStatus(char *a);//?

#define IOUSBLog_AddStatus \
 void	AddStatus(UInt32 a, char *b);//?

#define IOUSBLog_USBLogPrint \
 void 	USBLogPrintf(UInt32 a, char *b,...);//?

#define IOUSBLog_usblog \
    static IOUSBLog	*usblog();//c

#define IOUSBLog_init \
 bool	 init( OSDictionary * a = 0 );//?

};

#endif//HYS_IOKIT_USB_IOUSBLOG_H
