#ifndef HYS_IOKIT_USB_IOUSBUSERCLIENT_H
#define HYS_IOKIT_USB_IOUSBUSERCLIENT_H

enum {
	kUSBInterfaceUserClientGetConfigDescriptor,//?
	kUSBInterfaceUserClientLowLatencyPrepareBuffer,//?
	kUSBInterfaceUserClientLowLatencyReadIsochPipe,//?
	kUSBInterfaceUserClientWriteIsochPipe,//?
	kUSBInterfaceUserClientLowLatencyReleaseBuffer,//?
	kUSBInterfaceUserClientSetPipePolicy,//?
	kUSBInterfaceUserClientAbortPipe,//?
	kUSBInterfaceUserClientWritePipe,//?
	kUSBInterfaceUserClientGetPipeStatus,//?
	kUSBInterfaceUserClientClearPipeStall,//?
	kUSBInterfaceUserClientResetPipe,//?
	kUSBInterfaceUserClientReadIsochPipe,//?
	kUSBInterfaceUserClientControlRequestOut,//?
	kUSBInterfaceUserClientGetPipeProperties,//?
	kUSBInterfaceUserClientReadPipe,//?
	kUSBInterfaceUserClientGetEndpointProperties,//?
	kUSBInterfaceUserClientControlRequestIn,//?
	kUSBInterfaceUserClientGetBandwidthAvailable,//?
	kUSBInterfaceUserClientGetFrameListTime,//?
	kUSBInterfaceUserClientGetFrameNumberWithTime,//?
	kUSBInterfaceUserClientGetFrameNumber,//?
	kUSBInterfaceUserClientGetMicroFrameNumber,//?
	kUSBInterfaceUserClientSetAlternateInterface,//?
	kUSBInterfaceUserClientClose,//?
	kUSBInterfaceUserClientOpen,//?
	kUSBInterfaceUserClientGetDevice,//?
	kUSBDeviceUserClientAbortPipeZero,//?
	kUSBDeviceUserClientSuspend,//?
	kUSBDeviceUserClientDeviceRequestOut,//?
	kUSBDeviceUserClientCreateInterfaceIterator,//?
	kUSBDeviceUserClientResetDevice,//?
	kUSBDeviceUserClientDeviceRequestIn,//?
	kUSBDeviceUserClientGetConfigDescriptor,//?
	kUSBDeviceUserClientSetConfig,//?
	kUSBDeviceUserClientGetConfig,//?
	kUSBDeviceUserClientSetAsyncPort,//?
	kUSBDeviceUserClientOpen,//?
	kUSBDeviceUserClientClose,//?
	kUSBDeviceUserClientReEnumerateDevice,//?
	kUSBDeviceUserClientGetFrameNumber,//?
	kUSBDeviceUserClientGetMicroFrameNumber,//?
	kUSBDeviceUserClientGetFrameNumberWithTime,//?
	kIOUSBLibDeviceUserClientNumCommands,//?
	kUSBInterfaceUserClientSetAsyncPort,//?
	kIOUSBLibInterfaceUserClientNumCommands,//?
};//enum

//////////////

typedef struct IOUSBUserClientAsyncParamBlock IOUSBUserClientAsyncParamBlock;
struct IOUSBUserClientAsyncParamBlock {
	IOMemoryDescriptor* fMem;//c
 	OSAsyncReference64 fAsyncRef;//c
	int fMax;//?
	int fAsyncCount;//?
	IOUSBDevRequestDesc req;//c
};

typedef struct IOUSBInterfaceUserClientISOAsyncParamBlock IOUSBInterfaceUserClientISOAsyncParamBlock;
struct IOUSBInterfaceUserClientISOAsyncParamBlock {
	void*  frameBase;//c
 	IOMemoryDescriptor* countMem;//c
	IOUSBIsocFrame     frames[0];//c
	int frameLen;//c
	IOMemoryDescriptor* dataMem;//c
	OSAsyncReference64 fAsyncRef;//c
	int fAsyncCount;//?
	int numFrames;//?
};
////////////////
class  IOUSBUserClientInit_HYS
{
    OSDeclareDefaultStructors(IOUSBUserClientInit_HYS);

public:

#define IOUSBUserClientInit_MergeDictionaryIntoDictionary \
bool	MergeDictionaryIntoDictionary(OSDictionary *a,  OSDictionary *  b);//?

#define IOUSBUserClientInit_MergeDictionaryIntoProvider \
bool 		MergeDictionaryIntoProvider(IOService * a, OSDictionary * b);//?

#define IOUSBUserClientInit_start \
bool		start(IOService *  a) ;//?

};

#endif//HYS_IOKIT_USB_IOUSBUSERCLIENT_H
