#ifndef HYS_IOKIT_USB_USB_H
#define HYS_IOKIT_USB_USB_H

//hys add
#define USBMakeBMRequestType USBmakebmRequestType
////////

#define mungeMaxPacketSize(a) a//?

/////////////////////////////
#define kUSBDevicePropertyLocationID "kUSBDevicePropertyLocationID"//?
#define kUSBDevicePropertyBusPowerAvailable "kUSBDevicePropertyBusPowerAvailable"//?
#define kUSBDevicePropertyAddress "kUSBDevicePropertyAddress"//?
#define kUSBControllerNeedsContiguousMemoryForIsoch "kUSBControllerNeedsContiguousMemoryForIsoch"//?
#define kUSBDeviceResumeRecoveryTime "kUSBDeviceResumeRecoveryTime"//?
#define kUSBProductIDMask "USBProductIDMask"//?
#define kUSBHubDontAllowLowPower "kUSBHubDontAllowLowPower"//?
#define kUSBSuspendPort "kUSBSuspendPort"//?
#define kUSBPreferredConfiguration "kUSBPreferredConfiguration"//?
#define kUSBExpressCardCantWake "kUSBExpressCardCantWake"//?

//////////////////////////
#define kIOUSBMessagePortHasBeenReset 1//?
#define kIOUSBMessagePortHasBeenResumed 2//?
#define kIOUSBMessageHubResumePort 3//?
#define kIOUSBPipeStalled 4//?
#define kIOUSBNotSent1Err 5//?
#define kIOUSBBufferUnderrunErr 6//?
#define kIOUSBBufferOverrunErr 7//?
#define kIOUSBNotSent2Err 8//?
#define kIOUSBWrongPIDErr 9//?
#define kIOUSBMessageHubIsDeviceConnected 10//?
#define kIOUSBMessagePortWasNotSuspended 11//?
#define kIOUSBMessagePortHasBeenSuspended 12//?
#define kIOUSBTransactionTimeout 13//?
#define kIOUSBInterfaceNotFound 14//?
#define kIOUSBMessageHubSetPortRecoveryTime 15//?
#define kIOUSBConfigNotFound 16//?
#define kIOUSBNotEnoughPowerErr 17//?
#define kIOUSBUnknownPipeErr 18//?
#define kIOUSBMessageHubResetPort 19//?
#define kIOUSBMessageHubReEnumeratePort 20//?
#define kIOUSBMessageHubSuspendPort 21//?
#define kIOUSBNoAsyncPortErr 22//?
#define kIOUSBEndpointNotFound 23//?
#define kIOUSBHighSpeedSplitError 24//?
#define kIOUSBLinkErr 25//?
#define kIOUSBPIDCheckErr 26//?
#define kIOUSBDataToggleErr 27//?
#define kIOUSBBitstufErr 28//?
#define kIOUSBCRCErr 29//?
#define kIOUSBMessageExpressCardCantWake 30//?
#define kIOUSBMessageCompositeDriverReconfigured 31//?
#define kIOUSBLowLatencyBufferNotPreviouslyAllocated 32//?
#define kIOUSBLowLatencyFrameListNotPreviouslyAllocated 33//?
#define kIOUSBTransactionReturned 34//?
#define kIOUSBDeviceNotHighSpeed 35//?
#define kIOUSBMessageHubPortClearTT 36//?
#define kIOUSBReserved1Err 37//?
#define kIOUSBReserved2Err 38//?
#define kIOUSBSyncRequestOnWLThread 39//?
#define kIOUSBNotEnoughPipesErr 40//?
#define kIOUSBTooManyPipesErr 41//?

/////////////
enum {
	kUSBGangOverCurrentNotificationType,//?
	kIOUSBAnyProduct,//?
	kIOUSBAnyVendor,//?
	kIOUSBAnyProtocol,//?
	kIOUSBAnySubClass,//?
	kIOUSBAnyClass,//?
	kUSBLowLatencyIsochTransferKey,//?
	kUSBNotEnoughPowerNotificationType,//?
	kUSBIndividualOverCurrentNotificationType,//?
};
///////////////////////////////////////
struct IOUSBMatch  {
	int usbClass;//?
	int usbSubClass;//?
	int usbProtocol;//?
	int usbVendor;//?
	int usbProduct;//?
};
typedef struct IOUSBMatch IOUSBMatch;

typedef struct LowLatencyUserBufferInfoV2 LowLatencyUserBufferInfoV2;
struct LowLatencyUserBufferInfoV2 {
	LowLatencyUserBufferInfoV2 *nextBuffer;//c
 	void* bufferAddress;//c
	int cookie;//?
	int bufferSize;//?
	int bufferType;//?
	int isPrepared;//?
	void* mappedUHCIAddress;//c
};

struct IOUSBIsocStruct {
	int fPipe;//?
	void* fBuffer;//c
 	int fBufSize;//?
	UInt64 fStartFrame;//c
	UInt32 fNumFrames;//c
	struct IOUSBIsocFrame*  fFrameCounts;//c
};
typedef struct IOUSBIsocStruct IOUSBIsocStruct;

struct IOUSBLowLatencyIsocStruct {
	int fDataBufferCookie;//?
	int fDataBufferOffset;//?
 	int fFrameListBufferCookie;//?
 	int fFrameListBufferOffset;//?
	int fPipe;//?
	int fBufSize;//?
 	int fStartFrame;//?
	int fNumFrames;//?
	int fUpdateFrequency;//?
};
typedef struct IOUSBLowLatencyIsocStruct IOUSBLowLatencyIsocStruct;

///////////////
typedef UInt16 USBDeviceAddress;//c

#endif//HYS_IOKIT_USB_USB_H
