#ifndef HYS_MSC_MSCOBJEC_H
#define HYS_MSC_MSCOBJEC_H

class  MscObject_HYS{

protected:

#define MscObject_getAttributes \
void getAttributes(bool refresh=false);//c

#define MscObject_mInfo \
MscObjectInfo mInfo;//c

#define MscObject_mAttributesLoaded \
mutable bool mAttributesLoaded;//c

#define MscObject_mDataLoaded \
mutable bool mDataLoaded;//c

#define MscObject_mConnection \
MscTokenConnection *mConnection;//c

#define MscObject_mData \
char *mData;//c

public:

#define MscObject_write \
virtual void write(const char *dataToWrite,size_t dataSize);//c

#define MscObject_read \
virtual void read();//c

#define MscObject_deleteobj \
virtual void deleteobj(const char *objectID,bool zeroFlag);//c

#define MscObject_create \
virtual void create(const char *objectID,u_int32_t objectSize,const MscObjectACL& objectACL=MscObjectACL());//c

#define MscObject__MscObject \
virtual ~MscObject();//c

#define  MscObject_MscObject \
MscObject(const char *objectID,MscTokenConnection *connection);//c

#define MscObject_MscObject_const_MSCObjectInfo \
MscObject(const MSCObjectInfo& info,MscTokenConnection *connection);//c

#define MscObject_objid \
 virtual const char *objid() const	{};//c

#define MscObject_data \
virtual const void *data() { };//c

#define MscObject_size \
virtual uint32 size() const	{};//c

};

#endif//HYS_MSC_MSCOBJEC_H
