#ifndef HYS_MSC_MSCTOKENCONNECTION_H
#define HYS_MSC_MSCTOKENCONNECTION_H

class MscTokenConnection_HYS {

protected:

#define MscTokenConnection_mLocalTokenInfo \
MSCTokenInfo mLocalTokenInfo;//c

public://operator

#define MscTokenConnection_operator \
MscTokenConnection &operator = (const MSCTokenConnection &rTokenInfo);//c

public://func

#define MscTokenConnection_generateKeys \
void generateKeys(MSCUChar8 prvKeyNum,MSCUChar8 pubKeyNum, MSCGenKeyParams& params);//c

#define MscTokenConnection_clearReset \
bool clearReset();//c

#define MscTokenConnection_moved \
bool moved();//c

#define MscTokenConnection_extendedFeature \
void extendedFeature(MSCULong32 extFeature,MSCPUChar8 outData,MSCULong32 outLength,MSCPUChar8 inData, MSCPULong32 inLength);//c

#define MscTokenConnection_known \
bool known();//c

#define MscTokenConnection_tokenWasReset \
bool tokenWasReset();//c

#define MscTokenConnection_getChallenge \
void getChallenge(const char *seed,size_t seedSize,const char *randomData,size_t randomDataSize);//c

#define MscTokenConnection_changed \
bool changed();//c

#define MscTokenConnection_getStatus \
void getStatus(MSCStatusInfo& statusInfo);//c

#define MscTokenConnection_getKeyAttributes \
void getKeyAttributes(MSCUChar8 keyNumber,MSCKeyInfo& keyInfo);//c

#define MscTokenConnection_writeFramework \
void writeFramework(const MSCInitTokenParams& initParams);//c

#define MscTokenConnection_selectAID_std_string \
void selectAID(std::string aid);//c

#define MscTokenConnection_selectAID_const_char \
void selectAID(const char *aidValue, MSCULong32 aidSize);//c

#define MscTokenConnection_logoutAll \
void logoutAll();//c

#define MscTokenConnection_endTransaction \
void endTransaction(MSCULong32 endAction=SCARD_LEAVE_CARD);//c

#define MscTokenConnection_beginTransaction \
void beginTransaction();//c

#define MscTokenConnection_getObjectAttributes \
void getObjectAttributes(std::string objectID,MSCObjectInfo& objectInfo);//c

#define MscTokenConnection_listPins \
unsigned int listPins();//c

#define MscTokenConnection_verifyPIN \
void verifyPIN(MSCUChar8 pinNum,std::string pin);//c

#define MscTokenConnection_release \
void release(MSCULong32 endAction=SCARD_LEAVE_CARD);//c

#define MscTokenConnection_connect \
void connect(const char *applicationName=NULL,MSCULong32 sharingMode=MSC_SHARE_SHARED);//c

#define MscTokenConnection_MscTokenConnection \
MscTokenConnection() {};//c

#define  MscTokenConnection_MscTokenConnection_const_MSCTokenInfo \
MscTokenConnection(const MSCTokenInfo &rTokenInfo);//c

#define MscTokenConnection_MscTokenConnection_const_MSCTokenConnection \
MscTokenConnection(const MSCTokenConnection &rTokenConnection);//c

#define MscTokenConnection_getCapabilities \
MSCULong32 getCapabilities(MSCULong32 Tag);//c

};

#endif//HYS_MSC_MSCTOKENCONNECTION_H
