#ifndef HYS_PCSC_MUSCLECARD_H
#define HYS_PCSC_MUSCLECARD_H

#define MSC_TOKEN_EMPTY_STR "MSC_TOKEN_EMPTY_STR"//?
#define MSC_TOKEN_UNKNOWN_STR "MSC_TOKEN_UNKNOWN_STR"//?

//////////////////
#define MSC_MODE_RSA_NOPAD 1//?
#define MSC_SUCCESS 2//?
#define MSC_DIR_SIGN 3//?
#define MSC_MODE_RSA_PAD_PKCS1 4//?
#define MSC_CAPABLE_RSA_NOPAD 5//?
#define MSC_TAG_CAPABLE_RSA 6//?
#define MSC_DIR_DECRYPT 7//?
#define MSC_CAPABLE_RSA_PKCS1 8//?
#define MSC_UNSUPPORTED_FEATURE 9//?
#define MSC_TOKEN_TYPE_RESET 10//?
#define MSC_INTERNAL_ERROR 11//?
#define MSC_SERVICE_UNRESPONSIVE 12//?
#define MSC_UNRECOGNIZED_TOKEN 13//?
#define MSC_TIMEOUT_OCCURRED 14//?
#define MSC_CANCELLED 15//?
#define MSC_TOKEN_REMOVED 16//?
#define MSC_INVALID_PARAMETER 17//?
#define MSC_TOKEN_RESET 18//?
#define MSC_TOKEN_INSERTED 19//?
#define MSC_SHARING_VIOLATION 20//?
#define MSC_INVALID_HANDLE 21//?
#define MSC_TOKEN_TYPE_REMOVED 22//?
#define MSC_SEQUENCE_RESET 23//?
#define MSC_SEQUENCE_NEXT 24//?
#define MSC_GEN_ALG_RSA_CRT 25//?
#define MSC_AUT_NONE 26//?
#define MSC_OPT_DEFAULT 27//?
#define MSC_AUT_ALL 28//?
#define MSC_UNAUTHORIZED 29//?
#define MSC_KEYPOLICY_DIR_SIGN 30//?
#define MSC_KEYPOLICY_DIR_DECRYPT 31//?
#define MSC_KEYPOLICY_MODE_RSA_NOPAD 32//?
#define MSC_KEYPOLICY_DIR_VERIFY 33//?
#define MSC_KEYPOLICY_DIR_ENCRYPT 34//?
#define MSC_KEY_RSA_PUBLIC 35//?
#define MSC_OBJECT_EXISTS 36//?
#define MSC_KEY_DSA_PUBLIC 37//?
#define MSC_AUT_PIN_0 38//?
#define MSC_KEY_3DES 39//?
#define MSC_BLOB_ENC_PLAIN 40//?
#define MSC_KEY_RSA_PRIVATE 41//?
#define MSC_KEY_RSA_PRIVATE_CRT 42//?
#define MSC_KEY_3DES3 43//?
#define MSC_AUT_PIN_1 44//?
#define MSC_KEY_DSA_PRIVATE 45//?
#define MSC_KEY_DES 46//?
#define MSC_AUT_PIN_2 47//?
#define MSC_AUT_PIN_3 48//?
#define MSC_AUT_PIN_4 49//?
#define MSC_UNSPECIFIED_ERROR 50//?
#define MSC_SUPPORT_COMPUTECRYPT 51//?
#define MSC_SUPPORT_RSA 52//?
#define MSC_SUPPORT_GETCHALLENGE 53//?
#define MSC_TAG_SUPPORT_CRYPTOALG 54//?
#define MSC_CAPABLE_RSA_1024 55//?
#define MSC_SUPPORT_LISTKEYS 56//?
#define MSC_TAG_CAPABLE_OBJ_AUTH 57//?
#define MSC_CAPABLE_PIN_NONALPHA 58//?
#define MSC_SUPPORT_CHANGEPIN 59//?
#define MSC_TAG_CAPABLE_PIN_ATTR 60//?
#define MSC_TAG_CAPABLE_OBJ_ATTR 61//?
#define MSC_TAG_CAPABLE_PIN_MAXNUM 62//?
#define MSC_TAG_CAPABLE_OBJ_MAXNUM 63//?
#define MSC_TAG_CAPABLE_PIN_MINSIZE 64//?
#define MSC_TAG_CAPABLE_PIN_MAXSIZE 65//?
#define MSC_TAG_CAPABLE_PIN_CHARSET 66//?
#define MSC_CAPABLE_PIN_A_Z 67//?
#define MSC_CAPABLE_PIN_a_z 68//?
#define MSC_TAG_CAPABLE_ID_STATE 69//?
#define MSC_TAG_SUPPORT_FUNCTIONS 70//?
#define MSC_TAG_CAPABLE_PIN_POLICY 71//?
#define MSC_TAG_CAPABLE_RANDOM_MIN 72//?
#define MSC_TAG_CAPABLE_RANDOM_MAX 73//?
#define MSC_TAG_CAPABLE_PIN_AUTH 74//?
#define MSC_TAG_CAPABLE_KEY_AUTH 75//?
#define MSC_TAG_CAPABLE_OBJ_IDSIZE 76//?
#define MSC_DIR_ENCRYPT 77//?
#define MSC_NO_MEMORY_LEFT 78//?
#define MSC_AUTH_FAILED 79//?
#define MSC_SUPPORT_VERIFYPIN 80//?
#define MSC_SUPPORT_LISTOBJECTS 81//?
#define MSC_OBJECT_NOT_FOUND 82//?
#define MSC_INCORRECT_ALG 83//?
#define MSC_IDENTITY_BLOCKED 84//?
#define MSC_SEQUENCE_END 85//?
#define MSC_CAPABLE_PIN_CALC 86//?
#define MSC_CAPABLE_PIN_0_9 87//?
#define MSC_SUPPORT_READOBJECT 88//?
#define MSC_SUPPORT_LISTPINS 89//?
#define MSC_MAX_KEYS 90//?
#define MSC_PERCENT_STEPSIZE 91//?
#define MSC_SIZEOF_KEYPACKET 92//?
#define MSC_TRANSPORT_ERROR 93//?
#define MSC_SIGNATURE_INVALID 94//?
#define MSC_INCONSISTENT_STATUS 95//?
#define MSC_SUPPORT_LOGOUTALL 96//?
#define MSC_CAPABLE_PIN_RESET 97//?
#define MSC_INIT_IGNORE_KEY 98//?
#define MSC_CAPABLE_RSA_KEYGEN 99//?
#define MSC_OPERATION_NOT_ALLOWED 100//?
#define MSC_INIT_USE_KEY 101//?
#define MSC_SUPPORT_IMPORTKEY 102//?
#define MSC_INIT_DEFAULT_KEY 103//?
#define MSC_SUPPORT_CREATEOBJECT 104//?
#define MSC_MODE_DES_ECB_NOPAD 105//?
#define MSC_SUPPORT_GENKEYS 106//?
#define MSC_SUPPORT_UNBLOCKPIN 107//?
#define MSC_SUPPORT_DELETEOBJECT 108//?
#define MSC_SUPPORT_EXPORTKEY 109//?
#define MSC_SUPPORT_WRITEOBJECT 110//?
#define MSC_SUPPORT_DSA 111//?
#define MSC_TAG_CAPABLE_DSA 112//?
#define MSC_CAPABLE_DSA_KEYGEN 113//?
#define MSC_CAPABLE_RSA_768 114//?
#define MSC_SUPPORT_IDEA 115//?
#define MSC_SUPPORT_ELGAMAL 116//?
#define MSC_CAPABLE_RSA_512 117//?
#define MSC_SUPPORT_DES 118//?
#define MSC_LIST_SLOTS 119//?
#define MSC_SUPPORT_TWOFISH 120//?
#define MSC_SUPPORT_BLOWFISH 121//?
#define MSC_CAPABLE_RSA_4096 122//?
#define MSC_CAPABLE_RSA_2048 123//?
#define MSC_SUPPORT_3DES 124//?
#define MSC_STATE_UNAWARE 125//?
#define MSC_SUPPORT_AES 126//?
#define MSC_SUPPORT_EXTAUTH 127//?
#define MSC_SUPPORT_CREATEPIN 128//?
#define MSC_MAXSIZEOF_APDU_DATALEN 129//?
#define MSC_ZF_WRITE_ZERO 130//?
#define MSC_CIPHER_INIT 131//?
#define MSC_KEYPOLICY_MODE_DES_ECB_NOPAD 132//?
#define MSC_CIPHER_PROCESS 133//?
#define MSC_CIPHER_FINAL 134//?
#define MSC_CAPABLE_ID_STATE 135//?
#define MSC_CAPABLE_PIN_LEAVE 136//?
#define MSC_CAPABLE_OBJ_ZERO 137//?
#define MSC_TAG_CAPABLE_3DES 138//?
#define MSC_CAPABLE_DES_ECB 139//?
#define MSC_TAG_CAPABLE_DES 140//?
#define MSC_LIST_KNOWN 141//?
#define MSC_LIST_ALL 142//?
#define MSC_TOKEN_TYPE_KNOWN 143//?
#define MSC_TOKEN_TYPE_UNKNOWN 144//?
#define MSC_INSUFFICIENT_BUFFER 145//?
#define MSC_MAXSIZE_TOKENARRAY 146//?
#define MSC_TOKEN_UNRESPONSIVE 147//?
#define MSC_ZF_DEFAULT 148//?
#define MSC_INCORRECT_P1 149//?
#define MSC_INCORRECT_P2 150//?

/////////////
#define MSC_LEAVE_TOKEN    SCARD_LEAVE_CARD//c
#define MSC_RESET_TOKEN    SCARD_RESET_CARD//c
#define MSC_STATE_CHANGED      SCARD_STATE_CHANGED//c
#define MSC_SHARE_SHARED     SCARD_SHARE_SHARED//c
#define MSC_SHARE_DIRECT     SCARD_SHARE_DIRECT//c
#define MSC_STATE_EMPTY        SCARD_STATE_EMPTY//c
#define MSC_STATE_PRESENT      SCARD_STATE_PRESENT//c
#define MSC_NO_TIMEOUT         INFINITE//c

////////////

struct MSCObjectACL {
	MSCUShort16 readPermission;//c
	MSCUShort16 writePermission;//c
	MSCUShort16 deletePermission;//c
};
typedef struct MSCObjectACL  MSCObjectACL;
typedef MSCObjectACL *MSCLPObjectACL;

struct MSCObjectInfo {
	MSCChar8 objectID[MSC_MAXSIZE_OBJID];//c
	MSCULong32 objectSize;//c
	MSCObjectACL objectACL;//c
};
typedef struct MSCObjectInfo MSCObjectInfo;
typedef MSCObjectInfo *MSCLPObjectInfo;

struct MSCKeyPolicy {
	MSCUShort16 cipherDirection;//c
	MSCUShort16 cipherMode;//c
};
typedef struct MSCKeyPolicy MSCKeyPolicy;
typedef MSCKeyPolicy *MSCLPKeyPolicy;

struct MSCKeyACL {
	MSCUShort16 readPermission;//c
	MSCUShort16 writePermission;//c
	MSCUShort16 usePermission;//c
};
typedef struct MSCKeyACL MSCKeyACL;
typedef MSCKeyACL *MSCLPKeyACL;

struct MSCKeyInfo {
	MSCUShort16 keySize;//c
	MSCUChar8 keyNum;//c
	MSCUChar8 keyType;//c
	MSCKeyPolicy keyPolicy;//c
	MSCKeyACL keyACL;//c
	MSCUChar8 keyPartner;//c
 	MSCUChar8 keyMapping;//c
};
typedef struct MSCKeyInfo MSCKeyInfo;
typedef MSCKeyInfo *MSCLPKeyInfo;

struct MSCStatusInfo {
	MSCUShort16 appVersion;//c
	MSCUShort16 swVersion;	//c
	MSCULong32 freeMemory;//c
	MSCULong32 totalMemory;//c
	MSCUChar8 usedPINs;//c
	MSCUChar8 usedKeys;//c
	MSCUShort16 loggedID;//c
};
typedef struct MSCStatusInfo MSCStatusInfo;
typedef MSCStatusInfo *MSCLPStatusInfo;

struct MSCInitTokenParams{
	MSCUChar8  transportBehavior;//c
	MSCULong32 transportKeyLen;//c
	MSCUChar8 transportKey[MAX_BUFFER_SIZE];//c
	MSCULong32 objectMemory;//c
	MSCUChar8  defaultCHV[MAX_BUFFER_SIZE];//c
	MSCUChar8  defaultCHVUnblock[MAX_BUFFER_SIZE];//c
	MSCULong32 newTransportKeyLen;//c
	MSCUChar8  newTransportKey[MAX_BUFFER_SIZE];//c
	MSCUChar8  defaultCHVTries;//c
	MSCUChar8  defaultCHVUnblockTries;//c
	MSCULong32 defaultCHVLen;//c
	MSCULong32 defaultCHVUnblockSize;//c
};
typedef struct MSCInitTokenParams MSCInitTokenParams;
typedef MSCInitTokenParams *MSCLPInitTokenParams;

struct MSCGenKeyParams {
	MSCUChar8 algoType;//c
	MSCUShort16 keySize;//c
	MSCKeyACL privateKeyACL;//c
	MSCKeyACL publicKeyACL;//c
	MSCKeyPolicy privateKeyPolicy;//c
	MSCKeyPolicy publicKeyPolicy;//c
	MSCUChar8 keyGenOptions;//c
	MSCPUChar8 pOptParams;//c
	MSCULong32 optParamsSize;//c
};
typedef struct MSCGenKeyParams MSCGenKeyParams;
typedef MSCGenKeyParams *MSCLPGenKeyParams;

struct MSCCryptInit  {
	MSCUChar8 keyNum;//c
	MSCUChar8 cipherMode;//c
	MSCUChar8 cipherDirection;//c
	MSCPUChar8 optParams;//c
	MSCUShort16 optParamsSize;//c
};
typedef struct MSCCryptInit  MSCCryptInit;
typedef MSCCryptInit *MSCLPCryptInit;

////////////
char *msc_error(unsigned long int errorCode);//c

MSC_RV MSCImportKey(MSCLPTokenConnection pConnection,
		MSCUChar8 keyNum,
		MSCLPKeyACL pKeyACL,
		MSCPUChar8 pKeyBlob,
		MSCULong32 keyBlobSize,
		MSCLPKeyPolicy keyPolicy,
		MSCPVoid32 pAddParams, MSCUChar8 addParamsSize);//c

MSC_RV MSCExportKey(MSCLPTokenConnection pConnection,
		MSCUChar8 keyNum,
		MSCPUChar8 pKeyBlob,
		MSCPULong32 keyBlobSize,
		MSCPVoid32 pAddParams, MSCUChar8 addParamsSize);//c

MSC_RV MSCExtAuthenticate(MSCLPTokenConnection pConnection,
				  MSCUChar8 keyNum,
				  MSCUChar8 cipherMode,
				  MSCUChar8 cipherDirection, 
				  MSCPUChar8 pData, 
				  MSCULong32 dataSize);//c

MSC_RV MSCComputeCrypt(MSCLPTokenConnection pConnection,
		MSCLPCryptInit cryptInit,
		MSCPUChar8 pInputData,
		MSCULong32 inputDataSize,
		MSCPUChar8 pOutputData, MSCPULong32 outputDataSize);//c

MSC_RV MSCCreateObject(MSCLPTokenConnection pConnection,
		MSCString objectID,
		MSCULong32 objectSize, MSCLPObjectACL pObjectACL);//c

MSC_RV MSCDeleteObject(MSCLPTokenConnection pConnection,
		MSCString objectID, MSCUChar8 zeroFlag);//c

MSC_RV MSCWriteObject(MSCLPTokenConnection pConnection,
		MSCString objectID, MSCULong32 offset, 
		MSCPUChar8 pInputData, MSCULong32 dataSize,
		LPRWEventCallback rwCallback, MSCPVoid32 addParams);//c

MSC_RV MSCReadAllocateObject(MSCLPTokenConnection pConnection,
		MSCString objectID, MSCPUChar8 *pOutputData, 
                MSCPULong32 dataSize,
                LPRWEventCallback rwCallback, MSCPVoid32 addParams);//c

MSC_RV MSCCreatePIN(MSCLPTokenConnection pConnection,
			    MSCUChar8 pinNum,
			    MSCUChar8 pinAttempts,
			    MSCPUChar8 pPinCode,
			    MSCULong32 pinCodeSize,
			    MSCPUChar8 pUnblockCode, 
			    MSCUChar8 unblockCodeSize);//c

MSC_RV MSCListPINs(MSCLPTokenConnection pConnection,
		MSCPUShort16 pPinBitMask);//c

MSC_RV MSCUnblockPIN(MSCLPTokenConnection pConnection,
		MSCUChar8 pinNum,
		MSCPUChar8 pUnblockCode, MSCULong32 unblockCodeSize);//c

MSC_RV MSCChangePIN(MSCLPTokenConnection pConnection,
		MSCUChar8 pinNum,
		MSCPUChar8 pOldPinCode,
		MSCUChar8 oldPinCodeSize,
		MSCPUChar8 pNewPinCode, MSCUChar8 newPinCodeSize);//c

MSC_RV MSCListObjects(MSCLPTokenConnection pConnection,
		MSCUChar8 seqOption, MSCLPObjectInfo pObjectInfo);//c

MSC_RV MSCListKeys(MSCLPTokenConnection pConnection,
			   MSCUChar8 seqOption, 
			   MSCLPKeyInfo pKeyInfo);//c

MSC_RV MSCReleaseConnection(MSCLPTokenConnection pConnection,
			MSCULong32 endAction	
		);//c

MSC_RV MSCEstablishConnection(MSCLPTokenInfo tokenStruct,	
		MSCULong32 sharingMode,
		MSCPUChar8 applicationName,	
		MSCULong32 nameSize,	
		MSCLPTokenConnection pConnection	
		);//c

MSC_RV MSCGetChallenge(MSCLPTokenConnection pConnection,
		MSCPUChar8 pSeed,
		MSCUShort16 seedSize,
		MSCPUChar8 pRandomData, MSCUShort16 randomDataSize);//c

MSC_RV MSCWriteFramework(MSCLPTokenConnection pConnection,
		MSCLPInitTokenParams pInitParams);//c

MSC_RV MSCEndTransaction(MSCLPTokenConnection pConnection,
					MSCULong32 endAction	
		);//c

MSC_RV MSCGetKeyAttributes(MSCLPTokenConnection pConnection,
				   MSCUChar8 keyNumber, 
				   MSCLPKeyInfo pKeyInfo);//c

MSC_RV MSCBeginTransaction(MSCLPTokenConnection pConnection	);//c
MSC_RV MSCLogoutAll(MSCLPTokenConnection pConnection);//c

MSC_RV MSCVerifyPIN(MSCLPTokenConnection pConnection,
			    MSCUChar8 pinNum, 
			    MSCPUChar8 pPinCode, 
			    MSCULong32 pinCodeSize);//c

MSC_RV MSCGetObjectAttributes(MSCLPTokenConnection pConnection,
				      MSCString objectID, 
				      MSCLPObjectInfo pObjectInfo);//c

MSCUChar8 MSCIsTokenKnown(MSCLPTokenConnection pConnection);//c

MSC_RV MSCGetCapabilities(MSCLPTokenConnection pConnection,
		MSCULong32 Tag, MSCPUChar8 Value, MSCPULong32 Length);//c

MSC_RV MSCGenerateKeys(MSCLPTokenConnection pConnection,
		MSCUChar8 prvKeyNum,
		MSCUChar8 pubKeyNum, MSCLPGenKeyParams pParams);//c

MSC_RV MSCGetStatus(MSCLPTokenConnection pConnection,
		MSCLPStatusInfo pStatusInfo);//c

MSC_RV MSCExtendedFeature(MSCLPTokenConnection pConnection,
		MSCULong32 extFeature,
		MSCPUChar8 outData,
		MSCULong32 outLength, MSCPUChar8 inData, MSCPULong32 inLength);//c

MSCUChar8 MSCIsTokenReset(MSCLPTokenConnection pConnection);//c
MSCUChar8 MSCClearReset(MSCLPTokenConnection pConnection);//c
MSCUChar8 MSCIsTokenChanged(MSCLPTokenConnection pConnection);//c
MSCUChar8 MSCIsTokenMoved(MSCLPTokenConnection pConnection);//c

#endif//HYS_PCSC_MUSCLECARD_H
