#ifndef HYS_PCSC_PCSCLITE_H
#define HYS_PCSC_PCSCLITE_H

////////////
#define SCARD_PCI_T0	(&g_rgSCardT0Pci) //c
#define SCARD_PCI_T1	(&g_rgSCardT1Pci)//c
#define SCARD_PCI_RAW	(&g_rgSCardRawPci)//c
////////////////

#define PCSCLITE_PUBSHM_FILE	"PCSCLITE_PUBSHM_FILE"//?
#define PCSCLITE_CSOCK_NAME "PCSCLITE_CSOCK_NAME"//?
#define PCSCLITE_VERSION_NUMBER "PCSCLITE_VERSION_NUMBER"//?
#define PCSCLITE_IPC_DIR "PCSCLITE_IPC_DIR"//?
#define PCSCLITE_READER_CONFIG "PCSCLITE_READER_CONFIG"//?

//////////////////
#define SCARD_E_CANCELLED	 0x80100002//c
#define SCARD_E_INVALID_ATR 0x80100015//c
#define SCARD_E_INVALID_HANDLE	0x80100003//c
#define SCARD_E_UNKNOWN_READER		0x80100009//c
#define SCARD_E_TIMEOUT			0x8010000A//c
#define SCARD_E_SHARING_VIOLATION	0x8010000B//c
#define SCARD_E_NO_SMARTCARD		0x8010000C//c
#define SCARD_E_UNKNOWN_CARD		0x8010000D//c
#define SCARD_E_PROTO_MISMATCH		0x8010000F//c
#define SCARD_E_READER_UNAVAILABLE	0x80100017//c
#define SCARD_W_RESET_CARD		0x80100068//c
#define SCARD_E_PCI_TOO_SMALL		0x80100019//c
#define SCARD_E_NO_SERVICE		0x8010001D//c

//////////////
#define MAX_READERNAME 1//?
#define MAX_ATR_SIZE 2//?
#define MAX_BUFFER_SIZE 3//?
#define SCARD_LEAVE_CARD 4//?
#define SCARD_RESET_CARD 5//?
#define SCARD_E_UNSUPPORTED_FEATURE 6//?
#define SCARD_S_SUCCESS 7//?
#define SCARD_W_REMOVED_CARD 8//?
#define SCARD_E_CARD_UNSUPPORTED 10//?
#define SCARD_W_INSERTED_CARD 11//?
#define SCARD_E_INVALID_VALUE 22//?
#define SCARD_E_INVALID_PARAMETER 23//?
#define SCARD_W_UNSUPPORTED_CARD 24//?
#define SCARD_PROTOCOL_T1 25//?
#define SCARD_PROTOCOL_T0 26//?
#define SCARD_STATE_CHANGED 27//?
#define SCARD_SHARE_SHARED 28//?
#define MAX_LIBNAME 29//?
#define MAX_DEVICENAME 30//?
#define PCSCLITE_MAX_READER_CONTEXT_CHANNELS 31//?
#define PCSCLITE_MAX_CONTEXTS 32//?
#define SCARD_F_UNKNOWN_ERROR 33//?
#define SCARD_F_INTERNAL_ERROR 34//?
#define SCARD_UNKNOWN 35//?
#define SCARD_SWALLOWED 36//?
#define SCARD_ABSENT 37//?
#define SCARD_PRESENT 38//?
#define SCARD_SPECIFIC 39//?
#define SCARD_REMOVED 40//?
#define SCARD_E_NO_MEMORY 41//?
#define SCARD_NEGOTIABLE 42//?
#define SCARD_POWERED 43//?
#define PCSCLITE_STATUS_WAIT 44//?
#define PCSCLITE_STATUS_POLL_RATE 45//?
#define SCARD_PROTOCOL_RAW 46//?
#define SCARD_SCOPE_USER 47//?
#define SCARD_SCOPE_TERMINAL 48//?
#define SCARD_SCOPE_SYSTEM 49//?
#define SCARD_SCOPE_GLOBAL 50//?
#define PCSCLITE_SVC_IDENTITY 51//?
#define SCARD_SHARE_EXCLUSIVE 52//?
#define SCARD_SHARE_DIRECT 53//?
#define SCARD_W_UNPOWERED_CARD 54//?
#define SCARD_PROTOCOL_UNSET 55//?
#define SCARD_W_UNRESPONSIVE_CARD 56//?
#define SCARD_UNPOWER_CARD 57//?
#define SCARD_EJECT_CARD 58//?
#define SCARD_E_INSUFFICIENT_BUFFER 59//?
#define SCARD_E_NOT_TRANSACTED 60//?
#define SCARD_RESET 61//?

#ifndef INFINITE
#define INFINITE 62//?
#endif

#define SCARD_STATE_EMPTY 63//?
#define PCSCLITE_MAX_READERS_CONTEXTS 64//?
#define BLOCK_STATUS_RESUME 65//?
#define SCARD_E_INVALID_TARGET 66//?
#define SCARD_E_DUPLICATE_READER 67//?
#define PCSCLITE_MSG_KEY_LEN 68//?
#define PCSCLITE_MCLIENT_ATTEMPTS 69//?
#define PCSCLITE_CLIENT_ATTEMPTS 70//?
#define SCARD_F_COMM_ERROR 71//?
#define PCSCLITE_MAX_APPLICATION_CONTEXT_CHANNELS 72//?
#define PCSCLITE_MAX_MESSAGE_SIZE 73//?
#define PCSCLITE_MAX_APPLICATION_CONTEXTS 74//?
#define MAX_BUFFER_SIZE_EXTENDED 75//?
#define BLOCK_STATUS_BLOCKING 76//?
#define SCARD_STATE_UNKNOWN 77//?
#define SCARD_STATE_EXCLUSIVE 78//?
#define SCARD_STATE_UNAVAILABLE 79//?
#define SCARD_STATE_ATRMATCH 80//?
#define SCARD_STATE_IGNORE 81//?
#define SCARD_STATE_INUSE 82//?
#define SCARD_STATE_MUTE 83//?
#define SCARD_STATE_PRESENT 84//?
#define SCARD_STATE_UNAWARE 85//?
#define SCARD_E_SYSTEM_CANCELLED 86//?
#define PCSCLITE_SERVER_ATTEMPTS 87//?
#define SCARD_E_CANT_DISPOSE 88//?
#define SCARD_E_SERVICE_STOPPED 89//?
#define SCARD_F_WAITED_TOO_LONG 90//?
#define SCARD_E_READER_UNSUPPORTED 91//?
#define SCARD_E_NOT_READY 92//?
#define PCSCLITE_MAX_APPLICATIONS 95//?

///////////////
#define SCARD_PROTOCOL_ANY		(SCARD_PROTOCOL_T0|SCARD_PROTOCOL_T1)//c
#define PCSCLITE_MAX_APPLICATIONS_CONTEXTS \
	PCSCLITE_MAX_APPLICATIONS * PCSCLITE_MAX_APPLICATION_CONTEXTS//c

//////////////

typedef int32_t SCARDHANDLE;//c
typedef int32_t SCARDCONTEXT;//c
typedef SCARDHANDLE *LPSCARDHANDLE;//c
typedef SCARDCONTEXT *LPSCARDCONTEXT;//c
//////////
struct SCARD_READERSTATE_A {
	const char *szReader;//c
	uint32_t dwCurrentState;//c
	uint32_t cbAtr;//c
	unsigned char rgbAtr[MAX_ATR_SIZE];//c
	uint32_t dwEventState;//c
};
typedef struct SCARD_READERSTATE_A SCARD_READERSTATE_A;
typedef SCARD_READERSTATE_A SCARD_READERSTATE;//c
typedef SCARD_READERSTATE_A *LPSCARD_READERSTATE_A;//c
typedef SCARD_READERSTATE_A  *PSCARD_READERSTATE_A;//c

struct _SCARD_IO_REQUEST {
	uint32_t cbPciLength;//c
	uint32_t dwProtocol;//c
};
typedef struct  _SCARD_IO_REQUEST SCARD_IO_REQUEST;
typedef SCARD_IO_REQUEST  *LPSCARD_IO_REQUEST;
typedef const SCARD_IO_REQUEST *LPCSCARD_IO_REQUEST;//c

////////////////////

extern SCARD_IO_REQUEST g_rgSCardT0Pci;//c
extern SCARD_IO_REQUEST g_rgSCardT1Pci;//c
extern SCARD_IO_REQUEST g_rgSCardRawPci;//c
char *pcsc_stringify_error(int32_t err);//c

#endif//HYS_PCSC_PCSCLITE_H
