#ifndef HYS_PCSC_THREAD_GENERIC_H
#define HYS_PCSC_THREAD_GENERIC_H

#define THREAD_ATTR_DETACHED 1//?
#define THREAD_ATTR_DEFAULT 2//?

///////////////////////////
#ifdef WIN32
	#define PCSCLITE_THREAD_T                HANDLE//c
	#define PCSCLITE_MUTEX_T                 CRITICAL_SECTION*//c
	#define PCSCLITE_MUTEX                   CRITICAL_SECTION//c
	#define PCSCLITE_THREAD_FUNCTION(f)      void *(*f)(void *)//c
#else//WIN32
	#define PCSCLITE_THREAD_T                pthread_t//c
	#define PCSCLITE_MUTEX_T                 pthread_mutex_t*//c
	#define PCSCLITE_MUTEX                   pthread_mutex_t//c
	#define PCSCLITE_THREAD_FUNCTION(f)      void *(*f)(void *)//c
#endif//WIN32
//////////////////


#endif//HYS_PCSC_THREAD_GENERIC_H
