#ifndef HYS_QUICKTIME_MOVIES_H
#define HYS_QUICKTIME_MOVIES_H

#define MCGetMovie(a) MCGetIndMovie(a, 0)//c
#define FindNextText  TextMediaFindNextText //c
#define HiliteTextSample  TextMediaHiliteTextSample//c

enum {
	movieProgressOpen ,//?
	movieProgressUpdatePercent ,//?
	movieProgressClose ,//?
	MovieFileType ,//?
	kParentAtomIsContainer ,//?
	nextTimeMediaSample ,//?
	nextTimeEdgeOK ,//?
	kUserDataTextFullName,//?
	kQTPropertyClass_SoundDescription,//?
	kQTMovieAudioExtractionComplete,//?
	kQTPropertyClass_MovieAudioExtraction_Audio,//?
	kQTMovieAudioExtractionAudioPropertyID_AudioChannelLayout,//?
	kQTMovieAudioExtractionAudioPropertyID_AudioStreamBasicDescription,//?
	kQTPropertyClass_MovieAudioExtraction_Movie,//?
	kQTMetaDataItemUninitialized,//?
	kPropertyClass_MetaDataItem,//?
	kMCIsPlayerEventSelect,//?
};

//AlwaysPreview-mportScrapbook.c
struct SampleDescription {
	int descSize;//?
	int dataFormat;//?
	int resvd1;//?
	int resvd2;//?
	int dataRefIndex;//?
};
typedef struct SampleDescription SampleDescription;

struct TextDescription_defaultstyle {//?
	int scrpFont;//?
};

struct TextDescription{
	int displayFlags;//?
	int defaultFontName[1];//?
	int size;//
	Rect defaultTextBox;//?//BurntTextSampleCode-ConvertTextMovie.c
	struct TextDescription_defaultstyle defaultStyle;//?
};
typedef struct TextDescription TextDescription;

struct SoundDescription {
	int sampleRate;//?
	int descSize;//?
	int dataFormat;//?
	int dataRefIndex;//?
	int numChannels;//?
	int sampleSize;//?
};
typedef struct SoundDescription SoundDescription;

struct ModifierTrackGraphicsModeRecord {
	int graphicsMode;//?
	RGBColor opColor;//c
};
typedef struct ModifierTrackGraphicsModeRecord ModifierTrackGraphicsModeRecord;

typedef int QTPropertyClass;//?
typedef int QTPropertyID;//?
typedef int QTPropertyValuePtr;//?
typedef int MovieProgressProcPtr;//?
typedef int MovieAudioExtractionRef;//?
typedef int ConstQTPropertyValuePtr;//?
typedef int QTPropertyValueType;//?
typedef int QTPathStyle;//?
typedef int QTSoundDescriptionKind;//?
typedef int UserData;//?
typedef int QTMetaDataRef;//?
typedef int QTMetaDataItem;//?
typedef int QTMetaDataStorageFormat;//?
typedef int QTMetaDataKeyFormat;//?
typedef int QTMutableSampleTableRef;//?
typedef int QTSampleTableRef;//?
typedef int QTSampleDescriptionID;//?
typedef int QTTrackPropertyListenerUPP;//?
typedef int QTMoviePropertyListenerUPP;//?
typedef int QTAudioContextRef;//?
typedef int FlashDescriptionHandle;//?

#endif//HYS_QUICKTIME_MOVIES_H
