#ifndef HYS_SECURITY_CERTEXTEBNSIONS_H
#define HYS_SECURITY_CERTEXTEBNSIONS_H

#define CE_KU_DigitalSignature 1//?
#define CE_KU_NonRepudiation 2//?
#define CE_KU_KeyEncipherment 3//?
///////////
enum CE_GeneralNameType  {
	GNT_RFC822Name,//?
	GNT_OtherName,//?
};
typedef enum CE_GeneralNameType CE_GeneralNameType;

///////////////////

typedef uint16 CE_KeyUsage;//c
///////////

struct CE_GeneralName {
	CE_GeneralNameType		nameType;//c
	CSSM_DATA				name;//c
};
typedef struct CE_GeneralName CE_GeneralName;

struct CE_OtherName {
	CSSM_OID				typeId;//c
	CSSM_DATA				value;//c
};
typedef struct CE_OtherName CE_OtherName;

struct CE_GeneralNames {
	uint32					numNames;//c
	CE_GeneralName			*generalName;	//c
};
typedef struct CE_GeneralNames CE_GeneralNames;

#endif//HYS_SECURITY_CERTEXTEBNSIONS_H
