#ifndef HYS_SYSTEMCONFIGURATION_SCDPLUGIN_H
#define HYS_SYSTEMCONFIGURATION_SCDPLUGIN_H

#define kSCBundleIsBuiltinKey		CFSTR("Builtin")//c
#define kSCBundleEnabledKey		CFSTR("Enabled")//c
#define kSCBundleVerboseKey		CFSTR("Verbose")//c
#define kSCBundleRequiresKey		CFSTR("Requires")//c

//////////////
typedef void	(*SCDPluginExecCallBack)		(pid_t		pid,
							 int		status,
							 struct rusage	*rusage,
							 void		*context);//c

typedef	void	(*SCDPluginExecSetup)			(pid_t		pid,
							 void		*setupContext);//c

typedef void	(*SCDynamicStoreBundleLoadFunction)	(CFBundleRef	bundle,
							 Boolean	bundleVerbose);//c

typedef void	(*SCDynamicStoreBundleStartFunction)	(const char	*bundleName,
							 const char	*bundlePath);//c

typedef void	(*SCDynamicStoreBundlePrimeFunction)	(void);//c
typedef void	(*SCDynamicStoreBundleStopFunction)	(CFRunLoopSourceRef	stopRls);//c

#endif//HYS_SYSTEMCONFIGURATION_SCDPLUGIN_H
