#ifndef HYS_SYSTEMCONFIGURATION_SCSCHEMADEFINITIONS_H
#define HYS_SYSTEMCONFIGURATION_SCSCHEMADEFINITIONS_H

#if MAC_OS_X_VERSION_MIN_REQUIRED <= 1020
  #ifndef SCSTR
    #include <CoreFoundation/CFString.h>
    #define SCSTR(s) CFSTR(s)
  #endif
  #ifndef SC_SCHEMA_DECLARATION
    #define SC_SCHEMA_DECLARATION(k,q)	extern const CFStringRef k q;
  #endif
  #ifndef SC_SCHEMA_KV
    #define SC_SCHEMA_KV(k,v,t)	SCSTR( v )
  #endif
#endif//c

#ifndef SC_SCHEMA_KV
  #define SC_SCHEMA_KV(k,v,t)	k
#endif//c

#ifndef SC_SCHEMA_DECLARATION
  #ifndef SCSTR
    #include <CoreFoundation/CFString.h>
    #define SC_SCHEMA_DECLARATION(k,q)	extern const CFStringRef k q;
  #else
    #import <Foundation/NSString.h>
    #define SC_SCHEMA_DECLARATION(k,q)	extern NSString * k q;
  #endif
#endif
#if (MAC_OS_X_VERSION_MIN_REQUIRED >= 1010) && (MAC_OS_X_VERSION_MAX_ALLOWED <= 1040)
  #ifndef SCSTR
    #include <CoreFoundation/CFString.h>
    #define SCSTR(s) CFSTR(s)
  #endif
#endif//c
/////////////////

#endif//HYS_SYSTEMCONFIGURATION_SCSCHEMADEFINITIONS_H
