#ifndef HYS_GNU_SYMSEG_H
#define HYS_GNU_SYMSEG_H

#define MACH_ROOT_FORMAT 1//?
/////////////////

enum language {language_c};//c

struct mach_root {
  	int format;//c
  	int length;//c
  	int ldsymoff;//c
  	char *filename;//c
  	struct loadmap *loadmap;//c
  	char *filedir;//c
  	struct blockvector *blockvector; //c
  	struct typevector *typevector; //c
  	enum language language;//c
  	char *version;//c
  	char *compilation;	//c
  	struct sourcevector *sourcevector; //c
};

struct symbol_root {
  	int length;//c
  	int ldsymoff;//c
  	char *filename;//c
  	char *filedir;	//c
  	struct blockvector *blockvector;//c
  	struct typevector *typevector;//c
  	enum language language;//c
  	char *version;//c
  	char *compilation;	//c
  	struct sourcevector *sourcevector; //c
};

#endif//HYS_GNU_SYMSEG_H
