#ifndef HYS_HYS_H
#define HYS_HYS_H

#ifndef __private_extern__
#define __private_extern__ 
#endif

#ifdef __CYGWIN__

//#include <mingw/_mingw.h>
#ifdef __THROW
	#undef __THROW
#endif
	
#define __THROW __MINGW_NOTHROW

#include <ansidecl.h>
#define __nonnull ATTRIBUTE_NONNULL


#endif//__CYGWIN__
//////////////////////////////////////

////AppleMacRISC4PE-MacRISC4CPU.cpp
//AppleMacRISC2PE/AppleMacRISC2PE-161.2.2/UniN.h
#define kUniNNormal                (0x00)
#define kUniNIdle2                 (0x01)
#define kUniNSleep                 (0x02)
#define kUniNSave                  (0x03)
#define kUniNVersion               (0x0000)
#define kUniNHWInitState           (0x0070)
#define kUniNHWInitStateRunning    (0x02)

 #define kUniNRevision3_2_1 0x0032
#define kUniNVersion3			   (0x0030)
#define kU3ToggleRegister 0x00e0
#define kU3MPICEnableOutputs 0x0004
#define kU3MPICReset 0x0002
#define kU3DARTCntlRegister 0x94
#define kU3PMClockControl 0x0020
#define kUniNVSPSoftReset			(0x170)
#define kUniNHWInitStateSleeping   (0x01)
#define kU3HTLinkFreqRegister 0x120
#define kU3HTLinkConfigRegister 0x110
#define IS_U3_HEAVY(x)					false
#define kU3APIPhyConfigRegister1 0x23030

#define IS_U4(a) a//??
#define kU3DARTExcpXBEMask  1//?
#define kU4APIMask1Register 2//?
#define kU3ChipFaultMaskRegister 3//?
#define kU4APIExceptionRegister 4//?
#define kU3APIExceptionRegister 5//?
#define kU3API_DARTExcp 6//?
#define kU4API_DARTExcp 7//?
#define kU4DARTExceptionRegister 8//?
#define kU4DARTExcpRQOPMask 9//?
#define kU3API_ECC_CE_L 10//?
#define kU4DARTExcpXCDMask 11//?
#define kU3API_ECC_UE_L 12//?
#define kU4DARTExcpRQSRCMask 13//?
#define kU4DARTExcpLogAdrsMask 14//?
#define kU3API_ECC_CE_H 15//?
#define kU3API_ECC_UE_H 16//?
#define kU4DARTExcpLogAdrsShift 17//?
#define kU3MemCheckCtrlRegister 18//?
#define kU3DARTExceptionRegister 19//?
#define kU3MCCR_ECC_CE_MASK_L 20//?
#define kU3DARTExcpRQOPMask 21//?
#define kU3DARTExcpXEEMask 22//?
#define kU3MCCR_ECC_UE_MASK_L 23//?
#define kU3DARTExcpRQSRCMask 24//?
#define kU3DARTExcpLogAdrsMask 25//?
#define kU3DARTExcpLogAdrsShift 26//?
#define kU3MemErrorAddressRegister 27//?
#define kU3MemErrorSyndromeRegister 28//?
#define kU3MCCR_ECC_CE_MASK_H 29//?
#define kU3MCCR_ECC_UE_MASK_H 30//?
#define kU3MEAR_RNK_A_mask 31//?
#define kU4API_ECC_CEExcp 32//?
#define kU3MEAR_RNK_A_shift 33//?
#define kU3MESR_ECC_SYNDROMES_mask 34//?
#define kU4API_ECC_UEExcp 35//?
#define kU3MESR_ECC_SYNDROME_mask 36//?
#define kU4MemCheckCtrlRegister 37//?
#define kU4MCCR_ECC_CE_MASK 38//?
#define kU4MCCR_ECC_UE_MASK 39//?
#define kU3MCCR_ECC_EN 40//?
#define kU4MEAR_RK_shift 41//?
#define kU4MemErrorSyndromeRegister 42//?
#define kU4MemErrorAddressRegister1 43//?
#define kU4MemErrorAddressRegister2 44//?
#define kU4MEAR_RK_mask 45//?

extern int  upperSyndrome;//?
extern int syndromes;//?
extern int lowerSyndrome;//?

//////////////////////////
 //AppleOnboardAudio-nan.c
//fp_private.h

#define OC_uint32_t_need
#include <stdint.h>

typedef struct                  
      {
#if defined(__BIG_ENDIAN__)
      uint32_t high;
      uint32_t low;
#else
      uint32_t low;
      uint32_t high;
#endif
      } dHexParts;

typedef union
      {
      unsigned char byties[8];
      double dbl;
      } DblInHex;
///////////////////////////////////
 //AppleOnboardAudio-PlatformInterfaceI2C.h

enum {
	kCodec_NumberOfTypes,//?
};

 //AppleOnboardAudio-PlatformInterfaceI2C_Mapped.cpp
//AppleOnboardAudio/AppleOnboardAudioUserClient.h
enum  {
	kCodec_PCM3052,
} ;
///////////////////////////////

//AppleRAID-artest.c

typedef int MKMediaRef;//?
typedef int MKStatus;//?

///////////////////////////////
#endif //HYS_HYS_H

