#ifndef HYS_KERN_CLOCK_H
#define HYS_KERN_CLOCK_H

#define ADD_ABSOLUTETIME(t1, t2)              (AbsoluteTime_to_scalar(t1) +=                               AbsoluteTime_to_scalar(t2))//c
//////////////////////

extern void clock_interval_to_deadline(uint32_t		interval,uint32_t		scale_factor,uint64_t		*result);//c
extern void clock_interval_to_absolutetime_interval(uint32_t		interval,uint32_t		scale_factor,uint64_t		*result);//.c
extern void delay_for_interval(uint32_t		interval,uint32_t		scale_factor);//c

#endif//HYS_KERN_CLOCK_H

