#ifndef HYS_KERN_SCHED_PRIM_H
#define HYS_KERN_SCHED_PRIM_H

#define thread_wakeup_with_result(x, z)		thread_wakeup_prim((x), FALSE, (z))//c
#define thread_wakeup_one(x)	thread_wakeup_prim((x), TRUE, THREAD_AWAKENED)//c
#define thread_wakeup(x) thread_wakeup_prim((x), FALSE, THREAD_AWAKENED)//c

////////////////////////////////
extern wait_result_t	assert_wait_timeout(event_t				event,wait_interrupt_t	interruptible,uint32_t			interval,uint32_t			scale_factor);//c
extern wait_result_t	thread_block(thread_continue_t	continuation);//c
extern wait_result_t	assert_wait(event_t				event,wait_interrupt_t	interruptible);//c
extern kern_return_t	thread_wakeup_prim(event_t				event,boolean_t			one_thread,wait_result_t		result);//c
extern wait_result_t	assert_wait_deadline(event_t				event,wait_interrupt_t	interruptible,uint64_t			deadline);//c

#endif//HYS_KERN_SCHED_PRIM_H

