#ifndef HYS_MACH_O_GMON_H
#define HYS_MACH_O_GMON_H

#define	HISTCOUNTER	unsigned short//c
///////////////////
#define HASHFRACTION 1//?
#define HISTFRACTION 2//?
#define ARCDENSITY 3//?
#define MINARCS 4//?
#define GMON_MAGIC 5//?
#define GMONTYPE_RLD_STATE 6//?
#define GMONTYPE_DYLD_STATE 7//?
#define GMONTYPE_SAMPLES 8//?
#define GMONTYPE_ARCS_ORDERS 9//?

//////////

struct phdr {
    	char	*lpc; //c
    	char	*hpc; //c
    	int	ncnt;	//c
};

struct tostruct {
   	unsigned short	 link;//c
    	char	 *selfpc;//c
    	long		count;//c
    	unsigned short	order;//c
};

struct gmon_data {
    	unsigned long type;//c
    	unsigned long size;//c
};

struct rawarc_order {
    	unsigned long	raw_frompc;
    	unsigned long	raw_selfpc;
    	unsigned long	raw_count;
    	unsigned long	raw_order;
};//c

#endif//HYS_MACH_O_GMON_H
