#ifndef HYS_MACH_HOST_INFO_H
#define HYS_MACH_HOST_INFO_H

#define HOST_BASIC_INFO_COUNT ((mach_msg_type_number_t) \
		(sizeof(host_basic_info_data_t)/sizeof(integer_t)))//c

#define HOST_CPU_LOAD_INFO_COUNT ((mach_msg_type_number_t) \
		(sizeof (host_cpu_load_info_data_t) / sizeof (integer_t)))//c

#define HOST_SCHED_INFO_COUNT ((mach_msg_type_number_t) \
		(sizeof(host_sched_info_data_t)/sizeof(integer_t)))//c

//////////////
#define HOST_CPU_LOAD_INFO 4//?
#define HOST_BASIC_INFO 5//?
#define HOST_SCHED_INFO 6//?
#define HOST_VM_INFO 7//?

//////////////////////////////

typedef integer_t	*host_info_t;//c
typedef	integer_t	host_flavor_t;//c
///////////
struct host_cpu_load_info {
	natural_t	cpu_ticks[CPU_STATE_MAX];//c
};
typedef struct host_cpu_load_info host_cpu_load_info_data_t;//c

struct  host_basic_info {
	cpu_type_t		cpu_type;//c
	cpu_subtype_t		cpu_subtype;//c
};
typedef	struct host_basic_info	host_basic_info_data_t;//c

struct host_sched_info {
	integer_t	min_timeout;//c
};
typedef	struct host_sched_info	host_sched_info_data_t;

#endif//HYS_MACH_HOST_INFO_H
