#ifndef HYS_MACH_HPPA_THREAD_STATUS_H
#define HYS_MACH_HPPA_THREAD_STATUS_H

#define	HPPA_INTEGER_THREAD_STATE_COUNT (sizeof(struct hp_pa_integer_thread_state) / sizeof(unsigned long))//c

#define	HPPA_FRAME_THREAD_STATE_COUNT (sizeof(struct hp_pa_frame_thread_state) / sizeof(unsigned long))//c

#define	HPPA_FP_THREAD_STATE_COUNT (sizeof(struct hp_pa_fp_thread_state) / sizeof(unsigned long))//c

////////////////
#define HPPA_INTEGER_THREAD_STATE 1//?
#define HPPA_FRAME_THREAD_STATE 2//?
#define HPPA_FP_THREAD_STATE 3//?

////////////////////

struct hp_pa_frame_thread_state {
	unsigned long	ts_pcsq_front;//c
	unsigned long	ts_pcoq_front;//c
	unsigned long	ts_pcoq_back;//c
	unsigned long	ts_pcsq_back;//c
	unsigned long	ts_psw;//c
	unsigned long	ts_unaligned_faults;	//c
	unsigned long	ts_fault_address;//c
	unsigned long	ts_step_range_start;//c
	unsigned long	ts_step_range_stop;//c
};

struct hp_pa_integer_thread_state { 
	unsigned long	ts_gr30;//c
	unsigned long	ts_gr1;//c
	unsigned long	ts_gr2;//c
	unsigned long	ts_gr3;//c
	unsigned long	ts_gr4;//c
	unsigned long	ts_gr5;//c
	unsigned long	ts_gr6;//c
	unsigned long	ts_gr7;//c
	unsigned long	ts_gr8;//c
	unsigned long	ts_gr9;//c
	unsigned long	ts_gr10;//c
	unsigned long	ts_gr11;//c
	unsigned long	ts_gr12;//c
	unsigned long	ts_gr13;//c
	unsigned long	ts_gr14;//c
	unsigned long	ts_gr15;//c
	unsigned long	ts_gr16;//c
	unsigned long	ts_gr17;//c
	unsigned long	ts_gr18;//c
	unsigned long	ts_gr19;//c
	unsigned long	ts_gr20;//c
	unsigned long	ts_gr21;//c
	unsigned long	ts_gr22;//c
	unsigned long	ts_gr23;//c
	unsigned long	ts_gr24;//c
	unsigned long	ts_gr25;//c
	unsigned long	ts_gr26;//c
	unsigned long	ts_gr27;//c
	unsigned long	ts_gr28;//c
	unsigned long	ts_gr29;//c
	unsigned long	ts_gr31;//c
	unsigned long	ts_sr0;//c
	unsigned long	ts_sr1;//c
	unsigned long	ts_sr2;//c
	unsigned long	ts_sr3;//c
	unsigned long	ts_sar;//c
};
typedef struct hp_pa_integer_thread_state hp_pa_integer_thread_state_t;

struct hp_pa_fp_thread_state {
	double	ts_fp0;	
	double	ts_fp1;
	double	ts_fp2;
	double	ts_fp3;
	double	ts_fp4;
	double	ts_fp5;
	double	ts_fp6;
	double	ts_fp7;
	double	ts_fp8;
	double	ts_fp9;
	double	ts_fp10;
	double	ts_fp11;
	double	ts_fp12;
	double	ts_fp13;
	double	ts_fp14;
	double	ts_fp15;
	double	ts_fp16;
	double	ts_fp17;
	double	ts_fp18;
	double	ts_fp19;
	double	ts_fp20;
	double	ts_fp21;
	double	ts_fp22;
	double	ts_fp23;
	double	ts_fp24;
	double	ts_fp25;
	double	ts_fp26;
	double	ts_fp27;
	double	ts_fp28;
	double	ts_fp29;
	double	ts_fp30;
	double	ts_fp31;
};//c
typedef struct hp_pa_fp_thread_state hp_pa_fp_thread_state_t;

#endif//HYS_MACH_HPPA_THREAD_STATUS_H
