#ifndef HYS_MACH_I860_THREAD_STATUS_H
#define HYS_MACH_I860_THREAD_STATUS_H

#define	I860_THREAD_STATE_REGS	(4)//c

#define	I860_THREAD_STATE_REGS_COUNT \
	(sizeof (struct i860_thread_state_regs) / sizeof (int))//c
////////////

struct i860_thread_state_regs {
	int	ireg[31];  
	int	freg[30];  
	int	psr;	   
	int	epsr;	
	int	db;	  
	int	pc;	 
	int	_padding_;
	double	Mres3;
	double	Ares3;
	double	Mres2;
	double	Ares2;
	double	Mres1;
	double	Ares1;
	double	Ires1;
	double	Lres3m;
	double	Lres2m;
	double	Lres1m;
	double	KR;
	double	KI;
	double	T;
	int	Fsr3;
	int 	Fsr2;
	int	Fsr1;
	int	Mergelo32;
	int	Mergehi32;
};//c

#endif//HYS_MACH_I860_THREAD_STATUS_H
