#ifndef HYS_MACH_MACH_TYPES_H
#define HYS_MACH_MACH_TYPES_H

#define TASK_NULL		((task_t) 0)//c

////////////

#ifdef	KERNEL

#include <mach/vm_param.h>

typedef struct task			*task_t, *task_name_t;//c
typedef struct ipc_space		*ipc_space_t;//c
typedef struct host			*host_t;//c
#ifndef	MACH_KERNEL_PRIVATE

__BEGIN_DECLS
struct task ;
__END_DECLS

#endif	/* MACH_KERNEL_PRIVATE */

#else	/* KERNEL */


typedef mach_port_t		task_t;//c
typedef mach_port_t		ipc_space_t;//c
typedef mach_port_t		host_t;//c

#endif	/* KERNEL */


//////////////
#ifdef __cplusplus
extern "C" {
#endif

struct semaphore;
struct task;

#ifdef __cplusplus
}
#endif//c

typedef task_t	task_port_t;//c
typedef struct thread *thread_act_t;//c
typedef struct semaphore  *semaphore_t;//c
typedef struct thread	*thread_t;//c
typedef thread_t		thread_port_t;//c
typedef thread_t		*thread_array_t;//c
typedef	thread_array_t		thread_port_array_t;//c
typedef mach_port_t		exception_handler_t;//c
typedef exception_handler_t	exception_port_t;//c

#endif//HYS_MACH_MACH_TYPES_H
