#ifndef HYS_MACH_TASK_INFO_H
#define HYS_MACH_TASK_INFO_H

#define TASK_BASIC_INFO_COUNT   \
                (sizeof(task_basic_info_data_t) / sizeof(natural_t))//c

#if !defined(__LP64__)
#define TASK_BASIC_INFO TASK_BASIC_INFO_32//c
#else
#define TASK_BASIC_INFO TASK_BASIC_INFO_64//c
#endif

#define	TASK_THREAD_TIMES_INFO_COUNT	((mach_msg_type_number_t) \
		(sizeof(task_thread_times_info_data_t) / sizeof(natural_t)))//c

////////////

#define TASK_BASIC_INFO_32 1//?
#define TASK_THREAD_TIMES_INFO 2//?
#define TASK_SCHED_TIMESHARE_INFO 3//?
#define TASK_SCHED_RR_INFO 4//?
#define TASK_SCHED_FIFO_INFO 5//?
#define  TH_FLAGS_SWAPPED 6//?

/////////////
struct task_basic_info {
    	vm_size_t       virtual_size;//c
 	vm_size_t       resident_size; //c
	time_value_t    user_time; //c
   	time_value_t    system_time; //c
	policy_t	policy;//c
};

typedef struct task_basic_info          task_basic_info_data_t;//c

struct task_thread_times_info {
	time_value_t	user_time;//c
	time_value_t	system_time;//c
};
typedef struct task_thread_times_info	task_thread_times_info_data_t;//c

#endif//HYS_MACH_TASK_INFO_H
