#ifndef HYS_MACH_THREAD_INFO_H
#define HYS_MACH_THREAD_INFO_H

#define THREAD_BASIC_INFO_COUNT   ((mach_msg_type_number_t) \
                (sizeof(thread_basic_info_data_t) / sizeof(natural_t)))//c

/////////////
#define TH_STATE_RUNNING 1//?
#define TH_STATE_UNINTERRUPTIBLE 2//?
#define TH_STATE_WAITING 3//?
#define TH_STATE_STOPPED 4//?
#define TH_STATE_HALTED 5//?
#define THREAD_SCHED_TIMESHARE_INFO 6//?
#define THREAD_SCHED_FIFO_INFO 7//?
#define THREAD_SCHED_RR_INFO 8//?
#define THREAD_BASIC_INFO 9//?

/////////
typedef	integer_t	*thread_info_t;	//c

////////////
struct thread_basic_info {
	integer_t       run_state;//c
	integer_t       sleep_time;//c
	policy_t	policy;//c
   	time_value_t    user_time;//c
   	time_value_t    system_time;   //c
        integer_t       cpu_usage;   //c
    	integer_t       flags;//c
       	integer_t       suspend_count;//c
};
typedef struct thread_basic_info  thread_basic_info_data_t;//c

#endif//HYS_MACH_THREAD_INFO_H
