#ifndef HYS_MACH_VM_PARAM_H
#define HYS_MACH_VM_PARAM_H

#define ptoa_32(x) ((uint32_t)(x) << PAGE_SHIFT)//c
#define atop_32(x) ((uint32_t)(x) >> PAGE_SHIFT)//c
#define ptoa_64(x) ((uint64_t)(x) << PAGE_SHIFT)//c
#define round_page_32(x) (((uint32_t)(x) + PAGE_MASK) & ~((signed)PAGE_MASK))//c
#define trunc_page_32(x) ((uint32_t)(x) & ~((signed)PAGE_MASK))//c
#define round_page(x) (((vm_offset_t)(x) + PAGE_MASK) & ~((signed)PAGE_MASK))//c

#ifndef __CAST_DOWN_CHECK
#define __CAST_DOWN_CHECK
#define CAST_DOWN( type, addr )  ( ((type)((uintptr_t) (addr))) ) //c
#endif /* __CAST_DOWN_CHECK */

///////////////////
extern vm_size_t	page_size;//c
extern uint64_t		max_mem;//c
extern vm_size_t	mem_size;//c

#endif//HYS_MACH_VM_PARAM_H
