#ifndef HYS_MISCCFS_DEVFS_DEVFS_H
#define HYS_MISCCFS_DEVFS_DEVFS_H

#include <unistd.h>//uid_t-linuix

#define DEVFS_CHAR 1//?
#define UID_ROOT 2//?
#define GID_WHEEL 3//?
#define DEVFS_BLOCK 4//?
#define GID_OPERATOR 5//?
#define DEVFS_CLONE_ALLOC 6//?

//////////////

void * 	devfs_make_node_clone(dev_t dev, int chrblk, uid_t uid, gid_t gid, 
			     int perms, int (*clone)(dev_t dev, int action),
			     const char *fmt, ...);//c

void	devfs_remove(void * handle);//c

#endif//HYS_MISCCFS_DEVFS_DEVFS_H
