#ifndef HYS_NETAT_APPLETALK_H
#define HYS_NETAT_APPLETALK_H

#define DDP_ADSP 1//?
#define AT_ST_STARTED 2//?
#define ATPROTO_ASP 3//?
#define DDP_ATP 4//?
#define NBP_NVE_STR_SIZE 5//?
#define NBP_TUPLE_SIZE 6//?
#define AT_ST_MULTIHOME 7//?
#define ATP_TRESP_MAX 8//?
#define AT_ST_ROUTER 9//?
#define DDP_NBP 10//?
#define DDP_GETSOCKNAME 11//?
#define DDP_ECHO 12//?
#define MAX_ZONES 13//?

///////////////
#define ATPROTO_ADSP DDP_ADSP//c
#define ATPROTO_ATP DDP_ATP//c
///////////////////////
typedef u_char ua_short[2];	//c
typedef ua_short at_net_unal;//c
typedef at_net_unal at_net;//c
typedef u_char  at_socket;//c
typedef u_char	at_node;//c
typedef u_short at_net_al;//c

//////////////
struct at_addr{
	u_short     s_net;	//c
	u_char      s_node;	//c
};

struct at_inet{
	u_short	net;	//c
	u_char	node;//c
	u_char	socket;//c	
};
typedef struct at_inet at_inet_t;//c

struct strbuf_t{
	int  maxlen; //c
	int  len;    //c
	char *buf;   //c

};
typedef struct strbuf_t strbuf_t;

struct at_state{
	unsigned int	flags;//c
};
typedef struct at_state at_state_t;

struct at_nvestr {
	int len;//?
	int str[1];//?
};
typedef struct at_nvestr at_nvestr_t;

struct at_entity{
	at_nvestr_t zone;//c
	at_nvestr_t object;//c
	at_nvestr_t type;//c
};
typedef struct at_entity  at_entity_t;

struct at_retry{
    short	interval;	//c
    short	retries;		//c
    u_char      backoff;     //c

};
typedef struct at_retry at_retry_t;

struct at_resp{
	u_char	bitmap;//c
	struct	iovec resp[ATP_TRESP_MAX];//c
	long	userdata[ATP_TRESP_MAX];//c
};
typedef struct at_resp at_resp_t;

struct at_nbptuple{
	at_entity_t  enu_entity;//c
	at_inet_t enu_addr;//c
	u_char		enu_enum;//c
};
typedef struct at_nbptuple at_nbptuple_t;

struct ddp_addr{
	at_inet_t inet;//c
	u_short		ddptype;//.c
};
typedef struct ddp_addr ddp_addr_t;//?

struct sockaddr_at{
	u_char  	sat_len;    //c
	u_char  	sat_family; //c
	u_char  	sat_port;	//c
	struct at_addr  sat_addr;//c
};

#endif //HYS_NETAT_APPLETALK_H
