#ifndef HYS_NETAT_ATP_H
#define HYS_NETAT_ATP_H

#define AT_ATP_PEEK 1//?
#define ATP_DATA_SIZE 2//?
#define AT_ATP_CANCEL_REQUEST 3//?
#define AT_ATP_BIND_REQ 4//?
#define TOTAL_ATP_HDR_SIZE 5//?
#define AT_ATP_RELEASE_RESPONSE 6//?
#define ATP_HDR_SIZE 7//?
#define ATP_CMD_TREQ 8//?
#define ATP_XO_8MIN 9//?
#define ATP_DEF_INTERVAL 10//?
#define ATP_DEF_RETRIES 11//?

struct atpBDS{
	int bdsBuffAddr;//?
	int bdsBuffSz;//?
	int bdsUserData;//?
	int bdsDataSz;//?
};

struct at_atp_t{
	int tid;//?
	int user_bytes;//?
	int xo;//?
	int bitmap;//?
	int xo_relt;//?
	int data;//?
};
typedef struct at_atp_t at_atp_t;//?

struct at_atpreq{
	int at_atpreq_treq_length;//?
	int at_atpreq_type;//?
	at_inet_t  at_atpreq_to;//c
	int at_atpreq_maximum_retries;//?
	int at_atpreq_retry_timeout;//?
	int at_atpreq_xo;//?
	int at_atpreq_xo_relt;//?
	int at_atpreq_treq_bitmap;//?
	int at_atpreq_treq_user_bytes;//?
	int at_atpreq_treq_data;//?
	int at_atpreq_tid;//?
	int at_atpreq_tresp_data[1];//?
	int at_atpreq_tresp_lengths[1];//?
	int at_atpreq_tresp_bitmap;//?
	int at_atpreq_tresp_eom_seqno;//?
	int at_atpreq_tresp_user_bytes[1];//?
};
typedef struct at_atpreq at_atpreq;//?

struct atp_set_default{
	int def_retries;//?
	int def_rate;//?
	int def_bdsp;//?
	int def_BDSlen;//?
};

#endif//HYS_NETAT_ATP_H
