#ifndef HYS_NETAT_DDP_H
#define HYS_NETAT_DDP_H

#define ZIP_SOCKET 1//?
#define DDP_IOC_GET_CFG 2//?
#define DDP_DATAGRAM_SIZE 3//?
#define DDP_X_HDR_SIZE 4//?
#define NBP_SOCKET 5//?
#define DDP_DATA_SIZE 6//?
#define EP_SOCKET 7//?
#define DDP_SOCKET_1st_DYNAMIC 8//?

///////////////////
struct at_ddp_t {
#if BYTE_ORDER == BIG_ENDIAN
		unsigned	unused:2,
        		    hopcount:4,  	/* hop count/len high order  */
        			length_H:2;	
#endif
#if BYTE_ORDER == LITTLE_ENDIAN
		unsigned	length_H:2,
					hopcount:4,
					unused:2;
#endif
        at_net     src_net;//c
        at_node    src_node;//c
        at_socket  src_socket;//c
        at_net     dst_net;//c
        at_node    dst_node; //c
        at_socket  dst_socket; //c
   	char       data[DDP_DATA_SIZE];//c
        u_char	   type; //c
  	ua_short   checksum;  //c
};
typedef struct at_ddp_t at_ddp_t;

struct at_ddp_stats { 
	u_int	xmit_packets;//c
	u_int	xmit_bytes;//c
	u_int	xmit_BRT_used;//c
	u_int	rcv_packets;//c
	u_int	rcv_bytes;//c
	u_int	rcv_unreg_socket;//c
	u_int	rcv_bad_socket;//c
	u_int	rcv_bad_length;//c
	u_int	rcv_bad_checksum;//c
	u_int	rcv_dropped_nobuf;//c
	u_int	xmit_dropped_nobuf;//c
};
typedef struct at_ddp_stats at_ddp_stats_t;

#endif//HYS_NETAT_DDP_H
