#ifndef HYS_NETINET_IN_VAR_H
#define HYS_NETINET_IN_VAR_H

#define KEV_INET_SUBCLASS 1//c
//////////////////////////////////////
#define KEV_INET_ARPCOLLISION 1//?
#define KEV_INET_NEW_ADDR 3//?
#define KEV_INET_CHANGED_ADDR 4//?
#define KEV_INET_ADDR_DELETED 5//?
#define KEV_INET_SIFDSTADDR 6//?
#define KEV_INET_SIFBRDADDR 7//?
#define KEV_INET_SIFNETMASK 8//?
#define KEV_INET_PORTINUSE 9//?

//////////////////

struct kev_in_data {
	struct net_event_data   link_data;//c
};

struct kev_in_collision {
	u_char			hw_len;//c
	struct net_event_data	link_data;	//c
	struct in_addr		ia_ipaddr;	//c
	u_char			hw_addr[0];//c
};

struct kev_in_portinuse {
	u_int16_t		port;//c
	u_int32_t		req_pid;//c
};

#endif//HYS_NETINET_IN_VAR_H
