#ifndef HYS_PEXPERT_PEXPERT_H
#define HYS_PEXPERT_PEXPERT_H

#define kPEReleaseScreen 1//?
#define kPEDisableScreen 2//?
#define kPEAcquireScreen 3//?
#define kPEEnableScreen 4//?

struct clock_frequency_info_t{
	int timebase_frequency_hz;//?
	int timebase_frequency_num;//?
	int timebase_frequency_den;//?
	int cpu_clock_rate_hz;//?
	int bus_to_cpu_rate_num;//?
	int cpu_frequency_hz;//?
	int cpu_frequency_max_hz;//?
};
typedef struct clock_frequency_info_t clock_frequency_info_t;

struct PE_Video {
	int v_baseAddr;//?
	int v_rowBytes;//?
	int v_width;//?
	int v_height;//?
	int v_depth;//?
	int v_display;//?
};
typedef struct PE_Video PE_Video;

typedef int cpu_id_t;//?

//////////////////////////
extern clock_frequency_info_t gPEClockFrequencyInfo;//c
extern int gPESerialBaud;//?

int PE_parse_boot_arg(const char * a,void * b);//?
int PE_call_timebase_callback();//?
int PE_write_IIC(int a,int b,int c);//?
int PE_enter_debugger(char* a);//?

#endif//HYS_PEXPERT_PEXPERT_H


