#ifndef HYS_SECURITYT_CDSA_UTILTIES_CSSMACLPOD_H
#define HYS_SECURITYT_CDSA_UTILTIES_CSSMACLPOD_H

namespace Security {

typedef CSSM_ACL_AUTHORIZATION_TAG AclAuthorization;//c

uint32 pinFromAclTag(const char *tag, const char *suffix = NULL);//c
//////////////////
class  AclEdit_HYS {
public:

#define Security_AclEdit_AclEdit_SSM_ACL_EDIT \
AclEdit(CSSM_ACL_EDIT_MODE m, CSSM_ACL_HANDLE h, const AclEntryInput *data) {};//c

#define Security_AclEdit_AclEdit_const_AclEntryInput \
AclEdit(const AclEntryInput &add){ };//c

#define Security_AclEdit_AclEdit_CSSM_ACL_HANDLE_const_AclEntryInput \
AclEdit(CSSM_ACL_HANDLE h, const AclEntryInput &modify){ };//c

#define Security_AclEdit_AclEdit_CSSM_ACL_HANDLE \
AclEdit(CSSM_ACL_HANDLE h){ };//c

#define Security_AclEdit_mode \
CSSM_ACL_EDIT_MODE mode() const {};//c

#define Security_AclEdit_handle \
CSSM_ACL_HANDLE handle() const {  };//c

#define  Security_AclEdit_newEntry \
const AclEntryInput *newEntry() const {  };//c

};

class AutoAclEntryInfoList_HYS{

public://operator

#define Security_AutoAclEntryInfoList_operator \
operator bool () const {};//c

#define Security_AutoAclEntryInfoList_operator1 \
bool operator ! () const	{ };//c

#define Security_AutoAclEntryInfoList_operator2 \
operator uint32 *()	{ };//c

#define Security_AutoAclEntryInfoList_operator3 \
operator CSSM_ACL_ENTRY_INFO ** ()	{};//c

#define Security_AutoAclEntryInfoList_operator4 \
const AclEntryInfo &operator [] (uint32 ix) const		{ };//c

#define Security_AutoAclEntryInfoList_operator5 \
AclEntryInfo &operator[] (uint32 ix)	 { };//c

public://data

#define Security_AutoAclEntryInfoList_mEntries \
AclEntryInfo *mEntries;//c

#define Security_AutoAclEntryInfoList_mCount \
uint32 mCount;//c

#define Security_AutoAclEntryInfoList_mAllocator \
Allocator *mAllocator;//c

public://func

#define Security_AutoAclEntryInfoList_addPinState \
void addPinState(uint32 slot, uint32 state);//c

#define Security_AutoAclEntryInfoList_addPinState_uint32 \
void addPinState(uint32 slot, uint32 state, uint32 count);//c

#define Security_AutoAclEntryInfoList_clear \
void clear();//c

#define Security_AutoAclEntryInfoList_addPin \
void addPin(const TypedList &subj, uint32 slot);//c

#define Security_AutoAclEntryInfoList_size \
uint32 size() const {};//c

#define Security_AutoAclEntryInfoList_size_uint32 \
void size(uint32 newSize);//

#define Security_AutoAclEntryInfoList_entries \
AclEntryInfo *entries() const {};//c

#define Security_AutoAclEntryInfoList_add \
void add(const TypedList &subj, const AclAuthorizationSet &auths, const char *tag = NULL);//c

#define Security_AutoAclEntryInfoList_allocator_Allocator \
void allocator(Allocator &allocator);//c

#define Security_AutoAclEntryInfoList_allocator \
Allocator &allocator() const { };//c

#define Security_AutoAclEntryInfoList_AutoAclEntryInfoList \
AutoAclEntryInfoList(Allocator *allocator = NULL): mEntries(NULL), mCount(0), mAllocator(allocator) { };//c

};

class  AutoAclOwnerPrototype_HYS {

public://operator

#define Security_AutoAclOwnerPrototype_operator \
operator bool () const {};//c

#define Security_AutoAclOwnerPrototype_operator1 \
bool operator ! () const { };//c
	
#define Security_AutoAclOwnerPrototype_operator2 \
operator AclOwnerPrototype * ()	{  };//c

#define Security_AutoAclOwnerPrototype_operator3 \
operator AclOwnerPrototype & (){ };//c

#define Security_AutoAclOwnerPrototype_operator4 \
AclOwnerPrototype &operator * ()	{ };//c

#define Security_AutoAclOwnerPrototype_operator5 \
AclOwnerPrototype &operator = (const TypedList &subj) {};//c

public://data

#define Security_AutoAclOwnerPrototype_mAclOwnerPrototype \
AclOwnerPrototype *mAclOwnerPrototype;//c

#define Security_AutoAclOwnerPrototype_mAllocator \
Allocator *mAllocator;//c

public://func

#define Security_AutoAclOwnerPrototype_allocator_Allocator \
void allocator(Allocator &allocator);//c

#define Security_AutoAclOwnerPrototype_allocator  \
Allocator &allocator() const {};//c

#define Security_AutoAclOwnerPrototype_AutoAclOwnerPrototype \
AutoAclOwnerPrototype(Allocator *allocator = NULL): mAclOwnerPrototype(NULL),mAllocator(allocator) { };//c

};

class AclAuthorizationSet_HYS {
public:

#define Security_AclAuthorizationSet_AclAuthorizationSet \
AclAuthorizationSet() { };//c

#define Security_AclAuthorizationSet_AclAuthorizationSet_AclAuthorization \
AclAuthorizationSet(AclAuthorization auth) { };//c

#define Security_AclAuthorizationSet_AclAuthorizationSet_AclAuthorization_AclAuthorization \
AclAuthorizationSet(AclAuthorization *authBegin, AclAuthorization *authEnd): set<AclAuthorization>(authBegin, authEnd) { };//c

#define Security_AclAuthorizationSet_AclAuthorizationSet_AclAuthorization_AclAuthorization___ \
AclAuthorizationSet(AclAuthorization a1, AclAuthorization a2, ...);//c

};

class AclEntryInput_HYS {
public:

#define Security_AclEntryInput_proto \
AclEntryPrototype &proto() {};//c

#define Security_AclEntryInput_proto_const \
const AclEntryPrototype &proto() const {};//c

};

class  AclEntryPrototype_HYS {
public:

#define Security_AclEntryPrototype_subject \
TypedList &subject() { };//c

#define Security_AclEntryPrototype_subject_const \
const TypedList &subject() const {};//c

};

};//Security

#endif//HYS_SECURITYT_CDSA_UTILTIES_CSSMACLPOD_H

#ifdef HYS_SECURITYT_CDSA_UTILTIES_CSSMACLPOD_H_END
#undef  HYS_SECURITYT_CDSA_UTILTIES_CSSMACLPOD_H_END

namespace Security {
namespace DataWalkers {

template <class Action>
AclEntryInput *walk(Action &operate, AclEntryInput * &input) {};//c

template <class Action>
void walk(Action &operate, AclEntryInput &input){};//c

template <class Action>
void walk(Action &operate, AclEntryInfo &info){};//c

template <class Action>
void walk(Action &operate, AuthorizationGroup &auth){};//c

template <class Action>
void walk(Action &operate, CSSM_AUTHORIZATIONGROUP &auth){ };//c

template <class Action>
void walk(Action &operate, AclEntryPrototype &proto){};//v

template <class Action>
AclEntryPrototype *walk(Action &operate, AclEntryPrototype * &proto){};//c

template <class Action>
void walk(Action &operate, AclOwnerPrototype &proto){};//c

template <class Action>
AclOwnerPrototype *walk(Action &operate, AclOwnerPrototype * &proto) {};//c

}//DataWalkers
};//Security
#endif //HYS_SECURITYT_CDSA_UTILTIES_CSSMACLPOD_H_END
