#ifndef HYS_SECURITY_CDSA_UTILIRES_CSSMERROS_H
#define HYS_SECURITY_CDSA_UTILIRES_CSSMERROS_H

namespace Security {

class CssmError_HYS{

public://data

#define Security_CssmError_error \
const CSSM_RETURN error;//c

public:

#define Security_CssmError_CssmError \
CssmError(CSSM_RETURN err);//c


#define Security_CssmError_merge \
static CSSM_RETURN merge(CSSM_RETURN error, CSSM_RETURN base);//c

#define Security_CssmError_cssmError_CSSM_RETURN \
static CSSM_RETURN cssmError(CSSM_RETURN error, CSSM_RETURN base);//c

#define Security_CssmError_CSSM_RETURN_cssmError_const_CommonError \
static CSSM_RETURN cssmError(const CommonError &error, CSSM_RETURN base);//c

#define Security_CssmError_throwMe \
static void throwMe(CSSM_RETURN error) __attribute__((noreturn));//c

};

}//Security

#endif//HYS_SECURITY_CDSA_UTILIRES_CSSMERROS_H
