#ifndef HYS_SECURITY_CDSA_UTILITIES_CSSMKIEY_H
#define HYS_SECURITY_CDSA_UTILITIES_CSSMKIEY_H

namespace Security {

class CssmKey_HYS {

public:
    class Header_HYS {
    public:

	#define Security_CssmKey_Header_blobFormat \
	CSSM_KEYBLOB_FORMAT blobFormat() const {};//c

	#define Security_CssmKey_Header_blobFormat_CSSM_KEYBLOB_FORMAT \
 	void blobFormat(CSSM_KEYBLOB_FORMAT blobFormat) {  };//c

	#define Security_CssmKey_Header_keyClass \
	CSSM_KEYCLASS keyClass() const {};//c

	#define Security_CssmKey_Header_keyClass_CSSM_KEYCLASS \
	void keyClass(CSSM_KEYCLASS keyClass) {};//c

	#define Security_CssmKey_Header_algorithm \
	CSSM_KEY_TYPE algorithm() const {};//c

	#define Security_CssmKey_Header_algorithm_CSSM_KEY_TYPE \
	void algorithm(CSSM_KEY_TYPE algorithm) { };//c

	#define Security_CssmKey_Header_blobType \
	CSSM_KEYBLOB_TYPE blobType() const {};//c

	#define Security_CssmKey_Header_blobType_CSSM_KEYBLOB_TYPE \
	void blobType(CSSM_KEYBLOB_TYPE blobType) {  };//c

	#define Security_CssmKey_Header_cspGuid \
	const Guid &cspGuid() const { };//c

	#define Security_CssmKey_Header_cspGuid_const_Guid \
	void cspGuid(const Guid &guid) { };//c

    };

public:

#define Security_CssmKey_usage_uint32  \
void usage(uint32 u) { };//c

#define Security_CssmKey_usage \
uint32 usage() const { };//c

#define Security_CssmKey_clearAttribute \
void clearAttribute(uint32 attr) {};//c

#define Security_CssmKey_setAttribute \
void setAttribute(uint32 attr) {};//c

#define Security_CssmKey_length \
size_t length() const { };//c

#define Security_CssmKey_keyData \
CssmData &keyData()		{};//c

#define Security_CssmKey_keyData_const  \
const CssmData &keyData() const { };//c

#define Security_CssmKey_keyClass \
CSSM_KEYCLASS keyClass() const		{ };//c

#define Security_CssmKey_keyClass_CSSM_KEYCLASS \
void keyClass(CSSM_KEYCLASS keyClass) { };//c

#define Security_CssmKey_algorithm \
CSSM_KEY_TYPE algorithm() const		{  };//c

#define Security_CssmKey_algorithm_CSSM_KEY_TYPE \
void algorithm(CSSM_KEY_TYPE algorithm) {};//c

#define Security_CssmKey_blobFormat \
CSSM_KEYBLOB_FORMAT blobFormat() const {};//c

#define Security_CssmKey_blobFormat_CSSM_KEYBLOB_FORMAT \
void blobFormat(CSSM_KEYBLOB_FORMAT blobFormat) {};//c

#define Security_CssmKey_blobType \
CSSM_KEYBLOB_TYPE blobType() const	{  };//c

#define Security_CssmKey_blobType_CSSM_KEYBLOB_TYPE \
void blobType(CSSM_KEYBLOB_TYPE blobType) {};//c

#define Security_CssmKey_header  \
Header &header() { };//c

#define Security_CssmKey_header_const \
const Header &header() const {};//c
	

};


};//Security

#endif//HYS_SECURITY_CDSA_UTILITIES_CSSMKIEY_H

#ifdef  HYS_SECURITY_CDSA_UTILITIES_CSSMKIEY_H_END
#undef HYS_SECURITY_CDSA_UTILITIES_CSSMKIEY_H_END

namespace Security {

typedef CssmKey CssmWrappedKey;//c

};//Security


#endif//HYS_SECURITY_CDSA_UTILITIES_CSSMKIEY_H_END
