#ifndef HYS_SECURITY_UTILS_ALLOC_H
#define HYS_SECURITY_UTILS_ALLOC_H

namespace Security {

class Allocator_HYS {

public:

#define Security_Allocator_malloc \
virtual void *malloc(size_t) throw(std::bad_alloc) = 0;//c

#define Security_Allocator_standard \
static Allocator &standard(UInt32 a = normal);//c

#define Security_Allocator_free \
virtual void free(void *) throw() = 0;//c

};

}//Security


#endif//HYS_SECURITY_UTILS_ALLOC_H
