#ifndef HYS_SECURITY_UTILTIES_IODEVICE_H
#define HYS_SECURITY_UTILTIES_IODEVICE_H

namespace Security {
namespace IOKit {

class Device_HYS{

public://operator

#define Security_IOKit_Device_operator \
operator bool () const	{ };//c

#define Security_IOKit_Device_operator1 \
bool operator ! () const	{};//c

public://func

#define Security_IOKit_Device_path \
std::string path(const char *plane = kIOServicePlane) const;//c

#define Security_IOKit_Device_property \
CFTypeRef property(const char *name) const;//c
	
#define Security_IOKit_Device_property_const_char \
template <class T> \
T property(const char *name) const {};//c

#define Security_IOKit_Device_ioObject \
io_service_t ioObject() const { };//c

#define Security_IOKit_Device_Device \
Device() : mService(MACH_PORT_NULL) { };//c

#define Security_IOKit_Device_Device_io_service_t \
Device(io_service_t d) : mService(d) { };//c

#define Security_IOKit_Device_mService \
io_service_t mService;//c

};

class  DeviceMatch_HYS {
public:

#define Security_IOKit_DeviceMatch_dict \
CFRef<CFMutableDictionaryRef> &dict() { };//c

#define Security_IOKit_DeviceMatch_DeviceMatch_CFMutableDictionaryRef \
DeviceMatch(CFMutableDictionaryRef dict) : CFRef<CFMutableDictionaryRef>(dict) { };//c

#define Security_IOKit_DeviceMatch_DeviceMatch \
DeviceMatch();//c

#define Security_IOKit_DeviceMatch_DeviceMatch_const_char \
DeviceMatch(const char *cls);//c

#define Security_IOKit_DeviceMatch_DeviceMatch_const_char_const_char \
DeviceMatch(const char *cls, const char *name, uint32_t value, ...); //c	

};

class  NotificationPort_HYS {

public://data

#define Security_IOKit_NotificationPort_mPortRef \
IONotificationPortRef mPortRef;//c

public://func

#define Security_IOKit_NotificationPort_source \
CFRunLoopSourceRef source() const;//c

#define Security_IOKit_NotificationPort_addInterestNotification \
void addInterestNotification(Receiver &receiver, io_service_t service, const io_name_t interestType = kIOGeneralInterest);//c

#define Security_IOKit_NotificationPort_port \
mach_port_t port() const;//c

#define Security_IOKit_NotificationPort_add \
void add(DeviceMatch match, Receiver &receiver, const char *type = kIOFirstMatchNotification);//c

};

class DeviceIterator_HYS {

public://operator

#define Security_IOKit_DeviceIterator_operator \
io_service_t operator () ();

public://data

#define Security_IOKit_DeviceIterator_mAtEnd \
bool mAtEnd;//c

#define Security_IOKit_DeviceIterator_mIterator \
io_iterator_t mIterator;//c	

public://func

#define Security_IOKit_DeviceIterator_DeviceIterator \
DeviceIterator(io_iterator_t iter) : mIterator(iter), mAtEnd(false) { };//c

};


}//IOKit
}//Security

#endif//HYS_SECURITY_UTILTIES_IODEVICE_H
