#ifndef HYS_SECURITY_UTILITIRS_MACHPP_H
#define HYS_SECURITY_UTILITIRS_MACHPP_H

namespace Security {
namespace MachPlusPlus {

inline void check(kern_return_t a){};//c

class Port_HYS {

public://operator

operator mach_port_t () const {  };//c

public://func

#define Security_MachPlusPlus_Port_requestNotify \
mach_port_t requestNotify(mach_port_t notify,mach_msg_id_t type = MACH_NOTIFY_DEAD_NAME, mach_port_mscount_t sync = 1);//c

};

class VMGuard_HYS {

private:
#define Security_MachPlusPlus_VMGuard_mAddr \
void *mAddr; //c

#define Security_MachPlusPlus_VMGuard_mLength \
size_t mLength; //c

public:

#define Security_MachPlusPlus_VMGuard_VMGuard \
VMGuard(void *addr, size_t length) : mAddr(addr), mLength(length) { };//c

};

class Error_HYS {

public://data

#define Security_MachPlusPlus_Error_error \
const kern_return_t error;//c

public://func

#define Security_MachPlusPlus_Error_check \
static void check(kern_return_t err);//c

#define Security_MachPlusPlus_Error_osStatus \
virtual OSStatus osStatus() const;//c

};

}//MachPlusPlus
}//Security

#endif//HYS_SECURITY_UTILITIRS_MACHPP_H
