#ifndef HYS_SECURITY_UTTIES_UNIXPP_H
#define HYS_SECURITY_UTTIES_UNIXPP_H

namespace Security {
namespace UnixPlusPlus {

class  AutoFileDesc_HYS {
public:

#define Security_UnixPlusPlus_AutoFileDesc_AutoFileDesc \
AutoFileDesc() { };//cc

#define Security_UnixPlusPlus_AutoFileDesc_AutoFileDesc_int \
AutoFileDesc(int fd) : FileDesc(fd) { };//cc

#define Security_UnixPlusPlus_AutoFileDesc_AutoFileDesc_const_char \
AutoFileDesc(const char *path, int flag = O_RDONLY, mode_t mode = 0666): FileDesc(path, flag, mode) { };//cc

#define Security_UnixPlusPlus_AutoFileDesc_AutoFileDesc_const_std_string \
AutoFileDesc(const std::string &path, int flag = O_RDONLY, mode_t mode = 0666): FileDesc(path, flag, mode) { };//cc

};

class FileDesc_HYS {

private:

#define Security_UnixPlusPlus_FileDesc_mFd \
int mFd;	//c

protected:

#define Security_UnixPlusPlus_FileDesc_invalidFd \
static const int invalidFd = -1;//c

#define Security_UnixPlusPlus_FileDesc_mAtEnd \
bool mAtEnd;//c

#define Security_UnixPlusPlus_FileDesc_FileDesc_int_bool  \
FileDesc(int fd, bool atEnd) : mFd(fd), mAtEnd(atEnd) { };//cc

public:

#define Security_UnixPlusPlus_FileDesc_writeAll_const_void \
void writeAll(const void *addr, size_t length);//c

#define Security_UnixPlusPlus_FileDesc_writeAll_char \
void writeAll(char *s) {}//c

#define Security_UnixPlusPlus_FileDesc_writeAll_const_char  \
void writeAll(const char *s) {  };//c

#define Security_UnixPlusPlus_FileDesc_writeAll_const_Data \
template <class Data> \
void writeAll(const Data &ds) {};//c

#define Security_UnixPlusPlus_FileDesc_readAll_void \
size_t readAll(void *addr, size_t length);//c

#define Security_UnixPlusPlus_FileDesc_readAll_std_string \
size_t readAll(std::string &content);//c

#define Security_UnixPlusPlus_FileDesc_fileSize \
size_t fileSize() const;//c

#define Security_UnixPlusPlus_FileDesc_FileDesc \
FileDesc() : mFd(invalidFd), mAtEnd(false) { };//cc

#define Security_UnixPlusPlus_FileDesc_FileDesc_int \
FileDesc(int fd) : mFd(fd), mAtEnd(false) { };//cc

#define Security_UnixPlusPlus_FileDesc_FileDesc_const_char \
explicit FileDesc(const char *path, int flag = O_RDONLY, mode_t mode = 0666): mFd(invalidFd){};//c 
	
#define Security_UnixPlusPlus_FileDesc_FileDesc_const_std_string \
explicit FileDesc(const std::string &path, int flag = O_RDONLY, mode_t mode = 0666): mFd(invalidFd)	{};//c

};

}//UnixPlusPlus
}//Security

#endif//HYS_SECURITY_UTTIES_UNIXPP_H
