#ifndef HYS_SECURITYT_UTILITURES_UTILITIRS_H
#define HYS_SECURITYT_UTILITURES_UTILITIRS_H

namespace Security {

#define NOCOPY(a)	private: a(const a &); void operator = (const a &);//c
#define IFDEBUG(it)		IFELSEDEBUG(it,)//c
//////////

#if defined(NDEBUG)

# define safe_cast	static_cast
# define safer_cast	static_cast

# define IFELSEDEBUG(d,nd) nd

#else

template <class Derived, class Base>
inline Derived safer_cast(Base &base){};//c

template <class Derived, class Base>
inline Derived safe_cast(Base *base) {};//c

# define IFELSEDEBUG(d,nd) d

#endif //NDEBUG


///////////

template <class In>
static inline void for_each_delete(In first, In last) {};//c

template <class In>
static inline void for_each_map_delete(In first, In last) {};//c


/////////

class  PodWrapper_HYS {
public:

#define Security_PodWrapper_overlayVar \
static Wrapper * &overlayVar(POD * &data) {};//c

#define Security_PodWrapper_overlayVar_const_POD \
static const Wrapper * &overlayVar(const POD * &data) {};//c

#define Security_PodWrapper_required \
static Wrapper &required(POD *data) {};//c

#define Security_PodWrapper_required_const_POD \
static const Wrapper &required(const POD *data) {};//c

#define Security_PodWrapper_optional \
static Wrapper *optional(POD *data) {};//c

#define Security_PodWrapper_optional_const_POD \
static const Wrapper *optional(const POD *data) {};//c

#define Security_PodWrapper_clearPod \
void clearPod() {};//c

#define Security_PodWrapper_Wrapper_overlay_POD \
static Wrapper *overlay(POD *data){  };//c

#define Security_PodWrapper_const_Wrapper_overlay_const_POD \
static const Wrapper *overlay(const POD *data) {};//c

#define Security_PodWrapper_Wrapper_overlay_POD_1 \
static Wrapper &overlay(POD &data){ };//c

#define Security_PodWrapper_const_Wrapper_overlay_const_POD_1 \
static const Wrapper &overlay(const POD &data) {};//c

};

class auto_array_HYS{

public://data

#define Security_auto_array_mArray \
T *mArray;//c

public://func

#define Security_auto_array_get \
T *get() { };//c

#define Security_auto_array_auto_array \
auto_array() : mArray(NULL) {};//c

#define Security_auto_array_auto_array_size_t \
auto_array(size_t inSize) : mArray(new T[inSize]) {};//c

};

}//Security

#endif//HYS_SECURITYT_UTILITURES_UTILITIRS_H
