#ifndef HYS_SERVERS_BOOTSTRAP_H
#define HYS_SERVERS_BOOTSTRAP_H

#define BOOTSTRAP_SUCCESS 1//?
#define BOOTSTRAP_STATUS_INACTIVE 2//?
#define BOOTSTRAP_STATUS_ACTIVE 3//?
#define BOOTSTRAP_STATUS_ON_DEMAND 4//?
#define BOOTSTRAP_PER_PID_SERVICE 5//?
#define BOOTSTRAP_UNKNOWN_SERVICE 6//?
#define BOOTSTRAP_MAX_NAME_LEN 7//?
#define BOOTSTRAP_NAME_IN_USE 8//?
#define BOOTSTRAP_NO_MEMORY 9//?
#define BOOTSTRAP_SERVICE_ACTIVE 10//?
#define BOOTSTRAP_NOT_PRIVILEGED 11//?

//////////////////////////
typedef char name_t[BOOTSTRAP_MAX_NAME_LEN];//c
typedef name_t * name_array_t;//c
typedef boolean_t *bool_array_t;//c
///////////////


const char *bootstrap_strerror(kern_return_t r) __attribute__((__nothrow__, __pure__, __warn_unused_result__));//c
kern_return_t bootstrap_look_up( mach_port_t bp, name_t service_name, mach_port_t *sp);//c
kern_return_t bootstrap_check_in(mach_port_t bp,name_t service_name,mach_port_t *sp);//c
extern mach_port_t bootstrap_port;//c

#endif //HYS_SERVERS_BOOTSTRAP_H

