#ifndef HYS_STDDEF_H
#define HYS_STDDEF_H

#ifndef NULL
#define NULL __DARWIN_NULL
#endif /* ! NULL */


//////////////////////////add start
#ifndef OC__darwin_wint_t
#define OC__darwin_wint_t
#if defined(__GNUC__) && defined(__WINT_TYPE__)
typedef __WINT_TYPE__		__darwin_wint_t;	
#else
typedef __darwin_ct_rune_t	__darwin_wint_t;	
#endif//c
//i386-_types.h/
#endif//OC__darwin_wint_t
///////////////add end

#ifndef	_WINT_T
#define	_WINT_T
typedef	__darwin_wint_t		wint_t;//c
#endif	/* _WINT_T */


//#if defined(__STDDEF_H__) || defined(__need_wchar_t)
#ifndef	__cplusplus
#ifndef	_WCHAR_T
#define	_WCHAR_T
typedef	__darwin_wchar_t	wchar_t;
#endif	/* _WCHAR_T */
#endif	/* __cplusplus */
//#endif /* __STDDEF_H__ || __need_wchar_t */

#endif//HYS_STDDEF_H
/////////////////////////////////////////////////////
#ifdef HYS_STDDEF_H_END
#undef HYS_STDDEF_H_END

#ifndef _PTRDIFF_T
#define _PTRDIFF_T
typedef	__darwin_ptrdiff_t	ptrdiff_t;//c
#endif /* _PTRDIFF_T */


#ifdef offsetof
    #undef offsetof
#endif    

#if defined(__GNUC__) && (__GNUC__ == 3 && __GNUC_MINOR__ >= 5 || __GNUC__ > 3)
	#ifndef __offsetof	/* Deprecated: for source compatability only */
		#define __offsetof(type, field) __builtin_offsetof(type, field)
	#endif
//#ifdef OC_offsetof
	#define __builtin_offsetof(type, field)  ((size_t)(&((type *)0)->field))
//#endif
	#define offsetof(type, field) __builtin_offsetof(type, field)
#else /* ! (gcc >= 3.5) */
	#ifndef __offsetof	/* Deprecated: for source compatability only */
		#define __offsetof(type, field) ((size_t)(&((type *)0)->field))
	#endif
#define offsetof(type, field) ((size_t)(&((type *)0)->field))
#endif /* (gcc >= 3.5) */

#endif //HYS_STDDEF_H_END
/////////////////////
#ifdef __need_wint_t
#undef __need_wint_t

#ifndef	_WINT_T
#define	_WINT_T
typedef	__darwin_wint_t		wint_t;//c
#endif	/* _WINT_T */
#endif //__need_wint_t
///////////////////
