#ifndef HYS_STDIO_H
#define HYS_STDIO_H

#define	EOF	(-1)//c

#if __DARWIN_UNIX03
#define	stdin	__stdinp
#define	stdout	__stdoutp
#define	stderr	__stderrp
#else /* !__DARWIN_UNIX03 */

#ifndef stdin
#define stdin	(&__sF[0])
#endif

#ifndef stdout
#define stdout	(&__sF[1])
#endif

#ifndef stderr
#define stderr	(&__sF[2])
#endif

#endif /* __DARWIN_UNIX03 *///c
///////////////////////////////////////////

#ifndef OC_struct___sFILE
#define OC_struct___sFILE
struct __sFILE {
	struct __sFILEX *_extra;//c
};
#endif

#ifndef OC_TYPE_FILE
#define OC_TYPE_FILE
typedef struct __sFILE FILE;
#endif

#ifndef   _SIZE_T
#define   _SIZE_T
typedef   __darwin_size_t      size_t;//c
#endif

#ifndef _VA_LIST
#define _VA_LIST
typedef __darwin_va_list	va_list;//c
#endif

///////////////////////
extern FILE __sF[];//c
int	 printf(const char * __restrict, ...) __DARWIN_LDBL_COMPAT(printf);//c

#ifndef native_snprintf
int	 snprintf(char * __restrict, size_t, const char * __restrict, ...) __DARWIN_LDBL_COMPAT(snprintf);//c
#endif

int	 fprintf(FILE * __restrict, const char * __restrict, ...) __DARWIN_LDBL_COMPAT(fprintf);//c

#ifndef native_sprintf
int	 sprintf(char * __restrict, const char * __restrict, ...) __DARWIN_LDBL_COMPAT(sprintf);//c
#endif

#endif//HYS_STDIO_H
