#ifndef HYS_STUFF_SEG_ADDR_TABLE_H
#define HYS_STUFF_SEG_ADDR_TABLE_H


#define NEXT_FLAT_ADDRESS_TO_ASSIGN  "<<< Next flat address to assign >>>"//c
#define NEXT_SPLIT_ADDRESS_TO_ASSIGN "<<< Next split address to assign >>>"//c
#define NEXT_DEBUG_ADDRESS_TO_ASSIGN "<<< Next debug address to assign >>>"//c
#define FIXED_ADDRESS_AND_SIZE "<<< Fixed address and size not to assign >>>"//c

////////////////////

struct seg_addr_table {
    	unsigned long seg1addr;//c
    	unsigned long segs_read_write_addr;//c
    	enum bool split;//c
    	unsigned long segs_read_only_addr;//c
    	char *install_name;//c
    	unsigned long line;//c
};

/////////////////////
extern struct seg_addr_table * parse_seg_addr_table(
    char *file_name,
    char *flag,
    char *argument,
    unsigned long *table_size);//c

#endif//HYS_STUFF_SEG_ADDR_TABLE_H
