#ifndef HYS_SYS_DTRACE_H
#define HYS_SYS_DTRACE_H

#define DTRACEMNR_HELPER        "dtracehelper" //c
#define DTRACEHIOC              (('d' << 24) | ('t' << 16) | ('h' << 8))//c

#if !defined(__APPLE__)
#define DTRACEHIOC_ADDDOF       (DTRACEHIOC | 3)//c
#define DTRACEHIOC_REMOVE       (DTRACEHIOC | 2)//c
#else
#define DTRACEHIOC_ADDDOF	_IOW('h', 4, user_addr_t)//c
#define DTRACEHIOC_REMOVE	_IO('h', 2)	//c
#endif /* __APPLE__ */

///////////

#define DTRACE_MODNAMELEN 1//?

/////////////////////////////
struct dof_helper { 
 	char dofhp_mod[DTRACE_MODNAMELEN]; //c
        uint64_t dofhp_dof;//c
   	uint64_t dofhp_addr;  //c
};
typedef struct dof_helper dof_helper_t;

struct dof_ioctl_data { 
	uint64_t dofiod_count;//c
	dof_helper_t dofiod_helpers[1];//c
};
typedef struct dof_ioctl_data dof_ioctl_data_t;

#endif//HYS_SYS_DTRACE_H
