#ifndef HYS_SYS_FCNTL_H
#define HYS_SYS_FCNTL_H

///////////////////

#define F_LOG2PHYS 1//?
#define O_EVTONLY  2//?
#define F_NOCACHE 3//?
#define O_EXLOCK 4//?
#define O_SHLOCK 5//?
#define F_ALLOCATEALL 6//?
#define F_PEOFPOSMODE 7//?
#define F_PREALLOCATE 8//?
#define F_SETSIZE 9//?
#define F_ALLOCATECONTIG 12//?
#define F_READBOOTSTRAP 13//?
#define F_WRITEBOOTSTRAP 14//?
#define F_FULLFSYNC 15//?
#define O_SYMLINK 22//??
#define F_RDADVISE 23//?
#define S_IFWHT 24//?

/////////////////////////
#define FWRITE 	0x0002//c
#define FREAD 0x0001//c
#define _FILESEC_UNSET_PROPERTY	((void *)0)//c

#ifndef S_IFMT
#define	S_IFMT		0170000
#endif

#ifndef S_IFLNK
#define	S_IFLNK		0120000
#endif

#ifndef S_IFDIR
#define	S_IFDIR		0040000	
#endif

#ifndef S_IFREG
#define	S_IFREG		0100000	
#endif

#ifndef S_IRUSR
#define	S_IRUSR		0000400	
#endif

#ifndef S_IWUSR
#define	S_IWUSR		0000200	
#endif

#ifndef O_NOFOLLOW
#define O_NOFOLLOW  0x0100  
#endif

#define	S_ISTXT		S_ISVTX//c

/////////////
#ifndef __off_t_defined
#define __off_t_defined
#ifndef _OFF_T
typedef __darwin_off_t	off_t;//c
#define _OFF_T
#endif//_OFF_T
#endif //__off_t_defined

#ifndef _SIZE_T
#define _SIZE_T
typedef __darwin_size_t	size_t;//c
#endif

#ifndef _FILESEC_T
struct _filesec;
typedef struct _filesec	*filesec_t;//c
#define _FILESEC_T
#endif

//////////
struct fbootstraptransfer { 
  	off_t fbt_offset;//c
  	size_t fbt_length;//c
  	void *fbt_buffer;//c
};
typedef struct fbootstraptransfer fbootstraptransfer_t;

 enum  filesec_property_t { 
	FILESEC_ACL = 5,//c
	FILESEC_MODE = 4,//c
	FILESEC_OWNER = 1,//c
	FILESEC_GROUP = 2,//c
	FILESEC_UUID = 3,//c
	FILESEC_GRPUUID = 6,//c
};
typedef enum filesec_property_t filesec_property_t;

struct radvisory {
       off_t   ra_offset;
       int     ra_count;
};//c

#endif//HYS_SYS_FCNTL_H
