#ifndef HYS_SYS_GMON_H
#define HYS_SYS_GMON_H

#define GMON_MAGIC 1//?
#define GMON_MAGIC_64 2//?
#define GMONTYPE_SAMPLES 3//?
#define GMONTYPE_RAWARCS 4//?
#define GMONTYPE_ARCS_ORDERS 5//?
#define GMONTYPE_DYLD_STATE 6//?
#define GMONTYPE_DYLD2_STATE 7//?
#define GMONVERSION 8//?

////////////////
struct gmon_data { 
    	uint32_t type;//c
    	uint32_t size;//c
};
typedef struct gmon_data gmon_data_t;

struct gmonhdr {
	uint32_t lpc;//c
	uint32_t hpc;//c
	uint32_t ncnt;//c
	int32_t version;//c
	int32_t profrate;	//c
	int32_t spare[3];//c
};

struct gmonhdr_64 {
	uint64_t lpc;//c
	uint64_t hpc;//c
	uint32_t ncnt;//c
	int32_t version;//c
	int32_t profrate;	//c
	int32_t spare[3];//c
};

struct rawarc {
	uint32_t	raw_frompc;//c
	uint32_t	raw_selfpc;//c
	int32_t		raw_count;//c
};

struct rawarc_64 {
	uint64_t	raw_frompc;//c
	uint64_t	raw_selfpc;//c
	int32_t		raw_count;//c
};

struct rawarc_order {
 	uint32_t	raw_frompc;//c
    	uint32_t	raw_selfpc;//c
    	uint32_t	raw_count;//c
    	uint32_t	raw_order;//c
};

struct rawarc_order_64 {
  	uint64_t	raw_frompc;//c
    	uint64_t	raw_selfpc;//c
    	uint32_t	raw_count;//c
    	uint32_t	raw_order;//c
};

#endif//HYS_SYS_GMON_H
