#ifndef HYS_SYS_LOADABLE_FS_H
#define HYS_SYS_LOADABLE_FS_H

#define FSUR_INVAL		(-6)//c
#define FS_DIR_LOCATION		"/System/Library/Filesystems"//c
#define FSUR_IO_FAIL		(-4)//c
#define FSUC_PROBE		'p'//c
#define DEVICE_READONLY		"readonly"//c
#define DEVICE_WRITABLE		"writable"//c
#define DEVICE_FIXED		"fixed"//c
#define DEVICE_REMOVABLE	"removable"//c
#define FS_DIR_SUFFIX		".fs"//c
#define FSUR_RECOGNIZED		(-1)//c
#define FSUR_UNRECOGNIZED	(-2)//c
#define FSUR_IO_SUCCESS		(-3)//c
#define FSUC_MOUNT		'm'//c
#define FSUC_MOUNT_FORCE	'M'//c
#define FSUC_UNMOUNT		'u'//c
#define FSUR_LOADERR		(-7)//c
#define FS_NAME_SUFFIX		".name"//c
#define FS_LABEL_SUFFIX		".label"//c

//////////////////////////

#endif //HYS_SYS_LOADABLE_FS_H
