#ifndef HYS_SYS_PROC_H
#define HYS_SYS_PROC_H

#define SZOMB 1//?
#define P_TRACED 2//?
#define P_WEXIT 3//?
#define P_PPWAIT 4//?
#define P_SYSTEM 5//?
#define P_NOSWAP 6//?
#define P_PHYSIO 7//?
#define P_CONTROLT 8//?
#define P_ADVLOCK 9//?
#define P_LP64 10//?
#define P_NOCLDSTOP 11//?
#define P_PROFIL 12//?
#define P_SELECT 13//?
#define P_CONTINUED 14//?
#define P_SUGID 15//?
#define P_TIMEOUT 16//?
#define P_RESV3 17//?
#define P_EXEC 18//?
#define P_OWEUPC 19//?
#define P_AFFINITY 20//?
#define P_TRANSLATED 21//?
#define P_RESV5 22//?
#define P_CHECKOPENEVT 23//?
#define P_DEPENDENCY_CAPABLE 24//?
#define P_REBOOT 25//?
#define P_TBE 26//?
#define P_RESV7 27//?
#define P_THCWD 28//?
#define P_RESV9 29//?
#define P_RESV10 30//?
#define P_RESV11 31//?
#define P_NOSHLIB 32//?
#define P_FORCEQUOTA 33//?
#define P_NOCLDWAIT 34//?
#define P_NOREMOTEHANG 35//?

/////////////////
#ifndef extern_proc_DEF
#define extern_proc_DEF
struct extern_proc {
	union {
		struct timeval __p_starttime;//c
	} p_un;
	char	p_comm[MAXCOMLEN+1];//c
	pid_t	p_pid;//c
	char	p_stat;//c
	int p_flag;//c
	u_short	p_acflag;//c
	u_int	p_estcpu;//c
	int	p_traceflag;//c
	struct	vnode *p_tracep;//c
	u_char	p_usrpri;//c
	char	p_nice;//c
	void	*p_wchan;//c
	struct	rusage *p_ru;//c
	u_int	p_swtime;	//c
	int	p_siglist;//c
	sigset_t p_sigmask;//c
	u_int	p_slptime;	//c
	pid_t	e_tpgid;//c
	u_short	p_xstat;//c
	char	*p_wmesg;//c
};
#endif//extern_proc_DEF

#define p_starttime p_un.__p_starttime//c
//////////
extern proc_t kernproc;//c
int proc_pid(proc_t a);//c
int proc_selfpid(void);//c

#endif //HYS_SYS_PROC_H
