#ifndef HYS_TIME_H
#define HYS_TIME_H

#ifndef __time_t_defined
#define __time_t_defined
#ifndef	_TIME_T
#define	_TIME_T
typedef	__darwin_time_t		time_t;//c
#endif//_TIME_T
#endif//__time_t_defined

#ifndef	_SIZE_T
#define	_SIZE_T
typedef	__darwin_size_t		size_t;
#endif

#ifndef __clock_t_defined
#define __clock_t_defined
#ifndef	_CLOCK_T
#define _CLOCK_T
typedef	__darwin_clock_t	clock_t;//c
#endif//_CLOCK_T
#endif //__clock_t_defined

///////////////////////////
#ifndef OC_struct_tm
#define OC_struct_tm
struct tm { 
	int	tm_hour;//c
	int	tm_min;//c
	int	tm_sec;//c
	int	tm_wday;//c
	int	tm_mon;//c
	int	tm_mday;//c
	int	tm_year;//c
	int	tm_isdst;//c
};
#endif//OC_struct_tm
//////////////////////

clock_t clock(void) __DARWIN_ALIAS(clock);//c
double difftime(time_t, time_t);//c

#ifndef OC_mktime
time_t mktime(struct tm *) __DARWIN_ALIAS(mktime);//c
#endif

#ifndef OC_asctime
char *asctime(const struct tm *);//c
#endif

#ifndef OC_gmtime
struct tm *gmtime(const time_t *);//c
#endif

#ifndef OC_localtime
struct tm *localtime(const time_t *);//c
#endif

#ifndef OC_strftime
size_t strftime(char * __restrict, size_t, const char * __restrict, const struct tm * __restrict) __DARWIN_ALIAS(strftime);//c
#endif

time_t time(time_t *);//c
char *ctime(const time_t *);//c


#endif//HYS_TIME_H
