#ifndef HYS_UFS_FFS_FS_H
#define HYS_UFS_FFS_FS_H

#define UFS_LABEL_MAGIC		{ 'L', 'A', 'B', 'L' }//c
#define UFS_LABEL_OFFSET	(BBSIZE - UFS_LABEL_SIZE) //c
#define	SBOFF		((off_t)(BBOFF + BBSIZE))//c
//////////////////////
#define UFS_LABEL_SIZE 1//?
#define UFS_LABEL_VERSION 3//?
#define UFS_MAX_LABEL_NAME 4//?
#define SBSIZE 5//?
#define FS_MAGIC 7//?
#define BBSIZE 8//?

////////////////////
struct ufslabel{
	u_int32_t ul_magic;//c
	u_int16_t ul_checksum;//c
	u_int64_t ul_uuid;//c
    	u_int32_t		ul_version;//c
    	u_int16_t		ul_namelen;//c
};

struct fs{
	int32_t fs_magic;//c
	int32_t fs_bsize;//c
	int32_t fs_fsize;//c
};

#endif //HYS_UFS_FFS_FS_H

