#ifndef IOKIT_FIREWIRE_IOFWDCL_H
#define IOKIT_FIREWIRE_IOFWDCL_H

#include <IOKit/firewire/IOFireWireFamilyCommon.h>

#include <libkern/c++/OSObject.h>
#include <libkern/c++/OSSet.h>
#include <IOKit/IOTypes.h>

class IODCLProgram ;
class OSIterator ;
class IOFireWireLink ;
class IOMemoryMap ;

#include <HYS/IOKit/firewire/IOFWDCL.h>
class IOFWDCL : public OSObject,public IOFWDCL_HYS
{
	OSDeclareAbstractStructors( IOFWDCL ) ;
	
	public:
		class InternalData 
		{
			public:
		} ;

	protected:
	public:
	public:
public :
	protected :
	
		friend class IOFWDCLFriend ;
		
	public :
	public:
} ;

class IOFWReceiveDCL : public IOFWDCL
{
	OSDeclareAbstractStructors( IOFWReceiveDCL )

	protected :
	public:
	public :
	protected :
} ;

class IOFWSendDCL : public IOFWDCL
{
	OSDeclareAbstractStructors( IOFWSendDCL )

	protected:
	public:
	public :
	protected :
} ;

class IOFWSkipCycleDCL : public IOFWDCL
{
	OSDeclareAbstractStructors( IOFWSkipCycleDCL )

	public:
	protected :
} ;

#endif//.IOKIT_FIREWIRE_IOFWDCL_H
