
#ifndef _IOKIT_IOFWDCLPROGRAM_H
#define _IOKIT_IOFWDCLPROGRAM_H

#include <libkern/c++/OSObject.h>
#include <IOKit/firewire/IOFireWireFamilyCommon.h>
#include <IOKit/firewire/IOFireWireBus.h>
#include <IOKit/IOMemoryCursor.h>

#include <HYS/IOKit/firewire/IOFWDCLProgram.h>
class IODCLProgram : public OSObject,public IODCLProgram_HYS
{
    OSDeclareAbstractStructors(IODCLProgram)

private :	
protected:

/*ExpansionData


protected

struct ExpansionData { 
    IOFWIsochResourceFlags resourceFlags; 
}; 
Discussion 

This structure will be used to expand the capablilties of the class in the future.*/
struct ExpansionData { 
    IOFWIsochResourceFlags resourceFlags; 
};

/*fExpansionData


See Also:
reserved
protected

ExpansionData * fExpansionData; 
Discussion 

Reserved for future use. (Internal use only)*/

ExpansionData * fExpansionData; 

public :
IODCLProgram_generateBufferMap
IODCLProgram_virtualToPhysical
IODCLProgram_init 
IODCLProgram_free
IODCLProgram_pause
IODCLProgram_resume
IODCLProgram_getBufferMap
IODCLProgram_setForceStopProc
IODCLProgram_setIsochResourceFlags
IODCLProgram_getIsochResourceFlags

};

#endif /* ! _IOKIT_IOFWDCLPROGRAM_H */

