#ifndef _IOKIT_IOFireWireLink_H
#define _IOKIT_IOFireWireLink_H

#include <IOKit/firewire/IOFireWireFamilyCommon.h>
#include <IOKit/IOService.h>
#include <IOKit/IOFilterInterruptEventSource.h>
#include <IOKit/firewire/IOFireWireController.h>


struct IOFWNodeScan;
class IOFWDCLPool ;
class IODCLProgram ;

#include <HYS/IOKit/firewire/IOFireWireLink.h>
class IOFireWireLink : public IOService,public IOFireWireLink_HYS
{
    OSDeclareAbstractStructors(IOFireWireLink)

protected:
public:
IOFireWireLink_createController
IOFireWireLink_createWorkLoop
IOFireWireLink_createDeviceNub
IOFireWireLink_getController
IOFireWireLink_asyncPHYPacket
IOFireWireLink_configureAsyncRobustness
IOFireWireLink_createDCLPool 
IOFireWireLink_createBufferFillIsochPort
IOFireWireLink_getFireWireWorkLoop
IOFireWireLink_setPingTransmits
IOFireWireLink_getPingTimes
IOFireWireLink_getPingTransmits
IOFireWireLink_getWorkLoop
IOFireWireLink_handleAsyncCompletion
IOFireWireLink_notifyInvalidSelfIDs
IOFireWireLink_setLinkMode
IOFireWireLink_getCycleTimeAndUpTime
IOFireWireLink_isPhysicalAccessEnabledForNodeID
IOFireWireLink_enterLoggingMode
IOFireWireLink_disablePHYPortOnSleep
IOFireWireLink_handleSystemShutDown

private:
protected:
};


#endif /* ! _IOKIT_IOFireWireLink_H */

