#ifndef _IOKIT_IOFIREWIRENUB_H
#define _IOKIT_IOFIREWIRENUB_H


#include <IOKit/IOService.h>
#include <IOKit/firewire/IOFWCommand.h>
#include <IOKit/firewire/IOFWAddressSpace.h>

class IOFireWireController;
class IOFireWireBus;
class IOConfigDirectory;
class IOFireWireNub;
class IOFireWireDevice;
class IOFireWireUnit;
class IOFWSimplePhysicalAddressSpace;
class IOFWSimpleContiguousPhysicalAddressSpace;

#include <HYS/IOKit/firewire/IOFireWireNub.h>

class IOFireWireNubAux : public OSObject,public IOFireWireNubAux_HYS
{
    OSDeclareDefaultStructors(IOFireWireNubAux)

	friend class IOFireWireNub;
	
protected:	
private:
public://add

IOFireWireNubAux_isPhysicalAccessEnabled
IOFireWireNubAux_getTerminationState
IOFireWireNubAux_hopCount_
IOFireWireNubAux_free
IOFireWireNubAux_hopCount
IOFireWireNubAux_setTerminationState
IOFireWireNubAux_createSimplePhysicalAddressSpace
IOFireWireNubAux_createSimpleContiguousPhysicalAddressSpace
IOFireWireNubAux_init

};

class IOFireWireNub : public IOService,public IOFireWireNub_HYS
{
    OSDeclareAbstractStructors(IOFireWireNub)

    friend class IOFireWireController;
    friend class IOFireWireNubAux;
	friend class IOFireWireDeviceAux;
	friend class IOFireWireUnitAux;
	friend class IOFireWireDevice;
	friend class IOFireWireUnit;

protected:
public:

IOFireWireNub_createCompareAndSwapCommand
IOFireWireNub_getBus
IOFireWireNub_getController
IOFireWireNub_createWriteCommand
IOFireWireNub_setNodeFlags
IOFireWireNub_setConfigDirectory
IOFireWireNub_createPseudoAddressSpace
IOFireWireNub_createReadQuadCommand
IOFireWireNub_createWriteQuadCommand
IOFireWireNub_createPhysicalAddressSpace
IOFireWireNub_getConfigDirectoryRef
IOFireWireNub_getConfigDirectory
IOFireWireNub_createReadCommand
IOFireWireNub_setMaxPackLog
IOFireWireNub_maxPackLog_const_IOFireWireNub
IOFireWireNub_maxPackLog_FWAddress
IOFireWireNub_maxPackLog
IOFireWireNub_FWSpeed_const_IOFireWireNub
IOFireWireNub_FWSpeed
IOFireWireNub_getNodeIDGeneration
IOFireWireNub_getNodeIDGeneration_UInt16
IOFireWireNub_free
IOFireWireNub_createAuxiliary
IOFireWireNub_clearNodeFlags
IOFireWireNub_init
IOFireWireNub_getUniqueID
IOFireWireNub_getNodeFlags

private:

};

#endif /* ! _IOKIT_IOFIREWIRENUB_H */
