#ifndef _IOKIT_IOFIREWIREUNIT_H
#define _IOKIT_IOFIREWIREUNIT_H


#include <IOKit/firewire/IOFireWireNub.h>

class IOFireWireDevice;
class IOFireWireUnit;

#include <HYS/IOKit/firewire/IOFireWireUnit.h>
class IOFireWireUnitAux : public IOFireWireNubAux,public IOFireWireUnitAux_HYS
{
    OSDeclareDefaultStructors(IOFireWireUnitAux)

	friend class IOFireWireUnit;
	
protected:
private:
public://add

IOFireWireUnitAux_free
IOFireWireUnitAux_isPhysicalAccessEnabled
IOFireWireUnitAux_createSimpleContiguousPhysicalAddressSpace
IOFireWireUnitAux_createSimplePhysicalAddressSpace
IOFireWireUnitAux_init

};


class IOFireWireUnit : public IOFireWireNub,public IOFireWireUnit_HYS
{
    OSDeclareDefaultStructors(IOFireWireUnit)

	friend class IOFireWireUnitAux;
	friend class IOFireWireDevice;

public:

IOFireWireUnit_setMaxSpeed
IOFireWireUnit_getNodeFlags
IOFireWireUnit_setConfigDirectory
IOFireWireUnit_free
IOFireWireUnit_terminateUnitThreadFunc
IOFireWireUnit_clearNodeFlags
IOFireWireUnit_message
IOFireWireUnit_matchPropertyTable
IOFireWireUnit_setNodeFlags
IOFireWireUnit_handleOpen
IOFireWireUnit_handleClose
IOFireWireUnit_terminateUnit
IOFireWireUnit_createPhysicalAddressSpace
IOFireWireUnit_createAuxiliary
IOFireWireUnit_attach
IOFireWireUnit_createPseudoAddressSpace
IOFireWireUnit_init

protected:
private:
};

#endif /* ! _IOKIT_IOFIREWIREDEVICE_H */
