
#ifndef __IOLOCALCONFIGDIRECTORY_H__
#define __IOLOCALCONFIGDIRECTORY_H__

#include <libkern/c++/OSObject.h>
#include <IOKit/IOReturn.h>
#include <IOKit/firewire/IOFireWireFamilyCommon.h>
#include <IOKit/firewire/IOConfigDirectory.h>

class OSArray;
class OSData;
class IOFireWireController;
class IOFWUserObjectExporter ;

#include <HYS/IOKit/firewire/IOLocalConfigDirectory.h>
class IOLocalConfigDirectory : public IOConfigDirectory,public IOLocalConfigDirectory_HYS
{
	friend class IOFireWireController;

	OSDeclareDefaultStructors(IOLocalConfigDirectory);

protected:
public:

IOLocalConfigDirectory_exporterCleanup
IOLocalConfigDirectory_removeSubDir
IOLocalConfigDirectory_addEntry_FWAddress
IOLocalConfigDirectory_addEntry_OSData
IOLocalConfigDirectory_addEntry_IOLocalConfigDirectory
IOLocalConfigDirectory_addEntry_OSString
IOLocalConfigDirectory_addEntry
IOLocalConfigDirectory_incrementGeneration
IOLocalConfigDirectory_compile
IOLocalConfigDirectory_getEntries
IOLocalConfigDirectory_getIndexValue
IOLocalConfigDirectory_checkROMState
IOLocalConfigDirectory_updateROMCache
IOLocalConfigDirectory_create
IOLocalConfigDirectory_unlockData
IOLocalConfigDirectory_lockData
IOLocalConfigDirectory_getBase
IOLocalConfigDirectory_free
IOLocalConfigDirectory_init

/*update


public

virtual IOReturn update(
    UInt32 offset,
    const UInt32 *&romBase); 
Return Value

kIOReturnSuccess if the specified offset is now accessible at romBase[offset]. 
Discussion 

makes sure that the ROM has at least the specified capacity, and that the ROM is up-to-date from its start to at least the specified quadlet offset.*/
virtual IOReturn update(
    UInt32 offset,
    const UInt32 *&romBase); 

private:
};

#endif /* __IOLOCALCONFIGDIRECTORY_H__ */
