#ifndef __IOREMOTECONFIGDIRECTORY_H__
#define __IOREMOTECONFIGDIRECTORY_H__

#include <libkern/c++/OSObject.h>
#include <IOKit/IOReturn.h>

#include <IOKit/firewire/IOFireWireFamilyCommon.h>
#include <IOKit/firewire/IOConfigDirectory.h>

#include "IOFireWireROMCache.h"

class OSString;
class OSIterator;
class IOFireWireDevice;

#include <HYS/IOKit/firewire/IORemoteConfigDirectory.h>

class IORemoteConfigDirectory : public IOConfigDirectory,public IORemoteConfigDirectory_HYS
{
    OSDeclareDefaultStructors(IORemoteConfigDirectory);

protected:
public:

IORemoteConfigDirectory_checkROMState
IORemoteConfigDirectory_updateROMCache
IORemoteConfigDirectory_unlockData
IORemoteConfigDirectory_lockData
IORemoteConfigDirectory_getSubDir
IORemoteConfigDirectory_update
IORemoteConfigDirectory_getBase
IORemoteConfigDirectory_free
IORemoteConfigDirectory_withOwnerOffset
IORemoteConfigDirectory_initWithOwnerOffset

private:
};


#endif /* __IOREMOTECONFIGDIRECTORY_H__ */
