
#ifndef _IOKIT_IODISPLAY_H
#define _IOKIT_IODISPLAY_H

#include <IOKit/IOService.h>
#include <IOKit/graphics/IOFramebuffer.h>

class IODisplayParameterHandler;//add

#include <HYS/IOKit/graphics/IODisplay.h>

class IODisplayConnect : public IOService,public IODisplayConnect_HYS
{
    OSDeclareDefaultStructors(IODisplayConnect)

private:

protected:
public:

IODisplayConnect_joinPMtree
IODisplayConnect_initWithConnection
IODisplayConnect_getFramebuffer
IODisplayConnect_setAttributeForConnection
IODisplayConnect_getAttributeForConnection
IODisplayConnect_getConnection

};

class IODisplay : public IOService,public IODisplay_HYS
{
    OSDeclareAbstractStructors(IODisplay)


protected:
private:
public:

IODisplay_makeDisplayUsable
IODisplay_maxCapabilityForDomainState
IODisplay_initialPowerStateForDomainState
IODisplay_powerStateForDomainState
IODisplay_setPowerState
IODisplay_dropOneLevel
IODisplay_doDataSet
IODisplay_setProperties
IODisplay_updateNumber
IODisplay_setForKey
IODisplay_getConnectFlagsForDisplayMode
IODisplay_free
IODisplay_removeParameterHandler
IODisplay__framebufferEvent
IODisplay_initPowerManagement
IODisplay_doUpdate
IODisplay_addParameterHandler
IODisplay_readFramebufferEDID
IODisplay_stop
IODisplay_start
IODisplay_getGammaTableByIndex
IODisplay_doIntegerSet
IODisplay_getIntegerRange
IODisplay_getConnection
IODisplay_addParameter
IODisplay_setParameter
IODisplay_probe
IODisplay_initialize
IODisplay_framebufferEvent

};


class IOBacklightDisplay : public IODisplay,public IOBacklightDisplay_HYS
{
    OSDeclareDefaultStructors(IOBacklightDisplay)

protected:
public:

IOBacklightDisplay_powerStateForDomainState
IOBacklightDisplay_initialPowerStateForDomainState
IOBacklightDisplay_doIntegerSet
IOBacklightDisplay_handlePMSettingCallback
IOBacklightDisplay_setBrightness
IOBacklightDisplay_initPowerManagement
IOBacklightDisplay_setPowerState
IOBacklightDisplay_probe
IOBacklightDisplay_stop
IOBacklightDisplay_maxCapabilityForDomainState

private:
};

class IODisplayParameterHandler : public IOService,public IODisplayParameterHandler_HYS
{
    OSDeclareDefaultStructors(IODisplayParameterHandler)

public:

private:
};



#endif //_IOKIT_IODISPLAY_H
