#ifndef _IOKIT_IOGRAPHICSLIB_H
#define _IOKIT_IOGRAPHICSLIB_H

#ifdef __cplusplus
extern "C" {
#endif

#include <IOKit/IOKitLib.h>
#include <IOKit/graphics/IOFramebufferShared.h>
#include <IOKit/graphics/IOGraphicsInterface.h>
#include <IOKit/graphics/IOGraphicsPrivate.h>//add

#ifdef __cplusplus
}
#endif

#include <HYS/IOKit/graphics/IOGraphicsLib.h>

/*IODisplayDictionaryOptions


enum { 
    kIODisplayMatchingInfo = 0x00000100, 
    kIODisplayOnlyPreferredName = 0x00000200, 
    kIODisplayNoProductName = 0x00000400 
};  
Constants
kIODisplayMatchingInfo
Include only the keys necessary to match two displays with IODisplayMatchDictionaries().
kIODisplayOnlyPreferredName
The kDisplayProductName property includes only the localized names returned by CFBundleCopyPreferredLocalizationsFromArray().
kIODisplayNoProductName
The kDisplayProductName property is not included in the returned dictionary.*/

enum { 
    kIODisplayMatchingInfo = 0x00000100, 
    kIODisplayOnlyPreferredName = 0x00000200, 
    kIODisplayNoProductName = 0x00000400 
};  

#endif /* ! _IOKIT_IOGRAPHICSLIB_H */

