

#ifndef	_IOHIDSYSTEM_H
#define _IOHIDSYSTEM_H


#include <IOKit/IOTimerEventSource.h>
#include <IOKit/IOInterruptEventSource.h>
#include <IOKit/IOService.h>
#include <IOKit/IOMessage.h>
#include <IOKit/IOUserClient.h>
#include <IOKit/IOWorkLoop.h>
#include <IOKit/IOCommandGate.h>
#include <IOKit/IOBufferMemoryDescriptor.h>
#include <IOKit/pwr_mgt/IOPM.h>
#include <IOKit/graphics/IOGraphicsDevice.h>
#include <IOKit/hidsystem/IOHIDevice.h>
#include <IOKit/hidsystem/IOHIDShared.h>
#include <IOKit/hidsystem/IOHIDTypes.h>
#include <IOKit/hidsystem/IOLLEvent.h>
#include <IOKit/IODataQueue.h>
#include <IOKit/hid/IOHIDEvent.h>
#include <IOKit/hidsystem/ev_keymap.h>


class IOHIDKeyboardDevice;
class IOHIDPointingDevice;

#include <HYS/IOKit/hidsystem/IOHIDSystem.h>

class IOHIDSystem : public IOService,public IOHIDSystem_HYS
{
	OSDeclareDefaultStructors(IOHIDSystem);

	friend class IOHIDUserClient;
	friend class IOHIDParamUserClient;

private:


public:



};

#endif //_IOHIDSYSTEM_H
