
#ifndef _IOPCICONFIGURATOR_H
#define _IOPCICONFIGURATOR_H

#include <IOKit/IOLib.h>
#include <IOKit/pci/IOPCIBridge.h>

#include <HYS/IOKit/pci/IOPCIConfigurator.h>

class IOPCIConfigurator : public IOService,public IOPCIConfigurator_HYS
{
    OSDeclareDefaultStructors( IOPCIConfigurator );

protected:
public:

IOPCIConfigurator_pciWriteLatencyTimer
IOPCIConfigurator_start
IOPCIConfigurator_createRoot
IOPCIConfigurator_checkPCIConfiguration
IOPCIConfigurator_free
IOPCIConfigurator_pciBridgeScanBus
IOPCIConfigurator_pciBridgeCheckConfiguration
IOPCIConfigurator_pciBridgeAllocateResource
IOPCIConfigurator_pciBridgeDistributeResource
IOPCIConfigurator_pciBridgeConstructDeviceTree
IOPCIConfigurator_constructAddressingProperties
IOPCIConfigurator_constructProperties
IOPCIConfigurator_configRead32
IOPCIConfigurator_matchDTEntry
IOPCIConfigurator_matchACPIEntry
IOPCIConfigurator_pciBridgeConnectDeviceTree
IOPCIConfigurator_pciBridgeProbeChild
IOPCIConfigurator_configWrite32
IOPCIConfigurator_configWrite8
IOPCIConfigurator_pciRangeAppendSubRange
IOPCIConfigurator_pciBridgeDistributeResourceType
IOPCIConfigurator_pciDeviceProbeRanges
IOPCIConfigurator_pciBridgeClipRanges
IOPCIConfigurator_pciApplyConfiguration
IOPCIConfigurator_pciDisableAccess
IOPCIConfigurator_configRead16
IOPCIConfigurator_configWrite16
IOPCIConfigurator_pciRestoreAccess
IOPCIConfigurator_pciDeviceApplyConfiguration
IOPCIConfigurator_pciBridgeApplyConfiguration
IOPCIConfigurator_configRead8
IOPCIConfigurator_pciBridgeAddChild
IOPCIConfigurator_pciBridgeProbeRanges
IOPCIConfigurator_pciYentaProbeRanges
IOPCIConfigurator_pciCheckCacheLineSize
IOPCIConfigurator_safeProbeCallback
IOPCIConfigurator_pciProbeBaseAddressRegister
IOPCIConfigurator_pciSafeProbeBaseAddressRegister
IOPCIConfigurator_pciBridgeProbeBusRange

};


#endif /* !_IOPCICONFIGURATOR_H */
