#ifndef _IOPMKEYS_H_
#define _IOPMKEYS_H_

/*kIOPMPowerEventTimeKey


Key for the time of the scheduled power event. Value is a CFDateRef.

#define kIOPMPowerEventTimeKey "time" */
#define kIOPMPowerEventTimeKey "time"

/*kIOPMPowerEventTypeKey


Key for the type of power event. Value is a CFStringRef, with the c-string value of one of the "kIOPMAuto" strings.

#define kIOPMPowerEventTypeKey "eventtype" */
#define kIOPMPowerEventTypeKey "eventtype"

/*kIOPMAutoWakeOrPowerOn


Value for scheduled wake from sleep, or power on. The system will either wake OR power on, whichever is necessary.

#define kIOPMAutoWakeOrPowerOn "wakepoweron" */
#define kIOPMAutoWakeOrPowerOn "wakepoweron" 

/*kIOPMAutoPowerOn


Value for scheduled power on from off state.

#define kIOPMAutoPowerOn "poweron" */
#define kIOPMAutoPowerOn "poweron"

/*kIOPMAutoShutdown


Value for scheduled shutdown.

#define kIOPMAutoShutdown "shutdown" */
#define kIOPMAutoShutdown "shutdown" 

/*kIOPMAutoSleep


Value for scheduled sleep.

#define kIOPMAutoSleep "sleep" */
#define kIOPMAutoSleep "sleep" 

/*kIOPMAutoWake


Value for scheduled wake from sleep.

#define kIOPMAutoWake "wake" */
#define kIOPMAutoWake "wake" 

/*kIOPMAutoRestart


Value for scheduled restart.

#define kIOPMAutoRestart "restart" */
#define kIOPMAutoRestart "restart" 

/*kIOPMPowerEventAppNameKey


Key for the CFBundleIdentifier of the app that scheduled the power event. Value is a CFStringRef.

#define kIOPMPowerEventAppNameKey "scheduledby" */
#define kIOPMPowerEventAppNameKey "scheduledby"

#endif//_IOPMKEYS_H_

