
#ifndef _IOKIT_IOFIREWIRESBP2LUN_H
#define _IOKIT_IOFIREWIRESBP2LUN_H

#include <IOKit/IOService.h>
#include <IOKit/IOCommandGate.h>

#include <IOKit/firewire/IOFireWireUnit.h>

#include <IOKit/sbp2/IOFireWireSBP2Login.h>
#include <IOKit/sbp2/IOFireWireSBP2ManagementORB.h>

class IOFireWireSBP2Target;

#include <HYS/IOKit/sbp2/IOFireWireSBP2LUN.h>
class IOFireWireSBP2LUN : public IOService,public IOFireWireSBP2LUN_HYS
{
    OSDeclareDefaultStructors( IOFireWireSBP2LUN );

	friend class IOFireWireSBP2ManagementORB;
	friend class IOFireWireSBP2Login;
	friend class IOFireWireSBP2UserClient;
	
protected: 
public:

IOFireWireSBP2LUN_removeLogin
IOFireWireSBP2LUN_createLoginAction
IOFireWireSBP2LUN_staticCreateLogin
IOFireWireSBP2LUN_getTarget
IOFireWireSBP2LUN_getLUNumber
IOFireWireSBP2LUN_resumeNotify
IOFireWireSBP2LUN_staticRemoveManagementORBAction
IOFireWireSBP2LUN_matchPropertyTable
IOFireWireSBP2LUN_initLoginWithLUN
IOFireWireSBP2LUN_initMgmtORBWithLUN
IOFireWireSBP2LUN_removeManagementORBAction
IOFireWireSBP2LUN_suspendedNotify
IOFireWireSBP2LUN_staticRemoveLoginAction
IOFireWireSBP2LUN_removeLoginAction
IOFireWireSBP2LUN_clearAllTasksInSet
IOFireWireSBP2LUN_staticCreateManagementORBAction
IOFireWireSBP2LUN_createManagementORBAction
IOFireWireSBP2LUN_removeManagementORB
IOFireWireSBP2LUN_terminateNotify
IOFireWireSBP2LUN_message
IOFireWireSBP2LUN_handleOpen
IOFireWireSBP2LUN_finalize
IOFireWireSBP2LUN_executeFlushAllMgmtORBs
IOFireWireSBP2LUN_handleClose
IOFireWireSBP2LUN_staticExecuteFlushAllMgmtORBs
IOFireWireSBP2LUN_createLogin
IOFireWireSBP2LUN_getFireWireUnit
IOFireWireSBP2LUN_createManagementORB
IOFireWireSBP2LUN_flushAllManagementORBs
IOFireWireSBP2LUN_free
IOFireWireSBP2LUN_getDiagnostics
IOFireWireSBP2LUN_attach

private:

};

#endif //_IOKIT_IOFIREWIRESBP2LUN_H

