#ifndef _IOKIT_IOFIREWIRESBP2TARGET_H
#define _IOKIT_IOFIREWIRESBP2TARGET_H

#include <IOKit/firewire/IOFireWireUnit.h>
#include <IOKit/IOService.h>

#include <HYS/IOKit/sbp2/IOFireWireSBP2Target.h>
class IOFireWireSBP2Target : public IOService,public IOFireWireSBP2Target_HYS
{
    OSDeclareDefaultStructors(IOFireWireSBP2Target);

protected:
public:

IOFireWireSBP2Target_clearMgmtAgentAccess
IOFireWireSBP2Target_cancelMgmtAgentAccess
IOFireWireSBP2Target_completeMgmtAgentAccess
IOFireWireSBP2Target_beginIOCriticalSection
IOFireWireSBP2Target_configurePhysicalFilter
IOFireWireSBP2Target_synchMgmtAgentAccess
IOFireWireSBP2Target_clearTargetFlags
IOFireWireSBP2Target_setTargetFlags
IOFireWireSBP2Target_matchPropertyTable
IOFireWireSBP2Target_endIOCriticalSection
IOFireWireSBP2Target_getTargetFlags
IOFireWireSBP2Target_createLUN
IOFireWireSBP2Target_handleIsOpen
IOFireWireSBP2Target_handleClose
IOFireWireSBP2Target_handleOpen
IOFireWireSBP2Target_message
IOFireWireSBP2Target_free
IOFireWireSBP2Target_finalize
IOFireWireSBP2Target_stop
IOFireWireSBP2Target_scanForLUNs
IOFireWireSBP2Target_getFireWireUnit
IOFireWireSBP2Target_start

};

#endif//_IOKIT_IOFIREWIRESBP2TARGET_H


