
#ifndef _IOKIT_IOFIREWIRESBP2USERCLIENT_H
#define _IOKIT_IOFIREWIRESBP2USERCLIENT_H

#include <IOKit/IOUserClient.h>

#define FIREWIREPRIVATE
#include <IOKit/firewire/IOFireWireController.h>
#undef FIREWIREPRIVATE

#include <IOKit/sbp2/IOFireWireSBP2UserClientCommon.h>
#include <IOKit/sbp2/IOFireWireSBP2LUN.h>

#include <HYS/IOKit/sbp2/IOFireWireSBP2UserClient.h>
class IOFireWireSBP2UserClient : public IOUserClient,public IOFireWireSBP2UserClient_HYS
{
    OSDeclareDefaultStructors(IOFireWireSBP2UserClient)

protected:
public:

IOFireWireSBP2UserClient_setMgmtORBManageeLogin
IOFireWireSBP2UserClient_setMgmtORBCommandFunction
IOFireWireSBP2UserClient_submitMgmtORB
IOFireWireSBP2UserClient_releaseMgmtORB
IOFireWireSBP2UserClient_setMgmtORBCallback
IOFireWireSBP2UserClient_createMgmtORB
IOFireWireSBP2UserClient_LSIWorkaroundSyncBuffersForInput
IOFireWireSBP2UserClient_LSIWorkaroundSyncBuffersForOutput
IOFireWireSBP2UserClient_LSIWorkaroundSetCommandBuffersAsRanges
IOFireWireSBP2UserClient_setCommandBlock
IOFireWireSBP2UserClient_releaseCommandBuffers
IOFireWireSBP2UserClient_setCommandBuffersAsRanges
IOFireWireSBP2UserClient_setToDummy
IOFireWireSBP2UserClient_setCommandGeneration
IOFireWireSBP2UserClient_setCommandTimeout
IOFireWireSBP2UserClient_setORBRefCon
IOFireWireSBP2UserClient_setMaxORBPayloadSize
IOFireWireSBP2UserClient_setCommandFlags
IOFireWireSBP2UserClient_submitORB
IOFireWireSBP2UserClient_releaseORB
IOFireWireSBP2UserClient_mgmtORBCallback
IOFireWireSBP2UserClient_setPassword
IOFireWireSBP2UserClient_setFetchAgentWriteCompletion
IOFireWireSBP2UserClient_setBusyTimeoutRegisterValue
IOFireWireSBP2UserClient_createORB
IOFireWireSBP2UserClient_staticMgmtORBCallback
IOFireWireSBP2UserClient_setMgmtORBResponseBuffer
IOFireWireSBP2UserClient_enableUnsolicitedStatus
IOFireWireSBP2UserClient_ringDoorbell
IOFireWireSBP2UserClient_fetchAgentResetComplete
IOFireWireSBP2UserClient_fetchAgentWriteComple
IOFireWireSBP2UserClient_setMgmtORBManageeORB
IOFireWireSBP2UserClient_submitFetchAgentReset
IOFireWireSBP2UserClient_setMaxPayloadSize
IOFireWireSBP2UserClient_staticFetchAgentResetComplete
IOFireWireSBP2UserClient_getMgmtORBAsyncCallbackReference
IOFireWireSBP2UserClient_flushAllManagementORBs
IOFireWireSBP2UserClient_setMgmtORBAsyncCallbackReference
IOFireWireSBP2UserClient_setReconnectTime
IOFireWireSBP2UserClient_getLoginID
IOFireWireSBP2UserClient_getMaxCommandBlockSize
IOFireWireSBP2UserClient_setLoginFlags
IOFireWireSBP2UserClient_releaseLogin
IOFireWireSBP2UserClient_submitLogout
IOFireWireSBP2UserClient_staticFetchAgentWriteComplete
IOFireWireSBP2UserClient_createLogin
IOFireWireSBP2UserClient_statusNotify
IOFireWireSBP2UserClient_staticStatusNotify
IOFireWireSBP2UserClient_setStatusNotify
IOFireWireSBP2UserClient_unsolicitedNotify
IOFireWireSBP2UserClient_staticUnsolicitedNotify
IOFireWireSBP2UserClient_submitLogin
IOFireWireSBP2UserClient_loginCallback
IOFireWireSBP2UserClient_staticLoginCallback
IOFireWireSBP2UserClient_message
IOFireWireSBP2UserClient_staticLogoutCallback
IOFireWireSBP2UserClient_logoutCallback
IOFireWireSBP2UserClient_clientDied
IOFireWireSBP2UserClient_clientClose
IOFireWireSBP2UserClient_checkArguments
IOFireWireSBP2UserClient_setLogoutCallback
IOFireWireSBP2UserClient_setLoginCallback
IOFireWireSBP2UserClient_setMessageCallback
IOFireWireSBP2UserClient_getSessionRef
IOFireWireSBP2UserClient_openWithSessionRef
IOFireWireSBP2UserClient_setUnsolicitedStatusNotify
IOFireWireSBP2UserClient_close
IOFireWireSBP2UserClient_open
IOFireWireSBP2UserClient_externalMethod
IOFireWireSBP2UserClient_start
IOFireWireSBP2UserClient_initWithTask

};

#endif //_IOKIT_IOFIREWIRESBP2USERCLIENT_H

