//hys add fime
#ifndef OC_IOKIT_SMBUS_IOSMBUSCONTROLLER_H
#define OC_IOKIT_SMBUS_IOSMBUSCONTROLLER_H

#include <IOKit/IOCommandGate.h>

enum {
	kIOSMBusProtocolWriteWord,
	kIOSMBusProtocolReadWord,
	kIOSMBusProtocolWriteBlock,
	kIOSMBusProtocolReadBlock,
	kIOSMBusProtocolWriteByte,
	kIOSMBusProtocolReadByte,
	kIOSMBusProtocolSendByte,
	kIOSMBusStatusOK,
	kIOSMBusStatusUnknownFailure,
	kIOSMBusStatusDeviceAddressNotAcknowledged,
	kIOSMBusStatusDeviceError,
	kIOSMBusStatusDeviceCommandAccessDenied,
	kIOSMBusStatusUnknownHostError,
	kIOSMBusStatusTimeout,
	kIOSMBusStatusBusy,
	kIOSMBusStatusHostUnsupportedProtocol,
	kIOMessageSMBusAlarm,
	kIOSMBusStatusPECError,
	kIOSMBusMaxDataCount,
	kIOSMBusStatusDeviceAccessDenied,
};

///////////////
struct IOSMBusTransaction {
	int address;
	int command;
	int protocol;
	int sendDataCount;
	int sendData[1];
	int status;
	int receiveDataCount;
	uint8_t receiveData[1];
};
typedef struct IOSMBusTransaction IOSMBusTransaction;

struct IOSMBusAlarmMessage {
	int fromAddress;
	int data[1];
};
typedef struct IOSMBusAlarmMessage IOSMBusAlarmMessage;

typedef int IOSMBusTransactionCompletion;
typedef int IOSMBusStatus;

/////////////////////
class IOSMBusController {
    OSDeclareDefaultStructors(IOSMBusController)
public://func

inline int performTransaction(IOSMBusTransaction* a, IOSMBusTransactionCompletion b, OSObject* c, void* d=0) {};

};


#endif//OC_IOKIT_SMBUS_IOSMBUSCONTROLLER_H

