#ifndef _IOCDBLOCKSTORAGEDEVICE_H
#define _IOCDBLOCKSTORAGEDEVICE_H

#include <IOKit/storage/IOCDTypes.h>

//#ifdef KERNEL
#ifdef __cplusplus

#include <IOKit/storage/IOBlockStorageDevice.h>

#include <HYS/IOKit/storage/IOCDBlockStorageDevice.h>

class IOCDBlockStorageDevice : public IOBlockStorageDevice ,public IOCDBlockStorageDevice_HYS
{

    OSDeclareAbstractStructors(IOCDBlockStorageDevice)

protected:

public:
IOCDBlockStorageDevice_readTrackInfo
IOCDBlockStorageDevice_audioPause
IOCDBlockStorageDevice_audioPlay
IOCDBlockStorageDevice_audioScan
IOCDBlockStorageDevice_getAudioVolume
IOCDBlockStorageDevice_readDiscInfo
IOCDBlockStorageDevice_readTOC
IOCDBlockStorageDevice_setSpeed
IOCDBlockStorageDevice_init
IOCDBlockStorageDevice_getSpeed
IOCDBlockStorageDevice_audioStop
IOCDBlockStorageDevice_getAudioStatus
IOCDBlockStorageDevice_setAudioVolume
IOCDBlockStorageDevice_readTOC_IOMemoryDescriptor

};

#endif /* __cplusplus */
//#endif /* KERNEL */
#endif /* !_IOCDBLOCKSTORAGEDEVICE_H */

