#ifndef _IOKIT_IOUSBCOMMAND_H
#define _IOKIT_IOUSBCOMMAND_H

#include <IOKit/IOCommand.h>
#include <IOKit/IOMemoryDescriptor.h>
#include <IOKit/IODMACommand.h>
#include <IOKit/usb/USB.h>

#include <HYS/IOKit/usb/IOUSBCommand.h>
class IOUSBCommand : public IOCommand,public IOUSBCommand_HYS
{
    OSDeclareAbstractStructors(IOUSBCommand)

protected:
public:
IOUSBCommand_NewCommand
IOUSBCommand_init
IOUSBCommand_free
IOUSBCommand_SetSelector
IOUSBCommand_SetRequest
IOUSBCommand_SetAddress
IOUSBCommand_SetEndpoint
IOUSBCommand_SetDirection
IOUSBCommand_SetType
IOUSBCommand_SetBufferRounding
IOUSBCommand_SetBuffer
IOUSBCommand_SetClientCompletion
IOUSBCommand_SetUSLCompletion
IOUSBCommand_SetDataRemaining
IOUSBCommand_SetStage
IOUSBCommand_SetStatus
IOUSBCommand_SetOrigBuffer
IOUSBCommand_SetDisjointCompletion
IOUSBCommand_SetDblBufLength
IOUSBCommand_SetNoDataTimeout
IOUSBCommand_SetCompletionTimeout
IOUSBCommand_GetUIMScratch
IOUSBCommand_GetCompletionTimeout
IOUSBCommand_SetUIMScratch
IOUSBCommand_GetNoDataTimeout
IOUSBCommand_SetMultiTransferTransaction
IOUSBCommand_SetReqCount
IOUSBCommand_SetRequestMemoryDescriptor
IOUSBCommand_SetBufferMemoryDescriptor
IOUSBCommand_SetFinalTransferInTransaction
IOUSBCommand_SetUseTimeStamp
IOUSBCommand_SetTimeStamp
IOUSBCommand_SetIsSyncTransfer
IOUSBCommand_SetBufferUSBCommand
IOUSBCommand_GetSelector
IOUSBCommand_GetRequest
IOUSBCommand_GetAddress
IOUSBCommand_GetDirection
IOUSBCommand_GetEndpoint
IOUSBCommand_GetType
IOUSBCommand_GetBufferRounding
IOUSBCommand_GetBuffer
IOUSBCommand_GetUSLCompletion
IOUSBCommand_GetClientCompletion
IOUSBCommand_GetDataRemaining
IOUSBCommand_GetStage
IOUSBCommand_GetStatus
IOUSBCommand_GetOrigBuffer
IOUSBCommand_GetDisjointCompletion
IOUSBCommand_GetDblBufLength
IOUSBCommand_GetReqCount
IOUSBCommand_GetRequestMemoryDescriptor
IOUSBCommand_GetMultiTransferTransaction
IOUSBCommand_GetFinalTransferInTransaction
IOUSBCommand_GetBufferMemoryDescriptor
IOUSBCommand_GetTimeStamp
IOUSBCommand_GetUseTimeStamp
IOUSBCommand_GetIsSyncTransfer

};

///////////////////////
class IOUSBIsocCommand : public IOCommand,public IOUSBIsocCommand_HYS
{
    OSDeclareAbstractStructors(IOUSBIsocCommand)

protected:
public:
IOUSBIsocCommand_NewCommand
IOUSBIsocCommand_free
IOUSBIsocCommand_init

};


#endif//_IOKIT_IOUSBCOMMAND_H

