#ifndef IOUSBHIDDRIVER_H
#define IOUSBHIDDRIVER_H

#include <IOKit/IOBufferMemoryDescriptor.h>

#include <IOKit/hid/IOHIDDevice.h>

#include <IOKit/usb/IOUSBBus.h>
#include <IOKit/usb/IOUSBInterface.h>
#include <IOKit/usb/USB.h>

#include <HYS/IOKit/usb/IOUSBHIDDriver.h>
class IOUSBHIDDriver : public IOHIDDevice,public IOUSBHIDDriver_HYS
{
    OSDeclareDefaultStructors(IOUSBHIDDriver)

private:
public:
IOUSBHIDDriver_init
IOUSBHIDDriver_stop
IOUSBHIDDriver_free
IOUSBHIDDriver_SetReport
IOUSBHIDDriver_GetHexChar
IOUSBHIDDriver_LogMemReport
IOUSBHIDDriver_GetReport
IOUSBHIDDriver_ChangeOutstandingIO
IOUSBHIDDriver_IsPortSuspended
IOUSBHIDDriver_start
IOUSBHIDDriver_IncrementOutstandingIO
IOUSBHIDDriver_SetIdleMillisecs
IOUSBHIDDriver_SetProtocol
IOUSBHIDDriver_message
IOUSBHIDDriver_CheckForDeadDeviceEntry
IOUSBHIDDriver_ClearFeatureEndpointHaltEntry
IOUSBHIDDriver_HandleReportEntry
IOUSBHIDDriver_InitializeUSBHIDPowerManagement
IOUSBHIDDriver_StartFinalProcessing
IOUSBHIDDriver_DecrementOutstandingIO
IOUSBHIDDriver_RearmInterruptRead
IOUSBHIDDriver_willTerminate
IOUSBHIDDriver_didTerminate
IOUSBHIDDriver_maxCapabilityForDomainState
IOUSBHIDDriver_powerStateWillChangeTo
IOUSBHIDDriver_setPowerState
IOUSBHIDDriver_powerStateDidChangeTo
IOUSBHIDDriver_AbortAndSuspend
IOUSBHIDDriver_processPacket
IOUSBHIDDriver_SuspendPort
IOUSBHIDDriver_ClaimPendingRead
IOUSBHIDDriver_powerChangeDone
IOUSBHIDDriver_handleStart
IOUSBHIDDriver_handleStop
IOUSBHIDDriver_newLocationIDNumber
IOUSBHIDDriver_setReport
IOUSBHIDDriver_InterruptReadHandlerWithTimeStampEntry
IOUSBHIDDriver_newManufacturerString
IOUSBHIDDriver_GetIndexedString
IOUSBHIDDriver_newCountryCodeNumber
IOUSBHIDDriver_CheckForDeadDevice
IOUSBHIDDriver_getReport
IOUSBHIDDriver_newProductIDNumber
IOUSBHIDDriver_newProductString
IOUSBHIDDriver_newReportDescriptor
IOUSBHIDDriver_GetHIDDescriptor
IOUSBHIDDriver_newSerialNumberString
IOUSBHIDDriver_newTransportString
IOUSBHIDDriver_newVendorIDNumber
IOUSBHIDDriver_newVersionNumber
IOUSBHIDDriver_InterruptReadHandlerEntry
IOUSBHIDDriver_InterruptReadHandler
IOUSBHIDDriver_HandleReport
IOUSBHIDDriver_newIndexedString
IOUSBHIDDriver_ClearFeatureEndpointHalt
IOUSBHIDDriver_SuspendPortTimer
IOUSBHIDDriver_getMaxReportSize

};

#endif	// IOUSBHIDDRIVER_H
