
#ifndef _IOKIT_IOUSBMASSSTORAGECLASS_H
#define _IOKIT_IOUSBMASSSTORAGECLASS_H

#include <IOKit/IOLib.h>
#include <IOKit/IOService.h>
#include <IOKit/IOMemoryDescriptor.h>
#include <IOKit/IOMessage.h>
#include <IOKit/usb/IOUSBInterface.h>
#include <IOKit/usb/IOUSBPipe.h>
#include <IOKit/usb/USBSpec.h>
#include <IOKit/usb/USB.h>
#include <IOKit/scsi/IOSCSIProtocolServices.h>

#include <HYS/IOKit/usb/IOUSBMassStorageClass.h>
class IOUSBMassStorageClass : public IOSCSIProtocolServices,public IOUSBMassStorageClass_HYS
{
    OSDeclareDefaultStructors(IOUSBMassStorageClass)
private:
protected:

struct ExpansionData {
	IOUSBMassStorageClass_ExpansionData
	};
    ExpansionData *				reserved;


protected:

public:

IOUSBMassStorageClass_AbortSCSICommandForCBIProtocol
IOUSBMassStorageClass_SendSCSICommandForCBIProtocol
IOUSBMassStorageClass_GetCBIRequestBlock
IOUSBMassStorageClass_CBIProtocolUSBCompletionAction
IOUSBMassStorageClass_GetInterruptPipe
IOUSBMassStorageClass_GetInterfaceReference
IOUSBMassStorageClass_ReleaseCBIRequestBlock
IOUSBMassStorageClass_CBIProtocolCommandCompletion
IOUSBMassStorageClass_CBIProtocolTransferData
IOUSBMassStorageClass_GetBulkInPipe
IOUSBMassStorageClass_GetBulkOutPipe
IOUSBMassStorageClass_CBIProtocolReadInterrupt
IOUSBMassStorageClass_CBIGetStatusEndpointStatus
IOUSBMassStorageClass_GetStatusEndpointStatus
IOUSBMassStorageClass_CBIClearFeatureEndpointStall
IOUSBMassStorageClass_ClearFeatureEndpointStall
IOUSBMassStorageClass_CompleteSCSICommand
IOUSBMassStorageClass_GetControlPipe
IOUSBMassStorageClass_GetInterfaceSubclass
IOUSBMassStorageClass_init
IOUSBMassStorageClass_start
IOUSBMassStorageClass_SetInterfaceReference
IOUSBMassStorageClass_SetMaxLogicalUnitNumber
IOUSBMassStorageClass_GetInterfaceProtocol
IOUSBMassStorageClass_BeginProvidedServices
IOUSBMassStorageClass_HandleProtocolServiceFeature
IOUSBMassStorageClass_stop
IOUSBMassStorageClass_EndProvidedServices
IOUSBMassStorageClass_message
IOUSBMassStorageClass_free
IOUSBMassStorageClass_willTerminate
IOUSBMassStorageClass_sResetDevice
IOUSBMassStorageClass_sWaitForTaskAbort
IOUSBMassStorageClass_sAbortCurrentSCSITask
IOUSBMassStorageClass_FinishDeviceRecovery
IOUSBMassStorageClass_didTerminate
IOUSBMassStorageClass_sWaitForReset
IOUSBMassStorageClass_GetMaxLogicalUnitNumber
IOUSBMassStorageClass_SendSCSICommand
IOUSBMassStorageClass_SendSCSICommandForBulkOnlyProtocol
IOUSBMassStorageClass_AbortSCSICommand
IOUSBMassStorageClass_AbortSCSICommandForBulkOnlyProtocol
IOUSBMassStorageClass_IsProtocolServiceSupported
IOUSBMassStorageClass_GetBulkOnlyRequestBlock
IOUSBMassStorageClass_ReleaseBulkOnlyRequestBlock
IOUSBMassStorageClass_GetNextBulkOnlyCommandTag
IOUSBMassStorageClass_HandlePowerOn
IOUSBMassStorageClass_ResetDeviceNow
IOUSBMassStorageClass_AbortCurrentSCSITask
IOUSBMassStorageClass_handleOpen
IOUSBMassStorageClass_handleClose
IOUSBMassStorageClass_handleIsOpen
IOUSBMassStorageClass_GatedWaitForReset
IOUSBMassStorageClass_GatedWaitForTaskAbort
IOUSBMassStorageClass_StartDeviceRecovery
IOUSBMassStorageClass_DeviceRecoveryCompletionAction
IOUSBMassStorageClass_BulkOnlyUSBCompletionAction
IOUSBMassStorageClass_BulkOnlySendCBWPacket 
IOUSBMassStorageClass_BulkDeviceResetDevice
IOUSBMassStorageClass_BulkOnlyExecuteCommandCompletion
IOUSBMassStorageClass_BulkOnlyTransferData
IOUSBMassStorageClass_BulkOnlyReceiveCSWPacket

};//IOUSBMassStorageClass

#define _IOKIT_IOUSBMASSSTORAGECLASS_H_end 
#include <HYS/IOKit/usb/IOUSBMassStorageClass.h>
#undef _IOKIT_IOUSBMASSSTORAGECLASS_H_end

#endif //_IOKIT_IOUSBMASSSTORAGECLASS_H
