#ifndef _MSCKEY_H_
#define _MSCKEY_H_

#include <PCSC/musclecard.h>
#include <Msc/MscWrappers.h>
#include <Msc/MscTokenConnection.h>
#include <security_utilities/debugging.h>
#include <security_cdsa_utilities/cssmkey.h>

#include <HYS/Msc/MscKey.h>

class MscKey : public MscKeyInfo,public MscKey_HYS {
public:

MscKey_MscKey
MscKey_MscKey_unsigned_int
MscKey_MscKey_const_MSCKeyInfo

MscKey_connection
MscKey_computeCrypt
MscKey_exportKey
MscKey_debugDump
MscKey_importKey
MscKey_extAuthenticate
MscKey_convert

protected:

MscKey_mConnection

};

#endif /* !_MSCKEY_H_ */

