#ifndef  MOVIESFORMAT_H
#define MOVIESFORMAT_H

#include <CoreServices/CoreServices.h>
#include <QuickTime/Movies.h>


#include <AvailabilityMacros.h>

#include <HYS/QuickTime/MoviesFormat.h>

/*See Also

For general information about atoms, see Inside QuickTime: QuickTime File Format. 
'AllF' User data list entry atom to play all frames. 

struct MoviesUserData {
    long    size;
    long    udType;
    char    data[1];
};
Fields
size*/
struct MoviesUserData {
    long    size;
    long    udType;
    char    data[1];
};
typedef struct MoviesUserData  MoviesUserData;

/*See Also

For general information about atoms, see Inside QuickTime: QuickTime File Format. 
'udta' Holds one or more structures of movie user data. 

struct UserDataAtom {
    long              size;
    long              atomType;
    MoviesUserData    userData[1];
};
Fields
size*/
struct UserDataAtom {
    long              size;
    long              atomType;
    MoviesUserData    userData[1];
};
typedef struct UserDataAtom UserDataAtom;

#endif 
