#import <Foundation/Foundation.h>
#import <XgridFoundation/XGResource.h>

@class XGConnection;
@class XGControllerInternal;
@class XGGrid;

@interface XGController : XGResource

/*initWithConnection:


The designated initializer. 
- (id)initWithConnection:(XGConnection *)connection;
Parameter Descriptions
connection
The connection to be used by the receiver.
method result
An initialized instance.*/
- (id)initWithConnection:(XGConnection *)connection;

/* performSubmitJobActionWithJobSpecification:gridIdentifier:

Attempts to submit a job to the specified grid, or the default grid if no grid is specified.

    - (id)performSubmitJobActionWithJobSpecification:(NSDictionary *)jobSpecification 
            gridIdentifier:(NSString *)gridIdentifier;

method result
    An XGActionMontior instance for tracking the action progress. 
 */
    - (id)performSubmitJobActionWithJobSpecification:(NSDictionary *)jobSpecification 
            gridIdentifier:(NSString *)gridIdentifier;
			
 
@end

@interface XGController (XGControllerCreation)
@end
