#ifndef OS_OSUNSERIALIZE_H
#define OS_OSUNSERIALIZE_H

#include <sys/appleapiopts.h>

#ifdef __cplusplus
class OSObject;
class OSString;
#endif //__cplusplus

#include <HYS/libkern/c++/OSUnserialize.h>

#ifdef __cplusplus
/*OSUnserializeXML


Recreates an OS container object from its previously serialized OS container class instance data. 

extern OSObject* OSUnserializeXML(
    const char *buffer,
    OSString **errorString = 0);  
Parameters
buffer
Pointer to a buffer containing XML data representing the object to be recreated.
errorString
If this is a valid pointer and the XML parser finds an error in buffer, errorString contains text indicating the line number and type of error encountered.
Return Value

Returns a pointer to the recreated object, or zero on failure.*/
extern OSObject* OSUnserializeXML(
    const char *buffer,
    OSString **errorString = 0);  

#endif //__cplusplus

#endif//OS_OSUNSERIALIZE_H
