#ifndef	MACH_ERROR_H
#define	MACH_ERROR_H

//#include "/usr/include/mach/error.h"

#include <mach/kern_return.h>

#include <HYS/mach/error.h>

//#include <APPLE/mach/error.h>
/*err_sub

#define err_sub(x)  
Discussion 

The err_sub macro is defined as err_sub(x) (((x)&0xfff)<<14).*/
#define err_sub(x) (((x)&0xfff)<<14)

/*err_system

#define err_system(x)  
Discussion 

The err_system macro is defined as err_system(x) (((x)&0x3f)<<26).*/
#define err_system(x)  (((x)&0x3f)<<26)

/*Listing 5-1  Error.h system error values
#define     err_kern    err_system(0x0)     // kernel //
#define     err_us      err_system(0x1)     // user space library //
#define     err_server  err_system(0x2)     // user space servers //
#define     err_ipc     err_system(0x3)     // old ipc errors //
#define     err_mach_ipc err_system(0x4)    // mach-ipc errors //
#define     err_dipc    err_system(0x7)     // distributed ipc //
#define     err_local   err_system(0x3e)    // user defined errors //
#define     err_ipc_compat err_system(0x3f) // (compatibility) mach-ipc errors //
#define     err_max_system 0x3f*/
#define     err_local   err_system(0x3e)    // user defined errors //

#endif//MACH_ERROR_H

