#ifndef OC_BSD_MACHINE__TYPES_H_
#define OC_BSD_MACHINE__TYPES_H_

#if defined (__ppc__) || defined (__ppc64__)
#include "ppc/_types.h"
#elif defined (__i386__) || defined(__x86_64__)
#include "i386/_types.h"
#else
#error architecture not supported
#endif
////////////////////////////////////
#ifdef __CYGWIN__

#ifdef  OC__int32_t
#define  __int32_t linux__int32_t
#endif

#ifdef  OC__uint64_t
#define  __uint64_t linux__uint64_t
#endif

#ifdef  OC__int64_t
	#define __int64_t org__int64_t
#endif	

#ifdef OC__uint32_t
	#define  __uint32_t org__uint32_t
#endif
	
#ifdef OC__uint8_t
#define __uint8_t org___uint8_t	
#endif

#ifdef OC__uint16_t
#define  __uint16_t org___uint16_t
#endif

///////////////////
#include "/usr/include/machine/_types.h"
///////////////////////
#undef __uint16_t
#undef __uint8_t
#undef __uint32_t
#undef __int64_t
#undef   __int32_t 
#undef   __uint64_t 
#endif //__CYGWIN__
//////////////////////////////////////////

#endif /* OC_BSD_MACHINE__TYPES_H_ */
