#ifndef _NETINET_IN_H_
#define _NETINET_IN_H_

#include <sys/appleapiopts.h>
#include <sys/_types.h>
#include <stdint.h>	

#include <sys/socket.h>
#include <machine/endian.h>
#include <sys/_endian.h>

/////////////////

#ifdef __linux__
	#define in6_addr org_in6_addr
	#define sockaddr_in6 org_sockaddr_in6

#ifdef _IN_PORT_T
	#define in_port_t org_in_port_t
#else
	#define _IN_PORT_T
#endif

#ifdef OC_in6addr_any
	#define  in6addr_any org_in6addr_any
#else
	#define OC_in6addr_any
#endif

#define OC_native_in6addr_any

#define ipv6_mreq org_ipv6_mreq

#define in6addr_loopback org_in6addr_loopback
#endif//__linux__
////////////////
#include "/usr/include/netinet/in.h"
//////////////////

#ifdef in6addr_loopback
#undef in6addr_loopback
#endif

#ifdef ipv6_mreq 
	#undef ipv6_mreq
#endif

#ifdef in6addr_any
	#undef in6addr_any
#endif

#ifdef __linux__
	#undef s6_addr
	#undef s6_addr16
#endif//__linux__

#ifdef in_port_t
	#undef in_port_t
#endif

#ifdef in6_addr
#undef in6_addr
#endif

#ifdef sockaddr_in6
#undef sockaddr_in6
#endif

///////////////////
#define __KAME_NETINET_IN_H_INCLUDED_
#include <netinet6/in6.h>
#undef __KAME_NETINET_IN_H_INCLUDED_

#include <HYS/netinet/in.h>

#endif /* _NETINET_IN_H_ */
