#ifndef OC_OBJC_OBJC_API_H
#define OC_OBJC_OBJC_API_H

#include <AvailabilityMacros.h>

/////////////////////


#define Class org_Class
#define Method org_Method
#define Category org_Category
#define id org_id
#define objc_method_description org_objc_method_description
#define objc_protocol_list org_objc_protocol_list
#define object_copy org_object_copy
#define object_dispose org_object_dispose
#define objc_category  org_objc_category
#define objc_ivar org_objc_ivar
#define objc_ivar_list org_objc_ivar_list
#define objc_method org_objc_method
#define objc_method_list org_objc_method_list
#define Symtab org_Symtab
#define objc_symtab org_objc_symtab
#define Module org_Module
#define objc_module org_objc_module
//////////////////////

///////////
#define object_is_class new_object_is_class
////////////////////
//#ifdef ORG_OBJC
#include "/usr/GNUstep/System/Library/Headers/objc/objc-api.h"
//#endif
//////////////////
#undef object_is_class
static inline BOOL
object_is_class (Class object)
{
  return ((object != (Class)nil)  &&  CLS_ISMETA (object->class_pointer));
}//fixed
////////////////
#undef objc_module
#undef Module
#undef objc_symtab
#undef Symtab
#undef objc_method_list
#undef objc_method
#undef objc_ivar_list
#undef objc_ivar
#undef objc_category
#undef object_dispose
#undef object_copy
#undef objc_protocol_list
#undef objc_method_description
#undef id
#undef Category
#undef Class
#undef Method

///////////////
#include <HYS/objc/objc-api.h>


#define OC_objc_method_need
#include <HYS/objc/runtime.h>


#endif//OC_OBJC_OBJC_API_H
