#ifndef _H_CDSA_CLIENT_DLCLIENT
#define _H_CDSA_CLIENT_DLCLIENT  1

#include <security_cdsa_client/cssmclient.h>
#include <security_cdsa_client/dliterators.h>
#include <security_cdsa_client/aclclient.h>
#include <security_cdsa_client/DLDBList.h>
#include <security_cdsa_utilities/cssmacl.h>
#include <security_cdsa_utilities/cssmdb.h>
#include <security_cdsa_utilities/cssmdata.h>

#include <HYS/security_cdsa_client/dlclient.h>

namespace Security {
namespace CssmClient {

class DbImpl;
class DbMaker:public DbMaker_HYS {
public:
Security_CssmClient_DbMaker_newDb

};

class DbCursorImpl;
class DbCursorMaker:public DbCursorMaker_HYS{
public:

Security_CssmClient_DbCursorMaker_newDbCursor_const_CSSM_QUERY
Security_CssmClient_DbCursorMaker_newDbCursor_uint32

};

class DbUniqueRecordImpl;
class DbUniqueRecordMaker:public DbUniqueRecordMaker_HYS {
public:

Security_CssmClient_DbUniqueRecordMaker_newDbUniqueRecord

};


class DLImpl : public AttachmentImpl, public DbMaker,public DLImpl_HYS {
public:

Security_CssmClient_DLImpl_DLImpl_const_Guid
Security_CssmClient_DLImpl_DLImpl_const_Module

Security_CssmClient_DLImpl_newDb

private:
};

class DL : public Attachment ,public DL_HYS{
public:

Security_CssmClient_DL_OPERATOR

Security_CssmClient_DL_DL_Impl_TYPE

Security_CssmClient_DL_DL_Impl
Security_CssmClient_DL_DL
Security_CssmClient_DL_DL_const_Guid
Security_CssmClient_DL_DL_const_Module

};

class DbAttributes;
class DbUniqueRecord;
class Db;


class DbImpl : public ObjectImpl, public AclBearer,
	public DbCursorMaker, public DbUniqueRecordMaker,public DbImpl_HYS {
public:

Security_CssmClient_DbImpl_openParameters
Security_CssmClient_DbImpl_openParameters_const_void
Security_CssmClient_DbImpl_create

protected:
private:
};


class Db : public Object, public DLAccess,public Db_HYS {
public:


Securit_CssmClient_Db_Db_Impl_DATATYPE

Securit_CssmClient_Db_Db_Impl
Securit_CssmClient_Db_Db
Securit_CssmClient_Db_DbMaker

Securit_CssmClient_Db_OPERATOR

protected:
};

class DbCursorImpl : public ObjectImpl, public CssmAutoQuery {
public:
};

class DbCursor : public Object ,public DbCursor_HYS{
public:
Security_CssmClient_DbCursor_DbCursor_Impl_DATATYPE

Security_CssmClient_DbCursor_DbCursor_Impl
Security_CssmClient_DbCursor_DbCursor
Security_CssmClient_DbCursor_DbCursor_DbCursorMaker
Security_CssmClient_DbCursor_DbCursor_DbCursorMaker_uint32

};


class DbUniqueRecordImpl : public ObjectImpl {
public:
protected:
};

class DbUniqueRecord : public Object,public DbUniqueRecord_HYS {
public:

Security_CssmClient_DbUniqueRecord_DbUniqueRecord_Impl_DATATYPE

Security_CssmClient_DbUniqueRecord_DbUniqueRecord_Impl
Security_CssmClient_DbUniqueRecord_DbUniqueRecord
Security_CssmClient_DbUniqueRecord_DbUniqueRecord_DbUniqueRecordMaker

};

class DbAttributes : public CssmAutoDbRecordAttributeData
{
public:
};


class DbDbCursorImpl : public DbCursorImpl
{
public:
protected:
private:

};

} // end namespace CssmClient

} // end namespace Security

#endif // _H_CDSA_CLIENT_DLCLIENT
