#ifndef _H_CONTEXT
#define _H_CONTEXT

#include <security_utilities/utilities.h>
#include <security_utilities/debugging.h>
#include <security_cdsa_utilities/cssmalloc.h>
#include <security_cdsa_utilities/cssmwalkers.h>
#include <security_cdsa_utilities/cssmacl.h>
#include <security_cdsa_utilities/cssmdates.h>

#include <HYS/security_cdsa_utilities/context.h>

namespace Security {

class Context : public PodWrapper<Context, CSSM_CONTEXT> ,public Context_HYS{
public:



Security_Context_attributesInUse

public:
    class Attr : public PodWrapper<Attr, CSSM_CONTEXT_ATTRIBUTE>,public Context_Attr_HYS {
    public:
	Security_Context_Attr_operator_CssmCryptoData

	Security_Context_Attr_baseType
	Security_Context_Attr_type
    };

public:
Security_Context_operator1
Security_Context_Attr_operator
Security_Context_const_Attr_operator

Security_Context_algorithm
Security_Context_dump
Security_Context_type
Security_Context_getInt_CSSM_ATTRIBUTE_TYPE
Security_Context_getInt_CSSM_ATTRIBUTE_TYPE_uint32
Security_Context_getInt_CSSM_ATTRIBUTE_TYPE_CSSM_RETURN 
Security_Context_get
Security_Context_get_CSSM_RETURN

public:
public:
public:
    class Builder;
protected:
};


namespace DataWalkers {

} // end namespace DataWalkers

using namespace DataWalkers;

class Context::Builder: public Context_Builder_HYS {
protected:
public:

Security_Context_Builder_allocator

Security_Context_Builder_Builder
Security_Context_Builder_setup_T
Security_Context_Builder_setup_uint32
Security_Context_Builder_setup_CSSM_SIZE
Security_Context_Builder_setup_const_CSSM_CONTEXT_ATTRIBUTE
Security_Context_Builder_setup_const_Context_Attr
Security_Context_Builder_make
Security_Context_Builder_put
Security_Context_Builder_put_CSSM_ATTRIBUTE_TYPE
Security_Context_Builder_put_const_CSSM_CONTEXT_ATTRIBUTE
Security_Context_Builder_put_const_Context_Attr
Security_Context_Builder_done

public:
};

} // end namespace Security

#define  HYS_SECURITY_CDSA_UTILUITRS_CONTERX_H_END
#include <HYS/security_cdsa_utilities/context.h>
#undef HYS_SECURITY_CDSA_UTILUITRS_CONTERX_H_END

#endif //_H_CONTEXT
