#ifndef _H_CSSMLIST
#define _H_CSSMLIST

#include <security_utilities/utilities.h>
#include <security_cdsa_utilities/cssmalloc.h>
#include <security_cdsa_utilities/cssmwalkers.h>

#include <HYS/security_cdsa_utilities/cssmlist.h>

namespace Security {

class CssmList;
class TypedList;

class ListElement : public PodWrapper<ListElement, CSSM_LIST_ELEMENT>,public ListElement_HYS {
public:

Security_ListElement_toString
Security_ListElement_data
Security_ListElement_data_const

public:
};

} // end namespace Security


namespace Security {


class CssmList : public PodWrapper<CssmList, CSSM_LIST>,public CssmList_HYS {
public:

Security_CssmList_operator
Security_CssmList_operator1
Security_CssmList_operator2

Security_CssmList_length

public:
};

} // end namespace Security


namespace Security
{

class TypedList : public CssmList,public TypedList_HYS {
public:
Security_TypedList_overlay_CSSM_LIST
Security_TypedList_overlay_const_CSSM_LIST
Security_TypedList_type

};


namespace DataWalkers {



}	// end namespace DataWalkers
} 	// end namespace Security


#define HYS_SECURITY_CDSA_UTILTIES_CSSMLIST_H_END
#include <HYS/security_cdsa_utilities/cssmlist.h>
#undef HYS_SECURITY_CDSA_UTILTIES_CSSMLIST_H_END

#endif //_H_CSSMLIST
