#ifndef _H_HANDLEOBJECT
#define _H_HANDLEOBJECT

#include <Security/cssm.h>
#include <security_utilities/refcount.h>
#include <security_utilities/threading.h>
#include <security_utilities/globalizer.h>
#include <security_cdsa_utilities/cssmerrors.h>

#if __GNUC__ > 2
	#include <ext/hash_map>
	using __gnu_cxx::hash_map;
#else//__GNUC__
	#ifdef __linux__
		#include  <ext/hash_map>
		using __gnu_cxx::hash_map;
	#else//__linux__
		#include <hash_map>
	#endif//__linux__
#endif//__GNUC__

#include <HYS/security_cdsa_utilities/handleobject.h>

namespace Security {

class HandledObject:public HandledObject_HYS {
public:

Security_HandledObject_HandledObject_Handle
Security_HandledObject_HandledObject
Security_HandleObject_handle

protected:
private:

Security_HandledObject_mMyHandle
Security_HandledObject_mValid


};

class HandleObject : public HandledObject ,public HandleObject_HYS{
NOCOPY(HandleObject)
    	class State;

public:

Security_HandleObject_HandleObject

Security_HandleObject_find
Security_HandleObject_findAndKill

public:
protected:
private:

   	class State : public Mutex {
    	public:
    	private:
    	};
 
};

} // end namespace Security

#define HYS_SECUROITY_CDSA_UTILTIRS_HANDLEOBJECT_H_END
#include <HYS/security_cdsa_utilities/handleobject.h>
#undef HYS_SECUROITY_CDSA_UTILTIRS_HANDLEOBJECT_H_END



#endif //_H_HANDLEOBJECT
