#ifndef _H_IODEVICES
#define _H_IODEVICES

#include <security_utilities/mach++.h>
#include <security_utilities/machserver.h>
#include <security_utilities/cfutilities.h>
#include <IOKit/pwr_mgt/IOPMLib.h>

#include <HYS/security_utilities/iodevices.h>

namespace Security {
namespace IOKit {


class MasterPort : public MachPlusPlus::AutoPort {
public:
};

class Device :public Device_HYS{
public:
Security_IOKit_Device_mService

Security_IOKit_Device_Device
Security_IOKit_Device_Device_io_service_t

Security_IOKit_Device_ioObject
Security_IOKit_Device_property
Security_IOKit_Device_property_const_char
Security_IOKit_Device_path

Security_IOKit_Device_operator
Security_IOKit_Device_operator1

private:

};

class DeviceIterator:public DeviceIterator_HYS {
public:

Security_IOKit_DeviceIterator_mIterator
Security_IOKit_DeviceIterator_mAtEnd

Security_IOKit_DeviceIterator_DeviceIterator

Security_IOKit_DeviceIterator_operator

private:
};

class DeviceMatch : public CFRef<CFMutableDictionaryRef>,public DeviceMatch_HYS {
public:

Security_IOKit_DeviceMatch_DeviceMatch_CFMutableDictionaryRef
Security_IOKit_DeviceMatch_DeviceMatch
Security_IOKit_DeviceMatch_DeviceMatch_const_char
Security_IOKit_DeviceMatch_DeviceMatch_const_char_const_char
Security_IOKit_DeviceMatch_dict

};


class NotificationPort :public NotificationPort_HYS{
public:
	class Receiver {
		public:
	};
	
Security_IOKit_NotificationPort_mPortRef

Security_IOKit_NotificationPort_add
Security_IOKit_NotificationPort_port
Security_IOKit_NotificationPort_addInterestNotification
Security_IOKit_NotificationPort_source

private:
protected:

};


class MachPortNotificationPort : public NotificationPort, public MachPlusPlus::MachServer::NoReplyHandler {
public:
private:

};


} // end namespace MachPlusPlus
} // end namespace Security

#endif //_H_IODEVICES
