#ifndef  _H_POWERWATCH
#define _H_POWERWATCH

#include <security_utilities/machserver.h>
#include <IOKit/pwr_mgt/IOPMLib.h>

#include <HYS/security_utilities/powerwatch.h>

namespace Security {
namespace MachPlusPlus {

class PowerWatcher:public PowerWatcher_HYS {
public:

Security_MachPlusPlus_PowerWatcher_systemWillSleep
Security_MachPlusPlus_PowerWatcher_systemIsWaking

public:
};


class IOPowerWatcher : public PowerWatcher {
public:
protected:
};


class PortPowerWatcher : public IOPowerWatcher, public MachServer::NoReplyHandler {
public:
};


} // end namespace MachPlusPlus

} // end namespace Security


#endif //_H_POWERWATCH
