#ifndef _SECURITY_UTILITIES_SIMPLE_PREFS_H_
#define _SECURITY_UTILITIES_SIMPLE_PREFS_H_

#include <CoreFoundation/CFDictionary.h>
#include <CoreFoundation/CFString.h>
#include <security_utilities/utilities.h>

#include <HYS/security_utilities/simpleprefs.h>

namespace Security {

class Dictionary:public Dictionary_HYS {
	NOCOPY(Dictionary)
public:

Security_Dictionary_Dictionary
Security_Dictionary_Dictionary_const_char
Security_Dictionary_Dictionary_const_char_UserOrSystem
Security_Dictionary_Dictionary_CFDictionaryRef

Security_Dictionary_getBoolValue


protected:
};

class MutableDictionary : public Dictionary,public MutableDictionary_HYS {
	NOCOPY(MutableDictionary)
public:

Security_MutableDictionary_MutableDictionary
Security_MutableDictionary_MutableDictionary_const_char
Security_MutableDictionary_MutableDictionary_const_char_UserOrSystem
Security_MutableDictionary_MutableDictionary_CFDictionaryRef

Security_MutableDictionary_SetValue
Security_MutableDictionary_writePlistToPrefs

private:
};

}	/* end namespace Security */

#endif	/* _SECURITY_UTILITIES_SIMPLE_PREFS_H_ */
