#ifndef _H_TIMEFLOW
#define _H_TIMEFLOW

#include <sys/time.h>
#include <limits.h>
#include <math.h>

#include <HYS/security_utilities/timeflow.h>
namespace Security {
namespace Time {


class Interval :public Interval_HYS{
    friend class Absolute;
public:

Security_Time_Interval_Interval
Security_Time_Interval_Interval_int
Security_Time_Interval_Interval_double
Security_Time_Interval_Interval_time_t

private:

};

class Absolute {
    friend class Interval;
    friend Interval operator - (Absolute, Absolute);
    friend Absolute now();
    friend Absolute bigBang();
    friend Absolute heatDeath();
public:
private:
};

}	// end namespace Time
}	// end namespace Security

#define HYS_SECURITY_UTILTIUES_TIMEFLOW_H_END
#include <HYS/security_utilities/timeflow.h>
#undef HYS_SECURITY_UTILTIUES_TIMEFLOW_H_END

#endif //_H_TIMEFLOW
