#ifndef _H_UNIXPLUSPLUS
#define _H_UNIXPLUSPLUS

#include <security_utilities/utilities.h>
#include <security_utilities/errors.h>
#include <security_utilities/timeflow.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/uio.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <signal.h>
#include <fcntl.h>
#include <semaphore.h>
#include <cstdio>
#include <cstdarg>
#include <map>

#include <HYS/security_utilities/unix++.h>

namespace Security {
namespace UnixPlusPlus {


class IOVec : public iovec {
public:
};


class FileDesc:public FileDesc_HYS {
protected:

Security_UnixPlusPlus_FileDesc_FileDesc_int_bool 

public:

Security_UnixPlusPlus_FileDesc_FileDesc
Security_UnixPlusPlus_FileDesc_FileDesc_int
Security_UnixPlusPlus_FileDesc_FileDesc_const_char
Security_UnixPlusPlus_FileDesc_FileDesc_const_std_string
Security_UnixPlusPlus_FileDesc_fileSize
Security_UnixPlusPlus_FileDesc_readAll_void
Security_UnixPlusPlus_FileDesc_readAll_std_string
Security_UnixPlusPlus_FileDesc_writeAll_const_void
Security_UnixPlusPlus_FileDesc_writeAll_char
Security_UnixPlusPlus_FileDesc_writeAll_const_char 
Security_UnixPlusPlus_FileDesc_writeAll_const_Data

private:

Security_UnixPlusPlus_FileDesc_mFd

private:
protected:
Security_UnixPlusPlus_FileDesc_mAtEnd
Security_UnixPlusPlus_FileDesc_invalidFd

};

class AutoFileDesc : public FileDesc,public AutoFileDesc_HYS {
public:

Security_UnixPlusPlus_AutoFileDesc_AutoFileDesc
Security_UnixPlusPlus_AutoFileDesc_AutoFileDesc_int
Security_UnixPlusPlus_AutoFileDesc_AutoFileDesc_const_char
Security_UnixPlusPlus_AutoFileDesc_AutoFileDesc_const_std_string

};

class SigSet {
public:
private:

};


class StaticForkMonitor {
public:
protected:

};

class ForkMonitor : public StaticForkMonitor {
public:

};


}	// end namespace UnixPlusPlus
}	// end namespace Security


#endif //_H_UNIXPLUSPLUS
