#ifndef OC_STDINT_H
#define OC_STDINT_H

///////////////////////////////////
#ifdef __linux__
#ifdef OC_uint32_t
	#define __uint32_t_defined
#endif

#ifdef OC_uint16_t
	#define uint16_t orig_uint16_t
#endif

#ifdef OC_uint8_t
	#define uint8_t orig_uint8_t
#endif

#ifdef OC_uint64_t
	#define uint64_t orig_uint64_t
#else
	#define OC_uint64_t
#endif
	
#ifndef __int8_t_defined
#ifdef OC_int64_t
	#define int64_t orig_int64_t
#else
 	#define OC_int64_t
#endif
#endif //__int8_t_defined

#ifdef OC_int8_t
#define int8_t org_int8_t
#endif

#ifdef OC_int16_t
#define int16_t org_int16_t
#endif

#endif//__linux__
//////////
#ifdef __CYGWIN__

#ifdef OC_int64_t
	#define int64_t orig_int64_t
#else
 	#define OC_int64_t
#endif

#endif//__CYGWIN__
/////////////

//#ifdef CYGWIN_LINUX

#ifdef OC_int32_t
#define int32_t org_int32_t
#else
#define OC_int32_t
#endif

#ifdef OC_uintptr_t
	#define uintptr_t org_uintptr_t
#else
	#define OC_uintptr_t
#endif

#define OC_uint32_t

//#endif//CYGWIN_LINUX

////////////////
#include "/usr/include/stdint.h"
//////////////////
#undef int32_t
#undef int16_t
#undef int8_t 
#undef int64_t
#undef uint8_t
#undef uint16_t
#undef uint64_t

//////
#include <machine/types.h>

#include <HYS/stdint.h>

#endif//OC_STDINT_H

#ifdef OC_uint32_t_need
#include <HYS/stdint.h>
#endif
