#ifndef OC_SYS_SELECT_H
#define OC_SYS_SELECT_H

#include <sys/appleapiopts.h>
#include <sys/cdefs.h>
#include <sys/_types.h>

#include <sys/_structs.h>
///////////////////////////
#ifdef __linux__

#ifndef OC_fd_mask
#define OC_fd_mask
#endif

#ifdef OC_fd_set
	#define fd_set org_fd_set
#else
	#define OC_fd_set
#endif

#define sigset_t org_sigset_t

#ifdef OC_suseconds_t
#define __suseconds_t_defined
#endif

#endif//__linux__

////////////
#include "/usr/include/sys/select.h"
/////////////////

#ifdef fd_set
#undef fd_set
#endif

#ifdef sigset_t
#undef sigset_t
#endif
///////////////////////////////////////
__BEGIN_DECLS

#include <sys/_select.h>	

__END_DECLS

#endif//OC_SYS_SELECT_H
