#ifndef OC_SYS_SIGNAL_H
#define OC_SYS_SIGNAL_H

/////////////////////////
#include <HYS/sys/signal.h>
///////////
#ifdef __CYGWIN__

#ifdef _SIGSET_T
	#define sigset_t org_sigset_t
#else
	#define _SIGSET_T
#endif
	
#define sigaction org_sigaction
#endif//__CYGWIN__

///////////////
#include "/usr/include/sys/signal.h"
////////////////

#ifdef sigaction
	#undef sigaction
#endif
	
#ifdef sigset_t
	#undef sigset_t
#endif
#ifdef __linux__

#ifdef SIGIO
	#undef SIGIO
#endif

#ifdef SIGURG
#undef SIGURG
#endif

#endif//__linux__

//////////////////

#define  HYS_SYS_SIGNAL_H_END
#include <HYS/sys/signal.h>

#endif //OC_SYS_SIGNAL_H
