

SRCS_CPP =  IOLib.cpp   \
IOBufferMemoryDescriptor.cpp IOMemoryDescriptor.cpp  IORegistryEntry.cpp IODataQueue.cpp \
IOTimerEventSource.cpp  IOUserClient.cpp  IOWorkLoop.cpp\
IOEventSource.cpp acpi/IOACPIPlatformDevice.cpp IOService.cpp  \
storage/IOMedia.cpp storage/IOStorage.cpp acpi/IOACPITypes.cpp pci/IOPCIDevice.cpp \
IOCommandGate.cpp IOFilterInterruptEventSource.cpp IOInterruptEventSource.cpp\
serial/IOSerialStreamSync.cpp pccard/IOPCCard16Device.cpp IOLocks.cpp \
network/IOPacketQueue.cpp network/IONetworkController.cpp \
network/IOMbufMemoryCursor.cpp network/IOOutputQueue.cpp\
network/IOGatedOutputQueue.cpp network/IONetworkInterface.cpp \
network/IONetworkData.cpp network/IOEthernetController.cpp network/IONetworkMedium.cpp\
adb/IOADBDevice.cpp IONotifier.cpp hidsystem/IOHIKeyboard.cpp \
hidsystem/IOHIDevice.cpp hidsystem/IOHIDSystem.cpp IODeviceTreeSupport.cpp\
hidsystem/IOHIPointing.cpp IOPlatformExpert.cpp IOInterruptController.cpp\
graphics/IODisplay.cpp pwr_mgt/RootDomain.cpp graphics/IOFramebuffer.cpp\
ndrvsupport/IONDRVFramebuffer.cpp i2c/PPCI2CInterface.cpp\
network/IOKernelDebugger.cpp network/IOBasicOutputQueue.cpp ata/IOPCIATA.cpp \
ata/IOATABusInfo.cpp ata/IOATAController.cpp IOLocksPrivate.cpp \
ata/ATADeviceNub.cpp ata/IOATADevConfig.cpp ata/IOATABusCommand.cpp \
IODMACommand.cpp IOMemoryCursor.cpp ata/IOATACommand.cpp ata/IOATADevice.cpp\
ata/MacIOATA.cpp ppc/IODBDMA.cpp platform/AppleMacIO.cpp pwr_mgt/IOPowerConnection.cpp\
platform/ApplePlatformExpert.cpp IOCPU.cpp pci/IOPCIBridge.cpp pci/IOAGPDevice.cpp IOMapper.cpp\
IODeviceMemory.cpp IORangeAllocator.cpp audio/IOAudioControl.cpp audio/IOAudioDevice.cpp\
audio/IOAudioEngine.cpp audio/IOAudioStream.cpp audio/IOAudioSelectorControl.cpp \
audio/IOAudioPort.cpp audio/IOAudioLevelControl.cpp audio/IOAudioToggleControl.cpp \
IOSyncer.cpp IOCommandPool.cpp IOKitDebug.cpp serial/IORS232SerialStreamSync.cpp \
serial/IOSerialKeys.cpp scsi/IOSCSIParallelCommand.cpp scsi/IOSCSIParallelController.cpp\
scsi/IOSCSIParallelDevice.cpp usb/IOUSBInterface.cpp usb/IOUSBDevice.cpp \
usb/IOUSBController.cpp usb/IOUSBPipe.cpp IOMultiMemoryDescriptor.cpp \
acpi/IOACPIPlatformExpert.cpp adb/IOADBBus.cpp adb/IOADBController.cpp \
ata/ATATimerEventSource.cpp scsi/IOSCSIProtocolServices.cpp scsi/SCSITaskDefinition.cpp \
audio/IOAudioControlUserClient.cpp audio/IOAudioEngineUserClient.cpp \
storage/IOCDBlockStorageDevice.cpp  storage/IOCDMedia.cpp \
storage/IOCDBlockStorageDriver.cpp storage/IOCDPartitionScheme.cpp \
storage/IOBlockStorageDriver.cpp storage/IOBlockStorageDevice.cpp \
storage/IOCDMediaBSDClient.cpp  storage/IOMediaBSDClient.cpp storage/IODVDBlockStorageDevice.cpp \
storage/IODVDBlockStorageDriver.cpp  storage/IODVDMedia.cpp storage/IODVDMediaBSDClient.cpp avc/IOFireWireAVCCommand.cpp \
firewire/IOFireWireNub.cpp firewire/IOFWCommand.cpp firewire/IOFireWireController.cpp \
avc/IOFireWirePCRSpace.cpp avc/IOFireWireAVCTargetSpace.cpp \
firewire/IOFireWireBus.cpp avc/IOFireWireAVCUnit.cpp  firewire/IOFWPseudoAddressSpace.cpp \
firewire/IOFWAddressSpace.cpp firewire/IOLocalConfigDirectory.cpp \
avc/IOFireWireAVCLocalNode.cpp firewire/IOConfigDirectory.cpp firewire/IOFWSyncer.cpp \
firewire/IOFWLocalIsochPort.cpp firewire/IOFWDCLProgram.cpp firewire/IOFireWireLink.cpp \
firewire/IOFWIsochChannel.cpp firewire/IOFWDCLTranslator.cpp firewire/IOFWIsochPort.cpp \
firewire/IOFWPHYPacketListener.cpp firewire/IOFWPhysicalAddressSpace.cpp \
firewire/IOFWSimpleContiguousPhysicalAddressSpace.cpp \
firewire/IOFWSimplePhysicalAddressSpace.cpp firewire/IOFWAsyncStreamListener.cpp \
firewire/IOFWDCLPool.cpp firewire/IOFWDCL.cpp firewire/IOFWWorkLoop.cpp \
firewire/IOFireWirePowerManager.cpp firewire/IOFireWireDevice.cpp \
firewire/IOFireWireIRMAllocation.cpp  firewire/IOFWUtils.cpp firewire/IOFireWireUnit.cpp \
firewire/IORemoteConfigDirectory.cpp firewire/IOFireWireROMCache.cpp IOKitLib.cpp \
sbp2/IOFireWireSBP2ORB.cpp  sbp2/IOFireWireSBP2Login.cpp \
sbp2/IOFireWireSBP2Target.cpp  sbp2/IOFireWireSBP2LSIWorkaroundDescriptor.cpp \
sbp2/IOFireWireSBP2UserClient.cpp sbp2/IOFireWireSBP2LUN.cpp \
sbp2/IOFireWireSBP2ManagementORB.cpp graphics/IOAccelerator.cpp \
i2c/IOI2CInterface.cpp hidevent/IOHIDEventService.cpp  hid/IOHIDEvent.cpp \
IOSharedDataQueue.cpp graphics/IOGraphicsDevice.cpp hid/IOHIDElement.cpp \
hid/IOHIDLibPrivate.cpp hid/IOHIDInterface.cpp hidsystem/IOHIKeyboardMapper.cpp \
network/IONetworkUserClient.cpp  network/IOEthernetInterface.cpp \
pccard/IOPCCardEjectController.cpp  pccard/IOPCCardBridge.cpp \
pccard/IOCardBusDevice.cpp pccard/IOPCCard16Enabler.cpp IOCatalogue.cpp \
pci/IOPCIConfigurator.cpp  pci/IOPCIPrivate.cpp scsi/IOSCSICommand.cpp \
scsi/IOSCSIDevice.cpp scsi/spi/IOSCSIParallelInterfaceController.cpp \
serial/IOSerialDriverSync.cpp storage/IOAppleLabelScheme.cpp \
storage/IOFilterScheme.cpp storage/IOGUIDPartitionScheme.cpp \
storage/IOPartitionScheme.cpp storage/IOApplePartitionScheme.cpp \
storage/IOFDiskPartitionScheme.cpp usb/IOUSBControllerListElement.cpp \
usb/IOUSBControllerV3.cpp usb/IOUSBCommand.cpp usb/IOUSBNub.cpp  \
usb/IOUSBDeviceUserClient.cpp usb/IOUSBControllerV2.cpp \
usb/IOUSBHIDDriver.cpp hid/IOHIDDevice.cpp  usb/IOUSBHubDevice.cpp \
usb/IOUSBHubPolicyMaker.cpp usb/IOUSBInterfaceUserClient.cpp \
usb/IOUSBLog.cpp usb/IOUSBCompositeDriver.cpp usb/IOUSBRootHubDevice.cpp \
usb/IOUSBWorkLoop.cpp usb/IOUSBUserClient.cpp usb/IOUFIStorageServices.cpp \
usb/IOUSBMassStorageUFISubclass.cpp scsi/IOSCSIPrimaryCommandsDevice.cpp \
usb/IOUSBMassStorageClass.cpp scsi/IOSCSIPeripheralDeviceNub.cpp \
 pwr_mgt/IOPMPowerSource.cpp

SRCS_C = IOKit.c IOCFPlugin.c  hidsystem/IOHIDLib.c IOSharedLock.c hid/IOHIDValue.c \
hidsystem/IOHIDDescriptorParser.c IODataQueueClient.c IOKitLibPrivate.c \
IOCFURLAccess.c hid/IOHIDQueue.c hid/IOHIDManager.c hid/IOHIDTransaction.c \
pccard/k_compat.c pccard/cs.c system.c IOCFUnserialize.c

SRCS_M = scsi/SCSIDevice.m

SRCS = $(SRCS_CPP) $(SRCS_C) $(SRCS_M)

OBJS = $(SRCS_C:.c=.o) $(SRCS_CPP:.cpp=.o)  $(SRCS_M:.m=.o)

