#include <IOKit/firewire/IOConfigDirectory.h>

bool IOConfigDirectory:: initWithOffset(int a, int b){};//?
IOReturn IOConfigDirectory::createIterator(UInt32 a, UInt32 b,OSIterator *&c){};//?
IOReturn IOConfigDirectory::getKeyValue(int a, OSData *&b,OSString** c){};//?
IOReturn IOConfigDirectory::getKeyValue(int a, IOConfigDirectory *&b,OSString** c ){};//?
IOReturn IOConfigDirectory::getKeyOffset(int a, FWAddress &b,OSString** c ){};//?
IOReturn IOConfigDirectory::getIndexOffset(int a, FWAddress &b){};//?
int IOConfigDirectory::getType() const{};//c
int IOConfigDirectory::getNumEntries() const{};//c
IOReturn IOConfigDirectory::getIndexValue(int a, OSData *&b){};//?
IOReturn IOConfigDirectory::getIndexOffset(int a, UInt32 &b){};//?
IOReturn IOConfigDirectory::getIndexValue(int a, OSString *&b){};//?
IOReturn IOConfigDirectory::getIndexValue(int a, IOConfigDirectory *&b){};//?

int IOConfigDirectory_HYS::updateROMCache(int a,int b){};//?
const UInt32 * IOConfigDirectory_HYS::lockData(){};//?
int IOConfigDirectory_HYS::unlockData(){};//?
int IOConfigDirectory_HYS::checkROMState(){};//?
IOConfigDirectory * IOConfigDirectory_HYS::getSubDir(int a,int b){};//?

/*getKeyType


public

virtual IOReturn getKeyType(
    int key,
    IOConfigKeyType &type); 
Parameters
type
on return, set to the data type
Return Value

kIOReturnSuccess if the key exists in the dictionary 
Discussion 

Gets the data type for the specified key*/
IOReturn IOConfigDirectory::getKeyType(
    int key,
    IOConfigKeyType &type){}; 

/*getKeyValue


public

virtual IOReturn getKeyValue(
    int key,
    UInt32 &value,
    OSString ** text = NULL); 
Parameters
value
on return, set to the data type
text
if non-zero, on return points to the string description of the field, or NULL if no text found.
value
reference to variable to store the entry's value
Return Value

kIOReturnSuccess if the key exists in the dictionary and is of a type appropriate for the value parameter 
Discussion 

Gets the value for the specified key, in a variety of forms*/

IOReturn IOConfigDirectory::getKeyValue(
    int key,
    UInt32 &value,
    OSString ** text ){}; 


/*getIndexType


public

virtual IOReturn getIndexType(
    int index,
    IOConfigKeyType &type); 
Parameters
type
on return, set to the data type
Return Value

kIOReturnSuccess if the index exists in the dictionary 
Discussion 

Gets the data type for entry at the specified index*/
IOReturn IOConfigDirectory::getIndexType(
    int index,
    IOConfigKeyType &type){}; 
/*getIndexValue


public

virtual IOReturn getIndexValue(
    int index,
    UInt32 &value); 
Parameters
type
on return, set to the data type
value
reference to variable to store the entry's value
Return Value

kIOReturnSuccess if the index exists in the dictionary and is of a type appropriate for the value parameter 
Discussion 

Gets the value at the specified index of the directory, in a variety of forms.*/
IOReturn IOConfigDirectory:: getIndexValue(
    int index,
    UInt32 &value){}; 

/*getSubdirectories


public

virtual IOReturn getSubdirectories(
    OSIterator *&iterator); 
Parameters
iterator
on return, set to point to an OSIterator
Return Value

kIOReturnSuccess if the iterator could be created 
Discussion 

Creates an iterator over the subdirectories of the directory.*/
IOReturn IOConfigDirectory::getSubdirectories(
    OSIterator *&iterator){}; 

/*getIndexEntry


public

virtual IOReturn getIndexEntry(
    int index,
    UInt32 &value); 
Parameters
entry
on return, set to the entry value
value
reference to variable to store the entry's value
Return Value

kIOReturnSuccess if the index exists in the dictionary 
Discussion 

Gets the entry at the specified index of the directory, as a raw UInt32.*/
IOReturn IOConfigDirectory::getIndexEntry(
    int index,
    UInt32 &value){};


/*getIndexKey


public

virtual IOReturn getIndexKey(
    int index,
    int &key); 
Parameters
key
on return, set to the key
Return Value

kIOReturnSuccess if the index exists in the dictionary 
Discussion 

Gets the key for entry at the specified index*/
IOReturn IOConfigDirectory:: getIndexKey(
    int index,
    int &key){}; 

/*getKeySubdirectories


public

virtual IOReturn getKeySubdirectories(
    int key,
    OSIterator *&iterator); 
Parameters
key
type of subdirectory to iterate over
iterator
on return, set to point to an OSIterator
Return Value

kIOReturnSuccess if the iterator could be created 
Discussion 

Creates an iterator over subdirectories of a given type of the directory.*/
IOReturn IOConfigDirectory::getKeySubdirectories(
    int key,
    OSIterator *&iterator){}; 
