#include <IOKit/firewire/IOFWAddressSpace.h>

bool IOFWAddressSpaceAux::init( IOFWAddressSpace * a){};//?
void IOFWAddressSpaceAux:: free(){};//?
bool IOFWAddressSpaceAux::isTrustedNode( UInt16 a){};//?
void IOFWAddressSpaceAux::removeAllTrustedNodes(){};//?
void IOFWAddressSpaceAux::setExclusive( bool a ){};//c
void IOFWAddressSpaceAux::removeTrustedNode( IOFireWireDevice * a ){};//?
void IOFWAddressSpaceAux::addTrustedNode( IOFireWireDevice * a){};//?
bool IOFWAddressSpaceAux::isExclusive( ){};//c
bool IOFWAddressSpaceAux:: intersects( IOFWAddressSpace *a){};//?
bool IOFWAddressSpace::init(IOFireWireBus *a){};//?
IOFWAddressSpaceAux * IOFWAddressSpace::createAuxiliary( ){};//?
void IOFWAddressSpace::free(){};//?
/////////////////
int  IOFWAddressSpace_HYS::doRead(UInt16 a,int b,FWAddress c,int d,IOMemoryDescriptor** e,IOByteCount* f,IOFWRequestRefCon g){};//?
int IOFWAddressSpace_HYS::doWrite(UInt16 a,int b,FWAddress c,int d,const void* e,IOFWRequestRefCon f){};//?
int IOFWAddressSpace_HYS::setExclusive(int a){};//?

/*activate


Address space is ready for handling requests. 

public

virtual IOReturn activate(); 
Return Value

IOReturn*/
IOReturn IOFWAddressSpace::activate(){}; 

/*deactivate


Address space request handler is disabled. 

public

virtual void deactivate(); 
Return Value

none*/
void IOFWAddressSpace:: deactivate(){}; 

/*contains


returns number of bytes starting at addr in this space 

public

virtual UInt32 contains(
    FWAddress addr); 
Return Value

0 if it doesn't contain the address*/
UInt32 IOFWAddressSpace:: contains(
    FWAddress addr){}; 


/*doLock


A method for processing a lock request. 

public

virtual UInt32 doLock(
    UInt16 nodeID,
    IOFWSpeed &speed,
    FWAddress addr,
    UInt32 inlen, 
    const UInt32 *newVal,
    UInt32 &outLen,
    UInt32 *oldVal, 
    UInt32 extType,
    IOFWRequestRefCon refcon); 
Parameters
nodeID
FireWire Lock request for nodeID.
speed
at this 'speed'.
addr
with FireWire address 'addr'.
inlen
'inlen' bytes to use.
newVal
new value to write at 'addr' location .
outLen
'outLen' bytes for result.
oldVal
old value read from 'addr' location.
extType
Type like kFWExtendedTCodeCompareSwap.
refcon
Can be queried for extra info about the request.
Return Value

UIn32 returns kFWResponseComplete on success*/
 UInt32 IOFWAddressSpace::doLock(
    UInt16 nodeID,
    IOFWSpeed &speed,
    FWAddress addr,
    UInt32 inlen, 
    const UInt32 *newVal,
    UInt32 &outLen,
    UInt32 *oldVal, 
    UInt32 extType,
    IOFWRequestRefCon refcon){}; 


/*isTrustedNode


returns true if the node is added as a trusted node 

public

inline bool isTrustedNode(
    UInt16 nodeID ) 
Parameters
nodeID
is the nodeID to verify whether its trusted.
Return Value

false if nodeID is not trusted*/
bool IOFWAddressSpace:: isTrustedNode(
    UInt16 nodeID ){} ;
