#include <IOKit/firewire/IOFWPseudoAddressSpace.h>

bool IOFWPseudoAddressSpaceAux::init( IOFWAddressSpace * a){};//?
void IOFWPseudoAddressSpaceAux::free(){};//?
bool IOFWPseudoAddressSpaceAux::createMemberVariables( ){};//?
void IOFWPseudoAddressSpaceAux::destroyMemberVariables(){};//?

void IOFWPseudoAddressSpaceAux::setARxReqIntCompleteHandler( void * a, IOFWARxReqIntCompleteHandler b ){};//?

void IOFWPseudoAddressSpaceAux::handleARxReqIntComplete(){};//?
bool IOFWPseudoAddressSpaceAux::intersects( IOFWAddressSpace *a){};//?
IOReturn	IOFWPseudoAddressSpace::allocateAddress(FWAddress* a,UInt32 b){};//?
void IOFWPseudoAddressSpace::freeAddress(FWAddress a,UInt32 b){};//?
void IOFWPseudoAddressSpace::free(){};//?
IOFWAddressSpaceAux * IOFWPseudoAddressSpace::createAuxiliary(){};//?

////////////////////////

int IOFWPseudoAddressSpace_HYS::handleARxReqIntComplete(){};//?

/*initFixed


Initialize a fixed address space at top of kCSRRegisterSpaceBaseAddressHi 

public

virtual bool initFixed( 
    IOFireWireBus *bus, 
    FWAddress addr, 
    UInt32 len, 
    FWReadCallback reader, 
    FWWriteCallback writer, 
    void *refcon); 
Parameters
bus
Points to IOFireWireBus object.
addr
Points to starting address for the Pseudo Address Space.
reader
Callback handler for incoming Read.
writer
Callback handler for incoming Write.
refcon
Client's callback object.
Return Value

returns true on success, false on failure*/
 bool IOFWPseudoAddressSpace:: initFixed( 
    IOFireWireBus *bus, 
    FWAddress addr, 
    UInt32 len, 
    FWReadCallback reader, 
    FWWriteCallback writer, 
    void *refcon){}; 


/*simpleReader


A method for processing an address space read request 

public

static UInt32 simpleReader( 
    void *refcon, 
    UInt16 nodeID, 
    IOFWSpeed & speed, 
    FWAddress addr, 
    UInt32 len, 
    IOMemoryDescriptor ** buf, 
    IOByteCount *offset, 
    IOFWRequestRefCon reqrefcon); 
Parameters
refcon
Client's callback object.
nodeID
FireWire Read from nodeID.
speed
at this 'speed'.
addr
with FireWire address 'addr'.
len
read 'len' bytes from nodeID.
buf
points to a memory descriptor containing the packet data.
offset
start from this 'offset' in 'buf'.
reqrefcon
Can be queried for extra info about the request.
Return Value

UIn32 returns kFWResponseComplete on success*/
 UInt32 IOFWPseudoAddressSpace:: simpleReader( 
    void *refcon, 
    UInt16 nodeID, 
    IOFWSpeed & speed, 
    FWAddress addr, 
    UInt32 len, 
    IOMemoryDescriptor ** buf, 
    IOByteCount *offset, 
    IOFWRequestRefCon reqrefcon){} ;

/*doWrite


A method for processing an address space write request 

public

virtual UInt32 doWrite( 
    UInt16 nodeID, 
    IOFWSpeed& speed, 
    FWAddress addr, 
    UInt32 len, 
    const void *buf, 
    IOFWRequestRefCon reqrefcon); 
Parameters
nodeID
FireWire Write to nodeID.
speed
at this 'speed'.
addr
with FireWire address 'addr'.
len
write 'len' bytes to nodeID.
buf
obtain bytes from location given by 'buf'.
reqrefcon
Can be queried for extra info about the request.
Return Value

UIn32 returns kFWResponseComplete on success*/
UInt32 IOFWPseudoAddressSpace::doWrite( 
    UInt16 nodeID, 
    IOFWSpeed& speed, 
    FWAddress addr, 
    UInt32 len, 
    const void *buf, 
    IOFWRequestRefCon reqrefcon){}; 

/*contains


returns number of bytes starting at addr in this space 

public

virtual UInt32 contains(
    FWAddress addr); 
Return Value

0 if it doesn't contain the address*/
UInt32 IOFWPseudoAddressSpace:: contains(
    FWAddress addr){}; 


/*doRead


A method for processing an address space read request 

public

virtual UInt32 doRead( 
    UInt16 nodeID, 
    IOFWSpeed & speed, 
    FWAddress addr, 
    UInt32 len, 
    IOMemoryDescriptor ** buf, 
    IOByteCount *offset, 
    IOFWRequestRefCon reqrefcon); 
Parameters
nodeID
FireWire Read from nodeID.
speed
at this 'speed'.
addr
with FireWire address 'addr'.
len
read 'len' bytes from nodeID.
buf
points to a memory descriptor containing the packet data.
offset
start from this 'offset' in 'buf'.
reqrefcon
Can be queried for extra info about the request.
Return Value

UIn32 returns kFWResponseComplete on success*/
 UInt32 IOFWPseudoAddressSpace::doRead( 
    UInt16 nodeID, 
    IOFWSpeed & speed, 
    FWAddress addr, 
    UInt32 len, 
    IOMemoryDescriptor ** buf, 
    IOByteCount *offset, 
    IOFWRequestRefCon reqrefcon){}; 


/*simpleWriter


A method for processing an address space write request 

public

static UInt32 simpleWriter( 
    void *refcon, 
    UInt16 nodeID, 
    IOFWSpeed& speed, 
    FWAddress addr, 
    UInt32 len, 
    const void *buf, 
    IOFWRequestRefCon reqrefcon); 
Parameters
refcon
Client's callback object.
nodeID
FireWire Write to nodeID.
speed
at this 'speed'.
addr
with FireWire address 'addr'.
len
write 'len' bytes to nodeID.
buf
obtain bytes from location given by 'buf'.
reqrefcon
Can be queried for extra info about the request.
Return Value

UIn32 returns kFWResponseComplete on success*/
UInt32 IOFWPseudoAddressSpace::simpleWriter( 
    void *refcon, 
    UInt16 nodeID, 
    IOFWSpeed& speed, 
    FWAddress addr, 
    UInt32 len, 
    const void *buf, 
    IOFWRequestRefCon reqrefcon){}; 

/*simpleRead


Create an address space object to handle read-only memory (eg. the local ROM) handles everything itself 

public

static IOFWPseudoAddressSpace* simpleRead( 
    IOFireWireBus *bus, 
    FWAddress *addr, 
    UInt32 len, 
    const void *data); 
Parameters
bus
Points to IOFireWireBus object.
addr
Points to starting address for the Pseudo Address Space.
len
Length of the Pseudo Address Space.
data
The virtual address of the first byte in the memory.
Return Value

returns valid IOFWPseudoAddressSpace on success, null on failure*/
IOFWPseudoAddressSpace* IOFWPseudoAddressSpace:: simpleRead( 
    IOFireWireBus *bus, 
    FWAddress *addr, 
    UInt32 len, 
    const void *data){}; 

/*initAll


Initialize an address space object to handle r/w memory 

public

virtual bool initAll( 
    IOFireWireBus *bus, 
    FWAddress *addr, 
    UInt32 len, 
    FWReadCallback reader, 
    FWWriteCallback writer, 
    void *refcon); 
Parameters
bus
Points to IOFireWireBus object.
addr
Points to starting address for the Pseudo Address Space.
len
Length of the Pseudo Address Space.
reader
Callback handler for incoming Read.
writer
Callback handler for incoming Write.
refcon
Client's callback object.
Return Value

returns true on success, false on failure*/
bool IOFWPseudoAddressSpace:: initAll( 
    IOFireWireBus *bus, 
    FWAddress *addr, 
    UInt32 len, 
    FWReadCallback reader, 
    FWWriteCallback writer, 
    void *refcon){}; 


/*simpleRW(IOFireWireBus *, FWAddress *, UInt32, void *)


Create an address space object to handle r/w memory handles everything itself 

public

static IOFWPseudoAddressSpace* simpleRW( 
    IOFireWireBus *bus, 
    FWAddress *addr, 
    UInt32 len, 
    void *data); 
Parameters
bus
Points to IOFireWireBus object.
addr
Points to starting address for the Pseudo Address Space.
len
Length of the Pseudo Address Space.
data
The virtual address of the first byte in the memory.
Return Value

returns valid IOFWPseudoAddressSpace on success, null on failure*/
IOFWPseudoAddressSpace* IOFWPseudoAddressSpace::simpleRW( 
    IOFireWireBus *bus, 
    FWAddress *addr, 
    UInt32 len, 
    void *data){}; 



/*simpleRW(IOFireWireBus *, FWAddress *, IOMemoryDescriptor *)


Create an address space object to handle r/w memory handles everything itself 

public

static IOFWPseudoAddressSpace* simpleRW( 
    IOFireWireBus *bus, 
    FWAddress *addr, 
    IOMemoryDescriptor *data); 
Parameters
bus
Points to IOFireWireBus object.
addr
Points to starting address for the Pseudo Address Space.
data
The virtual address of the first byte in the memory.
Return Value

returns valid IOFWPseudoAddressSpace on success, null on failure */
IOFWPseudoAddressSpace* IOFWPseudoAddressSpace::simpleRW( 
    IOFireWireBus *bus, 
    FWAddress *addr, 
    IOMemoryDescriptor *data){}; 


/*simpleReadFixed


Create an address space object to handle fixed read-only memory (eg. the local ROM) handles everything itself 

public

static IOFWPseudoAddressSpace* simpleReadFixed( 
    IOFireWireBus *bus, 
    FWAddress addr, 
    UInt32 len, 
    const void *data); 
Parameters
bus
Points to IOFireWireBus object.
addr
Points to starting address for the Pseudo Address Space.
len
Length of the Pseudo Address Space.
data
The virtual address of the first byte in the memory.
Return Value

returns valid IOFWPseudoAddressSpace on success, null on failure*/
IOFWPseudoAddressSpace* IOFWPseudoAddressSpace::simpleReadFixed( 
    IOFireWireBus *bus, 
    FWAddress addr, 
    UInt32 len, 
    const void *data){}; 


/*simpleRWFixed


Create a Read/Write fixed address space at top of kCSRRegisterSpaceBaseAddressHi. 

public

static IOFWPseudoAddressSpace * simpleRWFixed(
    IOFireWireBus *control,
    FWAddress addr,
    UInt32 len,
    const void *data ); 
Parameters
control
Points to IOFireWireBus object.
addr
Points to starting address for the Pseudo Address Space.
len
Length of the address range.
data
The virtual address of the first byte in the memory.
Return Value

returns valid IOFWPseudoAddressSpace on success, null on failure*/
IOFWPseudoAddressSpace * IOFWPseudoAddressSpace::simpleRWFixed(
    IOFireWireBus *control,
    FWAddress addr,
    UInt32 len,
    const void *data ){}; 
