#include <IOKit/firewire/IOFireWireDevice.h>

bool IOFireWireDeviceAux:: init( IOFireWireDevice * a){};//?
bool IOFireWireDeviceAux::isTerminated(){};//?
void IOFireWireDeviceAux::setUnitCount( UInt32 a ){};//?
void IOFireWireDeviceAux::setMaxSpeed( IOFWSpeed a ){};//?
void IOFireWireDeviceAux::setTerminationState( TerminationState a ){};//?
IOReturn IOFireWireDevice::configureNode(){};//?
UInt32 IOFireWireDeviceAux::getUnitCount(){};//?
bool IOFireWireDeviceAux::isPhysicalAccessEnabled( ){};//?

IOFWSimpleContiguousPhysicalAddressSpace * IOFireWireDeviceAux::createSimpleContiguousPhysicalAddressSpace( vm_size_t a, IODirection db){};//?

void IOFireWireDeviceAux::free(){};//?
OSSet *IOFireWireDeviceAux:: getOpenUnitSet() const{};//c
void  IOFireWireDeviceAux::latchResumeTime( ){};//?

IOFWSimplePhysicalAddressSpace * IOFireWireDeviceAux::createSimplePhysicalAddressSpace( vm_size_t a, IODirection b){};//?

AbsoluteTime IOFireWireDeviceAux::getResumeTime(){};//?
IOFireWireNubAux * IOFireWireDevice::createAuxiliary(){};//?
void IOFireWireDevice::terminateDevice(void *a){};//?
void IOFireWireDevice::free(){};//?
bool IOFireWireDevice::attach(IOService * a){};//?
bool IOFireWireDevice::finalize( IOOptionBits a){};//?
void IOFireWireDevice::setNodeROM(UInt32 a, UInt16 b, const IOFWNodeScan *c){};//?
void IOFireWireDevice::readROMThreadFunc(void *a){};//?

void IOFireWireDevice::readROMDirGlue(void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d){};//?

void IOFireWireDevice::processROM(RomScan *a){};//?
IOReturn IOFireWireDevice::readRootDirectory( IOConfigDirectory *a, OSDictionary *b){};//?
void IOFireWireDevice::configurePhysicalFilter(){};//?
IOReturn IOFireWireDevice::readUnitDirectories( IOConfigDirectory *a, OSSet *b){};//?
void IOFireWireDevice::preprocessDirectories( OSDictionary *a, OSSet *b){};//?
IOReturn IOFireWireDevice:: processRootDirectory( OSDictionary *a){};//?
IOReturn IOFireWireDevice::processUnitDirectories( OSSet *a){};//?
IOReturn IOFireWireDevice::cacheROM(OSData *a, UInt32 b, const UInt32 *&c){};//?
IOReturn IOFireWireDevice::message( UInt32 a, IOService * b, void * c ){};//?
void IOFireWireDevice::handleClose( IOService *a, IOOptionBits b){};//?
const UInt32 * IOFireWireDevice::getROMBase(){};//?
void IOFireWireDevice::setRegistrationState( RegistrationState a){};//?
bool IOFireWireDevice::matchPropertyTable(OSDictionary * a){};//?
bool IOFireWireDevice::handleIsOpen( const IOService * a) const{};//?
bool IOFireWireDevice::handleOpen( IOService * a, IOOptionBits b, void *c ){};//?

///////////////////////

AbsoluteTime IOFireWireDevice_HYS::getResumeTime(){};//c
int IOFireWireDevice_HYS::latchResumeTime(){};//?
int IOFireWireDevice_HYS::setUnitCount(int a){};//?
OSSet* IOFireWireDevice_HYS::getOpenUnitSet() const {};//?
int IOFireWireDevice_HYS:: isPhysicalAccessEnabled(){};//?
int IOFireWireDevice_HYS::setMaxSpeed(int a){};//?

/*createPseudoAddressSpace


Creates local pseudo FireWire address spaces for the device to access. 

public

virtual IOFWPseudoAddressSpace *createPseudoAddressSpace(
    FWAddress *addr,
    UInt32 len, 
    FWReadCallback reader,
    FWWriteCallback writer,
    void *refcon); 
Parameters
addr
The FireWire address that is mapped to the pseudo address access.
len
Size of the address space to allocate.
reader
Read callback, when the device reads from this address space.
writer
Write callback, when the device writes to this address space.
refcon
Client's callback object returned during reader/writer callbacks.
Return Value

A valid IOFWPseudoAddressSpace object on success; NULL on failure.*/
IOFWPseudoAddressSpace * IOFireWireDevice::createPseudoAddressSpace(
    FWAddress *addr,
    UInt32 len, 
    FWReadCallback reader,
    FWWriteCallback writer,
    void *refcon){}; 

/*init


Initializes the nub. 

public

virtual bool init(
    OSDictionary *propTable,
    const IOFWNodeScan *scan); 
Parameters
propTable
Property table passed to the standard nub initialization.
scan
Pointer to the node scan structure.
Return Value

Returns true if initialization was successful; false otherwise.*/
 bool IOFireWireDevice::init(
    OSDictionary *propTable,
    const IOFWNodeScan *scan){}; 

/*createPhysicalAddressSpace


Creates local physical FireWire address spaces for the device to access. 

public

virtual IOFWPhysicalAddressSpace *createPhysicalAddressSpace(
    IOMemoryDescriptor *mem); 
Parameters
mem
Memory area allocated to back the physical access by Link hardware.
Return Value

A valid IOFWPhysicalAddressSpace object on success; NULL on failure.*/
IOFWPhysicalAddressSpace *IOFireWireDevice::createPhysicalAddressSpace(
    IOMemoryDescriptor *mem){};

/*getNodeFlags


Retrieves the node's characteristics. 

public

virtual UInt32 getNodeFlags(
    void ); 
Parameters
flags
Refer to "node flags" in IOFireWireFamilyCommon.h.
Return Value

UInt32 The flags set for a particular node.*/
UInt32 IOFireWireDevice::getNodeFlags(
    void ){}; 

/*setNodeFlags


Sets the node's characteristics. 

public

virtual void setNodeFlags(
    UInt32 flags ); 
Parameters
flags
Refer to "node flags" in IOFireWireFamilyCommon.h.*/
 void IOFireWireDevice::setNodeFlags(
    UInt32 flags ){};

/*clearNodeFlags


Resets the node's characteristics. 

public

virtual void clearNodeFlags(
    UInt32 flags ); 
Parameters
flags
Refer to "node flags" in IOFireWireFamilyCommon.h.*/
 void  IOFireWireDevice::clearNodeFlags(
    UInt32 flags ){};
