 #include <IOKit/hid/IOHIDManager.h>

/*IOHIDManagerGetTypeID


Returns the type identifier of all IOHIDManager instances. 

CF_EXPORT CFTypeID IOHIDManagerGetTypeID(
    void) ;  

Availability
Introduced in Mac OS X v10.5.*/
CF_EXPORT CFTypeID IOHIDManagerGetTypeID(
    void){} ;  

/*IOHIDManagerSetDeviceMatchingMultiple


Sets multiple matching criteria for device enumeration. 

CF_EXPORT void IOHIDManagerSetDeviceMatchingMultiple( 
    IOHIDManagerRef manager, 
    CFArrayRef multiple) ;  
Parameters
manager
Reference to an IOHIDManager.
multiple
CFArrayRef containing multiple CFDictionaryRef objects containg device matching criteria.
Discussion 

Matching keys are prefixed by kIOHIDDevice and declared in . This method is useful if interested in multiple, specific device classes. 

Availability
Introduced in Mac OS X v10.5.*/
CF_EXPORT void IOHIDManagerSetDeviceMatchingMultiple( 
    IOHIDManagerRef manager, 
    CFArrayRef multiple) {};  

/*IOHIDManagerSetInputValueMatchingMultiple


Sets multiple matching criteria for input values received via IOHIDManagerRegisterInputValueCallback. 

CF_EXPORT void IOHIDManagerSetInputValueMatchingMultiple( 
    IOHIDManagerRef manager, 
    CFArrayRef multiple) ;  
Parameters
manager
Reference to an IOHIDManager.
multiple
CFArrayRef containing multiple CFDictionaryRef objects containg input element matching criteria.
Discussion 

Matching keys are prefixed by kIOHIDElement and declared in . This method is useful if interested in multiple, specific elements . 

Availability
Introduced in Mac OS X v10.5.*/
CF_EXPORT void IOHIDManagerSetInputValueMatchingMultiple( 
    IOHIDManagerRef manager, 
    CFArrayRef multiple){} ;  
