 #include <IOKit/network/IOEthernetInterface.h>

UInt32 IOEthernetInterface::getFilters(const OSDictionary *a, const OSSymbol *b){};//c
bool IOEthernetInterface::setFilters(OSDictionary *a, const OSSymbol *b, UInt32 c){};//c
bool IOEthernetInterface::initIfnetParams(struct ifnet_init_params *a){};//?
int IOEthernetInterface::performGatedCommand(void *a, void *b, void *c, void *d, void *e){};//c
int IOEthernetInterface::syncSIOCSIFADDR(IONetworkController * a){};//c
int IOEthernetInterface::syncSIOCSIFFLAGS(IONetworkController * a){};//c
int IOEthernetInterface::syncSIOCADDMULTI(IONetworkController * a){};//c
int IOEthernetInterface::syncSIOCDELMULTI(IONetworkController * a){};//c
int IOEthernetInterface::syncSIOCSIFMTU(IONetworkController *a, struct ifreq *b, bool c){};//c
int IOEthernetInterface::syncSIOCGIFDEVMTU(IONetworkController * a, struct ifreq * b){};//c
int IOEthernetInterface::syncSIOCSIFLLADDR(IONetworkController * a, const char * b, int c){};//c
IOReturn IOEthernetInterface::enableController(IONetworkController * a){};//c

IOReturn IOEthernetInterface::disableFilter(IONetworkController * a, const OSSymbol *b, UInt32 c, IOOptionBits d ){};//c

IOReturn IOEthernetInterface::enableFilter(IONetworkController *a, const OSSymbol *b, UInt32 c, IOOptionBits d ){};//c

IOReturn IOEthernetInterface:: setupMulticastFilter(IONetworkController * a){};//c

IOReturn IOEthernetInterface::enableFilter_Wrapper(IOEthernetInterface *a, IONetworkController *b, const OSSymbol *c, UInt32 d, IOOptionBits e){};//c

bool IOEthernetInterface::willTerminate( IOService *a, IOOptionBits b){};//?
IOReturn IOEthernetInterface::attachToDataLinkLayer( IOOptionBits a, void *b){};//?
void IOEthernetInterface::_fixupVlanPacket(mbuf_t a, u_int16_t b, int c){};//c
void IOEthernetInterface:: feedPacketInputTap(mbuf_t a){};//?
void IOEthernetInterface::feedPacketOutputTap(mbuf_t a){};//?

/*getNamePrefix


Returns a string containing the prefix to use when creating a BSD name for this interface. 

public

virtual const char * getNamePrefix() const; 
Return Value

Returns a pointer to a constant C string "en". Therefore, Ethernet interfaces will be registered with BSD as en0, en1, etc. 
Discussion 

The BSD name for each interface object is created by concatenating a string returned by this method, with an unique unit number assigned by IONetworkStack.*/
 const char *IOEthernetInterface::getNamePrefix() const{};

/*init


Initializes an IOEthernetInterface instance. 

public

virtual bool init(
    IONetworkController *controller ); 
Parameters
controller
A network controller object that will service the interface object being initialized.
Return Value

Returns true on success, false otherwise. 
Discussion 

Instance variables are initialized, and an arpcom structure is allocated.*/
bool IOEthernetInterface::init(
    IONetworkController *controller ){}; 

/*free


Frees the IOEthernetInterface instance. 

protected

virtual void free(); 
Discussion 

The memory allocated for the arpcom structure is released, followed by a call to super::free().*/
 void IOEthernetInterface::free(){}; 

/*controllerDidOpen


A notification that the interface has opened the network controller. 

protected

virtual bool controllerDidOpen(
    IONetworkController *controller); 
Parameters
controller
The controller object that was opened.
Return Value

Returns true on success, false otherwise. Returning false will cause the controller to be closed, and any pending client opens to be rejected. 
Discussion 

This method will be called by IONetworkInterface after a network controller has accepted an open from this interface object. IOEthernetInterface will first call the implementation in its superclass, then inspect the controller through properties published in the registry. This method is called with the arbitration lock held.*/
 bool IOEthernetInterface::controllerDidOpen(
    IONetworkController *controller){}; 


/*controllerWillClose


A notification that the interface will close the network controller. 

protected

virtual void controllerWillClose(
    IONetworkController *controller); 
Parameters
controller
The controller that is about to be closed.
Discussion 

This method will simply call super to propagate the method call. This method is called with the arbitration lock held.*/
 void IOEthernetInterface::controllerWillClose(
    IONetworkController *controller){}; 

/*performCommand


Handles an ioctl command sent to the Ethernet interface. 

protected

virtual SInt32 performCommand(
    IONetworkController *controller, 
    UInt32 cmd, 
    void *arg0, 
    void *arg1); 
Parameters
controller
The controller object.
cmd
The ioctl command code.
arg0
Command argument 0. Generally a pointer to an ifnet structure associated with the interface.
arg1
Command argument 1.
Return Value

Returns a BSD return value defined in bsd/sys/errno.h. 
Discussion 

This method handles socket ioctl commands sent to the Ethernet interface from DLIL. Commands recognized and processed by this method are SIOCSIFADDR, SIOCSIFFLAGS, SIOCADDMULTI, and SIOCDELMULTI. Other commands are passed to the superclass.(*/
 SInt32 IOEthernetInterface:: performCommand(
    IONetworkController *controller, 
    UInt32 cmd, 
    void *arg0, 
    void *arg1){}; 

/*controllerWillChangePowerState


Handles a notification that the network controller servicing this interface object is about to transition to a new power state. 

protected

virtual IOReturn controllerWillChangePowerState( 
    IONetworkController *controller, 
    IOPMPowerFlags flags, 
    UInt32 stateNumber, 
    IOService *policyMaker); 
Parameters
controller
The network controller object.
flags
Flags that describe the capability of the controller in the new power state.
stateNumber
An index to a state in the network controller's power state array that the controller is switching to.
policyMaker
A reference to the network controller's policy-maker, and is also the originator of this notification.
Return Value

Always returns kIOReturnSuccess. 
Discussion 

If the controller is about to transition to an unusable state, and it is currently enabled, then the disable() method on the controller is called.*/
IOReturn IOEthernetInterface::controllerWillChangePowerState( 
    IONetworkController *controller, 
    IOPMPowerFlags flags, 
    UInt32 stateNumber, 
    IOService *policyMaker){}; 

/*controllerDidChangePowerState


Handles a notification that the network controller servicing this interface object has transitioned to a new power state. 

protected

virtual IOReturn controllerDidChangePowerState( 
    IONetworkController *controller, 
    IOPMPowerFlags flags, 
    UInt32 stateNumber, 
    IOService *policyMaker); 
Parameters
controller
The network controller object.
flags
Flags that describe the capability of the controller in the new power state.
stateNumber
An index to a state in the network controller's power state array that the controller has switched to.
policyMaker
A reference to the network controller's policy-maker, and is also the originator of this notification.
Return Value

Always returns kIOReturnSuccess. 
Discussion 

If the controller did transition to a usable state, and it was previously disabled due to a previous power change, then it is re-enabled.*/
 IOReturn IOEthernetInterface:: controllerDidChangePowerState( 
    IONetworkController *controller, 
    IOPMPowerFlags flags, 
    UInt32 stateNumber, 
    IOService *policyMaker){};

/*setProperties


Handles a request to set Ethernet interface properties from kernel or non-kernel clients. 

public

virtual IOReturn setProperties(
    OSObject *properties ); 
Parameters
properties
An OSDictionary containing a collection of properties.
Return Value

Returns kIOReturnUnsupported if the interface did not recognize any of the properties provided. Otherwise, the return code will be kIOReturnSuccess to indicate no errors, or an IOReturn error code to indicate that an error occurred while handling one of the properties. 
Discussion 

For non-kernel clients, the preferred access mechanism is through a user client connection.*/
 IOReturn IOEthernetInterface::setProperties(
    OSObject *properties ){}; 

