#include <IOKit/storage/IODVDBlockStorageDriver.h>

IODVDBlockStorageDevice * IODVDBlockStorageDriver::getProvider() const{};//?
IOReturn	IODVDBlockStorageDriver::acceptNewMedia(){};//?
const char * IODVDBlockStorageDriver::getDeviceTypeName(){};//?
IOMedia *	IODVDBlockStorageDriver::instantiateDesiredMediaObject(){};//?
IOMedia *IODVDBlockStorageDriver::instantiateMediaObject(UInt64 a,UInt64 b,UInt32 c,char *d){};//?

/*readStructure


Get control structures from the DVD media. 

public

virtual IOReturn readStructure(
    IOMemoryDescriptor *buffer,
    const DVDStructureFormat format, 
    const UInt32 address,
    const UInt8 layer,
    const UInt8 agid); 
Parameters
buffer
A buffer containing information, as documented in the specification "MtFuji Commands For Multimedia Devices."
format
As documented by MtFuji. See DVDStructureFormat.
address
As documented by MtFuji.
layer
As documented by MtFuji.
agid
As documented by MtFuji.
Discussion 

This function handles the getting of control structure data for the media.*/
 IOReturn IODVDBlockStorageDriver::readStructure(
    IOMemoryDescriptor *buffer,
    const DVDStructureFormat format, 
    const UInt32 address,
    const UInt8 layer,
    const UInt8 agid){}; 


/*sendKey


Send key info to the DVD drive. 

public

virtual IOReturn sendKey(
    IOMemoryDescriptor *buffer,
    const DVDKeyClass keyClass, 
    const UInt8 agid,
    const DVDKeyFormat keyFormat); 
Parameters
buffer
A buffer containing information, as documented in the specification "MtFuji Commands For Multimedia Devices."
keyClass
As documented by MtFuji. See DVDKeyClass.
agid
As documented by MtFuji.
keyFormat
As documented by MtFuji. See DVDKeyFormat.
Discussion 

This function handles the setting of key- and encryption-related data for the drive.*/
 IOReturn IODVDBlockStorageDriver::sendKey(
    IOMemoryDescriptor *buffer,
    const DVDKeyClass keyClass, 
    const UInt8 agid,
    const DVDKeyFormat keyFormat){}; 


/*reportKey


Get key info from the DVD drive. 

public

virtual IOReturn reportKey(
    IOMemoryDescriptor *buffer,
    const DVDKeyClass keyClass, 
    const UInt32 lba,
    const UInt8 agid,
    const DVDKeyFormat keyFormat); 
Parameters
buffer
A buffer containing information, as documented in the specification "MtFuji Commands For Multimedia Devices."
keyClass
As documented by MtFuji. See DVDKeyClass.
lba
As documented by MtFuji.
agid
As documented by MtFuji.
keyFormat
As documented by MtFuji. See DVDKeyFormat.
Discussion 

This function handles the getting of key- and encryption-related data for the drive.*/

IOReturn IODVDBlockStorageDriver::reportKey(
    IOMemoryDescriptor *buffer,
    const DVDKeyClass keyClass, 
    const UInt32 lba,
    const UInt8 agid,
    const DVDKeyFormat keyFormat){}; 
