#include <IOKit/storage/IODVDMedia.h>

IODVDBlockStorageDriver * IODVDMedia::getProvider() const{};//?
bool IODVDMedia::matchPropertyTable(OSDictionary * a, SInt32 * b){};//?

/*readRZoneInfo


public

virtual IOReturn readRZoneInfo(
    IOMemoryDescriptor *buffer, 
    UInt32 address, 
    DVDRZoneInfoAddressType addressType, 
    UInt16 *actualByteCount ); 
Parameters
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
address
As documented by MMC.
addressType
As documented by MMC.
actualByteCount
Returns the actual number of bytes transferred in the data transfer.
Return Value

Returns the status of the data transfer. 
Discussion 

Issue an MMC READ RZONE INFORMATION (READ TRACK INFORMATION) command.*/
 IOReturn IODVDMedia::readRZoneInfo(
    IOMemoryDescriptor *buffer, 
    UInt32 address, 
    DVDRZoneInfoAddressType addressType, 
    UInt16 *actualByteCount ){}; 


/*readDiscInfo


public

virtual IOReturn readDiscInfo(
    IOMemoryDescriptor *buffer, 
    UInt16 *actualByteCount ); 
Parameters
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
actualByteCount
Returns the actual number of bytes transferred in the data transfer.
Return Value

Returns the status of the data transfer. 
Discussion 

Issue an MMC READ DISC INFORMATION command.*/

 IOReturn IODVDMedia:: readDiscInfo(
    IOMemoryDescriptor *buffer, 
    UInt16 *actualByteCount ){}; 


/*reportKey


public

virtual IOReturn reportKey(
    IOMemoryDescriptor *buffer, 
    const DVDKeyClass keyClass, 
    const UInt32 address, 
    const UInt8 grantID, 
    const DVDKeyFormat format ); 
Parameters
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer. Pass null for the kDVDKeyFormatAGID_Invalidate format case.
keyClass
As documented by MMC.
address
As documented by MMC.
grantID
As documented by MMC.
format
As documented by MMC.
Return Value

Returns the status of the data transfer. 
Discussion 

Issue an MMC REPORT KEY command.*/
 IOReturn IODVDMedia:: reportKey(
    IOMemoryDescriptor *buffer, 
    const DVDKeyClass keyClass, 
    const UInt32 address, 
    const UInt8 grantID, 
    const DVDKeyFormat format ){}; 


/*sendKey


public

virtual IOReturn sendKey(
    IOMemoryDescriptor *buffer, 
    const DVDKeyClass keyClass, 
    const UInt8 grantID, 
    const DVDKeyFormat format ); 
Parameters
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer. Pass null for the kDVDKeyFormatAGID_Invalidate format case.
keyClass
As documented by MMC.
grantID
As documented by MMC.
format
As documented by MMC.
Return Value

Returns the status of the data transfer. 
Discussion 

Issue an MMC SEND KEY command.*/
IOReturn IODVDMedia::sendKey(
    IOMemoryDescriptor *buffer, 
    const DVDKeyClass keyClass, 
    const UInt8 grantID, 
    const DVDKeyFormat format ){}; 


/*readStructure


public

virtual IOReturn readStructure(
    IOMemoryDescriptor *buffer, 
    const DVDStructureFormat format, 
    const UInt32 address, 
    const UInt8 layer, 
    const UInt8 grantID ); 
Parameters
buffer
Buffer for the data transfer. The size of the buffer implies the size of the data transfer.
format
As documented by MMC.
address
As documented by MMC.
layer
As documented by MMC.
grantID
As documented by MMC.
Return Value

Returns the status of the data transfer. 
Discussion 

Issue an MMC READ DVD STRUCTURE command.*/
 IOReturn  IODVDMedia::readStructure(
    IOMemoryDescriptor *buffer, 
    const DVDStructureFormat format, 
    const UInt32 address, 
    const UInt8 layer, 
    const UInt8 grantID ){}; 

/*getSpeed


public

virtual IOReturn getSpeed(
    UInt16 *kilobytesPerSecond); 
Parameters
kilobytesPerSecond
Returns the current speed used for data transfers, in kB/s.
kDVDSpeedMin specifies the minimum speed for all DVD media (1X). kDVDSpeedMax specifies the maximum speed supported in hardware.
Return Value

Returns the status of the operation. 
Discussion 

Get the current speed used for data transfers.*/

 IOReturn  IODVDMedia::getSpeed(
    UInt16 *kilobytesPerSecond){}; 

/*setSpeed


public

virtual IOReturn setSpeed(
    UInt16 kilobytesPerSecond); 
Parameters
kilobytesPerSecond
Speed to be used for data transfers, in kB/s.
kDVDSpeedMin specifies the minimum speed for all DVD media (1X). kDVDSpeedMax specifies the maximum speed supported in hardware.
Return Value

Returns the status of the operation. 
Discussion 

Set the speed to be used for data transfers.*/
IOReturn IODVDMedia::setSpeed(
    UInt16 kilobytesPerSecond){}; 
