#include <IOKit/usb/IOUSBControllerV2.h>

 bool 	IOUSBControllerV2::	init( OSDictionary *  a){};//?
void		IOUSBControllerV2::free(){};//?cvoid		free();//?c
bool 		IOUSBControllerV2::start( IOService *  a ){};//?c
IOReturn	IOUSBControllerV2::	SetTestMode(UInt32 a, UInt32 b){};//?c
void IOUSBControllerV2::ReturnIsochDoneQueueEntry(OSObject *a, thread_call_param_t b){};//c
IOReturn	IOUSBControllerV2::AddHSHub(USBDeviceAddress a, UInt32 b){};//?c
 void	 IOUSBControllerV2::clearTTHandler(OSObject *a, void *b, IOReturn c, UInt32	d){};//c
IOReturn	IOUSBControllerV2::RemoveHSHub(USBDeviceAddress a){};//?c
void IOUSBControllerV2::ClearTT(USBDeviceAddress a, UInt8 b, Boolean c){};//?c
IOReturn IOUSBControllerV2::  DoCreateEP(OSObject *a, void *b, void *c,void *d, void *e){};//c
IODMACommand				*IOUSBControllerV2::GetNewDMACommand(){};//?c

void	IOUSBControllerV2::PutTDonDeferredQueue(IOUSBControllerIsochEndpoint* a, IOUSBControllerIsochListElement *b){};//?c

IOUSBControllerIsochListElement *IOUSBControllerV2::GetTDfromToDoList(IOUSBControllerIsochEndpoint* a){};//?c

void	IOUSBControllerV2::PutTDonToDoList(IOUSBControllerIsochEndpoint* a, IOUSBControllerIsochListElement *b){};//?c

IOReturn	IOUSBControllerV2::DeallocateIsochEP(IOUSBControllerIsochEndpoint *a){};//?c

IOUSBControllerIsochEndpoint* IOUSBControllerV2:: CreateIsochronousEndpoint(short a, short b, short c){};//?c

IOUSBControllerIsochEndpoint* IOUSBControllerV2::FindIsochronousEndpoint(short a, short b, short c, IOUSBControllerIsochEndpoint* *d){};//?c

void	IOUSBControllerV2::	ReturnIsochDoneQueue(IOUSBControllerIsochEndpoint* a){};//?c

 void	IOUSBControllerV2::PutTDonDoneQueue(IOUSBControllerIsochEndpoint* a, IOUSBControllerIsochListElement *b, bool c){};//?c

UInt64	IOUSBControllerV2::	GetMicroFrameNumber( void ){};//?c

IOReturn IOUSBControllerV2::DOHSHubMaintenance(OSObject *a, void *b, void *c, void *d, void *e){};//c

IOReturn	IOUSBControllerV2::	UIMSetTestMode(UInt32 a, UInt32 b){};//?c

IOReturn IOUSBControllerV2::UIMHubMaintenance(USBDeviceAddress a, UInt32 b, UInt32 c, UInt32 d){};//?c

 IOReturn IOUSBControllerV2::DOSetTestMode(OSObject *a, void *b, void *c, void *d, void *e){};//c

IOUSBControllerIsochEndpoint* IOUSBControllerV2::		AllocateIsochEP(void){};	//?c

 IOUSBControllerIsochListElement *IOUSBControllerV2::GetTDfromDeferredQueue(IOUSBControllerIsochEndpoint* a){};//?c

IOUSBControllerIsochListElement *IOUSBControllerV2::GetTDfromDoneQueue(IOUSBControllerIsochEndpoint* a){};//?c

/////////////

//////////////
/*GetFrameNumberWithTime


Real Time A/V applications send and receive Iscohronous data scheduled on certain USB frame numbers. The clock for these frame numbers is independent of the system clock, and drivers need to synchronize these two clocks. This routine will return a system time which corresponds to the beginning of a USB frame number. It is not necessarily the currrent frame, but it will be a frame in the recent past (within the past minute). The jitter between the start of the USB frame and the system time will be as low as possible, but due to hardware interrupt latencies could be as high as 200 microseconds. 

public

virtual IOReturn GetFrameNumberWithTime(
    UInt64 *frameNumber,
    AbsoluteTime *theTime); 
Parameters
frameNumber
A pointer to a UInt64 in which to hold the USB frame number corresponding to the given system time.
theTime
A pointer to an AbsoluteTime corresponding to the system time at the beginning of the given USB frame number.
Return Value

returns kIOReturnSuccess if the method is implemented by the controller, otherwise kIOReturnUnsupported*/
IOReturn IOUSBControllerV2::GetFrameNumberWithTime(
    UInt64 *frameNumber,
    AbsoluteTime *theTime){}; 

/*GetLowLatencyOptionsAndPhysicalMask


Low Latency transfers require that the client have access to the memory after the Isochronous I/O request has already been scheduled. This might be used, for example to fill in outgoing data "just in time." Some controllers, however, may have requirements which need to be followed in order to make sure that the memory buffer isn't moved after the call is made. This call will return an IOOptionBits and mach_vm_address_t which can be used in a call to IOBufferMemoryDescriptor::inTaskWithPhysicalMask which will help meet these requirements. 

public

virtual IOReturn GetLowLatencyOptionsAndPhysicalMask(
    IOOptionBits *optionBits,
    mach_vm_address_t *physicalMask); 
Parameters
optionBits
Pointer to an an IOOptionBits. The only bit which may be returned is kIOMemoryPhysicallyContiguous. Other bits, e.g. direction bits, must be ORd in by the client as needed. This call replaces the old property based method of obtaining this information.
physicalMask
Pointer to a mach_vm_address_t which should be used in the call to IOBufferMemoryDescriptor::inTaskWithPhysicalMask and will guarantee that when the memory is wired down it will be accessible by both the client and the USB controller at the same time.
Return Value

returns kIOReturnSuccess if the method is implemented by the controller, otherwise kIOReturnUnsupported*/
 IOReturn IOUSBControllerV2::GetLowLatencyOptionsAndPhysicalMask(
    IOOptionBits *optionBits,
    mach_vm_address_t *physicalMask){};

/*ReadV2


public

virtual IOReturn ReadV2(
    IOMemoryDescriptor *buffer, 
    USBDeviceAddress address, 
    Endpoint *endpoint, 
    IOUSBCompletionWithTimeStamp *completion, 
    UInt32 noDataTimeout, 
    UInt32 completionTimeout, 
    IOByteCount reqCount ); 
Parameters
buffer
place to put the transferred data
address
Address of the device on the USB bus
endpoint
description of endpoint
completion
describes action to take when buffer has been filled
noDataTimeout
number of milliseconds of no data movement before the request is aborted
completionTimeout
number of milliseonds after the command is on the bus in which it must complete
reqCount
number of bytes requested for the transfer (must not be greater than the length of the buffer)
Discussion 

Read from an interrupt or bulk endpoint*/
 IOReturn IOUSBControllerV2::ReadV2(
    IOMemoryDescriptor *buffer, 
    USBDeviceAddress address, 
    Endpoint *endpoint, 
    IOUSBCompletionWithTimeStamp *completion, 
    UInt32 noDataTimeout, 
    UInt32 completionTimeout, 
    IOByteCount reqCount ){}; 

/*CreateDevice


Create a new device as IOUSBController, making a note of the high speed hub device ID and port number the full/low speed device is attached to. 

public

virtual IOReturn CreateDevice(
    IOUSBDevice *newDevice, 
    USBDeviceAddress deviceAddress, 
    UInt8 maxPacketSize, 
    UInt8 speed, 
    UInt32 powerAvailable, 
    USBDeviceAddress hub, 
    int port); 
Parameters
newDevice
new device object to work with
deviceAddress
USB device ID
maxPacketSize
max packet size of endpoint zero
speed
speed of the device kUSBDeviceSpeedLow, kUSBDeviceSpeedFull, kUSBDeviceSpeedHigh
powerAvailable
power available to the device
hub
USB ID of hub the device is immediatly attached to. (Not necessarily high speed)
port
port number of port the device is attached to.*/
IOReturn IOUSBControllerV2:: CreateDevice(
    IOUSBDevice *newDevice, 
    USBDeviceAddress deviceAddress, 
    UInt8 maxPacketSize, 
    UInt8 speed, 
    UInt32 powerAvailable, 
    USBDeviceAddress hub, 
    int port){}; 


/*ConfigureDeviceZero


configure pipe zero of device zero, as IOUSBController, but also keeping note of high speed hub device is attached to. 

public

virtual IOReturn ConfigureDeviceZero(
    UInt8 maxPacketSize,
    UInt8 speed,
    USBDeviceAddress hub,
    int port); 
Parameters
maxPacketSize
max packet size for the pipe
speed
speed of the device kUSBDeviceSpeedLow, kUSBDeviceSpeedFull, kUSBDeviceSpeedHigh
hub
USB ID of hub the device is immediatly attached to. (Not necessarily high speed)
port
port number of port the device is attached to.*/
 IOReturn IOUSBControllerV2::ConfigureDeviceZero(
    UInt8 maxPacketSize,
    UInt8 speed,
    USBDeviceAddress hub,
    int port){}; 

/*OpenPipe


public

virtual IOReturn OpenPipe(
    USBDeviceAddress address, 
    UInt8 speed, 
    Endpoint *endpoint ); 
Parameters
address
Address of the device on the USB bus
speed
of the device: kUSBDeviceSpeedLow, kUSBDeviceSpeedFull or kUSBDeviceSpeedHigh
endpoint
description of endpoint to connect to
Discussion 

Open a pipe to the specified device endpoint*/
IOReturn IOUSBControllerV2::OpenPipe(
    USBDeviceAddress address, 
    UInt8 speed, 
    Endpoint *endpoint ){}; 


/*UIMCreateInterruptEndpoint


Create an endpoint in the controller to do interrupt transactions. 

public

virtual IOReturn UIMCreateInterruptEndpoint( 
    short functionAddress, 
    short endpointNumber, 
    UInt8 direction, 
    short speed, 
    UInt16 maxPacketSize, 
    short pollingRate, 
    USBDeviceAddress highSpeedHub, 
    int highSpeedPort) = 0; 
Parameters
functionAddress
USB device ID of device
endpointNumber
endpoint address of the endpoint in the device
direction
Direction of data flow. kUSBIn or kUSBOut
speed
speed of the device kUSBDeviceSpeedLow, kUSBDeviceSpeedFull, kUSBDeviceSpeedHigh
maxPacketSize
maximum packet size of this endpoint
pollingRate
The maximum polling interval from the endpoint descriptor.
highSpeedHub
If speed is not kUSBDeviceSpeedHigh, the address of the high speed hub to address split transactions to.
highSpeedPort
If speed is not kUSBDeviceSpeedHigh, the hub port to address split transactions to*/
IOReturn IOUSBControllerV2::UIMCreateInterruptEndpoint( 
    short functionAddress, 
    short endpointNumber, 
    UInt8 direction, 
    short speed, 
    UInt16 maxPacketSize, 
    short pollingRate, 
    USBDeviceAddress highSpeedHub, 
    int highSpeedPort) {}; 

/*UIMCreateBulkEndpoint


Create an endpoint in the controller to do bulk transactions. 

public

virtual IOReturn UIMCreateBulkEndpoint( 
    UInt8 functionNumber, 
    UInt8 endpointNumber, 
    UInt8 direction, 
    UInt8 speed, 
    UInt16 maxPacketSize, 
    USBDeviceAddress highSpeedHub, 
    int highSpeedPort) = 0; 
Parameters
functionNumber
USB device ID of device
endpointNumber
endpoint address of the endpoint in the device
direction
Direction of data flow. kUSBIn or kUSBOut
maxPacketSize
maximum packet size of this endpoint
speed
speed of the device kUSBDeviceSpeedFull, kUSBDeviceSpeedHigh
highSpeedHub
If speed is not kUSBDeviceSpeedHigh, the address of the high speed hub to address split transactions to.
highSpeedPort
If speed is not kUSBDeviceSpeedHigh, the hub port to address split transactions to*/
 IOReturn IOUSBControllerV2:: UIMCreateBulkEndpoint( 
    UInt8 functionNumber, 
    UInt8 endpointNumber, 
    UInt8 direction, 
    UInt8 speed, 
    UInt16 maxPacketSize, 
    USBDeviceAddress highSpeedHub, 
    int highSpeedPort) {}; 

/*UIMCreateControlEndpoint


Create an endpoint in the controller to do control transactions. 

public

virtual IOReturn UIMCreateControlEndpoint( 
    UInt8 functionNumber, 
    UInt8 endpointNumber, 
    UInt16 maxPacketSize, 
    UInt8 speed, 
    USBDeviceAddress highSpeedHub, 
    int highSpeedPort) = 0; 
Parameters
functionNumber
USB device ID of device
endpointNumber
endpoint address of the endpoint in the device
maxPacketSize
maximum packet size of this endpoint
speed
speed of the device kUSBDeviceSpeedLow, kUSBDeviceSpeedFull, kUSBDeviceSpeedHigh
highSpeedHub
If speed is not kUSBDeviceSpeedHigh, the address of the high speed hub to address split transactions to.
highSpeedPort
If speed is not kUSBDeviceSpeedHigh, the hub port to address split transactions to*/
IOReturn IOUSBControllerV2::UIMCreateControlEndpoint( 
    UInt8 functionNumber, 
    UInt8 endpointNumber, 
    UInt16 maxPacketSize, 
    UInt8 speed, 
    USBDeviceAddress highSpeedHub, 
    int highSpeedPort) {}; 



/*UIMCreateIsochEndpoint(short, short, UInt32, UInt8, USBDeviceAddress, int, UInt8)


Create an endpoint in the controller to do Isochronous transactions. 

public

virtual IOReturn UIMCreateIsochEndpoint( 
    short functionAddress, 
    short endpointNumber, 
    UInt32 maxPacketSize, 
    UInt8 direction, 
    USBDeviceAddress highSpeedHub, 
    int highSpeedPort, 
    UInt8 interval); 
Parameters
functionAddress
USB device ID of device
endpointNumber
endpoint address of the endpoint in the device
maxPacketSize
maximum packet size of this endpoint
direction
Specifies direction for the endpoint. kUSBIn or KUSBOut.
highSpeedHub
If non zero, this is a full speed device, the address of the high speed hub to address split transactions to.
highSpeedPort
If highSpeedHub is non zero, the hub port to address split transactions to
interval
The encoded interval value from the endpoint descriptor*/
IOReturn IOUSBControllerV2::UIMCreateIsochEndpoint( 
    short functionAddress, 
    short endpointNumber, 
    UInt32 maxPacketSize, 
    UInt8 direction, 
    USBDeviceAddress highSpeedHub, 
    int highSpeedPort, 
    UInt8 interval){}; 

/*UIMCreateIsochEndpoint(short, short, UInt32, UInt8, USBDeviceAddress, int)


Create an endpoint in the controller to do Isochronous transactions. 

public

virtual IOReturn UIMCreateIsochEndpoint( 
    short functionAddress, 
    short endpointNumber, 
    UInt32 maxPacketSize, 
    UInt8 direction, 
    USBDeviceAddress highSpeedHub, 
    int highSpeedPort) = 0; 
Parameters
functionAddress
USB device ID of device
endpointNumber
endpoint address of the endpoint in the device
maxPacketSize
maximum packet size of this endpoint
direction
Specifies direction for the endpoint. kUSBIn or KUSBOut.
highSpeedHub
If non zero, this is a full speed device, the address of the high speed hub to address split transactions to.
highSpeedPort
If highSpeedHub is non zero, the hub port to address split transactions to*/
IOReturn IOUSBControllerV2::UIMCreateIsochEndpoint( 
    short functionAddress, 
    short endpointNumber, 
    UInt32 maxPacketSize, 
    UInt8 direction, 
    USBDeviceAddress highSpeedHub, 
    int highSpeedPort) {}; 

