#include <IOKit/usb/IOUSBHubDevice.h>

bool		IOUSBHubDevice::	InitializeCharacteristics(void){};//?
void		IOUSBHubDevice::	SetHubCharacteristics(UInt32 a){};//?
 bool 	IOUSBHubDevice::init(){};//?
void		IOUSBHubDevice::	SetPolicyMaker(IOUSBHubPolicyMaker *a){};//?
 void		IOUSBHubDevice::	ReturnExtraPower(UInt32 a){};//?
UInt32	IOUSBHubDevice::		RequestExtraPower(UInt32 a){};//?
bool IOUSBHubDevice::	start( IOService * a){};//?
void	IOUSBHubDevice::free(){};//?
void 	IOUSBHubDevice::stop( IOService *a ){};//?
IOUSBHubDevice	* IOUSBHubDevice::NewHubDevice(void){};//c

///////////////////
/*GetHubCharacteristics


public

virtual UInt32 GetHubCharacteristics(); 
Return Value

returns a bitmap of characteristics 
Discussion 

returns characteristics of the hub device which might be useful for the driver of a device connected to the hub. kIOUSBHubDeviceIsRootHub indicates that the hub is a root hub kIOUSBHubDeviceIsOnHighSpeedBus indicates that the hub is running on a High Speed bus. If this bit is set and kIOUSBHubDeviceIsHighSpeed is clear, then this is a Classic Speed hub running on a High Speed bus, which means that Split Transactions will be used to communicate with downstream devices.*/
 UInt32 IOUSBHubDevice::GetHubCharacteristics(){}; 

/*GetMaxProvidedPower


public

virtual UInt32 GetMaxProvidedPower(); 
Return Value

the power is returned in milliamps - usually 100ma or 500 ma. 
Discussion 

returns the maximum amount of power available on any downstream port of this hub*/
UInt32 IOUSBHubDevice:: GetMaxProvidedPower(){}; 


/*GetPolicyMaker


public

virtual IOUSBHubPolicyMaker *GetPolicyMaker(
    void); 
Return Value

returns an IOUSBHubPolicyMaker* pointing to the policy maker for this hub. returns NULL is no policy maker is active on the hub device. 
Discussion 

returns a pointer to the policy maker for the hub, which can be used as the power plane parent.*/
 IOUSBHubPolicyMaker *IOUSBHubDevice::GetPolicyMaker(
    void){}; 

/*RequestProvidedPower


public

virtual UInt32 RequestProvidedPower(
    UInt32 requestedPower); 
Parameters
requestedPower
- the amount of power requested in milliamps (usually 100ma or 500 ma)
Return Value

the amount of power allocated for this driver in milliamps (usually 100ma or 500 ma) 
Discussion 

requests power from the hub device*/
 UInt32  IOUSBHubDevice::RequestProvidedPower(
    UInt32 requestedPower){}; 
