#include <Security/SecIdentity.h>
#include <stdio.h>

/*SecIdentityGetTypeID

Returns the unique identifier of the opaque type to which a SecIdentity object belongs.

CFTypeID SecIdentityGetTypeID (void);
Return Value

A value that identifies the opaque type of a SecIdentityRef object.
Discussion

This function returns a value that uniquely identifies the opaque type of a SecIdentityRef object. You can compare this value to the CFTypeID identifier obtained by calling the CFGetTypeID function on a specific object. These values might change from release to release or platform to platform.
Availability
Available in Mac OS X v10.2 and later.
Declared In
SecIdentity.h*/
CFTypeID SecIdentityGetTypeID (void){
printf ("SecIdentityGetTypeID");
};
