#include <stdio.h>
#include <mach/mach_port.h>

int mach_port_get_attributes(int a,int b,int c,int  d,int e){};//?
int mach_port_destroy(int a,int b){};//?
int mach_port_mod_refs(int a,int b,int c,int d){};//?
int mach_port_request_notification(int a,int b,int c,int d,int e,int f,int g){};//?
int mach_port_get_set_status(int a,int b,int c,int d){};//?
int mach_port_names(int a,int b,int c,int d,int e){};//?
int mach_port_get_refs(int a,int b,int c,int d){};//?

kern_return_t mach_port_set_attributes (ipc_space_t a, mach_port_name_t b, mach_port_flavor_t   c, mach_port_info_t d, mach_msg_type_number_t e){};//c

kern_return_t mach_port_insert_right( ipc_space_t a, mach_port_name_t b, mach_port_t c,	 mach_msg_type_name_t d){};//c

kern_return_t mach_port_insert_member( ipc_space_t a, mach_port_name_t b, mach_port_name_t c){};//c

kern_return_t mach_port_extract_member(ipc_space_t a, mach_port_name_t b, mach_port_name_t c){};//c

kern_return_t mach_port_deallocate(ipc_space_t a, mach_port_name_t b){};//c

///////////////////////////////
/*
Function: kern_return_t mach_port_allocate (mach_port_t task, mach_port_right_t right, mach_port_t *name)
    The mach_port_allocate function creates a new right in the specified task. The new right's name is returned in name, which may be any name that wasn't in use.

    The right argument takes the following values:

    MACH_PORT_RIGHT_RECEIVE
        mach_port_allocate creates a port. The new port is not a member of any port set. It doesn't have any extant send or send-once rights. Its make-send count is zero, its sequence number is zero, its queue limit is MACH_PORT_QLIMIT_DEFAULT, and it has no queued messages. name denotes the receive right for the new port. task does not hold send rights for the new port, only the receive right. mach_port_insert_right and mach_port_extract_right can be used to convert the receive right into a combined send/receive right. 
    MACH_PORT_RIGHT_PORT_SET
        mach_port_allocate creates a port set. The new port set has no members. 
    MACH_PORT_RIGHT_DEAD_NAME
        mach_port_allocate creates a dead name. The new dead name has one user reference. 

    The function returns KERN_SUCCESS if the call succeeded, KERN_INVALID_TASK if task was invalid, KERN_INVALID_VALUE if right was invalid, KERN_NO_SPACE if there was no room in task's IPC name space for another right and KERN_RESOURCE_SHORTAGE if the kernel ran out of memory.

    The mach_port_allocate call is actually an RPC to task, normally a send right for a task port, but potentially any send right. In addition to the normal diagnostic return codes from the call's server (normally the kernel), the call may return mach_msg return codes. */
kern_return_t mach_port_allocate (mach_port_t task, mach_port_right_t right, mach_port_t *name){};
