

.SUFFIXES : .m .o 
.m.o : 
	 g++  $(CFLAGS) -fconstant-string-class=NSConstantString -c $< -o $@ 


.SUFFIXES : .mm .o 
.mm.o : 
	 g++ $(CFLAGS) -fconstant-string-class=NSConstantString -c $< -o $@

.SUFFIXES : .c .o 
.c.o : 
	gcc  $(CFLAGS) -c $< -o $@

.SUFFIXES : .cpp .o 
.cpp.o : 
	g++ $(CFLAGS) -c $< -o $@
	
CC = gcc

all: $(TARGET)

INC =  -I/usr/local/include/opencocoa -I/usr/GNUstep/System/Library/Headers -I.
LIB_OPTION = -L/usr/GNUstep/System/Library/Libraries/ 
CFLAGS = -g -Wno-multichar  $(INC) $(DEF) $(COMPILE_OPTION)
OLD_CFLAGS =  -fPIC 
#-Wno-multichar  

TARGET = $(Name).dll

ARCHIVE = $(Name).a

all : $(ARCHIVE) $(TARGET)



$(ARCHIVE) :$(OBJS)


$(TARGET) :$(ARCHIVE) $(OBJS)
	$(CC) $(LIB_OPTION)  -shared -o $(Name).dll $(OBJS)  -Wl,--out-implib,${Name}.a $(LIBS) \
	-Xlinker --enable-auto-import 

clean :
	rm -rf  $(OBJS) $(TARGET) $(ARCHIVE) ${Name}.def core
	


dep :
	gccmakedep $(INC) $(SRCS)

$(TARGET)_OLD :$(ARCHIVE) $(OBJS)
	# dlltool --export-all-symbols  --output-def $(Name).def  --dllname $(Name).dll ${OBJS}
	# dlltool --output-lib ${Name}.a --input-def ${Name}.def  --dllname ${Name}.dll $(OBJS)
	# $(CC) -shared   -o $(Name).dll  $(OBJS) $(LIBS)

# $(TARGET) : $(ARCHIVE)
	# $(CC) -shared $(LIBS)  -o $(Name).dll  $(Name).a 


# $(ARCHIVE) : $(OBJS)
	# ar rc $(Name).a *.o