#ifndef OC_COREFOUNDATIOM_CFINTERNAL_H
#define OC_COREFOUNDATIOM_CFINTERNAL_H

#define OC_CF

#include <CoreFoundation/CFBase.h>
#include <CoreFoundation/CFURL.h>
#include <CoreFoundation/CFString.h>
#include <CoreFoundation/CFDate.h>
#include <CoreFoundation/CFArray.h>
#include <CoreFoundation/CFRunLoop.h>
#include <CoreFoundation/CFStorage.h>
#include "CFLogUtilities.h"
#include "CFRuntime.h"
#if DEPLOYMENT_TARGET_MACOSX
#include <xlocale.h>
#include <mach/mach_time.h>
#endif
#if DEPLOYMENT_TARGET_MACOSX || DEPLOYMENT_TARGET_LINUX || DEPLOYMENT_TARGET_FREEBSD
#include <sys/time.h>
#include <pthread.h>
#endif
#include <limits.h>
#include "auto_stubs.h"
#if !defined (__WIN32__)
#include <pthread.h>
#endif //__WIN32__
#ifndef __WIN32__
#include <libkern/OSAtomic.h>
#endif //__WIN32__

#include "ForFoundationOnly.h"

#if defined(__svr4__) || defined(__hpux__) || defined(__WIN32__)
#include <errno.h>
#elif DEPLOYMENT_TARGET_MACOSX || DEPLOYMENT_TARGET_LINUX || DEPLOYMENT_TARGET_FREEBSD
#include <sys/errno.h>
#endif

#ifndef OC_CF

#ifndef DEPLOYMENT_TARGET_MACOSX
	#define DEPLOYMENT_TARGET_MACOSX 1
	#define DEPLOYMENT_TARGET_MACOSX_DEF 1
#endif//mach/i386/boolean.h define boolean_t
//need auto-stubs.h

#ifndef CF_BUILDING_CF
	#define CF_BUILDING_CF 1
	#define CF_BUILDING_CF_DEF 1
#endif

#include "/usr/include/CoreFoundation/CFInternal.h"

#ifdef DEPLOYMENT_TARGET_MACOSX_DEF	
	#undef DEPLOYMENT_TARGET_MACOSX_DEF
	#undef DEPLOYMENT_TARGET_MACOSX
#endif

#ifdef CF_BUILDING_CF_DEF
	#undef CF_BUILDING_CF
	#undef CF_BUILDING_CF_DEF
#endif

#endif //OC_CF

#include <HYS/CoreFoundation/CFInternal.h>

#endif//OC_COREFOUNDATIOM_CFINTERNAL_H
