
//#ifndef __DISKARBITRATIOND_DADISK__
//#define __DISKARBITRATIOND_DADISK__
#ifndef __DISKARBITRATION_DADISK__
#define __DISKARBITRATION_DADISK__

#ifndef DISKARBITRATION_DADISK_H
#define DISKARBITRATION_DADISK_H

#include <CoreFoundation/CoreFoundation.h>

#include <IOKit/IOKitLib.h>

#ifndef __DISKARBITRATIOND_DASESSION__
#ifndef  __DISKARBITRATIOND_DADISK__

#include <DiskArbitration/DASession.h>

#endif//__DISKARBITRATIOND_DADISK__
#endif //__DISKARBITRATIOND_DASESSION__

#include "DAFileSystem.h"

#ifdef __cplusplus
extern "C" {
#endif

/*DADiskRef

typedef struct __DADisk * DADiskRef;  
Discussion 

Type of a reference to DADisk instances.*/

#ifndef __DISKARBITRATIOND_DADISK__
typedef struct __DADisk * DADiskRef;  //DADisk.h
#endif

#include <HYS/DiskArbitration/DADisk.h>

//func

/*DADiskCopyDescription


Obtains the Disk Arbitration description of the specified disk. 
extern CFDictionaryRef DADiskCopyDescription(
    DADiskRef disk );  
Parameters
disk
The DADisk for which to obtain the Disk Arbitration description.
Return Value

The disk's Disk Arbitration description. 
Discussion 

This function will contact Disk Arbitration to acquire the latest description of the specified disk, unless this function is called on a disk object passed within the context of a registered callback, in which case the description is current as of that callback event. 

The caller of this function receives a reference to the returned object. The caller also implicitly retains the object and is responsible for releasing it with CFRelease().*/
#ifndef __DISKARBITRATIOND_DADISK__
extern CFDictionaryRef DADiskCopyDescription(
    DADiskRef disk );  
#endif

#ifdef __cplusplus
}
#endif 

#include <DiskArbitration/DiskArbitration.h>//add


#endif//DISKARBITRATION_DADISK_H
#endif//__DISKARBITRATION_DADISK__
//#endif //__DISKARBITRATIOND_DADISK__
