//#ifndef __DISKARBITRATIOND_DASESSION__
//#define __DISKARBITRATIOND_DASESSION__

#ifndef __DISKARBITRATION_DASESSION__
#define __DISKARBITRATION_DASESSION__

#ifndef DISKARBITRATION_DASESSION_H
#define DISKARBITRATION_DASESSION_H

#include <CoreFoundation/CoreFoundation.h>
//#include <DiskArbitration/DiskArbitration.h>
#include <Security/Authorization.h>//AuthorizationRef(DiskArbitrationPrivate)
#include <HYS/DiskArbitration/DASession.h>
#ifdef __cplusplus
extern "C" {
#endif

/*DASessionRef

typedef struct __DASession * DASessionRef;  
Discussion 

Type of a reference to DASession instances.*/

typedef struct __DASession * DASessionRef;  

/*DAApprovalSessionRef


typedef struct __DAApprovalSession * DAApprovalSessionRef;  
Discussion 

Type of a reference to DAApprovalSession instances.*/
typedef struct __DAApprovalSession * DAApprovalSessionRef;  

//func


/*DASessionUnscheduleFromRunLoop


Unschedules the session from a run loop. 
extern void DASessionUnscheduleFromRunLoop(
    DASessionRef session,
    CFRunLoopRef runLoop,
    CFStringRef runLoopMode );  
Parameters
session
The session which is being unscheduled.
runLoop
The run loop on which the session is scheduled.
runLoopMode
The run loop mode in which the session is scheduled.*/
extern void DASessionUnscheduleFromRunLoop(
    DASessionRef session,
    CFRunLoopRef runLoop,
    CFStringRef runLoopMode );  

/*DASessionScheduleWithRunLoop


Schedules the session on a run loop. 
extern void DASessionScheduleWithRunLoop(
    DASessionRef session,
    CFRunLoopRef runLoop,
    CFStringRef runLoopMode );  
Parameters
session
The session which is being scheduled.
runLoop
The run loop on which the session should be scheduled.
runLoopMode
The run loop mode in which the session should be scheduled.*/
extern void DASessionScheduleWithRunLoop(
    DASessionRef session,
    CFRunLoopRef runLoop,
    CFStringRef runLoopMode );  

/*DASessionCreate


Creates a new session. 
extern DASessionRef DASessionCreate(
    CFAllocatorRef allocator );  
Return Value

A reference to a new DASession. 
Discussion 

The caller of this function receives a reference to the returned object. The caller also implicitly retains the object and is responsible for releasing it.*/
//#ifdef DiskArbitration_PKG
//	#define DASessionCreate __DASessionCreate
//#endif

extern DASessionRef DASessionCreate(
    CFAllocatorRef allocator ); 

//#undef DASessionCreate


#ifdef __cplusplus
}
#endif 

#endif //DISKARBITRATION_DASESSION_H
#endif //__DISKARBITRATION_DASESSION__
//#endif//__DISKARBITRATIOND_DASESSION__
