#ifndef HYS_CFOPENDIRECTORY_CFOPENDIRECTORY_H
#define HYS_CFOPENDIRECTORY_CFOPENDIRECTORY_H

typedef struct _ODNode         *ODNodeRef;//c
typedef struct _ODRecord        *ODRecordRef;//c
typedef struct _ODSessionRef    *ODSessionRef;//c
typedef struct _ODQuery         *ODQueryRef;//c
typedef struct _ODContext       *ODContextRef;//c

typedef void (*ODQueryCallback)( ODQueryRef a, CFArrayRef b, CFErrorRef c, void *d);//c

///////////

CF_EXPORT ODSessionRef kODSessionDefault;//c
CF_EXPORT const CFStringRef kODSessionProxyAddress;//c
CF_EXPORT const CFStringRef kODSessionProxyUsername;//c
CF_EXPORT const CFStringRef kODSessionProxyPassword;//c
//////////////////////

ODNodeRef ODNodeCreateCopy( CFAllocatorRef a, ODNodeRef b, CFErrorRef *c);//c
CFTypeID ODContextGetTypeID( void );//c
CFTypeID ODQueryGetTypeID( void );//c
CFArrayRef ODQueryCopyResults( ODQueryRef a, Boolean b, CFErrorRef *c );//c
CFTypeID ODSessionGetTypeID( void );//c
CFTypeID ODNodeGetTypeID( void );//c

ODNodeRef ODNodeCreateWithNodeType( CFAllocatorRef a, ODSessionRef b, ODNodeType c, CFErrorRef *d );//c

CFDataRef ODNodeCustomCall( ODNodeRef a, CFIndex b, CFDataRef c, CFErrorRef *e );//c
CFTypeID ODRecordGetTypeID( void );//c
CFStringRef ODRecordGetRecordName( ODRecordRef a);//c
Boolean ODRecordAddValue( ODRecordRef a, CFStringRef b, CFTypeRef c, CFErrorRef *d );//c
Boolean ODRecordRemoveValue( ODRecordRef a, CFStringRef b, CFTypeRef c, CFErrorRef *d );//c

#endif//HYS_CFOPENDIRECTORY_CFOPENDIRECTORY_H
