#ifndef HYS_COREFOUNDATION_CFBASE_H
#define HYS_COREFOUNDATION_CFBASE_H


//hys add
extern  void __CFPreferencesDomainInitialize(void);
//hys add 
	

#ifdef OC_CF	

#if defined(__WIN32__)
    #undef CF_EXPORT
    #if defined(CF_BUILDING_CF)
	#define CF_EXPORT __declspec(dllexport) extern
    #else
	#define CF_EXPORT __declspec(dllimport) extern
    #endif
#elif defined(macintosh)
    #if defined(__MWERKS__)
        #define CF_EXPORT __declspec(export) extern
    #endif
#endif//c


#if !defined(CF_EXPORT)
    #define CF_EXPORT extern
#endif//c

#if !defined(CF_INLINE)
    #if defined(__GNUC__) && (__GNUC__ == 4) && !defined(DEBUG)
        #define CF_INLINE static __inline__ __attribute__((always_inline))
    #elif defined(__GNUC__)
        #define CF_INLINE static __inline__
    #elif defined(__MWERKS__) || defined(__cplusplus)
	#define CF_INLINE static inline
    #elif defined(_MSC_VER)
        #define CF_INLINE static __inline
    #elif defined(__WIN32__)
	#define CF_INLINE static __inline__
    #endif
#endif//c

#if !defined(CF_EXTERN_C_BEGIN)
#if defined(__cplusplus)
#define CF_EXTERN_C_BEGIN extern "C" {
#define CF_EXTERN_C_END   }
#else
#define CF_EXTERN_C_BEGIN
#define CF_EXTERN_C_END
#endif
#endif//c

/////////////////////////


#ifndef	OC_UTF32Char
#define OC_UTF32Char

#undef UTF32Char
    typedef UInt32                  UTF32Char;//c
#endif

#ifndef OC_SINT8
	#define OC_SINT8
	typedef signed char             SInt8;//c
#endif

#ifndef OC_UINT8
	#define OC_UINT8
    typedef unsigned char           UInt8;//c
#endif

#ifndef OC_UINT16
	#define OC_UINT16
    typedef unsigned short          UInt16;//c
#endif

#ifndef OC_SINT16
	#define OC_SINT16
    typedef signed short            SInt16;//c
#endif

#ifndef OC_UINT32
	#define OC_UINT32
    	typedef unsigned int            UInt32;//c
#endif

#ifndef OC_SINT32	
	#define OC_SINT32
	typedef signed int              SInt32;//c
#endif

#ifndef OC_UINT64
	#define OC_UINT64
    typedef uint64_t		    UInt64;//c
#endif

#ifndef OC_SINT64
	#define OC_SINT64
    typedef int64_t		    SInt64;//c
#endif

#ifndef OC_OSStatus
#define OC_OSStatus
    typedef SInt32                  OSStatus;//c
#endif

#ifndef OC_Float32	
#define OC_Float32
    typedef float                   Float32;//c
#endif
	
#ifndef OC_Float64
	#define OC_Float64
	typedef double                  Float64;//c
#endif
	
#ifndef OC_UniChar
#define OC_UniChar
    typedef unsigned short          UniChar;//c
#endif

#ifndef OC_StringPtr
#define OC_StringPtr	
    typedef unsigned char *         StringPtr;//c
#endif

#ifndef OC_Str255
	#define OC_Str255
    typedef unsigned char           Str255[256];//c
#endif

#ifndef OC_ConstStr255Param
#define OC_ConstStr255Param	
    typedef const unsigned char *   ConstStr255Param;//c
#endif

#ifndef OC_OSErr
#define OC_OSErr
    typedef SInt16                  OSErr;//c
#endif
	
#ifndef OC_RegionCode
#define OC_RegionCode
    typedef SInt16                  RegionCode;//c
#endif

#ifndef OC_ConstStringPtr	
#define OC_ConstStringPtr	
    typedef const unsigned char *   ConstStringPtr;//c
#endif

#ifndef OC_LangCode
	#define OC_LangCode
    typedef SInt16                  LangCode;//c
#endif

#ifndef OC_UTF16Char
#define OC_UTF16Char
    typedef UInt16                  UTF16Char;//c
#endif

#ifndef OC_BOOLEAN
	#define OC_BOOLEAN
    typedef unsigned char           Boolean;//c
#endif

    typedef UInt8                   UTF8Char;//c
#endif//OC_CF

//#endif

#endif//HYS_COREFOUNDATION_CFBASE_H
