#ifndef HYS_DVCOMPONENTGLUE_ISOCHRONOUSDATAHANDLER_H
#define HYS_DVCOMPONENTGLUE_ISOCHRONOUSDATAHANDLER_H

enum {
	kIDHComponentType,//?
	kIDHDeviceAtomType,//?
	kIDHErrDeviceDisconnected,//?
	kIDHDataTypeAtomType,//?
	kIDHEventFrameDropped,//?
	kIDHErrDeviceList,//?
	kIDHVideoRefreshRateAtomType,//?
	kIDHGetFormatSelect,//?
	kIDHReadSelect,//?
	kIDHUseCMPAtomType,//?
	kIDHDeviceIDEveryDevice,//?
	kIDHDataSizeAtomType,//?
	kIDHDataIntervalAtomType,//?
	kIDHNameAtomType,//?
	kIDHIsochMediaType,//?
	kIDHDataBufferSizeAtomType,//?
	kIDHInvalidDeviceID,//?
	kIDHVideoDecompressorComponentAtomType,//?
	kIDHVideoDimensionsAtomType,//?
	kIDHVideoMediaAtomType,//?
	kIDHSoundChannelCountAtomType,//?
	kIDHVideoPixelTypeAtomType,//?
	kIDHDataIODirectionAtomType,//?
	kIDHIsochModeAtomType,//?
	kIDHDataTypeIsInputAndOutput,//?
	kIDHVideoResolutionAtomType,//?
	kIDHSetFormatSelect,//?
	kIDHDisposeNotificationSelect,//?
	kIDHCancelNotificationSelect,//?
	kIDHVideoDecompressorTypeAtomType,//?
	kIDHSoundMediaAtomType,//?
	kIDHSoundSampleSizeAtomType,//?
	kIDHSoundSampleRateAtomType,//?
	kIDHErrDeviceNotConfigured,//?
	kIDHUniqueIDType,//?
	kIDHDV_SD,//?
	kIDHCloseDeviceSelect,//?
	kIDHWriteSelect,//?
	kIDHReleaseBufferSelect,//?
	kIDHGetDeviceStatusSelect,//?
	kIDHEventDeviceChanged,//?
	kIDHDeviceIDType,//?
	kIDHOpenForReadTransactions,//?
	kIDHEventReadEnabled,//?
	kIDHErrDeviceNotOpened,//?
	kIDHEventDeviceRemoved,//?
	kIDHEventReadDisabled,//?
	kIDHIsochServiceAtomType,//?
	kIDHEventDeviceAdded,//?
	kIDHCancelPendingIOSelect,//?
	kIDHOpenForWriteTransactions,//?
	kIDHEventWriteDisabled,//?
	kIDHErrDeviceCantWrite,//?
	kIDHEventWriteEnabled,//?
	kIDHDV_SDL,//?
	kIDHDVCPro_25,//?
	kIDHErrDeviceInUse,//?
	kIDHIsochVersionAtomType,//?
	kIDHUpdateDeviceListSelect,//?
	kIDHGetDeviceTimeSelect,//?
	kIDHErrCompletionPending,//?
	kIDHGetDeviceListSelect,//?
	kIDHOpenDeviceSelect,//?
	kIDHGetDeviceControlSelect,//?
	kIDHGetDeviceConfigurationSelect,//?
	kIDHNotifyMeWhenSelect,//?
	kIDHSetDeviceConfigurationSelect,//?
	kIDHGetDeviceClockSelect,//?
	kIDHNewNotificationSelect,//?
	kIDHEventEveryEvent,//?
	kIDHErrInvalidDeviceID,//?
	kIDHErrDeviceBusy,//?
};

struct IDHDeviceStatus {
	int version;//?
	int physicallyConnected;//?
	int readEnabled;//?
	int writeEnabled;//?
	int exclusiveAccess;//?
	int currentBandwidth;//?
	int currentChannel;//?
	int inputStandard;//?
	int inputFormat;//?
	int outputFormats;//?
	int deviceActive;//?
	int localNodeID;//?
};
typedef struct IDHDeviceStatus IDHDeviceStatus;

struct IDHEventHeader  {
	int event;//?
	int deviceID;//?
	int notificationID;//?
};
typedef struct IDHEventHeader  IDHEventHeader;

struct IDHGenericEvent {
	IDHEventHeader  eventHeader;//c
};
typedef struct IDHGenericEvent IDHGenericEvent;

typedef OSStatus (* IDHNotificationProcPtr )(IDHGenericEvent *a, void *b);//c

typedef IDHNotificationProcPtr IDHNotificationUPP;//c

struct IDHParameterBlock {
	int reserved1;//?
	int actualCount;//?
	int result;//?
	IDHNotificationUPP completionProc;//c
	int refCon;//?
	int buffer;//?
	int requestedCount;//?
};
typedef struct IDHParameterBlock IDHParameterBlock;

struct IDHDeviceFrameDroppedEvent {
	IDHEventHeader eventHeader;//c
	int totalDropped;//?
	int newlyDropped;//?
};
typedef struct IDHDeviceFrameDroppedEvent IDHDeviceFrameDroppedEvent;

struct IDHDimension {
	int x;//?
	int y;//?
};
typedef struct IDHDimension IDHDimension;

struct IDHResolution {
	int x;//?
	int y;//?
};
typedef struct IDHResolution IDHResolution;

struct IDHDeviceConnectionEvent {
	IDHEventHeader  eventHeader;//c
};
typedef struct IDHDeviceConnectionEvent IDHDeviceConnectionEvent;

typedef int IDHDeviceID;//?
typedef int IDHNotificationID;//?
typedef int IDHEvent;//?
typedef int PsuedoID;//?

typedef IDHNotificationProcPtr  IDHNotificationProc;//c

//func
ComponentResult IDHGetDeviceList(ComponentInstance  a,QTAtomContainer *   b);//c

#endif//HYS_DVCOMPONENTGLUE_ISOCHRONOUSDATAHANDLER_H


