#ifndef HYS_DIRECTORYSERVICECORE_BASEDIRECTORYPLUGINTYPOES_H
#define HYS_DIRECTORYSERVICECORE_BASEDIRECTORYPLUGINTYPOES_H

#define kBDPINameKey "kBDPINameKey"
#define kBDPITypeKey "kBDPITypeKey"//?
#define kBDPIAttributeKey "kBDPIAttributeKey"//?

const int kBPDIBufferTax	= 1;//?

enum {
	kBDPIDirNode,//?
	kBDPIRecordEntry,//?
	kBDPISearchRecords,//?
	kBDPIAttributeEntry,//?
	kBDPIUndefined,//?
};

struct  sBDPINodeContext {
	int fType;//?
	BDPIVirtualNode * fVirtualNode;//c
	int fUID;//?
	int fEffectiveUID;//?
};

struct sBDPIAuthContext {
	int a;//dummy
};

typedef void (*SearchCtxStateFree)(void *a);//c

struct sBDPISearchRecordsContext {
	void * fStateInfo;//c
	CFArrayRef fRecordTypeList;//c
	CFStringRef fAttributeType;//c
	int fPattMatchType;//?
	CFArrayRef fValueList;//c
	CFArrayRef fReturnAttribList;//c
	int fAttribsOnly;//?
	int fIndex;//?
	int fMaxRecCount;//?
	SearchCtxStateFree fStateInfoCallback;//c
	int fRecTypeIndex;//?
};

struct sBDPIRecordEntryContext {
	BDPIVirtualNode * fVirtualNode;//c
	CFMutableDictionaryRef fRecord;//c
	int fType;//?
};

struct sBDPIAttributeEntryContext {
	CFMutableDictionaryRef fRecord;//c
	CFStringRef fAttributeName;//c
	CFMutableArrayRef fAttributeValueList;//c
	int fType;//?
	int fVirtualNode;//?
};

typedef void *BDPIOpaqueBuffer;//c
typedef int CntxDataType;//?

#endif//HYS_DIRECTORYSERVICECORE_BASEDIRECTORYPLUGINTYPOES_H
