#ifndef HYS_DIRECTORYSERVICECORE_CDSAUTHPARAMS_H
#define HYS_DIRECTORYSERVICECORE_CDSAUTHPARAMS_H




class CDSAuthParams_HYS {
public://data
UInt32 uiAuthMethod;//c
char * mAuthMethodStr;//c
char* pUserName;//c
char * pNewPassword;//c
char * pOldPassword;//c
unsigned char* pNTLMDigest;//c
unsigned long ntlmDigestLen;//c
unsigned char * pCramResponse;//c
unsigned long cramResponseLen;//c
char *pSambaName;//c
char * pDomain;//c
char * pAdminUser;//c
char * pAdminPassword;//c
unsigned char* PeerC16;//c
tDataListPtr dataList;//c
char * path;//c
UInt32 hashLength;//c
SInt32 hashesLengthFromFile;//c
tDataNodePtr secureHashNode;//c
unsigned int itemCount;//c
char * nativeAttrType;//c
char * policyStr;//c
unsigned long policyStrLen;//c
int keySize;//c
char * challenge;//c
char * apopResponse;//c
char * aaData;//c
char* aaDataLocalCacheUser;//c
CFDictionaryRef serviceInfoDict;//c
	bool						mPostAuthEvent;//c
struct timespec modDateOfPassword;//c
struct timeval	 modDateAssist;//c
PWGlobalAccessFeatures globalAccess;//c
PWGlobalMoreAccessFeatures globalMoreAccess;//c
digest_context_t digestContext;//c
	unsigned char				P21[kHashShadowKeyLength];//c
	unsigned char				C8[kHashShadowChallengeLength];//c
	unsigned char				P24[kHashShadowResponseLength];//c
	unsigned char				P24Input[kHashShadowResponseLength];//c
	unsigned char				hashes[kHashTotalLength];//c
	unsigned char				generatedHashes[kHashTotalLength];//c
	unsigned char				C16[16];//c
	unsigned char				secureHash[kHashSaltedSHA1Length];//c
	unsigned char				GeneratedNTLM[EVP_MAX_MD_SIZE];//c
	char						MSCHAP2Response[MS_AUTH_RESPONSE_LENGTH+1];//c

public://func
#define CDSAuthParams_LoadParamsForAuthMethod \
	virtual tDirStatus				LoadParamsForAuthMethod(tDataNodePtr inAuthMethod,tDataBufferPtr inAuthData,tDataBufferPtr inAuthStepData );//c

#define CDSAuthParams_ZeroHashes \
		virtual void					ZeroHashes( void );//c

#define CDSAuthParams_PostEvent \
		virtual void					PostEvent( tDirStatus inAuthResult );//c

#define CDSAuthParams_DictionaryFromAuthItems \
		virtual CFMutableDictionaryRef	DictionaryFromAuthItems( void );//c

#define CDSAuthParams_SetParamsFromDictionary \
	virtual void					SetParamsFromDictionary( CFDictionaryRef inKeyedAuthItems );//c

#define CDSAuthParams_ExtractServiceInfo \
virtual tDirStatus				ExtractServiceInfo( tDataBufferPtr inAuthStepData );//c

#define CDSAuthParams_INIT  \
CDSAuthParams();//c

#define CDSAuthParams_FINAL  \
		virtual							~CDSAuthParams();//c

};


#endif //HYS_DIRECTORYSERVICECORE_CDSAUTHPARAMS_H
