#ifndef HYS_DIRECTORYSERVOCECORE_PRIVATETYPES_H
#define HYS_DIRECTORYSERVOCECORE_PRIVATETYPES_H

//hys add start
#define eDirNodeType_ETC \
kLocalHostedType,/*?*/ \
kBSDNodeType ,/*?*/\
kDHCPLDAPv3NodeType,/*?*/ \
kCacheNodeType,/*?*/ \
kDefaultNetworkNodeType,/*?*/ \
kConfigNodeType,/*?*/ \
kSearchNodeType,/*?*/ \
kContactsSearchNodeType,/*?*/ \
kNetworkSearchNodeType,/*?*/
//hys add end

#ifndef nil
	#define nil NULL//c
#endif 


#include <stdio.h>

#define kStdErr stderr //?
#define LOG fprintf //?
#define LOG1 fprintf //?
#define LOG2 fprintf//?
#define LOG3 fprintf //?
#define LOG4 fprintf//?

#define kDSNameAndAATag "kDSNameAndAATag"//?

#define DSCFRelease(a) //?
#define DSFree(a) //?
#define DSIsStringEmpty(a) 1 //?
#define DSFreePassword(a)	//?
#define DSFreeString(a)  //?
#define DSRelease(a) //?
#define DSDelete(a)	//?
#define DSFreeStringList(a)//?

#define kMaxInternalDispatchRecursion 1//?

enum {
	eDirectoryRefType='A',//?
	eNodeRefType='B',//?
	eAttrListRefType='C',//?
	eAttrValueListRefType='D',//?
	eRecordRefType='E',//?
};

enum {
	kAuthNTSessionKey,//?
	kAuthSMB_NT_Key,//?
	kAuthNTLMv2,//?
	kAuthDIGEST_MD5,//?
	kAuthNativeNoClearText,//?
	kAuthAPOP,//?
	kAuthPPS,//?
	kAuth2WayRandom,//?
	kAuthSetPasswdAsRoot,//?
	kAuthGetUserName,//?
	kAuthSetPolicy,//?
	kAuthSetPolicyAsRoot,//?
	kAuthChangePasswd,//?
	kAuthNewComputer,//?
	kAuthGetPolicy,//?
	kAuthGetEffectivePolicy,//?
	kAuthUnknownMethod,//?
	kAuthSyncSetupReplica,//?
	kAuthSetComputerAcctPasswdAsRoot,//?
	kAuthNewUse,//?
	kAuthNewUserWithPolicy,//?
	kAuthGetGlobalPolicy,//?
	kAuthSetUserName,//?
	kAuthGetUserData,//?
	kAuthSetGlobalPolicy,//?
	kAuthSetUserData,//?
	kAuthDeleteUser,//?
	kAuthMSCHAP2,//?
	kAuthMSLMCHAP2ChangePasswd,//?
	kAuth2WayRandomChangePass,//?
	kAuthSMB_NTUserSessionKey,//?
	kAuthSetPasswd,//?
	kAuthSetLMHash,//?
	kAuthCRAM_MD5,//?
	kAuthSMB_LM_Key,//?
	kAuthGetKerberosPrincipal,//?
	kAuthSMBWorkstationCredentialSessionKey,//?
	kAuthNTSetWorkstationPasswd,//?
	kAuthNativeMethod,//?
	kAuthDecrypt,//?
	kAuthNativeRetainCredential,//?
	kAuthGetDisabledUsers,//?
	kAuthClearText,//?
	kAuthVPN_PPTPMasterKeys,//?
	kAuthListReplicas,//?
	kAuthEncryptToUser,//?
	kAuthNewUser,//?
	kAuthGetIDByName,//?
	kAuthNativeClearTextOK,//?
	kAuthCrypt,//?
	kAuthKerberosTickets,//?
	kAuthSetCertificateHashAsRoot,//?
	kAuthNTLMv2WithSessionKey,//?
	ds_fnfErr,//?
	kAuthSecureHash,//?
	kAuthReadSecureHash,//?
	kAuthWriteSecureHash,//?
	kAuthWithAuthorizationRef,//?
	kAuthSetPasswdCheckAdmin,//?
	kAuthSetShadowHashWindows,//?
	kAuthSetShadowHashSecure,//?
	kAuthGetMethodListForUser,//?
	kASCIICodeScript,//?
	kAuthNTSetNTHash,//?
	ds_fnOpnErr,//?
	ds_gfpErr,//?
	ds_readErr,//?
	ds_writErr,//?
	ds_permErr,//?
};

struct tDataBufferPriv {
	char fBufferData[1];//c
	tDataNodePtr fNextPtr;//c
	int fBufferLength;//?
	tDataNodePtr fPrevPtr;//c
	int fScriptCode;//?
	int fBufferSize;//?
};
typedef  struct tDataBufferPriv tDataBufferPriv;

typedef int eRefTypes;//?

#endif //HYS_DIRECTORYSERVOCECORE_PRIVATETYPES_H
