#ifndef HYS_DIRECTORYSERVICECORE_SHAREDCONSTS_H
#define HYS_DIRECTORYSERVICECORE_SHAREDCONSTS_H

#define kDSStdAuthSetShadowHashWindows "kDSStdAuthSetShadowHashWindows"//?
#define kDSStdAuthSetShadowHashSecure "kDSStdAuthSetShadowHashSecure"//?
#define kDSStdRecordTypeDirectoryNodeInfo "kDSStdRecordTypeDirectoryNodeInfo"//?

#define kMaxFixedMsgData 1//?
#define kMsgBlockSize 2//?
#define kMaxFixedMsg 3//?

enum {
	kKerberosMutex,//?
	kServerRunLoop,//?
	kDoPlugInCustomCall,//?
	kOpenDirNode,//?
	kHandleNetworkTransition,//?
	kCloseDirNode,//?
	kGetDirNodeInfo,//?
	kGetAttributeEntry,//?
	kGetAttributeValue,//?
	kCloseAttributeList,//?
	kCloseAttributeValueList,//?
	kDoDirNodeAuth,//?
	kSetAttributeValues,//?
	kLogEverything,//?
	kLogMeta,//?
	kLogPlugin,//?
	kLogCritical,//?
	kLogApplication,//?
	kReleaseContinueData,//?
	kGetRecordList,//?
	kGetRecordEntry,//?
	kOpenRecord,//?
	kGetRecordReferenceInfo,//?
	kGetRecordAttributeInfo,//?
	kGetRecordAttributeValueByValue,//?
	kGetRecordAttributeValueByIndex,//?
	kGetRecordAttributeValueByID,//?
	kCloseRecord,//?
	kSetRecordName,//?
	kSetRecordType,//?
	kDeleteRecord,//?
	kCreateRecord,//?
	kCreateRecordAndOpen,//?
	kAddAttribute,//?
	kRemoveAttribute,//?
	kAddAttributeValue,//?
	kRemoveAttributeValue,//?
	kSetAttributeValue,//?
	kDoDirNodeAuthOnRecordType,//?
	kDoMultipleAttributeValueSearch,//?
	kDoAttributeValueSearch,//?
	kDoMultipleAttributeValueSearchWithData,//?
	kDoAttributeValueSearchWithData,//?
	kFlushRecord,//?
	ktDataBuff,//?
	kAttrMatch,//?
	kAttrType,//?
	kAuthResponseBuff,//?
	kAuthMethod,//?
	kAttrTypeBuff,//?
	kAttrValueBuff,//?
	kFirstAttrBuff,//?
	kNewAttrBuff,//?
	kRecNameBuff,//?
	kRecTypeBuff,//?
	kAuthStepBuff,//?
	kAuthStepDataResponse,//?
	ktDataList,//?
	kDirNodeName,//?
	kAttrTypeRequestList,//?
	kRecTypeList,//?
	kAttrTypeList,//?
	kRecNameList,//?
	kNodeInfoTypeList,//?
	kNodeNamePatt,//?
	kAttrMatches,//?
	kAttrValueList,//?
	ktAttrEntry,//?
	ktAttrValueEntry,//?
	ktRecordEntry,//?
	kLogError,//?
	kLogDebugHeader,//?
	kLogEmergency,//?
	kLogDebug,//?
	kLogInfo,//?
	kLogNotice,//?
	kLogPerformanceStats,//?
	kLogWarning,//?
	kLogAPICalls,//?
	kLogThreads,//?
	kLogEndpoint,//?
	kLogConnection,//?
	kLogTCPEndpoint,//?
	kLogHandler,//?
	kLogMsgQueue,//?
	kLogMsgTrans,//?
	kLogAlert,//?
	kLogAssert,//?
	kLogListener,//?
	kDSPlugInCallsEnd,//?
	kOpenDirService,//?
	kResult,//?
	ktDirRef,//?
	kContextData,//?
	kOpenDirServiceProxy,//?
	kNodeCount,//?
	kOpenDirServiceLocal,//?
	kCloseDirService,//?
	ktPidRef,//?
	ktGenericRef,//?
	kAddChildPIDToReference,//?
	kGetDirNodeCount,//?
	kGetDirNodeChangeToken,//?
	kNodeChangeToken,//?
	kOutBuffLen,//?
	kGetDirNodeList,//?
	ktDirPattMatch,//?
	kFindDirNodes,//?
	ktNodeRef,//?
	kAttrInfoOnly,//?
	kAttrInfoCount,//?
	ktAttrListRef,//?
	kAttrRecEntryCount,//?
	kRecEntryIndex,//?
	kAttrInfoIndex,//?
	ktAttrValueListRef,//?
	kAttrValueIndex,//?
	ktRecRef,//?
	kAuthOnlyBool,//?
	ktNodeRefMap,///
	kAttrPattMatch,//?
	kMatchRecCount,//?
	kVerifyDirRefNum,//?
	kCustomRequestCode,//?
	kAttrValueID,//?
	kAttrBuff,//?
	kOpenRecBool,//?
};

struct mach_msg_type_t {
	int msgt_name;//?
	int msgt_size;//?
	int msgt_number;//?
	int msgt_translate;//?
};
typedef struct mach_msg_type_t mach_msg_type_t;

struct sObject {
	int type;//?
	int count;//?
	int used;//?
	int length;//?
	int offset;//?
};
typedef struct sObject sObject;

struct  sComData {
	int fDataSize;//?
	int fDataLength;//?
	mach_msg_type_t type;//c
	int fPID;//?
	sObject obj[1];//?
	int data;//?
};
typedef struct sComData sComData;

struct sComProxyData {
	int a;//dummy
};
typedef struct sComProxyData sComProxyData;

struct sDSTableEntry {
	int fRefNum;//?
	void * fData;//c
	struct sDSTableEntry  *fNext;//c
};
typedef struct sDSTableEntry sDSTableEntry;

struct sIPCMsg {
	mach_msg_header_t fHeader;//c
	int fMsgType;//?
	int fCount;//?
	int fPort;//?
	int fPID;//?
	int fMsgID;//?
	int fOf;//?
};
typedef struct sIPCMsg sIPCMsg;

typedef int eValueType;//?

#endif //HYS_DIRECTORYSERVICECORE_SHAREDCONSTS_H
