#ifndef HYS_EAP8021X_EAPTLS_H
#define HYS_EAP8021X_EAPTLS_H

enum EAPTLSPacketFlags {
	kEAPTLSPacketFlagsStart,//?
	kEAPTLSPacketFlagsLengthIncluded,//?
	kEAPTLSPacketFlagsMoreFragments,//?
};
typedef enum EAPTLSPacketFlags EAPTLSPacketFlags;

struct EAPTLSPacket {
   	uint8_t		tls_data[0];//c
    	uint8_t		flags;//c
    	uint8_t		identifier;//c
    	uint8_t		code;//c
    	uint8_t		type;//c
};
typedef struct EAPTLSPacket EAPTLSPacket;
typedef struct EAPTLSPacket* EAPTLSPacketRef;

struct EAPTLSLengthIncludedPacket {
    	uint8_t		tls_data[0];//c
    	uint8_t		tls_message_length[4]; //c
    	uint8_t		flags;//c
};
typedef struct EAPTLSLengthIncludedPacket EAPTLSLengthIncludedPacket;
typedef struct EAPTLSLengthIncludedPacket *EAPTLSLengthIncludedPacketRef;

#endif//HYS_EAP8021X_EAPTLS_H
