#ifndef HYS_FOUNDATION_NSVALUE_H
#define HYS_FOUNDATION_NSVALUE_H

//hys add start

#ifndef CGFLOAT_DEFINED
#define CGFLOAT_DEFINED 1//c
#if defined(__LP64__) && __LP64__
typedef double CGFloat;
#else	/* !defined(__LP64__) || !__LP64__ */
typedef float CGFloat;
#endif	/* !defined(__LP64__) || !__LP64__ */
#endif//CGFLOAT_DEFINED
//CoreGraphics/CGBase.h

#if __LP64__ || NS_BUILD_32_LIKE_64

typedef CGPoint NSPoint;
typedef CGRect NSRect;
typedef CGSize NSSize;

#else

#ifndef OC_NSPoint
#define OC_NSPoint
typedef struct _NSPoint {
    CGFloat x;
    CGFloat y;
} NSPoint;
#endif

#ifndef OC_NSSize
#define OC_NSSize
typedef struct _NSSize {
    CGFloat width;	
    CGFloat height;		
} NSSize;
#endif

#ifndef OC_NSRect
#define OC_NSRect
typedef struct _NSRect {
    NSPoint origin;
    NSSize size;
} NSRect;
#endif

#endif

//Foundation/NSGeometry.h"

//hys add end

#endif//HYS_FOUNDATION_NSVALUE_H
