#ifndef HYS_IOI2C_IOI2CDEVICE_H
#define  HYS_IOI2C_IOI2CDEVICE_H

enum {
	kI2CPowerEvent_ON,//?
	kI2CPowerEvent_WAKE,//?
	kStateFlags_kprintf,//?
	kI2CPowerEvent_OFF,//?
	kI2CPowerEvent_SLEEP,//?
	kI2CPowerEvent_STARTUP,//?
};

class  IOI2CDevice_HYS
{
	OSDeclareDefaultStructors(IOI2CDevice_HYS)


public://data

enum {
	kStateFlags_DISABLE_PM,//?
	kI2CPowerEvent_DOZE,//?
	kPFMode_Standard,//?
	kStateFlags_TEARDOWN,//?
	kIOI2CPowerState_COUNT,//?
	kStateFlags_PMInit,//?
	kIOI2CPowerState_OFF,//?
	kSetPowerStateTimeout,//?
	kI2CPowerEvent_SHUTDOWN,//?
	kIOI2CPowerState_SLEEP,//?
	kIOI2CPowerState_ON,//?
	kIOI2CPowerState_DOZE,//?
	kStateFlags_STARTUP,//?
	kStateFlags_IOLog,//?
	kPFMode_Dumb,//?
	kPFMode_Subaddress,//?
	kPFMode_Combined,//?
};

struct ExpansionData {
	int fEnableOnDemandPlatformFunctions;//?
	IOLock* fPFLock;//c
};
#define fPFLock (reserved->fPFLock)//c
#define fEnableOnDemandPlatformFunctions  (reserved->fEnableOnDemandPlatformFunctions)//c

ExpansionData *reserved;//c
IOService* fProvider;//c
OSArray  *fPlatformFuncArray;//c
const OSSymbol* symLockI2CBus;//c
const OSSymbol* symUnlockI2CBus;//c
const OSSymbol* symWriteI2CBus;//c
const OSSymbol* symReadI2CBus;//c
const OSSymbol* symClientWrite;//c
const OSSymbol* symClientRead;//c
const OSSymbol* symPowerInterest;//c
volatile semaphore_t fClientSem;//c
thread_call_t fPowerStateThreadCall;//c
void* fSysPowerRef;//c

int fDeviceOffline;//?
int fI2CAddress;//?
int fStateFlags;//?
int fCurrentPowerState;//?
int fPowerThreadID;//?
int fClientIOBlocked;//?

public://dara=define

#define kI2CPF_READ_BUFFER_LEN 1//?

public://define

#define IOI2CDevice_getPlatformFunction_const_char \
IOReturn getPlatformFunction (const char* a, IOPlatformFunction **b, UInt32 c = 0);//?

#define IOI2CDevice_performFunction_const_OSSymbol  \
IOReturn performFunction (const OSSymbol *a, void *b = 0, void *c = 0, void *d = 0, void *e = 0 );//?

#define IOI2CDevice_performFunction_IOPlatformFunction \
IOReturn performFunction (IOPlatformFunction *a, void *b = 0, void *c = 0, void *d = 0, void *e = 0 );//?

#define IOI2CDevice_performFunction \
IOReturn performFunction (const char *a, void *b = 0, void *c = 0, void *d = 0, void *e = 0 );//?

#define IOI2CDevice_getPlatformFunction \
IOReturn getPlatformFunction (const OSSymbol *a, IOPlatformFunction	**b, UInt32 d = 0);//c

#define IOI2CDevice_callPlatformFunction \
IOReturn callPlatformFunction (const OSSymbol *a, bool b, void* c, void	 *d, void* e, void* f);//?

#define IOI2CDevice_writeI2C_IOI2CCommand \
IOReturn writeI2C(IOI2CCommand *a, UInt32 b);//?

#define IOI2CDevice_readI2C_IOI2CCommand \
IOReturn readI2C(IOI2CCommand *a, UInt32 b);//?

#define IOI2CDevice_processPowerEvent \
void processPowerEvent(UInt32 a);//?

#define IOI2CDevice_powerStateThreadCall \
void powerStateThreadCall(unsigned long a);//?

#define IOI2CDevice_setPowerState \
IOReturn setPowerState(unsigned long a, IOService *b);//?

#define IOI2CDevice_message \
IOReturn message(UInt32 a, IOService *b, void *c= 0);//?

#define IOI2CDevice_sPowerStateThreadCall \
static void sPowerStateThreadCall(thread_call_param_t	a, thread_call_param_t b);//?

#define IOI2CDevice_InitializePlatformFunctions \
IOReturn InitializePlatformFunctions(void);//c

#define IOI2CDevice_maxCapabilityForDomainState \
unsigned long maxCapabilityForDomainState ( IOPMPowerFlags a);//?

#define IOI2CDevice_InitializePowerManagement \
IOReturn InitializePowerManagement(void);//c

#define IOI2CDevice_newUserClient \
IOReturn newUserClient(task_t a, void *b, UInt32 c, OSDictionary *d, IOUserClient	**e);//?

#define IOI2CDevice_stop \
void stop ( IOService *a );//?

#define IOI2CDevice_free \
void free ( void );//?

#define IOI2CDevice_initI2CResources \
IOReturn initI2CResources(void);//c

#define IOI2CDevice_start \
bool start ( IOService *a);//?

#define IOI2CDevice_init  \
bool init ( OSDictionary *a);//?

#define IOI2CDevice_readI2C \
IOReturn readI2C (UInt32 a,UInt8 *b, UInt32 c, UInt32 d=0, UInt32 e=0,UInt32 f= 0, UInt32 g= 0, UInt32 h= 0);//?

#define IOI2CDevice_getI2CAddress \
UInt32 getI2CAddress(void);//c

#define IOI2CDevice_freeI2CResources \
void freeI2CResources(void);//c

#define IOI2CDevice_lockI2CBus \
IOReturn lockI2CBus(UInt32* a);//c

#define IOI2CDevice_unlockI2CBus \
IOReturn unlockI2CBus(UInt32	a);//c

#define IOI2CDevice_writeI2C \
IOReturn writeI2C (UInt32	a,UInt8* b, UInt32 c, UInt32 d =0, UInt32 e =0, UInt32	f= 0, UInt32 g = 0, UInt32 h = 0);//?

#define  IOI2CDevice_isI2COffline \
bool isI2COffline(void);//c

#define IOI2CDevice_performFunctionsWithFlags \
void performFunctionsWithFlags(UInt32 a);//c

public://func

};

#endif//HYS_IOI2C_IOI2CDEVICE_H
