#ifndef HYS_IOKIT_IOHIBERATEPRIVATE_H
#define HYS_IOKIT_IOHIBERATEPRIVATE_H

#define DECLARE_IOHIBERNATEPROGRESSALPHA  \
int gIOHibernateProgressAlpha[1][1];
//?

#define kIOHibernateMachineSignatureKey "kIOHibernateMachineSignatureKey"//?
#define kIOHibernateBootImageKey "kIOHibernateBootImageKey"//?
#define kIOHibernateBootImageKeyKey "kIOHibernateBootImageKeyKey"//?
#define kIOHibernatePreviewBufferKey "kIOHibernatePreviewBufferKey"//?
#define kIOHibernatePreviewActiveKey "kIOHibernatePreviewActiveKey"//?
#define kIOHibernateModeKey "kIOHibernateModeKey"//?
#define kIOHibernateStateKey "kIOHibernateStateKey"//?
#define kIOHibernateFileKey "kIOHibernateFileKey"//?
#define kIOHibernateFeatureKey "kIOHibernateFeatureKey"//?
#define kIOHibernateFreeRatioKey "kIOHibernateFreeRatioKey"//?
#define kIOHibernateFreeTimeKey "kIOHibernateFreeTimeKey"//?

enum {
	kIOHibernateStateWakingFromHibernate,//?
	kIOHibernateHeaderInvalidSignature,//?
	kIOHibernateModeOn,//?
	kIOHibernateHeaderSignature,//?
	kIOHibernateProgressCount,//?
	kIOHibernateProgressWidth,//?
	kIOHibernateProgressOriginY,//?
	kIOHibernateProgressSpacing,//?
	kIOHibernateProgressHeight,//?
	kIOHibernateProgressDarkGray,//?
	kIOHibernateProgressMidGray,//?
	kIOHibernateProgressSaveUnderSize,//?
	kIOHibernateProgressLightGray,//?
	kIOHibernateModeSleep,//?
};

struct IOHibernateImageHeader{
	int restore1CodePage;//?
	int restore1PageCount;//?
	int restore1CodeOffset;//?
	int restore1StackOffset;//?
	int fileExtentMap[1];//?
	int fileExtentMapSize;//?
	int actualRestore1Sum;//?
	int image1Size;//?
	int signature;//?
	int machineSignature;//?
	int previewSize;//?
	int imageSize;//?
	int previewPageListSize;//?
	int encryptStart;//?
};
typedef struct IOHibernateImageHeader IOHibernateImageHeader;

struct IOPolledFileExtent {
	int length;//?
	int start;//?
};
typedef struct IOPolledFileExtent IOPolledFileExtent;

struct hibernate_graphics_t{
	int progressSaveUnder[1][1];//?
	int physicalAddress;//?
	int mode;//?
	int rowBytes;//?
	int width;//?
	int height;//?
	int depth;//?
};
typedef struct hibernate_graphics_t hibernate_graphics_t;

struct hibernate_cryptvars_t {
	aes_ctx ctx;//c
	int aes_iv[1];//?
};
typedef struct hibernate_cryptvars_t hibernate_cryptvars_t;

struct hibernate_cryptwakevars_t{
	int aes_iv[1];//?
};
typedef struct hibernate_cryptwakevars_t hibernate_cryptwakevars_t;

#endif //HYS_IOKIT_IOHIBERATEPRIVATE_H
