#ifndef HYS_IOKIT_IOLIB_H
#define HYS_IOKIT_IOLIB_H

#define min(a,b) ((a) < (b) ? (a) : (b))//c
#define max(a,b) ((a) > (b) ? (a) : (b))//c
#define IONew(type,number)        (type*)IOMalloc(sizeof(type) * (number) )//c
#define IODelete(ptr,type,number) IOFree( (ptr) , sizeof(type) * (number) )//c
#define eieio() OSSynchronizeIO()//c
#define IORound(value,multiple)     ((((value) + (multiple) - 1) / (multiple)) * (multiple))//c
#define IOTrunc(value,multiple)       (((value) / (multiple)) * (multiple));//c

/////////////////////////////////
typedef thread_t IOThread;//c
typedef void (*IOThreadFunc)(void *a);//c
/////////////////////////

static inline IOFixed IOFixedMultiply(IOFixed a, IOFixed b) {};//c
static inline IOFixed IOFixedDivide(IOFixed a, IOFixed b) {};//c

////////////////////////////

const char *IOFindNameForValue(int value, 
	const IONamedValue *namedValueArray);//c

void IOGetTime( mach_timespec_t * clock_time);//c
struct OSDictionary * IOOFPathMatching( const char * path, char * buf, int maxLen );//c
void IOPanic(const char *reason);//c

#ifndef OC_IOKIT_IOBSDNameMatching
#define OC_IOKITIB_IOBSDNameMatching
struct OSDictionary * IOBSDNameMatching( const char * name );//c
#endif

#endif//HYS_IOKIT_IOLIB_H
