#ifndef HYS_IOKIT_IOMAPPER_H
#define HYS_IOKIT_IOMAPPER_H

class  IOMapper_HYS
{
    OSDeclareAbstractStructors(IOMapper_HYS);
public://data

bool fIsSystem;//c
static IOMapper *gSystem;//c
ppnum_t fTablePhys;//c
void*  fTable;//c

public://func
 

#define IOMapper_allocTable \
    virtual bool allocTable(IOByteCount size);//c

#define IOMapper_NewARTTable \
    static OSData * NewARTTable(IOByteCount size,void ** virtAddrP, ppnum_t *physAddrP);//c

#define IOMapper_FreeARTTable \
    static void FreeARTTable(OSData *handle, IOByteCount size);//c

public://.add

//AppleMacRiscPCI-AppleDART.cpp
//kern-clock.h

void  clock_interval_to_deadline(uint32_t a,uint32_t  b,AbsoluteTime *c) {;//c
void  clock_interval_to_deadline(uint32_t a,uint32_t  b,uint64_t *c);//c
};

void clock_get_uptime(AbsoluteTime *result) {;
void clock_get_uptime(uint64_t *result);
};
////////////////////////////////////
};

#endif//HYS_IOKIT_IOMAPPER_H
