#ifndef HYS_IOKIT_IOREGISTRTENTRY_H
#define HYS_IOKIT_IOREGISTRTENTRY_H


enum {
#ifndef IOKIT_kIORegistryIterateRecursively
	#define IOKIT_kIORegistryIterateRecursively
	kIORegistryIterateRecursively,//?,
#endif

#ifndef IOKIT_kIORegistryIterateParents
	#define IOKIT_kIORegistryIterateParents
	kIORegistryIterateParents,//?
#endif
	OC_HYS_IOKIT_IOREGISTRTENTRY_H,//dummy
};


#ifdef __cplusplus

extern const OSSymbol * gIONameKey;//c
typedef void (*IORegistryEntryApplierFunction)(IORegistryEntry *a, void *b);//c

class IORegistryEntry_HYS
{
  OSDeclareDefaultStructors(IORegistryEntry_HYS)

public:

#define IORegistryEntry_init \
virtual bool init( IORegistryEntry * from,const IORegistryPlane * inPlane );//c

#define IORegistryEntry_makePlane \
static const IORegistryPlane * makePlane( const char * name );//c

#define IORegistryEntry_setLocation \
virtual void setLocation( const char * location, const IORegistryPlane * plane = 0 );//c

#define IORegistryEntry_applyToChildren \
virtual void applyToChildren( IORegistryEntryApplierFunction applier, void * context, const IORegistryPlane * plane ) const;//c

};

#endif //__cplusplus

#endif//HYS_IOKIT_IOREGISTRTENTRY_H


