#ifndef HYS_IOKIT_ADB_IOADBCONTROLLER_H
#define HYS_IOKIT_ADB_IOADBCONTROLLER_H

//hys add

#define IOADBController_start \
bool start ( IOService * a );//?

#define IOADBController_powerStateWillChangeTo \
IOReturn powerStateWillChangeTo ( IOPMPowerFlags a, unsigned long b, IOService* c);//?

#define IOADBController_powerStateDidChangeTo \
IOReturn powerStateDidChangeTo ( IOPMPowerFlags a, unsigned long b, IOService* c);//?

#define IOADBController_probeAddress \
 bool probeAddress ( IOADBAddress a );//?

#define IOADBController_moveDeviceFrom \
bool moveDeviceFrom ( IOADBAddress a, IOADBAddress  b, bool c );//?

#define IOADBController_firstBit \
unsigned int firstBit ( unsigned int a );//?

#define IOADBController_probeBus \
IOReturn probeBus ( );//?

#define IOADBController_cancelAllIO \
IOReturn cancelAllIO();//?

#define IOADBController_claimDevice \
IOReturn claimDevice ( unsigned long, IOService *, ADB_callback_func );//?

#define IOADBController_clearOwner \
IOReturn clearOwner ( void * );//?

#define IOADBController_setOwner \
IOReturn setOwner ( void * a, IOService * b, ADB_callback_func c );//?

#define IOADBController_flush \
IOReturn flush ( ADBDeviceControl * a);//?

#define IOADBController_releaseDevice \
 IOReturn releaseDevice ( unsigned long );//?

#define IOADBController_readRegister \
    IOReturn readRegister ( ADBDeviceControl * a, IOADBRegister b, \
                            UInt8 * c, IOByteCount * d );//?

#define IOADBController_packet \
void packet ( UInt8 * a, IOByteCount b, UInt8 c );//?

#define IOADBController_readDeviceForUser \
IOReturn readDeviceForUser(unsigned long, unsigned long, UInt8 *, IOByteCount *);//?

#define IOADBController_newUserClient \
IOReturn newUserClient(  task_t,  void *, UInt32, IOUserClient ** );//?

#define IOADBController_getURLComponentUnit \
 int getURLComponentUnit ( IOService * a, char * b, int c );//?

#define IOADBController_writeDeviceForUser \
IOReturn writeDeviceForUser(unsigned long, unsigned long, UInt8 *, IOByteCount *);//?

#define IOADBController_handlerID \
UInt8 handlerID ( ADBDeviceControl * a);//?

#define IOADBController_setHandlerID \
    IOReturn setHandlerID ( ADBDeviceControl * a, UInt8 b );//?

#define IOADBController_writeRegister \
    IOReturn writeRegister ( ADBDeviceControl *a, IOADBRegister b, \
                             UInt8 * c, IOByteCount * d );

#define IOADBController_defaultHandlerID  \
    UInt8 defaultHandlerID ( ADBDeviceControl * a);//?

#define IOADBController_matchNubWithPropertyTable \
 bool matchNubWithPropertyTable( IOService * a, OSDictionary *  b);//?

#define IOADBController_defaultAddress \
    IOADBAddress defaultAddress ( ADBDeviceControl *a);//?

#define IOADBController_address \
   IOADBAddress address ( ADBDeviceControl * a );//?

//////////////////

#define ADB_RET_OK 1//?
#define ADB_RET_NOTPRESENT 2//?

int autopollHandler (IOService * a,int b,int c,UInt8 *d);//?

class IOADBController_HYS
{
//OSDeclareAbstractStructors(IOADBController_HYS)

public://data

IOPMrootDomain * rootDomain;//c
int busProbed;//?
thread_call_t probeThread;//c
int claimed_devices[1];//?

public://func
int readFromDevice(int a,int b,UInt8* c,IOByteCount * d);//?
int writeToDevice(int a,int b,UInt8 * c,IOByteCount *d);//?
int setAutoPollEnable(int a);//?
int resetBus();//?
int setAutoPollList(int a);//?
int setAutoPollPeriod(int a);//?
int flushDevice(int a);//?

};
#endif//HYS_IOKIT_ADB_IOADBCONTROLLER_H
