#ifndef HYS_IOKIT_ATA_IOATAREGI386_H
#define HYS_IOKIT_ATA_IOATAREGI386_H


#define DefineIOATAReg(a)                                   \
class IOATAReg##a : public OSObject                         \
{                                                           \
    OSDeclareAbstractStructors( IOATAReg##a )               \
                                                            \
public:                                                     \
    virtual void operator = (UInt##a rhs) = 0;              \
    virtual operator UInt##a() const = 0;                   \
};//c

DefineIOATAReg( 8 );
DefineIOATAReg( 16 );
DefineIOATAReg( 32);

typedef IOATAReg16 * IOATARegPtr16;//c
typedef IOATAReg8 * IOATARegPtr8;//c
typedef IOATAReg32 * IOATARegPtr32;//c

#define DefineIOATAIOReg(a)                                 \
class IOATAIOReg##a : public IOATAReg##a                    \
{                                                           \
    OSDeclareDefaultStructors( IOATAIOReg##a )              \
                                                            \
protected:                                                  \
    UInt16 _address;                                        \
                                                            \
public:                                                     \
    static IOATAIOReg##a * withAddress( UInt16 address );   \
                                                            \
    virtual bool initWithAddress( UInt16 address );         \
    virtual UInt16 getAddress() const;                      \
                                                            \
    virtual void operator = (UInt##a rhs);                  \
    virtual operator UInt##a() const;                       \
};//c

DefineIOATAIOReg( 8 );
DefineIOATAIOReg( 16 );
DefineIOATAIOReg( 32 );

#endif//HYS_IOKIT_ATA_IOATAREGI386_H



