#ifndef HYS_IOKIT_ATA_IOPCIATA_H
#define HYS_IOKIT_ATA_IOPCIATA_H

class IOPCIATA_HYS
{
    OSDeclareDefaultStructors(IOPCIATA_HYS)

public://data

enum ATADMAState  {
	kATADMAError,//?
	kATADMAStatus,//?
	kATADMAStarting,//?
};	

enum {
	kContinue_PRD,//?
	kLast_PRD,//?
};
//////////////
struct PRD{
	UInt8	*bufferPtr;  // c
	UInt16	byteCount;   //c
	UInt16	flags;    //c
};	

//////////////
IOATARegPtr8 _bmStatusReg;//c
IOATARegPtr8 _bmCommandReg;//c
IOATARegPtr32 _bmPRDAddresReg;//c
PRD  *_prdTable;//c
UInt32	_dmaState;//c
IOPhysicalAddress _prdTablePhysical;	//c
IONaturalMemoryCursor* _DMACursor;//c
public://func

#define IOPCIATA_handleDeviceInterrupt \
virtual IOReturn handleDeviceInterrupt(void);//c

#define IOPCIATA_setPRD \
virtual void setPRD(UInt8 *bffr, UInt16 count, PRD *tableElement, UInt16 end);//c

#define IOPCIATA_stopDMA  \
	virtual IOReturn stopDMA( void );//c

#define IOPCIATA_activateDMAEngine  \
	virtual void activateDMAEngine(void);//c

#define IOPCIATA_createChannelCommands  \
	virtual IOReturn createChannelCommands(void);//c

};


#endif//HYS_IOKIT_ATA_IOPCIATA_H
