#ifndef HYS_IOKIT_AUDIO_IOAUDIOUSERCLIENT_H
#define HYS_IOKIT_AUDIO_IOAUDIOUSERCLIENT_H

//hys add 

#define IOAudioEngineUserClient_registerClientParameterBuffer \
IOReturn registerClientParameterBuffer (void * a, UInt32 b);//?

#define IOAudioEngineUserClient_initWithAudioEngine_OSDictionary \
bool initWithAudioEngine(IOAudioEngine *a, task_t b, void *c, UInt32 d, OSDictionary *e);//?

#define IOAudioEngineUserClient_safeRegisterClientBuffer \
IOReturn safeRegisterClientBuffer(UInt32 a, void * b, UInt32 c, UInt32 d);//?

#define IOAudioEngineUserClient_safeRegisterClientBuffer64 \
IOReturn safeRegisterClientBuffer64(UInt32 a, mach_vm_address_t * b, UInt32 c, UInt32 d);//?

#define IOAudioEngineUserClient_findExtendedInfo \
IOAudioClientBufferExtendedInfo * findExtendedInfo(UInt32 a);//?

#define IOAudioEngineUserClient_findExtendedInfo64 \
IOAudioClientBufferExtendedInfo64 * findExtendedInfo64(UInt32 a);//?

#define IOAudioEngineUserClient_removeBufferSet \
void removeBufferSet(IOAudioClientBufferSet *a);//?

#define IOAudioEngineUserClient_performClientIO \
IOReturn performClientIO(UInt32 a,UInt32 b,bool c,UInt32 d,UInt32 e,UInt32 f);//?

#define IOAudioEngineUserClient_getClientNearestStartTime \
IOReturn getClientNearestStartTime(IOAudioStream *a,IOAudioTimeStamp *b,UInt32 c);//?

#define IOAudioEngineUserClient_unregisterClientBuffer64 \
IOReturn unregisterClientBuffer64(mach_vm_address_t  * a, UInt32 b);//?

#define IOAudioEngineUserClient_findBufferSet \
IOAudioClientBufferSet *findBufferSet(UInt32 a);//?

#define IOAudioEngineUserClient_registerClientBuffer64 \
IOReturn registerClientBuffer64(IOAudioStream *a,mach_vm_address_t b,UInt32 c,UInt32 d);//?

#define IOAudioEngineUserClient_registerClientBuffer \
IOReturn registerClientBuffer(IOAudioStream *a,void * b,UInt32 c,UInt32 d);//?

#define IOAudioEngineUserClient_unregisterBufferAction \
static IOReturn unregisterBufferAction(OSObject *a,void *b,void *c,void *d,void *e);//?
		
#define IOAudioEngineUserClient_registerBufferAction \
static IOReturn registerBufferAction(OSObject *a,void *b,void *c,void *d,void *e);//?

#define IOAudioEngineUserClient_unregisterBuffer64 \
IOReturn unregisterBuffer64(mach_vm_address_t a, UInt32 b);//?

#define IOAudioEngineUserClient_externalMethod \
IOReturn externalMethod(uint32_t a,IOExternalMethodArguments * b,	IOExternalMethodDispatch * c,OSObject * d,void * e);//?

#define IOAudioEngineUserClient_registerNotificationAction \
static IOReturn registerNotificationAction(OSObject *a, void *b,void *c,void *d,void *e);//?

#define IOAudioEngineUserClient_registerNotification \
IOReturn registerNotification(mach_port_t a, UInt32 b);//?

#define IOAudioEngineUserClient_registerNotificationPort \
IOReturn registerNotificationPort(mach_port_t a, UInt32 b, UInt32 c);//?

#define IOAudioEngineUserClient_clientMemoryForType \
IOReturn clientMemoryForType(UInt32 a,UInt32 *b,IOMemoryDescriptor **c);//?

#define IOAudioEngineUserClient_isOnline \
bool isOnline();//?

#define IOAudioEngineUserClient_lockBuffers \
void lockBuffers();//?

#define IOAudioEngineUserClient_setOnline \
void setOnline(bool a);//?

#define IOAudioEngineUserClient_clientDied \
IOReturn clientDied();//?

#define IOAudioEngineUserClient_closeClientAction \
static IOReturn closeClientAction(OSObject *a, void *b,void *c,void *d,void *e);//?
		
#define IOAudioEngineUserClient_stop \
void stop(IOService *a);//?

#define IOAudioEngineUserClient_freeClientBufferSetList \
void freeClientBufferSetList();//?

#define IOAudioEngineUserClient_getNearestStartTime \
IOReturn getNearestStartTime(IOAudioStream *a,IOAudioTimeStamp *b,UInt32 c);//?

#define IOAudioEngineUserClient_getNearestStartTimeAction \
static IOReturn getNearestStartTimeAction(OSObject *a,void *b, void *c, void *d, void *e);//?

#define IOAudioEngineUserClient_free \
void free();//?

#define IOAudioEngineUserClient_registerBuffer64 \
IOReturn registerBuffer64(IOAudioStream *a, mach_vm_address_t b, UInt32 c, UInt32 d);//?

#define IOAudioEngineUserClient_unregisterBuffer \
IOReturn unregisterBuffer( void * a, UInt32 b);//?

#define IOAudioEngineUserClient_registerBuffer \
IOReturn registerBuffer(IOAudioStream *a, void* b, UInt32 c, UInt32 d);//?

#define IOAudioEngineUserClient_getExternalMethodForIndex \
IOExternalMethod *getExternalMethodForIndex(UInt32 a);//?

#define IOAudioEngineUserClient_getExternalTrapForIndex \
IOExternalTrap *getExternalTrapForIndex(UInt32 a);//?

#define IOAudioEngineUserClient_unlockBuffers \
void unlockBuffers();//?

#define IOAudioEngineUserClient_closeClient \
IOReturn closeClient();//?

#define IOAudioEngineUserClient_clientClose \
IOReturn clientClose();//?

#define IOAudioEngineUserClient_freeClientBuffer \
void freeClientBuffer(IOAudioClientBuffer64 *a);//?

#define IOAudioEngineUserClient_withAudioEngine_OSDictionary \
static IOAudioEngineUserClient *withAudioEngine(IOAudioEngine *a, task_t b, void *c, UInt32 d, OSDictionary *e);//?
	
#define IOAudioEngineUserClient_withAudioEngine \
static IOAudioEngineUserClient *withAudioEngine(IOAudioEngine *a, task_t b, void *c, UInt32 d);//?

#define IOAudioEngineUserClient_initWithAudioEngine \
bool initWithAudioEngine(IOAudioEngine *a, task_t b, void *c, UInt32 d);//?

#define IOAudioEngineUserClient_stopClientAction \
static IOReturn stopClientAction(OSObject *a, void *b,void *c,void *d,void *e);//?

#define IOAudioEngineUserClient_clientStart \
IOReturn clientStart();//?

#define IOAudioEngineUserClient_startClient \
IOReturn startClient();//?

#define IOAudioEngineUserClient_sendNotification \
IOReturn sendNotification(UInt32 a);//?

#define IOAudioEngineUserClient_stopClient \
IOReturn stopClient();//?

#define IOAudioEngineUserClient_performWatchdogOutput \
void performWatchdogOutput(IOAudioClientBufferSet *a, UInt32 b);//?

#define IOAudioEngineUserClient_unregisterClientBuffer \
IOReturn unregisterClientBuffer(void * a, UInt32 b);//?

#define IOAudioEngineUserClient_performClientInput \
IOReturn performClientInput(UInt32 a, IOAudioClientBufferSet *b);//?

#define IOAudioEngineUserClient_performClientOutput \
IOReturn performClientOutput(UInt32 a, UInt32 b, IOAudioClientBufferSet *c, UInt32 d, UInt32 e);//?

#define IOAudioEngineUserClient_getConnectionID \
IOReturn getConnectionID(UInt32 *a);//?

#define IOAudioEngineUserClient_startClientAction \
static IOReturn startClientAction(OSObject *a, void *b, void *c, void *d, void *e);//?

#define IOAudioEngineUserClient_clientStop \
IOReturn clientStop();//?

#define IOAudioEngineUserClient_sendFormatChangeNotification \
void sendFormatChangeNotification(IOAudioStream *a);//?

////////////

struct IOAudioClientBuffer {
	IOAudioStream *audioStream;//c
	IOMemoryDescriptor* sourceBufferDescriptor;//c
	IOMemoryMap* sourceBufferMap;//c
	IOAudioEngineUserClient* userClient;//c
	void* sourceBuffer;//c
	IOAudioBufferDataDescriptor *bufferDataDescriptor;//c
	int numSampleFrames;//?
	int numChannels;//?
	void* unmappedSourceBuffer;//c
	struct IOAudioClientBuffer* mNextBuffer32;//c
	struct IOAudioClientBuffer *nextClip;//c
	struct IOAudioClientBuffer* previousClip;//c
	struct IOAudioClientBuffer* nextClient;//c
	IOAudioEnginePosition mixedPosition;//c
};

struct  IOAudioClientBuffer64 {
	struct IOAudioClientBuffer64* mNextBuffer64;//c
	IOAudioClientBuffer  mAudioClientBuffer32;//c
	int mUnmappedSourceBuffer64;//?
};


struct IOAudioClientBufferExtendedInfo {
	IOMemoryDescriptor*  paramBufferDescriptor;//c
	IOMemoryMap* paramBufferMap;//c
	void* paramBuffer;//c
	int bufferSetID;//?
};

struct IOAudioClientBufferExtendedInfo64 {
	IOAudioClientBufferExtendedInfo mAudioClientBufferExtended32;//c
	mach_vm_address_t mUnmappedParamBuffer64;//c
	struct IOAudioClientBufferExtendedInfo64* mNextExtended64;//c
};

class IOAudioEngineUserClient_HYS
{
    OSDeclareDefaultStructors(IOAudioEngineUserClient_HYS)
 
public://data

struct ExpansionData {
	IOAudioClientBufferExtendedInfo64* extendedInfo;//c
	int classicMode;//?
	IOExternalMethod methods[1];//?
};

task_t clientTask;//c
IOAudioEngine	* audioEngine;//c
IOAudioClientBufferSet *clientBufferSetList;//c
IORecursiveLock * clientBufferLock;//c
IOWorkLoop* workLoop;//c
IOCommandGate* commandGate;//c
ExpansionData* reserved;//c
IOExternalTrap trap;//c
IOAudioNotificationMessage *notificationMessage;//c
int online;//?
int numSampleFrames;//?

public://func

};

#endif//HYS_IOKIT_AUDIO_IOAUDIOUSERCLIENT_H
