#ifndef HYS_IOKIT_AVC_IOFIREWIREAVCCOMMAND_H
#define HYS_IOKIT_AVC_IOFIREWIREAVCCOMMAND_H

//hys add

#define IOFireWireAVCCommand_writeDone \
static void writeDone(void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//?

#define IOFireWireAVCCommand_handleResponse \
UInt32 handleResponse(UInt16 a, UInt32 b, const void *c);//?

#define IOFireWireAVCCommand_complete \
IOReturn	complete(IOReturn a);//?

#define IOFireWireAVCCommand_handleResponseWithSimpleMatching \
UInt32 handleResponseWithSimpleMatching(UInt16  a, UInt32 b, const void *c);//?

#define IOFireWireAVCCommand_free \
void		free();//?

#define IOFireWireAVCCommand_execute \
IOReturn	execute();//?

#define IOFireWireAVCCommand_resetInterimTimeout \
IOReturn resetInterimTimeout();//?

#define IOFireWireAVCCommand_init \
bool init(IOFireWireNub *a, const UInt8 * b, UInt32 c,UInt8 * d, UInt32 * e);//?

#define IOFireWireAVCCommand_reinit \
IOReturn reinit(IOFireWireNub *a, const UInt8 * b, UInt32 c,UInt8 * d, UInt32 * e);//?

#define IOFireWireAVCCommand_withNub \
static IOFireWireAVCCommand *withNub(IOFireWireNub *a, const UInt8 * b, UInt32 c,UInt8 * d, UInt32 * e);//?

#define IOFireWireAVCCommand_withNub_UInt32 \
static IOFireWireAVCCommand *withNub(IOFireWireNub *a, UInt32 b,const UInt8 * c, UInt32 d, UInt8 * e, UInt32 * f);//?

////////////////


class IOFireWireAVCCommand_HYS
{
    OSDeclareDefaultStructors(IOFireWireAVCCommand_HYS)

public://data

IOMemoryDescriptor * fMem;//c
UInt32 *fResponseLen;//c
UInt8 * fResponse;//c
IOFWCommand *fWriteCmd;//c
const UInt8 * fCommand;//c

int fWriteGen;//?
int fWriteNodeID;//?
int bypassRobustCommandResponseMatching;//?
int fCurRetries;//?
int fCmdLen;//?
int fMaxRetries;//?

public://func

};

#endif//HYS_IOKIT_AVC_IOFIREWIREAVCCOMMAND_H
