#ifndef HYS_IOKIT_AVC_IOFIREWIREAVCCONSTS_H
#define HYS_IOKIT_AVC_IOFIREWIREAVCCONSTS_H

#define IOAVCType(a) a//?

#define kAVCUnitAddress 1//?
#define kIOFWPCROutputPayloadPhase 2//?
#define kIOFWPCRChannel  3//?
#define kIOFWPCRBroadcast 4//?
#define kIOFWPCRP2PCount 5//?
#define kIOFWPCRChannelPhase 6//?
#define kIOFWPCROnline 7//?
#define kIOFWPCRP2PCountPhase 8//?
#define kIOFWPCROutputOverheadPhase 9//?
#define kIOFWPCROutputDataRate 10//?
#define kIOFWPCRDataRatePhase 11//?
#define kIOFWPCRBroadcastBasePhase 12//?
#define kIOFWPCRExtensionPhase 13//?
#define kIOFWPCRNumPlugsPhase 14//?
#define kAVCAllOpcodes 15//?
#define kAVCAllSubunitsAndUnit 16//?
#define kAVCMaxNumPlugs 17//?
#define kAVCInvalidPlug 18//?
#define kAVCAnyAvailableIsochPlug 19//?
#define kAVCAnyAvailableExternalPlug 20//?
#define kAVCAnyAvailableSubunitPlug 21//?
#define kAVCPlugSignalFormatNTSCDV 22//?
#define kAVCMultiplePlugs 23.//?

enum {
	kAVCVideoCamera,//?
	kAVCInTransitionStatus,//?
	kAVCNotifyCommand,//?
	kAVCNumSubUnitTypes,//?
	kIOFWAVCSubunitPlugMsgConnected,//?
	kIOFWAVCSubunitPlugMsgConnectedPlugModified,//?
	IOFWAVCPlugSubunitDestType,//?
	kIOFWAVCSubunitPlugMsgDisconnected,//?
	kAVCPlugInfoOpcode,//?
	kAVCNotImplementedStatus,//?
	kAVCPowerOpcode,//?
	kAVCSubunitInfoOpcode,//?
	kAVCUnitInfoOpcode,//?
	kAVCConnectOpcode,//?
	IOFWAVCPlugExternalInputType,//?
	IOFWAVCPlugExternalOutputType,//?
	kAVCControlCommand,//?
	kAVCStatusInquiryCommand,//?
	kAVCOutputPlugSignalFormatOpcode,//?
	kAVCTapeRecorder,//?
	kAVCSignalModeMask_STYPE,//?
	kAVCSignalModeMask_DVCPro25,//?
	kAVCInputSignalModeOpcode,//?
	kAVCSignalModeMask_SDL,//?
	kAVCOutputSignalModeOpcode,//?
	kAVCSignalModeDummyOperand,//?
	kAVCVendorDependentOpcode,//?
	kAVCImplementedStatus,//?
	kAVCAcceptedStatus,//?
	kAVCSignalModeMask_50,//?
	kAVCSignalModeDVCPro625_50,//?
	kAVCSignalModeSD525_60,//?
	kAVCSignalModeDVCPro525_60,//?
	kAVCSignalModeSD625_50,//?
	kAVCSignalModeHD1250_50,//?
	kAVCSignalModeHD1125_60,//?
	kAVCSignalModeSDL625_50,//?
	kAVCSignalModeSDL525_60,//?
	kAVCInputPlugSignalFormatOpcode,//?
	kAVCCommandResponse,//?
	kAVCRejectedStatus,//?
	kIOFWAVCSubunitPlugMsgSignalFormatModified,//?
	kAVCAddress,//?
	kAVCOpcode,//?
	kAVCOperand0,//?
	kAVCOperand1,//?
	kAVCOperand2,//?
	kAVCOperand3,//?
	kAVCOperand4,//?
	IOFWAVCPlugSubunitSourceType,//?
	kAVCInterimStatus,//?
	kAVCAsyncCommandStateCancled,//?
	kAVCAsyncCommandStateOutOfMemory,//?
	kAVCAsyncCommandStateBusReset,//?
	kAVCAsyncCommandStateReceivedFinalResponse,//?
	kAVCAsyncCommandStateTimeOutBeforeResponse,//?
	kAVCAsyncCommandStatePendingRequest,//?
	kAVCAsyncCommandStateRequestSent,//?
	kAVCAsyncCommandStateRequestFailed,//?
	kAVCAsyncCommandStateWaitingForResponse,//?
	kAVCAsyncCommandStateReceivedInterimResponse,//?
	kFWAVCAsyncPlug0,//?
	kFWAVCAsyncPlug30,//?
	kFWAVCAsyncPlugAny,//?
	kFWAVCProducerMode_SEND,//?
	kFWAVCStatePlugDisconnected,//?
	kFWAVCStateBusSuspended,//?
	kFWAVCStateBusResumed,//?
	kFWAVCStatePlugReconnected,//?
	kFWAVCStateDeviceRemoved,//?
	kFWAVCConsumerMode_LAST,//?
	kFWAVCConsumerMode_MORE,//?
	kFWAVCConsumerMode_LESS,//?
	kFWAVCConsumerMode_JUNK,//?
	kFWAVCConsumerMode_LOST,//?
	IOFWAVCPlugIsochOutputType,//?
	IOFWAVCPlugIsochInputType,//?
	kAVCConnectionsOpcode,//?
	kAVCSignalSourceOpcode,//?
	kAVCDisconnectOpcode,//?
};

typedef int IOFWAVCPlugTypes;//?
typedef int IOFWAVCSubunitPlugMessages;//?
typedef int IOFWAVCAsyncCommandState;//?

#endif//HYS_IOKIT_AVC_IOFIREWIREAVCCONSTS_H
