#ifndef HYS_IOKIT_FIREWIRE_IOCONFIGDIRECTORY_H
#define HYS_IOKIT_FIREWIRE_IOCONFIGDIRECTORY_H

#include <assert.h> //linux=assert
//IOFireWireFamily-IOFireWireFamily.kmodproj/IOConfigEntry.cpp

class IOConfigDirectory;//add

class  IOConfigDirectory_HYS
{
//    OSDeclareAbstractStructors(IOConfigDirectory_HYS);

public://data
int fStart;//c
int fType;//c
int fNumEntries;//c

public://func-define

#define IOConfigDirectory_initWithOffset \
bool initWithOffset(int a, int b);//?

#define IOConfigDirectory_createIterator \
IOReturn createIterator(UInt32 a, UInt32 b,OSIterator *&c);//?

#define IOConfigDirectory_getKeyValue \
IOReturn getKeyValue(int a, OSData *&b,OSString** c =0);//?

#define IOConfigDirectory_getKeyValue_IOConfigDirectory \
IOReturn getKeyValue(int a, IOConfigDirectory *&b,OSString** c = 0);//?

#define IOConfigDirectory_getKeyOffset \
IOReturn getKeyOffset(int a, FWAddress &b,OSString** c =0);//?

#define IOConfigDirectory_getIndexOffset \
IOReturn getIndexOffset(int a, FWAddress &b);//?

#define IOConfigDirectory_getType \
int getType() const;//c

#define IOConfigDirectory_getNumEntries \
int getNumEntries() const;//c

#define IOConfigDirectory_getIndexValue_OSData \
IOReturn getIndexValue(int a, OSData *&b);//?

#define IOConfigDirectory_getIndexOffset_UInt32 \
IOReturn getIndexOffset(int a, UInt32 &b);//?

#define IOConfigDirectory_getIndexValue_OSString \
IOReturn getIndexValue(int a, OSString *&b);//?

#define IOConfigDirectory_getIndexValue_IOConfigDirectory \
IOReturn getIndexValue(int a, IOConfigDirectory *&b);//?

public://func

int updateROMCache(int a,int b);//?
const UInt32 * lockData();//?
int unlockData();//?
int checkROMState();//?
IOConfigDirectory *getSubDir(int a,int b);//?

};

#endif//HYS_IOKIT_FIREWIRE_IOCONFIGDIRECTORY_H
