#ifndef HYS_IOKIT_FIRREWIRE_IOFWDCLPROGRAM_H
#define HYS_IOKIT_FIRREWIRE_IOFWDCLPROGRAM_H

class IODCLProgram_HYS
{
 //   OSDeclareAbstractStructors(IODCLProgram_HYS)

public://data

IOMemoryMap*  fBufferMem;//c

public://func-define

#define IODCLProgram_generateBufferMap \
void generateBufferMap( DCLCommand * a ) ;//c

#define IODCLProgram_virtualToPhysical \
IOReturn virtualToPhysical(IOVirtualRange a[],unsigned	 b, IOMemoryCursor::IOPhysicalSegment c[],unsigned &d, unsigned e) ;//?

#define IODCLProgram_init  \
bool init ( IOFireWireBus :: DCLTaskInfo * a = 0) ;//?

#define IODCLProgram_free \
void free () ;//?
	
#define IODCLProgram_pause \
IOReturn pause ();//?

#define IODCLProgram_resume \
IOReturn resume ();//?

#define IODCLProgram_getBufferMap \
IOMemoryMap *getBufferMap() const ;//c

#define IODCLProgram_setForceStopProc \
void	setForceStopProc( IOFWIsochChannel::ForceStopNotificationProc a, void* b, IOFWIsochChannel* c) ;//?

#define IODCLProgram_setIsochResourceFlags \
void	setIsochResourceFlags ( IOFWIsochResourceFlags a) ;//?

#define IODCLProgram_getIsochResourceFlags \
IOFWIsochResourceFlags getIsochResourceFlags () const ;//c

public://func
int allocateHW(int a,int b);//?
int releaseHW();//?
int stop ();//?
int notify(int a,DCLCommand ** b,int c);//?
int compile(int a,int b);//?
int start();//?
int closeGate();//?
int openGate();//?

};

#endif//HYS_IOKIT_FIRREWIRE_IOFWDCLPROGRAM_H
