#ifndef HYS_IOKIT_FIREWIRE_IOFWDCLTRANSLATOR_H
#define HYS_IOKIT_FIREWIRE_IOFWDCLTRANSLATOR_H

class  IODCLTranslator_HYS
{
 //   OSDeclareAbstractStructors(IODCLTranslator_HYS)

public://data

enum {
	kNumPacketsPerPingPong,//?
	kNumPingPongs,//?
	kMaxIsochPacketSize,//?
};

DCLCommand* fToInterpret;//c
IODCLProgram*  fHWProgram;//c
DCLCommand*  fCurrentDCLCommand;//c
int fPingCount;//c
UInt32 fPacketHeader;//c
DCLLabel  fStartLabel;//c
DCLJump fJumpToStart;//c

DCLTransferPacket fTransfers[1];//?
DCLCallProc fCalls[1];//?
UInt8 fBuffer[1];//?

public://func

#define IODCLTranslator_init \
bool init(DCLCommand* a);//?

#define IODCLTranslator_releaseHW \
IOReturn releaseHW();//?

#define IODCLTranslator_stop \
void stop();//?

#define IODCLTranslator_getTranslatorOpcodes \
DCLCommand* getTranslatorOpcodes();//c

#define IODCLTranslator_setHWProgram \
void setHWProgram(IODCLProgram *a);//?

#define IODCLTranslator_allocateHW \
IOReturn allocateHW(IOFWSpeed a, UInt32 b);//?

#define IODCLTranslator_notify \
IOReturn notify(IOFWDCLNotificationType a, DCLCommand** b, UInt32 c);//?

#define IODCLTranslator_ListeningDCLPingPongProc \
static void ListeningDCLPingPongProc(DCLCommand* a);//?

#define IODCLTranslator_TalkingDCLPingPongProc \
static void TalkingDCLPingPongProc(DCLCommand* a);//?

};

class  IODCLTranslateListen_HYS
{
    OSDeclareDefaultStructors(IODCLTranslateListen_HYS)

public:
#define IODCLTranslateListen_start \
IOReturn start();//?

#define IODCLTranslateListen_compile \
IOReturn compile(IOFWSpeed a, UInt32 b);//?

};

class  IODCLTranslateTalk_HYS
{
    OSDeclareDefaultStructors(IODCLTranslateTalk_HYS)

public:
#define IODCLTranslateTalk_compile \
IOReturn compile(IOFWSpeed a, UInt32 b);//?

#define IODCLTranslateTalk_start \
IOReturn start();//?

};


#endif//HYS_IOKIT_FIREWIRE_IOFWDCLTRANSLATOR_H
