#ifndef HYS_IOKIT_FIREWIRE_IOFWPHYPACKETLISTENER_H
#define HYS_IOKIT_FIREWIRE_IOFWPHYPACKETLISTENER_H

typedef void (*FWPHYPacketCallback)( void *a, UInt32 b, UInt32 c);//c

class IOFWPHYPacketListener_HYS
{
	OSDeclareDefaultStructors( IOFWPHYPacketListener_HYS );

public://data
IOFireWireController * fControl;//c
FWPHYPacketCallback fCallback;//c
void* fRefCon;//c

public://func

#define IOFWPHYPacketListener_setCallback \
void setCallback( FWPHYPacketCallback a );//?

#define IOFWPHYPacketListener_free \
void free( );//?

#define IOFWPHYPacketListener_activate \
IOReturn activate();//?

#define IOFWPHYPacketListener_processPHYPacket \
void processPHYPacket( UInt32 a, UInt32 b);//?

#define IOFWPHYPacketListener_deactivate \
void deactivate();//?

#define IOFWPHYPacketListener_initWithController \
bool initWithController( IOFireWireController * a);//?

#define IOFWPHYPacketListener_getRefCon \
void * getRefCon();//?

#define IOFWPHYPacketListener_setRefCon \
void setRefCon( void *a);//?

#define IOFWPHYPacketListener_createWithController \
static IOFWPHYPacketListener * createWithController( IOFireWireController * a);//?

};


#endif//HYS_IOKIT_FIREWIRE_IOFWPHYPACKETLISTENER_H
