#ifndef HYS_IOKIT_FIREWIRE_IOFIREWIREBUS_H
#define HYS_IOKIT_FIREWIRE_IOFIREWIREBUS_H

class IOFireWireBusAux;//add

extern const OSSymbol *gFireWire_GUID;//c
extern const OSSymbol *gFireWireVendor_ID;//c
extern const OSSymbol *gFireWireProduct_Name;//c
extern const OSSymbol *gFireWireNodeID;//c
extern const OSSymbol *gFireWireSelfIDs;//c
extern const OSSymbol *gFireWireROM;//c
extern const OSSymbol *gFireWireVendor_Name;//c
extern const OSSymbol *gFireWireModel_ID;//c
extern const OSSymbol *gFireWireUnit_Spec_ID;//c
extern const OSSymbol *gFireWireUnit_SW_Version;//c
extern const OSSymbol *gFireWireTDM;//c
extern const OSSymbol *gFireWireSpeed;//c

class  IOFireWireBus_HYS
{
  //  OSDeclareAbstractStructors(IOFireWireBus_HYS)

public://define

#define IOFireWireBus_gIOFireWirePlane \
static const IORegistryPlane * gIOFireWirePlane;//c

#define IOFireWireBus_createBufferFillIsochPort \
IOFWBufferFillIsochPort *createBufferFillIsochPort() ;//?

public://data

struct DCLTaskInfoAux {
	int version;//?
	union {
		struct {
			IOMemoryMap*  bufferMemoryMap;//c
		} v0;
		struct {
			IOMemoryMap* bufferMemoryMap;//c
		} v1;
		struct {
			IOMemoryMap * bufferMemoryMap;	//c
			IOWorkLoop* workloop;//c
 			int options;//?
		} v2;
	} u;
};

struct DCLTaskInfo{
	int unused0;//?
	int unused1;//?
	int unused2;//?
	int unused3;//?
	int unused4;//?
	int unused5;//?
	DCLTaskInfoAux* auxInfo;//c
};

IOFireWireBusAux * fAuxiliary;//c

public://func

int RemoveUnitDirectory(IOLocalConfigDirectory * a);//?
int getBusCycleTime(int a,int b);//?
int resetBus();//?
IOFWAddressSpace * getAddressSpace(FWAddress a);//?

 IOFWPseudoAddressSpace * createInitialAddressSpace(int a,int b,FWReadCallback c,FWWriteCallback d,void* e);//?

IOFWDCLPool *createDCLPool(int a=0);//?

IOFWSimpleContiguousPhysicalAddressSpace *createSimpleContiguousPhysicalAddressSpace(int a,int b);//?

IOFWSimplePhysicalAddressSpace *createSimplePhysicalAddressSpace(int a,int b);//?
};

class  IOFireWireBusAux_HYS
{
  //  OSDeclareAbstractStructors(IOFireWireBusAux_HYS)
public :

IOFWBufferFillIsochPort * createBufferFillIsochPort();//?

};

#endif//HYS_IOKIT_FIREWIRE_IOFIREWIREBUS_H
