#ifndef HYS_IOKIT_FIREWIRE_IOFIREWIRERMALLOCATION_H
#define HYS_IOKIT_FIREWIRE_IOFIREWIRERMALLOCATION_H

class  IOFireWireIRMAllocation_HYS
{
	OSDeclareDefaultStructors(IOFireWireIRMAllocation_HYS)

public://type

typedef IOReturn (*AllocationLostNotificationProc)(void* a, class IOFireWireIRMAllocation* b);//c

public://data

IORecursiveLock *fLock ;//c
IOFireWireController *fControl;//c
AllocationLostNotificationProc fAllocationLostProc;//c
void*  fLostProcRefCon;//c

int isAllocated;//?
int fIsochChannel;//?
int fReleaseIRMResourcesOnFree;//?
int fAllocationGeneration;//?
int fBandwidthUnits;//?

public://define

#define IOFireWireIRMAllocation_allocateIsochResources \
IOReturn allocateIsochResources(UInt8 a, UInt32 b);//?

#define IOFireWireIRMAllocation_free \
void free();//?

#define IOFireWireIRMAllocation_areIsochResourcesAllocated \
Boolean areIsochResourcesAllocated(UInt8 *a, UInt32 *b);//?

#define IOFireWireIRMAllocation_GetRefCon \
void * GetRefCon();//?

#define IOFireWireIRMAllocation_getAllocationGeneration \
UInt32 getAllocationGeneration();//?

#define IOFireWireIRMAllocation_setReleaseIRMResourcesOnFree \
void setReleaseIRMResourcesOnFree(Boolean a);//?

#define IOFireWireIRMAllocation_SetRefCon \
void SetRefCon(void* a); //?

#define IOFireWireIRMAllocation_deallocateIsochResources \
IOReturn deallocateIsochResources();//?

#define IOFireWireIRMAllocation_failedToRealloc \
void failedToRealloc();//?

#define IOFireWireIRMAllocation_threadFunc \
static void threadFunc( void * a);//?

#define IOFireWireIRMAllocation_handleBusReset \
void handleBusReset(UInt32 a);//?

#define IOFireWireIRMAllocation_release \
void release() const;//?

#define IOFireWireIRMAllocation_init \
bool init( IOFireWireController *a, Boolean b= 0, AllocationLostNotificationProc c = 0, void *d = 0);//?

};

#endif//HYS_IOKIT_FIREWIRE_IOFIREWIRERMALLOCATION_H
