#ifndef HYS_IOKIT_FIREWIRE_IOLOCALCONFIGDIRECTORY_H
#define HYS_IOKIT_FIREWIRE_IOLOCALCONFIGDIRECTORY_H

class IOLocalConfigDirectory;//add

class IOLocalConfigDirectory_HYS
{
	OSDeclareDefaultStructors(IOLocalConfigDirectory_HYS);

public://data

OSArray*  fEntries;//c
OSData*  fROM;//c
UInt32 fHeader;//c

public://define

#define IOLocalConfigDirectory_exporterCleanup \
static void	exporterCleanup( const OSObject * a, IOFWUserObjectExporter *b) ;//?

#define IOLocalConfigDirectory_removeSubDir \
IOReturn removeSubDir(IOLocalConfigDirectory *a);//?

#define IOLocalConfigDirectory_addEntry_FWAddress \
IOReturn addEntry(int a, FWAddress b, OSString *c =0);//?

#define IOLocalConfigDirectory_addEntry_OSData \
IOReturn addEntry(int a, OSData *b, OSString *c = 0);//?

#define IOLocalConfigDirectory_addEntry_IOLocalConfigDirectory  \
IOReturn addEntry(int a, IOLocalConfigDirectory *b,	OSString *c =0);//?

#define IOLocalConfigDirectory_addEntry_OSString \
IOReturn addEntry(OSString *a);//?

#define IOLocalConfigDirectory_addEntry \
IOReturn addEntry(int a, UInt32 b, OSString *c = 0);//?

#define IOLocalConfigDirectory_incrementGeneration \
IOReturn incrementGeneration();//?

#define IOLocalConfigDirectory_compile \
IOReturn compile(OSData *a);//?

#define IOLocalConfigDirectory_getEntries \
const OSArray *getEntries() const;//?

#define IOLocalConfigDirectory_getIndexValue \
IOReturn getIndexValue(int a, IOConfigDirectory *&b);//?

#define IOLocalConfigDirectory_checkROMState \
IOReturn checkROMState();//?

#define IOLocalConfigDirectory_updateROMCache \
IOReturn updateROMCache( UInt32 a, UInt32 b);//?

#define IOLocalConfigDirectory_create \
static IOLocalConfigDirectory *create();//?

#define IOLocalConfigDirectory_unlockData \
void unlockData();//?

#define IOLocalConfigDirectory_lockData \
const UInt32 * lockData();//?

#define IOLocalConfigDirectory_getBase \
const UInt32 *getBase();//?

#define IOLocalConfigDirectory_init \
bool init();//?

#define IOLocalConfigDirectory_free \
void free();

public://func

};

#endif//HYS_IOKIT_FIREWIRE_IOLOCALCONFIGDIRECTORY_H
