#ifndef HYS_IOKIT_GRPHICS_IOGRAPHICSTYPES_H
#define HYS_IOKIT_GRPHICS_IOGRAPHICSTYPES_H

#define kDisplayProductID "kDisplayProductID"//?
#define kAppleSenseKey "kAppleSenseKey"//?
#define kIOFBConfigKey "kIOFBConfigKey"//?
#define kIOFBModesKey "kIOFBModesKey"//?
#define kIOFBModeIDKey "kIOFBModeIDKey"//?
#define kIOFBModeIDKey "kIOFBModeIDKey"//?
#define kIOFBModeDMKey "kIOFBModeDMKey"//?
#define kIOFBTimingRangeKey "kIOFBTimingRangeKey"//?
#define kIODisplayBrightnessKey "kIODisplayBrightnessKey"//?
#define kIOFBModeAIDKey "kIOFBModeAIDKey"//?
#define kIOFBModeTMKey "kIOFBModeTMKey"//?
#define kIOFBProbeOptionsKey "kIOFBProbeOptionsKey"//?
#define kIOFBGammaWidthKey "kIOFBGammaWidthKey"//?
#define kIOFBGammaCountKey "kIOFBGammaCountKey"//?
#define kIOFBCLUTDeferKey "kIOFBCLUTDeferKey"//?
#define kIOFBCursorInfoKey "kIOFBCursorInfoKey"//?
#define kIOFBWidthKey "kIOFBWidthKey"//?
#define kIOFBMemorySizeKey "kIOFBMemorySizeKey"//?
#define kIODisplayConnectFlagsKey "kIODisplayConnectFlagsKey"//?
#define kIOFBDetailedTimingsKey "kIOFBDetailedTimingsKey"//?
#define kIOFBHeightKey "kIOFBHeightKey"//?
#define kIOFBRefreshRateKey "kIOFBRefreshRateKey"//?
#define kIOFBFlagsKey "kIOFBFlagsKey"//?
#define kIOFBBytesPerRowKey "kIOFBBytesPerRowKey"//?
#define kIOFBBytesPerPlaneKey "kIOFBBytesPerPlaneKey"//?
#define kIOFBBitsPerPixelKey "kIOFBBitsPerPixelKey"//?
#define kIOFBComponentCountKey "kIOFBComponentCountKey"//?
#define kIOFBBitsPerComponentKey "kIOFBBitsPerComponentKey"//?
#define kIOHibernatePreviewActiveKey "kIOHibernatePreviewActiveKey"//?
#define IO8BitIndexedPixels "IO8BitIndexedPixels"//?
#define IO16BitDirectPixels "IO16BitDirectPixels"//?
#define IO32BitDirectPixels "IO32BitDirectPixels"//?
#define kIODisplayParametersKey "kIODisplayParametersKey"//?
#define kIODisplayGUIDKey "kIODisplayGUIDKey"//?
#define kIODisplayValueKey "kIODisplayValueKey"//?
#define kIODisplayMinValueKey "kIODisplayMinValueKey"//?
#define kIODisplayMaxValueKey "kIODisplayMaxValueKey"//?
#define kIODisplayContrastKey "kIODisplayContrastKey"//?
#define kIODisplayHorizontalPositionKey "kIODisplayHorizontalPositionKey"//?
#define kIODisplayHorizontalSizeKey "kIODisplayHorizontalSizeKey"//?
#define kIODisplayVerticalPositionKey "kIODisplayVerticalPositionKey"//?
#define kIODisplayVerticalSizeKey "kIODisplayVerticalSizeKey"//?
#define kIODisplayTrapezoidKey "kIODisplayTrapezoidKey"//?
#define kIODisplayPincushionKey "kIODisplayPincushionKey"//?
#define kIODisplayParallelogramKey "kIODisplayParallelogramKey"//?
#define kIODisplayRotationKey "kIODisplayRotationKey"//?
#define kIODisplayOverscanKey "kIODisplayOverscanKey"//?
#define kIODisplayVideoBestKey "kIODisplayVideoBestKey"//?
#define kIODisplayParametersCommitKey "kIODisplayParametersCommitKey"//?
#define kIODisplayParametersDefaultKey "kIODisplayParametersDefaultKey"//?
#define kIODisplayTheatreModeKey "kIODisplayTheatreModeKey"//?
#define kIODisplayTheatreModeWindowKey "kIODisplayTheatreModeWindowKey"//?
#define kIODisplayEDIDKey "kIODisplayEDIDKey"//?
#define kAppleDisplayTypeKey "kAppleDisplayTypeKey"//?
#define kDisplayVendorID "kDisplayVendorID"//?
#define kIO16BitFloatPixels "kIO16BitFloatPixels"//?
#define kIOFBHostAccessFlagsKey "kIOFBHostAccessFlagsKey"//?
#define kIOFBScalerInfoKey "kIOFBScalerInfoKey"//?
#define IO1BitIndexedPixels "IO1BitIndexedPixels"//?
#define IO2BitIndexedPixels "IO2BitIndexedPixels"//?
#define IO4BitIndexedPixels "IO4BitIndexedPixels"//?
#define IO8BitIndexedPixels "IO8BitIndexedPixels"//?
#define IO16BitIndexedPixels "IO16BitIndexedPixels"//?
#define kIO32BitFloatPixels "kIO32BitFloatPixels"//?
#define kIO30BitDirectPixels "kIO30BitDirectPixels"//?
#define kIO64BitDirectPixels "kIO64BitDirectPixels"//?
#define kIODisplayOverrideMatchingKey "kIODisplayOverrideMatchingKey"//?
#define kIODisplayIsDigitalKey "kIODisplayIsDigitalKey"//?
#define kDisplayBundleKey "kDisplayBundleKey"//?
#define kDisplayProductName "kDisplayProductName"//?
#define kIODisplayLocationKey "kIODisplayLocationKey"//?
#define kDisplayVerticalImageSize "kDisplayVerticalImageSize"//?
#define kDisplayHorizontalImageSize "kDisplayHorizontalImageSize"//?
#define kDisplaySerialNumber "kDisplaySerialNumber"//?
#define kIODisplayHasBacklightKey "kIODisplayHasBacklightKey"//?
#define kDisplayRedPointX "kDisplayRedPointX"//?
#define kDisplaySubPixelLayout "kDisplaySubPixelLayout"//?
#define kDisplayFixedPixelFormat "kDisplayFixedPixelFormat"//?
#define kDisplayYearOfManufacture "kDisplayYearOfManufacture"//?
#define kDisplayWeekOfManufacture "kDisplayWeekOfManufacture"//?
#define kDisplayBrightnessAffectsGamma "kDisplayBrightnessAffectsGamma"//?
#define kDisplayWhitePointX "kDisplayWhitePointX"//?
#define kDisplayGreenPointY "kDisplayGreenPointY"//?
#define kDisplayWhiteGamma "kDisplayWhiteGamma"//?
#define kDisplayRedPointY "kDisplayRedPointY"//?
#define kDisplayViewAngleAffectsGamma "kDisplayViewAngleAffectsGamma"//?
#define kDisplayGreenPointX "kDisplayGreenPointX"//?
#define kDisplayBluePointX "kDisplayBluePointX"//?
#define kDisplayBluePointY "kDisplayBluePointY"//?
#define kDisplayWhitePointY "kDisplayWhitePointY"//?
#define kIOFBModeDFKey "kIOFBModeDFKey"//?
#define kIOFramebufferInfoKey "kIOFramebufferInfoKey"//?
///////////////////
enum {
	kIORGBSignedDirectPixels,//?
	kIORGBDirectPixels,//?
	kHardwareCursorDescriptorMajorVersion,//?
	kHardwareCursorDescriptorMinorVersion,//?
	kIOScaleStretchToFit,//?
	kDisplayModeNotGraphicsQualityFlag,//?
	kIOScaleStretchOnly,//?
	kIOScaleCanRotate,//?
	kIOScaleCanBorderInsetOnly,//?
	kIOMirrorForced,//?
	kIOTimingIDApplePAL_ST,//?
	kIOTimingIDAppleNTSC_ST,//?
	kIORangeSupportsInterlacedCEATimingWithConfirm,//?
	kIOScaleCanScaleInterlaced,//?
	kIOTimingIDApplePAL_STconv,//?
	kIOTimingIDApplePAL_FF,//?
	kDisplayModeNeverShowFlag,//?
	kIOTimingIDApplePAL_FFconv,//?
	kIOTimingIDApple_FixedRateLCD,//?
	kIOScaleCanDownSamplePixels,//?
	kIOTimingIDAppleNTSC_FFconv,//?
	kIOTimingIDAppleNTSC_STconv,//?
	kIOTimingIDAppleNTSC_FF,//?
	kIOMaxPixelBits,//?
	kDisplaySubPixelLayoutRGB,//?
	kIOScaleCanSupportInset,//?
	kIOScaleCanUpSamplePixels,//?
	kIOTimingIDInvalid,//?
	kIOTimingIDApple_0x0_0hz_Offline,//?
	kSetCLUTWithLuminance,//?
	kIOConnectionBuiltIn,//?
	kIOInterlacedCEATiming,//?
	kDisplayProductIDGeneric,//?
	kIODetailedTimingValid,//?
	kDisplayModeValidFlag,//?
	kFramebufferDisableAltivecAccess,//?
	kIOCLUTPixels,//?
	kDisplayModeSafetyFlags,//?
	kIOScalingInfoValid,//?
	kIOScaleRotateFlags,//?
	kDisplayModeTelevisionFlag,//?
	kDisplayModeBuiltInFlag,//?
	kSetCLUTImmediately,//?

	kIOScaleSwapAxes,//?
	kSetCLUTByValue,//?
	kIOMirrorHWClipped,//?
	kIOMirrorIsPrimary,//?
	kIODigitalSignal,//?
	kIOAnalogSetupExpected,//?
	kDisplayModeDefaultFlag,//?
	kIORangeSupportsVSyncSerration,//?
	kIOFBServerConnectType,//?
	kIOFBSharedConnectType,//?
	kDisplayModeNotPresetFlag,//?
	kIOMirrorDefault,//?
	kIOFBSystemAperture,//?
	kIOSyncPositivePolarity,//?
	kDisplayModeStretchedFlag,//?
	kDisplayModeInterlacedFlag,//?
	kIOAnalogSignalLevel_0700_0300,//?
	kIOFBUserRequestProbe,//?
	kIOScaleRotate0,//?
	kIORangeSupportsSyncOnGreen,//?
	kIORangeSupportsCompositeSync,//?
	kDisplayModeSimulscanFlag,//?
	kIORGBSignedFloatingPointPixels,//?
	kIORangeSupportsInterlacedCEATiming,//?
	kDisplayModeSafeFlag,//?
	kIOScaleInvertY,//?
	kIOScaleInvertX,//?
};

enum {
   kTransparentEncoding 	= 0,
   kInvertingEncoding
};//c

enum {
    	kConnectionSyncFlags		= 'sycf',//c
    	kConnectionChanged			= 'chng',//c
    	kConnectionPostWake			= 'pwak',//c
    	kConnectionSyncEnable		= 'sync',//c
    	kIOFBVBLInterruptType		= 'vbl ',//c
    	kDisplayVendorIDUnknown	= 'unkn',//c
    	kConnectionPower			= 'powr',//c
  	kConnectionOverscan			= 'oscn',//c
    	kIOVRAMSaveAttribute		= 'vrsv',//c
    	kConnectionProbe			= 'prob',//c
    	kIOPowerAttribute			= 'powr',//c
    	kConnectionEnable			= 'enab',//c
    	kIOFBConnectInterruptType		= 'dci ',//c
    	kConnectionSupportsLLDDCSense	= 'lddc',//c
    	kIOCursorControlAttribute		= 'crsc',//c
    	kConnectionSupportsAppleSense	= 'asns',//c
    	kIODeferCLUTSetAttribute		= 'vclt',//c
    	kConnectionDisplayParameterCount	= 'pcnt',//c
    	kConnectionSupportsHLDDCSense	= 'hddc',//c
    	kConnectionDisplayParameters	= 'parm',//c
    	kConnectionFlags			= 'flgs',//c
    	kIOMirrorAttribute			= 'mirr',//c
    	kIOCapturedAttribute		= 'capd',//c
    	kIOClamshellStateAttribute		= 'clam',//c
    	kIOMirrorDefaultAttribute		= 'mrdf',//c
    	kIOHardwareCursorAttribute		= 'crsr',//c
    	kIODisplayModeIDReservedBase  = (long)0x80000000,//c
    	kIOSystemPowerAttribute		= 'spwr',//c
  	kTransparentEncodingShift	= (kTransparentEncoding << 1),//c
   	kTransparentEncodedPixel	= (0x01 << kTransparentEncodingShift),//c
    	kIODisplayModeIDBootProgrammable = (long)0xFFFFFFFB,//c
   	kInvertingEncodingShift	= (kInvertingEncoding << 1),//c
   	kInvertingEncodedPixel	= (0x01 << kInvertingEncodingShift),//c
    	kIOScaleRotate270		= kIOScaleSwapAxes | kIOScaleInvertY,//c
    	kIOScaleRotate180		= kIOScaleInvertX  | kIOScaleInvertY,//c
    	kIOScaleRotate90		= kIOScaleSwapAxes | kIOScaleInvertX,//c
};
////////////////////
typedef SInt32	IODisplayModeID;//c
typedef char IOPixelEncoding[ kIOMaxPixelBits ];//c
typedef IOIndex IOPixelAperture;//c
typedef UInt16 IOColorComponent;//c
typedef UInt32	IODisplayVendorID;//c
typedef UInt32	IODisplayProductID;//c
typedef UInt32  IOAppleTimingID;//c

struct IOGBounds {
    SInt16	minx;
    SInt16	maxx;
    SInt16	miny;
    SInt16	maxy;
};
typedef struct IOGBounds IOGBounds;//c

struct IOGSize {
    SInt16	width;
    SInt16	height;
};
typedef struct IOGSize IOGSize;//c

struct IOGPoint {
    SInt16	x;
    SInt16	y;
};
typedef struct IOGPoint IOGPoint;//c

struct IODetailedTimingInformationV1 {
};
typedef struct IODetailedTimingInformationV1 IODetailedTimingInformationV1;

struct IOTimingInformation {
    IOAppleTimingID		appleTimingID;	
    UInt32			flags;
    union {
      	IODetailedTimingInformationV1	v1;
      	IODetailedTimingInformationV2	v2;
    }				detailedInfo;
};
typedef struct IOTimingInformation IOTimingInformation;//c

struct IOFBDisplayModeDescription {
	IODisplayModeInformation info;//c
	IOTimingInformation timingInfo;//c
};
typedef struct IOFBDisplayModeDescription IOFBDisplayModeDescription;

struct IOFramebufferInformation {
    IOPhysicalAddress		baseAddress;
    UInt32			activeWidth;
    UInt32			activeHeight;
    IOByteCount			bytesPerRow;
    IOByteCount			bytesPerPlane;
    UInt32			bitsPerPixel;
    UInt32			pixelType;
    UInt32			flags;
    UInt32			reserved[ 4 ];
};
typedef struct IOFramebufferInformation IOFramebufferInformation;//c

struct IODisplayScalerInformation {
    	IOOptionBits	scalerFeatures;//c
    	UInt32		maxHorizontalPixels;//c
    	UInt32		maxVerticalPixels;//c
};
typedef struct IODisplayScalerInformation IODisplayScalerInformation;

typedef UInt32	IOSelect;//c

//#if !defined(__Point__) && !defined(BINTREE_H) && !defined(__MACTYPES__)
#ifndef __Point__
	#define __Point__
	typedef IOGPoint Point;//c
#endif
//#endif

//#if !defined(__Bounds__) && !defined(BINTREE_H) && !defined(__MACTYPES__)
#ifndef __Bounds__
#define __Bounds__
typedef IOGBounds Bounds;//c
#endif



#endif//HYS_IOKIT_GRPHICS_IOGRAPHICSTYPES_H
