#ifndef HYS_IOKIT_HID_IOHIDEVENT_H
#define HYS_IOKIT_HID_IOHIDEVENT_H


#ifdef __cplusplus
class IOHIDEvent;//add

class  IOHIDEvent_HYS
{
    OSDeclareAbstractStructors( IOHIDEvent_HYS)
public:

static IOHIDEvent  *accelerometerEvent (AbsoluteTime a, IOFixed b, IOFixed c, IOFixed d,  IOOptionBits e = 0);//c

static IOHIDEvent* ambientLightSensorEvent (AbsoluteTime a,UInt32 b,UInt32 c=0,UInt32 d=0,IOOptionBits e=0);//c

static IOHIDEvent * temperatureEvent ( AbsoluteTime a, IOFixed b, IOOptionBits c= 0);//c
static IOHIDEvent * withEventData(AbsoluteTime a,int b,NXEventData * c,int d=0);//?
static IOHIDEvent* withBytes(const void *a,int b);//?
int getLength();//?
int readBytes(void* a,int b);//?
static IOHIDEvent* keyboardEvent(AbsoluteTime a,int b,int c,int d,int e=0);//?

public://hys add

#define kIOHIDKeyboardEvent  1
#define kIOHIDMouseEvent 2
#define kIOHIDScrollEvent 3

struct HYS_IOKIT_HID_IOHIDEVENT_H_data_keyboard {
	int usagePage;
	int usage;
	int value;
	int repeat;
};

struct HYS_IOKIT_HID_IOHIDEVENT_H_data_mouse {
	int buttons;
	int dx;
	int dy;
};

struct HYS_IOKIT_HID_IOHIDEVENT_H_data_scroll_lines {
	int deltaAxis1;
	int deltaAxis2;
	int deltaAxis3;
};

struct HYS_IOKIT_HID_IOHIDEVENT_H_data_scroll {
	HYS_IOKIT_HID_IOHIDEVENT_H_data_scroll_lines lines;
};

struct HYS_IOKIT_HID_IOHIDEVENT_H_data {
	HYS_IOKIT_HID_IOHIDEVENT_H_data_keyboard keyboard;
	HYS_IOKIT_HID_IOHIDEVENT_H_data_mouse mouse;
	HYS_IOKIT_HID_IOHIDEVENT_H_data_scroll scroll;
};

int type;
HYS_IOKIT_HID_IOHIDEVENT_H_data data;

};
#endif//__cplusplus

#endif//HYS_IOKIT_HID_IOHIDEVENT_H
