#ifndef HYS_IOKIT_HID_IOHIDUSERCLIENT_H
#define HYS_IOKIT_HID_IOHIDUSERCLIENT_H

enum {
	kIOHIDLibUserClientStopQueue,//?
	kIOHIDLibUserClientStartQueue,//?
	kIOHIDLibUserClientQueueHasElement,//?
	kIOHIDLibUserClientRemoveElementFromQueue,//?
	kIOHIDLibUserClientAddElementToQueue,//?
	kIOHIDLibUserClientCreateQueue,//?
	kIOHIDLibUserClientSetQueueAsyncPort,//?
	kIOHIDLibUserClientGetElements,//?
	kIOHIDLibUserClientGetReport,//?
	kIOHIDLibUserClientSetReport,//?
	kIOHIDLibUserClientClose,//?
	kIOHIDLibUserClientOpen,//?
	kIOHIDLibUserClientAsyncPortType,//?
	kIOHIDLibUserClientDeviceIsValid,//?
	kHIDReportHandlerType,//?
	kHIDElementType,//?
	kIOHIDLibUserClientElementValuesType,//?
	kIOHIDLibUserClientGetElementCount,//?
	kIOHIDLibUserClientDeviceValidPortType,//?
	kIOHIDLibUserClientConnectManager,//?
	kIOHIDLibUserClientPostElementValues,//?
	kIOHIDLibUserClientUpdateElementValues,//?
};

struct IOHIDElementStruct;
typedef struct IOHIDElementStruct IOHIDElementStruct;
struct IOHIDElementStruct {
	int type;//?
	int valueLocation;//?
	int cookieMin;//?
	int reportCount;//?
	int size;//?
	int parentCookie;//?
	int usageMin;//?
	int usageMax;//?
	int usagePage;//?
	int flags;//?
 	int reportID;//?
	int duplicateValueSize;//?
	int duplicateIndex;//?
	int collectionType;//?
	int reportSize;//?
	int max;//?
	int min;//?
	int scaledMax;//?
	int scaledMin;//?
	int unit;//?
	int unitExponent;//?
	int cookieMax;//?
	int bytes;//?
	int valueSize;//?
};

struct _IOHIDElementValue {
	int timestamp;//?
	int generation;//?
	IOHIDElementCookie cookie;//c
	int value[1];//?
};
typedef struct _IOHIDElementValue IOHIDElementValue;

#endif//HYS_IOKIT_HID_IOHIDUSERCLIENT_H
