#ifndef HYS_IOKIT_HID_IOHIDSERVICEPLUGIN_H
#define HYS_IOKIT_HID_IOHIDSERVICEPLUGIN_H

//hys add

#include <IOKit/ndrvsupport/IOMacOSTypes.h>//kNilOptions

//#ifdef _IOKIT_IOHIDIUNKNOWN_H

#include <IOKit/IOCFPlugIn.h>//CFUUIDRef
static const void* kIOHIDDeviceTypeID;
static const void* kIOHIDServicePlugInTypeID;
static CFUUIDRef kIOHIDDeviceFactoryID;
//#endif


//IOHIDLib/IOHIDEventServiceClass.h-IOHIDFamily
//#ifdef _IOKIT_IOHIDEVENTSERVICECLASS_H
#include <CoreFoundation/CFMachPort.h>//CFMachPort
//#endif

class IOHIDEvent;
typedef IOHIDEvent* IOHIDEventRef;

typedef int (*IOHIDServiceEventCallback)(void* a,void* b,void* c,IOHIDEventRef d,int e);


typedef int IOHIDEventType;

struct IOHIDServiceInterface2 {
	HRESULT (*a)(void*, REFIID, void**);
    	HRESULT (*b)(void*, REFIID, void**);
    	UInt32 (*c)(void*);
    	UInt32 (*d)(void*);
    	boolean_t (*e)(void*, IOOptionBits);
    	void (*f)(void*, IOOptionBits);
    	const void* (*g)(void*, CFStringRef);
    	boolean_t (*h)(void*, CFStringRef, const void*);
    	void (*i)(void*, IOHIDServiceEventCallback, void*, void*);
	void (*j)(void*, CFRunLoopRef, CFStringRef);
	void (*k)(void*, CFRunLoopRef, CFStringRef);
	IOHIDEvent* (*l)(void*, IOHIDEventType, IOHIDEvent*, IOOptionBits);
};
typedef struct IOHIDServiceInterface2 IOHIDServiceInterface2;

static inline IOHIDEventRef IOHIDEventCreateWithData( CFAllocatorRef  a,  CFDataRef  b){return 0;};

static inline CFDataRef IOHIDEventCreateData (CFAllocatorRef a,IOHIDEventRef b){return 0;};

static const void* kIOHIDServiceInterfaceID;
static const void *kIOHIDServiceInterface2ID;

////////////
#endif//HYS_IOKIT_HID_IOHIDSERVICEPLUGIN_H
