#ifndef HYS_IOKIT_HID_IOHIDUSAGETABLES_H
#define HYS_IOKIT_HID_IOHIDUSAGETABLES_H

enum {
	kHIDUsage_Tfon_Hold,//?
	kHIDUsage_KeyboardCapsLock,//?
	kHIDUsage_Dig_Puck,//?
	kHIDUsage_Dig_Stylus,//?
	kHIDUsage_KeyboardRightAlt,//?
	kHIDUsage_KeyboardRightShift,//?
	kHIDUsage_KeyboardRightControl,//?
	kHIDUsage_KeyboardLeftGUI,//?
	kHIDUsage_KeyboardLeftAlt,//?
	kHIDUsage_KeyboardLeftShift,//?
	kHIDUsage_Dig_BarrelPressure,//?
	kHIDUsage_LED_CapsLock,//?
	kHIDUsage_KeyboardA,//?
	kHIDUsage_Dig_Invert,//?
	kHIDUsage_Dig_TransducerIndex,//?
	kHIDUsage_Dig_Twist,//?
	kHIDUsage_Dig_YTilt,//?
	kHIDUsage_Dig_XTilt,//?
	kHIDUsage_Dig_Eraser,//?
	kHIDUsage_Dig_TipSwitch,//?
	kHIDUsage_Dig_BarrelSwitch,//?
	kHIDUsage_Dig_InRange,//?
	kHIDUsage_Csmr_ACPan,//?
	kHIDUsage_Dig_TipPressure,//?
	kHIDUsage_LED_NumLock,//?
	kHIDUsage_KeyboardRightGUI,//?
	kHIDUsage_KeyboardLeftControl,//?
	kHIDUsage_KeyboardErrorRollOver,//?
	kHIDUsage_KeyboardLockingNumLock,//?
	kHIDUsage_Csmr_Mute,//?
	kHIDUsage_Csmr_VolumeDecrement,//?
	kHIDUsage_Csmr_VolumeIncrement,//?
	kHIDUsage_Csmr_Eject,//?
	kHIDUsage_Csmr_StopOrEject,//?
	kHIDUsage_Csmr_FastForward,//?
	kHIDUsage_Csmr_Rewind,//?
	kHIDUsage_Csmr_ScanPreviousTrack,//?
	kHIDUsage_Csmr_ScanNextTrack,//?
	kHIDUsage_Csmr_PlayOrSkip,//?
	kHIDUsage_Csmr_PlayOrPause,//?
	kHIDUsage_Csmr_Play,//?
	kHIDUsage_Csmr_Sleep,//?
	kHIDUsage_Csmr_Reset,//?
	kHIDUsage_Csmr_Power,//?
	kHIDPage_GenericDesktop,//?
	kHIDUsage_GD_Keyboard,//?
	kHIDPage_PID,//?
	kHIDUsage_GD_X,//?
	kHIDUsage_GD_Y,//?
	kHIDUsage_GD_Z,//?
	kHIDUsage_GD_Rx,//?
	kHIDUsage_GD_Ry,//?
	kHIDUsage_GD_Rz,//?
	kHIDUsage_GD_Slider,//?,
	kHIDUsage_GD_Dial,//?
	kHIDUsage_GD_Wheel,//?
	kHIDUsage_GD_Hatswitch,//?
	kHIDPage_Button,//?
	kHIDPage_Undefined,//?
	kHIDUsage_GD_Mouse,//?
	kHIDUsage_GD_Pointer,//?
	kHIDUsage_PD_PowerConverter,//?
	kHIDUsage_PD_ConfigApparentPower,//?
	kHIDPage_VendorDefinedStart,//?
	kHIDUsage_GD_Joystick,//?
	kHIDUsage_GD_GamePad,//?
	kHIDUsage_GD_Keypad,//?
	kHIDUsage_GD_MultiAxisController,//?
	kHIDUsage_GD_CountedBuffer,//?
	kHIDPage_Arcade,//?
	kHIDPage_AlphanumericDisplay,//?
	kHIDPage_BarCodeScanner,//?
	kHIDPage_Scale,//?
	kHIDPage_CameraControl,//?
	kHIDUsage_GD_Select,//?
	kHIDUsage_BS_Level3,//?
	kHIDUsage_BS_Level2,//?
	kHIDUsage_BS_ChargerSpec,//?
	kHIDUsage_BS_ChargerSelectorSupport,//?
	kHIDUsage_BS_ACPresent,//?
	kHIDUsage_BS_ResetToZero,//?
	kHIDUsage_BS_CapacityGranularity1,//?
	kHIDUsage_BS_PowerFail,//?
	kHIDUsage_BS_PrimaryBatterySupport,//?
	kHIDUsage_BS_Rechargable,//?
	kHIDUsage_BS_CapacityGranularity2,//?
	kHIDUsage_BS_iOEMInformation,//?
	kHIDUsage_BS_MasterMode,//?
	kHIDUsage_BS_VoltageOutOfRange,//?
	kHIDUsage_BS_CurrentOutOfRange,//?
	kHIDUsage_BS_CurrentNotRegulated,//?
	kHIDUsage_BS_VoltageNotRegulated,//?
	kHIDUsage_BS_ThermistorOverRange,//?
	kHIDUsage_BS_iManufacturerName,//?
	kHIDUsage_BS_iDevicename,//?
	kHIDUsage_BS_InhibitCharge,//?
	kHIDUsage_BS_InternalChargeController,//?
	kHIDUsage_BS_SerialNumber,//?
	kHIDUsage_BS_iDeviceChemistry,//?
	kHIDUsage_BS_ManufacturerData,//?
	kHIDUsage_BS_WarningCapacityLimit,//?
	kHIDUsage_BS_RunTimeToEmpty,//?
	kHIDUsage_BS_AverageTimeToEmpty,//?
	kHIDUsage_BS_FullChargeCapacity,//?
	kHIDUsage_BS_AverageTimeToFull,//?
	kHIDUsage_BS_AlarmInhibited,//?
	kHIDUsage_BS_ThermistorUnderRange,//?
	kHIDUsage_BS_ThermistorHot,//?
	kHIDUsage_BS_ThermistorCold,//?
	kHIDUsage_BS_BatteryPresent,//?
	kHIDUsage_BS_EnablePolling,//?
	kHIDUsage_BS_RelativeStateOfCharge,//?
	kHIDUsage_BS_AbsoluteStateOfCharge,//?
	kHIDUsage_BS_RemainingCapacity,//?
	kHIDUsage_BS_SMBErrorCode,//?
	kHIDUsage_BS_SpecificationInfo,//?
	kHIDUsage_BS_ManufacturerDate,//?
	kHIDUsage_BS_DesignCapacity,//?
	kHIDUsage_BS_BattPackModelLevel,//?
	kHIDUsage_BS_CycleCount,//?
	kHIDUsage_BS_AverageCurrent,//?
	kHIDUsage_BS_Maxerror,//?
	kHIDUsage_BS_AtRateTimeToEmpty,//?
	kHIDUsage_BS_AtRateTimeToFull,//?
	kHIDUsage_BS_NeedReplacement,//?
	kHIDUsage_BS_AtRateOK,//?
	kHIDUsage_BS_ConditioningFlag,//?
	kHIDUsage_BS_FullyDischarged,//?
	kHIDUsage_BS_FullyCharged,//?
	kHIDUsage_BS_Discharging,//?
	kHIDUsage_BS_Charging,//?
	kHIDUsage_BS_RemainingTimeLimitExpired,//?
	kHIDUsage_BS_BelowRemainingCapacityLimit,//?
	kHIDUsage_BS_TerminateDischarge,//?
	kHIDUsage_BS_TerminateCharge,//?
	kHIDUsage_BS_ChargeController,//?
	kHIDUsage_BS_PrimaryBattery,//?,
	kHIDUsage_BS_BroadcastToCharger,//?
	kHIDUsage_BS_CapacityMode,//?
	kHIDUsage_BS_AtRate,//?
	kHIDUsage_BS_RemainingTimeLimit,//?
	kHIDUsage_BS_RemainingCapacityLimit,//?
	kHIDUsage_BS_BatterySupported,//?
	kHIDUsage_BS_SMBSelectorPresets,//?
	kHIDUsage_BS_ManufacturerAccess,//?
	kHIDUsage_BS_ChargingIndicator,//?
	kHIDUsage_BS_SelectorRevision,//?
	kHIDUsage_BS_OKToUse,//?
	kHIDUsage_GD_ByteCount,//?
	kHIDUsage_PID_ET_CustomForceData,//?
	kHIDUsage_GD_MotionWakeup,//?
	kHIDUsage_GD_Start,//?
	kHIDUsage_GD_Vx,//?
	kHIDUsage_GD_Vy,//?
	kHIDUsage_BS_Usenext,//?
	kHIDUsage_BS_BatteryInsertion,//?
	kHIDUsage_BS_ChargerConnection,//?
	kHIDUsage_BS_OutputConnection,//?
	kHIDUsage_BS_ConnectionToSMBus,//?
	kHIDUsage_BS_OptionalMfgFunction5,//?
	kHIDUsage_BS_OptionalMfgFunction4,//?
	kHIDUsage_BS_SMBBatteryStatus,//?
	kHIDUsage_BS_SMBBatteryMode,//?
	kHIDUsage_PD_Tested,//?
	kHIDUsage_BS_OptionalMfgFunction3,//?
	kHIDUsage_BS_OptionalMfgFunction2,//?
	kHIDUsage_PD_Buck,//?
	kHIDUsage_PD_Switchable,//?
	kHIDUsage_BS_OptionalMfgFunction1,//?
	kHIDUsage_BS_SMBSelectorInfo,//?
	kHIDUsage_BS_SMBChargerMode,//?
	kHIDUsage_BS_SMBAlarmWarning,//?
	kHIDUsage_BS_SMBSelectorState,//?
	kHIDUsage_PD_Boost,//?
	kHIDUsage_PD_Used,//?
	kHIDUsage_PD_SwitchOnOff,//?
	kHIDUsage_BS_SMBChargerSpecInfo,//?
	kHIDUsage_BS_SMBChargerStatus,//?
	kHIDUsage_BS_Undefined,//?
	kHIDPage_BatterySystem,//?
	kHIDUsage_PD_iserialNumber,//?
	kHIDUsage_PD_iProduct,//?
	kHIDUsage_PD_iManufacturer,//?
	kHIDUsage_PD_CommunicationLost,//?
	kHIDUsage_PD_AwaitingPower,//?
	kHIDUsage_PD_Initialized,//?
	kHIDUsage_PD_ShutdownImminent,//?
	kHIDUsage_PD_ShutdownRequested,//?
	kHIDUsage_PD_OverTemperature,//?
	kHIDUsage_PD_OverCharged,//?
	kHIDUsage_PD_Overload,//?
	kHIDUsage_PD_FrequencyOutOfRange,//?
	kHIDUsage_PD_VoltageOutOfRange,//?
	kHIDUsage_PD_InternalFailure,//?
	kHIDUsage_PD_Good,//?
	kHIDUsage_PD_Present,//?
	kHIDUsage_PD_AudibleAlarmControl,//?
	kHIDUsage_PD_ModuleReset,//?
	kHIDUsage_PD_Test,//?
	kHIDUsage_PD_DelayBeforeShutdown,//?
	kHIDUsage_PD_DelayBeforeStartup,//?
	kHIDUsage_PD_DelayBeforeReboot,//?
	kHIDUsage_PD_HighVoltageTransfer,//?
	kHIDUsage_PD_LowVoltageTransfer,//?
	kHIDUsage_PD_ToggleControl,//?
	kHIDUsage_PD_SwitchOffControl,//?
	kHIDUsage_PD_SwitchOnControl,//?
	kHIDUsage_PD_ConfigHumidity,//?
	kHIDUsage_PD_ConfigTemperature,//?
	kHIDUsage_PD_ConfigPercentLoad,//?
	kHIDUsage_PD_ConfigActivePower,//?
	kHIDUsage_PD_ConfigFrequency,//?
	kHIDUsage_GD_Vz,//?
	kHIDUsage_PD_ConfigCurrent,//?
	kHIDUsage_PD_ConfigVoltage,//?
	kHIDUsage_PD_BadCount,//?
	kHIDUsage_PD_Humidity,//?
	kHIDUsage_PD_Temperature,//?
	kHIDUsage_PD_PercentLoad,//?
	kHIDUsage_PD_ActivePower,//?
	kHIDUsage_PD_ApparentPower,//?
	kHIDUsage_PD_Frequency,//?
	kHIDUsage_PD_Current,//?
	kHIDUsage_PD_Voltage,//?
	kHIDUsage_PD_PowerSummaryID,//?
	kHIDUsage_PD_PowerSummary,//?
	kHIDUsage_PD_GangID,//?
	kHIDUsage_PD_Gang,//?
	kHIDUsage_PD_OutletID,//?
	kHIDUsage_PD_Outlet,//?
	kHIDUsage_PD_FlowID,//?
	kHIDUsage_PD_Flow,//?
	kHIDUsage_PD_OutputID,//?
	kHIDUsage_PD_Output,//?
	kHIDUsage_PD_InputID,//?
	kHIDUsage_PD_Input,//?
	kHIDUsage_PD_OutletSystemID,//?
	kHIDUsage_PD_OutletSystem,//?
	kHIDUsage_PD_BatteryID,//?
	kHIDUsage_GD_SystemPowerDown,//?
	kHIDUsage_PD_ChargerID,//?
	kHIDUsage_PD_PowerSupply,//?
	kHIDPage_Unicode,//?
	kHIDUsage_PID_ParameterBlockSize,//?
	kHIDUsage_PD_Charger,//?
	kHIDUsage_PID_RAM_PoolAvailable,//?
	kHIDUsage_PID_DC_DeviceContinue,//?
	kHIDUsage_PID_DC_DevicePause,//?,
	kHIDUsage_PD_PresentStatus,//?
	kHIDUsage_PID_DeviceManagedPool,//?
	kHIDUsage_PID_DC_DeviceReset,//?
	kHIDUsage_PID_DeviceControl,//?
	kHIDUsage_PID_DeviceControlReport,//?
	kHIDUsage_PD_BatterySystem,//?
	kHIDUsage_PID_ActuatorsEnabled,//?
	kHIDUsage_PID_DC_DisableActuators,//?
	kHIDUsage_PID_TypeSpecificBlockHandle,//?
	kHIDUsage_PID_BlockFreeReport,//?
	kHIDUsage_PD_PowerConverterID,//?
	kHIDUsage_PID_ActuatorOverrideSwitch,//?
	kHIDUsage_PID_SafetySwitch,//?
	kHIDUsage_PID_EffectPlaying,//?
	kHIDUsage_PID_StateReport,//?
	kHIDUsage_PID_BlockLoadError,//?
	kHIDUsage_PID_StartDelay,//?
	kHIDUsage_PID_BlockLoadReport,//?
	kHIDUsage_PID_PoolAlignment,//?
	kHIDUsage_PID_DC_EnableActuators,//?
	kHIDUsage_PID_PoolMoveReport,//?
	kHIDUsage_PID_SimultaneousEffectsMax,//?
	kHIDUsage_PID_ROM_EffectBlockCount,//?
	kHIDUsage_PID_SharedParameterBlocks,//?
	kHIDUsage_GD_Vbrx,//?
	kHIDUsage_GD_Vbry,//?
	kHIDUsage_GD_SystemMenuUp,//?
	kHIDPage_VR,//?
	kHIDPage_Sport,//?
	kHIDUsage_PID_SetEffectReport,//?
	kHIDPage_PowerDevice,//?
	kHIDUsage_PD_Undefined,//?
	kHIDUsage_PD_iName,//?
	kHIDUsage_PD_ChangedStatus,//?
	kHIDUsage_PD_UPS,//?
	kHIDUsage_PD_BatterySystemID,//?
	kHIDUsage_PD_Battery,//?
	kHIDUsage_PID_DeviceGainReport,//?
	kHIDUsage_PID_LoopCount,//?
	kHIDUsage_PID_RampStart,//?
	kHIDUsage_PID_SetRampForceReport,//?
	kHIDUsage_PID_SetConstantForceReport,//?
	kHIDUsage_PID_Phase,//?
	kHIDUsage_PID_BlockType,//?
	kHIDUsage_PID_SetEnvelopeReport,//?
	kHIDUsage_PID_AttackLevel,//?
	kHIDUsage_PID_AttackTime,//?
	kHIDUsage_PID_FadeLevel,//?
	kHIDUsage_PID_FadeTime,//?
	kHIDUsage_PID_CP_Offset,//?
	kHIDUsage_LED_SystemSuspend,//?
	kHIDUsage_LED_GenericIndicator,//?
	kHIDUsage_LED_IndicatorAmber,//?
	kHIDUsage_LED_IndicatorGreen,//?
	kHIDUsage_LED_IndicatorRed,//?
	kHIDPage_LEDs,//?
	kHIDUsage_PID_SetConditionReport,//?
	kHIDUsage_PID_TypeSpecificBlockOffset,//?
	kHIDUsage_PID_Direction,//?
	kHIDUsage_GD_SystemMenuDown,//?
	kHIDUsage_GD_SystemMenuLeft,//?
	kHIDUsage_PID_ET_Ramp,//?
	kHIDUsage_PID_ET_ConstantForce,//?
	kHIDUsage_PID_EffectType,//?
	kHIDUsage_GD_DPadUp,//?
	kHIDUsage_GD_Vno,//?
	kHIDUsage_PID_DirectionEnable,//?
	kHIDUsage_PID_PositiveCoefficient,//?
	kHIDUsage_PID_NegativeCoefficient,//?
	kHIDUsage_PID_PositiveSaturation,//?
	kHIDUsage_PID_NegativeSaturation,//?
	kHIDUsage_PID_DeadBand,//?
	kHIDUsage_PID_DownloadForceSample,//?
	kHIDUsage_PID_IsochCustomForceEnable,//?
	kHIDUsage_PID_CustomForceDataReport,//?
	kHIDUsage_PID_CustomForceData,//?
	kHIDUsage_PID_SetCustomForceReport,//?
	kHIDUsage_PID_CustomForceDataOffset,//?
	kHIDUsage_PID_SampleCount,//?
	kHIDUsage_PID_SetPeriodicReport,//?
	kHIDUsage_PID_Offset,//?
	kHIDUsage_PID_Normal,//?
	kHIDUsage_PID_PhysicalInterfaceDevice,//?
	kHIDUsage_PID_BlockHandle,//?
	kHIDUsage_PID_BlockLoadStatus,//?
	kHIDUsage_PID_BlockLoadSuccess,//?
	kHIDUsage_PID_BlockLoadFull,//?
	kHIDUsage_PID_DC_StopAllEffects,//?
	kHIDUsage_PID_DevicePaused,//?
	kHIDUsage_PID_ActuatorPower,//?
	kHIDUsage_PID_CreateNewEffectReport,//?
	kHIDUsage_GD_Vbrz,//?
	kHIDUsage_GD_SystemSleep,//?
	kHIDUsage_GD_SystemWakeUp,//?
	kHIDUsage_GD_SystemContextMenu,//?
	kHIDUsage_GD_SystemMainMenu,//?
	kHIDUsage_GD_SystemAppMenu,//?
	kHIDUsage_GD_SystemMenuHelp,//?
	kHIDUsage_GD_SystemMenuExit,//?
	kHIDPage_Ordinal,//?
	kHIDUsage_PID_MoveSource,//?
	kHIDUsage_PID_MoveDestination,//?
	kHIDUsage_PID_Magnitude,//?
	kHIDUsage_PID_Period,//?
	kHIDUsage_PID_RampEnd,//?
	kHIDUsage_PID_OpEffectStartSolo,//?
	kHIDUsage_GD_SystemControl,//?
	kHIDUsage_GD_SystemMenu,//?
	kHIDUsage_GD_SystemMenuRight,//?
	kHIDUsage_GD_DPadRight,//?
	kHIDUsage_GD_DPadLeft,//?
	kHIDUsage_GD_Reserved,//?
	kHIDPage_Simulation,//?
	kHIDPage_Game,//?
	kHIDPage_KeyboardOrKeypad,//?
	kHIDUsage_LED_ExternalPowerConnected,//?
	kHIDPage_Telephony,//?
	kHIDPage_Consumer,//?
	kHIDPage_Digitizer,//?
	kHIDUsage_PID_EffectBlockIndex,//?
	kHIDUsage_PID_OpEffectStop,//?
	kHIDUsage_PID_ParamBlockOffset,//?
	kHIDUsage_PID_TriggerButton,//?
	kHIDUsage_PID_MoveLength,//?
	kHIDUsage_PID_ROM_PoolSize,//?
	kHIDUsage_PID_RAM_PoolSize,//?,
	kHIDUsage_PID_PoolReport,//?
	kHIDUsage_PID_DeviceGain,//?
	kHIDUsage_PID_OpEffectStart,//?
	kHIDUsage_PID_EffectOperation,//?
	kHIDUsage_GD_DPadDown,//?
	kHIDUsage_PID_ET_Damper,//?
	kHIDUsage_PID_ET_Inertia,//?
	kHIDUsage_PID_ET_Friction,//?
	kHIDUsage_PID_Duration,//?
	kHIDUsage_PID_SamplePeriod,//?
	kHIDUsage_PID_Gain,//?
	kHIDUsage_PID_TriggerRepeatInterval,//?
	kHIDUsage_PID_AxesEnable,//?
	kHIDUsage_PID_EffectOperationReport,//?
	kHIDUsage_PID_CustomForceVendorDefinedData,//?
	kHIDUsage_PID_ROM_Flag,//?
	kHIDUsage_PID_ET_Square,//?
	kHIDUsage_PID_ET_Sine,//?
	kHIDUsage_PID_ET_Triangle,//?
	kHIDUsage_PID_ET_Spring,//?
	kHIDUsage_PID_ET_SawtoothDown,//?
	kHIDUsage_PID_ET_SawtoothUp,//?
	kHIDUsage_Button_1,//?
	kHIDUsage_Button_2,//?
	kHIDUsage_Button_3,//?
};

#endif//HYS_IOKIT_HID_IOHIDUSAGETABLES_H
