#ifndef HYS_IOKIT_HIDSYSTEM_IOHIDSHARED_H
#define HYS_IOKIT_HIDSYSTEM_IOHIDSHARED_H

#define kIOHIDSystemClass "kIOHIDSystemClass"//?

#define EV_SPECIAL_KEY_MSG_ID 1//?
#define LLEQSIZE 2//?
#define MAXPRESSURE 3//?
#define MINPRESSURE 4//?

enum {
	kIOHIDEventQueueTypeUser,//?
	kIOHIDEventQueueTypeKernel,//?
	kIOHIDGlobalMemory,//?
	kIOHIDEventNotification,//?
	kIOHIDServerConnectType,//?
	kIOHIDParamConnectType,//?
	kIOHIDCurrentShmemVersion,//?
	kIOHIDEventSystemConnectType,//?
};

struct _NXEQElStruct {
	NXEvent event;//c
	int sema;//?
	int next;//?
};
typedef struct _NXEQElStruct  NXEQElement;

struct _evGlobals {
	IOGPoint cursorLoc;//c
	int frame;//?
	int lastFrame;//?
	int version;//?
	int structSize;//?
	int waitCursorEnabled;//?
	int globalWaitCursorEnabled;//?
	int waitThreshold;//?
	int buttons;//?
	int eNum;//?
	int eventFlags;//?
 	int dontCoalesce;//?
	int VertRetraceClock;//?
	int dontWantCoalesce;//?
	int wantPressure;//?
	int wantPrecision;//?
	int mouseRectValid;//?
	int movedMask;//?
	int cursorSema;//?
	ev_lock_data_t waitCursorSema;//c
	NXEQElement lleq[1];//?
	int LLELast;//?
	int LLEHead;//?
	int LLETail;//?
	int AALastEventSent;//?
	int AALastEventConsumed;//?
	int ctxtTimedOut;//?
	int waitCursorUp;//?
	IOGBounds mouseRect;//c
};
typedef volatile struct _evGlobals EvGlobals;

struct MasterAudioFunctions {};
typedef struct MasterAudioFunctions MasterAudioFunctions;

struct _evOffsets {
	int evGlobalsOffset;//?
	int evShmemOffset;//?
};
typedef volatile struct _evOffsets  EvOffsets;

struct evioSpecialKeyMsg {
	mach_msg_header_t Head;//?
	int key;//?
	int direction;//?
	int flags;//?
	int level;//?
};
typedef struct evioSpecialKeyMsg *evioSpecialKeyMsg_t;

struct evioLLEvent {
	int type;//?
	NXEventData data;//c
	int setCursor;//?
	IOGPoint location;//c
	int setFlags;//?
 	int flags;//?
};
typedef struct evioLLEvent _NXLLEvent;

#endif //HYS_IOKIT_HIDSYSTEM_IOHIDSHARED_H
