#ifndef HYS_IOKIT_IOHIDSYSTEM_IOHIDSYSTEM_H
#define HYS_IOKIT_IOHIDSYSTEM_IOHIDSYSTEM_H

#define kIOHIDSystem508MouseClickMessage 1//?
#define kIOHIDSystem508SpecialKeyDownMessage 2//?

class IOHIDSystem_HYS
{
	OSDeclareDefaultStructors(IOHIDSystem_HYS);

public://data

IOBufferMemoryDescriptor *  globalMemory;//c
IOService * displayManager;//c

int serverConnect;//?

public://func

int setParamProperties(OSDictionary* a);//?
int evClose();//?
int setEventPort(int a);//?
int registerScreen(IOGraphicsDevice *a, Bounds * b);//?
int createShmem(int a,int b,int c,int d,int e,int f);//?
int setEventsEnable(int a,int b,int c,int d,int e,int f);//?
int setCursorEnable(int a,int b,int c,int d,int e,int f);//?
int extPostEvent(int a,int b,int c,int d,int e,int f);//?
int extSetMouseLocation(int a,int b,int c,int d,int e,int f);//?
int extGetButtonEventNum(int a,int b,int c,int d,int e,int f);//?
int extSetBounds(int a);//?
int setStackShotPort(int a);//?
int registerEventQueue(IODataQueue * a);//?
int unregisterEventQueue(IODataQueue* a);//?

};

#endif//HYS_IOKIT_IOHIDSYSTEM_IOHIDSYSTEM_H
