#ifndef HYS_IOKIT_HIDSYSTEM_IOHISTYPES_H
#define HYS_IOKIT_HIDSYSTEM_IOHISTYPES_H

#define NX_EVS_DEVICE_INFO "NX_EVS_DEVICE_INFO"//?

#define NX_EVS_DEVICE_INTERFACE_ADB 1//
#define kAppleOnboardGUID 2//?
#define EV_MAXPRESSURE 3//?
#define EV_TICKS_PER_SEC 4//?
#define EV_RB 5//?
#define EV_TICK_TIME 6//?
#define EV_LB 7//?
#define __OLD_NX_EVS_DEVICE_INFO 8//?

enum {
	EVMOVE,//?
	EVSHOW,//?
	EVHIDE,//?
	EVLEVEL,//?
	EVNOP,//?
	NX_LeftButton,//?
	NX_RightButton,//?
	NX_OneButton,//?
};

struct NXEventSystemDevice {
	int dev_type;//?
	int interface;//?
	int id;//?
	int interface_addr;//?
};
typedef struct NXEventSystemDevice NXEventSystemDevice;

struct evsioKeymapping {
	int mapping;//?
	int size;//?
};
typedef struct evsioKeymapping NXKeyMapping;

struct evsioMouseScaling {
	int numScaleLevels;//?
	int scaleThresholds[1];//?
	int scaleFactors[1];//?
};
typedef struct evsioMouseScaling NXMouseScaling;

typedef int EvCmd;//?
typedef int NXMouseButton;//?
typedef int NXEventSystemInfoType;//?

#endif//HYS_IOKIT_HIDSYSTEM_IOHISTYPES_H
