#ifndef HYS_IOKIT_HIDSYSTEM_IOHIDEVICE_H
#define HYS_IOKIT_HIDSYSTEM_IOHIDEVICE_H

enum {
	kHIKeyboardDevice,//?
	kHIRelativePointingDevice,//?
	kHIUnknownDevice,//?
};

typedef int IOHIDKind;//?

class  IOHIDevice_HYS
{
  OSDeclareDefaultStructors(IOHIDevice_HYS);

public://define

#define IOHIDevice_setProperties \
IOReturn  setProperties( OSObject * a);//?

#define IOHIDevice_getGUID \
UInt64    getGUID();//?

#define IOHIDevice_open \
bool open(  IOService *a, IOOptionBits b = 0, void *c = 0 );//?

#define IOHIDevice_free \
void free();//?

#define IOHIDevice_start \
bool start(IOService * a);//?

#define IOHIDevice_init \
bool init(OSDictionary *a = 0);//?

#define IOHIDevice_deviceType \
UInt32    deviceType();//?

#define IOHIDevice_setParamProperties \
IOReturn  setParamProperties(OSDictionary *a);//?

#define IOHIDevice_hidKind   \
IOHIDKind hidKind();//?

#define IOHIDevice_interfaceID \
UInt32    interfaceID();//?

#define IOHIDevice_updateProperties \
bool 	    updateProperties(void);//?

};

#endif//HYS_IOKIT_HIDSYSTEM_IOHIDEVICE_H

