#ifndef HYS_IOKIT_HIDSYSTEM_IOHIDKEYBOARD_H
#define HYS_IOKIT_HIDSYSTEM_IOHIDKEYBOARD_H

typedef void (*KeyboardEventCallback)(OSObject *a, unsigned b, unsigned c, unsigned d, unsigned  e, unsigned f, unsigned g, unsigned  h, unsigned  i, bool j, AbsoluteTime k, OSObject *l, void *m);//c

typedef void (*KeyboardSpecialEventCallback)(OSObject *a, unsigned b, unsigned c, unsigned d, unsigned e, UInt64 f, bool g, AbsoluteTime h, OSObject *i, void *j);//c

typedef void (*UpdateEventFlagsCallback)(OSObject *a, unsigned b, OSObject *c, void *     d);//c

typedef int KeyboardEventAction;//?
typedef int KeyboardSpecialEventAction;//?
typedef int UpdateEventFlagsAction;//?

class IOHIKeyboard_HYS
{
    OSDeclareDefaultStructors(IOHIKeyboard_HYS);

public:

int  *_keyboardEventTarget;//?
int  * _keyState;//?
int _codeToRepeat;//?

int doesKeyLock(unsigned int a);//?
int setDeviceFlags(unsigned int a);//?
int deviceFlags();//?
int dispatchKeyboardEvent(unsigned int , bool, AbsoluteTime);//?
int open(IOService* a, IOOptionBits b,KeyboardEventAction c, KeyboardSpecialEventAction d, UpdateEventFlagsAction e);//?

int keyboardEvent(unsigned int a, unsigned int b , unsigned int c, unsigned int d, unsigned int e, unsigned int f , unsigned int g);//?;

void  keyboardSpecialEvent(unsigned int a, unsigned int b, unsigned int c, unsigned int);//?

int open(IOService *a, IOOptionBits	b, void *c, KeyboardEventCallback d, KeyboardSpecialEventCallback e, UpdateEventFlagsCallback f);//?

int alphaLock();//?
int eventFlags();//?
int setAlphaLock(int a);//?
int setNumLock(int a);//?
int updateEventFlags(int a);//?
int setCharKeyActive(int a);//?
int numLock();//?
int getLEDStatus();//?
int isRepeat();//?

};

#endif//HYS_IOKIT_HIDSYSTEM_IOHIDKEYBOARD_H
