#ifndef HYS_IOKIT_HIDSYSTEM_IOLLEVENMT_H
#define HYS_IOKIT_HIDSYSTEM_IOLLEVENMT_H

#define _NXSize_	NXSize //c
//////////////
#define EventCodeMask(a) a//?
///////////////////
#define NX_NULLEVENT 1//?
#define NX_SECONDARYFNMASK 2//?
#define NX_SYSDEFINED 3//?
#define NX_SUBTYPE_STICKYKEYS_FN_UP 4//?
#define NX_SUBTYPE_STICKYKEYS_FN_LOCK 5//?
#define NX_SUBTYPE_STICKYKEYS_FN_DOWN 6//?
#define NX_RMOUSEDRAGGEDMASK 7//?
#define NX_SUBTYPE_TABLET_PROXIMITY 8//?
#define NX_SCROLLWHEELMOVED 9//?
#define NX_FLAGSCHANGED 10//?
#define NX_SUBTYPE_TABLET_POINT 11//?
#define NX_TABLETPOINTER 12//?
#define NX_KEYDOWN 13//?
#define NX_UNDIMMASK 14//?
#define NX_LMOUSEDOWN 15//?
#define NX_RMOUSEDOWN 16//?
#define NX_LMOUSEUP 17//?
#define NX_RMOUSEUP 18//?
#define NX_TABLET_CAPABILITY_DEVICEIDMASK 19//?
#define NX_TABLET_CAPABILITY_ABSYMASK 20//?
#define NX_SUBTYPE_HIDPARAMETER_MODIFIED 21//?
#define NX_FLAGSCHANGEDMASK 22//?
#define NX_SCROLLWHEELMOVEDMASK 23//?
#define NX_KEYUP 24//?
#define NX_TABLET_CAPABILITY_ABSXMASK 25//?
#define NX_TABLET_CAPABILITY_BUTTONSMASK 26//?
#define NX_TABLET_CAPABILITY_PRESSUREMASK 27//?
#define NX_TABLET_POINTER_PEN 28//?
#define NX_STYLUSPROXIMITYMASK 29//?
#define NX_SUBTYPE_DEFAULT 30//?
#define NX_COMMANDMASK 31//?
#define NX_TABLETPROXIMITY 32//?
#define NX_ZOOM 33//?
#define NX_CONTROLMASK 34//?
#define NX_SHIFTMASK 35//?
#define NX_ALTERNATEMASK 36//?
#define NX_SYMBOLSET 37//?
#define NX_SUBTYPE_POWER_KEY 38//?
#define NX_SUBTYPE_SLEEP_EVENT 39//?
#define NX_SUBTYPE_SHUTDOWN_EVENT 40//?
#define NX_SUBTYPE_RESTART_EVENT 41//?
#define NX_SUBTYPE_EJECT_KEY 42//?
#define NX_SUBTYPE_AUX_CONTROL_BUTTONS 43//?
#define NX_SUBTYPE_AUX_MOUSE_BUTTONS 44//?
#define NX_NONCOALSESCEDMASK 45//?
#define NX_LMOUSEDRAGGEDMASK 46//?
#define NX_LMOUSEDRAGGED 47//?
#define NX_RMOUSEDRAGGED 48//?
#define NX_MOUSEMOVEDMASK 49//?
#define NX_MOUSEMOVED 50//?
#define NX_MOUSEEXITED 51//?
#define NX_LMOUSEDOWNMASK 52//?
#define NX_RMOUSEDOWNMASK 53//?
#define NX_LMOUSEUPMASK 54//?
#define NX_RMOUSEUPMASK 55//?
#define NX_KEYDOWNMASK 56//?
#define NX_KEYUPMASK 57//?
#define NX_OMOUSEDOWN 58//?
#define NX_OMOUSEUP 59//?
#define NX_OMOUSEDRAGGED 60//?
#define NX_DEVICELCTLKEYMASK 61//?
#define NX_DEVICELSHIFTKEYMASK 62//?
#define NX_DEVICELALTKEYMASK 63//?
#define NX_DEVICELCMDKEYMASK 64//?
#define NX_DEVICERCTLKEYMASK 65//?
#define NX_DEVICERSHIFTKEYMASK 66//?
#define NX_DEVICERALTKEYMASK 67//?
#define NX_DEVICERCMDKEYMASK 68//?
#define NX_TABLET_POINTER_CURSOR 69//?
#define NX_TABLET_CAPABILITY_TILTXMASK 70//?
#define NX_TABLET_CAPABILITY_TILTYMASK 71//?
#define NX_TABLET_POINTER_UNKNOWN 72//?
#define NX_TABLET_CAPABILITY_TANGENTIALPRESSUREMASK 73//?
#define NX_TABLET_CAPABILITY_ROTATIONMASK 74//?
#define NX_TABLET_POINTER_ERASER 75//?
#define NX_TABLET_CAPABILITY_ABSZMASK 76//?
#define NX_ALPHASHIFTMASK 77//?
#define NX_NUMERICPADMASK 78//?
#define NX_SUBTYPE_STICKYKEYS_OFF 79//?
#define NX_SUBTYPE_STICKYKEYS_SHIFT_LOCK 80//?
#define NX_SUBTYPE_STICKYKEYS_ALTERNATE_LOCK 81//?
#define NX_SUBTYPE_STICKYKEYS_COMMAND_LOCK 82//?
#define NX_SUBTYPE_STICKYKEYS_CONTROL_UP 83//?
#define NX_SUBTYPE_STICKYKEYS_ALTERNATE_DOWN 84//?
#define NX_SUBTYPE_SLOWKEYS_END 85//?
#define NX_SUBTYPE_STICKYKEYS_SHIFT_UP 86//?
#define NX_SUBTYPE_STICKYKEYS_ALTERNATE_UP 87//?
#define NX_SUBTYPE_STICKYKEYS_COMMAND_UP 88//?
#define NX_SUBTYPE_STICKYKEYS_CONTROL_LOCK 89//?
#define NX_SUBTYPE_STICKYKEYS_SHIFT_DOWN 90//?
#define NX_SUBTYPE_STICKYKEYS_CONTROL_DOWN 91//?
#define NX_SUBTYPE_STICKYKEYS_COMMAND_DOWN 92//?
#define NX_SUBTYPE_STICKYKEYS_TOGGLEMOUSEDRIVING 93//?
#define NX_SUBTYPE_STICKYKEYS_ON 94//?
#define NX_SUBTYPE_SLOWKEYS_START 95//?
#define NX_SUBTYPE_SLOWKEYS_ABORT 96//?
#define NX_SUBTYPE_STICKYKEYS_RELEASE 97//?
#define NX_ASCIISET 98//?

struct _NXTabletPointData {
	int pressure;//?
};
typedef struct _NXTabletPointData NXTabletPointData, *NXTabletPointDataPtr;

union NXEventData {
	struct {
		int eventNum;//?
		int click;//?
		int subType;//?
		int subx;//?
		int suby;//?
		int pressure;//?
		union {
 			NXTabletPointData point;//c
			int proximity;//?
		}  tablet;
	} mouse;//?

	 struct {
		int enterProximity;//?
		int capabilityMask;//?
		int pointerType;//?
		int systemTabletID;//?
		int deviceID;//?
	} proximity;

	struct {
		int deviceID;//?
		int buttons;//?
		int x;//?
		int y;//?
		int pressure;//?
	} tablet;

	struct {
		int deltaAxis1;//?
		int deltaAxis2;//?
		int deltaAxis3;//?
		int fixedDeltaAxis1;//?
		int fixedDeltaAxis2;//?
		int fixedDeltaAxis3;//?
		int pointDeltaAxis1;//?
		int pointDeltaAxis2;//?
		int pointDeltaAxis3;//?
		int reserved1;//?
	}scrollWheel;

	struct {
		int repeat;//?
		int keyCode;//?
		int charSet;//?
		int charCode;//?
		int origCharSet;//?
		int origCharCode;//?
		int keyboardType;//?
	} key;
	
	struct {
		int subType;//?
		int reserved;//?
		union {
			int L[1];//?
		} misc;
	} compound;

	struct {
		int dx;//?
		int dy;//?
		int subType;//?
		int subx;//?
		int suby;//?
		int reserved1;//?
		union {
			int proximity;//?
 			NXTabletPointData  point;//c
		} tablet;
	} mouseMove;
};
typedef union NXEventData NXEventData;//?

struct _NXEvent {
	int type;//?
	unsigned long long time;//c
	int flags;//?
	NXEventData data;//c
	int service_id;//?
	int ext_pid;//?
	int window;//?

	struct {
		int x;//c
		int y;//c
	} location;
};
typedef struct _NXEvent  NXEvent, *NXEventPtr;

struct _NXTabletProximityData {};
typedef struct _NXTabletProximityData NXTabletProximityData, *NXTabletProximityDataPtr;

struct _NXSize {
	int width;//?
	int height;//?
};
typedef struct _NXSize  NXSize;

#endif//HYS_IOKIT_HIDSYSTEM_IOLLEVENMT_H

