#ifndef HYS_IOKIT_HIDSYSTEM_EV_KEYMAP_H
#define HYS_IOKIT_HIDSYSTEM_EV_KEYMAP_H

#define NX_NUM_SCANNED_SPECIALKEYS 1//? 
#define NX_KEYTYPE_NUM_LOCK 2//?
#define NX_KEYTYPE_SOUND_UP 3//?
#define NX_KEYTYPE_SOUND_DOWN 4//?
#define NX_KEYTYPE_ILLUMINATION_UP 5//?
#define NX_KEYTYPE_MUTE 6//?
#define NX_KEYTYPE_BRIGHTNESS_UP 7//?
#define NX_KEYTYPE_BRIGHTNESS_DOWN 8//?
#define NX_KEYTYPE_ILLUMINATION_DOWN 9//?
#define NX_KEYTYPE_VIDMIRROR 10//?
#define NX_KEYTYPE_EJECT 11//?
#define NX_KEYTYPE_ILLUMINATION_TOGGLE 12//?
#define NX_KEYTYPE_CAPS_LOCK 13//?
#define NX_NOSPECIALKEY 14//?
#define NX_POWER_KEY 15//?
#define NX_KEYTYPE_PLAY 16//?
#define NX_KEYTYPE_NEXT 17//?
#define NX_KEYTYPE_PREVIOUS 18//?
#define NX_KEYTYPE_FAST 19.//?
#define NX_KEYTYPE_REWIND 20//?
#define NX_NUMSPECIALKEYS 21//?
#define NX_KEYTYPE_HELP 22//?
#define NX_UP_ARROW_KEY 23//?
#define NX_DOWN_ARROW_KEY 24//?
#define NX_KEYTYPE_CONTRAST_UP 25//?
#define NX_KEYTYPE_CONTRAST_DOWN	 26//?
#define NX_KEYTYPE_LAUNCH_PANEL 27//?
#define NX_MODIFIERKEY_ALPHALOCK 28//?
#define NX_NUMMODIFIERS 29//?
#define NX_WHICHMODMASK 30//?
#define NX_MODIFIERKEY_RCOMMAND 31//?
#define NX_CHARGENMASK 32//?
#define NX_MODMASK 33//?
#define NX_MODIFIERKEY_SECONDARYFN 34//?
#define NX_NUMKEYCODES 35//?
#define NX_MODIFIERKEY_ALTERNATE 36//?
#define NX_SPECIALKEYMASK 37//?
#define NX_MODIFIERKEY_RSHIFT 38//?
#define NX_MODIFIERKEY_SHIFT 39//?
#define NX_MODIFIERKEY_COMMAND 40//?
#define NX_MODIFIERKEY_NUMLOCK 41//?
#define NX_MODIFIERKEY_RCONTROL 42//?
#define NX_MODIFIERKEY_RALTERNATE 43//?
#define NX_MODIFIERKEY_CONTROL 44//?
#define NX_MODIFIERKEY_NUMERICPAD 45//?

struct _NXParsedKeyMapping_ {
	const unsigned char * mapping;//c
	int mappingLen;//?
	int maxMod;//?
	unsigned char * modDefs[1];//?
	int numDefs;//?
	int keyBits[1];//?
	int numSeqs;//?
	unsigned char * keyDefs[1];//?
	int shorts;//?
	unsigned char* seqDefs[1];//?
 	int specialKeys[1];//?
	int numSpecialKeys;//?
};
typedef struct _NXParsedKeyMapping_  NXParsedKeyMapping;

#endif//HYS_IOKIT_HIDSYSTEM_EV_KEYMAP_H

