#ifndef HYS_IOKIT_KEXT_KXTEXTMANAGER_H
#define HYS_IOKIT_KEXT_KXTEXTMANAGER_H

typedef enum {
	kKXKextManagerErrorNone,//?
	kKXKextManagerErrorFileAccess,//?
	kKXKextManagerErrorDiskFull,//?
	kKXKextManagerErrorChildTask,//?
	kKXKextManagerErrorLoadedVersionDiffers,//?
	kKXKextManagerErrorAlreadyLoaded,//?
	kKXKextManagerErrorLoadKernelComponent,//?
	kKXKextManagerErrorLoadExecutableNoArch,//?
	kKXKextManagerErrorCache,//?
	kKXKextManagerErrorAuthentication,//?
	kKXKextManagerErrorInvalidArgument,//?
	kKXKextManagerErrorUserAbort,//?
	kKXKextManagerErrorUnspecified,//?
	kKXKextManagerErrorLinkLoad,//?
	kKXKextManagerErrorNoMemory,//?
	kKXKextManagerErrorSerialization,//?
	kKXKextManagerErrorKextNotFound,//?
} KXKextManagerError;

///////////////////////////////
#define kKXSystemExtensionsFolder        (CFSTR("/System/Library/Extensions"))//c
///////////////////////////
typedef enum {
    kKXKextManagerLogLevelSilent      = -2,   
    kKXKextManagerLogLevelErrorsOnly  = -1,
    kKXKextManagerLogLevelDefault     = 0,
    kKXKextManagerLogLevelBasic       = 1,
    kKXKextManagerLogLevelLoadBasic   = 2,
    kKXKextManagerLogLevelDetails     = 3,
    kKXKextManagerLogLevelKexts       = 4,
    kKXKextManagerLogLevelKextDetails = 5,
    kKXKextManagerLogLevelLoadDetails = 6
} KXKextManagerLogLevel;//c

typedef struct __KXKextManager * KXKextManagerRef;//c
/////////////////////

#endif//HYS_IOKIT_KEXT_KXTEXTMANAGER_H
