#ifndef HYS_IOKIT_NSETWORK_IOEHERTNETINERFACE_H
#define HYS_IOKIT_NSETWORK_IOEHERTNETINERFACE_H

#define kIOMulticastFilterData   kIOMulticastAddressList //c

//////////////////////

#ifdef __cplusplus
class  IOEthernetInterface_HYS
{
    OSDeclareDefaultStructors( IOEthernetInterface_HYS )

//hys add

int *_arpcom;

/////////

private :

public:


OSDictionary* _requiredFilters;//c
OSDictionary* _activeFilters;//c
OSDictionary* _supportedFilters;//c

int _controllerLostPower;//?
int _ctrEnabled;//?
int _mcAddrCount;//?

public://define

#define IOEthernetInterface_ExpansionData \
    struct ExpansionData {  \
		UInt32 altMTU;	 \
		UInt32 publishedFeatureID;    \
	};

public://func-define

#define IOEthernetInterface_feedPacketOutputTap \
void feedPacketOutputTap(mbuf_t a);//?

#define IOEthernetInterface_feedPacketInputTap \
void feedPacketInputTap(mbuf_t a);//?

#define IOEthernetInterface__fixupVlanPacket \
void _fixupVlanPacket(mbuf_t a, u_int16_t b, int c);//c

#define IOEthernetInterface_attachToDataLinkLayer \
IOReturn attachToDataLinkLayer( IOOptionBits a, void *b);//?

#define IOEthernetInterface_willTerminate \
bool willTerminate( IOService *a, IOOptionBits b);//?

#define IOEthernetInterface_enableFilter_Wrapper \
static IOReturn enableFilter_Wrapper(IOEthernetInterface *a, IONetworkController *b, const OSSymbol *c, UInt32 d, IOOptionBits e);//c

#define IOEthernetInterface_setupMulticastFilter \
IOReturn setupMulticastFilter(IONetworkController * a);//c

#define IOEthernetInterface_enableFilter \
IOReturn enableFilter(IONetworkController *a, const OSSymbol *b, UInt32 c, IOOptionBits d = 0);//c

#define IOEthernetInterface_disableFilter \
IOReturn disableFilter(IONetworkController * a, const OSSymbol *b, UInt32 c, IOOptionBits d = 0);//c

#define IOEthernetInterface_enableController \
IOReturn enableController(IONetworkController * a);//c

#define IOEthernetInterface_syncSIOCSIFLLADDR \
int syncSIOCSIFLLADDR(IONetworkController * a, const char * b, int c);//c

#define IOEthernetInterface_syncSIOCGIFDEVMTU \
 int syncSIOCGIFDEVMTU(IONetworkController * a, struct ifreq * b);//c

#define IOEthernetInterface_syncSIOCSIFMTU \
int syncSIOCSIFMTU(IONetworkController *a, struct ifreq *b, bool c);//c

#define IOEthernetInterface_syncSIOCDELMULTI  \
int syncSIOCDELMULTI(IONetworkController * a);//c

#define IOEthernetInterface_syncSIOCADDMULTI \
int syncSIOCADDMULTI(IONetworkController * a);//c

#define IOEthernetInterface_syncSIOCSIFFLAGS \
int syncSIOCSIFFLAGS(IONetworkController * a);//c

#define IOEthernetInterface_syncSIOCSIFADDR \
int syncSIOCSIFADDR(IONetworkController * a);//c

#define IOEthernetInterface_performGatedCommand \
static int performGatedCommand(void *a, void *b, void *c, void *d, void *e);//c

#define IOEthernetInterface_initIfnetParams \
bool initIfnetParams(struct ifnet_init_params *a);//?

#define IOEthernetInterface_setFilters \
bool setFilters(OSDictionary *a, const OSSymbol *b, UInt32 c);//c

#define IOEthernetInterface_getFilters \
UInt32 getFilters(const OSDictionary *a, const OSSymbol *b);//c

};
#endif //__cplusplus

#endif//HYS_IOKIT_NSETWORK_IOEHERTNETINERFACE_H


