#ifndef HYS_IOKIT_NETWORK_IONETWORKINTERFACE_H
#define HYS_IOKIT_NETWORK_IONETWORKINTERFACE_H

enum {
	kIONetworkEventTypeDLIL,//?
	kIONetworkEventTypeLinkUp,//?
	kIONetworkEventTypeLinkDown,//?
};

#ifdef __cplusplus
class  IONetworkInterface_HYS
{
  //  OSDeclareAbstractStructors( IONetworkInterface_HYS)

public://data



struct ExpansionData {
	int mtu;//c
	int flags;//c
	int addrlen;//c
	int hdrlen;//c
	int eflags;//c
	queue_head_t powerChangeNoticeList;//c
	thread_call_t  powerChangeThreadCall;//c
	IOLock* detachLock;//c
	IOSimpleLock * powerChangeNoticeLock;//c
	IONetworkStats driverStats;//c
	int type;//c
	int unit;//c
	IONetworkStats lastDriverStats;//c
	struct ifnet_stat_increment_param inputDeltas;//c
};

ifnet_t  _backingIfnet;//c
IONetworkController * _controller;//c
IORecursiveLock * _ifLock;//c
OSNumber *  _stateBits;//c
OSSet* _clientSet;//c
OSDictionary * _dataDict;//c
OSObject* _outTarget;//c
IOOutputAction  _outAction;//c
bpf_packet_func  _inputFilterFunc;//c
bpf_packet_func _outputFilterFunc;//c
mbuf_t _inputQHead;//c
mbuf_t  _inputQTail;//c
UInt32                   _inputQCount;//c
UInt32                   _clientVar[4];//c

public://define

#define IONetworkInterface_setExtendedFlags \
bool setExtendedFlags(UInt32 a, UInt32 b = 0);//c

#define IONetworkInterface_willTerminate \
bool willTerminate( IOService *a, IOOptionBits b);//?

#define IONetworkInterface__syncNetworkDataDict \
bool _syncNetworkDataDict();//c

#define IONetworkInterface_serializeProperties \
bool serializeProperties( OSSerialize * a ) const;//?

#define IONetworkInterface__setInterfaceProperty \
bool _setInterfaceProperty(UInt32 a, UInt32  b, UInt32 c, void *d, char *e);//c

#define IONetworkInterface_performGatedCommand \
static int  performGatedCommand(void *a, void *b, void *c, void *d, void *e);//c

#define IONetworkInterface_syncSIOCSIFMEDIA_IONetworkController \
SInt32 syncSIOCGIFMEDIA(IONetworkController * a, struct ifreq * b, UInt32 c);//c

#define IONetworkInterface_syncSIOCSIFMEDIA \
SInt32 syncSIOCSIFMEDIA(IONetworkController * a, struct ifreq * b);//c

#define IONetworkInterface_syncSIOCSIFMTU \
SInt32 syncSIOCSIFMTU(IONetworkController *A, struct ifreq * b);//c

#define IONetworkInterface_DLIL_INPUT \
void DLIL_INPUT(mbuf_t a);//c

#define IONetworkInterface_detach_shim \
static void  detach_shim(ifnet_t a);//c

#define IONetworkInterface_set_bpf_tap_shim \
static errno_t  set_bpf_tap_shim(ifnet_t a, bpf_tap_mode b, bpf_packet_func c);//c

#define IONetworkInterface_ioctl_shim \
static errno_t  ioctl_shim(ifnet_t a, u_int32_t b, void * c);//c

#define IONetworkInterface_output_shim \
static int  output_shim(ifnet_t a, mbuf_t b);//c

#define IONetworkInterface_powerChangeHandler \
static void powerChangeHandler(void *a, void *b, void *c, void *d, void *e);//c

#define IONetworkInterface__syncFromBackingIfnet \
void _syncFromBackingIfnet() const;//c

#define IONetworkInterface__syncToBackingIfnet \
void _syncToBackingIfnet();//c

#define IONetworkInterface_getParameter \
IONetworkData * getParameter(const char * a) const;//c

#define IONetworkInterface_initIfnetParams \
bool initIfnetParams(struct ifnet_init_params *a);//?

public:

};
#endif //__cplusplus
#endif//HYS_IOKIT_NETWORK_IONETWORKINTERFACE_H

