#ifndef HYS_IOKIT_PCCARD_IOCARDBUSDEVICE_H
#define HYS_IOKIT_PCCARD_IOCARDBUSDEVICE_H

class IOCardBusDevice_HYS
{
    OSDeclareDefaultStructors(IOCardBusDevice_HYS);

public://data

client_handle_t handle;//
dev_info_t	 bindName;//c
config_req_t	 configuration;//c

int socket;//?
int function;//?
int state;//?

public://define

#define IOCardBusDevice_matchLocation \
 IOService *		matchLocation(IOService * a);//?

#define IOCardBusDevice_matchPropertyTable \
bool		matchPropertyTable(OSDictionary * a, SInt32 *b);//?

#define IOCardBusDevice_finalize \
bool		finalize(IOOptionBits a);//?

#define IOCardBusDevice_unbindCardServices \
bool		unbindCardServices(void);//?

#define IOCardBusDevice_eventHandler \
 static int	eventHandler(cs_event_t a, int b, event_callback_args_t *c);//c

#define IOCardBusDevice_setProperties \
IOReturn		setProperties(OSObject * a);//?

#define IOCardBusDevice_setPowerState \
IOReturn		setPowerState(unsigned long a, IOService *b);//?

#define IOCardBusDevice_bindCardServices \
bool		bindCardServices(void);//?

};

#endif//HYS_IOKIT_PCCARD_IOCARDBUSDEVICE_H
