#ifndef HYS_IOKIT_PCCARD_SS_H
#define HYS_IOKIT_PCCARD_SS_H

#define MAP_16BIT 1
#define MAP_ACTIVE 2//?
#define MAP_USE_WAIT 3//?
#define MAP_ATTRIB 4//?
#define SS_SetMemMap 5//?
#define SS_READY 6//?
#define MAP_IOSPACE 7//?
#define MAP_PREFETCH 8//?
#define SS_CAP_STATIC_MAP 9//?
#define SS_CAP_PAGE_REGS 10//?
#define SS_DETECT 11//?
#define SS_PENDING 12//?
#define SS_3VCARD 13//?
#define SS_XVCARD 14//?
#define SS_CARDBUS 15//?
#define SS_OUTPUT_ENA 16//?
#define SS_RESET 17//?
#define SS_BATDEAD 18//?
#define SS_BATWARN 19//?
#define SS_WRPROT 20//?
#define SS_IOCARD 21//?
#define SS_DMA_MODE 22//?
#define SS_SPKR_ENA 23//?
#define MAP_AUTOSZ 24//?
#define SS_CAP_MEM_ALIGN 25//?
#define SS_CAP_PCCARD 26//?
#define SS_CAP_CARDBUS 27//?
#define SS_STSCHG 28//?
#define SS_POWERON 29//?
#define SS_PWR_AUTO 30//?
#define MAP_0WS 31//?
#define MAP_WRPROT 32//?

enum {
	SS_GetSocket,//?
	SS_RegisterCallback,//?
	SS_GetStatus,//?
	SS_SetSocket,//?
	SS_SetBridge,//?
	SS_SetIOMap,//?
	SS_InquireSocket,//?
};

struct pccard_mem_map {
    	u_char	map;//c
    	u_char	flags;//c
    	u_short	speed;//c
    	u_long	sys_start;
	u_long sys_stop;//c
    	u_int	card_start;//c
};
typedef struct pccard_mem_map pccard_mem_map;

struct socket_state_t {
	u_int	flags;//c
	u_int	csc_mask;//c
	u_char	Vcc;//c
	u_char  Vpp;//c
 	u_char	io_irq;//c
};
typedef struct socket_state_t socket_state_t;

struct socket_cap_t {
	int cardbus;//?
	IOPCCardBridge* pccard_nub;//c
	IOCardBusDevice* cardbus_nub[1];//?
	int pci_irq;//?
	IOPCIDevice* bridge_nub;//c
 	int features;//?
	struct bus_operations * bus;//c
	int map_size;//?
	int irq_mask;//?
};
typedef struct socket_cap_t socket_cap_t;

struct cb_bridge_map  {
	int map;//?
	int start;//?
	int flags;//?
	int stop;//?
};
typedef struct cb_bridge_map cb_bridge_map;

struct pccard_io_map {
	u_char map;//c
    	u_char	 flags;//c
    	u_short	 speed;//c
    	u_short	 start;// 
	u_short stop;//c
};
typedef struct pccard_io_map pccard_io_map;

struct ss_callback_t {
    	void	(*handler)(void *a, u_int b);//c
    	void	*info;//c
};
typedef struct ss_callback_t ss_callback_t;

#endif//HYS_IOKIT_PCCARD_SS_H
