
#ifndef HYS_IOKIT_PS_IOUPSPLUGIN_H
#define HYS_IOKIT_PS_IOUPSPLUGIN_H

//hys add
//enum {
	//kNilOptions,//IOHIDFamily-IOHIDUPSClass.cpp
//};//MacType define
/////////

#define kIOUPSPlugInTypeID CFUUIDGetConstantUUIDWithBytes(NULL, 	\
    0x40, 0xa5, 0x7a, 0x4e, 0x26, 0xa0, 0x11, 0xd8,			\
    0x92, 0x95, 0x00, 0x0a, 0x95, 0x8a, 0x2c, 0x78)//c

///////////////
#define IOUPSPLUGINBASE							\
    IOReturn (*getProperties)(	void * thisPointer, 			\
                                CFDictionaryRef * properties);		\
    IOReturn (*getCapabilities)(void * thisPointer, 			\
                                CFSetRef * capabilities);		\
    IOReturn (*getEvent)(	void * thisPointer, 			\
                                CFDictionaryRef * event);		\
    IOReturn (*setEventCallback)(void * thisPointer, 			\
                                IOUPSEventCallbackFunction callback,	\
                                void * callbackTarget,  		\
                                void * callbackRefcon);			\
    IOReturn (*sendCommand)(	void * thisPointer, 			\
                                CFDictionaryRef command)
                                
#define IOUPSPLUGIN_V140							\
    IOReturn (*createAsyncEventSource)(void * thisPointer,      \
                                CFTypeRef * source)


struct IOUPSPlugInInterface_v140 {
    IUNKNOWN_C_GUTS;
    IOUPSPLUGINBASE;
    IOUPSPLUGIN_V140;
};
typedef struct IOUPSPlugInInterface_v140 IOUPSPlugInInterface_v140;

typedef struct IOUPSPlugInInterface {
    IUNKNOWN_C_GUTS;
    IOUPSPLUGINBASE;
} IOUPSPlugInInterface;//c

#endif//HYS_IOKIT_PS_IOUPSPLUGIN_H
