#ifndef HYS_IOKIT_PWR_MGT_IOPM_H
#define HYS_IOKIT_PWR_MGT_IOPM_H

//hys add statr

#define kIOPMMessageSystemPowerEventOccurred "kIOPMMessageSystemPowerEventOccurred"

enum {
	kIOPMSetACAdaptorConnected,
};

//hys add endif///////////////
////////////////////////
#define kIOPMMessageFeatureChange                           iokit_family_msg(sub_iokit_powermanagement, 0x110)//c
#define kIOPMMessageBatteryStatusHasChanged         iokit_family_msg(sub_iokit_pmu, 0x100)//c
#define kIOPMMessageInternalBatteryFullyDischarged            iokit_family_msg(sub_iokit_powermanagement, 0x120)//c
#define IOPM_POWER_SOURCE_REV   2//c

//////////////////
#define kIOPMSettingWakeOnRingKey "kIOPMSettingWakeOnRingKey"//?
#define kIOPMSettingDisplaySleepUsesDimKey "kIOPMSettingDisplaySleepUsesDimKey"//?
#define kIOPMSettingDebugWakeRelativeKey "kIOPMSettingDebugWakeRelativeKey"//?
#define kIOPMSettingDebugPowerRelativeKey "kIOPMSettingDebugPowerRelativeKey"//?
#define kIOPMSettingAutoWakeCalendarKey "kIOPMSettingAutoWakeCalendarKey"//?
#define kIOPMSettingAutoPowerCalendarKey "kIOPMSettingAutoPowerCalendarKey"//?
#define kIOPMSettingAutoWakeSecondsKey "kIOPMSettingAutoWakeSecondsKey"//?
#define kIOPMSettingAutoPowerSecondsKey "kIOPMSettingAutoPowerSecondsKey"//?
#define kIOPMThermalLevelWarningKey "kIOPMThermalLevelWarningKey"//?
#define kIOPMCPUPowerLimitsKey "kIOPMCPUPowerLimitsKey"//?
#define kIOPMSettingRestartOnPowerLossKey "kIOPMSettingRestartOnPowerLossKey"//?
#define kIOPMSettingWakeOnACChangeKey "kIOPMSettingWakeOnACChangeKey"//?
#define kIOPMSettingMobileMotionModuleKey "kIOPMSettingMobileMotionModuleKey"//?
#define kIOPMSettingSleepOnPowerButtonKey "kIOPMSettingSleepOnPowerButtonKey"//?
#define kIOPMSettingWakeOnClamshellKey "kIOPMSettingWakeOnClamshellKey"//?
#define kIOBatteryInfoKey "kIOBatteryInfoKey"//?
#define kIOPMPSLegacyBatteryInfoKey "kIOPMPSLegacyBatteryInfoKey"//?
#define kIOPMPSExternalConnectedKey "kIOPMPSExternalConnectedKey"//?
#define kIOPMPSExternalChargeCapableKey "kIOPMPSExternalChargeCapableKey"//?
#define kIOPMPSBatteryInstalledKey "kIOPMPSBatteryInstalledKey"//?
#define kIOPMPSIsChargingKey "kIOPMPSIsChargingKey"//?
#define kIOPMPSErrorConditionKey "kIOPMPSErrorConditionKey"//?
#define kIOPMPSCurrentCapacityKey "kIOPMPSCurrentCapacityKey"//?
#define kIOPMPSMaxCapacityKey "kIOPMPSMaxCapacityKey"//?
#define kIOPMPSDesignCapacityKey "kIOPMPSDesignCapacityKey"//?
#define kIOPMPSTimeRemainingKey "kIOPMPSTimeRemainingKey"//?
#define kIOPMPSAmperageKey "kIOPMPSAmperageKey"//?
#define kIOPMPSMaxErrKey "kIOPMPSMaxErrKey"//?
#define kIOPMPSCycleCountKey "kIOPMPSCycleCountKey"//?
#define kIOPMPSLocationKey "kIOPMPSLocationKey"//?
#define kIOPMPSInvalidWakeSecondsKey "kIOPMPSInvalidWakeSecondsKey"//?
#define IOPMDeviceNameKey "kIOPMDeviceNameKey"//?
#define kIOPMDeviceNameKey "kIOPMDeviceNameKey"//?
#define kIOPMFullyChargedKey "kIOPMFullyChargedKey"//?
#define kIOPMPSManufactureDateKey "kIOPMPSManufactureDateKey"//?
#define kIOPMPSPostChargeWaitSecondsKey "kIOPMPSPostChargeWaitSecondsKey"//?
#define kIOPMPSPostDishargeWaitSecondsKey "kIOPMPSPostDishargeWaitSecondsKey"//?
#define kIOPMPSVoltageKey "kIOPMPSVoltageKey"//?
#define kIOBatteryFlagsKey "kIOBatteryFlagsKey"//?
#define kIOBatteryCurrentChargeKey "kIOBatteryCurrentChargeKey"//?
#define kIOBatteryCapacityKey "kIOBatteryCapacityKey"//?
#define kIOBatteryVoltageKey "kIOBatteryVoltageKey"//?
#define kIOBatteryAmperageKey "kIOBatteryAmperageKey"//?
#define kIOBatteryCycleCountKey "kIOBatteryCycleCountKey"//?

//////////////////

//////////////////////////////
////////////////
enum {
	kIOPMWillAckLater,//?
	kIOPMNoSuchState,//?
	kPMSetProcessorSpeed,//?
	kIOPMAckImplied,//?
	kIOPMNotPowerManaged,//?
	kPMEthernetWakeOnLANSettings,//?
	kIOPMUnknown,//?
	kIOPMDoze,//?
	kIOPMClockNormal,//?
	kPMPowerSource,//?
	kIOPMSoftSleep,//?
	kIOPMInternalPower,//?
	kPMMinutesToSpinDown,//?
	kIOPMExternalPower,//?
	kPMMinutesToSleep,//?
	kIOPMPreventSystemSleep,//?
	kPMMinutesToDim,//?
	kIOPMSuperclassPolicy1,//?
	kIOPMLowestState,//?
	kIOPMNoErr,//?
	kIOPMMaxPerformance,//?
};

enum {
    	kIOBatteryChargerConnect    = (1 << 0),//c
    	kIOBatteryInstalled         = (1 << 2),//c
    	kIOBatteryCharge            = (1 << 1),//c
    	kInflowForciblyEnabledBit = (1 << 0),//c
  	kIOPMEnableClamshell          = (1<<7),//c
  	kIOPMDisableClamshell         = (1<<6),//c
  	kIOPMClosedClamshell  = (1<<9), //c
  	kIOPMBatteryDepleted  = (1<<5),//c
  	kIOPMRawLowBattery    = (1<<7),  //c
  	kIOPMACnoChargeCapability = (1<<6),  //c
  	kIOPMForceLowSpeed    = (1<<8), //c
  	kIOPMProcessorSpeedChange     = (1<<8), //c
    	IOPMSoftSleep               = kIOPMSoftSleep,//c
  	IOPMLowestState             = kIOPMLowestState,//c
    	IOPMAckImplied = kIOPMAckImplied,//c
	kIOPMBatteryInstalled = kIOBatteryInstalled,//c
	kIOPMBatteryCharging  = kIOBatteryCharge,//c
  	kIOPMACInstalled      = kIOBatteryChargerConnect,//c
    	IOPMClockNormal             = kIOPMClockNormal,//c
    	IOPMNoErr = kIOPMNoErr,//c
    	IOPMMaxPerformance          = kIOPMMaxPerformance,//c
    	IOPMNoSuchState = kIOPMNoSuchState,//c
};
///////////////////////////////
struct IOPowerStateChangeNotification {
	void* powerRef;//c
	unsigned long returnValue;//c
};
typedef struct IOPowerStateChangeNotification IOPowerStateChangeNotification;

struct IOPMCalendarStruct {
    UInt32      year;
    UInt8       month;
    UInt8       day;
    UInt8       hour;
    UInt8       minute;
    UInt8       second;
};//c
typedef struct IOPMCalendarStruct IOPMCalendarStruct;

#endif//HYS_IOKIT_PWR_MGT_IOPM_H
/////////////////////////////////////////////////////////
#ifdef   HYS_IOKIT_PWR_MGT_IOPM_H_END
#undef HYS_IOKIT_PWR_MGT_IOPM_H_END

enum {
	IOPMPowerOn                 = kIOPMPowerOn,//c
   	IOPMDeviceUsable            = kIOPMDeviceUsable,//c
};

#endif//HYS_IOKIT_PWR_MGT_IOPM_H_END
