#ifndef HYS_IOKIT_PWR_MGT_IOPMPOWERSOURCE_H
#define HYS_IOKIT_PWR_MGT_IOPMPOWERSOURCE_H

class  IOPMPowerSource_HYS
{
    OSDeclareDefaultStructors(IOPMPowerSource_HYS)

public:

OSDictionary * properties;//c
const OSSymbol * manufacturerKey;//c
const OSSymbol *serialKey;//c
bool settingsChangedSinceUpdate;//c
const OSSymbol *batteryInfoKey;//c
const OSSymbol *errorConditionKey;//c

public://func

#define IOPMPowerSource_getPSProperty \
OSObject *getPSProperty(const OSSymbol *a);//c

#define IOPMPowerSource_manufacturer \
    OSSymbol *manufacturer(void);//c

#define IOPMPowerSource_setLegacyIOBatteryInfo \
 void setLegacyIOBatteryInfo(OSDictionary *a);//c

#define IOPMPowerSource_isCharging \
bool isCharging(void);//c

#define IOPMPowerSource_batteryInstalled \
  bool batteryInstalled(void);//c

#define IOPMPowerSource_externalConnected \
bool externalConnected(void);//c

#define IOPMPowerSource_setAdapterInfo  \
void setAdapterInfo(int a);//c

#define IOPMPowerSource_setCycleCount \
void setCycleCount(unsigned int a);//c

#define IOPMPowerSource_setVoltage \
void setVoltage(unsigned int a);//c

#define IOPMPowerSource_setTimeRemaining \
void setTimeRemaining(int a);//c

#define IOPMPowerSource_setAmperage \
void setAmperage(int a);//c

#define IOPMPowerSource_setMaxCapacity \
void setMaxCapacity(unsigned int a);//c

#define IOPMPowerSource_setCurrentCapacity \
void setCurrentCapacity(unsigned int a);//c

#define IOPMPowerSource_setLocation \
void setLocation(int a);//c

#define IOPMPowerSource_setSerial \
void setSerial(OSSymbol *a);//c

#define IOPMPowerSource_setManufacturer \
void setManufacturer(OSSymbol *a);//c

#define IOPMPowerSource_setPSProperty \
    void setPSProperty(const OSSymbol *a, OSObject *b);//c

#define IOPMPowerSource_setErrorCondition \
    void setErrorCondition(OSSymbol *a);//c

#define IOPMPowerSource_setIsCharging \
void setIsCharging(bool a);//c

#define IOPMPowerSource_setBatteryInstalled \
void setBatteryInstalled(bool a);//c

#define IOPMPowerSource_setExternalChargeCapable \
 void setExternalChargeCapable(bool a);//c

#define IOPMPowerSource_setExternalConnected \
void setExternalConnected(bool a);//c

};

#endif//HYS_IOKIT_PWR_MGT_IOPMPOWERSOURCE_H
