#ifndef HYS_IOKIT_SBP2_IOFIREWIRESBP2LSIWORKAROUNNDDESCRIPTORT_H
#define HYS_IOKIT_SBP2_IOFIREWIRESBP2LSIWORKAROUNNDDESCRIPTORT_H

class  IOFireWireSBP2LSIWorkaroundDescriptor_HYS
{
	OSDeclareDefaultStructors(IOFireWireSBP2LSIWorkaroundDescriptor_HYS)

public://data

OSArray* fPermanentRanges;//c
OSArray* fBufferDescriptors;//c
IOPhysicalRange *fRangeTable;//c
OSArray* fRanges;//c
IOMemoryDescriptor *  fOriginalDesc;//c
IOByteCount  fLength;//c
IOByteCount fOffset;//c
IODirection fDirection;//c
IOByteCount fRangeTableSize;//c
UInt32 fPermanentPages;//c
IOByteCount fAllocatedBytesCount;//c
bool fFixedCapacity;//c
UInt32 fAllocatedRangesCount;//c

public://func

#define IOFireWireSBP2LSIWorkaroundDescriptor_syncBuffersForInput \
    virtual IOReturn syncBuffersForInput( void );	//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_syncBuffersForOutput \
	virtual IOReturn syncBuffersForOutput( void );  //c

#define IOFireWireSBP2LSIWorkaroundDescriptor_initializeBuffers \
	virtual IOReturn initializeBuffers( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_resegmentOddLengthSegments \
	virtual IOReturn resegmentOddLengthSegments( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_initializeRangesArray \
	virtual IOReturn initializeRangesArray( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_initWithDescriptor \
   virtual bool initWithDescriptor( IOMemoryDescriptor * desc, IOByteCount offset = 0,  IOByteCount len = 0, IODirection direction = kIODirectionOutIn );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_withDescriptor \
static IOFireWireSBP2LSIWorkaroundDescriptor * withDescriptor( IOMemoryDescriptor * desc, IOByteCount offset = 0,  IOByteCount len = 0, IODirection direction = kIODirectionOutIn );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_resetToInitialCapacity \
	virtual IOReturn resetToInitialCapacity( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_withCapacity \
static IOFireWireSBP2LSIWorkaroundDescriptor * withCapacity ( UInt32 permanentRanges, IOByteCount permanentBufferSpace, bool fixedCapacity );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_initWithCapacity \
	virtual bool initWithCapacity( UInt32 permanentRanges, IOByteCount permanentBufferSpace, bool fixedCapacity );

#define IOFireWireSBP2LSIWorkaroundDescriptor_initWithPhysicalRanges \
    virtual bool initWithPhysicalRanges( IOPhysicalRange * ranges,  UInt32            withCount,IODirection       withDirection,bool              asReference = false );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_initWithPhysicalAddress \
    virtual bool initWithPhysicalAddress( IOPhysicalAddress address, IOByteCount       withLength,IODirection       withDirection );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_rangeTableAllocatorFree \
	virtual void rangeTableAllocatorFree( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_rangeTableAllocatorNewTable \
	virtual IOPhysicalRange * rangeTableAllocatorNewTable( UInt32 entries );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_rangeTableAllocatorInitialize \
	virtual IOReturn rangeTableAllocatorInitialize( UInt32 requestedBufferSize );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_bufferAllocatorFree \
	virtual void bufferAllocatorFree( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_bufferAllocatorDeallocateAllBuffers \
	virtual void bufferAllocatorDeallocateAllBuffers( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_bufferAllocatorInitialize \
	virtual IOReturn bufferAllocatorInitialize( IOByteCount requestedBufferSize );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_rangeAllocatorFree \
	virtual void rangeAllocatorFree( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_rangeAllocatorNewRange \
	virtual IOFireWireSBP2LSIRange * rangeAllocatorNewRange( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_rangeAllocatorDeallocateAllRanges \
	virtual void rangeAllocatorDeallocateAllRanges( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_rangeAllocatorInitialize \
	virtual IOReturn rangeAllocatorInitialize( UInt32 rangeCount );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_initWithAddress_void \
virtual bool initWithAddress( void *      address,IOByteCount withLength,IODirection withDirection );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_initWithAddress \
    virtual bool initWithAddress( vm_address_t address,     IOByteCount  withLength,IODirection  withDirection,task_t       withTask );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_splitLargeSegments \
	virtual IOReturn splitLargeSegments( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_recalculateSmallSegments \
	virtual IOReturn recalculateSmallSegments( void );//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_free \
	virtual void free();//c

#define IOFireWireSBP2LSIWorkaroundDescriptor_initWithRanges \
    virtual bool initWithRanges(  IOVirtualRange * ranges,   UInt32           withCount,IODirection      withDirection,task_t           withTask,bool             asReference = false );//c/

#define IOFireWireSBP2LSIWorkaroundDescriptor_bufferAllocatorNewBuffer \
	virtual void * bufferAllocatorNewBuffer( IOPhysicalAddress * address );//c

};

#endif//HYS_IOKIT_SBP2_IOFIREWIRESBP2LSIWORKAROUNNDDESCRIPTORT_H
