#ifndef HYS_IOKIT_SBP2_IOFIREWIRESBP2LUN_H
#define HYS_IOKIT_SBP2_IOFIREWIRESBP2LUN_H

class  IOFireWireSBP2LUN_HYS
{
    OSDeclareDefaultStructors( IOFireWireSBP2LUN_HYS );

public://data

IOFireWireSBP2Target * fProviderTarget;//c
OSSet * fLoginSet;//c
OSIterator * fLoginSetIterator;//c
OSSet* fORBSet;//c
OSIterator* fORBSetIterator;//c
IOCommandGate * fGate;//c
OSObject* fDiagnostics;//c

int fLUNumber;//?

public://define

#define IOFireWireSBP2LUN_removeLogin \
void removeLogin( IOFireWireSBP2Login * a );//?

#define IOFireWireSBP2LUN_createLoginAction \
IOReturn createLoginAction( IOFireWireSBP2Login ** a);//?

#define IOFireWireSBP2LUN_staticCreateLogin \
static IOReturn staticCreateLogin( OSObject *a, void *b, void *c, void *d, void *e );//?

#define IOFireWireSBP2LUN_getTarget \
IOFireWireSBP2Target * getTarget( void );//?

#define IOFireWireSBP2LUN_getLUNumber \
UInt32 getLUNumber( void );//?

#define IOFireWireSBP2LUN_resumeNotify \
void resumeNotify( void );//?

#define IOFireWireSBP2LUN_staticRemoveManagementORBAction \
static IOReturn staticRemoveManagementORBAction( OSObject *a, void *b, void *c, void *d, void *e );//?

#define IOFireWireSBP2LUN_matchPropertyTable \
bool matchPropertyTable(OSDictionary *a);//?

#define IOFireWireSBP2LUN_initLoginWithLUN \
bool initLoginWithLUN( IOFireWireSBP2Login *a, IOFireWireSBP2LUN *b);//?

#define IOFireWireSBP2LUN_initMgmtORBWithLUN \
bool initMgmtORBWithLUN( IOFireWireSBP2ManagementORB *a, IOFireWireSBP2LUN *b, void *c, FWSBP2ManagementCallback d);//?
 
#define IOFireWireSBP2LUN_removeManagementORBAction \
IOReturn removeManagementORBAction( IOFireWireSBP2ManagementORB *a);//?

#define IOFireWireSBP2LUN_suspendedNotify \
void suspendedNotify( void );//?

#define IOFireWireSBP2LUN_staticRemoveLoginAction \
static IOReturn staticRemoveLoginAction( OSObject *a, void *b, void *c, void *d, void *e);//?

#define IOFireWireSBP2LUN_removeLoginAction \
IOReturn removeLoginAction( IOFireWireSBP2Login * a);//?

#define IOFireWireSBP2LUN_clearAllTasksInSet \
void clearAllTasksInSet( void );//?  

#define IOFireWireSBP2LUN_staticCreateManagementORBAction \
static IOReturn staticCreateManagementORBAction( OSObject *a, void *b, void *c, void *d, void *e );//?

#define IOFireWireSBP2LUN_createManagementORBAction \
IOReturn createManagementORBAction( void *a, FWSBP2ManagementCallback b, IOFireWireSBP2ManagementORB ** c);//?

#define IOFireWireSBP2LUN_removeManagementORB \
void removeManagementORB( IOFireWireSBP2ManagementORB *a ); //?
	
#define IOFireWireSBP2LUN_terminateNotify \
void terminateNotify( void );//?

#define IOFireWireSBP2LUN_message \
IOReturn message( UInt32 a, IOService *b, void *c= 0 );//?

#define IOFireWireSBP2LUN_handleOpen \
bool handleOpen( IOService *a, IOOptionBits b, void *c);//?

#define IOFireWireSBP2LUN_finalize \
bool finalize( IOOptionBits a );//?

#define IOFireWireSBP2LUN_executeFlushAllMgmtORBs \
IOReturn executeFlushAllMgmtORBs( void );//?

#define IOFireWireSBP2LUN_handleClose \
void handleClose(  IOService *a, IOOptionBits	b);//?

#define IOFireWireSBP2LUN_staticExecuteFlushAllMgmtORBs \
static IOReturn staticExecuteFlushAllMgmtORBs( OSObject *a, void * b, void *c, void *d, void *e );//?

#define IOFireWireSBP2LUN_createLogin \
IOFireWireSBP2Login *createLogin( void );//?

#define IOFireWireSBP2LUN_getFireWireUnit \
IOFireWireUnit * getFireWireUnit( void );//?

#define IOFireWireSBP2LUN_createManagementORB \
IOFireWireSBP2ManagementORB * createManagementORB( void *a, FWSBP2ManagementCallback b);//?

#define IOFireWireSBP2LUN_flushAllManagementORBs \
void flushAllManagementORBs( void );//?

#define IOFireWireSBP2LUN_free \
void free( void );//?

#define IOFireWireSBP2LUN_getDiagnostics \
OSObject * getDiagnostics( void );//?

#define IOFireWireSBP2LUN_attach \
bool attach( IOService *a);//?

public://func


};
#endif//HYS_IOKIT_SBP2_IOFIREWIRESBP2LUN_H
