#ifndef HYS_IOKIT_SBP2_IOFIREWIRESBP2MANAGEMENTORB_H
#define HYS_IOKIT_SBP2_IOFIREWIRESBP2MANAGEMENTORB_H

enum {
	kFWSBP2TargetReset,//?
	kFWSBP2LogicalUnitReset,//?
	kFWSBP2AbortTaskSet,//?
	kFWSBP2AbortTask,//?
	kFWSBP2QueryLogins,//?
};

class  IOFireWireSBP2ManagementORB_HYS
{
    OSDeclareDefaultStructors( IOFireWireSBP2ManagementORB_HYS )

public://data

struct FWSBP2TaskManagementORB {
	int statusFIFOAddressHi;//?
	int statusFIFOAddressLo;//?
	int options;//?
	int loginID;//?
	int orbOffsetHi;//?
	int orbOffsetLo;//?
};
typedef struct FWSBP2TaskManagementORB FWSBP2TaskManagementORB;

struct FWSBP2QueryLoginsORB {
	int lun;//?
	int queryResponseAddressHi;//?
	int queryResponseAddressLo;//?
	int queryResponseLength;//?
};
typedef struct FWSBP2QueryLoginsORB FWSBP2QueryLoginsORB;

struct ExpansionData {
	int fInCriticalSection;//?
};

ExpansionData * fExpansionData;//c
IOFireWireSBP2LUN *  fLUN;//c
IOFireWireUnit * fUnit;//c
FWSBP2ManagementCallback fCompletionCallback;//c
void* fCompletionRefCon;//c
IOFWAddressSpace * fManagementORBAddressSpace;//c
FWAddress  fManagementORBAddress;//c
FWAddress fStatusBlockAddress;//c
IOFWAddressSpace * fStatusBlockAddressSpace;//c
IOMemoryDescriptor * fWriteCommandMemory;//c
IOFWWriteCommand * fWriteCommand;//c
FWSBP2TaskManagementORB fManagementORB;//c
IOFWCommand * fTimeoutCommand;//c
IOMemoryMap * fResponseMap;//c
IOFWAddressSpace * fResponseAddressSpace;//c
OSObject * fManageeCommand;//c
void * fResponseBuf;//c
FWAddress fResponseAddress;//c
OSAsyncReference fCallbackAsyncRef;//c

int fTimeoutTimerSet;//?
int fFunction;//?
int fResponseLen;//?
int fCompleting;//?
int fManagementOffset;//?
int fManagementTimeout;//?

public://define

#define IOFireWireSBP2ManagementORB_complete \
IOReturn complete( IOReturn a);//?

#define IOFireWireSBP2ManagementORB_statusBlockWrite \
UInt32 statusBlockWrite(UInt16 a, FWAddress b, UInt32 c, const void *d, IOFWRequestRefCon e);//?

#define IOFireWireSBP2ManagementORB_clearAllTasksInSet \
void clearAllTasksInSet( void );//?

#define IOFireWireSBP2ManagementORB_handleTimeout \
void handleTimeout( IOReturn a, IOFireWireBus *b, IOFWBusCommand *c);//?

#define IOFireWireSBP2ManagementORB_writeComplete \
void writeComplete( IOReturn a, IOFireWireNub *b, IOFWCommand *c);//?

#define IOFireWireSBP2ManagementORB_setORBToDummy \
void setORBToDummy( IOFireWireSBP2ORB *a);//?

#define IOFireWireSBP2ManagementORB_execute \
IOReturn execute( void );//?

#define IOFireWireSBP2ManagementORB_getResponseBuffer \
void getResponseBuffer( void ** a, UInt32 *b );//?

#define IOFireWireSBP2ManagementORB_setResponseBuffer_void \
IOReturn setResponseBuffer( void *a, UInt32 b);//?

#define IOFireWireSBP2ManagementORB_getManageeCommand \
OSObject* getManageeCommand( void );//?

#define IOFireWireSBP2ManagementORB_getCommandFunction \
UInt32 getCommandFunction( void );//?

#define IOFireWireSBP2ManagementORB_release \
void release() const;//?

#define IOFireWireSBP2ManagementORB_removeManagementORB \
void removeManagementORB( IOFireWireSBP2ManagementORB *a);//?

#define IOFireWireSBP2ManagementORB_free \
void free( void );//?

#define IOFireWireSBP2ManagementORB_handleTimeoutStatic \
static void handleTimeoutStatic(void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d);//?

#define IOFireWireSBP2ManagementORB_writeCompleteStatic \
static void writeCompleteStatic(void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d);//?

#define IOFireWireSBP2ManagementORB_statusBlockWriteStatic \
static UInt32 statusBlockWriteStatic(void *a, UInt16 b, IOFWSpeed &c, FWAddress d, UInt32 e, const void *f, IOFWRequestRefCon g);//?

#define IOFireWireSBP2ManagementORB_allocateResources \
IOReturn allocateResources( void );//?

#define IOFireWireSBP2ManagementORB_suspendedNotify \
void suspendedNotify();//?

#define IOFireWireSBP2ManagementORB_getAsyncCallbackReference \
void getAsyncCallbackReference( void * a );//?

#define IOFireWireSBP2ManagementORB_setAsyncCallbackReference \
void setAsyncCallbackReference( void *a);

#define IOFireWireSBP2ManagementORB_getUnitInformation \
IOReturn getUnitInformation( void );//?

#define IOFireWireSBP2ManagementORB_setManageeCommand \
void setManageeCommand( OSObject *a );//?

#define IOFireWireSBP2ManagementORB_setCommandFunction \
IOReturn setCommandFunction( UInt32 a);//?

#define IOFireWireSBP2ManagementORB_initWithLUN \
bool initWithLUN(IOFireWireSBP2LUN *a, void *b, FWSBP2ManagementCallback c);

#define IOFireWireSBP2ManagementORB_setResponseBuffer \
IOReturn setResponseBuffer( IOMemoryDescriptor *a);//?

public://func

};

#endif//HYS_IOKIT_SBP2_IOFIREWIRESBP2MANAGEMENTORB_H
