#ifndef HYS_IOKIT_SBP2_IOFIREWIRESBP2USERCLIENT_H
#define HYS_IOKIT_SBP2_IOFIREWIRESBP2USERCLIENT_H

class  IOFireWireSBP2UserClient_HYS
{
    OSDeclareDefaultStructors(IOFireWireSBP2UserClient_HYS)

public://data

task_t fTask;//c
OSAsyncReference64 fMessageCallbackAsyncRef;//c
OSAsyncReference64 fLoginCallbackAsyncRef;//c
OSAsyncReference64 fLogoutCallbackAsyncRef;//c
OSAsyncReference64 fUnsolicitedStatusNotifyAsyncRef;//c
OSAsyncReference64 fStatusNotifyAsyncRef;//c
OSAsyncReference64 fFetchAgentWriteAsyncRef;//c
OSAsyncReference64 fFetchAgentResetAsyncRef;//c
IOFireWireSBP2LUN * fProviderLUN;//c
IOFireWireSBP2Login * fLogin;//c

int fOpened;//?
int fStarted;//?

public://func-define

#define IOFireWireSBP2UserClient_setMgmtORBManageeLogin \
IOReturn setMgmtORBManageeLogin(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setMgmtORBCommandFunction \
IOReturn setMgmtORBCommandFunction(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_submitMgmtORB \
IOReturn submitMgmtORB(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_releaseMgmtORB \
IOReturn releaseMgmtORB(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setMgmtORBCallback \
IOReturn setMgmtORBCallback(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_createMgmtORB \
IOReturn createMgmtORB(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_LSIWorkaroundSyncBuffersForInput \
IOReturn LSIWorkaroundSyncBuffersForInput(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_LSIWorkaroundSyncBuffersForOutput \
IOReturn LSIWorkaroundSyncBuffersForOutput(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_LSIWorkaroundSetCommandBuffersAsRanges \
IOReturn LSIWorkaroundSetCommandBuffersAsRanges(  IOExternalMethodArguments *a);//?

#define IOFireWireSBP2UserClient_setCommandBlock \
IOReturn setCommandBlock(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_releaseCommandBuffers \
IOReturn releaseCommandBuffers(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setCommandBuffersAsRanges \
IOReturn setCommandBuffersAsRanges(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setToDummy \
IOReturn setToDummy(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setCommandGeneration \
IOReturn setCommandGeneration(  IOExternalMethodArguments * a );//?

#define IOFireWireSBP2UserClient_setCommandTimeout \
IOReturn setCommandTimeout(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setORBRefCon \
IOReturn setORBRefCon(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setMaxORBPayloadSize \
IOReturn setMaxORBPayloadSize( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setCommandFlags \
IOReturn setCommandFlags(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_submitORB \
IOReturn submitORB(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_releaseORB \
IOReturn releaseORB(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_mgmtORBCallback \
void mgmtORBCallback( IOReturn a, IOFireWireSBP2ManagementORB *b);

#define IOFireWireSBP2UserClient_setPassword \
IOReturn setPassword( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setFetchAgentWriteCompletion \
IOReturn setFetchAgentWriteCompletion( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setBusyTimeoutRegisterValue \
IOReturn setBusyTimeoutRegisterValue( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_createORB \
IOReturn createORB(  IOExternalMethodArguments * a );//?

#define IOFireWireSBP2UserClient_staticMgmtORBCallback \
static void staticMgmtORBCallback( void *a, IOReturn b, IOFireWireSBP2ManagementORB * c );//?

#define IOFireWireSBP2UserClient_setMgmtORBResponseBuffer \
IOReturn setMgmtORBResponseBuffer(  IOExternalMethodArguments * a );//?

#define IOFireWireSBP2UserClient_enableUnsolicitedStatus \
IOReturn enableUnsolicitedStatus( IOExternalMethodArguments *a );//?

#define IOFireWireSBP2UserClient_ringDoorbell \
IOReturn ringDoorbell( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_fetchAgentResetComplete \
void fetchAgentResetComplete( IOReturn a);//?

#define IOFireWireSBP2UserClient_fetchAgentWriteComple \
void fetchAgentWriteComplete( IOReturn a, IOFireWireSBP2ORB *b);//?

#define IOFireWireSBP2UserClient_setMgmtORBManageeORB \
IOReturn setMgmtORBManageeORB(  IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_submitFetchAgentReset \
IOReturn submitFetchAgentReset( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setMaxPayloadSize \
IOReturn setMaxPayloadSize( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_staticFetchAgentResetComplete \
static void staticFetchAgentResetComplete( void *a, IOReturn b);//?

#define IOFireWireSBP2UserClient_getMgmtORBAsyncCallbackReference \
void getMgmtORBAsyncCallbackReference( IOFireWireSBP2ManagementORB *a, void *b);//?

#define IOFireWireSBP2UserClient_flushAllManagementORBs \
void flushAllManagementORBs( void );//?

#define IOFireWireSBP2UserClient_setMgmtORBAsyncCallbackReference \
void setMgmtORBAsyncCallbackReference(IOFireWireSBP2ManagementORB *a, void * b);//?

#define IOFireWireSBP2UserClient_setReconnectTime \
IOReturn setReconnectTime( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_getLoginID \
IOReturn getLoginID( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_getMaxCommandBlockSize \
IOReturn getMaxCommandBlockSize( IOExternalMethodArguments * a);

#define IOFireWireSBP2UserClient_setLoginFlags \
IOReturn setLoginFlags( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_releaseLogin \
IOReturn releaseLogin( IOExternalMethodArguments * a );//?

#define IOFireWireSBP2UserClient_submitLogout \
IOReturn submitLogout( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_staticFetchAgentWriteComplete \
static void staticFetchAgentWriteComplete( void *a, IOReturn b, IOFireWireSBP2ORB *c);//?

#define IOFireWireSBP2UserClient_createLogin \
IOReturn createLogin( IOExternalMethodArguments * a );//?

#define IOFireWireSBP2UserClient_statusNotify \
void statusNotify( FWSBP2NotifyParams *a );//?

#define IOFireWireSBP2UserClient_staticStatusNotify \
static void staticStatusNotify( void * a, FWSBP2NotifyParams * b);//?

#define IOFireWireSBP2UserClient_setStatusNotify \
IOReturn setStatusNotify( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_unsolicitedNotify \
void unsolicitedNotify( FWSBP2NotifyParams * a);//?

#define IOFireWireSBP2UserClient_staticUnsolicitedNotify \
static void staticUnsolicitedNotify( void *a, FWSBP2NotifyParams *b);//?

#define IOFireWireSBP2UserClient_submitLogin \
IOReturn submitLogin( IOExternalMethodArguments * a );//?

#define IOFireWireSBP2UserClient_loginCallback \
void loginCallback( FWSBP2LoginCompleteParamsPtr a);//?

#define IOFireWireSBP2UserClient_staticLoginCallback \
static void staticLoginCallback( void *a, FWSBP2LoginCompleteParamsPtr b);//?

#define IOFireWireSBP2UserClient_message \
IOReturn message( UInt32 a, IOService *b, void *c);//?

#define IOFireWireSBP2UserClient_staticLogoutCallback \
static void staticLogoutCallback( void *a, FWSBP2LogoutCompleteParamsPtr b);//?

#define IOFireWireSBP2UserClient_logoutCallback \
void logoutCallback( FWSBP2LogoutCompleteParamsPtr a);//?

#define IOFireWireSBP2UserClient_clientDied \
IOReturn clientDied( void );//?

#define IOFireWireSBP2UserClient_clientClose \
IOReturn clientClose( void );//?

#define IOFireWireSBP2UserClient_checkArguments \
IOReturn checkArguments( IOExternalMethodArguments *a, uint32_t b, uint32_t c, uint32_t d, uint32_t e );//?

#define IOFireWireSBP2UserClient_setUnsolicitedStatusNotify \
IOReturn setUnsolicitedStatusNotify( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_close \
IOReturn close( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_open \
IOReturn open( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_externalMethod \
IOReturn externalMethod(	uint32_t a, IOExternalMethodArguments *b, IOExternalMethodDispatch *c, OSObject *d,void *e);//?

#define IOFireWireSBP2UserClient_start \
bool start( IOService * a);//?

#define IOFireWireSBP2UserClient_initWithTask \
bool initWithTask( task_t a, void * b, UInt32 c, OSDictionary * d);//?

#define IOFireWireSBP2UserClient_openWithSessionRef \
IOReturn openWithSessionRef( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_getSessionRef \
IOReturn getSessionRef( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setMessageCallback \
IOReturn setMessageCallback( IOExternalMethodArguments * a);//?

#define IOFireWireSBP2UserClient_setLoginCallback \
IOReturn setLoginCallback( IOExternalMethodArguments * a );//?

#define IOFireWireSBP2UserClient_setLogoutCallback \
IOReturn setLogoutCallback( IOExternalMethodArguments * a);//?

public://func


};


#endif//HYS_IOKIT_SBP2_IOFIREWIRESBP2USERCLIENT_H
