#ifndef HYS_IOKIT_SCSI_IOSCSIPRIMARYCOMMANDSDEVICE_H
#define HYS_IOKIT_SCSI_IOSCSIPRIMARYCOMMANDSDEVICE_H

class  IOSCSIPrimaryCommandsDevice_HYS
{
   OSDeclareAbstractStructors ( IOSCSIPrimaryCommandsDevice_HYS )

public://data

OSDictionary *	fDeviceCharacteristicsDictionary;//c

public://define

#define IOSCSIPrimaryCommandsDevice_SetRequestedDataTransferCount \
bool	SetRequestedDataTransferCount (SCSITaskIdentifier a, UInt64 b);//c

#define IOSCSIPrimaryCommandsDevice_SetDataBuffer  \
bool	SetDataBuffer (SCSITaskIdentifier a, IOMemoryDescriptor *b);//c

#define IOSCSIPrimaryCommandsDevice_SetDataTransferDirection \
bool	SetDataTransferDirection (SCSITaskIdentifier a, UInt8 b);//c

#define IOSCSIPrimaryCommandsDevice_SetCommandDescriptorBlock_SCSITaskIdentifier_UInt8_UInt8 \
bool 	SetCommandDescriptorBlock (SCSITaskIdentifier a, UInt8 b, UInt8 c, UInt8 d, UInt8 e, UInt8 f, UInt8 h);//c
	
#define IOSCSIPrimaryCommandsDevice_SetCommandDescriptorBlock_SCSITaskIdentifier_UInt8 \
bool 	SetCommandDescriptorBlock (	SCSITaskIdentifier a, UInt8 b, UInt8 c, UInt8 d, UInt8 e, UInt8 f,  UInt8 g, UInt8 h, UInt8 i, UInt8 j, UInt8 k);//c
	
#define IOSCSIPrimaryCommandsDevice_SetCommandDescriptorBlock_SCSITaskIdentifier \
bool 	SetCommandDescriptorBlock (SCSITaskIdentifier a, UInt8 b, UInt8 c, UInt8 d, UInt8 e, UInt8 f, UInt8 g, UInt8 h, UInt8 i, UInt8 j, UInt8 k, UInt8 l, UInt8 m);//c
	
#define IOSCSIPrimaryCommandsDevice_SetCommandDescriptorBlock \
bool 	SetCommandDescriptorBlock (SCSITaskIdentifier a, UInt8 b, UInt8 c, UInt8 d, UInt8 e, UInt8 f, UInt8 g, UInt8 h, UInt8 i, UInt8 j, UInt8 k, UInt8 l, UInt8 m, UInt8 n, UInt8 o, UInt8 p, UInt8 q);//c

#define IOSCSIPrimaryCommandsDevice_IsMemoryDescriptorValid_IOMemoryDescriptor \
bool 	IsMemoryDescriptorValid (IOMemoryDescriptor *a);//c
	
#define IOSCSIPrimaryCommandsDevice_IsMemoryDescriptorValid \
bool 	IsMemoryDescriptorValid (IOMemoryDescriptor *a, UInt64 b);//c
	
#define IOSCSIPrimaryCommandsDevice_SetApplicationLayerReference \
bool	SetApplicationLayerReference (SCSITaskIdentifier a,void *b);//c

#define IOSCSIPrimaryCommandsDevice_ResetForNewTask \
bool 	ResetForNewTask(SCSITaskIdentifier a);//c

#define IOSCSIPrimaryCommandsDevice_GetAutoSenseData_SCSITaskIdentifier \
bool	GetAutoSenseData (	SCSITaskIdentifier a, SCSI_Sense_Data *b ); //c

#define IOSCSIPrimaryCommandsDevice_GetAutoSenseData \
bool	GetAutoSenseData (	SCSITaskIdentifier a, SCSI_Sense_Data *b, UInt8 c);//c

#define IOSCSIPrimaryCommandsDevice_SendCommand_SCSITaskIdentifier \
SCSIServiceResponse  SendCommand (	SCSITaskIdentifier a, UInt32 b);//c

#define IOSCSIPrimaryCommandsDevice_SendCommand \
void 	SendCommand (SCSITaskIdentifier a, UInt32 b, SCSITaskCompletion c);//c
	
#define IOSCSIPrimaryCommandsDevice_GetSCSITask  \
SCSITaskIdentifier		GetSCSITask ( void );//?c

#define  IOSCSIPrimaryCommandsDevice_ReleaseSCSITask \
void	ReleaseSCSITask ( SCSITaskIdentifier a );//?c

#define IOSCSIPrimaryCommandsDevice_GetDataBuffer \
IOMemoryDescriptor *GetDataBuffer (SCSITaskIdentifier  a);//c

#define IOSCSIPrimaryCommandsDevice_GetTaskStatus \
SCSITaskStatus GetTaskStatus (SCSITaskIdentifier a);//c

#define IOSCSIPrimaryCommandsDevice_GetServiceResponse \
SCSIServiceResponse GetServiceResponse (SCSITaskIdentifier a);//c

#define IOSCSIPrimaryCommandsDevice_GetApplicationLayerReference \
void *GetApplicationLayerReference (SCSITaskIdentifier a);//c
	
#define IOSCSIPrimaryCommandsDevice_sGetOwnerForTask \
static OSObject *sGetOwnerForTask ( SCSITaskIdentifier a);//c
	
};
#endif//HYS_IOKIT_SCSI_IOSCSIPRIMARYCOMMANDSDEVICE_H
