#ifndef HYS_IOKIT_SCSI_IOSCSIPROTOCOLINTERFACE_H
#define HYS_IOKIT_SCSI_IOSCSIPROTOCOLINTERFACE_H

#define kIOPropertyReadTimeOutDurationKey "kIOPropertyReadTimeOutDurationKey"//?
#define kIOPropertyWriteTimeOutDurationKey "kIOPropertyWriteTimeOutDurationKey"//?
#define kIOPropertyRetryCountKey "kIOPropertyRetryCountKey"//?
#define kIOPropertySCSIDeviceCharacteristicsKey  "kIOPropertySCSIDeviceCharacteristicsKey"//?

////////////////////////////////////
enum {
	kSCSIProtocolFeature_MaximumWriteTransferByteCount,//?
	kSCSIProtocolFeature_ProtocolSpecificPolling,//?
	kSCSIProtocolFeature_ProtocolSpecificSleepCommand,//?
	kSCSIProtocolFeature_ProtocolSpecificPowerOff,//?
	kSCSIProtocolFeature_ACA,//?
	kSCSIProtocolFeature_CPUInDiskMode,//?
	kSCSIProtocolFeature_GetMaximumLogicalUnitNumber,//?
	kSCSIProtocolFeature_MaximumReadBlockTransferCount,//?
	kSCSIProtocolFeature_MaximumWriteBlockTransferCount,//?
	kSCSIProtocolFeature_ProtocolAlwaysReportsAutosenseData,//?
	kSCSIProtocolFeature_MaximumReadTransferByteCount,//?
	kSCSIProtocolFeature_SubmitDefaultInquiryData,//?
};
//////////////////////////////
typedef int SCSIProtocolFeature;//?
////////////////////////////////////////////////////
class  IOSCSIProtocolInterface_HYS
{	
	OSDeclareAbstractStructors ( IOSCSIProtocolInterface_HYS )
public:

IOCommandGate * fCommandGate;//c

};
	

#endif//HYS_IOKIT_SCSI_IOSCSIPROTOCOLINTERFACE_H
