#ifndef HYS_IOKIT_SCSI_SCSIPARALLELTARGET_H
#define HYS_IOKIT_SCSI_SCSIPARALLELTARGET_H

enum {
	kCDBFlagsEnableTagQueuing,//?
	kStatePending,//?
	kSCSICommandCancel,//?
	kStateIdle,//?
	kStateActive,//?
	kStateIssue,//?
	kSCSICommandBusReset,//?
	kSCSICommandNone,//?
	kSCSICommandReqSense,//?
	kSCSICommandExecute,//?
	kSCSICommandAbort,//?
	kSCSICommandAbortAll,//?
	kSCSICommandDeviceReset,//?
};

struct SCSINegotiationResults{
	int returnCode;//?
	int transferPeriodpS;//?
	int transferOffset;//?
	int transferWidth;//?
	int transferOptions;//?
};
typedef struct SCSINegotiationResults SCSINegotiationResults;

struct SCSITarget {
	SCSINegotiationResults negotiationResult;//c
	queue_head_t deviceList;//c
 	IORWLock * clientSem;//c
	IORWLock* targetSem;//c
	int commandLimitSave;//?
	int commandLimit;//?
	SCSITargetParms targetParmsCurrent;//c
	void* targetPrivateData;//c
	UInt32* tagArray;//c
	OSNumber *regObjTransferPeriod;//c
	OSNumber* regObjTransferOffset;//c
	OSNumber* regObjTransferWidth;//c
	OSNumber* regObjTransferOptions;//c
	OSNumber* regObjCmdQueue;//c
	int targetAllocated;//?
	int reqSenseCount;//?
	int reqSenseState;//?
	int negotiateState;//?
 	int state;//?
	int commandCount;//?
	SCSITargetParms	 targetParmsNew;//c
};
typedef struct SCSITarget SCSITarget;

typedef int SCSICommandType;//?

#endif //HYS_IOKIT_SCSI_SCSIPARALLELTARGET_H
