#ifndef HYS_IOKIT_SCSI_SCSIPUBLIC_H
#define HYS_IOKIT_SCSI_SCSIPUBLIC_H

enum {
	kSCSIDevTypeModRemovable,//?
	kSCSICmdTestUnitReady,//?
	kSCSIMsgAbortTag,//?
	kSCSIMsgBusDeviceReset,//?
	kSCSIMsgAbort,//?
	kSCSICmdInquiry,//?
	kSCSICmdRequestSense,//?
	kSCSIStatusQueueFull,//?
	kSCSIStatusCommandTerminated,//?
	kSCSIStatusReservationConfict,//?
	kSCSIStatusIntermediateMet,//?
	kSCSIStatusIntermediate,//?
	kSCSIStatusBusy,//?
	kSCSIStatusConditionMet,//?
	kSCSIMsgExtended,//?
	kSCSIMsgWideDataXferReq,//?
	kSCSIMsgSyncXferReq,//?
	kSCSIStatusCheckCondition,//?
	kSCSIDevTypeQualifierMask,//?
	kSCSIDevTypeQualifierConnected,//?
	kSCSIDevTypeQualifierNotConnected,//?
	kSCSIDevTypeQualifierReserved,//?
	kSCSIDevTypeQualifierMissing,//?
	kSCSIDevCapCmdQue,//?
	kSCSIDevCapSync,//?
	kSCSIDevCapWBus32,//?
	kSCSIDevCapWBus16,//?
	kSCSIInqVersionSCSI3,//?
	kSCSI3InqOptionClockDT,//?
	kSCSI3InqOptionIUS,//?
	kSCSI3InqOptionQAS,//?
	kSCSICmdModeSense6,//?
	kSCSIDevTypeMask,//?
};

struct _SCSIInquiry {
 	unsigned char flags;//c
	unsigned char devType;//c
 	int version;//?
	unsigned char scsi3Options;//c
	int vendorName;//?
	int productName;//?
	int productRevision;//?
	int devTypeMod;//?
};
typedef struct _SCSIInquiry SCSIInquiry;

#endif //HYS_IOKIT_SCSI_SCSIPUBLIC_H
