#ifndef HYS_IOKIT_STORAGE_IOCDBLOCKSTORAGEDRIVER_H
#define HYS_IOKIT_STORAGE_IOCDBLOCKSTORAGEDRIVER_H

//hys add

#define IOCDBlockStorageDriver_getProvider \
IOCDBlockStorageDevice * getProvider() const;//?

#define IOCDBlockStorageDriver_acceptNewMedia \
IOReturn	acceptNewMedia();//?

#define IOCDBlockStorageDriver_ejectMedia \
IOReturn	ejectMedia();//?

#define IOCDBlockStorageDriver_audioPause \
IOReturn	audioPause(bool a);//?

#define IOCDBlockStorageDriver_getMediaType \
UInt32	getMediaType();//?

#define IOCDBlockStorageDriver_audioStop \
IOReturn	audioStop();//?
 
#define IOCDBlockStorageDriver_cacheTocInfo \
IOReturn	cacheTocInfo();//?

#define IOCDBlockStorageDriver_audioPlay \
IOReturn	audioPlay(CDMSF a,CDMSF b);//?

#define IOCDBlockStorageDriver_free \
void	free();//?

#define IOCDBlockStorageDriver_reportDiscInfo \
IOReturn reportDiscInfo(CDDiscInfo *a);//?

#define IOCDBlockStorageDriver_reportTrackInfo \
 IOReturn	reportTrackInfo(UInt16 a,CDTrackInfo *b);//?

#define IOCDBlockStorageDriver_audioScan \
IOReturn	audioScan(CDMSF a,bool b);//?

#define IOCDBlockStorageDriver_decommissionMedia \
IOReturn	decommissionMedia(bool a);//?

#define IOCDBlockStorageDriver_writeCD \
void	writeCD(IOService *a,UInt64 b,IOMemoryDescriptor *c,CDSectorArea d,CDSectorType e,IOStorageCompletion f);//?

#define IOCDBlockStorageDriver_executeRequest \
void 	executeRequest(UInt64 a,IOMemoryDescriptor *b,IOStorageCompletion c,Context *d);//?

#define IOCDBlockStorageDriver_readISRC \
IOReturn	readISRC(UInt8 a,CDISRC b);//?

#define IOCDBlockStorageDriver_getMediaBlockSize \
UInt64	getMediaBlockSize(CDSectorArea a,CDSectorType b);//?

#define IOCDBlockStorageDriver_getAudioStatus \
IOReturn	getAudioStatus(CDAudioStatus *a);//?

#define IOCDBlockStorageDriver_setSpeed \
IOReturn	setSpeed(UInt16 a);//?

#define IOCDBlockStorageDriver_readTrackInfo \
IOReturn	readTrackInfo(IOMemoryDescriptor *a,UInt32 b,CDTrackInfoAddressType c,UInt16 *d);//?

#define  IOCDBlockStorageDriver_prepareRequest \
void	prepareRequest(UInt64 a,IOMemoryDescriptor *b,CDSectorArea c,CDSectorType d, IOStorageCompletion e);//?

#define IOCDBlockStorageDriver_getDeviceTypeName \
const char * getDeviceTypeName();//?

#define IOCDBlockStorageDriver_setAudioVolume \
IOReturn	setAudioVolume(UInt8 a,UInt8 b);//?

#define IOCDBlockStorageDriver_recordMediaParameters \
IOReturn	recordMediaParameters();//?

#define IOCDBlockStorageDriver_instantiateDesiredMediaObject \
IOMedia *	instantiateDesiredMediaObject();//?

#define IOCDBlockStorageDriver_readDiscInfo \
IOReturn	readDiscInfo(IOMemoryDescriptor *a,UInt16 *b);//?

#define IOCDBlockStorageDriver_readTOC \
IOReturn	readTOC(IOMemoryDescriptor *a,CDTOCFormat b,UInt8 c,UInt8 d,UInt16 *e);//?

#define IOCDBlockStorageDriver_instantiateMediaObject \
IOMedia *	instantiateMediaObject(UInt64 a,UInt64 b,UInt32 c,char *d);//?

#define IOCDBlockStorageDriver_getAudioVolume \
IOReturn	getAudioVolume(UInt8 *a,UInt8 *b);//?

#define IOCDBlockStorageDriver_readCD \
void	readCD(IOService *a,UInt64 b,IOMemoryDescriptor *c,CDSectorArea d,CDSectorType e,IOStorageCompletion f);//?

#define IOCDBlockStorageDriver_init \
bool	init(OSDictionary * a);//?

#define IOCDBlockStorageDriver_readMCN \
IOReturn	readMCN(CDMCN a);//?

#define IOCDBlockStorageDriver_getTOC \
 CDTOC *	getTOC();//?

#define IOCDBlockStorageDriver_getSpeed \
IOReturn	getSpeed(UInt16 * a);//?

//////////
class  IOCDBlockStorageDriver_HYS
 {

    OSDeclareDefaultStructors(IOCDBlockStorageDriver_HYS)


public://data
struct ExpansionData {
	int minBlockNumberAudio;//?
	int maxBlockNumberAudio;//?
};
 ExpansionData * _expansionData;

#define _minBlockNumberAudio \
 IOCDBlockStorageDriver::_expansionData->minBlockNumberAudio //c
 #define _maxBlockNumberAudio \
IOCDBlockStorageDriver::_expansionData->maxBlockNumberAudio//c

static const int kBlockTypeCD = 0;//?
static const int kBlockSizeCD = 1;//?

CDTOC * _toc;//c
int _tocSize;//?
int _acNub;//?

public://func

};



#endif//HYS_IOKIT_STORAGE_IOCDBLOCKSTORAGEDRIVER_H
