#ifndef HYS_IOKIT_IOCDTYPRS_H
#define HYS_IOKIT_IOCDTYPRS_H

enum {
	kCDSectorSizeWhole,//?
	kCDSectorSizeMode1,//?
	kCDSectorTypeMode1,//?
	kCDSectorTypeCDDA,//?
	kCDSectorSizeMode2Form2,//?
	kCDSectorTypeMode2Form2,//?
	kCDSectorSizeMode2Form1,//?
	kCDSectorTypeMode2Form1,//?
	kCDSectorSizeMode2,//?
	kCDSectorTypeMode2,//?
	kCDTOCFormatPMA,//?
	kCDSectorAreaUser,//?
	kCDMediaTypeR,//?
	kCDMediaTypeRW,//?
	kCDSectorTypeUnknown,//?
	kCDSectorTypeCount,//?
	kCDMediaTypeROM,//?
	kCDTrackInfoAddressTypeTrackNumber,//?
};

struct CDMSF {
	int second;//?
	int minute;//?
	int frame;//?
};
typedef struct CDMSF CDMSF;

struct CDDiscInfo {
	int discStatus;//?
	int erasable;//?
	int lastTrackNumberInLastSessionLSB;//?
	CDMSF lastPossibleStartTimeOfLeadOut;//?
	int firstTrackNumberInLastSessionLSB;//?
	int dataLength;//?
};
typedef struct CDDiscInfo CDDiscInfo;

struct CDTrackInfo {
	int packet;//?
	int blank;//?
	int lastRecordedAddress;//?
	int dataLength;//?
};
typedef struct CDTrackInfo CDTrackInfo;

struct CDAudioStatus {};
typedef struct CDAudioStatus CDAudioStatus;

struct CDTOCDescriptor {
	int point;//?
	int adr;//?
	int session;//?
	CDMSF p;//c
	int control;//?
	int tno;//?
	CDMSF address;//c
	int zero;//?
};
typedef struct CDTOCDescriptor CDTOCDescriptor;

struct CDTOC {
	CDTOCDescriptor descriptors[1];//?
	int length;//?
};
typedef struct CDTOC CDTOC;

struct CDPMADescriptor {
	int adr;//?
	CDMSF p;//c
};
typedef struct CDPMADescriptor CDPMADescriptor;

struct CDPMA {
	int dataLength;//?
	CDPMADescriptor descriptors[1];//?
};
typedef struct CDPMA CDPMA;

typedef int CDTOCFormat;//?
typedef int CDTrackInfoAddressType;//?
typedef int CDMCN;//?
typedef int CDSectorArea;//?
typedef int CDSectorType;//?
typedef int CDISRC;//?
typedef int CDSectorSize;//?

//func
inline int CDTOCGetDescriptorCount(CDTOC *a) {return 0;};//?
inline int CDConvertMSFToClippedLBA(CDMSF a){return 0;};//?
inline CDMSF CDConvertLBAToMSF(int  a){CDMSF aa; return aa;};//?

#endif//HYS_IOKIT_IOCDTYPRS_H
