#ifndef HYS_IOKIT_STORAGE_IOGUIDPARTIONSCHME_H
#define HYS_IOKIT_STORAGE_IOGUIDPARTIONSCHME_H

////////////////////////////////
#define GPT_HDR_SIG "GPT_HDR_SIG"//?
#define kIOGUIDPartitionSchemeClass "kIOGUIDPartitionSchemeClass"//?

/////////////////
struct gpt_hdr {
    	uint8_t  hdr_sig[8];//c
    	uint32_t hdr_crc_self;//c
    	uint32_t hdr_size;//c
   	uint32_t padding;//c
    	uint64_t hdr_lba_table;//c
    	uint32_t hdr_crc_table;//c
   	uint32_t hdr_entries;//c
    	uint32_t hdr_entsz;//c
};

struct gpt_ent {
	uuid_t ent_type;//c
	uuid_t ent_uuid;//c
    	uint64_t ent_lba_start;//c
    	uint64_t ent_lba_end;//c
    	uint16_t ent_name[36];//c
};
////////////////////////////////
#ifdef __cplusplus
class  IOGUIDPartitionScheme_HYS
{
    OSDeclareDefaultStructors(IOGUIDPartitionScheme_HYS);

public://data

OSSet *  _partitions;//c

public://define

#define IOGUIDPartitionScheme_instantiateMediaObject \
IOMedia * instantiateMediaObject( gpt_ent * a, UInt32 b);//?

#define IOGUIDPartitionScheme_isPartitionInvalid \
bool isPartitionInvalid( gpt_ent * a, UInt32  b);//?

#define IOGUIDPartitionScheme_isPartitionCorrupt \
 bool isPartitionCorrupt( gpt_ent *a, UInt32 b);//?

#define IOGUIDPartitionScheme_instantiateDesiredMediaObject \
IOMedia * instantiateDesiredMediaObject( gpt_ent * a, UInt32 b);//?

#define IOGUIDPartitionScheme_isPartitionUsed \
bool isPartitionUsed(gpt_ent * a);//?

#define IOGUIDPartitionScheme_requestProbe \
 IOReturn requestProbe(IOOptionBits a);//?

#define IOGUIDPartitionScheme_init \
bool init(OSDictionary * a = 0);//?

#define IOGUIDPartitionScheme_probe \
IOService * probe(IOService * a, SInt32 * b);//?

#define IOGUIDPartitionScheme_free \
 void free();//?

#define IOGUIDPartitionScheme_scan \
 OSSet * scan(SInt32 * a);//?

#define IOGUIDPartitionScheme_start \
 bool start(IOService *a);//?

#define IOGUIDPartitionScheme_attachMediaObjectToDeviceTree \
bool attachMediaObjectToDeviceTree(IOMedia *a);//?

#define IOGUIDPartitionScheme_stop \
void stop(IOService * a);//?

#define IOGUIDPartitionScheme_detachMediaObjectFromDeviceTree \
void detachMediaObjectFromDeviceTree(IOMedia * a);//?

};
#endif //__cplusplus
#endif//HYS_IOKIT_STORAGE_IOGUIDPARTIONSCHME_H
