#ifndef HYS_IOKIT_STORAGE_IOMEDIABSDCLIENT_H
#define HYS_IOKIT_STORAGE_IOMEDIABSDCLIENT_H

#ifdef __cplusplus
class  IOMediaBSDClient_HYS
{
    OSDeclareDefaultStructors(IOMediaBSDClient_HYS)

public://data

AnchorTable * _anchors;//c
MinorTable *  _minors;//c

public://define

#define IOMediaBSDClient_init \
 bool init(OSDictionary * a = 0);//?

#define IOMediaBSDClient_free \
 void free();//?

#define IOMediaBSDClient_start \
bool start(IOService * a);//?

#define IOMediaBSDClient_createNodes \
bool createNodes(IOMedia *a);//?

#define IOMediaBSDClient_terminate \
bool terminate(IOOptionBits a);//?

#define IOMediaBSDClient_getProvider \
IOMedia * getProvider() const;//?

#define IOMediaBSDClient_getWholeMedia \
IOMedia * getWholeMedia( IOMedia *a, UInt32 *b = 0, char *c = 0 );//?

#define IOMediaBSDClient_getAnchors \
AnchorTable * getAnchors();//?

#define IOMediaBSDClient_getMinors \
MinorTable *  getMinors();//?

#define IOMediaBSDClient_getMinor \
MinorSlot *   getMinor(UInt32 a);//?

#define IOMediaBSDClient_ioctl \
int ioctl(dev_t a, u_long b, caddr_t c, int d, proc_t e);//?

public:

};
#endif //__cplusplus


#endif//HYS_IOKIT_STORAGE_IOMEDIABSDCLIENT_H
