#ifndef HYS_IOKIT_USB_IOUSBCOMPOSITEDRIVER_H
#define HYS_IOKIT_USB_IOUSBCOMPOSITEDRIVER_H

class IOUSBCompositeDriver_HYS
{
    OSDeclareDefaultStructors(IOUSBCompositeDriver_HYS)

public://data

IOUSBDevice*  fDevice;//c
IONotifier * fNotifier;//c

int fConfigbmAttributes;//?
int fConfigValue;//?
int fExpectingClose;//?

public://define

#define IOUSBCompositeDriver_ReConfigureDevice \
IOReturn        ReConfigureDevice();//?

#define IOUSBCompositeDriver_CompositeDriverInterestHandler \
static IOReturn CompositeDriverInterestHandler(void *a, void *b, UInt32 c, IOService *d,  void * e, vm_size_t f);//c

#define IOUSBCompositeDriver_ConfigureDevice \
 bool            ConfigureDevice();//?

#define IOUSBCompositeDriver_didTerminate \
bool            didTerminate( IOService * a, IOOptionBits b, bool * c);//?

#define IOUSBCompositeDriver_willTerminate \
 bool            willTerminate( IOService * a, IOOptionBits b );//?

#define IOUSBCompositeDriver_message \
 IOReturn        message( UInt32 a, IOService * b,  void * c = 0 );//?

#define IOUSBCompositeDriver_start \
bool            start(IOService * a);//?

};


#endif//HYS_IOKIT_USB_IOUSBCOMPOSITEDRIVER_H
