#ifndef HYS_IOKIT_USB_IOUSBHUBPOLUCYMAKER_H
#define HYS_IOKIT_USB_IOUSBHUBPOLUCYMAKER_H

#define kIOUSBHubPowerStateStable 1//c

////////////////
enum {
	kIOUSBHubNumberPowerStates=5,//c
};

enum {
	kIOUSBHubPowerStateLowPower,//?
	kHubResumeRecoveryTime,//?
	kIOUSBHubPowerStateSleep,//?
	kIOUSBHubPowerStateOn,//?
	kIOUSBHubPowerStateOff,//?
	kIOUSBHubPowerStateRestart,//?
	kPortResumeRecoveryTime,//?
};

//////////////////
class  IOUSBHubPolicyMaker_HYS
{
	//OSDeclareAbstractStructors(IOUSBHubPolicyMaker_HYS)

public://data

IOUSBHubDevice* _device;//c
IOUSBControllerV2* _bus;//c
IOUSBHubDevice *_parentHubDevice;//c

int _extraPower;//?
int _dozeEnabled;//?
int _myPowerState;//?
int _extraPowerRemaining;//?
int _isRootHub;//?
int _powerStateChangingTo;//?
int _hubResumeRecoveryTime;//?
int _dontAllowSleepPower;//?
int _dontAllowLowPower;//?

public://define

#define IOUSBHubPolicyMaker_ReturnExtraPortPower \
IOReturn			ReturnExtraPortPower(UInt32 a, UInt32 b);//c

#define IOUSBHubPolicyMaker_AllocateExtraPower \
void				AllocateExtraPower();//c

#define IOUSBHubPolicyMaker_GetExtraPortPower \
IOReturn			GetExtraPortPower(UInt32 a, UInt32 *b);//c

#define IOUSBHubPolicyMaker_EnsureUsability \
IOReturn				EnsureUsability(void);//?

#define IOUSBHubPolicyMaker_powerChangeDone \
void			powerChangeDone ( unsigned long a );//?

#define IOUSBHubPolicyMaker_setPowerState \
IOReturn	setPowerState ( unsigned long a, IOService* b);//?

#define IOUSBHubPolicyMaker_maxCapabilityForDomainState \
unsigned long	maxCapabilityForDomainState ( IOPMPowerFlags a );//?

#define IOUSBHubPolicyMaker_powerStateWillChangeTo \
IOReturn	powerStateWillChangeTo ( IOPMPowerFlags a, unsigned long b, IOService* c);//?

#define IOUSBHubPolicyMaker_powerStateForDomainState \
unsigned long	powerStateForDomainState ( IOPMPowerFlags a );//?

#define IOUSBHubPolicyMaker_start \
bool			start(IOService * a);//?

#define IOUSBHubPolicyMaker_powerStateDidChangeTo \
IOReturn	powerStateDidChangeTo ( IOPMPowerFlags a, unsigned long b, IOService* c);//?

public://func

int ConfigureHubDriver();//?
int HubPowerChange(int a);//?

};


#endif//HYS_IOKIT_USB_IOUSBHUBPOLUCYMAKER_H
