#ifndef HYS_IOKIT_USB_IOUSBINTERFACEUSERCLIENT_H
#define HYS_IOKIT_USB_IOUSBINTERFACEUSERCLIENT_H

enum {
	kSizeToIncrementLowLatencyCommandPool,//?
};

//////////////
typedef struct IOUSBLowLatencyUserClientBufferInfo  IOUSBLowLatencyUserClientBufferInfo;
struct IOUSBLowLatencyUserClientBufferInfo {
	IOMemoryDescriptor *	 bufferDescriptor;//c
	IOBufferMemoryDescriptor *writeDescritporForUHCI;//c
	int frameListKernelAddress;//?
	void* bufferAddress;//c
	int cookie;//?
	int bufferType;//?
	int bufferSize;//?
	IOMemoryMap *writeMapForUHCI;//c
	IOMemoryDescriptor* frameListDescriptor;//c
 	IOMemoryMap* frameListMap;//c
	IOUSBLowLatencyUserClientBufferInfo * nextBuffer;//c
};

////////////////////
class  IOUSBInterfaceUserClientV2_HYS
{
    OSDeclareDefaultStructors(IOUSBInterfaceUserClientV2_HYS)

public://data
struct IOUSBInterfaceUserClientExpansionData    {  };
IOUSBInterfaceUserClientExpansionData *fIOUSBInterfaceUserClientExpansionData;//c

/////////////
IOCommandPool *   fFreeUSBLowLatencyCommandPool;//c
IOUSBInterface *	 fOwner;//c
IOCommandGate *   fGate;//c
IOWorkLoop	*      fWorkLoop;//c
IOUSBLowLatencyUserClientBufferInfo *fUserClientBufferInfoListHead;//c

int fCurrentSizeOfCommandPool;//?
int fOutstandingIO;//?
int fNeedToClose;//?
int fNeedContiguousMemoryForLowLatencyIsoch;//?
int fClientRunningUnderRosetta;//?
int fTask;//?
int fDead;//?
int fWakePort;//?

public:

#define IOUSBInterfaceUserClientV2_sMethods \
static const IOExternalMethodDispatch		sMethods[kIOUSBLibInterfaceUserClientNumCommands];//c

public://define

#define IOUSBInterfaceUserClientV2_PrintExternalMethodArgs \
void PrintExternalMethodArgs( IOExternalMethodArguments * a, UInt32 b );//c

#define IOUSBInterfaceUserClientV2_message \
 IOReturn	message( UInt32 a, IOService * b,  void * c = 0 );//?

#define IOUSBInterfaceUserClientV2_willTerminate \
 bool                                willTerminate( IOService * a, IOOptionBits b );//?

#define IOUSBInterfaceUserClientV2_free \
void                                free();//?

#define IOUSBInterfaceUserClientV2_stop \
void                                stop(IOService * a);//?

#define IOUSBInterfaceUserClientV2_clientClose \
IOReturn                            clientClose( void );//?

#define IOUSBInterfaceUserClientV2_clientDied \
IOReturn                            clientDied( void );//?

#define IOUSBInterfaceUserClientV2_ReleasePreparedDescriptors \
 void                                ReleasePreparedDescriptors();//?

#define IOUSBInterfaceUserClientV2_GetGatedOutstandingIO \
static IOReturn  GetGatedOutstandingIO(OSObject *a, void *b, void *c, void *d, void *e);//c

#define IOUSBInterfaceUserClientV2_ChangeOutstandingIO \
 static IOReturn   ChangeOutstandingIO(OSObject *a, void *b, void *c, void *d,void *e);//c

#define IOUSBInterfaceUserClientV2_RemoveDataBufferFromList \
 bool  RemoveDataBufferFromList( IOUSBLowLatencyUserClientBufferInfo *a);//?

#define IOUSBInterfaceUserClientV2_IncreaseCommandPool \
void                                IncreaseCommandPool();//?

#define IOUSBInterfaceUserClientV2_DoIsochPipeAsync \
IOReturn DoIsochPipeAsync(IOUSBIsocStruct *a, io_user_reference_t * b, uint32_t c, IODirection d);//?

#define IOUSBInterfaceUserClientV2_ControlRequestIn_UInt8_UInt8 \
IOReturn ControlRequestIn(UInt8 a, UInt8 b,  UInt8 c, UInt16 d, UInt16 e, mach_vm_size_t f, mach_vm_address_t g, UInt32 h, UInt32 i, IOUSBCompletion * j);//?

#define IOUSBInterfaceUserClientV2_ControlRequestIn_UInt8 \
IOReturn ControlRequestIn(UInt8 a, UInt8 b, UInt8 c, UInt16 d, UInt16 e, UInt32 f, UInt32 g, void *h, uint32_t *i);//?

#define IOUSBInterfaceUserClientV2_ControlRequestIn \
IOReturn  ControlRequestIn(UInt8 a, UInt8 b, UInt8 c, UInt16 d, UInt16 e, UInt32 f, UInt32 g, IOMemoryDescriptor *h, uint32_t *i);//?

#define IOUSBInterfaceUserClientV2_ControlRequestOut_UInt8_UInt8 \
IOReturn  ControlRequestOut(UInt8 a, UInt8 b,  UInt8 c, UInt16 d, UInt16 e, mach_vm_size_t f, mach_vm_address_t g, UInt32 h, UInt32 i, IOUSBCompletion * j);//?

#define IOUSBInterfaceUserClientV2_ControlRequestOut_UInt8 \
IOReturn ControlRequestOut(UInt8 a, UInt8 b,  UInt8 c, UInt16 d, UInt16 e, UInt32 f, UInt32 g, const void *h, uint32_t i);//?

#define IOUSBInterfaceUserClientV2_ControlRequestOut \
IOReturn  ControlRequestOut(UInt8 a, UInt8 b,  UInt8 c, UInt16 d, UInt16 e, UInt32 f, UInt32 g, IOMemoryDescriptor *h);//?

#define IOUSBInterfaceUserClientV2_SetPipePolicy \
IOReturn SetPipePolicy(UInt8 a, UInt16 b, UInt8 c);//?

#define IOUSBInterfaceUserClientV2_ResetPipe \
IOReturn                            ResetPipe(UInt8 a);//?

#define IOUSBInterfaceUserClientV2_ClearPipeStall \
IOReturn                            ClearPipeStall(UInt8 a, bool b);//?

#define IOUSBInterfaceUserClientV2_didTerminate \
bool   didTerminate( IOService *a, IOOptionBits b, bool * c);//?

#define IOUSBInterfaceUserClientV2_GetPipeProperties \
IOReturn  GetPipeProperties(UInt8 a, uint64_t *b, uint64_t *c, uint64_t *d, uint64_t *e, uint64_t *f);//?

#define IOUSBInterfaceUserClientV2_WritePipe_UInt8_UInt32 \
IOReturn WritePipe(UInt8 a, UInt32 b, UInt32 c, mach_vm_address_t d, mach_vm_size_t e, IOUSBCompletion * f);//?

#define IOUSBInterfaceUserClientV2_WritePipe_UInt8 \
IOReturn  WritePipe(UInt8 a, UInt32 b, UInt32 c, const void *d, UInt32 e);//?

#define IOUSBInterfaceUserClientV2_WritePipe \
IOReturn  WritePipe(UInt8 a, UInt32 b, UInt32 c, IOMemoryDescriptor *d);//?

#define IOUSBInterfaceUserClientV2_GetPipeObj \
IOUSBPipe *                         GetPipeObj(UInt8 a);//?

#define IOUSBInterfaceUserClientV2_ReadPipe_UInt8_UInt32 \
IOReturn	ReadPipe(UInt8 a, UInt32 b, UInt32 c, mach_vm_address_t d, mach_vm_size_t e, IOUSBCompletion * f);//?

#define IOUSBInterfaceUserClientV2_ReadPipe_UInt8 \
IOReturn  ReadPipe(UInt8 a, UInt32 b, UInt32 c, void *d, UInt32 *e);//?

#define IOUSBInterfaceUserClientV2_ReadPipe \
IOReturn  ReadPipe(UInt8 a, UInt32 b, UInt32 c, IOMemoryDescriptor *d, IOByteCount *e);//?

#define IOUSBInterfaceUserClientV2_GetConfigDescriptor \
IOReturn	GetConfigDescriptor(UInt8 a, IOUSBConfigurationDescriptorPtr b, UInt32 *c);//?

#define IOUSBInterfaceUserClientV2_GetConfigDescriptor_UInt8 \
IOReturn	GetConfigDescriptor(UInt8 a, IOMemoryDescriptor * b, uint32_t *c);//?

#define IOUSBInterfaceUserClientV2_GetEndpointProperties \
IOReturn    GetEndpointProperties(UInt8 a, UInt8 b, UInt8 c, uint64_t *d, uint64_t *e, uint64_t *f);//?

#define IOUSBInterfaceUserClientV2_GetFrameListTime \
 IOReturn                            GetFrameListTime(uint64_t *a);//?

#define IOUSBInterfaceUserClientV2_GetBandwidthAvailable \
IOReturn                            GetBandwidthAvailable(uint64_t *a);//?

#define IOUSBInterfaceUserClientV2_GetFrameNumberWithTime \
IOReturn  GetFrameNumberWithTime(IOUSBGetFrameStruct *a, UInt32 *b);//?

#define IOUSBInterfaceUserClientV2_GetMicroFrameNumber \
IOReturn   GetMicroFrameNumber(IOUSBGetFrameStruct *a, UInt32 *b);//?

#define IOUSBInterfaceUserClientV2_GetFrameNumber \
IOReturn                            GetFrameNumber(IOUSBGetFrameStruct *a, UInt32 *b);//?

#define IOUSBInterfaceUserClientV2_GetDevice \
IOReturn                            GetDevice(uint64_t *a);//?

#define IOUSBInterfaceUserClientV2_SetAlternateInterface \
IOReturn                            SetAlternateInterface(UInt8 a);//?

#define IOUSBInterfaceUserClientV2_AbortPipe \
 IOReturn                            AbortPipe(UInt8 a);//?

#define IOUSBInterfaceUserClientV2_GetOutstandingIO \
UInt32                              GetOutstandingIO(void);//?

#define IOUSBInterfaceUserClientV2_close \
IOReturn                            close(void);//?

#define IOUSBInterfaceUserClientV2_IncrementOutstandingIO \
void                                IncrementOutstandingIO(void);//?

#define IOUSBInterfaceUserClientV2_DecrementOutstandingIO \
void                                DecrementOutstandingIO(void);//?

#define IOUSBInterfaceUserClientV2_open \
 IOReturn                            open(bool a);//?

#define IOUSBInterfaceUserClientV2_ReqComplete \
 static void   ReqComplete(void *a, void *b, IOReturn c, UInt32 d);//c

#define IOUSBInterfaceUserClientV2_SetAsyncPort \
IOReturn                            SetAsyncPort(mach_port_t a);//?

#define IOUSBInterfaceUserClientV2_SetAsyncReference \
void						SetAsyncReference(OSAsyncReference64  a);//?

#define IOUSBInterfaceUserClientV2_FindBufferCookieInList \
IOUSBLowLatencyUserClientBufferInfo *	FindBufferCookieInList( UInt32 a);//?

#define IOUSBInterfaceUserClientV2_finalize \
bool                                finalize(IOOptionBits a);//?

#define IOUSBInterfaceUserClientV2_AddDataBufferToList \
void  AddDataBufferToList( IOUSBLowLatencyUserClientBufferInfo * a);//?

#define IOUSBInterfaceUserClientV2_DoLowLatencyIsochPipeAsync \
IOReturn  DoLowLatencyIsochPipeAsync(IOUSBLowLatencyIsocStruct *a, IOUSBLowLatencyIsocCompletion *b, IODirection c);//?

#define IOUSBInterfaceUserClientV2_IsoReqComplete \
static void   IsoReqComplete(void *a, void *b, IOReturn c, IOUSBIsocFrame *d);//c

#define IOUSBInterfaceUserClientV2_initWithTask \
 bool	 initWithTask(task_t a, void *b, UInt32 c, OSDictionary *d);//?

#define IOUSBInterfaceUserClientV2_start \
bool                                start( IOService * a);//?

#define IOUSBInterfaceUserClientV2_GetPipeStatus \
IOReturn                            GetPipeStatus(UInt8 a);//?

#define IOUSBInterfaceUserClientV2_LowLatencyIsoReqComplete \
static void   LowLatencyIsoReqComplete(void *a, void *b, IOReturn c, IOUSBLowLatencyIsocFrame *d);//c

#define IOUSBInterfaceUserClientV2_externalMethod \
IOReturn externalMethod(	uint32_t a, IOExternalMethodArguments *b, IOExternalMethodDispatch * c, OSObject * d, void * e);//?

#define IOUSBInterfaceUserClientV2_LowLatencyPrepareBuffer \
IOReturn    LowLatencyPrepareBuffer(LowLatencyUserBufferInfoV2 *a, uint64_t * b);//?

#define IOUSBInterfaceUserClientV2_LowLatencyReleaseBuffer \
IOReturn         LowLatencyReleaseBuffer(LowLatencyUserBufferInfoV2 *a);//?

#define IOUSBInterfaceUserClientV2__open \
static IOReturn	_open(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__close \
static IOReturn	_close(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define  IOUSBInterfaceUserClientV2__GetDevice \
static IOReturn	_GetDevice(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__GetBandwidthAvailable \
static IOReturn	_GetBandwidthAvailable(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__ReadIsochPipe \
static IOReturn	_ReadIsochPipe(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__LowLatencyReleaseBuffer \
static IOReturn	_LowLatencyReleaseBuffer(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__LowLatencyPrepareBuffer \
static IOReturn	_LowLatencyPrepareBuffer(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__SetAsyncPort \
static IOReturn	_SetAsyncPort(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__LowLatencyWriteIsochPipe \
static IOReturn	_LowLatencyWriteIsochPipe(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__SetAlternateInterface \
static IOReturn	_SetAlternateInterface(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__GetFrameNumber \
static IOReturn	_GetFrameNumber(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__GetPipeProperties \
static IOReturn	_GetPipeProperties(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__ReadPipe \
static IOReturn	_ReadPipe(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__WritePipe \
static IOReturn	_WritePipe(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__GetPipeStatus \
static IOReturn	_GetPipeStatus(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__AbortPipe \
static IOReturn	_AbortPipe(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__ResetPipe \
static IOReturn	_ResetPipe(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__ClearPipeStall \
static IOReturn	_ClearPipeStall(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__ControlRequestOut \
static IOReturn	_ControlRequestOut(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__ControlRequestIn \
static IOReturn	_ControlRequestIn(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__SetPipePolicy \
static IOReturn	_SetPipePolicy(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__GetEndpointProperties \
static IOReturn	_GetEndpointProperties(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__GetMicroFrameNumber \
static IOReturn	_GetMicroFrameNumber(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__GetFrameListTime \
static IOReturn	_GetFrameListTime(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__GetFrameNumberWithTime \
static IOReturn	_GetFrameNumberWithTime(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__WriteIsochPipe \
static IOReturn	_WriteIsochPipe(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__LowLatencyReadIsochPipe \
static IOReturn	_LowLatencyReadIsochPipe(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c

#define IOUSBInterfaceUserClientV2__GetConfigDescriptor \
static IOReturn	_GetConfigDescriptor(IOUSBInterfaceUserClientV2 * a, void *b, IOExternalMethodArguments * c);//c


};//IOUSBInterfaceUserClientV2_HYS

//////////////////

class  IOUSBLowLatencyCommand_HYS
{
    //OSDeclareAbstractStructors(IOUSBLowLatencyCommand_HYS)

public://data
OSAsyncReference64	 fAsyncRef;//c

int fAsyncReferenceCount;//?

public://define

#define IOUSBLowLatencyCommand_NewCommand \
 static IOUSBLowLatencyCommand *	NewCommand(void);//c

#define IOUSBLowLatencyCommand_SetAsyncCount \
 void						SetAsyncCount(uint32_t  a);//?

#define IOUSBLowLatencyCommand_SetAsyncReference \
 void						SetAsyncReference(OSAsyncReference64  a);//?

public://func

int GetFrameBase(){};//?
int GetAsyncReference( OSAsyncReference64* a){};//?
IOMemoryDescriptor *  GetDataBuffer() {};//?
int SetFrameBase(void* a) {};//?
int SetDataBuffer(IOMemoryDescriptor* a) {};//?

};

#endif//HYS_IOKIT_USB_IOUSBINTERFACEUSERCLIENT_H
