#ifndef HYS_IOKIT_USB_IOUSBMASSSTORAGESUBCLASS_H
#define HYS_IOKIT_USB_IOUSBMASSSTORAGESUBCLASS_H


class  IOUSBMassStorageUFIDevice_HYS
{
    OSDeclareDefaultStructors(IOUSBMassStorageUFIDevice_HYS)

public://data

enum {
	kPollingMode_Suspended,//?
	kPollingMode_NewMedia,//?
	kPollingMode_MediaRemoval,//?
};
////////////////////

thread_call_t  fPollingThread;//c

int fMediumBlockCount;//?
int fMediumBlockSize;//?
int fMediumIsWriteProtected;//?
int fMediumPresent;//?
int fPollingMode;//?

public://define

#define IOUSBMassStorageUFIDevice_WRITE_AND_VERIFY \
bool 	WRITE_AND_VERIFY(SCSITaskIdentifier a, IOMemoryDescriptor *b, UInt32 c, SCSICmdField1Bit d, SCSICmdField1Bit  e, SCSICmdField1Bit f, SCSICmdField4Byte g, SCSICmdField2Byte h);//?c

#define IOUSBMassStorageUFIDevice_SEND_DIAGNOSTICS \
bool 	SEND_DIAGNOSTICS(SCSITaskIdentifier a, SCSICmdField1Bit b, SCSICmdField1Bit c, SCSICmdField1Bit d,	SCSICmdField1Bit e);//?c

#define IOUSBMassStorageUFIDevice_SEEK \
bool 	SEEK(SCSITaskIdentifier a, SCSICmdField4Byte b);//?c

#define IOUSBMassStorageUFIDevice_REZERO_UNIT \
bool 	REZERO_UNIT(SCSITaskIdentifier a);//?c

#define IOUSBMassStorageUFIDevice_READ_12 \
bool 	READ_12(SCSITaskIdentifier a,IOMemoryDescriptor *b, UInt32 c, SCSICmdField1Bit d, SCSICmdField1Bit e,	SCSICmdField1Bit f, SCSICmdField4Byte g, SCSICmdField4Byte h);//?c

#define IOUSBMassStorageUFIDevice_VERIFY \
bool 	VERIFY(SCSITaskIdentifier a, SCSICmdField1Bit b, SCSICmdField1Bit c, SCSICmdField1Bit d, SCSICmdField4Byte e, SCSICmdField2Byte f);//?c

#define IOUSBMassStorageUFIDevice_PREVENT_ALLOW_MEDIUM_REMOVAL \
bool	PREVENT_ALLOW_MEDIUM_REMOVAL(SCSITaskIdentifier a, SCSICmdField1Bit b);//?c

#define IOUSBMassStorageUFIDevice_MODE_SELECT_10 \
bool	MODE_SELECT_10(SCSITaskIdentifier a, IOMemoryDescriptor	 *b, SCSICmdField1Bit c, SCSICmdField1Bit d,	SCSICmdField2Byte e);  //?c

#define IOUSBMassStorageUFIDevice_FORMAT_UNIT \
bool 	FORMAT_UNIT(SCSITaskIdentifier a, IOMemoryDescriptor *b, IOByteCount c, SCSICmdField1Byte d, SCSICmdField2Byte e);//?c

#define IOUSBMassStorageUFIDevice_IsParameterValid_SCSICmdField1Byte \
bool	IsParameterValid(SCSICmdField1Byte a, SCSICmdField1Byte b);//c

#define IOUSBMassStorageUFIDevice_IsParameterValid_SCSICmdField2Byte \
bool	IsParameterValid(SCSICmdField2Byte a, SCSICmdField2Byte b);//c

#define IOUSBMassStorageUFIDevice_IsParameterValid \
bool	IsParameterValid(SCSICmdField4Byte a, SCSICmdField4Byte b);//c
	
#define IOUSBMassStorageUFIDevice_WRITE_10 \
bool 	WRITE_10(SCSITaskIdentifier a, IOMemoryDescriptor *b, UInt32 c, SCSICmdField1Bit d, SCSICmdField1Bit e, SCSICmdField1Bit f, SCSICmdField4Byte g, SCSICmdField2Byte h);//?c

#define IOUSBMassStorageUFIDevice_IssueWrite_IOMemoryDescriptor \
IOReturn	IssueWrite(IOMemoryDescriptor *a, UInt64 b, UInt64 c);//?c

#define IOUSBMassStorageUFIDevice_IssueWrite \
IOReturn	IssueWrite(IOMemoryDescriptor *a, UInt64 b, UInt64 c, void *d);//?c

#define IOUSBMassStorageUFIDevice_READ_10 \
bool 	READ_10(	SCSITaskIdentifier a, IOMemoryDescriptor *b, UInt32 c, SCSICmdField1Bit d, SCSICmdField1Bit e,	SCSICmdField1Bit f, SCSICmdField4Byte g, SCSICmdField2Byte  h);//?c

#define IOUSBMassStorageUFIDevice_IssueRead_IOMemoryDescriptor \
IOReturn	IssueRead(IOMemoryDescriptor *a, UInt64 b, UInt64 c);//?c
	
#define IOUSBMassStorageUFIDevice_IssueRead \
IOReturn	IssueRead(IOMemoryDescriptor *a, UInt64 b, UInt64 c, void *d);//?c

#define IOUSBMassStorageUFIDevice_GetNumberOfPowerStateTransitions  \
UInt32		GetNumberOfPowerStateTransitions ( void );//?c

#define IOUSBMassStorageUFIDevice_TicklePowerManager  \
 void		TicklePowerManager ( void );//?c

#define IOUSBMassStorageUFIDevice_HandleCheckPowerState \
void		HandleCheckPowerState ( void );//?c

#define IOUSBMassStorageUFIDevice_HandlePowerChange \
void		HandlePowerChange ( void );//?c

#define IOUSBMassStorageUFIDevice_GetInitialPowerState \
UInt32		GetInitialPowerState ( void );//?c

#define IOUSBMassStorageUFIDevice_MODE_SENSE_10 \
bool	MODE_SENSE_10(SCSITaskIdentifier a, IOMemoryDescriptor 	*b, SCSICmdField1Bit c, SCSICmdField2Bit d, SCSICmdField6Bit e,	SCSICmdField2Byte f );//?c

#define IOUSBMassStorageUFIDevice_READ_CAPACITY \
bool 	READ_CAPACITY(SCSITaskIdentifier a, IOMemoryDescriptor *b, SCSICmdField1Bit c, SCSICmdField4Byte d, SCSICmdField1Bit e);//?c

#define IOUSBMassStorageUFIDevice_READ_FORMAT_CAPACITIES \
bool 	READ_FORMAT_CAPACITIES(SCSITaskIdentifier a, IOMemoryDescriptor *b, SCSICmdField2Byte c);//?c

#define IOUSBMassStorageUFIDevice_DetermineMediumWriteProtectState \
bool		DetermineMediumWriteProtectState( void );//?c

#define IOUSBMassStorageUFIDevice_DetermineMediaPresence \
bool		DetermineMediaPresence( void );//?c

#define IOUSBMassStorageUFIDevice_DetermineMediumCapacity \
bool	DetermineMediumCapacity(UInt64 *a, UInt64 *b);//?c

#define IOUSBMassStorageUFIDevice_WRITE_12 \
bool 	WRITE_12(SCSITaskIdentifier a, IOMemoryDescriptor *b, UInt32 c, SCSICmdField1Bit d, SCSICmdField1Bit e, SCSICmdField1Bit f, SCSICmdField4Byte g, SCSICmdField4Byte h);//?c

#define IOUSBMassStorageUFIDevice_PollForMediaRemoval \
 void		PollForMediaRemoval( void );//?c

#define IOUSBMassStorageUFIDevice_PollForNewMedia \
 void		PollForNewMedia( void );//?c

#define IOUSBMassStorageUFIDevice_ResetMediumCharacteristics \
void		ResetMediumCharacteristics( void );//?c

#define IOUSBMassStorageUFIDevice_SetMediumCharacteristics \
void		SetMediumCharacteristics(UInt32 a, UInt32 b);//?c 

#define IOUSBMassStorageUFIDevice_INQUIRY \
bool	INQUIRY(SCSITaskIdentifier a, IOMemoryDescriptor *b, SCSICmdField1Byte c, SCSICmdField1Byte d);//?c

#define IOUSBMassStorageUFIDevice_START_STOP_UNIT \
bool 	START_STOP_UNIT(	SCSITaskIdentifier a, SCSICmdField1Bit b, SCSICmdField1Bit c, SCSICmdField1Bit d);//?c

#define IOUSBMassStorageUFIDevice_REQUEST_SENSE \
bool 	REQUEST_SENSE(SCSITaskIdentifier a, IOMemoryDescriptor 	*b, SCSICmdField1Byte c );//?c

#define IOUSBMassStorageUFIDevice_TEST_UNIT_READY \
bool 	TEST_UNIT_READY(SCSITaskIdentifier a);//?c

#define IOUSBMassStorageUFIDevice_TerminateDeviceSupport \
void		TerminateDeviceSupport( void );//?c

#define  IOUSBMassStorageUFIDevice_StopDeviceSupport \
void 		StopDeviceSupport ( void );//?c

#define IOUSBMassStorageUFIDevice_ResumeDeviceSupport \
void		ResumeDeviceSupport( void );//?c

#define IOUSBMassStorageUFIDevice_DisablePolling \
 void		DisablePolling( void );//?c

#define IOUSBMassStorageUFIDevice_SuspendDeviceSupport \
void		SuspendDeviceSupport( void );//?c

#define IOUSBMassStorageUFIDevice_CreateStorageServiceNub \
 void 		CreateStorageServiceNub( void );//?c

#define IOUSBMassStorageUFIDevice_DetermineDeviceCharacteristics \
bool		DetermineDeviceCharacteristics( void );//?c

#define IOUSBMassStorageUFIDevice_ClearNotReadyStatus \
bool		ClearNotReadyStatus( void );//?c

#define IOUSBMassStorageUFIDevice_InitializeDeviceSupport \
bool		InitializeDeviceSupport( void);//?c

#define IOUSBMassStorageUFIDevice_EnablePolling \
void		EnablePolling( void );//?:c

#define IOUSBMassStorageUFIDevice_StartDeviceSupport  \
void 		StartDeviceSupport ( void );//?c

#define IOUSBMassStorageUFIDevice_ProcessPoll \
void		ProcessPoll( void );//?c

#define IOUSBMassStorageUFIDevice_sProcessPoll \
static 	void		sProcessPoll( void * a, void * b);//c

#define IOUSBMassStorageUFIDevice_ReportMediumWriteProtection \
bool		ReportMediumWriteProtection( void );//?c

#define IOUSBMassStorageUFIDevice_ReportMediumTotalBlockCount \
UInt64		ReportMediumTotalBlockCount( void );//?c

#define IOUSBMassStorageUFIDevice_GetRevisionString \
char *		GetRevisionString( void );//?c

#define IOUSBMassStorageUFIDevice_GetProductString \
 char *		GetProductString( void );//?c

#define IOUSBMassStorageUFIDevice_GetVendorString \
char *		GetVendorString( void );//?c

#define IOUSBMassStorageUFIDevice_GetFormatCapacities \
UInt32 GetFormatCapacities(UInt64 *a, UInt32 b) const;//?c

#define IOUSBMassStorageUFIDevice_FormatMedium \
IOReturn	FormatMedium(UInt64 a, UInt64 b);//?c

#define IOUSBMassStorageUFIDevice_EjectTheMedium \
IOReturn	EjectTheMedium( void );//?c

#define IOUSBMassStorageUFIDevice_SyncReadWrite \
IOReturn	SyncReadWrite(IOMemoryDescriptor *a,	UInt64 b, UInt64	c, UInt64 d);//?c

#define IOUSBMassStorageUFIDevice_ReportMediumBlockSize \
UInt64		ReportMediumBlockSize( void );//?c

#define IOUSBMassStorageUFIDevice_AsyncReadWrite \
IOReturn	AsyncReadWrite(IOMemoryDescriptor *a, UInt64 b,	UInt64 c, UInt64	 d, void *e);//?c

#define IOUSBMassStorageUFIDevice_AsyncReadWriteComplete \
static void			AsyncReadWriteComplete( SCSITaskIdentifier	a );//c

#define IOUSBMassStorageUFIDevice_ReportDeviceMaxBlocksWriteTransfer \
UInt64		ReportDeviceMaxBlocksWriteTransfer( void );//?c

#define IOUSBMassStorageUFIDevice_ReportDeviceMaxBlocksReadTransfer \
UInt64		ReportDeviceMaxBlocksReadTransfer( void );//?c

#define IOUSBMassStorageUFIDevice_GetDeviceCharacteristicsDictionary \
OSDictionary *		GetDeviceCharacteristicsDictionary ( void );//c

#define IOUSBMassStorageUFIDevice_GetProtocolCharacteristicsDictionary \
OSDictionary *		GetProtocolCharacteristicsDictionary ( void );//c

};//IOUSBMassStorageUFIDevice_HYS

class  IOUSBMassStorageUFISubclass_HYS
{
    OSDeclareDefaultStructors(IOUSBMassStorageUFISubclass_HYS)
public:

#define IOUSBMassStorageUFISubclass_BeginProvidedServices \
bool		BeginProvidedServices( void );//?c

#define IOUSBMassStorageUFISubclass_EndProvidedServices \
bool		EndProvidedServices( void );//?c

};


#endif//HYS_IOKIT_USB_IOUSBMASSSTORAGESUBCLASS_H
