#ifndef HYS_IOKIT_USB_IOUSBPIPE_H
#define HYS_IOKIT_USB_IOUSBPIPE_H

class IOUSBInterface;//add

class IOUSBPipe_HYS
{
    OSDeclareDefaultStructors(IOUSBPipe_HYS)

public://data
struct ExpansionData  {  
	int _speed;//?
	IOUSBDevice *_device;//c
	IOUSBInterface	*_interface;//c
	int _crossEndianCompatible;//?
	int _correctStatus;//?
};
    ExpansionData * _expansionData;
//////////

IOUSBController * _controller;//c
const IOUSBEndpointDescriptor *_descriptor;//c
IOUSBController::Endpoint	_endpoint;//c

int _address;//?
int _status;//?

public://define

#define IOUSBPipe_GetAddress \
USBDeviceAddress GetAddress();//?

#define IOUSBPipe_ClosePipe \
    IOReturn ClosePipe(void);//c

#define IOUSBPipe_Write_IOMemoryDescriptor_UInt32_UInt32_IOUSBCompletion  \
IOReturn Write(IOMemoryDescriptor *a, UInt32 b, UInt32	c, IOUSBCompletion *d = 0);//?

#define IOUSBPipe_Write_IOMemoryDescriptor_IOUSBCompletion  \
IOReturn Write(IOMemoryDescriptor *a, IOUSBCompletion *b= 0);//?
	
#define IOUSBPipe_ControlRequest_IOUSBDevRequest_UInt32_UInt32_IOUSBCompletion \
IOReturn ControlRequest(IOUSBDevRequest* a, UInt32 b, UInt32 c, IOUSBCompletion *d = 0);//?
	
#define IOUSBPipe_ControlRequest_IOUSBDevRequest_IOUSBCompletion \
IOReturn ControlRequest(IOUSBDevRequest	*a, IOUSBCompletion	*b = 0);//?

#define IOUSBPipe_free \
void free();//?

#define IOUSBPipe_InitToEndpoint \
 bool InitToEndpoint(const IOUSBEndpointDescriptor *a, UInt8 b, USBDeviceAddress c, IOUSBController *d);//?

#define IOUSBPipe_ToEndpoint_const_IOUSBEndpointDescriptor_UInt8 \
static IOUSBPipe *ToEndpoint(const IOUSBEndpointDescriptor *a, UInt8 b, USBDeviceAddress c, IOUSBController * d);//c

#define IOUSBPipe_ToEndpoint_const_IOUSBEndpointDescriptor \
static IOUSBPipe *ToEndpoint(const IOUSBEndpointDescriptor *a, IOUSBDevice *b, IOUSBController * c);//c

#define IOUSBPipe_ToEndpoint \
static IOUSBPipe *ToEndpoint(const IOUSBEndpointDescriptor *a,IOUSBDevice *b, IOUSBController * c, IOUSBInterface *d);//c
	
#define IOUSBPipe_Read_IOMemoryDescriptor_IOUSBCompletion_IOByteCount \
IOReturn Read(IOMemoryDescriptor *a, IOUSBCompletion *b = 0, IOByteCount *c = 0);//?
	
#define IOUSBPipe_Read_IOMemoryDescriptor_UInt32_UInt32_IOUSBCompletion_IOByteCount \
IOReturn Read(IOMemoryDescriptor *a, UInt32 b, UInt32 c, IOUSBCompletion *d = 0, IOByteCount *e = 0);//?
	
#define IOUSBPipe_GetMaxPacketSize \
UInt16 GetMaxPacketSize();//?

#define IOUSBPipe_GetInterval \
UInt8 GetInterval();//?

public://func


};//IOUSBPipe_HYS

#endif//HYS_IOKIT_USB_IOUSBPIPE_H
