#ifndef HYS_MSC_MSCKEY_H
#define HYS_MSC_MSCKEY_H

class MscKey_HYS {

protected:

#define MscKey_mConnection \
MscTokenConnection *mConnection;//c

public:

#define MscKey_MscKey \
MscKey() { };//cc

#define MscKey_MscKey_unsigned_int \
MscKey(unsigned int keyNum, MscTokenConnection *connection);//c

#define MscKey_MscKey_const_MSCKeyInfo \
MscKey(const MSCKeyInfo& keyInfo,MscTokenConnection *connection) :MscKeyInfo(keyInfo), mConnection(connection) {};//cc

#define MscKey_convert \
void convert(CssmKey &cssmk);//c

#define MscKey_extAuthenticate \
void extAuthenticate(MSCUChar8 cipherMode,MSCUChar8 cipherDirection,const char *pData,size_t dataSize);//c

#define MscKey_importKey \
void importKey(const MSCKeyACL& keyACL,const void *keyBlob,size_t keyBlobSize, MSCKeyPolicy& keyPolicy,MSCPVoid32 pAddParams=NULL, MSCUChar8 addParamsSize=0);//c

#define MscKey_debugDump  \
IFDUMP(void debugDump());//c

#define MscKey_exportKey \
void exportKey(void *keyBlob,size_t keyBlobSize,MSCPVoid32 pAddParams=NULL, MSCUChar8 addParamsSize=0);//c

#define MscKey_computeCrypt \
void computeCrypt(MSCUChar8 cipherMode, MSCUChar8 cipherDirection, const MSCUChar8 *inputData, size_t inputDataSize, MSCUChar8 *outputData, size_t &outputDataSize);//c

#define MscKey_connection \
MscTokenConnection &connection() { };//c

};

#endif//HYS_MSC_MSCKEY_H
