#ifndef HYS_MSC_MSCTOKEN_G
#define HYS_MSC_MSCTOKEN_G

class MscToken_HYS{

protected:

#define MscToken_mConnection \
MscTokenConnection *mConnection;

#define MscToken_mObjects \
ObjectMap mObjects;

#define MscToken_mKeys  \
KeyMap mKeys;

public://datatype

typedef std::map<std::string, MscObject *> ObjectMap;//c
typedef ObjectMap::const_iterator ConstObjIterator;//c
typedef std::map<MSCUChar8, MscKey *> KeyMap;//c
typedef KeyMap::const_iterator ConstKeyIterator;//c
typedef ObjectMap::iterator ObjIterator;//c

public://data


public://func

#define MscToken_getKey \
MscKey &getKey(MSCUChar8 keyNum);//c

#define MscToken_dumpobjects \
void dumpobjects();//c

#define MscToken__MscToken \
virtual ~MscToken() {};

#define MscToken_kbegin \
ConstKeyIterator kbegin() const {};//c

#define MscToken_kend \
ConstKeyIterator kend()   const {};//c

#define MscToken_end_const \
ConstObjIterator end()   const { };//c

#define MscToken_end \
ObjIterator end() { }	;//c

#define MscToken_begin_const \
ConstObjIterator begin() const {};//c

#define MscToken_begin \
ObjIterator begin() {};//c

#define MscToken_MscToken \
MscToken();//c

#define MscToken_MscToken_MSCTokenConnection \
MscToken(MSCTokenConnection *connection) :mConnection(MscTokenConnection::optional(connection)) {};//c

#define MscToken_loadobjects \
void loadobjects();//c

#define MscToken_getObject \
MscObject &getObject(const std::string &objID);//c

};


#endif//HYS_MSC_MSCTOKEN_G
