#ifndef HYS_OPENDIRECTORY_NSOPNEDIRECTORY_H
#define HYS_OPENDIRECTORY_NSOPNEDIRECTORY_H

//const var  start
extern  NSString *const ODSessionProxyAddress;//?
extern  NSString *const ODSessionProxyUsername;//?
extern  NSString *const ODSessionProxyPassword;//?

//const var end

@interface ODSession (hys)

+(id)defaultSession;//c
+(id)sessionWithOptions:(NSDictionary *)a error:(NSError **) b;//c

@end//ODSession(hys)

@interface ODNode (hys) 

+ (id)nodeWithSession:(ODSession *)a name:(NSString *)b error:(NSError **)c;//c
- (NSArray *)supportedRecordTypes:(NSError **)b;//c
+ (id)nodeWithSession:(ODSession *)a type:(ODNodeType)b error:(NSError **)c;//c
- (NSDictionary *)nodeDetailsForKeys:(NSArray *)a error:(NSError **)b;//c
- (NSArray *)subnodeNames:(NSError **)a;//c

@end//ODNode(hys)

@interface ODQuery (hys)

    void        *_internal;//c

+ (ODQuery *)queryWithNode:(ODNode *)a forRecordTypes:(id)b attribute:(NSString *)c  matchType:(ODMatchType)d queryValues:(id)e returnAttributes:(id)f maximumResults:(NSInteger)g  error:(NSError **)h;//c

+ (ODQuery *)queryWithNode:(ODNode *)a usingPredicate:(NSPredicate *)b returnAttributes:(id)c maximumResults:(NSInteger)d error:(NSError **)e;//c

- (NSArray *)resultsAllowingPartial:(BOOL)a error:(NSError **)b;//c
- (id)delegate;//c

- (id)initWithNode:(ODNode *)a forRecordTypes:(id)b attribute:(NSString *)c matchType:(ODMatchType)d queryValues:(id)e returnAttributes:(id)f maximumResults:(NSInteger)g error:(NSError **)h;//c

- (id)initWithNode:(ODNode *)a usingPredicate:(NSPredicate *)b returnAttributes:(id)c maximumResults:(NSInteger)d error:(NSError **)e;//c

@end//ODQuery (hys)

@interface ODRecord (hys)

- (NSString *)recordName;//c
- (NSDictionary *)recordDetailsForAttributes:(NSArray *)a error:(NSError **)b;//c

@end//ODRecord

@interface NSObject(ODQueryDelegate_HYS)
- (void)results:(NSArray*)a forQuery:(ODQuery *)b error:(NSError *)c;//c
@end

#endif//HYS_OPENDIRECTORY_NSOPNEDIRECTORY_H
