#ifndef HYS_PASSWORDSERVER_REPLICAFILE_H
#define HYS_PASSWORDSERVER_REPLICAFILE_H

@interface ReplicaFile (hys)

-(id)initWithXMLStr:(const char * )a;//?
-(CFStringRef)getNameFromIPAddress:(const char *)a;//?
-(CFMutableDictionaryRef)getReplicaByName:(CFStringRef)a;//?
-(int)addIPAddress:(const char *)a orReplaceIP:(const char *)b inReplica:(CFMutableDictionaryRef)c;//?
-(CFStringRef)xmlString; //c
-(CFStringRef)getUniqueID;//?
-(int)stripSyncDates;//?
-(int)saveXMLData;//?
-(int)getParent;//?
-(int)addIPAddress:(const char *)a toReplica:(CFMutableDictionaryRef)b;//?
-(int)replicaCount;
-(int)getIDRangeForReplica:(CFStringRef)a start:(unsigned long *)b end:(unsigned long *)c;//?
-(int)setReplicaStatus:(int)a  forReplica:(CFMutableDictionaryRef)b;//?
-(int)decommissionReplica:(CFStringRef)a;//?
-(int)setEntryModDateForReplica:(CFMutableDictionaryRef)a;//?

@end//ReplicaFile (hys)

#endif //HYS_PASSWORDSERVER_REPLICAFILE_H
