#ifndef HYS_SECURITY_SECCMSBASE_H
#define HYS_SECURITY_SECCMSBASE_H

enum SECCertUsageEnum {
	certUsageSSLClient,//?
	certUsageSSLServer,//?
	certUsageSSLServerWithStepUp,//?
	certUsageSSLCA,//?
	certUsageEmailSigner,//?
    	certUsageEmailRecipient,//?
 	certUsageObjectSigner,//?
	certUsageUserCertImport,//?
    	certUsageVerifyCA,//?
    	certUsageProtectedObjectSigner,//?
   	certUsageStatusResponder,//?
 	certUsageAnyCA,//?

};
typedef enum SECCertUsageEnum SECCertUsage;

 enum SECOidTag {
	SEC_OID_PKCS7_SIGNED_DATA,//?
	SEC_OID_PKCS7_ENVELOPED_DATA,//?
	SEC_OID_PKCS7_ENCRYPTED_DATA,//?
	SEC_OID_PKCS7_DATA,//?
	SEC_OID_SHA1,//?
	SEC_OID_UNKNOWN,//?
	SEC_OID_MD2,//?
	SEC_OID_MD4,//?
	SEC_OID_MD5,//?
	SEC_OID_SHA256,//?
	SEC_OID_SHA384,//?
	SEC_OID_SHA512,//?
};
typedef enum SECOidTag SECOidTag;

enum SecCmsCertChainMode {
    	SecCmsCMCertChain,//?
};
typedef enum SecCmsCertChainMode SecCmsCertChainMode;

typedef struct SecCmsMessageStr *SecCmsMessageRef;//c
typedef struct SecArenaPoolStr *SecArenaPoolRef;//c
typedef CSSM_X509_ALGORITHM_IDENTIFIER SECAlgorithmID;//c
typedef struct SecCmsDigestContextStr *SecCmsDigestContextRef;//c
typedef struct SecCmsDecoderStr *SecCmsDecoderRef;//c
typedef struct SecCmsContentInfoStr *SecCmsContentInfoRef;//c
typedef struct SecCmsSignedDataStr *SecCmsSignedDataRef;//c
typedef struct SecCmsSignerInfoStr *SecCmsSignerInfoRef;//c
typedef struct SecCmsEnvelopedDataStr *SecCmsEnvelopedDataRef;//c
typedef struct SecCmsEncryptedDataStr *SecCmsEncryptedDataRef;//c
typedef void(*PK11PasswordFunc)(void);//c
typedef SecKeyRef SecSymmetricKeyRef;//c
typedef SecSymmetricKeyRef(*SecCmsGetDecryptKeyCallback)(void *arg, SECAlgorithmID *algid);//c
typedef struct SecCmsRecipientInfoStr *SecCmsRecipientInfoRef;//c
typedef struct SecCmsEncoderStr *SecCmsEncoderRef;//c

#endif//HYS_SECURITY_SECCMSBASE_H
