#ifndef HYS_SECURITY_CSSMTYPE_H
#define HYS_SECURITY_CSSMTYPE_H

#ifdef __cplusplus
extern "C" {
#endif

enum {
	CSSM_KEYUSE_SIGN,//?
	CSSM_INVALID_HANDLE,//?
	CSSM_DB_RECORDTYPE_OPEN_GROUP_START, //?
	CSSM_FALSE,//?
	CSSM_OK,//?
	CSSM_PVC_NONE,//?
	CSSM_PRIVILEGE_SCOPE_NONE,//?
	CSSM_KEY_HIERARCHY_NONE,//?
	CSSM_TRUE,//?
	CSSM_ALGMODE_NONE,//?
	CSSM_ALGID_3DES_3KEY,//?
	CSSM_ALGID_3DES_3KEY_EDE,//?
	CSSM_ALGID_DES,//?
	CSSM_ALGID_RC5,//?
	CSSM_ALGID_RC2,//?
	CSSM_ALGMODE_CBCPadIV8,//?
	CSSM_PADDING_PKCS5,//?
	CSSM_PADDING_PKCS7,//?
	CSSM_ALGID_RC4,//?
	CSSM_ALGID_RSA,//?
	CSSM_SERVICE_CSP,//?
	CSSM_ALGID_DH,//?
	CSSM_KEYUSE_ANY,//?
	CSSM_KEYATTR_RETURN_DATA,//?
	CSSM_KEYATTR_EXTRACTABLE,//?
	CSSM_KEYATTR_RETURN_REF,//?
	CSSM_KEYUSE_DERIVE,//?
	CSSM_ALGID_NONE,//?
	CSSM_ATTRIBUTE_DATA_CRYPTO_DATA,//?
	CSSM_KEYUSE_UNWRAP,//?
	CSSM_CERT_X_509v3,//?
	CSSM_DL_DB_RECORD_ANY,//?
	CSSM_KEYUSE_ENCRYPT,//?
	CSSM_ALGID_DSA,//?
	CSSM_KEYUSE_VERIFY,//?
	CSSM_KEYUSE_WRAP,//?
	CSSM_DB_ATTRIBUTE_FORMAT_BLOB,//?
	CSSM_KEYATTR_SENSITIVE,//?
	CSSM_KEYUSE_DECRYPT,//?
	CSSM_KEYATTR_PERMANENT,//?
	CSSM_CERT_ENCODING_UNKNOWN,//?
	CSSM_WORDID__STAR_,//?
	CSSM_WORDID_LOGIN,//?
	CSSM_WORDID_GENKEY,//?
	CSSM_WORDID_DELETE,//?
	CSSM_WORDID_EXPORT_CLEAR,//?
	CSSM_WORDID_EXPORT_WRAPPED,//?
	CSSM_WORDID_IMPORT_CLEAR,//?
	CSSM_WORDID_SIGN,//?
	CSSM_WORDID_ENCRYPT,//?
	CSSM_WORDID_DECRYPT,//?
	CSSM_WORDID_MAC,//?
	CSSM_WORDID_DERIVE,//?
	CSSM_WORDID_IMPORT_WRAPPED,//?
	CSSM_ACL_AUTHORIZATION_DBS_CREATE,//?
	CSSM_ACL_AUTHORIZATION_DBS_DELETE,//?
	CSSM_DB_ATTRIBUTE_FORMAT_COMPLEX,//?
	CSSM_ACL_AUTHORIZATION_DB_READ,//?
	CSSM_ACL_AUTHORIZATION_DB_INSERT,//?
	CSSM_ACL_AUTHORIZATION_DB_MODIFY,//?
	CSSM_ACL_AUTHORIZATION_DB_DELETE,//?
	CSSM_DB_ATTRIBUTE_FORMAT_STRING,//?
	CSSM_DB_ATTRIBUTE_FORMAT_SINT32,//?
	CSSM_DB_ATTRIBUTE_FORMAT_UINT32,//?
	CSSM_DB_ATTRIBUTE_FORMAT_BIG_NUM,//?
	CSSM_DB_ATTRIBUTE_FORMAT_REAL,//?
	CSSM_DB_ATTRIBUTE_FORMAT_TIME_DATE,//?
	CSSM_DB_ATTRIBUTE_FORMAT_MULTI_UINT32,//?
	CSSM_CERT_ENCODING_DER,//?
	CSSM_TP_ACTION_DEFAULT,//?
	CSSM_CERT_ENCODING_BER,//?
	CSSM_DB_OR,//?
	CSSM_DB_AND,//?
	CSSM_DB_NONE,//?
	CSSM_DB_CONTAINS_INITIAL_SUBSTRING,//?
	CSSM_DB_CONTAINS_FINAL_SUBSTRING,//?
	CSSM_DB_EQUAL,//?
	CSSM_DB_NOT_EQUAL,//?
	CSSM_DB_CONTAINS,//?
	CSSM_DB_LESS_THAN,//?
	CSSM_DB_GREATER_THAN,//?
	CSSM_ATTRIBUTE_DATA_UINT32,//?
	CSSM_ALGCLASS_NONE,//?
	CSSM_KEYHEADER_VERSION,//?
	CSSM_KEYBLOB_RAW,//?
	CSSM_KEYBLOB_RAW_FORMAT_NONE,//?
	CSSM_KEYCLASS_PRIVATE_KEY,//?
	CSSM_KEYATTR_MODIFIABLE,//?
	CSSM_KEYBLOB_RAW_FORMAT_FIPS186,//?
	CSSM_KEYBLOB_RAW_FORMAT_PKCS1,//?
	CSSM_KEYCLASS_PUBLIC_KEY,//?
	CSSM_KEYCLASS_OTHER,//?
	CSSM_KEYBLOB_RAW_FORMAT_OTHER,//?
	CSSM_KEYCLASS_SESSION_KEY,//?
	CSSM_WORDID_COMMENT,//?
	CSSM_DB_RECORDTYPE_SCHEMA_START,//?
	CSSM_KEYBLOB_REFERENCE,//?
	CSSM_KEYBLOB_REF_FORMAT_INTEGER,//?
	CSSM_KEYATTR_PRIVATE,//?
	CSSM_KEYATTR_ALWAYS_SENSITIVE,//?
	CSSM_KEYATTR_NEVER_EXTRACTABLE,//?
	CSSM_KEYUSE_SIGN_RECOVER,//?
	CSSM_KEYUSE_VERIFY_RECOVER,//?
	CSSM_KEYBLOB_WRAPPED,//?
	CSSM_KEYATTR_RETURN_NONE,//?
	CSSM_KEYBLOB_RAW_FORMAT_OCTET_STRING,//?
	CSSM_KEYBLOB_WRAPPED_FORMAT_PKCS7,//?
	CSSM_WORDID_PROMPTED_PASSWORD,//?
	CSSM_WORDID_PASSWORD,//?
	CSSM_DB_ATTRIBUTE_NAME_AS_STRING,//?
	CSSM_DB_INDEX_UNIQUE,//?
	CSSM_DB_INDEX_ON_UNKNOWN,//?
	CSSM_DB_ATTRIBUTE_NAME_AS_INTEGER,//?
	CSSM_ATTRIBUTE_DATA_ACCESS_CREDENTIALS,//?
	CSSM_DB_ATTRIBUTE_NAME_AS_OID,//?
	CSSM_WORDID_PROTECTED_PASSWORD,//?
	CSSM_ACL_EDIT_MODE_REPLACE,//?
	CSSM_ACL_EDIT_MODE_DELETE,//?
	CSSM_ACL_EDIT_MODE_ADD,//?
	CSSM_MODULE_STRING_SIZE,//?
	CSSM_LIST_ELEMENT_WORDID,//?
	CSSM_LIST_TYPE_UNKNOWN,//?
	CSSM_LIST_ELEMENT_DATUM,//?
};//enum
////////////////
enum {
	CSSM_PADDING_NONE=0,//c
	CSSM_PADDING_PKCS1 =CSSM_PADDING_NONE + 10,//c
	CSSM_ALGID_3DES =CSSM_ALGID_NONE + 77,//c
	CSSM_ALGID_CUSTOM =	CSSM_ALGID_NONE + 1,//c
	CSSM_ALGID_MD5 =	CSSM_ALGID_NONE + 7,//c
    	CSSM_ATTRIBUTE_PADDING =	CSSM_ATTRIBUTE_DATA_UINT32| 6,//c
	CSSM_ALGCLASS_SIGNATURE =	CSSM_ALGCLASS_NONE + 2,//c
	CSSM_ALGID_SHA1 =CSSM_ALGID_NONE + 8,//c
	CSSM_ALGCLASS_ASYMMETRIC =	CSSM_ALGCLASS_NONE + 8,//c
	CSSM_ACL_SUBJECT_TYPE_ANY =	CSSM_WORDID__STAR_,//c
	CSSM_DB_RECORDTYPE_SCHEMA_END =CSSM_DB_RECORDTYPE_SCHEMA_START + 4,//c
	CSSM_DL_DB_RECORD_GENERIC =	CSSM_DB_RECORDTYPE_OPEN_GROUP_START + 4,//c
	CSSM_SAMPLE_TYPE_PROMPTED_PASSWORD =	CSSM_WORDID_PROMPTED_PASSWORD,//c
	CSSM_SAMPLE_TYPE_PASSWORD =CSSM_WORDID_PASSWORD,//c
	CSSM_DL_DB_SCHEMA_INFO =CSSM_DB_RECORDTYPE_SCHEMA_START + 0,//c
	CSSM_DL_DB_SCHEMA_ATTRIBUTES =CSSM_DB_RECORDTYPE_SCHEMA_START + 2,//c
	CSSM_DL_DB_SCHEMA_INDEXES =CSSM_DB_RECORDTYPE_SCHEMA_START + 1,//c
  	 CSSM_ATTRIBUTE_ACCESS_CREDENTIALS =CSSM_ATTRIBUTE_DATA_ACCESS_CREDENTIALS	| 36,//c
	CSSM_SAMPLE_TYPE_PROTECTED_PASSWORD =	CSSM_WORDID_PROTECTED_PASSWORD,//c
	CSSM_ACL_SUBJECT_TYPE_PROTECTED_PASSWORD =CSSM_WORDID_PROTECTED_PASSWORD,//c
	CSSM_ACL_SUBJECT_TYPE_PROMPTED_PASSWORD =	CSSM_WORDID_PROMPTED_PASSWORD,//c
	CSSM_ACL_SUBJECT_TYPE_PASSWORD =CSSM_WORDID_PASSWORD,//c
};

////////////////

typedef uint32 CSSM_DB_RECORDTYPE;
typedef CSSM_INTPTR CSSM_HANDLE;//c
typedef CSSM_HANDLE *CSSM_MODULE_HANDLE_PTR;//c
typedef CSSM_HANDLE CSSM_MODULE_HANDLE;//c
typedef CSSM_MODULE_HANDLE CSSM_CSP_HANDLE; //c
typedef uint32 CSSM_KEYUSE;//c                                               
typedef uint32 CSSM_ALGORITHMS;//c
typedef sint32 CSSM_BOOL;//c
typedef uint32 CSSM_BITMASK;//c
typedef CSSM_BITMASK CSSM_PVC_MODE;//c
typedef uint64 CSSM_LONG_HANDLE;//c
typedef CSSM_LONG_HANDLE CSSM_CC_HANDLE; //c
typedef uint32 CSSM_ENCRYPT_MODE;//c
typedef uint32 CSSM_PADDING;//c
typedef uint32 CSSM_DB_MODIFY_MODE;//c
typedef uint32 CSSM_KEYATTR_FLAGS;//c
typedef uint32 CSSM_DB_ACCESS_TYPE;//c
typedef sint32 CSSM_ACL_SUBJECT_TYPE;//c
typedef uint32 CSSM_ATTRIBUTE_TYPE;//c
typedef uint32 CSSM_ACL_EDIT_MODE;//c
typedef CSSM_HANDLE CSSM_ACL_HANDLE;//c
typedef uint32 CSSM_SERVICE_MASK;//c
typedef CSSM_SERVICE_MASK CSSM_SERVICE_TYPE;//c
typedef uint32 CSSM_DB_ATTRIBUTE_FORMAT;//c
typedef uint32 CSSM_DB_OPERATOR;//c
typedef uint32 CSSM_CERT_TYPE;//c
typedef uint32 CSSM_CERT_ENCODING;//c
typedef uint32 CSSM_DB_CONJUNCTIVE;//c
typedef uint32 CSSM_QUERY_FLAGS;//c
typedef uint32 CSSM_CONTEXT_TYPE;//c
typedef uint32 CSSM_HEADERVERSION;//c
typedef uint32 CSSM_KEYBLOB_FORMAT;//c
typedef uint32 CSSM_KEYBLOB_TYPE;//c
typedef CSSM_ALGORITHMS CSSM_KEY_TYPE;//c
typedef uint32 CSSM_KEYCLASS;//c
typedef sint32 CSSM_WORDID_TYPE;//c
typedef uint32 CSSM_DB_ATTRIBUTE_NAME_FORMAT;//c
typedef char CSSM_STRING [CSSM_MODULE_STRING_SIZE + 4];//c

///////////////
struct cssm_data {
	CSSM_SIZE Length;//c
	uint8 *Data;//c
};
typedef struct cssm_data CSSM_DATA;
typedef CSSM_DATA  *CSSM_DATA_PTR;
typedef CSSM_DATA CSSM_OID;//c

struct cssm_date {};
typedef struct cssm_date CSSM_DATE;
typedef CSSM_DATE *CSSM_DATE_PTR;

struct cssm_keyheader {
	CSSM_ALGORITHMS AlgorithmId;//c
   	CSSM_HEADERVERSION HeaderVersion;//c
    	uint32 LogicalKeySizeInBits;//c
    	CSSM_KEYATTR_FLAGS KeyAttr;//c
 	CSSM_KEYUSE KeyUsage;//c
 	CSSM_DATE StartDate;//c
  	CSSM_DATE EndDate;//c
};
typedef struct cssm_keyheader CSSM_KEYHEADER;

struct cssm_key {
	CSSM_DATA KeyData;//c
	CSSM_KEYHEADER KeyHeader;//c
};
typedef struct cssm_key CSSM_KEY;
typedef struct cssm_key *CSSM_KEY_PTR;

struct cssm_version {
	int a;//dummy
	int b;//dummy
};
typedef struct cssm_version CSSM_VERSION;
typedef CSSM_VERSION *CSSM_VERSION_PTR;

struct cssm_guid {
	int a;//dummy
	int b;//dummy
	int c;//dummy
	int d[8];//dummy
};
typedef struct cssm_guid CSSM_GUID;//?

typedef void *( *CSSM_MALLOC)(uint32 a,void *b);//c
typedef void (*CSSM_FREE) (void *a,void *b);//c
typedef void *(*CSSM_REALLOC) (void *a,uint32 b,void *c);//c
typedef void *(*CSSM_CALLOC)(uint32 a,uint32 b,void *c);//c

struct cssm_memory_funcs {
	CSSM_MALLOC a;//dummy
	CSSM_FREE b;//dummy
	CSSM_REALLOC c;//dummy
	CSSM_CALLOC d;//dummy
	int e;//dummy
};
typedef struct cssm_memory_funcs CSSM_MEMORY_FUNCS;
typedef CSSM_MEMORY_FUNCS CSSM_API_MEMORY_FUNCS;//c

struct cssm_access_credentials {
	CSSM_STRING EntryTag;//c
};
typedef struct cssm_access_credentials CSSM_ACCESS_CREDENTIALS;//?

struct cssm_db_attribute_info {
    	union cssm_db_attribute_label {
        	char *AttributeName;//c
   		CSSM_OID AttributeOID;//c
     		uint32 AttributeID;//c
	} Label;
    	CSSM_DB_ATTRIBUTE_FORMAT AttributeFormat;//c
   	CSSM_DB_ATTRIBUTE_NAME_FORMAT AttributeNameFormat;//c
};
typedef struct cssm_db_attribute_info CSSM_DB_ATTRIBUTE_INFO;

struct cssm_db_attribute_data {
    	CSSM_DB_ATTRIBUTE_INFO Info;//c
    	uint32 NumberOfValues;//c
    	CSSM_DATA_PTR Value;//c
};
typedef struct cssm_db_attribute_data  CSSM_DB_ATTRIBUTE_DATA;
typedef CSSM_DB_ATTRIBUTE_DATA *CSSM_DB_ATTRIBUTE_DATA_PTR;

struct cssm_db_record_attribute_data {
    	CSSM_DB_RECORDTYPE DataRecordType;//c
 	uint32 SemanticInformation;//c
  	uint32 NumberOfAttributes;//c
    	CSSM_DB_ATTRIBUTE_DATA_PTR AttributeData;//c
};
typedef struct cssm_db_record_attribute_data CSSM_DB_RECORD_ATTRIBUTE_DATA;

struct cssm_selection_predicate {
    	CSSM_DB_OPERATOR DbOperator;//c
    	CSSM_DB_ATTRIBUTE_DATA Attribute;//c
};
typedef  struct cssm_selection_predicate CSSM_SELECTION_PREDICATE;
typedef CSSM_SELECTION_PREDICATE *CSSM_SELECTION_PREDICATE_PTR;

struct cssm_query {
    	CSSM_DB_CONJUNCTIVE Conjunctive;//c
    	CSSM_QUERY_FLAGS QueryFlags;//c
    	CSSM_SELECTION_PREDICATE_PTR SelectionPredicate;//c
 	uint32 NumSelectionPredicates;//
    	CSSM_DB_RECORDTYPE RecordType;//c
};
typedef struct cssm_query  CSSM_QUERY;

struct cssm_key_size {
    	uint32 LogicalKeySizeInBits;//c
    	uint32 EffectiveKeySizeInBits;//c
};
typedef struct cssm_key_size CSSM_KEY_SIZE;

struct cssm_context_attribute {};
typedef struct cssm_context_attribute CSSM_CONTEXT_ATTRIBUTE;
typedef CSSM_CONTEXT_ATTRIBUTE *CSSM_CONTEXT_ATTRIBUTE_PTR;

struct cssm_context {
 	CSSM_CONTEXT_ATTRIBUTE_PTR ContextAttributes;//c
};
typedef struct cssm_context  CSSM_CONTEXT;

struct cssm_list {};
typedef struct cssm_list CSSM_LIST;

struct cssm_authorizationgroup {};
typedef struct cssm_authorizationgroup CSSM_AUTHORIZATIONGROUP; 

struct cssm_acl_validity_period { };
typedef struct cssm_acl_validity_period CSSM_ACL_VALIDITY_PERIOD; 

struct cssm_acl_entry_prototype {
    CSSM_LIST TypedSubject;
    CSSM_BOOL Delegate;
    CSSM_AUTHORIZATIONGROUP Authorization;
    CSSM_ACL_VALIDITY_PERIOD TimeRange;
    CSSM_STRING EntryTag;
};//c
typedef struct cssm_acl_entry_prototype CSSM_ACL_ENTRY_PROTOTYPE;

struct cssm_acl_owner_prototype {
	int a;//dummy
	int b;//dummy
};
typedef struct cssm_acl_owner_prototype CSSM_ACL_OWNER_PROTOTYPE;

struct cssm_acl_entry_info {
	CSSM_ACL_ENTRY_PROTOTYPE a;//dummy
	CSSM_ACL_HANDLE b;//dummy
};
typedef struct  cssm_acl_entry_info CSSM_ACL_ENTRY_INFO;

struct cssm_acl_edit {};
typedef struct  cssm_acl_edit CSSM_ACL_EDIT;

struct cssm_csp_operational_statistics {};
typedef struct  cssm_csp_operational_statistics CSSM_CSP_OPERATIONAL_STATISTICS; 

struct cssm_subservice_uid {} ;
typedef struct cssm_subservice_uid CSSM_SUBSERVICE_UID;

struct cssm_crypto_data {};
typedef struct cssm_crypto_data CSSM_CRYPTO_DATA;

struct cssm_query_size_data {};
typedef struct cssm_query_size_data CSSM_QUERY_SIZE_DATA;

struct cssm_list_element {
    	union {
        	CSSM_DATA Word;//c
	} Element;
};
typedef struct cssm_list_element CSSM_LIST_ELEMENT;

struct cssm_acl_entry_input {};
typedef struct cssm_acl_entry_input  CSSM_ACL_ENTRY_INPUT;

struct cssm_sample {};
typedef struct cssm_sample CSSM_SAMPLE;

struct cssm_samplegroup {};
typedef struct cssm_samplegroup  CSSM_SAMPLEGROUP;

struct cssm_resource_control_context {};
typedef struct cssm_resource_control_context CSSM_RESOURCE_CONTROL_CONTEXT;

struct cssm_net_address {};
typedef struct cssm_net_address CSSM_NET_ADDRESS;

struct cssm_dl_db_handle {};
typedef struct cssm_dl_db_handle CSSM_DL_DB_HANDLE;
typedef CSSM_DL_DB_HANDLE *CSSM_DL_DB_HANDLE_PTR;

struct cssm_dl_db_list {};
typedef struct cssm_dl_db_list  CSSM_DL_DB_LIST;

struct cssm_db_record_attribute_info {};
typedef struct cssm_db_record_attribute_info  CSSM_DB_RECORD_ATTRIBUTE_INFO;

struct cssm_db_index_info {};
typedef  struct cssm_db_index_info CSSM_DB_INDEX_INFO;

struct cssm_pkcs5_pbkdf2_params {};
typedef struct cssm_pkcs5_pbkdf2_params CSSM_PKCS5_PBKDF2_PARAMS;

struct cssm_range {};
typedef struct cssm_range CSSM_RANGE;
typedef CSSM_RANGE *CSSM_RANGE_PTR;

struct cssm_db_unique_record {};
typedef struct cssm_db_unique_record  CSSM_DB_UNIQUE_RECORD;
typedef struct cssm_db_unique_record * CSSM_DB_UNIQUE_RECORD_PTR;

struct cssm_field { 
    	CSSM_OID FieldOid;//c
  	CSSM_DATA FieldValue;//c
};
typedef struct cssm_field  CSSM_FIELD;
typedef struct cssm_field* CSSM_FIELD_PTR;

//////////////////

typedef sint32 CSSM_RETURN;//c

typedef CSSM_RETURN (CSSMAPI *CSSM_CALLBACK)
    (CSSM_DATA_PTR OutData, void *CallerCtx);//c

typedef CSSM_MODULE_HANDLE CSSM_CL_HANDLE;//c

////////////////



#ifdef __cplusplus
}
#endif

#endif//HYS_SECURITY_CSSMTYPE_H

