#ifndef HYS_DEVICE_DEVICE_TYPES_H
#define HYS_DEVICE_DEVICE_TYPES_H


#if KERNEL
typedef uint64_t		io_user_reference_t;
#else
typedef natural_t		io_user_reference_t;
#endif //KERNEL

typedef char  io_name_t[1];//?
typedef int  io_string_t[1];//?
typedef char io_struct_inband_t[1];//.?
typedef uint64_t  io_async_ref64_t[1];//?
typedef int io_scalar_inband_t[1];//?

#ifdef IOKIT

#ifdef MACH_KERNEL

typedef struct IOObject * io_object_t;//c

#else

#ifndef	__IOKIT_PORTS_DEFINED__
#define __IOKIT_PORTS_DEFINED__
typedef mach_port_t io_object_t;//c
#endif	/* __IOKIT_PORTS_DEFINED__ */

#endif  /* MACH_KERNEL */

#endif  /* IOKIT */


#endif //HYS_DEVICE_DEVICE_TYPES_H


