#ifndef HYS_I386_MACHINE_ROUTINES_H
#define HYS_I386_MACHINE_ROUTINES_H

#define MACHINE_GROUP 1//?
#define MACHINE_NETWORK_GROUP 2//?
#define MACHINE_NETWORK_WORKLOOP 3//?

typedef void (*time_base_enable_t)(cpu_id_t a, boolean_t b);//c
typedef void (* ipi_handler_t)(void);//c

struct ml_processor_info_t{
	int boot_cpu;//?
	int cpu_id;//?
	int l2cr_value;//?
	int supports_nap;//?
	time_base_enable_t  time_base_enable;//c
	int start_paddr;//?
};
typedef struct ml_processor_info_t  ml_processor_info_t;//?

int ml_at_interrupt_context();//?
int ml_processor_register(int a,int b,int c,int d,int e);//?
int ml_phys_write(int a,int b);//?
int ml_thread_policy(int a,int b,int c);//?

#endif //HYS_I386_MACHINE_ROUTINES_H
