#ifndef HYS_KERN_THREAD_CALL_H
#define HYS_KERN_THREAD_CALL_H

typedef void * thread_call_param_t;//c
typedef struct call_entry * thread_call_t;//c
typedef void				(*thread_call_func_t)(thread_call_param_t		param0,	thread_call_param_t		param1);//c
////////////////////////////////////

extern thread_call_t thread_call_allocate(thread_call_func_t		func,thread_call_param_t		param0);//c
extern boolean_t thread_call_enter1(	thread_call_t			call,	thread_call_param_t		param1);//c
extern boolean_t  thread_call_cancel(	thread_call_t		call);//c
extern boolean_t thread_call_free(	thread_call_t		call);//c
extern boolean_t thread_call_enter( 	thread_call_t		call);//c
extern boolean_t thread_call_enter_delayed(	thread_call_t		call, 	uint64_t			deadline);//c
extern boolean_t thread_call_enter1_delayed( 	thread_call_t			call,	thread_call_param_t		param1,	uint64_t				deadline);//c
extern void thread_call_func_delayed( thread_call_func_t a, thread_call_param_t b, uint64_t c);//c
extern boolean_t	thread_call_func_cancel(thread_call_func_t		func,thread_call_param_t		param,boolean_t				cancel_all);//c
extern boolean_t	thread_call_is_delayed(thread_call_t		call,uint64_t			*deadline);//c

#endif //HYS_KERN_THREAD_CALL_H
