#ifndef HYS_KVBUF_H
#define HYS_KVBUF_H

struct kvbuf_t {
	int datalen;//?
	char *databuf;//c
};
typedef struct kvbuf_t kvbuf_t;

struct kvdict_t {
	int kcount;//?
	const char **key;//c
	uint32_t *vcount;//c
	const char *** val;//c
};
typedef struct kvdict_t kvdict_t;

struct kvarray_t {
	kvdict_t * dict;//c
	int kv;//?
	int curr;//?
	int count;//?
};
typedef struct kvarray_t kvarray_t;

kvbuf_t * kvbuf_init(char * a,int b);//?
int kvbuf_free(kvbuf_t * a);//?
kvbuf_t * kvbuf_new();//?
int kvbuf_add_dict(kvbuf_t * a);//?
int kvbuf_add_key(kvbuf_t * a,const char * b);//?
int kvbuf_add_val(kvbuf_t * a,const char * b);//?
int kvbuf_append_kvbuf(kvbuf_t * a,const kvbuf_t *b);//?
int kvbuf_reset(kvbuf_t *a);//?
int kvbuf_next_dict(kvbuf_t *a);//?
kvarray_t * kvbuf_decode(kvbuf_t * a);//c
int kvarray_free(kvarray_t * a);//?
char *kvbuf_next_key(kvbuf_t * a,uint32_t * b);//c
char *kvbuf_next_val(kvbuf_t *a);//c
int kvbuf_add_val_len(kvbuf_t *a,const char * b,int c);//?

#endif //HYS_KVBUF_H
