#ifndef HYS_LIBSA_MKEXT_H
#define HYS_LIBSA_MKEXT_H

#define MKEXT_MAGIC 'MKXT'//c
#define MKEXT_SIGN 'MOSX'//c
///////////////////////////
typedef struct mkext_file {
 	size_t offset;//c
   	size_t realsize;//c
   	size_t compsize;//c
    	time_t modifiedsecs;//c
} mkext_file;

typedef struct mkext_kext {
    mkext_file plist;      
    mkext_file module; 
} mkext_kext;//c

typedef struct mkext_header {
   	u_int32_t magic; //c
 	u_int32_t signature;//c
  	u_int32_t version; //c
 	u_int32_t numkexts;//c
	cpu_type_t cputype;//c
    	cpu_subtype_t cpusubtype;//c
    	mkext_kext kext[1];  //c
	u_int32_t length;//c
   	u_int32_t adler32;//c
} mkext_header;

#endif//HYS_LIBSA_MKEXT_H
