#ifndef HYS_MACH_O_RELOC_H
#define HYS_MACH_O_RELOC_H

#define R_SCATTERED 1//?
#define R_ABS 2//?

//////////////////////
enum reloc_type_generic
{
    GENERIC_RELOC_VANILLA,	
    GENERIC_RELOC_PAIR,		
    GENERIC_RELOC_SECTDIFF,
    GENERIC_RELOC_PB_LA_PTR,
    GENERIC_RELOC_LOCAL_SECTDIFF
};//c
///////////////////////

struct scattered_relocation_info {
#ifdef __BIG_ENDIAN__
   	uint32_t	r_scattered:1,	
	r_pcrel:1,
	r_length:2,	
	r_type:4,	
   	r_address:24;	
	  int32_t	r_value;
#endif /* __BIG_ENDIAN__ */
#ifdef __LITTLE_ENDIAN__
   	uint32_t r_address:24,
			r_type:4,
		r_length:2,
		r_pcrel:1, 	
		r_scattered:1;
	   int32_t	r_value;					
#endif /* __LITTLE_ENDIAN__ */
};

#endif//HYS_MACH_O_RELOC_H
