#ifndef HYS_MACH_I386_THREAD_STATUS_H
#define HYS_MACH_I386_THREAD_STATUS_H

#define i386_THREAD_STATE_COUNT	((mach_msg_type_number_t) \
    ( sizeof (i386_thread_state_t) / sizeof (int) ))//c

#define i386_FLOAT_STATE_COUNT ((mach_msg_type_number_t) \
		(sizeof(i386_float_state_t)/sizeof(unsigned int)))//c

#define I386_EXCEPTION_STATE_COUNT i386_EXCEPTION_STATE_COUNT//c

#define i386_EXCEPTION_STATE_COUNT	((mach_msg_type_number_t) \
    ( sizeof (i386_exception_state_t) / sizeof (int) ))//c

#define x86_THREAD_STATE64_COUNT	((mach_msg_type_number_t) \
    ( sizeof (x86_thread_state64_t) / sizeof (int) ))//c

/////////////
#define i386_THREAD_STATE 1//?
#define i386_FLOAT_STATE 2//?
#define i386_EXCEPTION_STATE 3//?
#define USER_DATA_SELECTOR 4//?
#define USER_CODE_SELECTOR 5//?
#define x86_THREAD_STATE 6//?
#define x86_THREAD_STATE64 7//?

/////////////
typedef _STRUCT_X86_THREAD_STATE32 i386_thread_state_t;//c
typedef _STRUCT_X86_EXCEPTION_STATE32 i386_exception_state_t;//c
typedef _STRUCT_X86_FLOAT_STATE32 i386_float_state_t;//c
typedef _STRUCT_X86_THREAD_STATE64 x86_thread_state64_t;//c

#endif//HYS_MACH_I386_THREAD_STATUS_H
