#ifndef HYS_MACH_M68K_THREAD_STATUS_H
#define HYS_MACH_M68K_THREAD_STATUS_H

#define	M68K_THREAD_STATE_REGS	(1)//c
#define	M68K_THREAD_STATE_REGS_COUNT (sizeof (struct m68k_thread_state_regs) / sizeof (int))//c
#define M68K_THREAD_STATE_68882	(2)//c

#define	M68K_THREAD_STATE_68882_COUNT \
	(sizeof (struct m68k_thread_state_68882) / sizeof (int))//c

#define M68K_THREAD_STATE_USER_REG (3)	//c

#define M68K_THREAD_STATE_USER_REG_COUNT \
	(sizeof (struct m68k_thread_state_user_reg) / sizeof (int))//c

///////////

struct m68k_thread_state_regs {
	int	dreg[8];
	int	areg[8];	
	short	pad0;		
	short	sr;		
	int	pc;		
};//c

struct m68k_thread_state_68882 {
	struct {
		int	fp[3];	
	} regs[8];
	int	cr;			
	int	sr;			
	int	iar;			
	int	state;		
};//c

struct m68k_thread_state_user_reg {
	int	user_reg;	
};//c

#endif//HYS_MACH_M68K_THREAD_STATUS_H
