#ifndef HYS_MACH_M88K_THREAD_STATUS_H
#define HYS_MACH_M88K_THREAD_STATUS_H

#define	M88K_THREAD_STATE_GRF		(1)//c

#define	M88K_THREAD_STATE_GRF_COUNT 	\
	(sizeof(m88k_thread_state_grf_t)/sizeof(int))//c

#define M88K_THREAD_STATE_XRF		(2)	//c

#define	M88K_THREAD_STATE_XRF_COUNT 		\
	(sizeof(m88k_thread_state_xrf_t)/sizeof(int))//c

#define	M88K_THREAD_STATE_USER		(3)//c

#define M88K_THREAD_STATE_USER_COUNT 		\
	(sizeof(m88k_thread_state_user_t)/sizeof(int))//c

#define M88110_THREAD_STATE_IMPL	(4)//c

#define	M88110_THREAD_STATE_IMPL_COUNT	\
	(sizeof(m88110_thread_state_impl_t)/sizeof(int))//c
//////////////

#define M88110_N_DATA_BP 1//?

/////////////

enum m88110_iresult_size_t {
	enum_m88110_iresult_size_t //dummy
};
typedef enum m88110_iresult_size_t m88110_iresult_size_t;

enum m88110_match_t {
	M88110_MATCH_BYTE,//?
	M88110_MATCH_SHORT,//?
	M88110_MATCH_WORD,//?
	M88110_MATCH_DOUBLE,//?
	M88110_MATCH_QUAD,//?
	M88110_MATCH_32,//?
	M88110_MATCH_64,//?
	M88110_MATCH_128,//?
	M88110_MATCH_256,//?
	M88110_MATCH_512,//?
	M88110_MATCH_1024,//?
	M88110_MATCH_2048,//?
	M88110_MATCH_4096,//?
};
typedef enum m88110_match_t m88110_match_t;
/////////////
struct _m88k_thread_state_grf {
	unsigned	r1;	
	unsigned	r2;		
	unsigned	r3;	
	unsigned	r4;		
	unsigned	r5;		
	unsigned	r6;		
	unsigned	r7;		
	unsigned	r8;		
	unsigned	r9;		
	unsigned	r10;		
	unsigned	r11;		
	unsigned	r12;		
	unsigned	r13;		
	unsigned	r14;		
	unsigned	r15;		
	unsigned	r16;		
	unsigned	r17;		
	unsigned	r18;		
	unsigned	r19;		
	unsigned	r20;		
	unsigned	r21;		
	unsigned	r22;		
	unsigned	r23;		
	unsigned	r24;		
	unsigned	r25;		
	unsigned	r26;		
	unsigned	r27;		
	unsigned	r28;		
	unsigned	r29;		
	unsigned	r30;		
	unsigned	r31;		
	unsigned	xip;		
	unsigned	xip_in_bd;	
	unsigned	nip;		
};//c
typedef struct _m88k_thread_state_grf m88k_thread_state_grf_t;

struct _m88k_thread_state_xrf {
	m88k_xrf_t	x1;			
	m88k_xrf_t	x2;
	m88k_xrf_t	x3;
	m88k_xrf_t	x4;
	m88k_xrf_t	x5;
	m88k_xrf_t	x6;
	m88k_xrf_t	x7;
	m88k_xrf_t	x8;
	m88k_xrf_t	x9;
	m88k_xrf_t	x10;
	m88k_xrf_t	x11;
	m88k_xrf_t	x12;
	m88k_xrf_t	x13;
	m88k_xrf_t	x14;
	m88k_xrf_t	x15;
	m88k_xrf_t	x16;
	m88k_xrf_t	x17;
	m88k_xrf_t	x18;
	m88k_xrf_t	x19;
	m88k_xrf_t	x20;
	m88k_xrf_t	x21;
	m88k_xrf_t	x22;		
	m88k_xrf_t	x23;
	m88k_xrf_t	x24;
	m88k_xrf_t	x25;
	m88k_xrf_t	x26;
	m88k_xrf_t	x27;
	m88k_xrf_t	x28;
	m88k_xrf_t	x29;
	m88k_xrf_t	x30;		
	m88k_xrf_t	x31;
	m88k_fpsr_t	fpsr;			
	m88k_fpcr_t	fpcr;	
};//c
typedef struct _m88k_thread_state_xrf m88k_thread_state_xrf_t;

struct _m88k_thread_state_user {
	int		user;//c
 };
typedef struct _m88k_thread_state_user m88k_thread_state_user_t;


struct m88110_bp_ctrl_t {
	unsigned	v:BIT_WIDTH(0);//c
	m88110_match_t	addr_match:BITS_WIDTH(12,1);//c
	unsigned	rwm:BIT_WIDTH(27);//c
	unsigned	rw:BIT_WIDTH(28);//c
};
typedef struct m88110_bp_ctrl_t m88110_bp_ctrl_t;

struct m88110_data_bp_t  {
	unsigned		addr;//c
	m88110_bp_ctrl_t	ctrl;//c
};
typedef struct m88110_data_bp_t m88110_data_bp_t;

struct m88110_psr_t {
	unsigned	mxm_dis:BIT_WIDTH(2);//c
	unsigned	sfu1dis:BIT_WIDTH(3);//c
	unsigned	trace:BIT_WIDTH(23);//c
	unsigned	sm:BIT_WIDTH(25);//c
	unsigned	sgn_imd:BIT_WIDTH(26);//c
	unsigned	c:BIT_WIDTH(28);//c
	unsigned	se:BIT_WIDTH(29);//c
	unsigned	le:BIT_WIDTH(30);//c
	unsigned	supr:BIT_WIDTH(31);//c
};
typedef struct m88110_psr_t m88110_psr_t;

struct m88110_fp_trap_status_t {
	unsigned	efinx:BIT_WIDTH(0);//c
	unsigned	efovf:BIT_WIDTH(1);//c
	unsigned	efunf:BIT_WIDTH(2);//c
	unsigned	efdvz:BIT_WIDTH(3);	//c
	unsigned	efinv:BIT_WIDTH(4);//c
	unsigned	priv:BIT_WIDTH(5);	//c
	unsigned	unimp:BIT_WIDTH(6);//c
	unsigned	sfu1_disabled:BIT_WIDTH(8);//c
	m88110_iresult_size_t	iresult_size:BITS_WIDTH(15,14);//c
};
typedef struct m88110_fp_trap_status_t m88110_fp_trap_status_t;

struct _m88110_thread_state_impl {
	m88110_data_bp_t	data_bp[M88110_N_DATA_BP];//c
	m88110_psr_t		psr;//c
	m88110_fp_trap_status_t	fp_trap_status;//c
	m88k_xrf_t		intermediate_result;//c
};
typedef struct _m88110_thread_state_impl m88110_thread_state_impl_t;


#endif//HYS_MACH_M88K_THREAD_STATUS_H
