#ifndef HYS_MACH_NOTIFY_H
#define HYS_MACH_NOTIFY_H

#define MACH_NOTIFY_NO_SENDERS		(MACH_NOTIFY_FIRST + 006)//c
#define MACH_NOTIFY_DEAD_NAME		(MACH_NOTIFY_FIRST + 010)//c
#define MACH_NOTIFY_PORT_DELETED	(MACH_NOTIFY_FIRST + 001 )//c
#define MACH_NOTIFY_LAST		(MACH_NOTIFY_FIRST + 015)//c
#define MACH_NOTIFY_PORT_DESTROYED	(MACH_NOTIFY_FIRST + 005)//c

////////////////////////////////////

#define MACH_NOTIFY_FIRST 3//?

//////////////////

struct mach_dead_name_notification_t {
    NDR_record_t	NDR;//c
    mach_port_name_t not_port;//c
};
typedef struct mach_dead_name_notification_t mach_dead_name_notification_t;

struct mach_port_deleted_notification_t {
	NDR_record_t	NDR;//c
    	mach_port_name_t not_port;//c
};
typedef struct mach_port_deleted_notification_t mach_port_deleted_notification_t;

struct mach_no_senders_notification_t {
    	mach_msg_header_t	not_header;//c
};
typedef struct mach_no_senders_notification_t mach_no_senders_notification_t;

#endif//HYS_MACH_NOTIFY_H
