#ifndef HYS_MACH_POLICY_H
#define HYS_MACH_POLICY_H

#define POLICY_TIMESHARE_INFO_COUNT	((mach_msg_type_number_t) \
	(sizeof(struct policy_timeshare_info)/sizeof(integer_t)))//c

#define POLICY_FIFO_INFO_COUNT	((mach_msg_type_number_t)	\
	(sizeof(struct policy_fifo_info)/sizeof(integer_t)))//c

#define POLICY_RR_INFO_COUNT	((mach_msg_type_number_t)	\
	(sizeof(struct policy_rr_info)/sizeof(integer_t)))//c

//////////////
#define POLICY_TIMESHARE 1//?
#define POLICY_FIFO 2//?
#define POLICY_RR 3//?

//////////////
typedef int 				policy_t;//c
////////////
struct policy_timeshare_info {
	integer_t		cur_priority;//c
	integer_t		base_priority;//c
};

struct policy_rr_info {
	integer_t		base_priority;//c
};

struct policy_fifo_info {
	integer_t		base_priority;//c
};

//////////
#endif//HYS_MACH_POLICY_H
