#ifndef HYS_MACH_PPC__STRUCTS_H
#define HYS_MACH_PPC__STRUCTS_H

#if __DARWIN_UNIX03
#define	_STRUCT_PPC_THREAD_STATE	struct __darwin_ppc_thread_state
_STRUCT_PPC_THREAD_STAT {
};
#else /* !__DARWIN_UNIX03 */
#define	_STRUCT_PPC_THREAD_STATE	struct ppc_thread_state
_STRUCT_PPC_THREAD_STATE {
	unsigned int srr0;//c
	unsigned int r1;//c
	unsigned int __srr1;//c
	unsigned int r2;//c
	unsigned int r3;//c
	unsigned int r4;//c
	unsigned int r5;//c
	unsigned int r6;//c
	unsigned int r7;//c
	unsigned int r8;//c
	unsigned int r9;//c
	unsigned int r10;//c
	unsigned int r0;//c
	unsigned int r11;//c
	unsigned int r12;//c
	unsigned int r13;//c
	unsigned int r14;//c
	unsigned int r15;//c
	unsigned int r16;//c
	unsigned int r17;//c
	unsigned int r18;//c
	unsigned int r19;//c
	unsigned int r20;//c
	unsigned int r21;//c
	unsigned int r22;//c
	unsigned int r23;//c
	unsigned int r24;//c
	unsigned int r25;//c
	unsigned int r26;//c
	unsigned int r27;//c
	unsigned int r28;//c
	unsigned int r29;//c
	unsigned int r30;//c
	unsigned int r31;//c
	unsigned int lr;	//c
	unsigned int cr;//c
	unsigned int xer;//c
	unsigned int ctr;//c
	unsigned int mq;//c
	unsigned int vrsave;	//c
};//_STRUCT_PPC_THREAD_STATE
#endif /* __DARWIN_UNIX03 */

#if __DARWIN_UNIX03
#define	_STRUCT_PPC_FLOAT_STATE	struct __darwin_ppc_float_state
_STRUCT_PPC_FLOAT_STATE
{

};
#else /* !__DARWIN_UNIX03 */
#define	_STRUCT_PPC_FLOAT_STATE	struct ppc_float_state
_STRUCT_PPC_FLOAT_STATE{
	double  fpregs[32];//c
	unsigned int fpscr_pad;//c
	unsigned int fpscr;//c
};
#endif /* __DARWIN_UNIX03 */


#if __DARWIN_UNIX03
#define _STRUCT_PPC_EXCEPTION_STATE	struct __darwin_ppc_exception_state
_STRUCT_PPC_EXCEPTION_STATE
{

};
#else /* !__DARWIN_UNIX03 */
#define _STRUCT_PPC_EXCEPTION_STATE	struct ppc_exception_state
_STRUCT_PPC_EXCEPTION_STATE {
#if defined(__LP64__)
	unsigned int dar;		
	unsigned int dsisr;
	unsigned int exception;		
	unsigned int pad0;		
	unsigned int pad1[4];		
#else
	unsigned long dar;		
	unsigned long dsisr;
	unsigned long exception;
	unsigned long pad0;		
	unsigned long pad1[4];		
#endif
};//c
#endif /* __DARWIN_UNIX03 */

#if __DARWIN_UNIX03
#define _STRUCT_PPC_THREAD_STATE64	struct __darwin_ppc_thread_state64
_STRUCT_PPC_THREAD_STATE64
{
};
#else /* !__DARWIN_UNIX03 */
#define _STRUCT_PPC_THREAD_STATE64	struct ppc_thread_state64
_STRUCT_PPC_THREAD_STATE64 {
	unsigned long long r0;//c
	unsigned long long r1;//c
	unsigned long long r2;//c
	unsigned long long r3;//c
	unsigned long long r4;//c
	unsigned long long r5;//c
	unsigned long long r6;//c
	unsigned long long r7;//c
	unsigned long long r8;//c
	unsigned long long r9;//c
	unsigned long long r10;//c
	unsigned long long r11;//c
	unsigned long long r12;//c
	unsigned long long r13;//c
	unsigned long long r14;//c
	unsigned long long r15;//c
	unsigned long long r16;//c
	unsigned long long r17;//c
	unsigned long long r18;//c
	unsigned long long r19;//c
	unsigned long long r20;//c
	unsigned long long r21;//c
	unsigned long long r22;//c
	unsigned long long r23;//c
	unsigned long long r24;//c
	unsigned long long r25;//c
	unsigned long long r26;//c
	unsigned long long r27;//c
	unsigned long long r28;//c
	unsigned long long r29;//c
	unsigned long long r30;//c
	unsigned long long r31;//c
	unsigned int cr;//c
	unsigned long long xer;//c
	unsigned long long lr;//c
	unsigned long long ctr;//c
	unsigned int vrsave;	//c
	unsigned long long srr0;//c
	unsigned long long srr1;//c
};
#endif /* __DARWIN_UNIX03 */

#endif//HYS_MACH_PPC__STRUCTS_H
