#ifndef HYS_MACH_PPC_THREAD_STATUS_H
#define HYS_MACH_PPC_THREAD_STATUS_H

#define PPC_THREAD_STATE_COUNT ((mach_msg_type_number_t) \
   (sizeof(ppc_thread_state_t) / sizeof(int)))//c

#define PPC_FLOAT_STATE_COUNT ((mach_msg_type_number_t) \
   (sizeof(ppc_float_state_t) / sizeof(int)))//c

#define PPC_EXCEPTION_STATE_COUNT ((mach_msg_type_number_t) \
   (sizeof(ppc_exception_state_t) / sizeof(int)))//c

#define PPC_THREAD_STATE64_COUNT ((mach_msg_type_number_t) \
   (sizeof(ppc_thread_state64_t) / sizeof(int)))//c

//////////////////
#define PPC_THREAD_STATE 1//?
#define PPC_FLOAT_STATE 2//?
#define PPC_EXCEPTION_STATE 3//?
#define PPC_THREAD_STATE64 4//?

//////////////////

typedef _STRUCT_PPC_THREAD_STATE	 ppc_thread_state_t;//c
typedef _STRUCT_PPC_FLOAT_STATE		ppc_float_state_t;//c
typedef _STRUCT_PPC_EXCEPTION_STATE	ppc_exception_state_t;//c
typedef _STRUCT_PPC_THREAD_STATE64	ppc_thread_state64_t;//c

#endif //HYS_MACH_PPC_THREAD_STATUS_H
