#ifndef HYS_MACH_VM_TYPES_H
#define HYS_MACH_VM_TYPES_H


typedef vm_offset_t  vm_address_t;//c
typedef mach_port_t		vm_map_t;//c
typedef uint64_t addr64_t;//c
typedef uint32_t ppnum_t;//c
typedef struct pmap		*pmap_t;//c
typedef uint64_t		vm_object_offset_t;//c
typedef vm_offset_t     	pointer_t;//c

#ifndef __vm_object_t_defined
#define __vm_object_t_defined
typedef struct vm_object 	*vm_object_t;//c
#endif

////////////////////

#ifdef  KERNEL_PRIVATE

#ifndef	MACH_KERNEL_PRIVATE

__BEGIN_DECLS

struct upl ;
struct vm_map_copy ;
struct vm_named_entry ;

__END_DECLS

#endif	/* MACH_KERNEL_PRIVATE */

typedef struct upl		*upl_t;//c
typedef struct vm_map_copy	*vm_map_copy_t;//c
typedef struct vm_named_entry	*vm_named_entry_t;//c

#else	/* KERNEL_PRIVATE */
typedef struct vm_map_copy	*vm_map_copy_t;//add
typedef mach_port_t		upl_t;//c
typedef mach_port_t		vm_named_entry_t;//c

#endif	/* KERNEL_PRIVATE */

#endif//HYS_MACH_VM_TYPES_H
