#ifndef HYS_MALLOC_MALLOC_H
#define HYS_MALLOC_MALLOC_H

struct vm_range_t {};
typedef struct vm_range_t vm_range_t;

typedef kern_return_t memory_reader_t(task_t a, vm_address_t b, vm_size_t c, void **d);//c
typedef void vm_range_recorder_t(task_t a, void *b, unsigned c, vm_range_t *d, unsigned e);//c

struct _malloc_zone_t{
	int  introspect;//?
};
typedef struct _malloc_zone_t malloc_zone_t;//

struct malloc_statistics_t {};
typedef struct malloc_statistics_t malloc_statistics_t;

struct malloc_introspection_t {
    kern_return_t (*enumerator)(task_t a, void *b, unsigned c, vm_address_t d, memory_reader_t e, vm_range_recorder_t f);//c
    size_t	(*good_size)(malloc_zone_t *a, size_t b);//c
    boolean_t 	(*check)(malloc_zone_t *a); //c
    void 	(*print)(malloc_zone_t *a, boolean_t b);//c
    void	(*log)(malloc_zone_t *a, void *b);//c
    void	(*force_lock)(malloc_zone_t *a);//c
    void	(*force_unlock)(malloc_zone_t *a);//c
    void	(*statistics)(malloc_zone_t *a, malloc_statistics_t *b);//c
};
typedef struct malloc_introspection_t malloc_introspection_t;


/////////////////////

malloc_zone_t *malloc_default_zone(void);//c
void malloc_zone_free(malloc_zone_t *a, void *b);//c
void *malloc_zone_realloc(malloc_zone_t *a, void *b, size_t c);//c
void *malloc_zone_malloc(malloc_zone_t *a, size_t b);//c
malloc_zone_t *malloc_zone_from_ptr(const void *a);//c

#endif//HYS_MALLOC_MALLOC_H
