#ifndef HYS_NET_IF_H
#define HYS_NET_IF_H

#ifdef __CYGWIN__
	#define IF_NAMESIZE 16//c
#endif //__CYGWIN__

#ifndef IFNAMSIZ
#define	IFNAMSIZ	IF_NAMESIZE//c
#endif

#define KEV_DL_SUBCLASS 2//c

///////////////////////
#define KEV_DL_LINK_ADDRESS_CHANGED 3//?
#define IFF_SIMPLEX 4//?
#define KEV_DL_LINK_ON 5//?
#define KEV_DL_LINK_OFF 6//?
#define KEV_DL_PROTO_DETACHED 7//?
#define KEV_DL_IF_ATTACHED 8//?
#define KEV_DL_IF_DETACHED 9//?
#define KEV_DL_IF_DETACHING 10//?
#define KEV_DL_SIFFLAGS 11//?
#define KEV_DL_SIFMETRICS 12//?
#define KEV_DL_SIFMTU 13//?
#define KEV_DL_SIFPHYS 14//?
#define KEV_DL_SIFMEDIA 15//?
#define KEV_DL_SIFGENERIC 16//?
#define KEV_DL_ADDMULTI 17//?
#define KEV_DL_DELMULTI 18//?
#define KEV_DL_PROTO_ATTACHED 19//?

///////////////////////////////////
struct ifmediareq64 {
	int ifm_count;//c
	int ifm_active;//c
	int ifm_current;//c
	int ifm_status;//c
	union {
		u_int64_t ifmu_ulist64;//c
		int *ifmu_ulist32;//c
	} ifm_ifmu;
};

struct ifdevmtu  {
	int ifdm_current;//c
	int	ifdm_min;//c
	int	ifdm_max;//c
};

struct ifmediareq {
	char	ifm_name[IFNAMSIZ];//c
	int	ifm_count;	//c
	int	ifm_status;//c
	int	ifm_active;//c
	int	*ifm_ulist;//c
	int	ifm_current;//c
};

struct if_msghdr {
	unsigned char	ifm_type;//c
	unsigned short	ifm_msglen;//c
};

struct kev_dl_proto_data {
     struct net_event_data   	link_data;//c
     u_int32_t			proto_remaining_count;//c
};

struct ifaliasreq {
	char	ifra_name[IFNAMSIZ];//c
	struct	sockaddr ifra_addr;//c
	struct	sockaddr ifra_mask;//c
};

#endif //HYS_NET_IF_H
