#ifndef HYS_NET_IF_BOND_VAR_H
#define HYS_NET_IF_BOND_VAR_H

#define IF_BOND_OP_GET_STATUS 1//?
#define IF_BOND_STATUS_REQ_VERSION 2//?
#define IF_BOND_MODE_LACP 3//?
#define IF_BOND_MODE_STATIC 4//?
#define IF_BOND_OP_SET_MODE 5//?
#define IF_BOND_OP_ADD_INTERFACE 6//?
#define IF_BOND_OP_REMOVE_INTERFACE 7//?

///////////////////

struct if_bond_status_req {
	union {		
		void *ibsru_buffer;//c
	} ibsr_ibsru;
    	int		ibsr_version;//c
  	int		ibsr_total;//c
	int		ibsr_count;//c
   	u_int8_t	ibsr_mode;//c
};
#define ibsr_buffer	ibsr_ibsru.ibsru_buffer//c

struct if_bond_req {
   	u_int32_t	ibr_op;//c
 	union {
		struct if_bond_status_req ibru_status;//c
		int	ibru_int_val;//c
		char	ibru_if_name[IFNAMSIZ];	//c
    	} ibr_ibru;
};
 struct if_bond_partner_state {
    	lacp_actor_partner_state	ibps_state;//c
    	lacp_system_priority 	ibps_system_priority;//c
    	lacp_system 		ibps_system;//c
};

struct if_bond_status {
 	char 	ibs_if_name[IFNAMSIZ];//c
 	struct if_bond_partner_state ibs_partner_state;//c
    	lacp_actor_partner_state	ibs_state;//c
};

#endif//HYS_NET_IF_BOND_VAR_H
