#ifndef HYS_NET_NDRV_H
#define HYS_NET_NDRV_H

#define SOL_NDRVPROTO		NDRVPROTO_NDRV	//c
////////////////////////////////
#define NDRV_PROTOCOL_DESC_VERS 1//?
#define NDRV_DEMUXTYPE_ETHERTYPE 2//?
#define NDRV_DEMUXTYPE_SAP 3//?
#define NDRV_DEMUXTYPE_SNAP 4//?
#define NDRVPROTO_NDRV 5//?
#define NDRV_SETDMXSPEC 6//?
#define NDRV_ADDMULTICAST 7//?
#define NDRV_DELMULTICAST 8//?

////////////////////////////////

struct ndrv_protocol_desc
{
    u_int32_t				version;
    u_int32_t				protocol_family;
    u_int32_t				demux_count;
    struct ndrv_demux_desc*	demux_list;
};//c

struct ndrv_demux_desc{
    	u_int16_t	type;//c
    	u_int16_t	length;//c
    	union {
        	u_int16_t	ether_type;
        	u_int8_t	sap[3];
        	u_int8_t	snap[5];
        	u_int8_t	other[28];
    	} data;//c
};

struct sockaddr_ndrv {
    	unsigned char snd_len;//c
	unsigned char snd_family;//c
	unsigned char snd_name[IFNAMSIZ];//c
};

#endif//HYS_NET_NDRV_H

