#ifndef HYS_NETAT_ADSP_H
#define HYS_NETAT_ADSP_H

#define dspOpen 1//?
#define ocAccept 2//?
#define ADSPOPEN 3//?
#define ADSPBINDREQ 4//?
#define ocRequest 5//?
#define dspClose 6//?
#define ADSPCLOSE 7//?
#define dspReset 8//?
#define dspRead 9//?
#define ADSPRESET 10//?
#define ADSPGETPEER 11//?
#define ADSPGETSOCK 12//?
#define dspCLListen 13//?
#define ADSPCLLISTEN 14//?
#define ADSPATTENTION 15//?
#define ADSPREAD 16//?
#define dspAttention 17//?
#define ADSP_MAX_DATA_LEN 18//?
#define dspWrite 19//?
#define dspOptions 20//?
#define ADSPOPTIONS 21//?

struct TRopenParams {
	int remoteCID;//?
	int sendSeq;//?
	int attnSendSeq;//?
	int sendWindow;//?
	at_inet_t  remoteAddress;//c
	int ocMode;//?
};
typedef struct TRopenParams TRopenParams;

struct TRcloseParams{
	int abort;//?
};
typedef struct TRcloseParams TRcloseParams;

struct TRioParams {
	int actCount;//?
	int reqCount;//?
	int dataPtr;//?
	int flush;//?
	int eom;//?
};
typedef struct TRioParams TRioParams;

struct TRattnParams {
	int attnSize;//?
	int attnData;//?
	int attnCode;//?
};
typedef struct TRattnParams TRattnParams;

struct TRoptionParams{
	int a;//dummy
};
typedef struct TRoptionParams TRoptionParams;

union adsp_command{
	TRopenParams openParams;//c
	TRcloseParams  closeParams;//c
	TRioParams ioParams;//c
	TRattnParams attnParams;//c
	TRoptionParams optionParams;//c
};

struct adspcmd{
	union adsp_command u;//c
	int csCode;//?
	int ioResult;//?
	int socket;//?
};



#endif //HYS_NETAT_ADSP_H
