#ifndef HYS_NETINET6_IN6_H
#define HYS_NETINET6_IN6_H

#define IPV6CTL_FORWARDING 1//?
/////////////////////////////////
#define M_LOOP	M_PROTO4//c

#define IN6ADDR_LINKLOCAL_ALLROUTERS_INIT \
	{{{ 0xff, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, \
	    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02 }}}//c

////////////////////////////////

struct in6_addr {
	union {
		__uint8_t   __u6_addr8[16];//c
		__uint16_t  __u6_addr16[8];//c
		__uint32_t  __u6_addr32[4];//c
	} __u6_addr;		
};
#define s6_addr   __u6_addr.__u6_addr8//c
#define s6_addr16 __u6_addr.__u6_addr16//c
//////////
struct sockaddr_in6{
	__uint8_t sin6_len;//c
	sa_family_t sin6_family;//c
	in_port_t sin6_port;//c
	struct in6_addr sin6_addr;//c
	__uint32_t	sin6_scope_id;//c
};

struct ipv6_mreq {
	struct in6_addr	ipv6mr_multiaddr;//c
};

///////////////
#ifndef OC_in6addr_any
#define OC_in6addr_any
extern const struct in6_addr in6addr_any;//c
#endif

extern const struct in6_addr in6addr_loopback;//c

#endif//HYS_NETINET6_IN6_H
