#ifndef HYS_SECURITY_CDSA_CLIENAT_CSSMCLIENT_H
#define HYS_SECURITY_CDSA_CLIENAT_CSSMCLIENT_H

namespace Security {
namespace CssmClient {


class  Module_HYS {

public://datatype

#define Security_CssmClient_Module_Impl \
typedef ModuleImpl Impl;//c

public:

#define Security_CssmClient_Module_Module_Impl \
explicit Module(Impl *impl) : Object(impl) {};//c

#define Security_CssmClient_Module_Module \
Module() : Object(NULL) {};//c

#define Security_CssmClient_Module_Module_const_Guid \
Module(const Guid &guid) : Object(new Impl(guid)) {};//c

#define Security_CssmClient_Module_Module_const_Guid_const_Cssm \
Module(const Guid &guid, const Cssm &session) : Object(new Impl(guid, session)) {};//c

};//Module_HYS

class  Object_HYS {

public:

#define Security_CssmClient_Object_mImpl \
RefPointer<Impl> mImpl;//c

#define Security_CssmClient_Object_Impl \
typedef ObjectImpl Impl;

#define Security_CssmClient_Object_Object \
explicit Object(Impl *impl) : mImpl(impl) {};//c

};

class ModuleImpl_HYS {
public:

#define Security_CssmClient_ModuleImpl_ModuleImpl_const_Guid \
ModuleImpl(const Guid &guid);//c

#define Security_CssmClient_ModuleImpl_ModuleImpl_const_Guid_const_Cssm \
ModuleImpl(const Guid &guid, const Cssm &session);//c

};

class Cssm_HYS{
public://datatype

#define Security_CssmClient_Cssm_Impl \
typedef CssmImpl Impl;

public://func

#define Security_CssmClient_Cssm_Cssm_Impl \
explicit Cssm(Impl *impl) : Object(impl) {};//c

#define Security_CssmClient_Cssm_Cssm \
explicit Cssm() : Object(new Impl()) {};//c

};
class Attachment_HYS {
public:

#define Security_CssmClient_Attachment_Attachment_Impl_DATATYPE \
typedef AttachmentImpl Impl;

#define Security_CssmClient_Attachment_Attachment_Impl \
explicit Attachment(Impl *impl) : Object(impl) {};//c

#define Security_CssmClient_Attachment_Attachment_const_Guid \
Attachment(const Guid &guid, CSSM_SERVICE_TYPE subserviceType):Object(new Impl(guid, subserviceType)) {};//c

#define Security_CssmClient_Attachment_Attachment_const_Module \
Attachment(const Module &module, CSSM_SERVICE_TYPE subserviceType): Object(new Impl(module, subserviceType)) {};//c

};

class AttachmentImpl_HYS {
public:

#define Security_CssmClient_AttachmentImpl_AttachmentImpl_const_Guid \
AttachmentImpl(const Guid &guid, CSSM_SERVICE_TYPE subserviceType);//c

#define Security_CssmClient_AttachmentImpl_AttachmentImpl_const_Module \
AttachmentImpl(const Module &module, CSSM_SERVICE_TYPE subserviceType);//c

#define Security_CssmClient_Attachment_AttachmentImpl \
AttachmentImpl(){};//hys add

};

class  ObjectImpl_HYS{
public:

#define Security_CssmClient_ObjectImpl_ObjectImpl \
explicit ObjectImpl();//c

#define Security_CssmClient_ObjectImpl_ObjectImpl_const_Object \
explicit ObjectImpl(const Object &parent);//c

};


}//CssmClient
}//Security

#endif//HYS_SECURITY_CDSA_CLIENAT_CSSMCLIENT_H
