#ifndef HYS_SECURITY_CDSA_UTILUITRS_CONTERX_H
#define HYS_SECURITY_CDSA_UTILUITRS_CONTERX_H

namespace Security {


class Context_Builder_HYS {

public://data

#define Security_Context_Builder_allocator \
Allocator &allocator;//c

public:

#define Security_Context_Builder_done \
void done(CSSM_CONTEXT_ATTRIBUTE * &attributes, uint32 &count);//c

#define Security_Context_Builder_put \
template <class T>  \
void put(CSSM_ATTRIBUTE_TYPE type, const T *p){   };//c

#define Security_Context_Builder_put_CSSM_ATTRIBUTE_TYPE \
void put(CSSM_ATTRIBUTE_TYPE type, uint32 value){};//c  

#define Security_Context_Builder_put_const_CSSM_CONTEXT_ATTRIBUTE \
void put(const CSSM_CONTEXT_ATTRIBUTE &attr){	};//c

#define Security_Context_Builder_put_const_Context_Attr \
void put(const Context::Attr &attr) {};//c

#define Security_Context_Builder_make \
size_t make();//c

#define Security_Context_Builder_setup_T \
 template <class T> \
void setup(T p, CSSM_RETURN invalidError = CSSM_OK){    };//c

///////////////
#if !(defined (__GNUG__) && defined (size_t))
	#define Security_Context_Builder_setup_uint32  
#else
	#define Security_Context_Builder_setup_uint32 \
	void setup(uint32 n, CSSM_RETURN invalidError = CSSM_OK){};//c
#endif
//uint32=CSSM_SIZE

//#if !(defined (__GNUG__) && defined (size_t))
//typedef __SIZE_TYPE__ size_t;
//#ifdef __BEOS__

//#define __ __SIZE_TYPE__ unsigned int
//#if __SIZE_TYPE__ ==unsigned int
//#else
//#endif
//////////////////////
#define Security_Context_Builder_setup_CSSM_SIZE \
void setup(CSSM_SIZE n, CSSM_RETURN invalidError = CSSM_OK) {};//c

#define Security_Context_Builder_setup_const_CSSM_CONTEXT_ATTRIBUTE \
void setup(const CSSM_CONTEXT_ATTRIBUTE &attr){ };//c

#define Security_Context_Builder_setup_const_Context_Attr \
void setup(const Context::Attr &attr) { };//c

#define Security_Context_Builder_Builder \
Builder(Allocator &alloc) : allocator(alloc) {};//c

};

class  Context_HYS{

public://operator

#define Security_Context_operator1 \
 void operator delete (void *addr, size_t, Allocator &alloc) throw(){ };//c

#define Security_Context_const_Attr_operator \
const Attr &operator [] (unsigned int ix) const {};//c

#define Security_Context_Attr_operator \
Attr &operator [] (unsigned int ix)  {};//c

public://func

#define Security_Context_get_CSSM_RETURN \
template <class Elem> \
Elem &get(CSSM_ATTRIBUTE_TYPE type, CSSM_RETURN err) const { };//c

#define Security_Context_get \
template <class Elem> \
Elem *get(CSSM_ATTRIBUTE_TYPE type) const {};//c

#define Security_Context_getInt_CSSM_ATTRIBUTE_TYPE_CSSM_RETURN  \
uint32 getInt(CSSM_ATTRIBUTE_TYPE type, CSSM_RETURN err) const {};//c

#define Security_Context_getInt_CSSM_ATTRIBUTE_TYPE \
uint32 getInt(CSSM_ATTRIBUTE_TYPE type) const {};//c
    
#define Security_Context_getInt_CSSM_ATTRIBUTE_TYPE_uint32 \
bool getInt(CSSM_ATTRIBUTE_TYPE type, uint32 &value) const {  };//c

#define Security_Context_type \
CSSM_CONTEXT_TYPE type() const { };//c

#define Security_Context_dump \
 IFDUMP(void dump(const char *title = NULL, const CSSM_CONTEXT_ATTRIBUTE *attrs = NULL) const;)//c

#define Security_Context_algorithm \
CSSM_ALGORITHMS algorithm() const { };//c

#define Security_Context_attributesInUse \
uint32 attributesInUse() const { };//c

};

class Context_Attr_HYS {

public://operator

 #define Security_Context_Attr_operator_CssmCryptoData \
operator CssmCryptoData & () const { };//c

 public:

#define Security_Context_Attr_type \
CSSM_ATTRIBUTE_TYPE type() const {};//c

#define Security_Context_Attr_baseType \
uint32 baseType() const {};//c

};

namespace DataWalkers {

template <class Action>
void walk(Action &operate, CSSM_CONTEXT_ATTRIBUTE &attr){};//c



} // end namespace DataWalkers

}//Security

#endif//HYS_SECURITY_CDSA_UTILUITRS_CONTERX_H

#ifdef  HYS_SECURITY_CDSA_UTILUITRS_CONTERX_H_END
#undef HYS_SECURITY_CDSA_UTILUITRS_CONTERX_H

namespace Security {
namespace DataWalkers {

template <class Action>
void walk(Action &operate, Context::Attr &attr) {};//c

}//DataWalkers
}//Security

#endif//HYS_SECURITY_CDSA_UTILUITRS_CONTERX_H
