#ifndef HYS_SECURITY_CDSA_UTILITIES_CSSMDB_H
#define HYS_SECURITY_CDSA_UTILITIES_CSSMDB_H

namespace Security {

class  CssmAutoQuery_HYS {
public:

#define Security_CssmAutoQuery_CssmAutoQuery_const_CSSM_QUERY \
CssmAutoQuery(const CSSM_QUERY &query, Allocator &allocator = Allocator::standard());//c

#define Security_CssmAutoQuery_CssmAutoQuery_uint32 \
CssmAutoQuery(uint32 capacity = 0, Allocator &allocator = Allocator::standard()) ;//c

};

class  CssmQuery_HYS{
public:

#define Security_CssmQuery_recordType \
CSSM_DB_RECORDTYPE recordType() const {};//c

#define Security_CssmQuery_recordType_CSSM_DB_RECORDTYPE \
void recordType(CSSM_DB_RECORDTYPE recordType)  {};//c

};



namespace DataWalkers {

struct DLDbFlatIdentifier {};

template<class Action>
DLDbFlatIdentifier *walk(Action &operate, DLDbFlatIdentifier * &ident) {};//c

template <class Action>
CSSM_QUERY *walk(Action &operate, CSSM_QUERY * &query) {};//c


}//DataWalkers
}//Security

#endif//HYS_SECURITY_CDSA_UTILITIES_CSSMDB_H

#ifdef HYS_SECURITY_CDSA_UTILITIES_CSSMDB_H_END
#undef HYS_SECURITY_CDSA_UTILITIES_CSSMDB_H_END

namespace Security {
namespace DataWalkers {

template <class Action>
void walk(Action &operate, CssmQuery &query){};//c

template <class Action>
CssmQuery *walk(Action &operate, CssmQuery * &query) {};//c

template <class Action>
CssmDbRecordAttributeData *walk(Action &operate, CssmDbRecordAttributeData * &data){};//c

template <class Action>
CssmSelectionPredicate *walk(Action &operate, CssmSelectionPredicate * &predicate){};//c

template<class Action>
void walk(Action &operate, CssmSelectionPredicate &predicate) {};//c


template <class Action>
void walk(Action &operate, CssmDbAttributeData &data) {};//c

template <class Action>
CssmDbAttributeData *walk(Action &operate, CssmDbAttributeData * &data){};//c

template <class Action>
void walk(Action &operate, CssmDbRecordAttributeData &data) {};//c

template <class Action>
CssmDbAttributeInfo *walk(Action &operate, CssmDbAttributeInfo * &info) {};//c

template <class Action>
void walk(Action &operate, CssmDbRecordAttributeInfo &info) {};//c

template <class Action>
CssmDbRecordAttributeInfo *walk(Action &operate, CssmDbRecordAttributeInfo * &info) {};//c

template <class Action>
void walk(Action &operate, CssmDbAttributeInfo &info) {};//c


}//DataWalkers
}//Security

#endif //HYS_SECURITY_CDSA_UTILITIES_CSSMDB_H_END
