#ifndef HYS_SECUROITY_CDSA_UTILTIRS_HANDLEOBJECT_H
#define HYS_SECUROITY_CDSA_UTILTIRS_HANDLEOBJECT_H

namespace Security {

class  HandledObject_HYS {

public://data

 typedef CSSM_HANDLE Handle;//c

#define Security_HandledObject_mMyHandle \
Handle mMyHandle;//c

#define Security_HandledObject_mValid \
bool mValid;	//c

public:

#define Security_HandledObject_HandledObject_Handle \
HandledObject(Handle h) : mMyHandle(h), mValid(true) { };//c

#define Security_HandledObject_HandledObject \
HandledObject() {};//c

};

class HandleObject_HYS{

public:

#define Security_HandleObject_findAndKill \
template <class Subtype> \
static Subtype &findAndKill(CSSM_HANDLE handle, CSSM_RETURN error);//c

#define Security_HandleObject_find \
template <class Subtype> \
static Subtype &find(CSSM_HANDLE handle, CSSM_RETURN error);//c

#define Security_HandleObject_handle \
Handle handle() const { };//c

#define Security_HandleObject_HandleObject \
HandleObject(){ };//c

};

}//Security

#endif//HYS_SECUROITY_CDSA_UTILTIRS_HANDLEOBJECT_H

#ifdef HYS_SECUROITY_CDSA_UTILTIRS_HANDLEOBJECT_H_END
#undef HYS_SECUROITY_CDSA_UTILTIRS_HANDLEOBJECT_H_END

namespace Security {

template <class Subclass>
inline Subclass &HandleObject::find(CSSM_HANDLE handle, CSSM_RETURN error) { };//c

template <class Subclass>
inline Subclass &HandleObject::findAndKill(CSSM_HANDLE handle, CSSM_RETURN error){};//c

}//Security

#endif//HYS_SECUROITY_CDSA_UTILTIRS_HANDLEOBJECT_H_END

