#ifndef HYS_SEURITY_UTILITIES_MACHSEVER_H
#define HYS_SEURITY_UTILITIES_MACHSEVER_H

namespace Security {
namespace MachPlusPlus {

class  MachServer_HYS {

public:
//////////////
class  Timer_HYS{

public:

#define Security_MachPlusPlus_MachServer_Timer_Timer \
Timer(bool longTerm = false) { };//c

};
///////////////////////////
public:

#define Security_MachPlusPlus_MachServer_notifyIfUnused \
virtual void notifyIfUnused(Port port, bool doNotify = true) const;//c

#define Security_MachPlusPlus_MachServer_notifyIfDead \
virtual void notifyIfDead(Port port, bool doNotify = true) const;//c

#define Security_MachPlusPlus_MachServer_MachServer \
MachServer();//c

#define Security_MachPlusPlus_MachServer_MachServer_const_char  \
MachServer(const char *name);//c

#define Security_MachPlusPlus_MachServer_MachServer_const_char_const_Bootstrap \
MachServer(const char *name, const Bootstrap &bootstrap);//c

#define Security_MachPlusPlus_MachServer_clearTimer \
virtual void clearTimer(Timer *timer);//c

#define Security_MachPlusPlus_MachServer_setTimer_Time_Absolute \
virtual void setTimer(Timer *timer, Time::Absolute when);//c

#define Security_MachPlusPlus_MachServer_setTimer_Time_Interval \
void setTimer(Timer *timer, Time::Interval offset) {};//c

#define Security_MachPlusPlus_MachServer_active \
static MachServer &active() {};//c

#define Security_MachPlusPlus_MachServer_Remove_Port \
void remove(Port receiver);//c

#define Security_MachPlusPlus_MachServer_Remove_Handler \
void remove(Handler &handler);//c

#define  Security_MachPlusPlus_MachServer_add_Port \
void add(Port receiver);//c

#define Security_MachPlusPlus_MachServer_add_Handler \
void add(Handler &handler);//c

#define Security_MachPlusPlus_MachServer_primaryServicePort \
Port primaryServicePort() const	{};//c

#define Security_MachPlusPlus_MachServer_run \
void run(size_t a = 4096, mach_msg_options_t b = 0);//c

};

}//MachPlusPlus
}//Security

#endif//HYS_SEURITY_UTILITIES_MACHSEVER_H
