#ifndef HYS_SECURITYD_CLIENT_SSCOMMON_H
#define HYS_SECURITYD_CLIENT_SSCOMMON_H

namespace Security {
namespace SecurityServer {

typedef CSSM_HANDLE RecordHandle;//c
typedef CSSM_HANDLE SearchHandle;//c
typedef CSSM_HANDLE KeyHandle;//c
typedef CSSM_HANDLE DbHandle;//c
typedef CSSM_HANDLE GenericHandle;	//c

typedef enum { dbAcl, keyAcl, objectAcl, loginAcl } AclKind;//c

///////////
class ClientCommon_HYS {

public://data

#define Security_SecurityServer_ClientCommon_internalAllocator \
Allocator &internalAllocator;//c

#define Security_SecurityServer_ClientCommon_returnAllocator \
Allocator &returnAllocator;//c

public://define

#define Security_SecurityServer_ClientCommon_ClientCommon \
ClientCommon(Allocator &a= Allocator::standard(),Allocator &b = Allocator::standard()): internalAllocator(a), returnAllocator(b) { };//c

};

};//SecurityServer
};//Security

#endif//HYS_SECURITYD_CLIENT_SSCOMMON_H
