#ifndef HYS_SYS_CDEFS_H
#define HYS_SYS_CDEFS_H

#define __IDSTRING(name,string) static const char name[] __unused = string//c

#ifndef __RCSID
#define __RCSID(s) __IDSTRING(rcsid,s)//c
#endif

#ifndef	__FBSDID
#if !defined(lint) && !defined(STRIP_FBSDID)
#define	__FBSDID(s)	__IDSTRING(__CONCAT(__rcsid_,__LINE__),s)
#else
#define	__FBSDID(s)	struct __hack
#endif
#endif//c

#if __DARWIN_UNIX03
#  if __DARWIN_64_BIT_INO_T
#    define __DARWIN_SUF_64_BIT_INO_T	"$INODE64"
#  else /* !__DARWIN_64_BIT_INO_T */
#    define __DARWIN_SUF_64_BIT_INO_T	/* nothing */
#  endif /* __DARWIN_UNIX03 */
#else /* !__DARWIN_UNIX03 */
#  define __DARWIN_SUF_64_BIT_INO_T	/* nothing */
#endif /* __DARWIN_UNIX03 */

#define __DARWIN_INODE64(sym)		__asm("_" __STRING(sym) __DARWIN_SUF_64_BIT_INO_T)//c

#if defined(__STDC__) || defined(__cplusplus)
#define	__STRING(x)	#x
#else	/* !(__STDC__ || __cplusplus) */
#define	__STRING(x)	"x"
#endif /* !(__STDC__ || __cplusplus) */

#define __DARWIN_ALIAS(sym)		__asm("_" __STRING(sym) __DARWIN_SUF_UNIX03)//c

#if __DARWIN_UNIX03
#  if !defined(__LP64__) && !defined(__arm__)
#    define __DARWIN_SUF_UNIX03		"$UNIX2003"
#    define __DARWIN_SUF_UNIX03_SET	1
#  else /* __LP64__ || __arm__ */
#    define __DARWIN_SUF_UNIX03		/* nothing */
#    define __DARWIN_SUF_UNIX03_SET	0
#  endif /* !__LP64__ && !__arm__ */
#else /* !__DARWIN_UNIX03 */
#  define __DARWIN_SUF_UNIX03		/* nothing */
#endif /* __DARWIN_UNIX03 */

#if !(__GNUC__ == 2 && __GNUC_MINOR__ == 95)
#if __STDC_VERSION__ < 199901
#define __restrict
#else
#define __restrict	restrict
#endif
#endif

#if defined(__ppc__)
#  if defined(__LDBL_MANT_DIG__) && defined(__DBL_MANT_DIG__) && \
	__LDBL_MANT_DIG__ > __DBL_MANT_DIG__
#    if __ENVIRONMENT_MAC_OS_X_VERSION_MIN_REQUIRED__-0 < 1040
#      define	__DARWIN_LDBL_COMPAT(x)	__asm("_" __STRING(x) "$LDBLStub")
#    else
#      define	__DARWIN_LDBL_COMPAT(x)	__asm("_" __STRING(x) "$LDBL128")
#    endif
#  else
#   define	__DARWIN_LDBL_COMPAT(x) /* nothing */
#  endif
#elif defined(__i386__) || defined(__ppc64__) || defined(__x86_64__) || defined (__arm__)
#  define	__DARWIN_LDBL_COMPAT(x)	/* nothing */
#else
#  error Unknown architecture
#endif

#if __GNUC__ > 2 || __GNUC__ == 2 && __GNUC_MINOR__ >= 7
#define __printflike(fmtarg, firstvararg) \
		__attribute__((__format__ (__printf__, fmtarg, firstvararg)))
#else
#define __printflike(fmtarg, firstvararg)
#endif//c

#ifndef __P

#if defined(__STDC__) || defined(__cplusplus)
#define	__P(protos)	protos		

#else	/* !(__STDC__ || __cplusplus) */
#define	__P(protos)	()		//c
#endif	/* !__GNUC__ */

#endif//__P

#endif//HYS_SYS_CDEFS_H
/////////////////////////////
#ifndef OC___unused
#define OC___unused

#if defined(__MWERKS__) && (__MWERKS__ > 0x2400)
#elif __GNUC__ > 2 || __GNUC__ == 2 && __GNUC_MINOR__ >= 5
#define	__dead2		__attribute__((__noreturn__))
#if __GNUC__ == 2 && __GNUC_MINOR__ >= 5 && __GNUC_MINOR__ < 7
#define	__unused	
#else
#define	__unused	__attribute__((__unused__))
#endif
#else
#if defined(__GNUC__) && !defined(__STRICT_ANSI__)
#endif
#endif//c

#ifndef __dead2
#define	__unused
#endif

#endif//OC___unused
//////////////////////
