#ifndef HYS_SYS_DISK_H
#define HYS_SYS_DISK_H

#define DKIOCGETBLOCKSIZE 1//?
#define DKIOCGETBLOCKCOUNT 2//?
#define DKIOCEJECT 3//?
#define DKIOCGETBLOCKCOUNT32 4//?
#define DKIOCGETMAXBLOCKCOUNTREAD 5//?
#define DKIOCISFORMATTED 6//?
#define DKIOCGETMAXBYTECOUNTWRITE 7//?
#define DKIOCGETMAXBLOCKCOUNTWRITE 8//?
#define DKIOCGETMAXSEGMENTCOUNTREAD 9//?
#define DKIOCGETMAXBYTECOUNTREAD 10//?
#define DKIOCGETMAXSEGMENTCOUNTWRITE 11//?
#define DKIOCGETMAXSEGMENTBYTECOUNTREAD 12//?
#define DKIOCGETMAXSEGMENTBYTECOUNTWRITE 13//?
#define DKIOCGETMINSEGMENTALIGNMENTBYTECOUNT 14//?
#define DKIOCGETBSDUNIT 15//?
#define DKIOCGETFORMATCAPACITIES 16//?
#define DKIOCGETMAXSEGMENTADDRESSABLEBITCOUNT 17//?
#define DKIOCISWRITABLE 18//?
#define DKIOCFORMAT 19//?
#define DKIOCSYNCHRONIZECACHE 20//?
#define DKIOCGETFIRMWAREPATH 21//?
#define DKIOCISVIRTUAL 22//?
#define DKIOCGETBASE 23//?
#define DKIOCGETFEATURES 24//?
#define DK_FEATURE_FORCE_UNIT_ACCESS 25//?
#define DKIOCSETBLOCKSIZE 26//?

////////////////////////////

struct dk_format_capacity_t {
    	uint64_t               blockCount;//c
    	uint32_t               blockSize;//c
};
typedef struct dk_format_capacity_t dk_format_capacity_t;

struct dk_format_capacities_t {
    	dk_format_capacity_t * capacities;//c
    	uint32_t               capacitiesCount;  //c
};
typedef struct dk_format_capacities_t dk_format_capacities_t;

struct dk_firmware_path_t {
    	char path[128];//c
};//c
typedef struct dk_firmware_path_t dk_firmware_path_t;

#endif//HYS_SYS_DISK_H
