#ifndef HYS_SYS_KAUTH_H
#define HYS_SYS_KAUTH_H

/////////////////////////////
#define KAUTH_ACE_PERMIT 1//?
#define KAUTH_ACE_DENY 2//?

/////////////////////////////
#define KAUTH_VNODE_WRITE_DATA			(1<<2)//c
#define KAUTH_EXTLOOKUP_VALID_UGUID	(1<<1)//c
#define KAUTH_EXTLOOKUP_VALID_GGUID	(1<<4)//c
#define KAUTH_EXTLOOKUP_WANT_MEMBERSHIP	(1<<12)//c
#define KAUTH_EXTLOOKUP_VALID_MEMBERSHIP (1<<13)//c
#define KAUTH_EXTLOOKUP_ISMEMBER	(1<<14)//c
#define KAUTH_EXTLOOKUP_WORKER		(1<<1)//c
#define KAUTH_EXTLOOKUP_RESULT		(1<<0)//c
#define KAUTH_VNODE_WRITE_DATA			(1<<2)//c
#define KAUTH_VNODE_READ_DATA			(1<<1)//c
#define	KAUTH_ACE_INHERITED		(1<<4)//c
#define KAUTH_VNODE_WRITE_ATTRIBUTES		(1<<8)//c
#define KAUTH_VNODE_WRITE_EXTATTRIBUTES		(1<<10)//c
#define KAUTH_VNODE_LIST_DIRECTORY		KAUTH_VNODE_READ_DATA//c
#define KAUTH_VNODE_ADD_FILE			KAUTH_VNODE_WRITE_DATA//c
#define KAUTH_VNODE_SEARCH			KAUTH_VNODE_EXECUTE//c
#define KAUTH_VNODE_EXECUTE			(1<<3)//c
#define KAUTH_VNODE_DELETE			(1<<4)//c
#define KAUTH_VNODE_APPEND_DATA			(1<<5)//c
#define KAUTH_VNODE_ADD_SUBDIRECTORY		KAUTH_VNODE_APPEND_DATA//c
#define KAUTH_VNODE_DELETE_CHILD		(1<<6)//c
#define KAUTH_VNODE_READ_ATTRIBUTES		(1<<7)//c
#define KAUTH_VNODE_READ_EXTATTRIBUTES		(1<<9)//c
#define KAUTH_VNODE_READ_SECURITY		(1<<11)//c
#define KAUTH_ACE_DIRECTORY_INHERIT	(1<<6)//c
#define KAUTH_VNODE_WRITE_SECURITY		(1<<12)//c
#define KAUTH_VNODE_CHANGE_OWNER		KAUTH_VNODE_TAKE_OWNERSHIP//c
#define KAUTH_VNODE_TAKE_OWNERSHIP		(1<<13)//c
#define KAUTH_ACE_FILE_INHERIT		(1<<5)//c
#define KAUTH_ACE_LIMIT_INHERIT		(1<<7)//c
#define KAUTH_ACE_ONLY_INHERIT		(1<<8)//c

///////////////////////////////////////

#ifndef _KAUTH_GUID
#define _KAUTH_GUID

struct guid_t {};
typedef struct guid_t guid_t;

#define _GUID_T
#endif /* _KAUTH_GUID */

struct kauth_identity_extlookup {
	u_int32_t	el_seqno;	//c
	u_int32_t	el_flags;//c
	guid_t		el_uguid;//c
	guid_t		el_gguid;//c
};

/////////////////////////

extern kauth_cred_t kauth_cred_get(void);//c

#endif //HYS_SYS_KAUTH_H
