#ifndef HYS_SYS_KDEBUG_H
#define HYS_SYS_KDEBUG_H

#if	(!defined(NO_KDEBUG))

#define KERNEL_DEBUG_CONSTANT(x,a,b,c,d,e)    \
do {					\
    if (kdebug_enable)			\
        kernel_debug(x,a,b,c,d,e);	\
} while(0)

#else

#define KERNEL_DEBUG_CONSTANT(x,a,b,c,d,e)

#endif//c

#define MACHDBG_CODE(SubClass, code) KDBG_CODE(DBG_MACH, SubClass, code)//c
#define KDBG_CODE(Class, SubClass, code) (((Class & 0xff) << 24) | ((SubClass & 0xff) << 16) | ((code & 0x3fff)  << 2))//c

////////////////
#define DBG_MACH_IHDLR 1//?
#define DBG_MACH 2//?
#define DBG_FUNC_NONE 3//?
#define DBG_FUNC_START 4//?
#define DBG_FUNC_END 5//?

/////////////////////////

extern unsigned int kdebug_enable;//c
extern void kernel_debug(unsigned int debugid, unsigned int arg1, unsigned int arg2, unsigned int arg3,  unsigned int arg4, unsigned int arg5);//c

#endif //HYS_SYS_KDEBUG_H
