#ifndef HYS_SYS_KERNEL_TYPES_H
#define HYS_SYS_KERNEL_TYPES_H

struct vnode;//c
	
#ifndef OC_fsid_t
#define OC_fsid_t
typedef struct fsid { int32_t val[2]; } fsid_t;//c
#endif

typedef int errno_t;//c
typedef int64_t daddr64_t;//c

///////////////////

#ifndef _KAUTH_GUID
#define _KAUTH_GUID

struct guid_t {};
typedef struct guid_t guid_t;

#define _GUID_T
#endif /* _KAUTH_GUID */

/////////////////////////////

#ifndef OC_mount_t
#define OC_mount_t

#ifndef BSD_BUILD
struct mount;
typedef struct mount * mount_t;//c
#else
typedef struct mount * mount_t;//c
#endif

#endif //OC_mount_t

#ifndef OC_vnode_t
#define OC_vnode_t

#ifndef BSD_BUILD
	struct vnode;
	typedef struct vnode * vnode_t;//c
#else
	typedef struct vnode * vnode_t;//c
#endif

#endif //OC_vnode_t

/////////////
#ifndef BSD_BUILD
struct buf;
typedef struct buf * buf_t;//c

struct file;
typedef struct file * file_t;//c

struct ucred;
typedef struct ucred * ucred_t;//.c

//#ifdef TBDDDD
//typedef struct fsid { int32_t val[2]; } fsid_t;	//c
//#endif /* TBDDDD */


struct proc;
typedef struct proc * proc_t;//c

#ifndef OC_uio_t
	#define OC_uio_t
struct uio;
typedef struct uio * uio_t;//c
#endif

struct vfs_context;
typedef struct vfs_context * vfs_context_t;//c

struct vfstable;
typedef struct vfstable * vfstable_t;//c

struct __ifnet;
struct __mbuf;
struct __pkthdr;
struct __socket;
struct __sockopt;
struct __ifaddr;
struct __ifmultiaddr;
struct __ifnet_filter;
struct __rtentry;

typedef	struct __ifnet*			ifnet_t;//c
typedef	struct __mbuf*			mbuf_t;//c
typedef	struct __pkthdr*		pkthdr_t;//c
typedef	struct __socket*		socket_t;//c
typedef struct __sockopt*		sockopt_t;//c
typedef struct __ifaddr*		ifaddr_t;//c
typedef struct __ifmultiaddr*	ifmultiaddr_t;//c
typedef struct __ifnet_filter*	interface_filter_t;//c
typedef struct __rtentry*		route_t;//c

#else /* BSD_BUILD */

typedef struct buf * buf_t;//c
typedef struct file * file_t;//c
typedef struct ucred * ucred_t;//c
typedef struct proc * proc_t;//c
typedef struct uio * uio_t;//c
typedef struct user_iovec * user_iovec_t;//.c
typedef struct vfs_context * vfs_context_t;//c
typedef struct vfstable * vfstable_t;//c


#endif /* !BSD_BUILD */

#endif //HYS_SYS_KERNEL_TYPES_H

