#ifndef HYS_SYS_MOUNT_INTERNAL_H
#define HYS_SYS_MOUNT_INTERNAL_H

#define MNTK_UNMOUNT 1//?
#define MNTK_WANTRDWR 2//?
/////////

#include <sys/statfs.h>//struct statfs -linux

#ifdef OC_BSD
	LIST_HEAD(vnodelst, vnode);//etc
#else
	TAILQ_HEAD(vnodelst, vnode);//c
#endif

struct mount {
	struct statfs	mnt_stat;//etc
	int		mnt_flag;//c
	int		mnt_kern_flag;	//c
	struct vnodelst	mnt_vnodelist;//c

	#ifdef OC_BSD
		CIRCLEQ_ENTRY(mount) mnt_list;	
	#else
		TAILQ_ENTRY(mount) mnt_list;//c
	#endif

};
///////////

#ifndef OC_RPCSVC_MOUNT_H
#ifdef OC_BSD
	extern	CIRCLEQ_HEAD(mntlist, mount) mountlist;//c
#else
	extern TAILQ_HEAD(mntlist, mount) mountlist;//c
#endif
#endif//OC_RPCSVC_MOUNT_H

#endif//HYS_SYS_MOUNT_INTERNAL_H
