#ifndef HYS_SYS_SIGNAL_H
#define HYS_SYS_SIGNAL_H

#ifndef sigmask
#define sigmask(m)	(1 << ((m)-1))//c
#endif

#ifndef SA_NOCLDSTOP
#define SA_NOCLDSTOP	0x0008
#endif

#ifndef SIGCHLD
#define	SIGCHLD	20
#endif

#ifndef SIG_BLOCK
#define	SIG_BLOCK	1
#endif

#ifndef SIG_UNBLOCK
#define	SIG_UNBLOCK	2
#endif

#ifndef SA_RESTART
#define SA_RESTART	0x0002
#endif

#ifndef NSIG
#define NSIG	__DARWIN_NSIG//c
#endif

#define SIGINFO 29//c

//////////////
#define __DARWIN_NSIG 2//?

///////////////

#ifndef _SIGSET_T
#define _SIGSET_T
typedef __darwin_sigset_t		sigset_t;//c
#endif

#ifndef __pid_t_defined
#define __pid_t_defined
#ifndef _PID_T
#define _PID_T
typedef __darwin_pid_t			pid_t;//c
#endif//_PID_T
#endif//__pid_t_defined

///////////////////////////

#ifndef OC_siginfo_t
#define OC_siginfo_t
typedef struct __siginfo {
	void	*si_addr;//c
	pid_t	si_pid;//c
} siginfo_t;
#endif

union __sigaction_u {
	void    (*__sa_handler)(int);//c
	void    (*__sa_sigaction)(int, struct __siginfo *,void *);//c
};
///////////////////////////
#ifndef OC_struct_sigaction
#define OC_struct_sigaction

struct sigaction {
	union __sigaction_u __sigaction_u;//c
	sigset_t sa_mask;//c
	int	sa_flags;//c
};
#endif //OC_struct_sigaction

#ifdef sa_handler
	#undef sa_handler
#endif
#define	sa_handler	__sigaction_u.__sa_handler//c


////////////////////////////////////////////
#endif //HYS_SYS_SIGNAL_H
/////////////////////////////
#ifdef   HYS_SYS_SIGNAL_H_END
#undef   HYS_SYS_SIGNAL_H_END

#define	SIGURG	16//c
#define	SIGIO	23//c

#ifdef sa_sigaction
#undef sa_sigaction
#endif

#define	sa_sigaction	__sigaction_u.__sa_sigaction//c

#endif//HYS_SYS_SIGNAL_H_END
