#ifndef HYS_SYS_TTY_H
#define HYS_SYS_TTY_H

#include <sys/unistd.h>//add
#include <sys/proc_internal.h>//struct proc

#define	t_lflag		t_termios.c_lflag//c
#define	t_cflag		t_termios.c_cflag//c
#define	t_iflag		t_termios.c_iflag//c
#define	t_ispeed	t_termios.c_ispeed//c
#define	t_ospeed	t_termios.c_ospeed//c

#define	TSA_CARR_ON(tp)		((void *)&(tp)->t_rawq)//c

/////////////////
#define TS_BUSY 1//?
#define TTOPRI 2//?
#define TS_ISOPEN 3//?
#define TTYHOG 4//?
#define TS_XCLUDE 5//?
#define DMBIS 6//?
#define DMBIC 7//?
#define DMSET 8//?
#define DMGET 9//?
#define TS_TTSTOP 10//?
#define TTIPRI 11//?
#define TS_CARR_ON 12//?
#define TTYCLSIZE 13//?
#define TS_CAN_BYPASS_L_RINT 14//?
#define TTY_PE 15//?
#define TTY_FE 16//?
#define TS_TIMEOUT 17//?
#define TS_FLUSH 18//?
#define TS_TBLOCK 19//?
#define TS_ASYNC 20//?
#define TS_BKSL 21//?
#define TS_ERASE 22//?
#define TS_LNCH 23//?
#define TS_TYPEN 24//?
#define TS_CNTTB 25//?

///////////////////////

struct clist {
	int c_cc;//d
};

struct tty {
	int t_line;//c
	int t_state;//c
	struct clist t_rawq;//c
	struct clist t_canq;//c
	struct termios t_termios;//c
 	struct clist t_outq;//c
	dev_t t_dev;//c
	void	(*t_oproc)(struct tty *);//c
	int	(*t_param)(struct tty *, struct termios *);//c
	long  t_rawcc;//c
	int	t_hiwat;//c
	int	t_lowat;//c
	int	t_column;//c
	struct	session *t_session;//c
	struct	pgrp *t_pgrp;//c
};

struct speedtab {
	int sp_speed;//c
	int sp_code;//c
};

////////////////

void	 termioschars(struct termios *t);//c
int	 ttyselect(struct tty *tp, int rw, void * wql, struct proc *p);//c
int	 ttioctl(struct tty *tp, u_long com, caddr_t data, int flag,struct proc *p);//c
void	 ttsetwater(struct tty *tp);//c
int	 ttspeedtab(int speed, struct speedtab *table);//c
int	 ttyclose(struct tty *a);//c
int	 clalloc(struct clist *a, int b, int ct);//c
void	 clfree(struct clist *a);//c
void	 ttwakeup(struct tty *a);//c
void	 ttwwakeup(struct tty *a);//c
int	 ttyinput(int a, struct tty *b);//c
int	 b_to_q(const u_char *a, int b, struct clist *c);//c
int	 q_to_b(struct clist *a, u_char *b, int c);//c

#endif//HYS_SYS_TTY_H
