#ifndef HYS_SYS_UIO_H
#define HYS_SYS_UIO_H

////////////////////////add start 
#ifndef OC_uio_t
#define OC_uio_t
typedef struct uio * uio_t;//sys--kernel-types.h
#endif

#ifndef OC_int64_t
#define OC_int64_t
#ifndef _INT64_T
#define _INT64_T
typedef	long long		int64_t;//i386-types.h
#endif//_INT64_T
#endif //OC_int64_t

#ifndef  OC_user_ssize_t
#define OC_user_ssize_t
typedef int64_t	 user_ssize_t;//i386-types.h
#endif //OC_user_ssize_t;

#ifndef __off_t_defined
#define __off_t_defined
#ifndef	_OFF_T
#define	_OFF_T
typedef	__darwin_off_t		off_t;//stdio.h
#endif//_OFF_T
#endif//__off_t_defined

#ifndef OC_u_int64_t
#define OC_u_int64_t
typedef	unsigned long long	u_int64_t;//i386-types.h
#endif//OC_u_int64_t

#ifndef OC_user_addr_t
#define OC_user_addr_t
typedef u_int64_t		user_addr_t;	//i386-types.h
#endif //OC_user_addr_t

#ifndef OC_user_size_t
#define OC_user_size_t
typedef u_int64_t		user_size_t;	//i386-types.h
#endif//OC_user_size_t

///////////////add end

enum {
	UIO_SYSSPACE,//?
	UIO_READ,//?
};
	
//////////////////////////////////

#ifndef _SIZE_T
#define _SIZE_T
typedef __darwin_size_t		size_t;//c
#endif

#ifndef OC_STRUCT_IOVEC
#ifndef _STRUCT_IOVEC
#define _STRUCT_IOVEC
struct iovec {
	void *   iov_base;//c
	size_t	 iov_len;//c	
};
#endif//_STRUCT_IOVEC
#endif//OC_STRUCT_IOVEC
/////////////////
user_ssize_t uio_resid( uio_t a_uio );//c
off_t uio_offset( uio_t a_uio );//c
extern int uiomove(const char * cp, int n, struct uio *uio);//c
void uio_setoffset( uio_t a_uio, off_t a_offset );//c

uio_t uio_create( int a_iovcount,		
				  off_t a_offset,		
				  int a_spacetype,	
				  int a_iodirection );	//c

int uio_addiov( uio_t a_uio, user_addr_t a_baseaddr, user_size_t a_length );//c
void uio_free( uio_t a_uio );//c
int uio_rw( uio_t a_uio );//c
void uio_setresid( uio_t a_uio, user_ssize_t a_value );//c
int uio_iovcnt( uio_t a_uio );//c
int uio_isuserspace( uio_t a_uio );//c

#endif //HYS_SYS_UIO_H
