#ifndef HYS_SYS_VNODE_INTERNAL_H
#define HYS_SYS_VNODE_INTERNAL_H

#define VROOT 1//?
#define VTEXT 2//?
#define VSYSTEM 3//?
#define VBWAIT 4//?
#define VALIASED 5//?

/////////
struct vnode {
	#ifdef OC_BSD
		LIST_ENTRY(vnode) v_mntvnodes;	
	#else
		TAILQ_ENTRY(vnode) v_mntvnodes;	//c
	#endif

	mount_t v_mount;//c
	u_short	 v_type;//c
	u_long	 v_flag;//c
	int32_t	 v_usecount;//c
	long		v_holdcnt;//etc
};


struct vnodeop_desc {
	int	vdesc_offset;//c
	const char *vdesc_name;//c
	int	vdesc_flags;//c
	int	*vdesc_vp_offsets;//c
	int	vdesc_vpp_offset;//c
	int	vdesc_cred_offset;//c
	int	vdesc_proc_offset;//c	
	int	vdesc_componentname_offset;//c
	int	vdesc_context_offset;//c
	caddr_t	*vdesc_transports;//c
};//c

#endif//HYS_SYS_VNODE_INTERNAL_H
