
#ifndef _IOI2CDevice_H
#define _IOI2CDevice_H

//#include <IOKit/IOLib.h>//add
#include <IOKit/IOService.h>
#include <IOI2C/IOI2CDefs.h>

class IOPlatformFunction;

#include <HYS/IOI2C/IOI2CDevice.h>

class IOI2CDevice : public IOService,public IOI2CDevice_HYS
{
	OSDeclareDefaultStructors(IOI2CDevice)

protected:
private:
public:

using IOService::callPlatformFunction;

IOI2CDevice_getPlatformFunction_const_char
IOI2CDevice_performFunction_const_OSSymbol
IOI2CDevice_performFunction_IOPlatformFunction
IOI2CDevice_performFunction
IOI2CDevice_getPlatformFunction
IOI2CDevice_callPlatformFunction 
IOI2CDevice_writeI2C_IOI2CCommand
IOI2CDevice_readI2C_IOI2CCommand
IOI2CDevice_processPowerEvent
IOI2CDevice_powerStateThreadCall
IOI2CDevice_setPowerState
IOI2CDevice_message
IOI2CDevice_sPowerStateThreadCall
IOI2CDevice_maxCapabilityForDomainState
IOI2CDevice_InitializePowerManagement
IOI2CDevice_newUserClient
IOI2CDevice_free
IOI2CDevice_stop
IOI2CDevice_initI2CResources
IOI2CDevice_start
IOI2CDevice_init 
IOI2CDevice_readI2C
IOI2CDevice_getI2CAddress
IOI2CDevice_freeI2CResources
IOI2CDevice_lockI2CBus
IOI2CDevice_unlockI2CBus
IOI2CDevice_writeI2C
IOI2CDevice_isI2COffline
IOI2CDevice_performFunctionsWithFlags
IOI2CDevice_InitializePlatformFunctions

};

#endif//_IOI2CDevice_H
