#ifndef _IOKIT_IOKITSERVER_H
#define _IOKIT_IOKITSERVER_H

#include <IOKit/IOTypes.h>
#include <IOKit/IOKitKeys.h>
#include <IOKit/OSMessageNotification.h>

//#ifdef __cplusplus
//extern "C" {
//#endif
#include <mach/kmod.h>
//#ifdef __cplusplus
//}
//#endif

#include <HYS/IOKit/IOKitServer.h>
/////////////
/*IOCatalogueReset


enum { 
    kIOCatalogResetDefault = 1 
};  
Constants
kIOCatalogResetDefault
Removes all entries from IOCatalogue except those used for booting the system.
Discussion 

user-client flag*/
enum { 
    kIOCatalogResetDefault = 1 
}; 

/*IOMakeMatching


enum { 
    kIOServiceMatching = 100, 
    kIOBSDNameMatching = 101, 
    kIOOFPathMatching = 102 
};  
Constants
kIOServiceMatching
kIOBSDNameMatching
kIOOFPathMatching*/
enum { 
    kIOServiceMatching = 100, 
    kIOBSDNameMatching = 101, 
    kIOOFPathMatching = 102 
};  

/*IOCatalogueSendData


enum { 
    kIOCatalogAddDrivers = 1, 
    kIOCatalogAddDriversNoMatch, 
    kIOCatalogRemoveDrivers, 
    kIOCatalogRemoveDriversNoMatch, 
    kIOCatalogStartMatching, 
    kIOCatalogRemoveKernelLinker, 
    kIOCatalogKextdFinishedLaunching 
};  
Constants
kIOCatalogAddDrivers
Signals a call to the addDrivers function in IOCatalogue.
kIOCatalogAddDriversNoMatch
Signals a call to the addDrivers function in IOCatalogue but does not start a matching thread.
kIOCatalogRemoveDrivers
Signals a call to the removeDrivers function in IOCatalogue.
kIOCatalogRemoveDriversNoMatch
Signals a call to the removeDrivers function in IOCatalogue but does not start a matching thread.
kIOCatalogStartMatching
Signals the IOCatalogue to start an IOService matching thread.
Discussion 

user-client flags.*/
enum { 
    kIOCatalogAddDrivers = 1, 
    kIOCatalogAddDriversNoMatch, 
    kIOCatalogRemoveDrivers, 
    kIOCatalogRemoveDriversNoMatch, 
    kIOCatalogStartMatching, 
    kIOCatalogRemoveKernelLinker, 
    kIOCatalogKextdFinishedLaunching 
};

/*IOCatalogueTerminate


enum { 
    kIOCatalogModuleUnload = 1, 
    kIOCatalogModuleTerminate, 
    kIOCatalogServiceTerminate 
};  
Constants
kIOCatalogModuleUnload

Terminates all services which depend on a particular module and unloads the module.
kIOCatalogModuleTerminate

Terminates all services which depend on a particular module but does not unload the module.
kIOCatalogServiceTerminate

Terminates a particular service by name.
Discussion 
user-client flags.*/
enum { 
    kIOCatalogModuleUnload = 1, 
    kIOCatalogModuleTerminate, 
    kIOCatalogServiceTerminate 
};  

/*IOCatalogueGetData


enum { 
    kIOCatalogGetContents = 1, 
    kIOCatalogGetModuleDemandList = 2, 
    kIOCatalogGetCacheMissList = 3, 
    kIOCatalogGetROMMkextList = 4 
};  
Constants
kIOCatalogGetContents

Returns a snapshot of the database to the caller.
Discussion 
user-client flags*/
enum { 
    kIOCatalogGetContents = 1, 
    kIOCatalogGetModuleDemandList = 2, 
    kIOCatalogGetCacheMissList = 3, 
    kIOCatalogGetROMMkextList = 4 
};  

#endif //_IOKIT_IOKITSERVER_H
