
#ifndef _IOKIT_IONOTIFIER_H
#define _IOKIT_IONOTIFIER_H

#include <libkern/c++/OSObject.h>

#ifdef __cplusplus
class IONotifier : public OSObject
{
    OSDeclareAbstractStructors(IONotifier)

public:

/*remove


Removes the notification request and releases it. 

public

virtual void remove() = 0; 
Discussion 

Removes the notification request and release it. Since creating an IONotifier instance will leave it with a retain count of one, creating an IONotifier and then removing it will destroy it. This method is synchronous with any handler invocations, so when this method returns its guaranteed the handler will not be in entered.*/
virtual void remove() = 0; 
};

#endif //__cplusplus
#endif//_IOKIT_IONOTIFIER_H
