#ifndef _IOKIT_IOACPIPLATFORMDEVICE_H
#define _IOKIT_IOACPIPLATFORMDEVICE_H

#include <libkern/c++/OSContainers.h>
#include <IOKit/IOPlatformExpert.h>
#include <IOKit/acpi/IOACPITypes.h>

class IOACPIPlatformExpert;

#include <HYS/IOKit/acpi/IOACPIPlatformDevice.h>

class IOACPIPlatformDevice : public IOPlatformDevice,public IOACPIPlatformDevice_HYS
{
OSDeclareDefaultStructors( IOACPIPlatformDevice )
public:
IOACPIPlatformDevice_init
IOACPIPlatformDevice_free
IOACPIPlatformDevice_attachToParent
IOACPIPlatformDevice_detachFromParent
IOACPIPlatformDevice_initACPIPowerManagement
IOACPIPlatformDevice_stopACPIPowerManagement
IOACPIPlatformDevice_getDeviceHandle
IOACPIPlatformDevice_getDeviceType
IOACPIPlatformDevice_setDeviceType
IOACPIPlatformDevice_validateObject_const_OSSymbol
IOACPIPlatformDevice_validateObject_const_char
IOACPIPlatformDevice_evaluateObject_const_char
IOACPIPlatformDevice_evaluateObject_const_OSSymbol
IOACPIPlatformDevice_evaluateInteger_const_char
IOACPIPlatformDevice_evaluateInteger_const_OSSymbol
IOACPIPlatformDevice_evaluateInteger_const_OSSymbol_UInt32
IOACPIPlatformDevice_evaluateInteger_const_char_UInt32
IOACPIPlatformDevice_getACPITableData
IOACPIPlatformDevice_getDeviceStatus
IOACPIPlatformDevice_installInterruptForFixedEvent
IOACPIPlatformDevice_installInterruptForGPE
IOACPIPlatformDevice_acquireGlobalLock
IOACPIPlatformDevice_releaseGlobalLock
IOACPIPlatformDevice_registerAddressSpaceHandler
IOACPIPlatformDevice_unregisterAddressSpaceHandler
IOACPIPlatformDevice_readAddressSpace
IOACPIPlatformDevice_writeAddressSpace
IOACPIPlatformDevice_getPathComponent
IOACPIPlatformDevice_compareName
IOACPIPlatformDevice_getResources
IOACPIPlatformDevice_hasSystemWakeCapability
IOACPIPlatformDevice_setSystemWakeCapabilityEnable
IOACPIPlatformDevice_hasACPIPowerStateSupport
IOACPIPlatformDevice_setACPIPowerManagementEnable
IOACPIPlatformDevice_ioWrite8
IOACPIPlatformDevice_ioRead8
IOACPIPlatformDevice_setPowerState
IOACPIPlatformDevice_ioRead32
IOACPIPlatformDevice_ioWrite16
IOACPIPlatformDevice_ioRead16
IOACPIPlatformDevice_ioWrite32

};

#endif //_IOKIT_IOACPIPLATFORMDEVICE_H

