
#ifndef _IOKIT_ADBCONTROLLER_H
#define _IOKIT_ADBCONTROLLER_H

#include <IOKit/IOService.h>
#include <IOKit/adb/adb.h>
#include <IOKit/adb/IOADBBus.h>

extern "C" {
#include <kern/thread_call.h>
}

class IOADBDevice;
class IOPMrootDomain;

#include <HYS/IOKit/adb/IOADBController.h>
class IOADBController: public IOADBBus,public IOADBController_HYS
{
OSDeclareAbstractStructors(IOADBController)

public:

IOADBController_start
IOADBController_powerStateWillChangeTo
IOADBController_powerStateDidChangeTo
IOADBController_probeAddress
IOADBController_moveDeviceFrom
IOADBController_firstBit
IOADBController_probeBus
IOADBController_cancelAllIO
IOADBController_claimDevice
IOADBController_clearOwner
IOADBController_setOwner
IOADBController_flush
IOADBController_releaseDevice
IOADBController_readRegister
IOADBController_packet
IOADBController_readDeviceForUser
IOADBController_newUserClient
IOADBController_getURLComponentUnit
IOADBController_writeDeviceForUser
IOADBController_handlerID
IOADBController_setHandlerID
IOADBController_writeRegister
IOADBController_defaultHandlerID 
IOADBController_matchNubWithPropertyTable
IOADBController_defaultAddress
IOADBController_address

private:
 
};

#endif //_IOKIT_ADBCONTROLLER_H
