
#ifndef __OPEN_SOURCE__
#endif


#ifndef _ATADEVICENUB_H
#define _ATADEVICENUB_H

#include <IOKit/IOTypes.h>
#include "IOATATypes.h"
#include "IOATADevice.h"
#include "IOATAController.h"

#include "IOATABusCommand.h"

class ATADeviceNub : public IOATADevice
{
    OSDeclareDefaultStructors(ATADeviceNub)

public:

/*ataDeviceNub


Creates nubs. 

public

static ATADeviceNub* ataDeviceNub(
    IOATAController *provider,
    ataUnitID unit,
    ataDeviceType devType); 
Discussion 

ataDeviceNub is a static creator function that is used by IOATAControllers to create nubs.*/
static ATADeviceNub* ataDeviceNub(
    IOATAController *provider,
    ataUnitID unit,
    ataDeviceType devType); 

protected:

private:

};

#endif /* !_IOATABUSNUB_H */


