#ifndef _IOKIT_IOAUDIOENGINEUSERCLIENT_H
#define _IOKIT_IOAUDIOENGINEUSERCLIENT_H

#include <IOKit/IOUserClient.h>
#include <IOKit/audio/IOAudioEngine.h>
#include <IOKit/audio/IOAudioTypes.h>
#include <IOKit/IOBufferMemoryDescriptor.h>

class IOAudioEngine;
class IOAudioStream;
class IOMemoryDescriptor;
class IOCommandGate;
class IOWorkLoop;

class IOAudioEngineUserClient;
class IOAudioClientBufferSet;

#include <HYS/IOKit/audio/IOAudioEngineUserClient.h>
class IOAudioEngineUserClient : public IOUserClient,public IOAudioEngineUserClient_HYS
{
    OSDeclareDefaultStructors(IOAudioEngineUserClient)

    friend class IOAudioEngine;
    friend class IOAudioClientBufferSet;
    friend class IOAudioStream;

private:
protected:
public:

IOAudioEngineUserClient_registerClientParameterBuffer
IOAudioEngineUserClient_initWithAudioEngine_OSDictionary 
IOAudioEngineUserClient_safeRegisterClientBuffer
IOAudioEngineUserClient_safeRegisterClientBuffer64
IOAudioEngineUserClient_findExtendedInfo
IOAudioEngineUserClient_findExtendedInfo64
IOAudioEngineUserClient_removeBufferSet
IOAudioEngineUserClient_performClientIO
IOAudioEngineUserClient_getClientNearestStartTime
IOAudioEngineUserClient_unregisterClientBuffer64
IOAudioEngineUserClient_findBufferSet
IOAudioEngineUserClient_registerClientBuffer64
IOAudioEngineUserClient_registerClientBuffer
IOAudioEngineUserClient_unregisterBufferAction
IOAudioEngineUserClient_registerBufferAction
IOAudioEngineUserClient_unregisterBuffer64
IOAudioEngineUserClient_externalMethod
IOAudioEngineUserClient_registerNotificationAction
IOAudioEngineUserClient_registerNotification
IOAudioEngineUserClient_registerNotificationPort
IOAudioEngineUserClient_clientMemoryForType
IOAudioEngineUserClient_isOnline
IOAudioEngineUserClient_lockBuffers
IOAudioEngineUserClient_setOnline
IOAudioEngineUserClient_clientDied
IOAudioEngineUserClient_closeClientAction
IOAudioEngineUserClient_stop
IOAudioEngineUserClient_freeClientBufferSetList
IOAudioEngineUserClient_getNearestStartTime
IOAudioEngineUserClient_getNearestStartTimeAction
IOAudioEngineUserClient_free
IOAudioEngineUserClient_registerBuffer64
IOAudioEngineUserClient_unregisterBuffer
IOAudioEngineUserClient_registerBuffer
IOAudioEngineUserClient_getExternalMethodForIndex
IOAudioEngineUserClient_getExternalTrapForIndex
IOAudioEngineUserClient_unlockBuffers
IOAudioEngineUserClient_closeClient
IOAudioEngineUserClient_clientClose
IOAudioEngineUserClient_freeClientBuffer
IOAudioEngineUserClient_withAudioEngine_OSDictionary
IOAudioEngineUserClient_withAudioEngine
IOAudioEngineUserClient_initWithAudioEngine
IOAudioEngineUserClient_stopClientAction
IOAudioEngineUserClient_clientStart
IOAudioEngineUserClient_startClient
IOAudioEngineUserClient_sendNotification
IOAudioEngineUserClient_stopClient
IOAudioEngineUserClient_performWatchdogOutput
IOAudioEngineUserClient_unregisterClientBuffer
IOAudioEngineUserClient_performClientInput
IOAudioEngineUserClient_performClientOutput
IOAudioEngineUserClient_getConnectionID
IOAudioEngineUserClient_startClientAction
IOAudioEngineUserClient_clientStop
IOAudioEngineUserClient_sendFormatChangeNotification

};

#endif /* _IOKIT_IOAUDIOENGINEUSERCLIENT_H */
