#ifndef IOKIT_FIREWIRE_IOFWDCLPOOL_H
#define IOKIT_FIREWIRE_IOFWDCLPOOL_H

#include <libkern/c++/OSObject.h>
#include <libkern/c++/OSArray.h>
#include <IOKit/IOTypes.h>

class IOFireWireLink ;
class IOFWDCL ;
class IOFWReceiveDCL ;
class IOFWSendDCL ;
class IOFWSkipCycleDCL ;
class IOFireWireUserClient ;
class IOMemoryDescriptor ;
class IOMemoryMap ;

#include <HYS/IOKit/firewire/IOFWDCLPool.h>

class IOFWDCLPool : public OSObject,public IOFWDCLPool_HYS
{
	OSDeclareAbstractStructors( IOFWDCLPool )

	friend class IOFireWireUserClient ;
	friend class IOFWUserLocalIsochPort ;
	
	protected:
	
	public:
	protected :
	protected :
	private :
	public :
} ;

#endif//IOKIT_FIREWIRE_IOFWDCLPOOL_H
