

#ifndef _IOKIT_IOFWDCLTRANSLATOR_H
#define _IOKIT_IOFWDCLTRANSLATOR_H

#include <libkern/c++/OSObject.h>
#include <IOKit/firewire/IOFWDCLProgram.h>

#include <HYS/IOKit/firewire/IOFWDCLTranslator.h>

class IODCLTranslator : public IODCLProgram,public IODCLTranslator_HYS
{
    OSDeclareAbstractStructors(IODCLTranslator)

protected:
public:
IODCLTranslator_init
IODCLTranslator_releaseHW
IODCLTranslator_stop
IODCLTranslator_getTranslatorOpcodes
IODCLTranslator_setHWProgram
IODCLTranslator_allocateHW
IODCLTranslator_notify
IODCLTranslator_ListeningDCLPingPongProc
IODCLTranslator_TalkingDCLPingPongProc

};

class IODCLTranslateTalk : public IODCLTranslator,public IODCLTranslateTalk_HYS
{
    OSDeclareDefaultStructors(IODCLTranslateTalk)

protected:
public:

IODCLTranslateTalk_compile
IODCLTranslateTalk_start

};


class IODCLTranslateListen : public IODCLTranslator,public IODCLTranslateListen_HYS
{
    OSDeclareDefaultStructors(IODCLTranslateListen)

protected:
public:
IODCLTranslateListen_start
IODCLTranslateListen_compile

};

#endif /* ! _IOKIT_IOFWDCLPROGRAM_H */

