#ifndef _IOKIT_IOFWISOCHCHANNEL_H
#define _IOKIT_IOFWISOCHCHANNEL_H

#include <libkern/c++/OSObject.h>
#include <IOKit/firewire/IOFireWireFamilyCommon.h>

class IOFireWireController;
class IOFWIsochChannel;
class IOFWIsochPort;
class OSSet;
class IOFWReadQuadCommand;
class IOFWCompareAndSwapCommand;

#include <HYS/IOKit/firewire/IOFWIsochChannel.h>

class IOFWIsochChannel : public OSObject,public IOFWIsochChannel_HYS
{
    OSDeclareDefaultStructors(IOFWIsochChannel)

public:
IOFWIsochChannel_init
IOFWIsochChannel_free
IOFWIsochChannel_checkMemoryInRange
IOFWIsochChannel_start
IOFWIsochChannel_setTalker
IOFWIsochChannel_addListener
IOFWIsochChannel_stop
IOFWIsochChannel_allocateChannel
IOFWIsochChannel_allocateChannelBegin
IOFWIsochChannel_updateBandwidth
IOFWIsochChannel_releaseChannelComplete
IOFWIsochChannel_releaseChannel
IOFWIsochChannel_reallocBandwidth
IOFWIsochChannel_handleBusReset
IOFWIsochChannel_threadFunc

protected:
private:
};

#endif /* ! _IOKIT_IOFWISOCHCHANNEL_H */

