#ifndef _IOKIT_IOFIREWIREBUS_H
#define _IOKIT_IOFIREWIREBUS_H

#include <IOKit/IOService.h>
#include <IOKit/firewire/IOFWIsochChannel.h>
#include <IOKit/firewire/IOFWAddressSpace.h>
#include <IOKit/firewire/IOFWCommand.h>
#include <IOKit/firewire/IOFireWireFamilyCommon.h>


class IOFireWireDevice;
class IOLocalConfigDirectory;
class IOFWLocalIsochPort;
class IOFireWirePowerManager;
class IOFireWireBus;
class IOFWDCLPool;
class IOFWSimpleContiguousPhysicalAddressSpace;
class IOFWSimplePhysicalAddressSpace;


class IOFWBufferFillIsochPort ;
#include <HYS/IOKit/firewire/IOFireWireBus.h>

class IOFireWireBusAux : public OSObject,public IOFireWireBusAux_HYS
{
    OSDeclareAbstractStructors(IOFireWireBusAux)

	friend class IOFireWireBus;
	
	protected:
	public :
	private:
};

class IOFireWireBus : public IOService,public IOFireWireBus_HYS
{
    OSDeclareAbstractStructors(IOFireWireBus)

public:
IOFireWireBus_createBufferFillIsochPort
IOFireWireBus_gIOFireWirePlane

protected:
private:

};

#endif /* ! _IOKIT_IOFIREWIREBUS_H */

