#ifndef _IOKIT_HID_IOHIDEVENTSERVICE_H
#define _IOKIT_HID_IOHIDEVENTSERVICE_H

#include <TargetConditionals.h>

#include <IOKit/IOService.h>
#include <IOKit/IOWorkLoop.h>
#include <IOKit/IOTimerEventSource.h>
#include <IOKit/hidsystem/IOHIDTypes.h>
#include <IOKit/hid/IOHIDInterface.h>
#include <IOKit/hid/IOHIDElement.h>

//#if TARGET_OS_EMBEDDED
   #include <IOKit/hid/IOHIDEvent.h>
//#endif

#ifdef __cplusplus
class   IOHIDPointing;
class   IOHIDKeyboard;
class   IOHIDConsumer;
#endif //__cplusplus

struct  TransducerData;

#include <HYS/IOKit/hidevent/IOHIDEventService.h>

#ifdef __cplusplus

class IOHIDEventService: public IOService,public IOHIDEventService_HYS
{
    OSDeclareAbstractStructors( IOHIDEventService )
    
    friend class IOHIDPointing;
    friend class IOHIDKeyboard;
    friend class IOHIDConsumer;
    friend class AppleEmbeddedKeyboard;

private:
protected:
public:
using IOHIDEventService_HYS::open;//add

};

#endif //__cplusplus

#endif /* !_IOKIT_HID_IOHIDEVENTSERVICE_H */
