
#ifndef _IOHIKEYBOARDMAPPER_H
#define _IOHIKEYBOARDMAPPER_H

#include <IOKit/hidsystem/ev_keymap.h>
#include <IOKit/hidsystem/IOLLEvent.h>
#include <IOKit/IOTimerEventSource.h>
#include <IOKit/IOInterruptEventSource.h>

class IOHIKeyboard;
class IOHIDSystem;
class IOHIDKeyboardDevice;

#include <HYS/IOKit/hidsystem/IOHIKeyboardMapper.h>

class IOHIKeyboardMapper : public OSObject,public IOHIKeyboardMapper_HYS
{
  OSDeclareDefaultStructors(IOHIKeyboardMapper);

private:
public:	

IOHIKeyboardMapper_message
IOHIKeyboardMapper_slowKeysPostProcess
IOHIKeyboardMapper_performF12Eject
IOHIKeyboardMapper_keyEventPostProcess
IOHIKeyboardMapper_stickyKeysSetFnState
IOHIKeyboardMapper_stickyKeysMouseUp
IOHIKeyboardMapper_stickyKeysModifierKey
IOHIKeyboardMapper_stickyKeysFilterKey
IOHIKeyboardMapper_f12EjectFilterKey
IOHIKeyboardMapper_slowKeysFilterKey
IOHIKeyboardMapper_stickyKeysCleanup
IOHIKeyboardMapper_stickyKeysNonModifierKey
IOHIKeyboardMapper_stickyKeysModifierToggleCheck
IOHIKeyboardMapper_postKeyboardSpecialEvent
IOHIKeyboardMapper_stickyKeysAllocToggleInfo
IOHIKeyboardMapper_stickyKeysFreeToggleInfo
IOHIKeyboardMapper_createParamDicts
IOHIKeyboardMapper_setParamProperties
IOHIKeyboardMapper_updateProperties
IOHIKeyboardMapper_makeNumberParamProperty
IOHIKeyboardMapper_setKeyboardTarget 
IOHIKeyboardMapper_calcModBit
IOHIKeyboardMapper_getParsedSpecialKey
IOHIKeyboardMapper_doCharGen
IOHIKeyboardMapper_doModCalc
IOHIKeyboardMapper_rawTranslateKeyCode
IOHIKeyboardMapper_modifierSwapFilterKey
IOHIKeyboardMapper_mapping
IOHIKeyboardMapper_stickyKeysfree
IOHIKeyboardMapper_serialize
IOHIKeyboardMapper_mappingLength
IOHIKeyboardMapper_free
IOHIKeyboardMapper_stickyKeysinit
IOHIKeyboardMapper_parseKeyMapping
IOHIKeyboardMapper_keyboardMapper
IOHIKeyboardMapper_init
IOHIKeyboardMapper_translateKeyCode

};

#endif//_IOHIKEYBOARDMAPPER_H
