
#ifndef _IOHIPOINTING_H
#define _IOHIPOINTING_H

#include <IOKit/hidsystem/IOHIPointing.h>
#include <IOKit/hidsystem/IOHIDevice.h>
#include <IOKit/hidsystem/IOHIDTypes.h>

class IOHIDPointingDevice;
struct ScrollAccelInfo;

#include <HYS/IOKit/hidsystem/IOHIPointing.h>

class IOHIPointing : public IOHIDevice,public IOHIPointing_HYS
{
    OSDeclareDefaultStructors(IOHIPointing);
    
    friend class IOHITablet;
    friend class IOHIDPointing;

private:
protected:
public:

IOHIPointing_copyScrollAccelerationTable
IOHIPointing_setParamProperties
IOHIPointing_dispatchScrollWheelEventWithAccelInfo
IOHIPointing_resetScroll
IOHIPointing_updateProperties
IOHIPointing_copyScrollAccelerationTableForType
IOHIPointing_scrollResolutionForType
IOHIPointing_resetPointer
IOHIPointing_scrollReportRate
IOHIPointing_setupScrollForAcceleration
IOHIPointing_setupForAcceleration
IOHIPointing_scalePointer
IOHIPointing_hidKind
IOHIPointing_powerStateDidChangeTo
IOHIPointing_powerStateWillChangeTo
IOHIPointing_message
IOHIPointing_close
IOHIPointing__scrollWheelEvent
IOHIPointing__absolutePointerEvent
IOHIPointing__relativePointerEvent
IOHIPointing_resolution
IOHIPointing_buttonCount
IOHIPointing_open_void
IOHIPointing_free
IOHIPointing_start
IOHIPointing_open
IOHIPointing_init
IOHIPointing_dispatchRelativePointerEvent
IOHIPointing_copyAccelerationTable
IOHIPointing_getPointingMode
IOHIPointing_setPointingMode
IOHIPointing_dispatchAbsolutePointerEvent
IOHIPointing_dispatchScrollWheelEvent

};

#endif //_IOHIPOINTING_H
