
#ifndef _IOKIT_IONDRVFRAMEBUFFER_H
#define _IOKIT_IONDRVFRAMEBUFFER_H

#include <IOKit/graphics/IOFramebuffer.h>
#include <IOKit/ndrvsupport/IOMacOSVideo.h>
#include <IOKit/ndrvsupport/IONDRVSupport.h>

#include <HYS/IOKit/ndrvsupport/IONDRVFramebuffer.h>
class IONDRVFramebuffer : public IOFramebuffer,public IONDRVFramebuffer_HYS
{
    OSDeclareDefaultStructors(IONDRVFramebuffer)

private:

IONDRVFramebuffer___private

protected:
public:

IONDRVFramebuffer_ndrvSetDisplayPowerState
IONDRVFramebuffer_powerStateForDomainState
IONDRVFramebuffer_initialPowerStateForDomainState
IONDRVFramebuffer_maxCapabilityForDomainState
IONDRVFramebuffer_hasDDCConnect
IONDRVFramebuffer_connectFlags
IONDRVFramebuffer_getAppleSense
IONDRVFramebuffer_getAttributeForConnection
IONDRVFramebuffer_processConnectChange
IONDRVFramebuffer_searchOfflineMode
IONDRVFramebuffer_setAttributeForConnection
IONDRVFramebuffer_setConnectionFlags
IONDRVFramebuffer_displayI2CPower
IONDRVFramebuffer_doI2CRequest
IONDRVFramebuffer_getConnectionCount
IONDRVFramebuffer_getOnlineState
IONDRVFramebuffer_getAttribute
IONDRVFramebuffer_ndrvUpdatePowerState
IONDRVFramebuffer_ndrvGetSetFeature
IONDRVFramebuffer_ndrvSetPowerState
IONDRVFramebuffer_setAttribute
IONDRVFramebuffer_setMirror
IONDRVFramebuffer_mirrorInfo
IONDRVFramebuffer_setGammaTable
IONDRVFramebuffer_setCLUTWithEntries
IONDRVFramebuffer_setApertureEnable
IONDRVFramebuffer_getStartupDisplayMode
IONDRVFramebuffer_setStartupDisplayMode
IONDRVFramebuffer_getTimingInfoForDisplayMode
IONDRVFramebuffer_getPixelFormatsForDisplayMode
IONDRVFramebuffer_setDetailedTimings
IONDRVFramebuffer_validateDetailedTiming
IONDRVFramebuffer_getPixelFormats
IONDRVFramebuffer_makeSubRange
IONDRVFramebuffer_setDetailedTiming
IONDRVFramebuffer_getResInfoForMode
IONDRVFramebuffer_validateDisplayMode
IONDRVFramebuffer_getResInfoForArbMode
IONDRVFramebuffer_getResInfoForDetailed
IONDRVFramebuffer_mapDepthIndex
IONDRVFramebuffer_iterateAllModes
IONDRVFramebuffer_setInfoProperties
IONDRVFramebuffer_createI2C
IONDRVFramebuffer_extStatus
IONDRVFramebuffer_doDriverIO
IONDRVFramebuffer_setCursorState
IONDRVFramebuffer_VSLPrepareCursorForHardwareCursor
IONDRVFramebuffer_VSLDoInterruptService
IONDRVFramebuffer_VSLDisposeInterruptService
IONDRVFramebuffer_setInterruptState
IONDRVFramebuffer_VSLNewInterruptService
IONDRVFramebuffer_setCursorImage
IONDRVFramebuffer_unregisterInterrupt
IONDRVFramebuffer_registerForInterruptType
IONDRVFramebuffer_free
IONDRVFramebuffer_undefinedSymbolHandler
IONDRVFramebuffer_findVRAM
IONDRVFramebuffer_getVRAMRange
IONDRVFramebuffer_requestProbe
IONDRVFramebuffer__doControl
IONDRVFramebuffer__probeAction
IONDRVFramebuffer__avProbeAction
IONDRVFramebuffer_initForPM
IONDRVFramebuffer__doStatus
IONDRVFramebuffer_getCurrentConfiguration
IONDRVFramebuffer_extControl
IONDRVFramebuffer_checkDriver
IONDRVFramebuffer_isConsoleDevice
IONDRVFramebuffer_enableController
IONDRVFramebuffer__videoJackStateChangeHandler
IONDRVFramebuffer_start
IONDRVFramebuffer_stop
IONDRVFramebuffer__undefinedSymbolHandler
IONDRVFramebuffer_setProperties
IONDRVFramebuffer_probe
IONDRVFramebuffer_getDDCBlock
IONDRVFramebuffer_setDisplayMode
IONDRVFramebuffer_getCurrentDisplayMode
IONDRVFramebuffer_getDisplayModeCount
IONDRVFramebuffer_getDisplayModes
IONDRVFramebuffer_getApertureRange
IONDRVFramebuffer_getPixelInformation
IONDRVFramebuffer_getInformationForDisplayMode
IONDRVFramebuffer_doStatus
IONDRVFramebuffer_doControl

};

#endif //_IOKIT_IONDRVFRAMEBUFFER_H


