
#ifndef _LINUX_K_COMPAT_H
#define _LINUX_K_COMPAT_H

#include <IOKit/assert.h>
#include <IOKit/IOLib.h>
#include <libkern/OSByteOrder.h>
#include <sys/errno.h>

#ifdef __cplusplus
class IOPCIDevice;
class IOPCCardBridge;
class IOCardBusDevice;
class IOPCCard16Device;
#else
typedef struct IOPCIDevice	IOPCIDevice;
typedef struct IOPCCardBridge	IOPCCardBridge;
#define        IOCardBusDevice	IOPCIDevice	
typedef struct IOPCCard16Device	IOPCCard16Device;
#endif //__cplusplus

#include <HYS/IOKit/pccard/k_compat.h>

#endif //_LINUX_K_COMPAT_H

