
#ifndef _IOKIT_IOPOWERCONNECTION_H
#define _IOKIT_IOPOWERCONNECTION_H

#include <IOKit/IOService.h>
#include <IOKit/pwr_mgt/IOPM.h>

class IOPowerConnection : public IOService
{
    OSDeclareDefaultStructors(IOPowerConnection)

protected:
  
public:
    
/*childHasRequestedPower


Return the flag that says whether the child has called requestPowerDomainState. 

public

bool childHasRequestedPower (
    void ); 
Discussion 

Called by the PCI Aux Power Supply Driver to see if a device driver is power managed.*/
bool childHasRequestedPower (
    void ); 

};

#endif 

