
#ifndef _IOKIT_IOFIREWIRESBP2MANAGEMENTORB_H
#define _IOKIT_IOFIREWIRESBP2MANAGEMENTORB_H

#include <IOKit/firewire/IOFWCommand.h>
#include <IOKit/firewire/IOFireWireUnit.h>

#include <IOKit/IOUserClient.h>

class IOFireWireSBP2LUN;
class IOFireWireSBP2ManagementORB;
class IOFireWireSBP2ORB;

/*FWSBP2ManagementCallback


typedef void ( *FWSBP2ManagementCallback)(
    void *refCon,
    IOReturn status,
    IOFireWireSBP2ManagementORB *orb);  
Parameters
refCon
Reference constant supplied when the notification was registered.
status
Indicates success or failure of operation.
orb
Indicates current orb status is for.*/
typedef void ( *FWSBP2ManagementCallback)(
    void *refCon,
    IOReturn status,
    IOFireWireSBP2ManagementORB *orb);  

#include <HYS/IOKit/sbp2/IOFireWireSBP2ManagementORB.h>
class IOFireWireSBP2ManagementORB : public IOFWCommand,public IOFireWireSBP2ManagementORB_HYS
{
    OSDeclareDefaultStructors( IOFireWireSBP2ManagementORB )

	friend class IOFireWireSBP2LUN;
	friend class IOFireWireSBP2UserClient;

public:

IOFireWireSBP2ManagementORB_complete
IOFireWireSBP2ManagementORB_statusBlockWrite
IOFireWireSBP2ManagementORB_clearAllTasksInSet
IOFireWireSBP2ManagementORB_handleTimeout
IOFireWireSBP2ManagementORB_writeComplete
IOFireWireSBP2ManagementORB_setORBToDummy
IOFireWireSBP2ManagementORB_execute
IOFireWireSBP2ManagementORB_getResponseBuffer
IOFireWireSBP2ManagementORB_setResponseBuffer_void
IOFireWireSBP2ManagementORB_getManageeCommand
IOFireWireSBP2ManagementORB_getCommandFunction
IOFireWireSBP2ManagementORB_release
IOFireWireSBP2ManagementORB_removeManagementORB
IOFireWireSBP2ManagementORB_free
IOFireWireSBP2ManagementORB_handleTimeoutStatic
IOFireWireSBP2ManagementORB_writeCompleteStatic
IOFireWireSBP2ManagementORB_statusBlockWriteStatic
IOFireWireSBP2ManagementORB_allocateResources
IOFireWireSBP2ManagementORB_suspendedNotify
IOFireWireSBP2ManagementORB_getAsyncCallbackReference
IOFireWireSBP2ManagementORB_setAsyncCallbackReference
IOFireWireSBP2ManagementORB_getUnitInformation
IOFireWireSBP2ManagementORB_setManageeCommand
IOFireWireSBP2ManagementORB_setCommandFunction
IOFireWireSBP2ManagementORB_initWithLUN
IOFireWireSBP2ManagementORB_setResponseBuffer

protected:
private:
    
};

#endif//_IOKIT_IOFIREWIRESBP2MANAGEMENTORB_H

