#ifndef _IOSCSIPARALLELCOMMAND_H
#define _IOSCSIPARALLELCOMMAND_H

#include "IOSCSICommand.h"
#include "SCSIParallelTarget.h"

class IOSCSIParallelDevice;
class IOSCSIParallelCommand;
class IOSyncer;

#include <HYS/IOKit/scsi/IOSCSIParallelCommand.h>

class IOSCSIParallelCommand : public IOSCSICommand,public IOSCSIParallelCommand_HYS
{
    OSDeclareDefaultStructors(IOSCSIParallelCommand)

    friend class IOSCSIParallelController;
    friend class IOSCSIParallelDevice;

private:
public:  


IOSCSIParallelCommand_getDevice
IOSCSIParallelCommand_getDevice_IOSCSIDevice
IOSCSIParallelCommand_getDevice_IOCDBDevice
IOSCSIParallelCommand_getClientData
IOSCSIParallelCommand_getCommandData
IOSCSIParallelCommand_getCmdType
IOSCSIParallelCommand_getOriginalCmd
IOSCSIParallelCommand_getSequenceNumber
IOSCSIParallelCommand_getTargetLun
IOSCSIParallelCommand_setTimeout
IOSCSIParallelCommand_getTimeout
IOSCSIParallelCommand_setResults
IOSCSIParallelCommand_setResults_SCSIResults
IOSCSIParallelCommand_adapterStatusToIOReturnCode
IOSCSIParallelCommand_getCDB
IOSCSIParallelCommand_complete
IOSCSIParallelCommand_getPointers
IOSCSIParallelCommand_scsiStatusToIOReturnCode
IOSCSIParallelCommand_getResults
IOSCSIParallelCommand_setQueueInfo
IOSCSIParallelCommand_getQueueInfo
IOSCSIParallelCommand_setPointers
IOSCSIParallelCommand_setCallback
IOSCSIParallelCommand_setCDB
IOSCSIParallelCommand_execute
IOSCSIParallelCommand_abort
IOSCSIParallelCommand_getCDB_CDBInfo
IOSCSIParallelCommand_setCDB_CDBInfo
IOSCSIParallelCommand_getResults_CDBResults
IOSCSIParallelCommand_zeroCommand
IOSCSIParallelCommand_free

};

#endif//_IOSCSIPARALLELCOMMAND_H
