#ifndef _IOSCSIPARALLELCONTROLLER_H
#define _IOSCSIPARALLELCONTROLLER_H

#include <IOKit/IOService.h>
#include <IOKit/IOWorkLoop.h>
#include <IOKit/IOCommandGate.h>
#include <IOKit/IOInterruptEventSource.h>
#include <IOKit/IOTimerEventSource.h>
#include <libkern/OSByteOrder.h>
#include <IOKit/IOMemoryCursor.h>
#include "SCSIDevice.h"
#include "SCSIParallelController.h"

class SCSITarget;
class IOSCSIParallelCommand;
class IOSCSIParallelDevice;

#include  <HYS/IOKit/scsi/IOSCSIParallelController.h>
class IOSCSIParallelController : public IOService,public IOSCSIParallelController_HYS
{
    OSDeclareDefaultStructors(IOSCSIParallelController)

    friend class IOSCSIParallelCommand;
    friend class IOSCSIParallelDevice;
	
public:
IOSCSIParallelController_sDomainCount
IOSCSIParallelController_start
IOSCSIParallelController_createWorkLoop
IOSCSIParallelController_initTargetGated
IOSCSIParallelController_configureController
IOSCSIParallelController_initQueues
IOSCSIParallelController_scanSCSIBus
IOSCSIParallelController_probeTarget
IOSCSIParallelController_initTarget
IOSCSIParallelController_releaseTarget
IOSCSIParallelController_createDevice
IOSCSIParallelController_releaseDevice
IOSCSIParallelController_initDevice
IOSCSIParallelController_releaseTargetGated
IOSCSIParallelController_initDeviceGated
IOSCSIParallelController_releaseDeviceGated
IOSCSIParallelController_addDevice
IOSCSIParallelController_allocateTarget
IOSCSIParallelController_deallocateTarget
IOSCSIParallelController_rescheduleCommand
IOSCSIParallelController_disableCommands
IOSCSIParallelController_enableCommands
IOSCSIParallelController_resetOccurred
IOSCSIParallelController_allocateLun
IOSCSIParallelController_completeCommand
IOSCSIParallelController_deleteDevice
IOSCSIParallelController_deallocateLun
IOSCSIParallelController_getTargetData
IOSCSIParallelController_getLunData
IOSCSIParallelController_allocCommand
IOSCSIParallelController_timer
IOSCSIParallelController_reset
IOSCSIParallelController_checkBusReset
IOSCSIParallelController_disableTimeoutOccurred
IOSCSIParallelController_dispatch
IOSCSIParallelController_findCommandWithNexus
IOSCSIParallelController_findDeviceWithTargetLun
IOSCSIParallelController_setCommandLimit
IOSCSIParallelController_getWorkLoop
IOSCSIParallelController_disableCommands_UInt32
IOSCSIParallelController_dispatchRequest
IOSCSIParallelController_free

protected:
private:

};

#endif//_IOSCSIPARALLELCONTROLLER_H
