
#ifndef _IOSCSIPARALLELDEVICE_H
#define _IOSCSIPARALLELDEVICE_H

#include "SCSIDevice.h"
#include "SCSIParallelTarget.h"
#include "SCSIPublic.h"
#include "IOSCSIDevice.h"

#include <libkern/c++/OSNumber.h>

class IOSCSIParallelController;

#include <HYS/IOKit/scsi/IOSCSIParallelDevice.h>
class IOSCSIParallelDevice : public IOSCSIDevice,public IOSCSIParallelDevice_HYS
{
    OSDeclareDefaultStructors(IOSCSIParallelDevice)
    
    friend class IOSCSIParallelCommand;
    friend class IOSCSIParallelController;


public:

IOSCSIParallelDevice_allocCommand
IOSCSIParallelDevice_init
IOSCSIParallelDevice_receiveCommand
IOSCSIParallelDevice_probeTargetLun
IOSCSIParallelDevice_setupTarget
IOSCSIParallelDevice_checkCmdQueEnabled
IOSCSIParallelDevice_setTargetParms
IOSCSIParallelDevice_getInquiryData
IOSCSIParallelDevice_abort
IOSCSIParallelDevice_reset
IOSCSIParallelDevice_holdQueue
IOSCSIParallelDevice_releaseQueue
IOSCSIParallelDevice_notifyIdle
IOSCSIParallelDevice_submitCommand
IOSCSIParallelDevice_abortAllCommands
IOSCSIParallelDevice_abortCommand
IOSCSIParallelDevice_resetOccurred
IOSCSIParallelDevice_resetComplete
IOSCSIParallelDevice_checkAbortQueue
IOSCSIParallelDevice_checkCancelQueue
IOSCSIParallelDevice_checkReqSense
IOSCSIParallelDevice_checkDeviceQueue
IOSCSIParallelDevice_rescheduleCommand
IOSCSIParallelDevice_getTargetParms
IOSCSIParallelDevice_setLunParms
IOSCSIParallelDevice_checkIdleNotify
IOSCSIParallelDevice_dispatchRequest
IOSCSIParallelDevice_open
IOSCSIParallelDevice_getLunParms
IOSCSIParallelDevice_checkNegotiate
IOSCSIParallelDevice_negotiationComplete
IOSCSIParallelDevice_checkTag
IOSCSIParallelDevice_allocTag
IOSCSIParallelDevice_freeTag
IOSCSIParallelDevice_findCommandWithNexus
IOSCSIParallelDevice_timer
IOSCSIParallelDevice_dispatch
IOSCSIParallelDevice_completeCommand
IOSCSIParallelDevice_executeCommandDone
IOSCSIParallelDevice_executeReqSenseDone
IOSCSIParallelDevice_abortCommandDone
IOSCSIParallelDevice_cancelCommandDone
IOSCSIParallelDevice_flushQueue
IOSCSIParallelDevice_finishCommand
IOSCSIParallelDevice_createProperties
IOSCSIParallelDevice_addToRegistry
IOSCSIParallelDevice_stripBlanks
IOSCSIParallelDevice_matchPropertyTable
IOSCSIParallelDevice_matchLocation
IOSCSIParallelDevice_allocCommand_IOCDBDevice
IOSCSIParallelDevice_allocCommand_IOSCSIDevice
IOSCSIParallelDevice_getWorkLoop
IOSCSIParallelDevice_close
IOSCSIParallelDevice_message
IOSCSIParallelDevice_free
IOSCSIParallelDevice_addCommand
IOSCSIParallelDevice_deleteCommand
IOSCSIParallelDevice_checkCommand
IOSCSIParallelDevice_getCommand
IOSCSIParallelDevice_stackCommand
IOSCSIParallelDevice_moveCommand
IOSCSIParallelDevice_moveAllCommands
IOSCSIParallelDevice_findCommand
IOSCSIParallelDevice_purgeAllCommands

private:
};


#endif//_IOSCSIPARALLELDEVICE_H
