
#ifndef _IOKIT_IO_SCSI_PRIMARY_COMMANDS_DEVICE_H_
#define _IOKIT_IO_SCSI_PRIMARY_COMMANDS_DEVICE_H_

//#if defined(KERNEL) && defined(__cplusplus)


#include <IOKit/IOLib.h>
#include <IOKit/IOService.h>
#include <IOKit/IOReturn.h>
#include <IOKit/IOMemoryDescriptor.h>
#include <IOKit/IOSyncer.h>


#include <IOKit/scsi/SCSICommandDefinitions.h>
#include <IOKit/scsi/SCSICmds_INQUIRY_Definitions.h>
#include <IOKit/scsi/SCSICmds_REQUEST_SENSE_Defs.h>
#include <IOKit/scsi/IOSCSIProtocolInterface.h>

class SCSIPrimaryCommands;

#include <HYS/IOKit/scsi/IOSCSIPrimaryCommandsDevice.h>
class IOSCSIPrimaryCommandsDevice : public IOSCSIProtocolInterface,public IOSCSIPrimaryCommandsDevice_HYS
{
   OSDeclareAbstractStructors ( IOSCSIPrimaryCommandsDevice )

private:
protected:
public:

IOSCSIPrimaryCommandsDevice_sGetOwnerForTask
IOSCSIPrimaryCommandsDevice_GetApplicationLayerReference
IOSCSIPrimaryCommandsDevice_GetServiceResponse
IOSCSIPrimaryCommandsDevice_GetTaskStatus
IOSCSIPrimaryCommandsDevice_GetDataBuffer
IOSCSIPrimaryCommandsDevice_ReleaseSCSITask
IOSCSIPrimaryCommandsDevice_GetSCSITask 
IOSCSIPrimaryCommandsDevice_SendCommand
IOSCSIPrimaryCommandsDevice_SendCommand_SCSITaskIdentifier
IOSCSIPrimaryCommandsDevice_GetAutoSenseData
IOSCSIPrimaryCommandsDevice_GetAutoSenseData_SCSITaskIdentifier
IOSCSIPrimaryCommandsDevice_ResetForNewTask
IOSCSIPrimaryCommandsDevice_SetApplicationLayerReference
IOSCSIPrimaryCommandsDevice_IsMemoryDescriptorValid
IOSCSIPrimaryCommandsDevice_IsMemoryDescriptorValid_IOMemoryDescriptor
IOSCSIPrimaryCommandsDevice_SetCommandDescriptorBlock
IOSCSIPrimaryCommandsDevice_SetCommandDescriptorBlock_SCSITaskIdentifier
IOSCSIPrimaryCommandsDevice_SetCommandDescriptorBlock_SCSITaskIdentifier_UInt8
IOSCSIPrimaryCommandsDevice_SetCommandDescriptorBlock_SCSITaskIdentifier_UInt8_UInt8
IOSCSIPrimaryCommandsDevice_SetDataTransferDirection
IOSCSIPrimaryCommandsDevice_SetDataBuffer 
IOSCSIPrimaryCommandsDevice_SetRequestedDataTransferCount

};

//#endif   /* defined(KERNEL) && defined(__cplusplus) */

#endif /* _IOKIT_IO_SCSI_PRIMARY_COMMANDS_DEVICE_H_ */
