#ifndef _IOKIT_IO_SCSI_PROTOCOL_SERVICES_H_
#define _IOKIT_IO_SCSI_PROTOCOL_SERVICES_H_

//#if defined(KERNEL) && defined(__cplusplus)

#include <kern/queue.h>
#include <IOKit/IOLib.h>
#include <IOKit/IOCommandGate.h>
#include <IOKit/scsi/SCSITask.h>
#include <IOKit/scsi/IOSCSIProtocolInterface.h>
#include <IOKit/scsi/SCSICmds_REQUEST_SENSE_Defs.h>
class SCSITask;

#include <HYS/IOKit/scsi/IOSCSIProtocolServices.h>

class IOSCSIProtocolServices : public IOSCSIProtocolInterface
,public IOSCSIProtocolServices_HYS
{
	
	OSDeclareAbstractStructors ( IOSCSIProtocolServices )
protected:
private:
public:

IOSCSIProtocolServices_GetLogicalUnitNumber
IOSCSIProtocolServices_GetCommandDescriptorBlock


};

//#endif	/* defined(KERNEL) && defined(__cplusplus) */

#endif	/* _IOKIT_IO_SCSI_PROTOCOL_SERVICES_H_ */
