#ifndef	_IOCDBLOCKSTORAGEDRIVER_H
#define	_IOCDBLOCKSTORAGEDRIVER_H

#include <IOKit/IOTypes.h>
#include <IOKit/storage/IOCDBlockStorageDevice.h>
#include <IOKit/storage/IOCDTypes.h>
#include <IOKit/storage/IOBlockStorageDriver.h>


class IOCDAudioControl;
class IOCDMedia;
class IOCDBlockStorageDevice;

#include <HYS/IOKit/storage/IOCDBlockStorageDriver.h>
class IOCDBlockStorageDriver : public IOBlockStorageDriver,
public IOCDBlockStorageDriver_HYS
 {

    OSDeclareDefaultStructors(IOCDBlockStorageDriver)

public:
IOCDBlockStorageDriver_getProvider
IOCDBlockStorageDriver_acceptNewMedia
IOCDBlockStorageDriver_ejectMedia
IOCDBlockStorageDriver_audioPause
IOCDBlockStorageDriver_getMediaType
IOCDBlockStorageDriver_audioStop
IOCDBlockStorageDriver_cacheTocInfo
IOCDBlockStorageDriver_audioPlay
IOCDBlockStorageDriver_free
IOCDBlockStorageDriver_reportDiscInfo
IOCDBlockStorageDriver_reportTrackInfo
IOCDBlockStorageDriver_audioScan
IOCDBlockStorageDriver_decommissionMedia
IOCDBlockStorageDriver_writeCD
IOCDBlockStorageDriver_executeRequest
IOCDBlockStorageDriver_readISRC
IOCDBlockStorageDriver_getMediaBlockSize
IOCDBlockStorageDriver_getAudioStatus
IOCDBlockStorageDriver_setSpeed
IOCDBlockStorageDriver_readTrackInfo
IOCDBlockStorageDriver_prepareRequest
IOCDBlockStorageDriver_getDeviceTypeName
IOCDBlockStorageDriver_setAudioVolume
IOCDBlockStorageDriver_recordMediaParameters
IOCDBlockStorageDriver_instantiateDesiredMediaObject
IOCDBlockStorageDriver_readDiscInfo
IOCDBlockStorageDriver_readTOC
IOCDBlockStorageDriver_instantiateMediaObject
IOCDBlockStorageDriver_getAudioVolume
IOCDBlockStorageDriver_readCD
IOCDBlockStorageDriver_init
IOCDBlockStorageDriver_readMCN
IOCDBlockStorageDriver_getTOC
IOCDBlockStorageDriver_getSpeed

protected:
   using	IOBlockStorageDriver::getMediaBlockSize;

};

#endif//_IOCDBLOCKSTORAGEDRIVER_H
