
#ifndef _IOCDPARTITIONSCHEME_H
#define _IOCDPARTITIONSCHEME_H

#include <IOKit/storage/IOCDTypes.h>

/*kIOMediaSessionIDKey


kIOMediaSessionIDKey is property of IOMedia objects. It has an OSNumber value.

#define kIOMediaSessionIDKey "Session ID" 
Discussion 

The kIOMediaSessionIDKey property is placed into each IOMedia instance created by the CD partition scheme. It identifies the session number the track was recorded on.*/
#define kIOMediaSessionIDKey "Session ID" 


//#ifdef KERNEL
#ifdef __cplusplus

#include <IOKit/storage/IOCDMedia.h>
#include <IOKit/storage/IOPartitionScheme.h>

#include <HYS/IOKit/storage/IOCDPartitionScheme.h>

class IOCDPartitionScheme : public IOPartitionScheme,public IOCDPartitionScheme_HYS
{
    OSDeclareDefaultStructors(IOCDPartitionScheme);

protected:
public:
IOCDPartitionScheme_getProvider
IOCDPartitionScheme_scan
IOCDPartitionScheme_init
IOCDPartitionScheme_probe
IOCDPartitionScheme_free
IOCDPartitionScheme_start
IOCDPartitionScheme_instantiateMediaObject
IOCDPartitionScheme_write
IOCDPartitionScheme_read
IOCDPartitionScheme_instantiateDesiredMediaObject
IOCDPartitionScheme_isPartitionInvalid
IOCDPartitionScheme_isPartitionCorrupt

};

#endif /* __cplusplus */
//#endif /* KERNEL */
#endif /* !_IOCDPARTITIONSCHEME_H */
