#ifndef _IOKIT_UFI_STORAGE_SERVICES_H_
#define _IOKIT_UFI_STORAGE_SERVICES_H_

//#if defined(KERNEL) && defined(__cplusplus)

#include <IOKit/IOTypes.h>
#include <IOKit/storage/IOBlockStorageDevice.h>
#include <IOKit/usb/IOUSBMassStorageUFISubclass.h>

#include <HYS/IOKit/usb/IOUFIStorageServices.h>
class IOUFIStorageServices : public IOBlockStorageDevice,public IOUFIStorageServices_HYS
{
	OSDeclareDefaultStructors ( IOUFIStorageServices)
private:
protected:
public:

IOUFIStorageServices_doSynchronizeCache
IOUFIStorageServices_reportWriteProtection
IOUFIStorageServices_reportMaxValidBlock 
IOUFIStorageServices_doLockUnlockMedia
IOUFIStorageServices_reportLockability
IOUFIStorageServices_reportBlockSize 
IOUFIStorageServices_reportEjectability
IOUFIStorageServices_doEjectMedia
IOUFIStorageServices_reportMaxReadTransfer
IOUFIStorageServices_reportMaxWriteTransfer 
IOUFIStorageServices_doAsyncReadWrite
IOUFIStorageServices_getVendorString
IOUFIStorageServices_reportMediaState
IOUFIStorageServices_getProductString
IOUFIStorageServices_reportPollRequirements 
IOUFIStorageServices_doGetFormatCapacities
IOUFIStorageServices_reportRemovability
IOUFIStorageServices_doFormatMedia
IOUFIStorageServices_attach
IOUFIStorageServices_getAdditionalDeviceInfoString
IOUFIStorageServices_detach
IOUFIStorageServices_message
IOUFIStorageServices_AsyncReadWriteComplete
IOUFIStorageServices_doSyncReadWrite
IOUFIStorageServices_getRevisionString

};

//#endif	/* defined(KERNEL) && defined(__cplusplus) */

#endif /* _IOKIT_UFI_STORAGE_SERVICES_H_ */
