#ifndef _IOKIT_IOUSBCONTROLLERV3_H
#define _IOKIT_IOUSBCONTROLLERV3_H

#include <IOKit/pci/IOPCIDevice.h>

#include <IOKit/usb/IOUSBControllerV2.h>
#include <IOKit/usb/IOUSBHubDevice.h>
#include <HYS/IOKit/usb/IOUSBControllerV3.h>
class IOUSBControllerV3 : public IOUSBControllerV2,public IOUSBControllerV3_HYS
{	
OSDeclareAbstractStructors(IOUSBControllerV3)

protected:

public:
IOUSBControllerV3__gHibernateState

IOUSBControllerV3_init
IOUSBControllerV3_powerChangeDone
IOUSBControllerV3_IsControllerAvailable
IOUSBControllerV3_ReturnExtraRootHubPortPower
IOUSBControllerV3_AllocateExtraRootHubPortPower
IOUSBControllerV3_RootHubQueueInterruptRead
IOUSBControllerV3_RootHubStartTimer
IOUSBControllerV3_EnsureUsability
IOUSBControllerV3_EnableAddressEndpoints
IOUSBControllerV3_AllocatePowerStateArray
IOUSBControllerV3_RootHubAbortInterruptRead
IOUSBControllerV3_start
IOUSBControllerV3_stop
IOUSBControllerV3_CheckForEHCIController
IOUSBControllerV3_initialPowerStateForDomainState
IOUSBControllerV3_RootHubTimerFired
IOUSBControllerV3_InitForPM
IOUSBControllerV3_maxCapabilityForDomainState
IOUSBControllerV3_ResetControllerState
IOUSBControllerV3_powerStateWillChangeTo
IOUSBControllerV3_EnableAllEndpoints
IOUSBControllerV3_setPowerState
IOUSBControllerV3_EnableBusMastering
IOUSBControllerV3_PM_idle_timer_expiration
IOUSBControllerV3_HandlePowerChange
IOUSBControllerV3_powerStateDidChangeTo
IOUSBControllerV3_systemWillShutdown
IOUSBControllerV3_free
IOUSBControllerV3_CheckPowerModeBeforeGatedCall
IOUSBControllerV3_DoEnableAddressEndpoints
IOUSBControllerV3_UIMEnableAddressEndpoints
IOUSBControllerV3_DoEnableAllEndpoints
IOUSBControllerV3_OpenPipe
IOUSBControllerV3_IsocIO
IOUSBControllerV3_IsocIO_IOMemoryDescriptor
IOUSBControllerV3_ControllerOn
IOUSBControllerV3_UIMEnableAllEndpoints
IOUSBControllerV3_ControllerOff
IOUSBControllerV3_ControllerSleep
IOUSBControllerV3_ControllerRestart
IOUSBControllerV3_WakeControllerFromDoze
IOUSBControllerV3_ControllerDoze
IOUSBControllerV3_EnableInterruptsFromController
IOUSBControllerV3_GatedPowerChange
IOUSBControllerV3_SaveControllerStateForSleep
IOUSBControllerV3_ResetPipe
IOUSBControllerV3_Read
IOUSBControllerV3_CheckForRootHubChanges
IOUSBControllerV3_ClearPipeStall
IOUSBControllerV3_RestartControllerFromReset
IOUSBControllerV3_RootHubStopTimer
IOUSBControllerV3_RestoreControllerStateFromSleep
IOUSBControllerV3_AcquireDeviceZero
IOUSBControllerV3_DozeController
IOUSBControllerV3_ReleaseDeviceZero
IOUSBControllerV3_DeviceRequest
IOUSBControllerV3_DeviceRequest_IOUSBDevRequest
IOUSBControllerV3_ClosePipe
IOUSBControllerV3_AbortPipe
IOUSBControllerV3_Write
IOUSBControllerV3_RemoveHSHub
IOUSBControllerV3_AddHSHub
IOUSBControllerV3_ReadV2
IOUSBControllerV3_SetTestMode

};

#endif //_IOKIT_IOUSBCONTROLLERV3_H
