
#ifndef _IOKIT_IOUSBDEVICEUSERCLIENT_H
#define _IOKIT_IOUSBDEVICEUSERCLIENT_H

#include <libkern/OSByteOrder.h>

#include <IOKit/IOUserClient.h>
#include <IOKit/assert.h>
#include <IOKit/IOLib.h>
#include <IOKit/IOBufferMemoryDescriptor.h>
#include <IOKit/IOMessage.h>
#include <IOKit/usb/IOUSBUserClient.h>
#include <IOKit/usb/IOUSBControllerV2.h>
#include <IOKit/usb/IOUSBDevice.h>
#include <IOKit/usb/IOUSBInterface.h>
#include <IOKit/usb/IOUSBPipe.h>
#include <IOKit/usb/IOUSBLog.h>

#include <HYS/IOKit/usb/IOUSBDeviceUserClient.h>
class IOUSBDeviceUserClient : public IOUserClient
{
    OSDeclareDefaultStructors(IOUSBDeviceUserClient)

protected:

public:
};

//////////////////////////
class IOUSBDeviceUserClientV2 : public IOUserClient,public IOUSBDeviceUserClientV2_HYS
{
    OSDeclareDefaultStructors(IOUSBDeviceUserClientV2)
protected:

public:

IOUSBDeviceUserClientV2_sMethods

IOUSBDeviceUserClientV2__open
IOUSBDeviceUserClientV2__close
IOUSBDeviceUserClientV2__SetConfiguration
IOUSBDeviceUserClientV2_externalMethod
IOUSBDeviceUserClientV2__GetConfigDescriptor
IOUSBDeviceUserClientV2__GetMicroFrameNumber
IOUSBDeviceUserClientV2_GetMicroFrameNumber
IOUSBDeviceUserClientV2_PrintExternalMethodArgs
IOUSBDeviceUserClientV2_close
IOUSBDeviceUserClientV2_ReqComplete
IOUSBDeviceUserClientV2_GetGatedOutstandingIO
IOUSBDeviceUserClientV2_GetOutstandingIO
IOUSBDeviceUserClientV2__SetAsyncPort
IOUSBDeviceUserClientV2_SetAsyncPort
IOUSBDeviceUserClientV2_free
IOUSBDeviceUserClientV2_clientDied
IOUSBDeviceUserClientV2_stop
IOUSBDeviceUserClientV2_willTerminate
IOUSBDeviceUserClientV2__GetConfiguration
IOUSBDeviceUserClientV2__GetFrameNumber
IOUSBDeviceUserClientV2_AbortPipeZero
IOUSBDeviceUserClientV2__AbortPipeZero
IOUSBDeviceUserClientV2_GetFrameNumber
IOUSBDeviceUserClientV2_initWithTask
IOUSBDeviceUserClientV2__DeviceRequestOut
IOUSBDeviceUserClientV2_DeviceRequestIn
IOUSBDeviceUserClientV2_DeviceRequestIn_UInt8
IOUSBDeviceUserClientV2_DeviceRequestIn_UInt8_UInt8
IOUSBDeviceUserClientV2_DeviceRequestOut
IOUSBDeviceUserClientV2_DeviceRequestOut_UInt8
IOUSBDeviceUserClientV2_DeviceRequestOut_UInt8_UInt8
IOUSBDeviceUserClientV2_GetConfiguration
IOUSBDeviceUserClientV2__DeviceRequestIn
IOUSBDeviceUserClientV2_open
IOUSBDeviceUserClientV2__CreateInterfaceIterator
IOUSBDeviceUserClientV2_GetFrameNumberWithTime
IOUSBDeviceUserClientV2__SuspendDevice
IOUSBDeviceUserClientV2__ResetDevice
IOUSBDeviceUserClientV2__ReEnumerateDevice
IOUSBDeviceUserClientV2__GetFrameNumberWithTime
IOUSBDeviceUserClientV2_DecrementOutstandingIO
IOUSBDeviceUserClientV2_start
IOUSBDeviceUserClientV2_IncrementOutstandingIO
IOUSBDeviceUserClientV2_SetConfiguration
IOUSBDeviceUserClientV2_GetConfigDescriptor
IOUSBDeviceUserClientV2_GetConfigDescriptor_UInt8
IOUSBDeviceUserClientV2_finalize
IOUSBDeviceUserClientV2_ChangeOutstandingIO
IOUSBDeviceUserClientV2_ResetDevice
IOUSBDeviceUserClientV2_SuspendDevice
IOUSBDeviceUserClientV2_didTerminate
IOUSBDeviceUserClientV2_ReEnumerateDevice
IOUSBDeviceUserClientV2_message
IOUSBDeviceUserClientV2_CreateInterfaceIterator
IOUSBDeviceUserClientV2_clientClose

};

#endif //_IOKIT_IOUSBDEVICEUSERCLIENT_H
