#ifndef _IOKIT_IOUSBMASSSTORAGEUFISUBCLASS_H
#define _IOKIT_IOUSBMASSSTORAGEUFISUBCLASS_H


#include <IOKit/usb/IOUSBMassStorageClass.h>
#include <IOKit/scsi/IOSCSIPrimaryCommandsDevice.h>

#include <HYS/IOKit/usb/IOUSBMassStorageUFISubclass.h>

class IOUSBMassStorageUFIDevice : public IOSCSIPrimaryCommandsDevice,public IOUSBMassStorageUFIDevice_HYS
{
    OSDeclareDefaultStructors(IOUSBMassStorageUFIDevice)

private:
protected:
public:

IOUSBMassStorageUFIDevice_GetProtocolCharacteristicsDictionary
IOUSBMassStorageUFIDevice_GetDeviceCharacteristicsDictionary
IOUSBMassStorageUFIDevice_ReportDeviceMaxBlocksReadTransfer
IOUSBMassStorageUFIDevice_ReportDeviceMaxBlocksWriteTransfer
IOUSBMassStorageUFIDevice_AsyncReadWriteComplete
IOUSBMassStorageUFIDevice_AsyncReadWrite
IOUSBMassStorageUFIDevice_ReportMediumBlockSize
IOUSBMassStorageUFIDevice_SyncReadWrite
IOUSBMassStorageUFIDevice_EjectTheMedium
IOUSBMassStorageUFIDevice_FormatMedium
IOUSBMassStorageUFIDevice_GetFormatCapacities
IOUSBMassStorageUFIDevice_GetVendorString
IOUSBMassStorageUFIDevice_GetProductString
IOUSBMassStorageUFIDevice_GetRevisionString
IOUSBMassStorageUFIDevice_ReportMediumTotalBlockCount
IOUSBMassStorageUFIDevice_ReportMediumWriteProtection
IOUSBMassStorageUFIDevice_sProcessPoll
IOUSBMassStorageUFIDevice_ProcessPoll
IOUSBMassStorageUFIDevice_StartDeviceSupport 
IOUSBMassStorageUFIDevice_EnablePolling
IOUSBMassStorageUFIDevice_InitializeDeviceSupport
IOUSBMassStorageUFIDevice_ClearNotReadyStatus
IOUSBMassStorageUFIDevice_DetermineDeviceCharacteristics
IOUSBMassStorageUFIDevice_CreateStorageServiceNub
IOUSBMassStorageUFIDevice_SuspendDeviceSupport
IOUSBMassStorageUFIDevice_DisablePolling
IOUSBMassStorageUFIDevice_ResumeDeviceSupport
IOUSBMassStorageUFIDevice_StopDeviceSupport
IOUSBMassStorageUFIDevice_TerminateDeviceSupport
IOUSBMassStorageUFIDevice_TEST_UNIT_READY
IOUSBMassStorageUFIDevice_REQUEST_SENSE
IOUSBMassStorageUFIDevice_START_STOP_UNIT
IOUSBMassStorageUFIDevice_INQUIRY
IOUSBMassStorageUFIDevice_SetMediumCharacteristics
IOUSBMassStorageUFIDevice_ResetMediumCharacteristics
IOUSBMassStorageUFIDevice_PollForNewMedia
IOUSBMassStorageUFIDevice_PollForMediaRemoval
IOUSBMassStorageUFIDevice_WRITE_12
IOUSBMassStorageUFIDevice_DetermineMediumCapacity
IOUSBMassStorageUFIDevice_DetermineMediaPresence
IOUSBMassStorageUFIDevice_DetermineMediumWriteProtectState
IOUSBMassStorageUFIDevice_READ_FORMAT_CAPACITIES
IOUSBMassStorageUFIDevice_READ_CAPACITY
IOUSBMassStorageUFIDevice_MODE_SENSE_10
IOUSBMassStorageUFIDevice_GetInitialPowerState
IOUSBMassStorageUFIDevice_HandlePowerChange
IOUSBMassStorageUFIDevice_HandleCheckPowerState
IOUSBMassStorageUFIDevice_TicklePowerManager 
IOUSBMassStorageUFIDevice_GetNumberOfPowerStateTransitions 
IOUSBMassStorageUFIDevice_IssueRead
IOUSBMassStorageUFIDevice_IssueRead_IOMemoryDescriptor
IOUSBMassStorageUFIDevice_READ_10
IOUSBMassStorageUFIDevice_IssueWrite
IOUSBMassStorageUFIDevice_IssueWrite_IOMemoryDescriptor
IOUSBMassStorageUFIDevice_WRITE_10
IOUSBMassStorageUFIDevice_IsParameterValid
IOUSBMassStorageUFIDevice_IsParameterValid_SCSICmdField2Byte
IOUSBMassStorageUFIDevice_IsParameterValid_SCSICmdField1Byte
IOUSBMassStorageUFIDevice_FORMAT_UNIT
IOUSBMassStorageUFIDevice_MODE_SELECT_10
IOUSBMassStorageUFIDevice_PREVENT_ALLOW_MEDIUM_REMOVAL
IOUSBMassStorageUFIDevice_VERIFY
IOUSBMassStorageUFIDevice_READ_12
IOUSBMassStorageUFIDevice_REZERO_UNIT
IOUSBMassStorageUFIDevice_SEEK
IOUSBMassStorageUFIDevice_SEND_DIAGNOSTICS
IOUSBMassStorageUFIDevice_WRITE_AND_VERIFY

};//IOUSBMassStorageUFIDevice

class IOUSBMassStorageUFISubclass : public IOUSBMassStorageClass,public IOUSBMassStorageUFISubclass_HYS
{
    OSDeclareDefaultStructors(IOUSBMassStorageUFISubclass)

protected:

IOUSBMassStorageUFISubclass_EndProvidedServices
IOUSBMassStorageUFISubclass_BeginProvidedServices

};

#endif //_IOKIT_IOUSBMASSSTORAGEUFISUBCLASS_H
