#ifndef _MSCTOKENCONNECTION_H_
#define _MSCTOKENCONNECTION_H_

#include <PCSC/musclecard.h>
#include <security_utilities/utilities.h>
//#include <sstream>
#include <map>
#include <set>
#include <Msc/MscWrappers.h>

#include <HYS/Msc/MscTokenConnection.h>

class MscTokenConnection : public Security::PodWrapper<MscTokenConnection, MSCTokenConnection>,public MscTokenConnection_HYS {
public:

MscTokenConnection_MscTokenConnection
MscTokenConnection_MscTokenConnection_const_MSCTokenInfo
MscTokenConnection_MscTokenConnection_const_MSCTokenConnection

MscTokenConnection_operator

MscTokenConnection_getCapabilities
MscTokenConnection_connect
MscTokenConnection_release
MscTokenConnection_verifyPIN
MscTokenConnection_listPins
MscTokenConnection_getObjectAttributes
MscTokenConnection_beginTransaction
MscTokenConnection_endTransaction
MscTokenConnection_logoutAll
MscTokenConnection_selectAID_std_string
MscTokenConnection_selectAID_const_char
MscTokenConnection_writeFramework
MscTokenConnection_getKeyAttributes
MscTokenConnection_getStatus
MscTokenConnection_changed
MscTokenConnection_getChallenge
MscTokenConnection_tokenWasReset
MscTokenConnection_known
MscTokenConnection_extendedFeature
MscTokenConnection_moved
MscTokenConnection_clearReset
MscTokenConnection_generateKeys

protected:
MscTokenConnection_mLocalTokenInfo

};

#endif /* !_MSCTOKENCONNECTION_H_ */

