#ifndef ASREGISTRY_H
#define ASREGISTRY_H

#include <ApplicationServices/ApplicationServices.h>
#include <AvailabilityMacros.h>



/*keyASPrepositionAt

enum {
   keyASPrepositionAt = 'at  ',
   keyASPrepositionIn = 'in  ',
   keyASPrepositionFrom = 'from',
   keyASPrepositionFor = 'for ',
   keyASPrepositionTo = 'to  ',
   keyASPrepositionThru = 'thru',
   keyASPrepositionThrough = 'thgh',
   keyASPrepositionBy = 'by  ',
   keyASPrepositionOn = 'on  ',
   keyASPrepositionInto = 'into',
   keyASPrepositionOnto = 'onto',
   keyASPrepositionBetween = 'btwn',
   keyASPrepositionAgainst = 'agst',
   keyASPrepositionOutOf = 'outo',
   keyASPrepositionInsteadOf = 'isto',
   keyASPrepositionAsideFrom = 'asdf',
   keyASPrepositionAround = 'arnd',
   keyASPrepositionBeside = 'bsid',
   keyASPrepositionBeneath = 'bnth',
   keyASPrepositionUnder = 'undr'
};*/
enum {
   keyASPrepositionAt = 'at  ',
   keyASPrepositionIn = 'in  ',
   keyASPrepositionFrom = 'from',
   keyASPrepositionFor = 'for ',
   keyASPrepositionTo = 'to  ',
   keyASPrepositionThru = 'thru',
   keyASPrepositionThrough = 'thgh',
   keyASPrepositionBy = 'by  ',
   keyASPrepositionOn = 'on  ',
   keyASPrepositionInto = 'into',
   keyASPrepositionOnto = 'onto',
   keyASPrepositionBetween = 'btwn',
   keyASPrepositionAgainst = 'agst',
   keyASPrepositionOutOf = 'outo',
   keyASPrepositionInsteadOf = 'isto',
   keyASPrepositionAsideFrom = 'asdf',
   keyASPrepositionAround = 'arnd',
   keyASPrepositionBeside = 'bsid',
   keyASPrepositionBeneath = 'bnth',
   keyASPrepositionUnder = 'undr'
};
//warning: multi-character character constant


/*keyAETarget

enum {
   keyAETarget = 'targ',
   keySubjectAttr = 'subj',
   keyASReturning = 'Krtn',
   kASAppleScriptSuite = 'ascr',
   kASScriptEditorSuite = 'ToyS',
   kASTypeNamesSuite = 'tpnm',
   typeAETE = 'aete',
   typeAEUT = 'aeut',
   kGetAETE = 'gdte',
   kGetAEUT = 'gdut',
   kUpdateAEUT = 'udut',
   kUpdateAETE = 'udte',
   kCleanUpAEUT = 'cdut',
   kASComment = 'cmnt',
   kASLaunchEvent = 'noop',
   keyScszResource = 'scsz',
   typeScszResource = 'scsz',
   kASSubroutineEvent = 'psbr',
   keyASSubroutineName = 'snam',
   kASPrepositionalSubroutine = 'psbr',
   keyASPositionalArgs = 'parg'
};*/
enum {
   keyAETarget = 'targ',
   keySubjectAttr = 'subj',
   keyASReturning = 'Krtn',
   kASAppleScriptSuite = 'ascr',
   kASScriptEditorSuite = 'ToyS',
   kASTypeNamesSuite = 'tpnm',
   typeAETE = 'aete',
   typeAEUT = 'aeut',
   kGetAETE = 'gdte',
   kGetAEUT = 'gdut',
   kUpdateAEUT = 'udut',
   kUpdateAETE = 'udte',
   kCleanUpAEUT = 'cdut',
   kASComment = 'cmnt',
   kASLaunchEvent = 'noop',
   keyScszResource = 'scsz',
   typeScszResource = 'scsz',
   kASSubroutineEvent = 'psbr',
   keyASSubroutineName = 'snam',
   kASPrepositionalSubroutine = 'psbr',
   keyASPositionalArgs = 'parg'
};
//warning: multi-character character constant

   
/*kDialectBundleResType

enum {
   kDialectBundleResType = 'Dbdl',
   cConstant = typeEnumerated,
   cClassIdentifier = pClass,
   cObjectBeingExamined = typeObjectBeingExamined,
   cList = typeAEList,
   cSmallReal = typeSMFloat,
   cReal = typeFloat,
   cRecord = typeAERecord,
   cReference = cObjectSpecifier,
   cUndefined = 'undf',
   cMissingValue = 'msng',
   cSymbol = 'symb',
   cLinkedList = 'llst',
   cVector = 'vect',
   cEventIdentifier = 'evnt',
   cKeyIdentifier = 'kyid',
   cUserIdentifier = 'uid ',
   cPreposition = 'prep',
   cKeyForm = enumKeyForm,
   cScript = 'scpt',
   cHandler = 'hand',
   cProcedure = 'proc'
};*/
enum {
   kDialectBundleResType = 'Dbdl',
   cConstant = typeEnumerated,
   cClassIdentifier = pClass,
   cObjectBeingExamined = typeObjectBeingExamined,
   cList = typeAEList,
   cSmallReal = typeSMFloat,
   cReal = typeFloat,
   cRecord = typeAERecord,
   cReference = cObjectSpecifier,
   cUndefined = 'undf',
   cMissingValue = 'msng',
   cSymbol = 'symb',
   cLinkedList = 'llst',
   cVector = 'vect',
   cEventIdentifier = 'evnt',
   cKeyIdentifier = 'kyid',
   cUserIdentifier = 'uid ',
   cPreposition = 'prep',
   cKeyForm = enumKeyForm,
   cScript = 'scpt',
   cHandler = 'hand',
   cProcedure = 'proc'
};
//warning: multi-character character constant

   
#endif
