#ifndef CVHOSTTIME_H
#define CVHOSTTIME_H

#include <TargetConditionals.h>

#include <QuartzCore/CVBase.h>

#if defined(__cplusplus)
extern "C" {
#endif

//func

/*CVGetHostClockFrequency

Retrieve the frequency of the host time base.

double CVGetHostClockFrequency
Return Value

The current host frequency.
Discussion

In Mac OS X, the host time base for CoreVideo and CoreAudio are identical, and the values returned from either API can be used interchangeably.
Availability
Available in Mac OS X v10.3 and later.
Declared In
CVHostTime.h*/
double CVGetHostClockFrequency(void);

#ifdef __cplusplus
}
#endif
#endif
