#ifndef OC__SEGLOAD__
#define OC__SEGLOAD__

#include <MacTypes.h>

#ifdef __cplusplus
extern "C" {
#endif

/*Application Files Record

struct AppFile {
      short          vRefNum;    //working directory reference number
      OSType         fType;      //file type
      short          versNum;    //version number; ignored
      Str255         fName;      //filename
   END;

typedef struct AppFile AppFile;
*/
struct AppFile {
      short          vRefNum;    /*working directory reference number*/
      OSType         fType;      /*file type*/
      short          versNum;    /*version number; ignored*/
      Str255         fName;      /*filename*/
};

typedef struct AppFile AppFile;

/*Application Launch File Routines

pascal void GetAppParms		(Str255 apName, short *apRefNum, 
				Handle *apParam);
pascal void CountAppFiles	(short *message, short *count);
pascal void GetAppFiles		(short index, AppFile *theFile);
pascal void ClrAppFiles		(short index);*/
pascal void CountAppFiles	(short *message, short *count);
pascal void GetAppFiles		(short index, AppFile *theFile);
pascal void ClrAppFiles		(short index);

#ifdef __cplusplus
}
#endif

#endif //OC__SEGLOAD__
