#ifndef  SCSCHEMADEFINITIONS_H
#define SCSCHEMADEFINITIONS_H

#include <AvailabilityMacros.h>
#include <HYS/SystemConfiguration/SCSchemaDefinitions.h>
/*kSCPropNetProxiesFTPPassive


"FTPPassive" 
extern const CFStringRef kSCPropNetProxiesFTPPassive;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesFTPPassive;

/*kSCPropNetProxiesHTTPProxy

"HTTPProxy" 
extern const CFStringRef kSCPropNetProxiesHTTPProxy;
Availability
Introduced in Mac OS X 10.1*/
extern const CFStringRef kSCPropNetProxiesHTTPProxy;  

/*kSCPropNetProxiesHTTPSProxy


"HTTPSProxy" 
extern const CFStringRef kSCPropNetProxiesHTTPSProxy;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesHTTPSProxy;  

/*kSCPropNetProxiesHTTPPort


"HTTPPort" 
extern const CFStringRef kSCPropNetProxiesHTTPPort;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesHTTPPort;  

/*kSCPropNetProxiesHTTPSPort


"HTTPSPort" 
extern const CFStringRef kSCPropNetProxiesHTTPSPort;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesHTTPSPort;  

/*kSCPrefSets


"Sets" 
extern const CFStringRef kSCPrefSets;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPrefSets;  

/*kSCEntNetInterface


"Interface" 
extern const CFStringRef kSCEntNetInterface;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetInterface;  

/*kSCPropNetInterfaceSubType


"SubType" 
extern const CFStringRef kSCPropNetInterfaceSubType;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetInterfaceSubType;  

/*kSCValNetInterfaceSubTypePPPoE


"PPPoE" 
extern const CFStringRef kSCValNetInterfaceSubTypePPPoE;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetInterfaceSubTypePPPoE;  

/*kSCPropNetServiceOrder


"ServiceOrder" 
extern const CFStringRef kSCPropNetServiceOrder;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetServiceOrder;  

/*kSCPropUserDefinedName


"UserDefinedName" 
extern const CFStringRef kSCPropUserDefinedName;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropUserDefinedName;  


/*kSCPrefCurrentSet


"CurrentSet" 
extern const CFStringRef kSCPrefCurrentSet;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPrefCurrentSet;  

/*kSCEntNetIPv4


"IPv4" 
extern const CFStringRef kSCEntNetIPv4;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetIPv4;  

/*kSCEntNetNetInfo


"NetInfo" 
extern const CFStringRef kSCEntNetNetInfo;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetNetInfo;  

/*kSCResvLink


"__LINK__" (Reserved) 
extern const CFStringRef kSCResvLink;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCResvLink;  

/*kSCPrefNetworkServices


"NetworkServices" 
extern const CFStringRef kSCPrefNetworkServices;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPrefNetworkServices;  

/*kSCCompNetwork


"Network" 
extern const CFStringRef kSCCompNetwork;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCCompNetwork;  

/*kSCCompService


"Service" 
extern const CFStringRef kSCCompService;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCCompService;  

/*kSCCompGlobal


"Global" 
extern const CFStringRef kSCCompGlobal;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCCompGlobal;  

/*kSCEntNetPPP


"PPP" 
extern const CFStringRef kSCEntNetPPP;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetPPP;  

/*kSCResvInactive


"__INACTIVE__" (Reserved) 
extern const CFStringRef kSCResvInactive;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCResvInactive;  

/*kSCPropNetInterfaceDeviceName


"DeviceName" 
extern const CFStringRef kSCPropNetInterfaceDeviceName;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetInterfaceDeviceName;  

/*kSCPropNetInterfaceHardware


"Hardware" 
extern const CFStringRef kSCPropNetInterfaceHardware;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetInterfaceHardware;  

/*kSCPropNetInterfaceType


"Type" 
extern const CFStringRef kSCPropNetInterfaceType;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetInterfaceType;  

/*kSCValNetInterfaceSubTypePPPSerial


"PPPSerial" 
extern const CFStringRef kSCValNetInterfaceSubTypePPPSerial;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetInterfaceSubTypePPPSerial;  

/*kSCValNetIPv4ConfigMethodDHCP


"DHCP" 
extern const CFStringRef kSCValNetIPv4ConfigMethodDHCP;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetIPv4ConfigMethodDHCP;  

/*kSCPropMACAddress


"MACAddress" 
extern const CFStringRef kSCPropMACAddress;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropMACAddress;  

/*kSCEntNetEthernet


"Ethernet" 
extern const CFStringRef kSCEntNetEthernet;  
Availability
Introduced in Mac OS X 10.*/
extern const CFStringRef kSCEntNetEthernet;  

/*kSCEntNetModem


"Modem" 
extern const CFStringRef kSCEntNetModem;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetModem;  

/*kSCValNetInterfaceTypeEthernet


"Ethernet" 
extern const CFStringRef kSCValNetInterfaceTypeEthernet;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetInterfaceTypeEthernet;  

/*kSCEntNetProxies


"Proxies" 
extern const CFStringRef kSCEntNetProxies;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetProxies;  

/*kSCValNetIPv4ConfigMethodPPP


"PPP" 
extern const CFStringRef kSCValNetIPv4ConfigMethodPPP;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetIPv4ConfigMethodPPP;  

/*kSCEntNetAirPort


"AirPort" 
extern const CFStringRef kSCEntNetAirPort;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetAirPort;  

/*kSCValNetInterfaceTypePPP


"PPP" 
extern const CFStringRef kSCValNetInterfaceTypePPP;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetInterfaceTypePPP;  

/*kSCValNetAppleTalkConfigMethodNode


"Node" 
extern const CFStringRef kSCValNetAppleTalkConfigMethodNode;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetAppleTalkConfigMethodNode;  

/*kSCEntNetAppleTalk


"AppleTalk" 
extern const CFStringRef kSCEntNetAppleTalk;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetAppleTalk;  

/*kSCEntNetDNS


"DNS" 
extern const CFStringRef kSCEntNetDNS;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetDNS;  

/*kSCValNetIPv4ConfigMethodManual


"Manual" 
extern const CFStringRef kSCValNetIPv4ConfigMethodManual;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetIPv4ConfigMethodManual;  

/*kSCPropNetPPPOverridePrimary


"PPPOverridePrimary" 
extern const CFStringRef kSCPropNetPPPOverridePrimary;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPOverridePrimary;  

/*kSCPropNetProxiesExceptionsList


"ExceptionsList" 
extern const CFStringRef kSCPropNetProxiesExceptionsList;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesExceptionsList;  

/*kSCPropNetProxiesGopherEnable


"GopherEnable" 
extern const CFStringRef kSCPropNetProxiesGopherEnable;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesGopherEnable;  

/*kSCPropNetAppleTalkNodeID


"NodeID" 
extern const CFStringRef kSCPropNetAppleTalkNodeID;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetAppleTalkNodeID;  

/*kSCPropNetDNSServerAddresses


"ServerAddresses" 
extern const CFStringRef kSCPropNetDNSServerAddresses;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetDNSServerAddresses;  

/*kSCPropNetPPPDisconnectOnIdle


"DisconnectOnIdle" 
extern const CFStringRef kSCPropNetPPPDisconnectOnIdle;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPDisconnectOnIdle;  

/*kSCPropNetPPPIPCPCompressionVJ


"IPCPCompressionVJ" 
extern const CFStringRef kSCPropNetPPPIPCPCompressionVJ;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPIPCPCompressionVJ;  

/*kSCPropNetPPPLCPEchoEnabled


"LCPEchoEnabled" 
extern const CFStringRef kSCPropNetPPPLCPEchoEnabled;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPLCPEchoEnabled;  

/*kSCPropNetAirPortPreferredNetwork


"PreferredNetwork" 
extern const CFStringRef kSCPropNetAirPortPreferredNetwork;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetAirPortPreferredNetwork;  

/*kSCPropNetModemConnectionScript


"ConnectionScript" 
extern const CFStringRef kSCPropNetModemConnectionScript;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetModemConnectionScript;  

/*kSCPropNetModemPulseDial


"PulseDial" 
extern const CFStringRef kSCPropNetModemPulseDial;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetModemPulseDial;  

/*kSCPropNetModemSpeaker


"Speaker" 
extern const CFStringRef kSCPropNetModemSpeaker;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetModemSpeaker;  

/*kSCPropNetModemDataCompression


"DataCompression" 
extern const CFStringRef kSCPropNetModemDataCompression;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetModemDataCompression;  

/*kSCPropNetProxiesSOCKSEnable


"SOCKSEnable" 
extern const CFStringRef kSCPropNetProxiesSOCKSEnable;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesSOCKSEnable;  

/*kSCPropNetProxiesSOCKSProxy


"SOCKSProxy" 
extern const CFStringRef kSCPropNetProxiesSOCKSProxy;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesSOCKSProxy;  

/*kSCPropNetAppleTalkConfigMethod


"ConfigMethod" 
extern const CFStringRef kSCPropNetAppleTalkConfigMethod;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetAppleTalkConfigMethod;  

/*kSCValNetIPv4ConfigMethodBOOTP


"BOOTP" 
extern const CFStringRef kSCValNetIPv4ConfigMethodBOOTP;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetIPv4ConfigMethodBOOTP;  

/*kSCValNetIPv4ConfigMethodINFORM


"INFORM" 
extern const CFStringRef kSCValNetIPv4ConfigMethodINFORM;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetIPv4ConfigMethodINFORM;  

/*kSCPropNetIPv4ConfigMethod


"ConfigMethod" 
extern const CFStringRef kSCPropNetIPv4ConfigMethod;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetIPv4ConfigMethod;  

/*kSCPropNetIPv4DHCPClientID


"DHCPClientID" 
extern const CFStringRef kSCPropNetIPv4DHCPClientID;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetIPv4DHCPClientID;  

/*kSCPropNetIPv4Addresses


"Addresses" 
extern const CFStringRef kSCPropNetIPv4Addresses;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetIPv4Addresses;  

/*kSCPropNetIPv4SubnetMasks


"SubnetMasks" 
extern const CFStringRef kSCPropNetIPv4SubnetMasks;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetIPv4SubnetMasks;  

/*kSCPropNetIPv4Router


"Router" 
extern const CFStringRef kSCPropNetIPv4Router;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetIPv4Router;  

/*kSCPropNetPPPCommRedialInterval


"CommRedialInterval" 
extern const CFStringRef kSCPropNetPPPCommRedialInterval;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPCommRedialInterval;  

/*kSCPropNetPPPLCPEchoInterval


"LCPEchoInterval" 
extern const CFStringRef kSCPropNetPPPLCPEchoInterval;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPLCPEchoInterval;  

/*kSCPropNetModemDialMode


"DialMode" 
extern const CFStringRef kSCPropNetModemDialMode;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetModemDialMode;  

/*kSCValNetModemDialModeIgnoreDialTone


"IgnoreDialTone" 
extern const CFStringRef kSCValNetModemDialModeIgnoreDialTone;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetModemDialModeIgnoreDialTone;  

/*kSCPropNetProxiesFTPEnable


"FTPEnable" 
extern const CFStringRef kSCPropNetProxiesFTPEnable;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesFTPEnable;  

/*kSCPropNetProxiesFTPProxy


"FTPProxy" 
extern const CFStringRef kSCPropNetProxiesFTPProxy;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesFTPProxy;  

/*kSCPropNetDNSSearchDomains


"SearchDomains" 
extern const CFStringRef kSCPropNetDNSSearchDomains;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetDNSSearchDomains;  

/*kSCPropNetPPPVerboseLogging


"VerboseLogging" 
extern const CFStringRef kSCPropNetPPPVerboseLogging;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPVerboseLogging;  

/*kSCPropNetPPPCommAlternateRemoteAddress


"CommAlternateRemoteAddress" 
extern const CFStringRef kSCPropNetPPPCommAlternateRemoteAddress;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPCommAlternateRemoteAddress;  

/*kSCPropNetPPPLCPEchoFailure


"LCPEchoFailure" 
extern const CFStringRef kSCPropNetPPPLCPEchoFailure;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPLCPEchoFailure;  

/*kSCValNetModemDialModeWaitForDialTone


"WaitForDialTone" 
extern const CFStringRef kSCValNetModemDialModeWaitForDialTone;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetModemDialModeWaitForDialTone;  

/*kSCPropNetModemErrorCorrection


"ErrorCorrection" 
extern const CFStringRef kSCPropNetModemErrorCorrection;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetModemErrorCorrection;  

/*kSCPropNetProxiesFTPPort


"FTPPort" 
extern const CFStringRef kSCPropNetProxiesFTPPort;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesFTPPort;  

/*kSCPropNetProxiesSOCKSPort


"SOCKSPort" 
extern const CFStringRef kSCPropNetProxiesSOCKSPort;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesSOCKSPort;  

/*kSCPropNetProxiesGopherProxy


"GopherProxy" 
extern const CFStringRef kSCPropNetProxiesGopherProxy;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesGopherProxy;  

/*kSCPropNetAppleTalkDefaultZone


"DefaultZone" 
extern const CFStringRef kSCPropNetAppleTalkDefaultZone;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetAppleTalkDefaultZone;  

/*kSCPropNetProxiesRTSPPort


"RTSPPort" 
extern const CFStringRef kSCPropNetProxiesRTSPPort;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesRTSPPort;  

/*kSCPropNetAppleTalkNetworkID


"NetworkID" 
extern const CFStringRef kSCPropNetAppleTalkNetworkID;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetAppleTalkNetworkID;  

/*kSCPropNetProxiesRTSPProxy


"RTSPProxy" 
extern const CFStringRef kSCPropNetProxiesRTSPProxy;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesRTSPProxy;  

/*kSCPropNetProxiesRTSPEnable


"RTSPEnable" 
extern const CFStringRef kSCPropNetProxiesRTSPEnable;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesRTSPEnable;  

/*kSCPropNetProxiesGopherPort


"GopherPort" 
extern const CFStringRef kSCPropNetProxiesGopherPort;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesGopherPort;  

/*kSCPropNetProxiesHTTPEnable


"HTTPEnable" 
extern const CFStringRef kSCPropNetProxiesHTTPEnable;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesHTTPEnable;  

/*kSCPropNetProxiesHTTPSEnable


"HTTPSEnable" 
extern const CFStringRef kSCPropNetProxiesHTTPSEnable;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetProxiesHTTPSEnable;  

/*kSCPropNetPPPDialOnDemand


"DialOnDemand" 
extern const CFStringRef kSCPropNetPPPDialOnDemand;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPDialOnDemand;  

/*kSCPropNetPPPCommRedialEnabled


"CommRedialEnabled" 
extern const CFStringRef kSCPropNetPPPCommRedialEnabled;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPCommRedialEnabled;  

/*kSCPropNetPPPCommRemoteAddress


"CommRemoteAddress" 
extern const CFStringRef kSCPropNetPPPCommRemoteAddress;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPCommRemoteAddress;  

/*kSCPropNetPPPDisconnectOnIdleTimer


"DisconnectOnIdleTimer" 
extern const CFStringRef kSCPropNetPPPDisconnectOnIdleTimer;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPDisconnectOnIdleTimer;  

/*kSCPropNetPPPLogfile


"Logfile" 
extern const CFStringRef kSCPropNetPPPLogfile;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPLogfile;  

/*kSCPropNetPPPCommRedialCount


"CommRedialCount" 
extern const CFStringRef kSCPropNetPPPCommRedialCount;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPCommRedialCount; 

/*kSCPropNetPPPDisconnectOnLogout


"DisconnectOnLogout" 
extern const CFStringRef kSCPropNetPPPDisconnectOnLogout;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPDisconnectOnLogout;  

/*kSCPropNetPPPIdleReminder


"IdleReminder" 
extern const CFStringRef kSCPropNetPPPIdleReminder;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPIdleReminder;  

/*kSCPropNetPPPCommDisplayTerminalWindow


"CommDisplayTerminalWindow" 
extern const CFStringRef kSCPropNetPPPCommDisplayTerminalWindow;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPCommDisplayTerminalWindow; 

/*kSCPropNetPPPAuthPassword


"AuthPassword" 
extern const CFStringRef kSCPropNetPPPAuthPassword;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPAuthPassword;  

/*kSCPropNetPPPAuthName


"AuthName" 
extern const CFStringRef kSCPropNetPPPAuthName;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPAuthName;  

/*kSCPropNetPPPIdleReminderTimer


"IdleReminderTimer" 
extern const CFStringRef kSCPropNetPPPIdleReminderTimer;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPIdleReminderTimer;  

/*kSCDynamicStoreDomainSetup


"Setup:" 
extern const CFStringRef kSCDynamicStoreDomainSetup;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCDynamicStoreDomainSetup;  

/*kSCCompAnyRegex


"[^/]+" 
extern const CFStringRef kSCCompAnyRegex;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCCompAnyRegex;  

/*kSCPropNetPPPStatus


"Status" 
extern const CFStringRef kSCPropNetPPPStatus;  
Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetPPPStatus;  

/*kSCEntNetFireWire


FireWire" 
extern const CFStringRef kSCEntNetFireWire;  
Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCEntNetFireWire;  

/*kSCValNetInterfaceTypeFireWire


"FireWire" 
extern const CFStringRef kSCValNetInterfaceTypeFireWire;  
Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetInterfaceTypeFireWire;  

/*kSCPropNetInterfaceSupportsModemOnHold


"SupportsModemOnHold" 
extern const CFStringRef kSCPropNetInterfaceSupportsModemOnHold;  
Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetInterfaceSupportsModemOnHold;  

/*kSCEntNetIPv6


"IPv6" 
extern const CFStringRef kSCEntNetIPv6;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetIPv6;  

/*kSCPropNetIPv6ConfigMethod


"ConfigMethod" 
extern const CFStringRef kSCPropNetIPv6ConfigMethod;  
Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetIPv6ConfigMethod;  

/*kSCValNetIPv6ConfigMethodAutomatic


"Automatic" 
extern const CFStringRef kSCValNetIPv6ConfigMethodAutomatic;  
Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetIPv6ConfigMethodAutomatic;  

/*kSCPropNetProxiesProxyAutoDiscoveryEnable


"ProxyAutoDiscoveryEnable" 
extern const CFStringRef kSCPropNetProxiesProxyAutoDiscoveryEnable;  
Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetProxiesProxyAutoDiscoveryEnable; 

/*kSCPropNetModemHoldReminderTime


"HoldReminderTime" 
extern const CFStringRef kSCPropNetModemHoldReminderTime;  
Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetModemHoldReminderTime;  

/*kSCPropNetModemHoldReminder


"HoldReminder" 
extern const CFStringRef kSCPropNetModemHoldReminder;  
Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetModemHoldReminder;  

/*kSCPropNetModemHoldDisconnectOnAnswer


"HoldDisconnectOnAnswer" 
extern const CFStringRef kSCPropNetModemHoldDisconnectOnAnswer;  
Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetModemHoldDisconnectOnAnswer;  

/*kSCPropNetModemHoldEnabled


"HoldEnabled" 
extern const CFStringRef kSCPropNetModemHoldEnabled;  
Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetModemHoldEnabled;  

/*kSCPropNetPPPDisconnectOnFastUserSwitch


"DisconnectOnFastUserSwitch" 
extern const CFStringRef kSCPropNetPPPDisconnectOnFastUserSwitch;  
Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetPPPDisconnectOnFastUserSwitch;  

/*kSCPropNetProxiesExcludeSimpleHostnames


"ExcludeSimpleHostnames" 
extern const CFStringRef kSCPropNetProxiesExcludeSimpleHostnames;  
Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetProxiesExcludeSimpleHostnames;  

/*kSCPropNetPPPACSPEnabled


"ACSPEnabled" 
extern const CFStringRef kSCPropNetPPPACSPEnabled;  
Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNetPPPACSPEnabled;  

/*kSCPropNetPPPDisconnectOnSleep


"DisconnectOnSleep" 
extern const CFStringRef kSCPropNetPPPDisconnectOnSleep;  
Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetPPPDisconnectOnSleep;  

/*kSCPropNetModemHoldCallWaitingAudibleAlert


"HoldCallWaitingAudibleAlert" 
extern const CFStringRef kSCPropNetModemHoldCallWaitingAudibleAlert;  
Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetModemHoldCallWaitingAudibleAlert;  

/*kSCDynamicStoreDomainState


"State:" 

extern const CFStringRef kSCDynamicStoreDomainState;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCDynamicStoreDomainState;  

/*kSCDynamicStorePropNetPrimaryService


"PrimaryService" 

extern const CFStringRef kSCDynamicStorePropNetPrimaryService;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCDynamicStorePropNetPrimaryService;  

/*kSCEntNetDHCP


extern const CFStringRef kSCEntNetDHCP;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetDHCP;  

/*kSCEntNet6to4


extern const CFStringRef kSCEntNet6to4;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCEntNet6to4;  

/*kSCValNetInterfaceSubTypeL2TP


"L2TP" 

extern const CFStringRef kSCValNetInterfaceSubTypeL2TP;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetInterfaceSubTypeL2TP;  

/*kSCValNetInterfaceSubTypePPTP


"PPTP" 

extern const CFStringRef kSCValNetInterfaceSubTypePPTP;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCValNetInterfaceSubTypePPTP;  

/*kSCPropNetPPPAuthPasswordEncryption


extern const CFStringRef kSCPropNetPPPAuthPasswordEncryption;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPAuthPasswordEncryption;  

/*kSCPropNetIPSecSharedSecret


extern const CFStringRef kSCPropNetIPSecSharedSecret;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCPropNetIPSecSharedSecret;  

/*kSCValNetIPSecSharedSecretEncryptionKeychain


extern const CFStringRef kSCValNetIPSecSharedSecretEncryptionKeychain;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCValNetIPSecSharedSecretEncryptionKeychain;  

/*kSCPropNetIPSecSharedSecretEncryption


extern const CFStringRef kSCPropNetIPSecSharedSecretEncryption;  

Availability
Introduced in Mac OS X 10.5.*/

extern const CFStringRef kSCPropNetIPSecSharedSecretEncryption;  

/*kSCValNetIPSecAuthenticationMethodSharedSecret


extern const CFStringRef kSCValNetIPSecAuthenticationMethodSharedSecret;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCValNetIPSecAuthenticationMethodSharedSecret;  

/*kSCPropNetIPSecAuthenticationMethod


extern const CFStringRef kSCPropNetIPSecAuthenticationMethod;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCPropNetIPSecAuthenticationMethod;  

/*kSCEntNetIPSec


extern const CFStringRef kSCEntNetIPSec;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCEntNetIPSec;  

/*kSCValNetPPPAuthPasswordEncryptionKeychain


extern const CFStringRef kSCValNetPPPAuthPasswordEncryptionKeychain;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetPPPAuthPasswordEncryptionKeychain;  

/*kSCValNetInterfaceType6to4


"6to4" 

extern const CFStringRef kSCValNetInterfaceType6to4;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetInterfaceType6to4;  

/*kSCDynamicStoreDomainPlugin


"Plugin:" 

extern const CFStringRef kSCDynamicStoreDomainPlugin;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCDynamicStoreDomainPlugin;  

/*kSCPropNetEthernetMediaSubType


"MediaSubType" 

extern const CFStringRef kSCPropNetEthernetMediaSubType;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetEthernetMediaSubType;  

/*kSCPropNetEthernetMediaOptions


"MediaOptions" 

extern const CFStringRef kSCPropNetEthernetMediaOptions;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetEthernetMediaOptions;  

/*kSCPropNetEthernetMTU


"MTU" 

extern const CFStringRef kSCPropNetEthernetMTU;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetEthernetMTU;  

/*kSCPropInterfaceName


"InterfaceName" 

extern const CFStringRef kSCPropInterfaceName;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropInterfaceName;  

/*kSCPropNetModemConnectionPersonality


extern const CFStringRef kSCPropNetModemConnectionPersonality;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCPropNetModemConnectionPersonality;  

/*kSCPropNetModemDeviceVendor


extern const CFStringRef kSCPropNetModemDeviceVendor;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCPropNetModemDeviceVendor; 

/*kSCPropNetModemDeviceModel


extern const CFStringRef kSCPropNetModemDeviceModel;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCPropNetModemDeviceModel;  

/*kSCPropNetAppleTalkComputerName


"ComputerName" 

extern const CFStringRef kSCPropNetAppleTalkComputerName;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetAppleTalkComputerName;  

/*kSCPropNetAppleTalkComputerNameEncoding


"ComputerNameEncoding" 

extern const CFStringRef kSCPropNetAppleTalkComputerNameEncoding;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetAppleTalkComputerNameEncoding;  

/*kSCDynamicStorePropNetInterfaces


"Interfaces" 

extern const CFStringRef kSCDynamicStorePropNetInterfaces;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCDynamicStorePropNetInterfaces;  

/*kSCEntNetLink


extern const CFStringRef kSCEntNetLink;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntNetLink;  

/*kSCPropNetLinkActive


"Active" 

extern const CFStringRef kSCPropNetLinkActive;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetLinkActive;  

/*kSCDynamicStorePropNetPrimaryInterface


"PrimaryInterface" 

extern const CFStringRef kSCDynamicStorePropNetPrimaryInterface;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCDynamicStorePropNetPrimaryInterface;  

/*kSCPropNetLinkDetaching


"Detaching" 

extern const CFStringRef kSCPropNetLinkDetaching;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetLinkDetaching;  

/*kSCValNetAppleTalkConfigMethodRouter


"Router" 

extern const CFStringRef kSCValNetAppleTalkConfigMethodRouter;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetAppleTalkConfigMethodRouter;  

/*kSCValNetAppleTalkConfigMethodSeedRouter


"SeedRouter" 

extern const CFStringRef kSCValNetAppleTalkConfigMethodSeedRouter;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetAppleTalkConfigMethodSeedRouter;

/*kSCPropNetAppleTalkSeedNetworkRange


"SeedNetworkRange" 

extern const CFStringRef kSCPropNetAppleTalkSeedNetworkRange;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetAppleTalkSeedNetworkRange;  

/*kSCPropNetAppleTalkSeedZones


"SeedZones" 

extern const CFStringRef kSCPropNetAppleTalkSeedZones;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetAppleTalkSeedZones;  

/*kSCCompUsers


"Users" 

extern const CFStringRef kSCCompUsers;  

Availability*/
extern const CFStringRef kSCCompUsers;  

/*kSCEntUsersConsoleUser


"ConsoleUser" 

extern const CFStringRef kSCEntUsersConsoleUser;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCEntUsersConsoleUser;  

/*kSCDynamicStoreDomainPrefs


"Prefs:" 

extern const CFStringRef kSCDynamicStoreDomainPrefs;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCDynamicStoreDomainPrefs;  

/*kSCPrefSystem


"System" 

extern const CFStringRef kSCPrefSystem;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPrefSystem;  

/*kSCCompSystem


"System" 

extern const CFStringRef kSCCompSystem;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCCompSystem;  

/*kSCPropSystemComputerName


"ComputerName" 

extern const CFStringRef kSCPropSystemComputerName;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropSystemComputerName;  

/*kSCCompHostNames


"HostNames" 

extern const CFStringRef kSCCompHostNames;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCCompHostNames;  

/*kSCPropSystemComputerNameEncoding


"ComputerNameEncoding" 

extern const CFStringRef kSCPropSystemComputerNameEncoding;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropSystemComputerNameEncoding;  

/*kSCPropNetLocalHostName


"LocalHostName" 

extern const CFStringRef kSCPropNetLocalHostName;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetLocalHostName;  

/*kSCCompInterface


"Interface" 

extern const CFStringRef kSCCompInterface;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCCompInterface;  

/*kSCPropNetDNSSearchOrder


"SearchOrder" 

extern const CFStringRef kSCPropNetDNSSearchOrder;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetDNSSearchOrder;  

/*kSCPropNetDNSSupplementalMatchDomains


"SupplementalMatchDomains" 

extern const CFStringRef kSCPropNetDNSSupplementalMatchDomains;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetDNSSupplementalMatchDomains;  

/*kSCPropNetDNSSupplementalMatchOrders


"SupplementalMatchOrders" 

extern const CFStringRef kSCPropNetDNSSupplementalMatchOrders;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetDNSSupplementalMatchOrders;  

/*kSCPropNetDNSSortList


"SortList" 

extern const CFStringRef kSCPropNetDNSSortList;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetDNSSortList;  

/*kSCPropNetDNSDomainName


"DomainName" 

extern const CFStringRef kSCPropNetDNSDomainName;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetDNSDomainName;  

/*kSCPropNetDNSOptions


"Options" 

extern const CFStringRef kSCPropNetDNSOptions;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetDNSOptions;  

/*kSCPropNetDNSServerTimeout


"ServerTimeout" 

extern const CFStringRef kSCPropNetDNSServerTimeout;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetDNSServerTimeout;  

/*kSCPropNetDNSServerPort


"ServerPort" 

extern const CFStringRef kSCPropNetDNSServerPort;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetDNSServerPort;  

/*kSCPropNetInterfaces


"Interfaces" 

extern const CFStringRef kSCPropNetInterfaces;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetInterfaces;  

/*kSCPropNetAppleTalkNetworkRange


"NetworkRange" 

extern const CFStringRef kSCPropNetAppleTalkNetworkRange;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetAppleTalkNetworkRange;  

/*kSCPropNetIPv4DestAddresses


"DestAddresses" 

extern const CFStringRef kSCPropNetIPv4DestAddresses;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetIPv4DestAddresses;  

/*kSCPropNetIPv4BroadcastAddresses


"BroadcastAddresses" 

extern const CFStringRef kSCPropNetIPv4BroadcastAddresses;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetIPv4BroadcastAddresses;  

/*kSCPropNetIPv6Flags


"Flags" 

extern const CFStringRef kSCPropNetIPv6Flags;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNetIPv6Flags;  

/*kSCPropNetIPv6PrefixLength


"PrefixLength" 

extern const CFStringRef kSCPropNetIPv6PrefixLength;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNetIPv6PrefixLength;  

/*kSCPropNetIPv6Addresses


"Addresses" 

extern const CFStringRef kSCPropNetIPv6Addresses;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetIPv6Addresses;  

/*kSCPropNetIPv6DestAddresses


"DestAddresses" 

extern const CFStringRef kSCPropNetIPv6DestAddresses;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNetIPv6DestAddresses;  

/*kSCPropNetProxiesProxyAutoConfigEnable


"ProxyAutoConfigEnable" 

extern const CFStringRef kSCPropNetProxiesProxyAutoConfigEnable;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetProxiesProxyAutoConfigEnable;  

/*kSCPropNetProxiesProxyAutoConfigURLString


"ProxyAutoConfigURLString" 

extern const CFStringRef kSCPropNetProxiesProxyAutoConfigURLString;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetProxiesProxyAutoConfigURLString;

/*kSCPropNetSMBNetBIOSName


extern const CFStringRef kSCPropNetSMBNetBIOSName;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCPropNetSMBNetBIOSName;  

/*kSCPropNetIPv6Router


"Router" 

extern const CFStringRef kSCPropNetIPv6Router;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNetIPv6Router;  

/*kSCPropNetSMBNetBIOSNodeType


extern const CFStringRef kSCPropNetSMBNetBIOSNodeType;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCPropNetSMBNetBIOSNodeType;  

/*kSCPropNetSMBNetBIOSScope


extern const CFStringRef kSCPropNetSMBNetBIOSScope;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCPropNetSMBNetBIOSScope;  

/*kSCPropNetSMBWorkgroup


extern const CFStringRef kSCPropNetSMBWorkgroup;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCPropNetSMBWorkgroup;  

/*kSCPropNetSMBWINSAddresses


extern const CFStringRef kSCPropNetSMBWINSAddresses;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCPropNetSMBWINSAddresses;  

/*kSCEntNetSMB


extern const CFStringRef kSCEntNetSMB;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCEntNetSMB;

/*kSCPropNetOverridePrimary


"OverridePrimary" 

extern const CFStringRef kSCPropNetOverridePrimary;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetOverridePrimary;  

/*kSCDynamicStorePropSetupCurrentSet


"CurrentSet" 

extern const CFStringRef kSCDynamicStorePropSetupCurrentSet;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCDynamicStorePropSetupCurrentSet;  

/*kSCDynamicStorePropSetupLastUpdated


"LastUpdated" 

extern const CFStringRef kSCDynamicStorePropSetupLastUpdated;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCDynamicStorePropSetupLastUpdated;  

/*kSCValNetSMBNetBIOSNodeTypeBroadcast


extern const CFStringRef kSCValNetSMBNetBIOSNodeTypeBroadcast;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCValNetSMBNetBIOSNodeTypeBroadcast;  

/*kSCValNetSMBNetBIOSNodeTypePeer


extern const CFStringRef kSCValNetSMBNetBIOSNodeTypePeer;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCValNetSMBNetBIOSNodeTypePeer;  

/*kSCValNetSMBNetBIOSNodeTypeMixed


extern const CFStringRef kSCValNetSMBNetBIOSNodeTypeMixed;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCValNetSMBNetBIOSNodeTypeMixed;  

/*kSCValNetSMBNetBIOSNodeTypeHybrid


extern const CFStringRef kSCValNetSMBNetBIOSNodeTypeHybrid;  

Availability
Introduced in Mac OS X 10.5.*/
extern const CFStringRef kSCValNetSMBNetBIOSNodeTypeHybrid;  

/*kSCEntNetL2TP


extern const CFStringRef kSCEntNetL2TP;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCEntNetL2TP;  

/*kSCPropNetL2TPIPSecSharedSecretEncryption


"IPSecSharedSecretEncryption" 

extern const CFStringRef kSCPropNetL2TPIPSecSharedSecretEncryption;  

Availability
Introduced in Mac OS X 10.3.*/

extern const CFStringRef kSCPropNetL2TPIPSecSharedSecretEncryption;  

/*kSCValNetL2TPIPSecSharedSecretEncryptionKeychain


"Keychain" 

extern const CFStringRef kSCValNetL2TPIPSecSharedSecretEncryptionKeychain;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetL2TPIPSecSharedSecretEncryptionKeychain;  

/*kSCPropNetL2TPIPSecSharedSecret


"IPSecSharedSecret" 

extern const CFStringRef kSCPropNetL2TPIPSecSharedSecret;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNetL2TPIPSecSharedSecret;  

/*kSCValNetModemDialModeManual


extern const CFStringRef kSCValNetModemDialModeManual;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetModemDialModeManual;  

/*kSCValNetPPPAuthPromptBefore


extern const CFStringRef kSCValNetPPPAuthPromptBefore;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetPPPAuthPromptBefore;  

/*kSCValNetPPPAuthPromptAfter


extern const CFStringRef kSCValNetPPPAuthPromptAfter;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetPPPAuthPromptAfter;  

/*kSCValNetPPPAuthProtocolCHAP


extern const CFStringRef kSCValNetPPPAuthProtocolCHAP;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetPPPAuthProtocolCHAP;  

/*kSCValNetPPPAuthProtocolEAP


extern const CFStringRef kSCValNetPPPAuthProtocolEAP;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetPPPAuthProtocolEAP;  

/*kSCValNetPPPAuthProtocolMSCHAP1


extern const CFStringRef kSCValNetPPPAuthProtocolMSCHAP1;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetPPPAuthProtocolMSCHAP1;  

/*kSCValNetPPPAuthProtocolMSCHAP2


extern const CFStringRef kSCValNetPPPAuthProtocolMSCHAP2;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetPPPAuthProtocolMSCHAP2;  

/*kSCValNetPPPAuthProtocolPAP


extern const CFStringRef kSCValNetPPPAuthProtocolPAP;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCValNetPPPAuthProtocolPAP;  

/*kSCPropNetPPPConnectTime


extern const CFStringRef kSCPropNetPPPConnectTime;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetPPPConnectTime; 

/*kSCPropNetPPPDisconnectTime


extern const CFStringRef kSCPropNetPPPDisconnectTime;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNetPPPDisconnectTime;  

/*kSCPropNetPPPPlugins


extern const CFStringRef kSCPropNetPPPPlugins;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetPPPPlugins;  

/*kSCPropNetPPPRetryConnectTime


extern const CFStringRef kSCPropNetPPPRetryConnectTime;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNetPPPRetryConnectTime;  

/*kSCPropNetPPPSessionTimer


extern const CFStringRef kSCPropNetPPPSessionTimer;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPSessionTimer;  

/*kSCPropNetPPPUseSessionTimer


extern const CFStringRef kSCPropNetPPPUseSessionTimer;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetPPPUseSessionTimer;

/*kSCPropNetPPPAuthEAPPlugins


extern const CFStringRef kSCPropNetPPPAuthEAPPlugins;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNetPPPAuthEAPPlugins; 

/*kSCPropNetPPPAuthPrompt


extern const CFStringRef kSCPropNetPPPAuthPrompt;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNetPPPAuthPrompt;  

/*kSCPropNetPPPAuthProtocol


extern const CFStringRef kSCPropNetPPPAuthProtocol;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPAuthProtocol;  

/*kSCPropNetPPPCommConnectDelay


extern const CFStringRef kSCPropNetPPPCommConnectDelay;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPCommConnectDelay;  

/*kSCPropNetPPPCommTerminalScript


extern const CFStringRef kSCPropNetPPPCommTerminalScript;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPCommTerminalScript;  

/*kSCPropNetPPPCommUseTerminalScript


extern const CFStringRef kSCPropNetPPPCommUseTerminalScript;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetPPPCommUseTerminalScript;  

/*kSCPropNetPPPCCPEnabled


extern const CFStringRef kSCPropNetPPPCCPEnabled;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCPropNetPPPCCPEnabled;  

/*kSCPropNetPPPCCPMPPE40Enabled


extern const CFStringRef kSCPropNetPPPCCPMPPE40Enabled;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetPPPCCPMPPE40Enabled;  

/*kSCPropNetPPPCCPMPPE128Enabled


extern const CFStringRef kSCPropNetPPPCCPMPPE128Enabled;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetPPPCCPMPPE128Enabled;  

/*kSCPropNetPPPIPCPUsePeerDNS


extern const CFStringRef kSCPropNetPPPIPCPUsePeerDNS;  

Availability
Introduced in Mac OS X 10.4.*/
extern const CFStringRef kSCPropNetPPPIPCPUsePeerDNS;  

/*kSCPropNetPPPLCPCompressionACField


extern const CFStringRef kSCPropNetPPPLCPCompressionACField;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPLCPCompressionACField;  

/*kSCPropNetPPPLCPCompressionPField


extern const CFStringRef kSCPropNetPPPLCPCompressionPField;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPLCPCompressionPField;  

/*kSCPropNetPPPLCPMRU


extern const CFStringRef kSCPropNetPPPLCPMRU;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPLCPMRU;  

/*kSCPropNetPPPLCPMTU


extern const CFStringRef kSCPropNetPPPLCPMTU;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPLCPMTU;  

/*kSCPropNetPPPLCPReceiveACCM


extern const CFStringRef kSCPropNetPPPLCPReceiveACCM;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPLCPReceiveACCM;  

/*kSCPropNetPPPLCPTransmitACCM


extern const CFStringRef kSCPropNetPPPLCPTransmitACCM;  

Availability
Introduced in Mac OS X 10.1.*/
extern const CFStringRef kSCPropNetPPPLCPTransmitACCM;  

/*kSCValNetIPv4ConfigMethodLinkLocal


"LinkLocal" 

extern const CFStringRef kSCValNetIPv4ConfigMethodLinkLocal;  

Availability
Introduced in Mac OS X 10.2.*/
extern const CFStringRef kSCValNetIPv4ConfigMethodLinkLocal;  

/*kSCValNetIPv6ConfigMethodManual


"Manual" 

extern const CFStringRef kSCValNetIPv6ConfigMethodManual;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetIPv6ConfigMethodManual;  

/*kSCValNetIPv6ConfigMethodRouterAdvertisement


"RouterAdvertisement" 

extern const CFStringRef kSCValNetIPv6ConfigMethodRouterAdvertisement;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetIPv6ConfigMethodRouterAdvertisement;  

/*kSCValNetIPv6ConfigMethod6to4


"6to4" 

extern const CFStringRef kSCValNetIPv6ConfigMethod6to4;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCValNetIPv6ConfigMethod6to4;  

/*kSCPropNet6to4Relay


"Relay" 

extern const CFStringRef kSCPropNet6to4Relay;  

Availability
Introduced in Mac OS X 10.3.*/
extern const CFStringRef kSCPropNet6to4Relay;  

#endif //SCSCHEMADEFINITIONS_H
