#ifndef _GUIDDEF_H_
#define _GUIDDEF_H_


#if defined(__cplusplus) && !defined(CINTERFACE)
#include <string.h>
#endif

#if defined(__cplusplus) && !defined(CINTERFACE)
#define REFIID              const IID &
#else /* !defined(__cplusplus) && !defined(CINTERFACE) */
#define REFIID              const IID* __MIDL_CONST
#endif /* !defined(__cplusplus) && !defined(CINTERFACE) */

#undef DEFINE_GUID

#ifdef INITGUID
#ifdef __cplusplus
#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
        EXTERN_C const GUID name DECLSPEC_HIDDEN; \
        EXTERN_C const GUID name = \
	{ l, w1, w2, { b1, b2,  b3,  b4,  b5,  b6,  b7,  b8 } }
#else
#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
        const GUID name DECLSPEC_HIDDEN; \
        const GUID name = \
	{ l, w1, w2, { b1, b2,  b3,  b4,  b5,  b6,  b7,  b8 } }
#endif
#else
#define DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
    EXTERN_C const GUID name DECLSPEC_HIDDEN
#endif


#ifndef GUID_DEFINED
#define GUID_DEFINED
typedef struct _GUID
{
#ifdef _MSC_VER
    unsigned long  Data1;
#else
    unsigned int   Data1;
#endif
    unsigned short Data2;
    unsigned short Data3;
    unsigned char  Data4[ 8 ];
} GUID;
#endif

typedef GUID IID,*LPIID;

#endif /* _GUIDDEF_H_ */
