#ifndef __WINE_WINSOCKAPI_STDLIB_H
#define __WINE_WINSOCKAPI_STDLIB_H

#ifndef USE_WS_PREFIX
# ifdef FD_CLR
#  include <sys/types.h>
# elif defined(RLIM_INFINITY)
#  include <sys/types.h>
#  include <time.h>
#  include <stdlib.h>
# else  /* FD_CLR */
#  include <sys/types.h>
#  include <time.h>
#  include <stdlib.h>
# endif /* FD_CLR */

#else
# include <sys/types.h>
# include <stdlib.h>
#endif /* !USE_WS_PREFIX */

#endif /* __WINE_WINSOCKAPI_STDLIB_H */

#ifndef __WINESRC__
# include <Wine/windows.h>
#else
# include <Wine/.windef.h>
#endif

#ifndef _WINSOCKAPI_
#define _WINSOCKAPI_

#ifdef __cplusplus
extern "C" {
#endif /* defined(__cplusplus) */


#ifdef __cplusplus
}
#endif

#ifndef __WINE_WINSOCK2__
#undef WS
#undef WS_API_PROTOTYPES
#undef WS_API_TYPEDEFS
#endif

#endif  /* _WINSOCKAPI_ */
