
#import <Foundation/Foundation.h>
#import <XgridFoundation/XGActionMonitor.h>

@class XGConnection;
@class XGController;
@class XGResourceInternal;

/*XGResourceState

See Also:
XGResourceState
typedef enum { 
    XGResourceStateUninitialized = 0, 
    XGResourceStateOffline, 
    XGResourceStateConnecting, 
    XGResourceStateUnavailable, 
    XGResourceStateAvailable, 
    XGResourceStateWorking, 
    XGResourceStatePending, 
    XGResourceStateStarting, 
    XGResourceStateStagingIn, 
    XGResourceStateRunning, 
    XGResourceStateSuspended, 
    XGResourceStateStagingOut, 
    XGResourceStateCanceled, 
    XGResourceStateFailed, 
    XGResourceStateFinished 
} XGResourceState; */
typedef enum { 
    XGResourceStateUninitialized = 0, 
    XGResourceStateOffline, 
    XGResourceStateConnecting, 
    XGResourceStateUnavailable, 
    XGResourceStateAvailable, 
    XGResourceStateWorking, 
    XGResourceStatePending, 
    XGResourceStateStarting, 
    XGResourceStateStagingIn, 
    XGResourceStateRunning, 
    XGResourceStateSuspended, 
    XGResourceStateStagingOut, 
    XGResourceStateCanceled, 
    XGResourceStateFailed, 
    XGResourceStateFinished 
} XGResourceState; 


@interface XGResource : NSObject

/*identifier

Returns the unique identifier of the receiver's resource.

    - (NSString *)identifier;

method result
    The unique identifier of the receiver's resource. 
Discussion

The identifier is a unique string assigned to the resouce by the Xgrid controller. All resources managed by a particular Xgrid controller are guaranteed to have a unique identifier, but no guarantee of uniqueness is made between multiple Xgrid controllers.*/
- (NSString *)identifier;
	
 @end
