#ifndef _OS_OSCOLLECTIONITERATOR_H
#define _OS_OSCOLLECTIONITERATOR_H

#include <libkern/c++/OSIterator.h>

#ifdef __cplusplus
class OSCollection;
class OSCollectionIterator : public OSIterator
{
    OSDeclareDefaultStructors(OSCollectionIterator)

protected:
public:

/*reset


Resets the iterator to begin the next iteration from the beginning of the collection. 

public

virtual void reset(); */
virtual void reset(); 

/*withCollection(const OSCollection *)


Creates and initializes an instance of OSCollectionIterator for the provided collection object. 

public

static OSCollectionIterator *withCollection(
    const OSCollection *inColl); 
Parameters
inColl
The OSCollection-derived collection object to be iteratated.
Return Value

Returns a new instance of OSCollection or 0 on failure.*/

static OSCollectionIterator *withCollection(
    const OSCollection *inColl); 

};
#endif//__cplusplus
#endif //_OS_OSCOLLECTIONITERATOR_H
