#ifndef _OS_OSITERATOR_H
#define _OS_OSITERATOR_H

#include <libkern/c++/OSObject.h>

#ifdef __cplusplus
//#ifdef _PLATFORMFUNCTIONS_H
 class IOPlatformFunctionIterator;//AppleGPIO
//#endif//

class OSIterator : public OSObject
{
    OSDeclareAbstractStructors(OSIterator)

public:

/*reset


Resets the iterator to the beginning of the collection (a pure virtual member function to be overridden by the subclass). 

public

virtual void reset() = 0; */
virtual void reset() = 0; 

/*getNextObject


Returns a reference to the current object in the collection and advances the interator to the next object (a pure virtual member function to be overridden by the subclass). 

public

virtual OSObject *getNextObject() = 0; */
virtual OSObject *getNextObject() = 0; 

};
#endif//__cplusplus

#endif//_OS_OSITERATOR_H
