#ifndef OC_MATH_H
#define OC_MATH_H

/////////////////
#include "/usr/include/math.h" 
/////////////////
#undef isnan
#undef isinf

#ifdef __CYGWIN__

#define OC__isnanf
#define native__isnanf

#endif//__CYGWIN__
/////////////////
#if (defined(__ppc__) || defined(__ppc64__))
#include "<architecture/ppc/math.h>
#elif (defined (__i386__) || defined( __x86_64__ ))
#include <architecture/i386/math.h>
#else
#error Unknown architecture
#endif

#
#endif //OC_MATH_H
