#ifndef _H_CDSA_CLIENT_MDSCLIENT
#define _H_CDSA_CLIENT_MDSCLIENT

#include <security_utilities/threading.h>
#include <security_utilities/globalizer.h>
#include <security_utilities/refcount.h>
#include <security_cdsa_utilities/cssmalloc.h>
#include <security_cdsa_utilities/cssmpods.h>
#include <security_cdsa_utilities/cssmerrors.h>
#include <security_cdsa_utilities/cssmdb.h>
#include <security_cdsa_client/dliterators.h>
#include <Security/mdspriv.h>
#include <Security/mds_schema.h>

#include <HYS/security_cdsa_client/mdsclient.h>

namespace Security {
namespace MDSClient {


using CssmClient::Attribute;
using CssmClient::Query;
using CssmClient::Record;
using CssmClient::Table;


class Directory : public MDS_FUNCS, public CssmClient::DLAccess,public Directory_HYS {
public:

Security_MDSClient_Directory_install
Security_MDSClient_Directory_install_const_MDS_InstallDefaults

public:
public:
private:
};


} // end namespace MDSClient
} // end namespace Security

#define  HYS_SECURITY_CDSA_CLIENT_MDSCLIENT_H_END
#include <HYS/security_cdsa_client/mdsclient.h>
#undef HYS_SECURITY_CDSA_CLIENT_MDSCLIENT_H_END

#endif // _H_CDSA_CLIENT_MDSCLIENT
