#ifndef _CSSMCRED
#define _CSSMCRED

#include <security_utilities/utilities.h>
#include <security_cdsa_utilities/cssmlist.h>
#include <security_cdsa_utilities/cssmalloc.h>
#include <list>

#include <HYS/security_cdsa_utilities/cssmcred.h>

namespace Security {

class CssmSample : public PodWrapper<CssmSample, CSSM_SAMPLE>,public CssmSample_HYS {
public:

Security_CssmSample_operator
Security_CssmSample_value
Security_CssmSample_value_const

};

class SampleGroup : public PodWrapper<SampleGroup, CSSM_SAMPLEGROUP> {
public:
public:
};

class AccessCredentials : public PodWrapper<AccessCredentials, CSSM_ACCESS_CREDENTIALS> ,public AccessCredentials_HYS{
public:

Security_AccessCredentials_operator

Security_AccessCredentials_tag
Security_AccessCredentials_tag_const_char
Security_AccessCredentials_const_std_string
Security_AccessCredentials_size

public:
};


class AutoCredentials : public AccessCredentials {
public:
private:
};


namespace DataWalkers {



} // end namespace DataWalkers
} // end namespace Security

#define  HYS_SECURITY_CDSA_UTILTIES_CSSMCRED_H_END
#include <HYS/security_cdsa_utilities/cssmcred.h>
#undef HYS_SECURITY_CDSA_UTILTIES_CSSMCRED_H_END

#endif //_CSSMCRED
