#ifndef _H_CSSMPODS
#define _H_CSSMPODS

#include <security_utilities/utilities.h>
#include <security_cdsa_utilities/cssmdata.h>
#include <string>

#include <HYS/security_cdsa_utilities/cssmpods.h>

namespace Security {

class Guid : public PodWrapper<Guid, CSSM_GUID>,public Guid_HYS {
public:

Security_Guid_Guid
Security_Guid_Guid_const_CSSM_GUID
Security_Guid_Guid_const_char
Security_Guid_Guid_const_std_string
Security_Guid_toString
Security_Guid_toString_char

private:

};

class CssmGuidData : public CssmData {
public:
private:

};


class CssmSubserviceUid : public PodWrapper<CssmSubserviceUid, CSSM_SUBSERVICE_UID> {
public:
};


class CryptoCallback {
public:
private:
};

class CssmCryptoData : public PodWrapper<CssmCryptoData, CSSM_CRYPTO_DATA>,public CssmCryptoData_HYS {
public:

Security_CssmCryptoData_CssmCryptoData
Security_CssmCryptoData_CssmCryptoData_const_CssmData
Security_CssmCryptoData_CssmCryptoData_const_CssmData_CryptoCallback
Security_CssmCryptoData_CssmCryptoData_CSSM_CALLBACK
Security_CssmCryptoData_CssmCryptoData_CryptoCallback

};

class CryptoDataClass : public CssmCryptoData {
public:
protected:
private:

};


class CssmKeySize : public PodWrapper<CssmKeySize, CSSM_KEY_SIZE> {
public:
};


class QuerySizeData : public PodWrapper<QuerySizeData, CSSM_QUERY_SIZE_DATA> {
public:
};


class CSPOperationalStatistics : 
	public PodWrapper<CSPOperationalStatistics, CSSM_CSP_OPERATIONAL_STATISTICS> {
public:
};


} // end namespace Security


#endif //_H_CSSMPODS
