#ifndef _H_CFUTILITIES
#define _H_CFUTILITIES

#include <security_utilities/utilities.h>
#include <security_utilities/globalizer.h>
#include <CoreFoundation/CoreFoundation.h>
#include <algorithm>

#include <HYS/security_utilities/cfutilities.h>

namespace Security {

template <class CFType> 
class CFRef :public CFRef_HYS{
public:

Security_CFRef_operator
Security_CFRef_operator1
Security_CFRef_operator2
Security_CFRef_operator3
Security_CFRef_operator4

Security_CFRef_CFRef
Security_CFRef_CFRef_CFType
Security_CFRef_CFRef_const_CFRef
Security_CFRef_CFRef_CFType_OSStatus


private:

Security_CFRef_CFRef_mRef

};

template <class CFType>
 class CFCopyRef : public CFRef<CFType> {
public:
};


class CFTempString : public CFRef<CFStringRef> {
public:
};

class CFTempURL : public CFRef<CFURLRef> {
public:
};

class CFTempNumber : public CFRef<CFNumberRef> {
public:
};

class CFTempData : public CFRef<CFDataRef> {
public:
};

class CFMallocData {
public:
private:
};

class CFDictionary : public CFCopyRef<CFDictionaryRef> {

public:
private:
public:	
private:

};



} // end namespace Security

#endif //_H_CFUTILITIES
