#ifndef _H_UTILITIES_ERROR
#define _H_UTILITIES_ERROR

#include <security_utilities/utilities.h>
#include <exception>

#include <HYS/security_utilities/errors.h>

namespace Security {


class CommonError : public std::exception,public CommonError_HYS {
protected:
public:
Security_CommonError_osStatus

protected:
private:
};

class UnixError : public CommonError,public UnixError_HYS {
protected:
public:

Security_UnixError_unixError

private:

};

class MacOSError : public CommonError ,public MacOSError_HYS{
protected:
public:

Security_MacOSError_throwMe

};


class CFError : public CommonError ,public CFError_HYS{
protected:

public:

Security_CFError_throwMe
};


} // end namespace Security


#endif //_H_UTILITIES_ERROR
