#ifndef _H_MACHPP
#define _H_MACHPP


#include <security_utilities/utilities.h>
#include <security_utilities/errors.h>
#include <security_utilities/threading.h>
#include <security_utilities/globalizer.h>
#include <mach/mach.h>
#include <servers/bootstrap.h>
#include <set>

#include <sys/types.h>
#include <unistd.h>

#include <HYS/security_utilities/mach++.h>

namespace Security {
namespace MachPlusPlus {


class Error : public CommonError,public Error_HYS {
protected:
public:

Security_MachPlusPlus_Error_error

Security_MachPlusPlus_Error_osStatus
Security_MachPlusPlus_Error_check

private:
};

class Port:public Port_HYS {
protected:
public:


Security_MachPlusPlus_Port_requestNotify

protected:
};



class AutoPort : public Port {
public:
};


class PortSet : public Port {
public:
};


class Bootstrap : public Port {
public:
private:
protected:
};


class TaskPort : public Port {
public:
};

class ReceivePort : public Port {
public:
};

class StBootstrap {
public:
private:
};


class VMGuard: public VMGuard_HYS {
public:

Security_MachPlusPlus_VMGuard_mAddr
Security_MachPlusPlus_VMGuard_mLength

Security_MachPlusPlus_VMGuard_VMGuard

private:
};


class Message {
public:
public:
protected:
private:
};


} // end namespace MachPlusPlus
} // end namespace Security

#endif //_H_MACHPP
