#ifndef _H_THREADING
#define _H_THREADING


#include <security_utilities/utilities.h>
#include <security_utilities/errors.h>
#include <security_utilities/debugging.h>
# include <pthread.h>

#include <security_utilities/threading_internal.h>

#include <HYS/security_utilities/threading.h>

namespace Security {


class ThreadStoreSlot {
public:
private:

};

class LockingPrimitive {
protected:
};


class Mutex : public LockingPrimitive,public Mutex_HYS {
    NOCOPY(Mutex)
    friend class Condition;

public:

Security_Mutex_Mutex
Security_Mutex_Mutex_Type

Security_Mutex_lock
Security_Mutex_unlock

private:
};


class Condition : public LockingPrimitive ,public Condition_HYS{
    NOCOPY(Condition)
public:	

Security_Condition_Condition

Security_Condition_broadcast
Security_Condition_wait

private:

};


class CountingMutex : public Mutex {
public:
private:

};

class Thread: public Thread_HYS {
    NOCOPY(Thread)
public:
    class Identity {
        friend class Thread;
    public:
    private:

    };

public:

Security_Thread_Thread

public:
protected:
private:
};


class ThreadRunner : public Thread {

public:
private:
};

template <class Lock,void (Lock::*_lock)() = &Lock::lock,void (Lock::*_unlock)() = &Lock::unlock>
class StLock :public StLock_HYS{
public:

Security_StLock_StLock_Lock
Security_StLock_StLock_Lock_bool

Security_StLock_StLock_me
Security_StLock_StLock_mActive

protected:

};



} // end namespace Security

#endif //_H_THREADING
