#ifndef OC_SYS_IOCTL_H
#define OC_SYS_IOCTL_H

#include <sys/ttycom.h>

#include <sys/ioccom.h>

#include <sys/filio.h>
#include <sys/sockio.h>

#if defined(USE_OLD_TTY) || COMPAT_43 || defined(COMPAT_SUNOS) || \
    defined(COMPAT_SVR4) || defined(COMPAT_NEXT_3X) || COMPAT_43_TTY
#include <sys/ioctl_compat.h>
#endif /* !_SYS_IOCTL_H_ */

#include "/usr/include/sys/ioctl.h"

#undef _IOWR
#define	_IOWR(a,b,c)	_IOC(IOC_INOUT,	(a), (b), sizeof(c))//c

#undef _IOW
#define	_IOW(a,b,c)	_IOC(IOC_IN,	(a), (b), sizeof(c))//c

#endif//OC_SYS_IOCTL_H
