#include <DiskArbitration/DiskArbitration.h>
#include <DiskArbitration/DADisk.h>

const CFStringRef kDADiskDescriptionMediaSizeKey;//?
const CFStringRef kDADiskDescriptionMediaWholeKey;//?
const CFStringRef kDADiskDescriptionVolumeMountableKey;//?
const CFStringRef kDADiskDescriptionVolumeNameKey;//?
const CFStringRef kDADiskDescriptionVolumePathKey;//?
const CFStringRef kDADiskDescriptionMediaPathKey;//?
const CFStringRef kDADiskDescriptionDeviceInternalKey;//?
const CFStringRef kDADiskDescriptionMediaEjectableKey;//?
const CFStringRef kDADiskDescriptionMediaKindKey;//?
const CFStringRef kDADiskDescriptionMediaLeafKey;//?
const CFStringRef kDADiskDescriptionMediaWritableKey;//?
const CFStringRef kDADiskDescriptionVolumeNetworkKey;//?
const CFStringRef kDADiskDescriptionMediaContentKey;//?
const CFStringRef kDADiskDescriptionMediaBSDMinorKey;//?
const CFStringRef kDADiskDescriptionVolumeKindKey;//?
const CFStringRef kDADiskDescriptionMediaBlockSizeKey;//?
const CFStringRef  kDADiskDescriptionMediaRemovableKey;//?
const CFStringRef  kDADiskDescriptionMediaTypeKey;//?
const CFStringRef  kDADiskDescriptionVolumeUUIDKey;//?
const CFStringRef  kDADiskDescriptionMediaBSDUnitKey;//?
const CFStringRef  kDADiskDescriptionMediaBSDNameKey;//?
const CFStringRef  kDADiskDescriptionMediaBSDMajorKey;//?
const CFStringRef  kDADiskDescriptionMediaIconKey;//?
const CFStringRef  kDADiskDescriptionMediaNameKey;//?
const CFStringRef  kDADiskDescriptionMediaUUIDKey;//?
const CFStringRef  kDADiskDescriptionDeviceProtocolKey;//?
const CFStringRef  kDADiskDescriptionDeviceModelKey;//?
const CFStringRef  kDADiskDescriptionDeviceRevisionKey;//?
const CFStringRef  kDADiskDescriptionDeviceVendorKey;//?
const CFStringRef  kDADiskDescriptionDevicePathKey;//?
const CFStringRef  kDADiskDescriptionDeviceUnitKey;//?
const CFStringRef  kDADiskDescriptionDeviceGUIDKey;//?
const CFStringRef  kDADiskDescriptionBusNameKey;//?
const CFStringRef  kDADiskDescriptionBusPathKey;//?

const char * DADiskGetID( DADiskRef a){};//c
void DADiskSetOption( DADiskRef a ,DADiskOption b, Boolean c ){};//?

/*DADiskCopyDescription


Obtains the Disk Arbitration description of the specified disk. 
extern CFDictionaryRef DADiskCopyDescription(
    DADiskRef disk );  
Parameters
disk
The DADisk for which to obtain the Disk Arbitration description.
Return Value

The disk's Disk Arbitration description. 
Discussion 

This function will contact Disk Arbitration to acquire the latest description of the specified disk, unless this function is called on a disk object passed within the context of a registered callback, in which case the description is current as of that callback event. 

The caller of this function receives a reference to the returned object. The caller also implicitly retains the object and is responsible for releasing it with CFRelease().*/
CFDictionaryRef DADiskCopyDescription(
    DADiskRef disk ){
printf ("DADiskCopyDescription",disk);
};  
