
#include <DiskArbitration/DiskArbitration.h>

/*kDADiskDescriptionMatchVolumeUnrecognized


extern CFDictionaryRef kDADiskDescriptionMatchVolumeUnrecognized;  
Discussion 

Predefined CFDictionary object containing a set of disk description keys and values appropriate for matching unrecognized volumes using DARegister*Callback().*/
CFDictionaryRef kDADiskDescriptionMatchVolumeUnrecognized;  

/*DADiskSetOptions


Sets the options for the specified disk. 

extern DAReturn DADiskSetOptions(
    DADiskRef disk,
    DADiskOptions options,
    Boolean value );  
Parameters
disk
The disk object for which to set the options.
options
The options to set or clear.
value
Pass TRUE to set options; otherwise pass FALSE to clear options.
Return Value

A result code.*/
 DAReturn DADiskSetOptions(
    DADiskRef disk,
    DADiskOptions options,
    Boolean value ){};  

/*kDADiskDescriptionMatchVolumeMountable


extern CFDictionaryRef kDADiskDescriptionMatchVolumeMountable;  
Discussion 

Predefined CFDictionary object containing a set of disk description keys and values appropriate for matching mountable volumes using DARegister*Callback().*/

 CFDictionaryRef kDADiskDescriptionMatchVolumeMountable;


/*kDADiskDescriptionWatchVolumePath


extern CFArrayRef kDADiskDescriptionWatchVolumePath;  
Discussion 

Predefined CFArray object containing a set of disk description keys appropriate for watching volume mount changes using DARegisterDiskDescriptionChangedCallback().*/
 CFArrayRef kDADiskDescriptionWatchVolumePath;  
