#include <IOKit/ata/IOATABusInfo.h>


/*setSocketType


Sets socket type. 

public

void setSocketType(
    ataSocketType inSocketType ); 
Discussion 

Set by ATAControllers: internal fixed, media-bay, PC-Card.*/
void IOATABusInfo::setSocketType(
    ataSocketType inSocketType ){};

/*zeroData


Sets this object to a blank state. 

public

virtual void zeroData(
    void); */
 void IOATABusInfo:: zeroData(
    void){};


/*setUnits


Sets how many devices are on this bus. 

public

void setUnits(
    UInt8 inNumUnits ); 
Discussion 

Set by ATAControllers.*/
void IOATABusInfo::setUnits(
    UInt8 inNumUnits ){};


/*setPIOModes


Sets bit-significant map of supported transfer modes. 

public

void setPIOModes(
    UInt8 inModeBitMap); 
Discussion 

Set by ATAControllers.*/
void IOATABusInfo::setPIOModes(
    UInt8 inModeBitMap){};


/*setDMAModes


Sets bit-significant map of supported transfer modes. 

public

void setDMAModes(
    UInt8 inModeBitMap ); 
Discussion 

Set by ATAControllers.*/
void IOATABusInfo::setDMAModes(
    UInt8 inModeBitMap ){};


/*setUltraModes


Sets bit-significant map of supported transfer modes. 

public

void setUltraModes(
    UInt8 inModeBitMap ); 
Discussion 

Set by ATAControllers.*/

void IOATABusInfo::setUltraModes(
    UInt8 inModeBitMap ){};


/*setExtendedLBA


Sets true for support of 48-bit LBA. 

public

void setExtendedLBA(
    bool inState ); 
Discussion 

Set by ATAControllers.*/

void IOATABusInfo::setExtendedLBA(
    bool inState ){};

/*setMaxBlocksExtended


Sets the maximum number of blocks allowed in a single transfer of data. 

public

void setMaxBlocksExtended(
    UInt16 inMaxBlocks); 
Discussion 

Set by controllers, this indicates the maximum number of blocks allowed in a single transfer of data. Some dma engines may not be capable of supporting the full 16-bit worth of sector count allowed under 48 bit extended LBA. Default is 256 blocks, same as standard ATA.*/

void IOATABusInfo::setMaxBlocksExtended(
    UInt16 inMaxBlocks){};


/*atabusinfo


Factory method. 

public

static IOATABusInfo* atabusinfo(
    void); */
 IOATABusInfo* atabusinfo(
    void){}; 

/*getSocketType


Returns the socket type, internal fixed, media-bay, PC-Card. 

public

ataSocketType getSocketType(
    void ); 
Discussion 

This method is used by clients of ATAControllers to find out about the bus.*/
ataSocketType getSocketType(
    void ){}; 

