#include <IOKit/avc/IOFireWireAVCTargetSpace.h>

bool AVCSubunitInfo::init(){};//c
void AVCSubunitInfo::free(){};//c
IOReturn IOFireWireAVCTargetSpace::targetSendAVCResponse(UInt32 generation, UInt16 nodeID, IOBufferMemoryDescriptor *pBufMemDesc, UInt32 size){};//c
UInt32 IOFireWireAVCTargetSpace::doWrite(UInt16 nodeID, IOFWSpeed &speed, FWAddress addr, UInt32 len,const void *buf, IOFWRequestRefCon refcon){};//c

 IOReturn IOFireWireAVCTargetSpace:: findAVCRequestHandler(IOFireWireAVCProtocolUserClient *userClient,UInt32 generation,UInt16 nodeID,IOFWSpeed speed,UInt32 handlerSearchIndex,const char *pCmdBuf,UInt32 cmdLen){};//c

IOReturn IOFireWireAVCTargetSpace:: activateWithUserClient(IOFireWireAVCProtocolUserClient *userClient){};//c
void  IOFireWireAVCTargetSpace::deactivateWithUserClient(IOFireWireAVCProtocolUserClient *userClient){};//c
void  IOFireWireAVCTargetSpace::pcrModified(IOFWAVCPlugTypes plugType,UInt32 plugNum,UInt32 newValue){};//c
bool IOFireWireAVCTargetSpace:: canConnectDestPlug(UInt32 destSubunitTypeAndID,IOFWAVCPlugTypes destPlugType,UInt32 *destPlugNum){};//c
UInt32 IOFireWireAVCTargetSpace::subUnitOfTypeCount(UInt32 type){};//c
IOReturn IOFireWireAVCTargetSpace::handleConnectCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len){};//c

IOReturn  IOFireWireAVCTargetSpace::setSubunitPlugSignalFormat(IOFireWireAVCProtocolUserClient *userClient,UInt32 subunitTypeAndID,IOFWAVCPlugTypes plugType,UInt32 plugNum,UInt32 signalFormat){};//c

 IOReturn IOFireWireAVCTargetSpace::connectTargetPlugs(IOFireWireAVCProtocolUserClient *userClient,AVCConnectTargetPlugsInParams *inParams,AVCConnectTargetPlugsOutParams *outParams){};//c

IOReturn IOFireWireAVCTargetSpace:: addSubunit(IOFireWireAVCProtocolUserClient *userClient,IOFireWireAVCSubunitPlugHandlerCallback callBack,OSAsyncReference64 asyncRef,UInt32 subunitType,UInt32 numSourcePlugs,UInt32 numDestPlugs,uint64_t userCallBack,uint64_t userRefCon,UInt32 *subUnitID){};//c


IOReturn IOFireWireAVCTargetSpace::installAVCCommandHandler(IOFireWireAVCProtocolUserClient *userClient,IOFireWireAVCTargetCommandHandlerCallback callBack,OSAsyncReference64 asyncRef,UInt32 subUnitTypeAndID,UInt32 opCode,uint64_t userCallBack,  uint64_t userRefCon){};//c

IOReturn IOFireWireAVCTargetSpace::getSubunitPlugSignalFormat(IOFireWireAVCProtocolUserClient *userClient,UInt32 subunitTypeAndID,IOFWAVCPlugTypes plugType,UInt32 plugNum,UInt32 *pSignalFormat){};//c

IOReturn IOFireWireAVCTargetSpace::disconnectTargetPlugs(IOFireWireAVCProtocolUserClient *userClient,UInt32 sourceSubunitTypeAndID,IOFWAVCPlugTypes sourcePlugType,UInt32 sourcePlugNum,UInt32 destSubunitTypeAndID,IOFWAVCPlugTypes destPlugType,UInt32 destPlugNum){};//c

AVCSubunitInfo * IOFireWireAVCTargetSpace::getSubunitInfo(UInt32 subunitTypeAndID){};//c
IOReturn IOFireWireAVCTargetSpace::handleSignalSourceCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len){};//c
IOReturn IOFireWireAVCTargetSpace::handleConnectionsCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len){};//c
IOReturn IOFireWireAVCTargetSpace::handleOutputPlugSignalFormatCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len){};//c
IOReturn IOFireWireAVCTargetSpace::handleInputPlugSignalFormatCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len){};//c
IOReturn IOFireWireAVCTargetSpace::handleDisconnectCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len){};//c
IOReturn IOFireWireAVCTargetSpace::handlePowerCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len){};//c
IOReturn IOFireWireAVCTargetSpace::handlePlugInfoCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len){};//c
IOReturn IOFireWireAVCTargetSpace::handleSubUnitInfoCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len){};//c
IOReturn IOFireWireAVCTargetSpace::handleUnitInfoCommand(UInt16 nodeID, UInt32 generation, const char *buf, UInt32 len){};//c

IOReturn IOFireWireAVCTargetSpace::getTargetPlugConnection(IOFireWireAVCProtocolUserClient *userClient,AVCGetTargetPlugConnectionInParams *inParams,AVCGetTargetPlugConnectionOutParams *outParams){};//c


///////////////////////////////////////




/*getAVCTargetSpace


returns the IOFireWireAVCTargetSpace object for the given FireWire bus 

public

static IOFireWireAVCTargetSpace *getAVCTargetSpace(
    IOFireWireController *controller); 
Parameters
bus
The FireWire bus*/
IOFireWireAVCTargetSpace * IOFireWireAVCTargetSpace::getAVCTargetSpace(
    IOFireWireController *controller){};

/*publishAVCUnitDirectory


Creates a local AVC Unit directory if it doesn't already exist 

public

virtual IOReturn publishAVCUnitDirectory(
    void); */
IOReturn IOFireWireAVCTargetSpace::publishAVCUnitDirectory(
    void){};

/*init


initializes the IOFireWireAVCTargetSpace object 

public

virtual bool init(
    IOFireWireController *controller); */
bool IOFireWireAVCTargetSpace:: init(
    IOFireWireController *controller){}; 

