#include <IOKit/avc/IOFireWireAVCUnit.h>

bool IOFireWireAVCAsynchronousCommand:: isPending(){};//?
void IOFireWireAVCAsynchronousCommand::free(){};//?;
IOReturn IOFireWireAVCAsynchronousCommand::reinit(const UInt8 * a, UInt32 b){};//c
IOReturn IOFireWireAVCAsynchronousCommand::submit(IOFireWireAVCNub *a){};//c
IOReturn IOFireWireAVCAsynchronousCommand::init(const UInt8 * a, UInt32 b, IOFireWireAVCAsynchronousCommandCallback c, void *d){};//c
IOReturn IOFireWireAVCAsynchronousCommand::cancel(){};//c

void IOFireWireAVCUnit::AVCAsynchRequestWriteDone(void *a, IOReturn b, IOFireWireNub *c, IOFWCommand *d){};//c

void IOFireWireAVCUnit::AVCAsynchDelayDone(void *a, IOReturn b, IOFireWireBus *c, IOFWBusCommand *d){};//c

void IOFireWireAVCUnit:: lockAVCAsynchronousCommandLock(){};//c
IOReturn IOFireWireAVCSubUnit:: message(UInt32 a, IOService *b, void *c){};//?
void IOFireWireAVCUnit:: rescanSubUnits(void *a){};//c

UInt32 IOFireWireAVCUnit::AVCResponse(void *a, UInt16 b, IOFWSpeed &c, FWAddress d, UInt32 e, const void *f, IOFWRequestRefCon g){};//c

void IOFireWireAVCUnit::updateSubUnits(bool a){};//?
bool IOFireWireAVCUnit::start(IOService *a){};//?
bool IOFireWireAVCSubUnit:: init(OSDictionary *a, IOFireWireAVCUnit *b){};//?
void IOFireWireAVCUnit::free(){};//?
IOReturn IOFireWireAVCUnit::message(UInt32 a, IOService *b, void *c){};//?
void IOFireWireAVCUnit::unlockAVCAsynchronousCommandLock(){};//c

UInt32 IOFireWireAVCUnit:: indexOfAVCAsynchronousCommandObject(IOFireWireAVCAsynchronousCommand *a){};//c

void IOFireWireAVCUnit::removeAVCAsynchronousCommandObjectAtIndex(UInt32 a){};//c
IOReturn IOFireWireAVCUnit::setProperties (OSObject * a){};//?

/*AVCCommand


Sends an AVC command to the device and stores the response. 

public

virtual IOReturn AVCCommand(
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen) = 0; 
Parameters
command
Pointer to command to send.
cmdLen
Length of the command.
response
Pointer to place to store the response.
responseLen
Pointer to response length - initialize to the size of the buffer pointed to by response, updated to the number of bytes returned by the device.*/
IOReturn  IOFireWireAVCNub::AVCCommand(
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen) {}; 

/*AVCCommandInGeneration


Sends an AVC command to the device and stores the response. The command must complete in the specified FireWire bus generation otherwise kIOFireWireBusReset is returned. 

public

virtual IOReturn AVCCommandInGeneration(
    UInt32 generation, 
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen) = 0; 
Parameters
generation
The bus generation that the command must execute in.
command
Pointer to command to send.
cmdLen
Length of the command.
response
Pointer to place to store the response.
responseLen
Pointer to response length - initialize to the size of the buffer pointed to by response, updated to the number of bytes returned by the device.*/
IOReturn IOFireWireAVCNub:: AVCCommandInGeneration(
    UInt32 generation, 
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen) {}; 

/*updateAVCCommandTimeout


By default, AVCCommands timeout 10 seconds after receiving an Interim response. This function resets the timeout of the current command to 10 seconds from the current time. Call this repeatedly for AVC commands that take a very long time to execute to prevent premature timeout. 

public

virtual IOReturn updateAVCCommandTimeout() = 0; */
IOReturn IOFireWireAVCNub::updateAVCCommandTimeout() {}; 


/*getDevice


Returns the FireWire device nub that is this object's provider . 

public

IOFireWireNub* getDevice() const ;*/
IOFireWireNub* IOFireWireAVCNub::getDevice() const{} ;

/*updateAVCCommandTimeout


By default, AVCCommands timeout 10 seconds after receiving an Interim response. This function resets the timeout of the current command to 10 seconds from the current time. Call this repeatedly for AVC commands that take a very long time to execute to prevent premature timeout. 

public

virtual IOReturn updateAVCCommandTimeout();*/ 

IOReturn  IOFireWireAVCUnit::updateAVCCommandTimeout(){};

/*AVCCommandInGeneration


Sends an AVC command to the device and stores the response. The command must complete in the specified FireWire bus generation otherwise kIOFireWireBusReset is returned. 

public

virtual IOReturn AVCCommandInGeneration(
    UInt32 generation, 
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen); 
Parameters
generation
The bus generation that the command must execute in.
command
Pointer to command to send.
cmdLen
Length of the command.
response
Pointer to place to store the response.
responseLen
Pointer to response length - initialize to the size of the buffer pointed to by response, updated to the number of bytes returned by the device.*/
IOReturn IOFireWireAVCUnit::AVCCommandInGeneration(
    UInt32 generation, 
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen){}; 

/*AVCCommand


Sends an AVC command to the device and stores the response. 

public

virtual IOReturn AVCCommand(
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen); 
Parameters
command
Pointer to command to send.
cmdLen
Length of the command.
response
Pointer to place to store the response.
responseLen
Pointer to response length - initialize to the size of the buffer pointed to by response, updated to the number of bytes returned by the device.*/
IOReturn IOFireWireAVCUnit::AVCCommand(
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen){};
 

/*handleClose


Overrideable method to control the open / close behaviour of an IOService. 

public

virtual void handleClose(
    IOService *forClient, 
    IOOptionBits options ); 
Parameters
forClient
Designates the client of the provider requesting the close.
options
Options for the close, may be interpreted by the implementor of handleOpen.
Discussion 

See IOService for discussion.*/

 void IOFireWireAVCSubUnit::handleClose(
    IOService *forClient, 
    IOOptionBits options ){}; 


/*handleOpen


Overrideable method to control the open / close behaviour of an IOService. 

public

virtual bool handleOpen(
    IOService *forClient, 
    IOOptionBits options, 
    void *arg ); 
Parameters
forClient
Designates the client of the provider requesting the open.
options
Options for the open, may be interpreted by the implementor of handleOpen.
Return Value

Return true if the open was successful, false otherwise. 
Discussion 

See IOService for discussion.*/
bool IOFireWireAVCSubUnit::handleOpen(
    IOService *forClient, 
    IOOptionBits options, 
    void *arg ){}; 

/*updateAVCCommandTimeout


By default, AVCCommands timeout 10 seconds after receiving an Interim response. This function resets the timeout of the current command to 10 seconds from the current time. Call this repeatedly for AVC commands that take a very long time to execute to prevent premature timeout. 

public

virtual IOReturn updateAVCCommandTimeout(); */
 IOReturn IOFireWireAVCSubUnit::updateAVCCommandTimeout(){};


/*AVCCommandInGeneration


Sends an AVC command to the device and stores the response. The command must complete in the specified FireWire bus generation otherwise kIOFireWireBusReset is returned. 

public

virtual IOReturn AVCCommandInGeneration(
    UInt32 generation, 
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen); 
Parameters
generation
The bus generation that the command must execute in.
command
Pointer to command to send.
cmdLen
Length of the command.
response
Pointer to place to store the response.
responseLen
Pointer to response length - initialize to the size of the buffer pointed to by response, updated to the number of bytes returned by the device.*/
IOReturn IOFireWireAVCSubUnit::AVCCommandInGeneration(
    UInt32 generation, 
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen){}; 

/*AVCCommand


Sends an AVC command to the device and stores the response. 

public

virtual IOReturn AVCCommand(
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen); 
Parameters
command
Pointer to command to send.
cmdLen
Length of the command.
response
Pointer to place to store the response.
responseLen
Pointer to response length - initialize to the size of the buffer pointed to by response, updated to the number of bytes returned by the device.*/
IOReturn IOFireWireAVCSubUnit::AVCCommand(
    const UInt8 *command,
    UInt32 cmdLen,
    UInt8 *response,
    UInt32 *responseLen){}; 

/*matchPropertyTable


Matching language support Match on the following properties of the unit: Vendor_ID GUID Unit_Type and available sub-units, match if the device has at least the requested number of a sub-unit type: AVCSubUnit_0 -> AVCSubUnit_1f 

public

virtual bool matchPropertyTable(
    OSDictionary *table); */
bool IOFireWireAVCUnit:: matchPropertyTable(
    OSDictionary *table){}; 


/*matchPropertyTable


Matching language support Match on the following properties of the sub unit: Vendor_ID GUID SubUnit_Type 

public

virtual bool matchPropertyTable(
    OSDictionary *table); */
 bool IOFireWireAVCSubUnit::matchPropertyTable(
    OSDictionary *table){};

/*handleOpen


Overrideable method to control the open / close behaviour of an IOService. 

public

virtual bool handleOpen(
    IOService *forClient, 
    IOOptionBits options, 
    void *arg ); 
Parameters
forClient
Designates the client of the provider requesting the open.
options
Options for the open, may be interpreted by the implementor of handleOpen.
Return Value

Return true if the open was successful, false otherwise. 
Discussion 

See IOService for discussion.*/
 bool IOFireWireAVCUnit::handleOpen(
    IOService *forClient, 
    IOOptionBits options, 
    void *arg ){}; 


/*handleClose


Overrideable method to control the open / close behaviour of an IOService. 

public

virtual void handleClose(
    IOService *forClient, 
    IOOptionBits options ); 
Parameters
forClient
Designates the client of the provider requesting the close.
options
Options for the close, may be interpreted by the implementor of handleOpen.
Discussion 

See IOService for discussion. */
 void IOFireWireAVCUnit:: handleClose(
    IOService *forClient, 
    IOOptionBits options ){}; 
