#include <IOKit/avc/IOFireWirePCRSpace.h>

UInt32 IOFireWirePCRSpace::doWrite(UInt16 a, IOFWSpeed &b, FWAddress c, UInt32 d,const void *e,IOFWRequestRefCon f){};//?
IOReturn IOFireWirePCRSpace:: activate(){};//?
void IOFireWirePCRSpace::deactivate(){};//?
IOReturn IOFireWirePCRSpace::allocatePlug(void *a, IOFireWirePCRCallback b, UInt32 &c, Client* d){};//?
void IOFireWirePCRSpace::freePlug(UInt32 a, Client* b){};//?
UInt32 IOFireWirePCRSpace::readPlug(UInt32 a){};//?
IOReturn IOFireWirePCRSpace:: updatePlug(UInt32 a, UInt32 b, UInt32 c){};//?

IOFireWirePCRSpace * IOFireWirePCRSpace_HYS::getPCRAddressSpace(IOFireWireBus *a){};//c


/*freeInputPlug


deallocates an input plug. 

public

virtual void freeInputPlug(
    UInt32 plug); 
Parameters
plug
value returned by allocateInputPlug.*/
 void IOFireWirePCRSpace::freeInputPlug(
    UInt32 plug){}; 

/*freeOutputPlug


deallocates an output plug. 

public

virtual void freeOutputPlug(
    UInt32 plug); 
Parameters
plug
value returned by allocateOutputPlug.*/
void IOFireWirePCRSpace::freeOutputPlug(
    UInt32 plug){}; 



/*setAVCTargetSpacePointer


public

virtual void setAVCTargetSpacePointer(
    IOFireWireAVCTargetSpace *pAVCTargetSpace); */

void IOFireWirePCRSpace::setAVCTargetSpacePointer(
    IOFireWireAVCTargetSpace *pAVCTargetSpace){};


/*readInputMasterPlug


returns the current value of the input master plug. 

public

virtual UInt32 readInputMasterPlug(); */
UInt32 IOFireWirePCRSpace::readInputMasterPlug(){}; 

/*allocateInputPlug


allocates an input plug. 

public

virtual IOReturn allocateInputPlug(
    void *refcon,
    IOFireWirePCRCallback func,
    UInt32 &plug); 
Parameters
refcon
arbitrary value passed back as first argument of callback.
func
callback function when a successful lock transaction to the plug has been performed
plug
set to the plug number if a plug is successfully allocated*/
 IOReturn IOFireWirePCRSpace:: allocateInputPlug(
    void *refcon,
    IOFireWirePCRCallback func,
    UInt32 &plug){}; 


/*allocateOutputPlug


allocates an output plug. 

public

virtual IOReturn allocateOutputPlug(
    void *refcon,
    IOFireWirePCRCallback func,
    UInt32 &plug); 
Parameters
refcon
arbitrary value passed back as first argument of callback.
func
callback function when a successful lock transaction to the plug has been performed
plug
set to the plug number if a plug is successfully allocated*/
IOReturn IOFireWirePCRSpace::allocateOutputPlug(
    void *refcon,
    IOFireWirePCRCallback func,
    UInt32 &plug){}; 


/*readInputPlug


returns the current value of an input plug. 

public

virtual UInt32 readInputPlug(
    UInt32 plug); 
Parameters
plug
value returned by allocateInputPlug.*/
UInt32 IOFireWirePCRSpace:: readInputPlug(
    UInt32 plug){}; 

/*readOutputPlug


returns the current value of an output plug. 

public

virtual UInt32 readOutputPlug(
    UInt32 plug); 
Parameters
plug
value returned by allocateOutputPlug.*/
UInt32 IOFireWirePCRSpace:: readOutputPlug(
    UInt32 plug){};

/*updateOutputMasterPlug


updates the value of the master output plug (simulating a lock transaction). 

public

virtual IOReturn updateOutputMasterPlug(
    UInt32 oldVal,
    UInt32 newVal); 
Parameters
oldVal
value returned by readOutputMasterPlug.
newVal
new value to store in plug if it's current value is oldVal.*/
IOReturn IOFireWirePCRSpace::updateOutputMasterPlug(
    UInt32 oldVal,
    UInt32 newVal){}; 


/*updateInputMasterPlug


updates the value of the master input plug (simulating a lock transaction). 

public

virtual IOReturn updateInputMasterPlug(
    UInt32 oldVal,
    UInt32 newVal); 
Parameters
oldVal
value returned by readInputMasterPlug.
newVal
new value to store in plug if it's current value is oldVal.*/
IOReturn IOFireWirePCRSpace:: updateInputMasterPlug(
    UInt32 oldVal,
    UInt32 newVal){}; 


/*readOutputMasterPlug


returns the current value of the output master plug. 

public

virtual UInt32 readOutputMasterPlug(); */

UInt32 IOFireWirePCRSpace::readOutputMasterPlug(){}; 

/*updateInputPlug


updates the value of an input plug (simulating a lock transaction). 

public

virtual IOReturn updateInputPlug(
    UInt32 plug,
    UInt32 oldVal,
    UInt32 newVal); 
Parameters
plug
value returned by allocateInputPlug.
oldVal
value returned by readInputPlug.
newVal
new value to store in plug if it's current value is oldVal.*/
IOReturn IOFireWirePCRSpace::updateInputPlug(
    UInt32 plug,
    UInt32 oldVal,
    UInt32 newVal){}; 

/*updateOutputPlug


updates the value of an output plug (simulating a lock transaction). 

public

virtual IOReturn updateOutputPlug(
    UInt32 plug,
    UInt32 oldVal,
    UInt32 newVal); 
Parameters
plug
value returned by allocateOutputPlug.
oldVal
value returned by readOutputPlug.
newVal
new value to store in plug if it's current value is oldVal.*/
IOReturn IOFireWirePCRSpace:: updateOutputPlug(
    UInt32 plug,
    UInt32 oldVal,
    UInt32 newVal){}; 


/*clearAllP2PConnections


public

virtual void clearAllP2PConnections(
    void); */
 void IOFireWirePCRSpace::clearAllP2PConnections(
    void){}; 

/*init


initializes the IOFireWirePCRSpace object 

public

virtual bool init(
    IOFireWireBus *bus); */
bool IOFireWirePCRSpace:: init(
    IOFireWireBus *bus){};


/*getPCRAddressSpace


returns the IOFireWirePCRSpace object for the given FireWire bus 

public

static IOFireWirePCRSpace *getPCRAddressSpace(
    IOFireWireBus *bus); 
Parameters
bus
The FireWire bus*/
IOFireWirePCRSpace * IOFireWirePCRSpace::getPCRAddressSpace(
    IOFireWireBus *bus){}; 
