#include <IOKit/firewire/IOFWAsyncStreamListener.h>

/*initAll


Creates an AsyncStream client for an Isoch channel. 

public

bool initAll(
    IOFireWireController *control,
    UInt32 channel,
    FWAsyncStreamReceiveCallback proc,
    void *refcon ); 
Parameters
control
Points to IOFireWireController.
channel
Isoch channel for listening.
proc
Callback on packet reception.
obj
Client's callback object.
Return Value

returns true on success, else false.*/
bool IOFWAsyncStreamListener:: initAll(
    IOFireWireController *control,
    UInt32 channel,
    FWAsyncStreamReceiveCallback proc,
    void *refcon ){};

/*getOverrunCounter


get overrun counter from the DCL program. 

public

UInt32 getOverrunCounter(); 
Parameters
none.
Return Value

returns the counter value.*/
UInt32 IOFWAsyncStreamListener::getOverrunCounter(){}; 

/*setFlags


set flags for the listener. 

public

void setFlags(
    UInt32 flags ); 
Parameters
flags
indicate performance metrics.
Return Value

none.*/
void IOFWAsyncStreamListener::setFlags(
    UInt32 flags ){}; 

/*getFlags


get the flags of listener. 

public

UInt32 getFlags(); 
Parameters
none.
Return Value

flags.*/
UInt32 IOFWAsyncStreamListener::getFlags(){}; 
