//#include <IOKit/IOService.h>
#include <IOKit/pccard/IOPCCardEjectController.h>

bool		IOPCCardEjectController::	start(IOService * a){};//c
void		IOPCCardEjectController::	stop(IOService * a){};//c

/*ejectCard


Physically ejects a card from its socket. 

public

virtual IOReturn ejectCard(); 
Return Value

Returns kIOReturnSuccess if the card is ejected. 
Discussion 

This method is called to initiate the physical ejection of a card. It is called by its peer, the IOPCCardBridge driver, after the bridge driver has terminated the socket's driver(s) and the socket has been powered down.*/
IOReturn IOPCCardEjectController:: ejectCard(){}; 

/*requestCardEjection


Makes a request for a card to be ejected. 

public

virtual bool requestCardEjection(); 
Return Value

Returns true if the ejection request was accepted by all drivers and the ejection was successful. 
Discussion 

This method is used to start a request for a card ejection by routing Card Services EjectCard call to the driver(s) for this socket. Normally, this would be called after an external event was detected, such as a platform-specific PC Card eject button press.*/
 bool IOPCCardEjectController::requestCardEjection(){}; 
