#include <IOKit/usb/IOUSBInterface.h>

bool		IOUSBInterface::start(IOService * a){};//?
 void		IOUSBInterface::close(IOService *a, IOOptionBits b ){};//?

bool		IOUSBInterface::init(	const IOUSBConfigurationDescriptor *a, const IOUSBInterfaceDescriptor *b){};//?

IOReturn IOUSBInterface::DeviceRequest(IOUSBDevRequestDesc *a, IOUSBCompletion *b){};//?

IOUSBInterface *IOUSBInterface::withDescriptors(const IOUSBConfigurationDescriptor *a, const IOUSBInterfaceDescriptor * b){};//c

bool		IOUSBInterface::handleOpen(IOService *a, IOOptionBits b , void *c  ){};//?
 bool		IOUSBInterface::open(IOService *a, IOOptionBits b , void *c ){};//?
void	IOUSBInterface::SetProperties(void){};//?
 IOReturn	IOUSBInterface::CallSuperClose(OSObject *a, void *b, void *c, void *d, void *e){};//c
 IOReturn	IOUSBInterface::CallSuperOpen(OSObject *a, void *b, void *c, void *d, void *e){};//c
 IOReturn	IOUSBInterface::CreatePipes(void){};//?
bool IOUSBInterface::matchPropertyTable(OSDictionary * a, SInt32 *b){};//?
void	IOUSBInterface::	handleClose(IOService *a, IOOptionBits b ){};//?
IOReturn 	IOUSBInterface::message( UInt32 a, IOService * b,  void *c  ){};//?
bool		IOUSBInterface::terminate( IOOptionBits a  ){};//?
void		IOUSBInterface::stop(IOService *  a){};//?
void 	IOUSBInterface::ClosePipes(void){};//?
bool	IOUSBInterface::	finalize(IOOptionBits a){};//?
void	IOUSBInterface::	free(){};	//?
UInt8 IOUSBInterface:: hex2char( UInt8  a){};//c

/////////////

/*GetDevice


public

virtual IOUSBDevice *GetDevice(); 
Return Value

Pointer to the IOUSBDevice object which is the parent of this IOUSBInterface object. 
Discussion 

returns the device the interface is part of.*/

 IOUSBDevice * IOUSBInterface::GetDevice(){}; 

/*GetInterfaceNumber


public

virtual UInt8 GetInterfaceNumber(); 
Return Value

the interface index 
Discussion 

returns the zero based value identifying the index in the array of concurrent interfaces supported by the current configuration*/
UInt8 IOUSBInterface::GetInterfaceNumber(){}; 

/*GetInterfaceProtocol


public

virtual UInt8 GetInterfaceProtocol(); 
Return Value

the interface index 
Discussion 

returns the protocol code (assigned by the USB).*/
UInt8 IOUSBInterface::GetInterfaceProtocol(){}; 


/*GetInterfaceStringIndex


public

virtual UInt8 GetInterfaceStringIndex(); 
Return Value

the string index 
Discussion 

returns the index of the string descriptor describing the interface*/
UInt8 IOUSBInterface::GetInterfaceStringIndex(){}; 

/*DeviceRequest


Sends a control request to the default control pipe in the device (pipe zero) 

public

virtual IOReturn DeviceRequest(
    IOUSBDevRequest *request,
    IOUSBCompletion *completion = 0); 
Parameters
request
The parameter block to send to the device
completion
Function to call when request completes. If omitted then DeviceRequest() executes synchronously, blocking until the request is complete.*/

IOReturn IOUSBInterface::DeviceRequest(
    IOUSBDevRequest *request,
    IOUSBCompletion *completion ){}; 

/*SetAlternateInterface


public

virtual IOReturn SetAlternateInterface(
    IOService *forClient,
    UInt16 alternateSetting); 
Parameters
forClient
The client requesting the alternate setting. This client must have the interface open in order to perform the request.
alternateSetting
Alternate setting (from the alternate interface's interface descriptor).
Return Value

exclusive access error if the interface is not open. otherwise the result of the transaction 
Discussion 

Select the specified alternate interface.*/

IOReturn IOUSBInterface::SetAlternateInterface(
    IOService *forClient,
    UInt16 alternateSetting){}; 

/*FindNextPipe


public

virtual IOUSBPipe *FindNextPipe(
    IOUSBPipe *current,
    IOUSBFindEndpointRequest *request); 
Parameters
current
Pipe to start searching from, NULL to start from beginning of list.
request
Requirements for pipe to match, updated with the found pipe's properties.
Return Value

Pointer to the pipe, or NULL if no pipe matches the request. 
Discussion 

Find a pipe of the interface that matches the requirements, either starting from the beginning of the interface's pipe list or from a specified pipe.*/

 IOUSBPipe * IOUSBInterface::FindNextPipe(
    IOUSBPipe *current,
    IOUSBFindEndpointRequest *request){}; 


/*FindNextAssociatedDescriptor


public

virtual const IOUSBDescriptorHeader * FindNextAssociatedDescriptor(
    const void *current,
    UInt8 type); 
Parameters
current
Descriptor to start searching from, NULL to start from beginning of list.
type
Descriptor type to search for, or kUSBAnyDesc to return any descriptor type.
Return Value

Pointer to the descriptor, or NULL if no matching descriptors found. 
Discussion 

Find the next descriptor of the requested type associated with the interface.*/
const IOUSBDescriptorHeader * IOUSBInterface:: FindNextAssociatedDescriptor(
    const void *current,
    UInt8 type){}; 

/*GetInterfaceSubClass


public

virtual UInt8 GetInterfaceSubClass(); 
Return Value

the interface subclass 
Discussion 

returns the subclass code (assigned by the USB). These codes are qualified by the value returned by GetInterfaceClass*/
 UInt8 IOUSBInterface::GetInterfaceSubClass(){}; 

/*GetNumEndpoints


public

virtual UInt8 GetNumEndpoints(); 
Return Value

the number of endpoints 
Discussion 

returns the number of endpoints used by this interface (excluding device endpoint zero. If the value is zero, this interface only uses endpoint zero.*/
 UInt8 IOUSBInterface:: GetNumEndpoints(){}; 

/*FindNextAltInterface


public

virtual const IOUSBInterfaceDescriptor *FindNextAltInterface(
    const IOUSBInterfaceDescriptor *current, 
    IOUSBFindInterfaceRequest *request); 
Parameters
current
interface descriptor to start searching from, NULL to start at alternate interface 0.
request
specifies what properties an interface must have to match.
Return Value

Pointer to a matching interface descriptor, or NULL if none match. 
Discussion 

return alternate interface descriptor satisfying the requirements specified in request, or NULL if there aren't any. request is updated with the properties of the returned interface.*/
const IOUSBInterfaceDescriptor  * IOUSBInterface::FindNextAltInterface(
    const IOUSBInterfaceDescriptor *current, 
    IOUSBFindInterfaceRequest *request){}; 

/*GetAlternateSetting


public

virtual UInt8 GetAlternateSetting(); 
Return Value

the alternate setting 
Discussion 

returns the alternate setting for this interface.*/
UInt8 IOUSBInterface:: GetAlternateSetting(){}; 

/*GetInterfaceClass


public

virtual UInt8 GetInterfaceClass(); 
Return Value

the interface class 
Discussion 

returns the class code for this interface (assigned by the USB) a value of zero is reserved if the value is FFh, the interface class is vendor-specific all other values are reserved for assignment by the USB*/
UInt8 IOUSBInterface:: GetInterfaceClass(){}; 

/*GetEndpointProperties


Returns the properties of an endpoint, possibly in an alternate interface. 

public

virtual IOReturn GetEndpointProperties(
    UInt8 alternateSetting,
    UInt8 endpointNumber,
    UInt8 direction,
    UInt8 *transferType,
    UInt16 *maxPacketSize,
    UInt8 *interval); 
Parameters
alternateSetting
specifies the desired alternate setting
endpointNumber
specifies the endpoint number
direction
specifies the direction (kUSBIn, kUSBOut)
transferType
a pointer to hold the transfer type (kUSBControl, kUSBBulk, etc.) of the endpoint if found.
maxPacketSize
a pointer to hold the maxPacketSize in the endpoint descriptor.
interval
a pointer to hold the interval value in the endpoint descriptor.
Return Value

returns kIOReturnSuccess if the endpoint is found, and kIOUSBEndpointNotFound if it is not.*/

 IOReturn IOUSBInterface::GetEndpointProperties(
    UInt8 alternateSetting,
    UInt8 endpointNumber,
    UInt8 direction,
    UInt8 *transferType,
    UInt16 *maxPacketSize,
    UInt8 *interval){}; 

/*GetPipeObj


public

virtual IOUSBPipe *GetPipeObj(
    UInt8 index); 
Parameters
index
value from zero to kUSBMaxPipes-1
Return Value

The IOUSBPipe object. Note that the client does not own a reference to this pipe, so the client should retain() the IOUSBPipe object if necessary. 
Discussion 

returns a handle to the pipe at the corresponding index*/
IOUSBPipe *IOUSBInterface::GetPipeObj(
    UInt8 index){}; 

/*GetConfigValue


public

virtual UInt8 GetConfigValue(); 
Return Value

The device configuration value. 
Discussion 

returns the device configuration value for the interface*/
 UInt8 IOUSBInterface::GetConfigValue(){}; 

