#import <XgridFoundation/XGJob.h>
//work

/* Data Types & Constants

All of the new data types and constants in this header file are listed alphabetically, with links to documentation and abstracts, if available.
XGJobSpecificationApplicationIdentifierKey	
XGJobSpecificationArgumentsKey	
XGJobSpecificationArgumentTypeKey	
XGJobSpecificationCommandKey	
XGJobSpecificationDependsOnJobsKey	
XGJobSpecificationDependsOnTasksKey	
XGJobSpecificationEnvironmentKey	
XGJobSpecificationFileDataKey	
XGJobSpecificationGridIdentifierKey	
XGJobSpecificationInputFileMapKey	
XGJobSpecificationInputFilesKey	
XGJobSpecificationInputStreamKey	
XGJobSpecificationIsExecutableKey	
XGJobSpecificationNameKey	
XGJobSpecificationNotificationEmailKey	
XGJobSpecificationPathIdentifierKey	
XGJobSpecificationSchedulerParametersKey	
XGJobSpecificationSubmissionIdentifierKey	
XGJobSpecificationTaskPrototypeIdentifierKey	
XGJobSpecificationTaskPrototypesKey	
XGJobSpecificationTaskSpecificationsKey	
XGJobSpecificationTypeKey	
XGJobSpecificationTypeTaskListValue	 */

 NSString * const XGJobSpecificationApplicationIdentifierKey;
 NSString * const XGJobSpecificationArgumentsKey	;
 NSString * const XGJobSpecificationArgumentTypeKey;	
 NSString * const XGJobSpecificationCommandKey	;
 NSString * const XGJobSpecificationDependsOnJobsKey	;
 NSString * const XGJobSpecificationDependsOnTasksKey	;
 NSString * const XGJobSpecificationEnvironmentKey	;
 NSString * const XGJobSpecificationFileDataKey	;
 NSString * const XGJobSpecificationGridIdentifierKey	;
 NSString * const XGJobSpecificationInputFileMapKey	;
 NSString * const XGJobSpecificationInputFilesKey	;
 NSString * const XGJobSpecificationInputStreamKey;	
 NSString * const XGJobSpecificationIsExecutableKey;	
 NSString * const XGJobSpecificationNameKey	;
 NSString * const XGJobSpecificationNotificationEmailKey	;
 NSString * const XGJobSpecificationPathIdentifierKey	;
 NSString * const XGJobSpecificationSchedulerParametersKey	;
 NSString * const XGJobSpecificationSubmissionIdentifierKey	;
 NSString * const XGJobSpecificationTaskPrototypeIdentifierKey;	
 NSString * const XGJobSpecificationTaskPrototypesKey	;
 NSString * const XGJobSpecificationTaskSpecificationsKey	;
 NSString * const XGJobSpecificationTypeKey	;
 NSString * const XGJobSpecificationTypeTaskListValue;

@implementation  XGJob


/*performStopAction


Attempts to stop the job represented by the receiver. 
- (XGActionMonitor *)performStopAction;
method result
An XGActionMonitor instance for tracking the action progress.*/
- (XGActionMonitor *)performStopAction{}


/*performDeleteAction


Attempts to delete the job represented by the receiver. 
- (XGActionMonitor *)performDeleteAction;
method result
An XGActionMonitor instance for tracking the action progress.*/
- (XGActionMonitor *)performDeleteAction{}


/*performGetSpecificationAction


Attempts to retrieve the specification used to submit the job represented by the reciever. 
- (XGActionMonitor *)performGetSpecificationAction;
method result
An XGActionMonitor instance for tracking the action progress.*/
- (XGActionMonitor *)performGetSpecificationAction{}


/*performGetOutputStreamsAction


Attempts to retrieve a list of output streams for the job represented by the receiver. 
- (XGActionMonitor *)performGetOutputStreamsAction;
method result
An XGActionMonitor instance for tracking the action progress.*/
- (XGActionMonitor *)performGetOutputStreamsAction{}



/*performGetOutputFilesAction


Attempts to retrieve a list of output files for the job represented by the receiver. 
- (XGActionMonitor *)performGetOutputFilesAction;
method result
An XGActionMonitor instance for tracking the action progress.*/
- (XGActionMonitor *)performGetOutputFilesAction{}



@end



