#include <stdio.h>
#include <libkern/c++/OSBoolean.h>

OSBoolean*  OSBoolean_HYS::withBoolean(bool a){};//c

/*kOSBooleanTrue


The OSBoolean constant for "true". 
extern OSBoolean * const & kOSBooleanTrue;  
Discussion 

The OSBoolean constant for "true". The object does not need to be retained or released. Comparisons of the form (booleanObject == kOSBooleanTrue) are acceptable and would be equivalent to (booleanObject->getValue() == true).*/
OSBoolean * const & kOSBooleanTrue;

/*&isTrue


A member function to test if the Boolean object is true. 

public

virtual bool isTrue() const; 
Return Value

Returns true if the OSBoolean object is true, false otherwise.*/
 bool OSBoolean::isTrue() const{};


/*kOSBooleanFalse


The OSBoolean constant for "false". 

extern OSBoolean * const & kOSBooleanFalse;  
Discussion 

The OSBoolean constant for "false". The object does not need to be retained or released. Comparisons of the form (booleanObject == kOSBooleanFalse) are acceptable and would be equivalent to (booleanObject->getValue() == false).*/

 OSBoolean * const & kOSBooleanFalse;  

 
/*getValue


Obtains the value of the OSBoolean object as the standard C++ type bool. 

public

virtual bool getValue() const; 
Return Value

The value of the OSBoolean object.*/
 bool OSBoolean::getValue() const{}; 

/*isFalse


Tests if the Boolean object is false. 

public

virtual bool isFalse() const; 
Return Value

Returns true if the OSBoolean object is false, false otherwise.*/
bool OSBoolean::isFalse() const{}; 
